<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE xsl:stylesheet [
  <!ENTITY copy "&#169;">
  <!ENTITY nbsp "&#160;">
  <!ENTITY lk "/webcenter_page/user_lang_key">
]>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:java="http://xml.apache.org/xslt/java" xmlns:XSLUtils="com.esko.webcenter.jsp.XSLUtils" xmlns:Lang="com.esko.webcenter.jsp.LanguageMgr" exclude-result-prefixes="XSLUtils java Lang">
  <xsl:import href="template.xsl"/>
  <xsl:import href="templatedate.xsl"/>
  <xsl:import href="projwctasktemplates.xsl"/>
  <xsl:import href="projdetails_template.xsl"/>
  <xsl:import href="attrunittmplts.xsl"/>
  <xsl:import href="attributetemplates.xsl"/>
  
  <xsl:key name="TaskStatusKey" match="/webcenter_page/project_wctask_status/status" use="id"/>
  
  <xsl:output method="html" doctype-public="-//W3C//DTD HTML 4.0//EN"/>
  <xsl:param name="w3">http://www.w3.org/</xsl:param>
  
  <xsl:variable name="isStrictMode" select="true()" />
  
	<!-- global variables -->
  
  <xsl:variable name="isTaskComplete" select="/webcenter_page/project_wctask/is_complete != 0" />
  <xsl:variable name="isTaskSpecsEditable" select="not($isTaskComplete) and (((/webcenter_page/is_task_editable = '1') and ($isProjectActive = '1')) or (/webcenter_page/is_project_editable = '1'))"/>
  
  
  <xsl:template name="bodyextensions">
    <xsl:attribute name="onload"></xsl:attribute>
  </xsl:template>

	<!-- 
  
            template that controls the generation of the body header
            
	-->
	<xsl:template name="bodyheader">
		<xsl:call-template name="DisplayTaskPageHeader">
			<xsl:with-param name="headerText" select="'PROJ_TASK_SPECS'"/>
			<xsl:with-param name="taskName" select="project_wctask/name"/>
		</xsl:call-template>
	</xsl:template>

  <!-- 
  
            template that controls the generation of the body content
            
  -->
  <xsl:template name="bodycontent">
	
	<tr>
      <td width="100%" >
	   <form name="actionform" method="post" action="doprojectwctask.jsp" enctype="MULTIPART/FORM-DATA">
	       <xsl:call-template name="projDetailsHiddenInputs"/>
	       <xsl:call-template name="projWcTaskDetailsHiddenInputs"/>
	   <input type="hidden" name="actionVal" value="SaveSpecificationValues"/>
        <div id="ACatObj"></div>
        <div id="ACatPanel"></div>
		</form>
      </td>
    </tr>
		
    <tr><td class="white_background"><img src="images/clearpixel.gif" width="1" height="10"/></td></tr>
	<xsl:call-template name="ShowRequiredTip"/>	
	
    <!-- Save Button -->
    <xsl:if test="$isTaskSpecsEditable">
      <tr><td class="white_background"><img src="images/clearpixel.gif" width="1" height="10"/></td></tr>
      <tr>
        <td>
          <img src="images/clearpixel.gif" width="10" height="1"/>
          <input type="submit" onclick="ValidateFormParams(this)" value="{Lang:getStr(&lk;,'SAVECHANGES')}" name="Save" class="buttonprimary" /></td>
      </tr>
    </xsl:if>
    
    <!-- Confirmation section -->
    <tr>
      <td>
        <img src="images/clearpixel.gif" width="10" height="1"/>
        <table border="0" cellspacing="0" cellpadding="0" width="100%">
          <xsl:call-template name="DisplayNotification"/>
          <xsl:call-template name="DisplayAttrSaveNotification"/>
        </table>
      </td>
    </tr> 
    
   <tr><td class="white_background" height="10"><img border="0" src="images/clearpixel.gif" alt="" width="1" height="1"/></td></tr>

  </xsl:template>  
  
 

  <!-- 
  
            template that controls the inclusion of javascript functionality 
            
  -->
  <xsl:template name="scriptincs">
    <script src="javascript/validate.js" type="text/javascript"/>
    <script src="javascript/TableSelection.js" type="text/javascript"/>
    <script src="javascript/webcenter_ajax.js" type="text/javascript"/>
    <script src="javascript/webcenter_xml.js" type="text/javascript"/>
    <script src="javascript/webcenter_html.js" type="text/javascript"/>
    <script type="text/javascript">
		
        function SetInitialFocus()
        {
          // set the focus to the keyword search box
          //document.projtaskform.clearfilters.focus();
        }

		
		function ValidateFormParams(elem)
		{
			assignDate(document.actionform);
			
			document.actionform.actionVal.value = 'SaveSpecificationValues';
	
		    var aCatObj = document.getElementById("ACatObj");
		    var validationOK = true;
		    if (aCatObj &amp;&amp; aCatObj.ACatObj) {
			    validationOK = aCatObj.ACatObj.prepareForSubmit(false, true);
		    }
			 if(validationOK){
		    	document.actionform.submit();
				elem.disabled = true;
			}
		   	return validationOK;
		}
		
      
	<xsl:if test="/webcenter_page/project_wctask/task_type_id">
	require(["attributecategory/AttributeCategory"], function(AttributeCategory){
      $(document).ready(function() {
			// construct the language array
			var currentUser = ObjectHandler.getCloneOfObject(gCurrentUser);
			currentUser.canEditAttributes = <xsl:value-of select="$isTaskSpecsEditable"/>;
				
			var aCatOptions = new Object();
			aCatOptions.ACatObj = "ACatObj";
			aCatOptions.isTemplate = false;
			aCatOptions.ACatPanel = "ACatPanel";
			aCatOptions.readURL = "GetTaskTypeLayoutXML.jsp?taskTypeID=" + '<xsl:value-of select="/webcenter_page/project_wctask/task_type_id"/>';
			aCatOptions.currentUser = currentUser;
			aCatOptions.valuesURL = "GetAttributes.jsp?projectid="+'<xsl:value-of select="/webcenter_page/project/@id"/>'
								+ "&amp;tasktypeid="+'<xsl:value-of select="/webcenter_page/project_wctask/task_type_id"/>'
			   						+ "&amp;taskid="+'<xsl:value-of select="/webcenter_page/project_wctask/@id"/>';
			aCatOptions.projectAttributeValuesURL = "GetAttributes.jsp?projectid="+'<xsl:value-of select="/webcenter_page/project/@id"/>';
			aCatOptions.defaultHourAsHalfHours = <xsl:value-of select="/webcenter_page/default_due_date_time"/>;
			aCatOptions.isTaskTypePage = true;
			aCatOptions.autoUpdateProjAttrsCheckbox = <xsl:value-of select="/webcenter_page/project_wctask/wctask_type/auto_update_project_attributes"/>;
			aCatOptions.type = "task";
			aCatOptions.projectID = '<xsl:value-of select="/webcenter_page/project/@id"/>';
			aCatOptions.taskID = '<xsl:value-of select="/webcenter_page/project_wctask/@id"/>';
			myACat = new AttributeCategory(aCatOptions);
			
		    // myACat is a global variable that is sometimes overwritten. this is a safe solution
		    var taskACatObj = myACat;
		    
		    // add trigger to warn user when leaving the page with unsaved changes
		    window.onbeforeunload = function() {
		    	if ((taskACatObj.attributesChanged === true) &amp;&amp; !taskACatObj.submitInProgress) {
		    		return '<xsl:call-template name="encodesinglequotes"><xsl:with-param name="string" select="Lang:getStr(&lk;,'ACatConfirmPageExit')"/></xsl:call-template>';
		    	}
		    };
     	 });
     });
	</xsl:if>

    </script>
    <xsl:call-template name="ProjDetailsJavaScript"/>
	<xsl:call-template name="AttributeTemplateJavaScript"/>	
  </xsl:template>
</xsl:stylesheet>
