/**
 * Copyright 2013 Craig Campbell
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may obtain a
 * copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
 * WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
 * License for the specific language governing permissions and limitations
 * under the License.
 * 
 * Mousetrap is a simple keyboard shortcut library for Javascript with no
 * external dependencies
 * 
 * @version 1.4.4
 * @url craig.is/killing/mice
 * 
 * See https://github.com/ccampbell/mousetrap
 * NOTICE: changed by Esko:
 * 	- fixed support for "-"-key
 *  - allow binding of multiple callbacks to 1 key combination
 *  - completely remove callback when unbinding
 */

define([],function(){function n(a,b,e){a.addEventListener?a.addEventListener(b,e,!1):a.attachEvent("on"+b,e)}function w(a){if("keypress"==a.type){var b=String.fromCharCode(a.which);a.shiftKey||(b=b.toLowerCase());return b}return i[a.which]?i[a.which]:x[a.which]?x[a.which]:String.fromCharCode(a.which).toLowerCase()}function o(a){var a=a||{},b=!1,e;for(e in k)a[e]?b=!0:k[e]=0;b||(p=!1)}function D(a){var b=[];a.shiftKey&&b.push("shift");a.altKey&&b.push("alt");a.ctrlKey&&b.push("ctrl");a.metaKey&&b.push("meta");
return b}function q(a,b,e){if(!r.stopCallback(b,b.target||b.srcElement,e)&&!1===a(b,e))b.preventDefault&&b.preventDefault(),b.stopPropagation&&b.stopPropagation(),b.returnValue=!1,b.cancelBubble=!0}function s(a){"number"!==typeof a.which&&(a.which=a.keyCode);var b=w(a);b&&("keyup"==a.type&&t===b?t=!1:r.handleKey(b,D(a),a))}function u(a){return"shift"==a||"ctrl"==a||"alt"==a||"meta"==a}function v(a,b){var e,c,f,d=[];e="+"===a?["+"]:a.split("+");for(f=0;f<e.length;++f)c=e[f],y[c]&&(c=y[c]),b&&("keypress"!=
b&&z[c])&&(c=z[c],d.push("shift")),u(c)&&d.push(c);e=c;f=b;if(!f){if(!l){l={};for(var g in i)95<g&&112>g||i.hasOwnProperty(g)&&(l[i[g]]=g)}f=l[e]?"keydown":"keypress"}"keypress"==f&&d.length&&(f="keydown");return{key:c,modifiers:d,action:f}}function A(a,b,e,c,f){m[a+":"+e]=b;var a=a.replace(/\s+/g," "),d=a.split(" ");if(1<d.length)for(var g=a,a=function(a){return function(){p=a;++k[g];clearTimeout(B);B=setTimeout(o,1E3)}},c=function(a){q(b,a,g);"keyup"!==e&&(t=w(a));setTimeout(o,10)},f=k[g]=0;f<d.length;++f){var h=
f+1===d.length?c:a(e||v(d[f+1]).action);A(d[f],h,e,g,f)}else d=v(a,e),j[d.key]=j[d.key]||[],j[d.key][c?"unshift":"push"]({callback:b,modifiers:d.modifiers,action:d.action,seq:c,level:f,combo:a})}for(var i={8:"backspace",9:"tab",13:"enter",16:"shift",17:"ctrl",18:"alt",20:"capslock",27:"esc",32:"space",33:"pageup",34:"pagedown",35:"end",36:"home",37:"left",38:"up",39:"right",40:"down",45:"ins",46:"del",91:"meta",93:"meta",107:"plus",224:"meta"},x={96:"0",106:"*",107:"+",109:"-",110:".",111:"/",173:"-",
186:";",187:"=",188:",",189:"-",190:".",191:"/",192:"`",219:"[",220:"\\",221:"]",222:"'"},z={"~":"`","!":"1","@":"2","#":"3",$:"4","%":"5","^":"6","&":"7","*":"8","(":"9",")":"0",_:"-","+":"=",":":";",'"':"'","<":",",">":".","?":"/","|":"\\"},y={option:"alt",command:"meta","return":"enter",escape:"esc",mod:/Mac|iPod|iPhone|iPad/.test(navigator.platform)?"meta":"ctrl"},l,j={},m={},k={},B,t=!1,C=!1,p=!1,h=1;20>h;++h)i[111+h]="f"+h;for(h=0;9>=h;++h)i[h+96]=h;n(document,"keypress",s);n(document,"keydown",
s);n(document,"keyup",s);var r={bind:function(a,b,e){for(var a=a instanceof Array?a:[a],c=0;c<a.length;++c)A(a[c],b,e);return this},unbind:function(a,b,e){for(var a=a instanceof Array?a:[a],c=0;c<a.length;++c){for(var f=b,d=e,g=v(a[c],d),h=j[g.key],i=0;i<h.length;)h[i].callback==f&&h[i].action==d?h.splice(i,1):i++;j[g.key]=h}return this},trigger:function(a,b){if(m[a+":"+b])m[a+":"+b]({},a);return this},reset:function(){j={};m={};return this},stopCallback:function(a,b){return-1<(" "+b.className+" ").indexOf(" mousetrap ")?
!1:"INPUT"==b.tagName||"SELECT"==b.tagName||"TEXTAREA"==b.tagName||b.contentEditable&&"true"==b.contentEditable},handleKey:function(a,b,e){var c;var f,d=[],g=e.type;if(j[a]){"keyup"==g&&u(a)&&(b=[a]);for(f=0;f<j[a].length;++f)if(c=j[a][f],!(c.seq&&k[c.seq]!=c.level)&&g==c.action&&("keypress"==g&&!e.metaKey&&!e.ctrlKey||b.sort().join(",")===c.modifiers.sort().join(",")))void 0==c.combo&&j[a].splice(f,1),d.push(c);c=d}else c=[];b={};g=0;f=!1;for(d=0;d<c.length;++d)c[d].seq&&(g=Math.max(g,c[d].level));
for(d=0;d<c.length;++d)c[d].seq?c[d].level==g&&(f=!0,b[c[d].seq]=1,q(c[d].callback,e,c[d].combo)):f||q(c[d].callback,e,c[d].combo);c="keypress"==e.type&&C;e.type==p&&(!u(a)&&!c)&&o(b);C=f&&"keydown"==e.type}};return r});