/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../edit_session ../virtual_renderer ../editor ../range ../lib/event ../lib/lang ../lib/dom".split(" "),function(g,l){g("../edit_session");var m=g("../virtual_renderer").VirtualRenderer,n=g("../editor").Editor,k=g("../range").Range,o=g("../lib/event"),p=g("../lib/lang"),j=g("../lib/dom"),q=function(d){d=new m(d);d.$maxLines=4;d=new n(d);d.setHighlightActiveLine(!1);d.setShowPrintMargin(!1);d.renderer.setShowGutter(!1);d.renderer.setHighlightGutterLine(!1);d.$mouseHandler.$focusWaitTimout=
0;d.$highlightTagPending=!0;return d};j.importCssString(".ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {    background-color: #CAD6FA;    z-index: 1;}.ace_editor.ace_autocomplete .ace_line-hover {    border: 1px solid #abbffe;    margin-top: -1px;    background: rgba(233,233,253,0.4);}.ace_editor.ace_autocomplete .ace_line-hover {    position: absolute;    z-index: 2;}.ace_editor.ace_autocomplete .ace_scroller {   background: none;   border: none;   box-shadow: none;}.ace_rightAlignedText {    color: gray;    display: inline-block;    position: absolute;    right: 4px;    text-align: right;    z-index: -1;}.ace_editor.ace_autocomplete .ace_completion-highlight{    color: #000;    text-shadow: 0 0 0.01em;}.ace_editor.ace_autocomplete {    width: 280px;    z-index: 200000;    background: #fbfbfb;    color: #444;    border: 1px lightgray solid;    position: fixed;    box-shadow: 2px 3px 5px rgba(0,0,0,.2);    line-height: 1.4;}");
l.AcePopup=function(d){var f=j.createElement("div"),a=new q(f);d&&d.appendChild(f);f.style.display="none";a.renderer.content.style.cursor="default";a.renderer.setStyle("ace_autocomplete");a.setOption("displayIndentGuides",!1);a.setOption("dragDelay",150);d=function(){};a.focus=d;a.$isFocused=!0;a.renderer.$cursorLayer.restartTimer=d;a.renderer.$cursorLayer.element.style.opacity=0;a.renderer.$maxLines=8;a.renderer.$keepTextAreaAtCursor=!1;a.setHighlightActiveLine(!1);a.session.highlight("");a.session.$searchHighlight.clazz=
"ace_highlight-marker";a.on("mousedown",function(b){var e=b.getDocumentPosition();a.selection.moveToPosition(e);h.start.row=h.end.row=e.row;b.stop()});var i,c=new k(-1,0,-1,Infinity),h=new k(-1,0,-1,Infinity);h.id=a.session.addMarker(h,"ace_active-line","fullLine");a.setSelectOnHover=function(b){b?c.id&&(a.session.removeMarker(c.id),c.id=null):c.id=a.session.addMarker(c,"ace_line-hover","fullLine")};a.setSelectOnHover(!1);a.on("mousemove",function(b){i?i.x==b.x&&i.y==b.y||(i=b,i.scrollTop=a.renderer.scrollTop,
b=i.getDocumentPosition().row,c.start.row!=b&&(c.id||a.setRow(b),g(b))):i=b});a.renderer.on("beforeRender",function(){if(i&&-1!=c.start.row){i.$pos=null;var b=i.getDocumentPosition().row;c.id||a.setRow(b);g(b,!0)}});a.renderer.on("afterRender",function(){var b=a.getRow(),e=a.renderer.$textLayer,b=e.element.childNodes[b-e.config.firstRow];b!=e.selectedNode&&(e.selectedNode&&j.removeCssClass(e.selectedNode,"ace_selected"),(e.selectedNode=b)&&j.addCssClass(b,"ace_selected"))});var f=function(){g(-1)},
g=function(b,e){b!==c.start.row&&(c.start.row=c.end.row=b,e||a.session._emit("changeBackMarker"),a._emit("changeHoverMarker"))};a.getHoveredRow=function(){return c.start.row};o.addListener(a.container,"mouseout",f);a.on("hide",f);a.on("changeSelection",f);a.session.doc.getLength=function(){return a.data.length};a.session.doc.getLine=function(b){b=a.data[b];return"string"==typeof b?b:b&&b.value||""};f=a.session.bgTokenizer;f.$tokenizeRow=function(b){var b=a.data[b],e=[];if(!b)return e;"string"==typeof b&&
(b={value:b});b.caption||(b.caption=b.value||b.name);for(var d=-1,c,g,f=0;f<b.caption.length;f++)g=b.caption[f],c=b.matchMask&1<<f?1:0,d!==c?(e.push({type:b.className||""+(c?"completion-highlight":""),value:g}),d=c):e[e.length-1].value+=g;b.meta&&b.meta.length+b.caption.length<a.renderer.$size.scrollerWidth/a.renderer.layerConfig.characterWidth-2&&e.push({type:"rightAlignedText",value:b.meta});return e};f.$updateOnChange=d;f.start=d;a.session.$computeWidth=function(){return this.screenWidth=0};a.$blockScrolling=
Infinity;a.isOpen=!1;a.isTopdown=!1;a.data=[];a.setData=function(b){a.data=b||[];a.setValue(p.stringRepeat("\n",b.length),-1);a.setRow(0)};a.getData=function(b){return a.data[b]};a.getRow=function(){return h.start.row};a.setRow=function(b){b=Math.max(-1,Math.min(this.data.length,b));h.start.row!=b&&(a.selection.clearSelection(),h.start.row=h.end.row=b||0,a.session._emit("changeBackMarker"),a.moveCursorTo(b||0,0),a.isOpen&&a._signal("select"))};a.on("changeSelection",function(){a.isOpen&&a.setRow(a.selection.lead.row);
a.renderer.scrollCursorIntoView()});a.hide=function(){this.container.style.display="none";this._signal("hide");a.isOpen=!1};a.show=function(b,e,d){var c=this.container,f=window.innerHeight,g=window.innerWidth,h=b.top+this.$borderSize;h+1.4*this.renderer.$maxLines*e>f-e&&!d?(c.style.top="",c.style.bottom=f-h+"px",a.isTopdown=!1):(c.style.top=h+e+"px",c.style.bottom="",a.isTopdown=!0);c.style.display="";this.renderer.$textLayer.checkForSizeChanges();b=b.left;b+c.offsetWidth>g&&(b=g-c.offsetWidth);c.style.left=
b+"px";this._signal("show");i=null;a.isOpen=!0};a.getTextLeftOffset=function(){return this.$borderSize+this.renderer.$padding+this.$imageSize};a.$imageSize=0;a.$borderSize=1;return a}});