/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ace/keyboard/hash_handler ace/editor ace/snippets ace/range ace/config ace/config".split(" "),function(f,d){function k(){}var o=f("ace/keyboard/hash_handler").HashHandler,p=f("ace/editor").Editor,q=f("ace/snippets").snippetManager,r=f("ace/range").Range,c,h;k.prototype={setupContext:function(a){this.ace=a;this.indentation=a.session.getTabString();c||(c=window.emmet);c.require("resources").setVariable("indentation",this.indentation);this.$syntax=null;this.$syntax=this.getSyntax()},
getSelectionRange:function(){var a=this.ace.getSelectionRange(),b=this.ace.session.doc;return{start:b.positionToIndex(a.start),end:b.positionToIndex(a.end)}},createSelection:function(a,b){var e=this.ace.session.doc;this.ace.selection.setRange({start:e.indexToPosition(a),end:e.indexToPosition(b)})},getCurrentLineRange:function(){var a=this.ace,b=a.getCursorPosition().row,e=a.session.getLine(b).length,a=a.session.doc.positionToIndex({row:b,column:0});return{start:a,end:a+e}},getCaretPos:function(){var a=
this.ace.getCursorPosition();return this.ace.session.doc.positionToIndex(a)},setCaretPos:function(a){a=this.ace.session.doc.indexToPosition(a);this.ace.selection.moveToPosition(a)},getCurrentLine:function(){var a=this.ace.getCursorPosition().row;return this.ace.session.getLine(a)},replaceContent:function(a,b,e){null==e&&(e=null==b?this.getContent().length:b);null==b&&(b=0);var d=this.ace,c=d.session.doc,b=r.fromPoints(c.indexToPosition(b),c.indexToPosition(e));d.session.remove(b);b.end=b.start;a=
this.$updateTabstops(a);q.insertSnippet(d,a)},getContent:function(){return this.ace.getValue()},getSyntax:function(){if(this.$syntax)return this.$syntax;var a=this.ace.session.$modeId.split("/").pop();if("html"==a||"php"==a){var b=this.ace.getCursorPosition(),b=this.ace.session.getState(b.row);"string"!=typeof b&&(b=b[0]);b&&(b=b.split("-"),1<b.length?a=b[0]:"php"==a&&(a="html"))}return a},getProfileName:function(){switch(this.getSyntax()){case "css":return"css";case "xml":case "xsl":return"xml";
case "html":var a=c.require("resources").getVariable("profile");a||(a=-1!=this.ace.session.getLines(0,2).join("").search(/<!DOCTYPE[^>]+XHTML/i)?"xhtml":"html");return a}return"xhtml"},prompt:function(a){return prompt(a)},getSelection:function(){return this.ace.session.getTextRange()},getFilePath:function(){return""},$updateTabstops:function(a){var b=0,e=null,d=c.require("range"),f=c.require("tabStops"),g=c.require("resources").getVocabulary("user"),h={tabstop:function(a){var c=parseInt(a.group,10),
g=0===c,c=g?++b:c+1E3,i=a.placeholder;i&&(i=f.processText(i,h));c="${"+c+(i?":"+i:"")+"}";g&&(e=d.create(a.start,c));return c},escape:function(a){return"$"==a?"\\$":"\\"==a?"\\\\":a}},a=f.processText(a,h);g.variables.insert_final_tabstop&&!/\$\{0\}$/.test(a)?a+="${0}":e&&(a=c.require("utils").replaceSubstring(a,"${0}",e));return a}};var m={expand_abbreviation:{mac:"ctrl+alt+e",win:"alt+e"},match_pair_outward:{mac:"ctrl+d",win:"ctrl+,"},match_pair_inward:{mac:"ctrl+j",win:"ctrl+shift+0"},matching_pair:{mac:"ctrl+alt+j",
win:"alt+j"},next_edit_point:"alt+right",prev_edit_point:"alt+left",toggle_comment:{mac:"command+/",win:"ctrl+/"},split_join_tag:{mac:"shift+command+'",win:"shift+ctrl+`"},remove_tag:{mac:"command+'",win:"shift+ctrl+;"},evaluate_math_expression:{mac:"shift+command+y",win:"shift+ctrl+y"},increment_number_by_1:"ctrl+up",decrement_number_by_1:"ctrl+down",increment_number_by_01:"alt+up",decrement_number_by_01:"alt+down",increment_number_by_10:{mac:"alt+command+up",win:"shift+alt+up"},decrement_number_by_10:{mac:"alt+command+down",
win:"shift+alt+down"},select_next_item:{mac:"shift+command+.",win:"shift+ctrl+."},select_previous_item:{mac:"shift+command+,",win:"shift+ctrl+,"},reflect_css_value:{mac:"shift+command+r",win:"shift+ctrl+r"},encode_decode_data_url:{mac:"shift+ctrl+d",win:"ctrl+'"},expand_abbreviation_with_tab:"Tab",wrap_with_abbreviation:{mac:"shift+ctrl+a",win:"shift+ctrl+a"}},j=new k;d.commands=new o;d.runEmmetCommand=function(a){try{j.setupContext(a);if("php"==j.getSyntax())return!1;var b=c.require("actions");if("expand_abbreviation_with_tab"==
this.action&&!a.selection.isEmpty())return!1;if("wrap_with_abbreviation"==this.action)return setTimeout(function(){b.run("wrap_with_abbreviation",j)},0);var e=a.selection.lead,d=a.session.getTokenAt(e.row,e.column);if(d&&/\btag\b/.test(d.type))return!1;var f=b.run(this.action,j)}catch(g){a._signal("changeStatus","string"==typeof g?g:g.message),console.log(g),f=!1}return f};for(var l in m)d.commands.addCommand({name:"emmet:"+l,action:l,bindKey:m[l],exec:d.runEmmetCommand,multiSelectAction:"forEach"});
d.updateCommands=function(a,b){b?a.keyBinding.addKeyboardHandler(d.commands):a.keyBinding.removeKeyboardHandler(d.commands)};d.isSupportedMode=function(a){return a&&/css|less|scss|sass|stylus|html|php|twig|ejs/.test(a)};var n=function(a,b){if(b){var c=d.isSupportedMode(b.session.$modeId);!1===a.enableEmmet&&(c=!1);c&&"string"==typeof h&&f("ace/config").loadModule(h,function(){h=null});d.updateCommands(b,c)}};d.AceEmmetEditor=k;f("ace/config").defineOptions(p.prototype,"editor",{enableEmmet:{set:function(a){this[a?
"on":"removeListener"]("changeMode",n);n({enableEmmet:!!a},this)},value:!0}});d.setCore=function(a){"string"==typeof a?h=a:c=a}});