/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

"undefined"!==typeof process&&require("amd-loader");
define("require exports module ../multi_select ./../edit_session ./../editor ./../range ./../test/mockrenderer ./emacs ./../test/assertions".split(" "),function(g,o,j){function e(c){c=new k(c.split("\n"));a=new l(new m,c);a.setKeyboardHandler(n.handler);d=a.selection}function f(a){return JSON.stringify(a,null,2)}function h(a,b){return a.map(function(a){return a[b]})}g("../multi_select");var k=g("./../edit_session").EditSession,l=g("./../editor").Editor,i=g("./../range").Range,m=g("./../test/mockrenderer").MockRenderer,
n=g("./emacs"),b=g("./../test/assertions"),a,d;j.exports={"test: detach removes emacs commands from command manager":function(){e("");b.ok(!!a.commands.byName.keyboardQuit,"setup error: emacs commands not installed");a.keyBinding.removeKeyboardHandler(a.getKeyboardHandler());b.ok(!a.commands.byName.keyboardQuit,"emacs commands not removed")},"test: keyboardQuit clears selection":function(){e("foo");a.selectAll();a.execCommand("keyboardQuit");b.ok(a.selection.isEmpty(),"selection non-empty")},"test: exchangePointAndMark without mark set":function(){e("foo");
d.setRange(i.fromPoints({row:0,column:1},{row:0,column:3}));a.execCommand("exchangePointAndMark");b.deepEqual({row:0,column:1},a.getCursorPosition(),f(a.getCursorPosition()))},"test: exchangePointAndMark with mark set":function(){e("foo");a.pushEmacsMark({row:0,column:1});a.pushEmacsMark({row:0,column:2});a.execCommand("exchangePointAndMark",{count:4});b.deepEqual({row:0,column:2},a.getCursorPosition(),f(a.getCursorPosition()));b.deepEqual([{row:0,column:1},{row:0,column:0}],a.session.$emacsMarkRing,
f(a.session.$emacsMarkRing))},"test: exchangePointAndMark with selection":function(){e("foo");a.pushEmacsMark({row:0,column:1});a.pushEmacsMark({row:0,column:2});d.setRange(i.fromPoints({row:0,column:0},{row:0,column:1}),!0);a.execCommand("exchangePointAndMark");b.deepEqual({row:0,column:1},a.getCursorPosition(),f(a.getCursorPosition()));b.deepEqual([{row:0,column:1},{row:0,column:2}],a.session.$emacsMarkRing,f(a.session.$emacsMarkRing))},"test: exchangePointAndMark with multi selection":function(){e("foo\nhello world\n123");
var c=[[{row:0,column:0},{row:0,column:3}],[{row:1,column:0},{row:1,column:5}],[{row:1,column:6},{row:1,column:11}]];c.forEach(function(a){d.addRange(i.fromPoints(a[0],a[1]))});b.equal("foo\nhello\nworld",a.getSelectedText());a.execCommand("exchangePointAndMark");b.equal("foo\nhello\nworld",a.getSelectedText());b.deepEqual(h(c,0),h(d.getAllRanges(),"cursor"),"selections dir not inverted")},"test: exchangePointAndMark with multi cursors":function(){e("foo\nhello world\n123");var c=[[{row:0,column:0},
{row:0,column:3}],[{row:1,column:0},{row:1,column:5}],[{row:1,column:6},{row:1,column:11}]];c.forEach(function(b){a.pushEmacsMark(b[1]);d.addRange(i.fromPoints(b[0],b[0]))});b.deepEqual(h(c,0),h(d.getAllRanges(),"cursor"),f(d.getAllRanges()));a.execCommand("exchangePointAndMark");b.deepEqual(h(c,1),h(d.getAllRanges(),"cursor"),"not inverted: "+f(d.getAllRanges()))},"test: setMark with multi cursors":function(){e("foo\nhello world\n123");var c=[{row:0,column:0},{row:1,column:0},{row:1,column:6}];c.forEach(function(a){d.addRange(i.fromPoints(a,
a))});a.execCommand("setMark");b.deepEqual(c,a.session.$emacsMarkRing,f(a.session.$emacsMarkRing))}}});"undefined"!==typeof module&&module===require.main&&require("asyncjs").test.testcase(module.exports).exec();