/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","../lib/keys","../lib/useragent"],function(j,k){function h(a,b){this.platform=b||(m.isMac?"mac":"win");this.commands={};this.commandKeyBinding={};this.addCommands(a);this.$singleCommand=!0}function l(a,b){h.call(this,a,b);this.$singleCommand=!1}var g=j("../lib/keys"),m=j("../lib/useragent"),i=g.KEY_MODS;l.prototype=h.prototype;(function(){this.addCommand=function(a){this.commands[a.name]&&this.removeCommand(a);this.commands[a.name]=a;a.bindKey&&this._buildKeyHash(a)};
this.removeCommand=function(a,b){var c=a&&("string"===typeof a?a:a.name),a=this.commands[c];b||delete this.commands[c];var c=this.commandKeyBinding,d;for(d in c){var e=c[d];if(e==a)delete c[d];else if(Array.isArray(e)){var f=e.indexOf(a);-1!=f&&(e.splice(f,1),1==e.length&&(c[d]=e[0]))}}};this.bindKey=function(a,b,c){"object"==typeof a&&(a=a[this.platform]);if(a){if("function"==typeof b)return this.addCommand({exec:b,bindKey:a,name:b.name||a});a.split("|").forEach(function(a){var e="";if(-1!=a.indexOf(" ")){var f=
a.split(/\s+/),a=f.pop();f.forEach(function(a){a=this.parseKeys(a);e+=(e?" ":"")+(i[a.hashId]+a.key);this._addCommandToBinding(e,"chainKeys")},this);e+=" "}a=this.parseKeys(a);this._addCommandToBinding(e+(i[a.hashId]+a.key),b,c)},this)}};this._addCommandToBinding=function(a,b,c){var d=this.commandKeyBinding,e;b?!d[a]||this.$singleCommand?d[a]=b:(Array.isArray(d[a])?-1!=(e=d[a].indexOf(b))&&d[a].splice(e,1):d[a]=[d[a]],c||b.isDefault?d[a].unshift(b):d[a].push(b)):delete d[a]};this.addCommands=function(a){a&&
Object.keys(a).forEach(function(b){var c=a[b];if(c){if("string"===typeof c)return this.bindKey(c,b);"function"===typeof c&&(c={exec:c});"object"===typeof c&&(c.name||(c.name=b),this.addCommand(c))}},this)};this.removeCommands=function(a){Object.keys(a).forEach(function(b){this.removeCommand(a[b])},this)};this.bindKeys=function(a){Object.keys(a).forEach(function(b){this.bindKey(b,a[b])},this)};this._buildKeyHash=function(a){this.bindKey(a.bindKey,a)};this.parseKeys=function(a){var b=a.toLowerCase().split(/[\-\+]([\-\+])?/).filter(function(a){return a}),
c=b.pop(),d=g[c];if(g.FUNCTION_KEYS[d])c=g.FUNCTION_KEYS[d].toLowerCase();else if(b.length){if(1==b.length&&"shift"==b[0])return{key:c.toUpperCase(),hashId:-1}}else return{key:c,hashId:-1};for(var d=0,e=b.length;e--;){var f=g.KEY_MODS[b[e]];if(null==f)return"undefined"!=typeof console&&console.error("invalid modifier "+b[e]+" in "+a),!1;d|=f}return{key:c,hashId:d}};this.findKeyCommand=function(a,b){return this.commandKeyBinding[i[a]+b]};this.handleKeyboard=function(a,b,c,d){b=i[b]+c;c=this.commandKeyBinding[b];
a.$keyChain&&(a.$keyChain+=" "+b,c=this.commandKeyBinding[a.$keyChain]||c);if(c&&("chainKeys"==c||"chainKeys"==c[c.length-1]))return a.$keyChain=a.$keyChain||b,{command:"null"};a.$keyChain&&0<d&&(a.$keyChain="");return{command:c}}}).call(h.prototype);k.HashHandler=h;k.MultiHashHandler=l});