/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ../../lib/oop ../../lib/lang ../../range ./fold_mode ../../token_iterator".split(" "),function(h,o){function g(c,b){return-1<c.type.lastIndexOf(b+".xml")}var j=h("../../lib/oop");h("../../lib/lang");var i=h("../../range").Range,l=h("./fold_mode").FoldMode,m=h("../../token_iterator").TokenIterator,n=o.FoldMode=function(c,b){l.call(this);this.voidElements=c||{};this.optionalEndTags=j.mixin({},this.voidElements);b&&j.mixin(this.optionalEndTags,b)};j.inherits(n,l);var k=
function(){this.tagName="";this.selfClosing=this.closing=!1;this.start={row:0,column:0};this.end={row:0,column:0}};(function(){this.getFoldWidget=function(c,b,a){var d=this._getFirstTagInLine(c,a);return!d?"":d.closing||!d.tagName&&d.selfClosing?"markbeginend"==b?"end":"":!d.tagName||(d.selfClosing||this.voidElements.hasOwnProperty(d.tagName.toLowerCase()))||this._findEndTagInLine(c,a,d.tagName,d.end.column)?"":"start"};this._getFirstTagInLine=function(c,b){for(var a=c.getTokens(b),d=new k,f=0;f<
a.length;f++){var e=a[f];if(g(e,"tag-open")){d.end.column=d.start.column+e.value.length;d.closing=g(e,"end-tag-open");e=a[++f];if(!e)break;d.tagName=e.value;d.end.column+=e.value.length;for(f++;f<a.length;f++)if(e=a[f],d.end.column+=e.value.length,g(e,"tag-close")){d.selfClosing="/>"==e.value;break}return d}if(g(e,"tag-close"))return d.selfClosing="/>"==e.value,d;d.start.column+=e.value.length}return null};this._findEndTagInLine=function(c,b,a,d){for(var c=c.getTokens(b),f=b=0;f<c.length;f++){var e=
c[f],b=b+e.value.length;if(!(b<d)&&g(e,"end-tag-open")&&(e=c[f+1])&&e.value==a)return!0}return!1};this._readTagForward=function(c){var b=c.getCurrentToken();if(!b)return null;var a=new k;do if(g(b,"tag-open"))a.closing=g(b,"end-tag-open"),a.start.row=c.getCurrentTokenRow(),a.start.column=c.getCurrentTokenColumn();else if(g(b,"tag-name"))a.tagName=b.value;else if(g(b,"tag-close"))return a.selfClosing="/>"==b.value,a.end.row=c.getCurrentTokenRow(),a.end.column=c.getCurrentTokenColumn()+b.value.length,
c.stepForward(),a;while(b=c.stepForward());return null};this._readTagBackward=function(c){var b=c.getCurrentToken();if(!b)return null;var a=new k;do{if(g(b,"tag-open"))return a.closing=g(b,"end-tag-open"),a.start.row=c.getCurrentTokenRow(),a.start.column=c.getCurrentTokenColumn(),c.stepBackward(),a;g(b,"tag-name")?a.tagName=b.value:g(b,"tag-close")&&(a.selfClosing="/>"==b.value,a.end.row=c.getCurrentTokenRow(),a.end.column=c.getCurrentTokenColumn()+b.value.length)}while(b=c.stepBackward());return null};
this._pop=function(c,b){for(;c.length;){var a=c[c.length-1];if(!b||a.tagName==b.tagName)return c.pop();if(this.optionalEndTags.hasOwnProperty(a.tagName))c.pop();else return null}};this.getFoldWidgetRange=function(c,b,a){var d=this._getFirstTagInLine(c,a);if(!d)return null;b=[];if(!d.closing&&!d.selfClosing){var c=new m(c,a,d.start.column),f={row:a,column:d.start.column+d.tagName.length+2};d.start.row==d.end.row&&(f.column=d.end.column);for(;a=this._readTagForward(c);){if(a.selfClosing)if(b.length)continue;
else return a.start.column+=a.tagName.length+2,a.end.column-=2,i.fromPoints(a.start,a.end);if(a.closing){if(this._pop(b,a),0==b.length)return i.fromPoints(f,a.start)}else b.push(a)}}else{c=new m(c,a,d.end.column);for(d={row:a,column:d.start.column};a=this._readTagBackward(c);){if(a.selfClosing)if(b.length)continue;else return a.start.column+=a.tagName.length+2,a.end.column-=2,i.fromPoints(a.start,a.end);if(a.closing)b.push(a);else if(this._pop(b,a),0==b.length)return a.start.column+=a.tagName.length+
2,a.start.row==a.end.row&&a.start.column<a.end.column&&(a.start.column=a.end.column),i.fromPoints(a.start,d)}}}}).call(n.prototype)});