/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define(["require","exports","module","./config"],function(t,u){var v=t("./config"),r=2E3,s=function(b){this.states=b;this.regExps={};this.matchMappings={};for(var f in this.states){for(var b=this.states[f],d=[],c=0,e=this.matchMappings[f]={defaultToken:"text"},o="g",n=[],j=0;j<b.length;j++){var a=b[j];a.defaultToken&&(e.defaultToken=a.defaultToken);a.caseInsensitive&&(o="gi");if(null!=a.regex){a.regex instanceof RegExp&&(a.regex=a.regex.toString().slice(1,-1));var h=a.regex,i=RegExp("(?:("+h+")|(.))").exec("a").length-
2;Array.isArray(a.token)?1==a.token.length||1==i?a.token=a.token[0]:i-1!=a.token.length?(this.reportError("number of classes and regexp groups doesn't match",{rule:a,groupCount:i-1}),a.token=a.token[0]):(a.tokenArray=a.token,a.token=null,a.onMatch=this.$arrayTokens):"function"==typeof a.token&&!a.onMatch&&(a.onMatch=1<i?this.$applyToken:a.token);1<i&&(/\\\d/.test(a.regex)?h=a.regex.replace(/\\([0-9]+)/g,function(a,b){return"\\"+(parseInt(b,10)+c+1)}):(i=1,h=this.removeCapturingGroups(a.regex)),!a.splitRegex&&
"string"!=typeof a.token&&n.push(a));e[c]=j;c+=i;d.push(h);a.onMatch||(a.onMatch=null)}}d.length||(e[0]=0,d.push("$"));n.forEach(function(a){a.splitRegex=this.createSplitterRegexp(a.regex,o)},this);this.regExps[f]=RegExp("("+d.join(")|(")+")|($)",o)}};(function(){this.$setMaxTokenCount=function(b){r=b|0};this.$applyToken=function(b){var f=this.splitRegex.exec(b).slice(1),d=this.token.apply(this,f);if("string"===typeof d)return[{type:d,value:b}];for(var b=[],c=0,e=d.length;c<e;c++)f[c]&&(b[b.length]=
{type:d[c],value:f[c]});return b};this.$arrayTokens=function(b){if(!b)return[];b=this.splitRegex.exec(b);if(!b)return"text";for(var f=[],d=this.tokenArray,c=0,e=d.length;c<e;c++)b[c+1]&&(f[f.length]={type:d[c],value:b[c+1]});return f};this.removeCapturingGroups=function(b){return b.replace(/\[(?:\\.|[^\]])*?\]|\\.|\(\?[:=!]|(\()/g,function(b,d){return d?"(?:":b})};this.createSplitterRegexp=function(b,f){if(-1!=b.indexOf("(?=")){var d=0,c=!1,e={};b.replace(/(\\.)|(\((?:\?[=!])?)|(\))|([\[\]])/g,function(b,
f,j,a,h,i){c?c="]"!=h:h?c=!0:a?(d==e.stack&&(e.end=i+1,e.stack=-1),d--):j&&(d++,1!=j.length&&(e.stack=d,e.start=i));return b});null!=e.end&&/^\)*$/.test(b.substr(e.end))&&(b=b.substring(0,e.start)+b.substr(e.end))}return RegExp(b,(f||"").replace("g",""))};this.getLineTokens=function(b,f){if(f&&"string"!=typeof f){var d=f.slice(0),f=d[0];"#tmp"===f&&(d.shift(),f=d.shift())}else d=[];var c=f||"start",e=this.states[c];e||(c="start",e=this.states[c]);var o=this.matchMappings[c],n=this.regExps[c];n.lastIndex=
0;for(var j,a=[],h=0,i=0,g={type:null,value:""};j=n.exec(b);){var m=o.defaultToken,l=null,p=j[0],q=n.lastIndex;if(q-p.length>h){var k=b.substring(h,q-p.length);g.type==m?g.value+=k:(g.type&&a.push(g),g={type:m,value:k})}for(k=0;k<j.length-2;k++)if(void 0!==j[k+1]){l=e[o[k]];m=l.onMatch?l.onMatch(p,c,d):l.token;l.next&&(c="string"==typeof l.next?l.next:l.next(c,d),e=this.states[c],e||(this.reportError("state doesn't exist",c),c="start",e=this.states[c]),o=this.matchMappings[c],h=q,n=this.regExps[c],
n.lastIndex=q);break}if(p)if("string"===typeof m)(!l||!1!==l.merge)&&g.type===m?g.value+=p:(g.type&&a.push(g),g={type:m,value:p});else if(m){g.type&&a.push(g);g={type:null,value:""};for(k=0;k<m.length;k++)a.push(m[k])}if(h==b.length)break;h=q;if(i++>r){for(i>2*b.length&&this.reportError("infinite loop with in ace tokenizer",{startState:f,line:b});h<b.length;)g.type&&a.push(g),g={value:b.substring(h,h+=2E3),type:"overflow"};c="start";d=[];break}}g.type&&a.push(g);1<d.length&&d[0]!==c&&d.unshift("#tmp",
c);return{tokens:a,state:d.length?d:c}};this.reportError=v.reportError}).call(s.prototype);u.Tokenizer=s});