/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2012, Ajax.org B.V.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("component/smartnames/encoding/smartnamestringpart",["require","exports","module"],function(g,d){var l=function(){};(function(){this.isSmartNamePart=function(){return null!==this._smartName};this.isTextPart=function(){return null!==this._text};this.getAsSmartName=function(){return this._smartName};this.getAsText=function(){return this._text}}).call(l.prototype);d.makeSmartNamePart=function(c){if(null==c)throw'A "SmartName" part of a SmartName string can not be null.';var d=new l;d._smartName=
c;d._text=null;return d};d.makePlainTextPart=function(c){if(null==c)throw'A "Text" part of a SmartName string can not be null.';var d=new l;d._smartName=null;d._text=c;return d}});
define("utils/wcrerror",[],function(){var g=function(d,l){Error.call(this);this.errormessage=l;this.langTag=d;this.message=(this.errormessage?this.errormessage+" ":"")+(this.langTag?"(langTag: "+this.langTag+")":"")};g.prototype=Object.create(Error.prototype);g.prototype.constructor=g;g.prototype.name="WCRError";g.prototype.getTag=function(){return this.langTag};return g});
define("utils/extendedstring",[],function(){String.prototype.replaceAll=function(g,d){return void 0===d?this.toString():this.split(g).join(d)};return null});
define("component/smartnames/encoding/smartnameargumentencoding",["utils/wcrerror","utils/extendedstring"],function(g){var d={},l=function(c,d){this._delimeterChar=c;this._escapeChar=d};(function(){this.encodeSmartName=function(c,d){for(var k=c,h=0;h<d.length;h++)var f=d[h].replaceAll(this._escapeChar,this._escapeChar+this._escapeChar).replaceAll(this._delimeterChar,this._escapeChar+this._delimeterChar),k=k+this._delimeterChar,k=k+f;return k.toString()};this.decodeSmartNameArguments=function(c){for(var d=
[],k=!1,h="",f=0;f<c.length;f++){var e=c.charAt(f);if(e===this._escapeChar)k&&(h+=this._escapeChar),k=!k;else if(e===this._delimeterChar)k?(h+=this._delimeterChar,k=!1):(d.push(h),h="");else{if(k)throw new g("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");h+=e}}d.push(h);if(k)throw new g("SMARTNAME_ARGUMENT_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of arguments of SmartName failed. Found a single escape character in the string.");
return d}}).call(l.prototype);d.DEFAULT=new l(":","\\");d.constructor=l;return d});
define("component/smartnames/encoding/smartname",["../encoding/smartnameargumentencoding"],function(g){var d=function(){if(1===arguments.length){var d=g.DEFAULT.decodeSmartNameArguments(arguments[0]);this._name=d[0];this._arguments=1<d.length?d.slice(1,d.length):[]}else if(1<arguments.length)this._name=arguments[0],2==arguments.length&&arguments[1].constructor==Array?this._arguments=arguments[1]:(this._arguments=Array.prototype.slice.call(arguments),this._arguments=this._arguments.slice(1,this._arguments.length));
else if(1>arguments.length)throw Error("A SmartName requires at least one 'name' parameter.");};(function(){this.getName=function(){return this._name};this.getArguments=function(){return this._arguments};this.getFullName=function(){return g.DEFAULT.encodeSmartName(this._name,this._arguments)};this.equals=function(g){if(g instanceof d){var c=g.getName()===this.getName(),g=this._compareArguments(g);return c&&g}return!1};this._compareArguments=function(d){if(this._arguments.length===d.getArguments().length){for(var c=
0;c<this._arguments.length;c++)if(this._arguments[c]!==d.getArguments()[c])return!1;return!0}return!1};this.getDisplayName=function(){return"ProjAttr"==this._name?this._arguments[0]+" (Project)":"DocAttr"==this._name?this._arguments[0]+" (Document)":this.getFullName()}}).call(d.prototype);return d});
define("component/smartnames/encoding/smartnameencoding",["./smartnamestringpart","./smartname","utils/wcrerror","underscore","utils/extendedstring"],function(g,d,l,c){function m(f){if(!1===f)throw Error("Something is wrong in the implementation of the SmartNameEncoding. Assert failed.");}var k={},h=function(f,e,i){this._startOfSmartName=f;this._endOfSmartName=e;this._escapeChar=i;this._charactersToEscape=[];for(var a=i+f+e,b=0;b<a.length;b++){var h=a.charAt(b);c.contains(this._charactersToEscape,
h)||this._charactersToEscape.push(h)}m(-1===f.indexOf(i));m(-1===e.indexOf(i))};(function(){this.escapeString=function(f){for(var e=0;e<this._charactersToEscape.length;e++)f=f.replaceAll(""+this._charactersToEscape[e],""+this._escapeChar+this._charactersToEscape[e]);return f};this.unescapeString=function(f){for(var e=this._charactersToEscape.length-1;0<=e;e--)f=f.replaceAll(""+this._escapeChar+this._charactersToEscape[e],""+this._charactersToEscape[e]);return f};this.encodeSmartNameString=function(f){for(var e=
"",i="",a=0;a<f.length;a++){var b=f[a];b.isTextPart()?i+=b.getAsText():(e+=this.escapeString(i),i="",e+=this._startOfSmartName,e+=this.escapeString(b.getAsSmartName().getFullName()),e+=this._endOfSmartName)}return e+=this.escapeString(i)};this.decodeSmartNameString=function(f){for(var e=[],i=!1,a="",b=0;b<f.length;b++){var h=f.charAt(b);if(h===this._escapeChar)if(b+1<f.length){h=f.charAt(b+1);if(!c.contains(this._charactersToEscape,h))throw new l("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");
a+=h;b++}else throw new l("SMARTNAME_PARSING_ILLEGAL_ESCAPE_CHARACTER","Parsing of string with SmartNames failed. Found a single escape character in the string.");else if(b+this._startOfSmartName.length<=f.length&&this._startOfSmartName===f.substring(b,b+this._startOfSmartName.length)){if(i)throw new l("SMARTNAME_PARSING_SMARTNAME_ALREADY_OPEN","Parsing of string with SmartNames failed. SmartName started within a SmartName.");0<a.length&&e.push(g.makePlainTextPart(a));a="";i=!0;b+=this._startOfSmartName.length-
1}else if(b+this._endOfSmartName.length<=f.length&&this._endOfSmartName===f.substring(b,b+this._endOfSmartName.length)){if(i)e.push(g.makeSmartNamePart(new d(a))),a="",i=!1;else throw new l("SMARTNAME_PARSING_SMARTNAME_NOT_OPEN","Parsing of string with SmartNames failed. SmartName was closed before the SmartName was opened.");b+=this._endOfSmartName.length-1}else a+=h}if(i)throw new l("SMARTNAME_PARSING_SMARTNAME_NEVER_CLOSED","Parsing of string with SmartNames failed. SmartName was never closed.");
0<a.length&&e.push(g.makePlainTextPart(a));return e};this.containsSmartName=function(f){for(var f=this.decodeSmartNameString(f),e=0;e<f.length;e++)if(f[e].isSmartNamePart())return!0;return!1};this.modifySmartNameEncodedString=function(f,e,i){if(void 0===e||null===e)e=function(a){return a};if(void 0===i||null===i)i=function(a){return a};for(var f=this.decodeSmartNameString(f),a=0;a<f.length;a++){var b=f[a];b.isSmartNamePart()?(b=b.getAsSmartName(),b=i(b),f[a]=g.makeSmartNamePart(b)):(b=b.getAsText(),
b=e(b),f[a]=g.makePlainTextPart(b))}return this.encodeSmartNameString(f)}}).call(h.prototype);k.SAVEDSEARCH=new h("{","}","!");k.AUTONAMING=new h("[","]","\u00a7");k.UNIVERSALCOPYPASTEENCODING=new h("[","]","\\");k.constructor=h;return k});
define("lib/ace/snippets","require exports module ./lib/oop ./lib/event_emitter ./lib/lang ./range ./anchor ./keyboard/hash_handler ./tokenizer ./lib/dom ./editor".split(" "),function(g,d){var l=g("./lib/oop"),c=g("./lib/event_emitter").EventEmitter,m=g("./lib/lang"),k=g("./range").Range;g("./anchor");var h=g("./keyboard/hash_handler").HashHandler,f=g("./tokenizer").Tokenizer,e=k.comparePoints,i=function(){this.snippetMap={};this.snippetNameMap={}};(function(){l.implement(this,c);this.getTokenizer=
function(){function j(j,a,b){j=j.substr(1);return/^\d+$/.test(j)&&!b.inFormatString?[{tabstopId:parseInt(j,10)}]:[{text:j}]}function a(j){return"(?:[^\\\\"+j+"]|\\\\.)"}i.$tokenizer=new f({start:[{regex:/:/,onMatch:function(j,a,b){return b.length&&b[0].expectIf?(b[0].expectIf=!1,b[0].elseBranch=b[0],[b[0]]):":"}},{regex:/\\./,onMatch:function(j,a,b){a=j[1];"}"==a&&b.length?j=a:-1!="`$\\".indexOf(a)?j=a:b.inFormatString&&("n"==a?j="\n":"t"==a?j="\n":-1!="ulULE".indexOf(a)&&(j={changeCase:a,local:"a"<
a}));return[j]}},{regex:/}/,onMatch:function(j,a,b){return[b.length?b.shift():j]}},{regex:/\$(?:\d+|\w+)/,onMatch:j},{regex:/\$\{[\dA-Z_a-z]+/,onMatch:function(a,b,e){a=j(a.substr(1),b,e);e.unshift(a[0]);return a},next:"snippetVar"},{regex:/\n/,token:"newline",merge:!1}],snippetVar:[{regex:"\\|"+a("\\|")+"*\\|",onMatch:function(j,a,b){b[0].choices=j.slice(1,-1).split(",")},next:"start"},{regex:"/("+a("/")+"+)/(?:("+a("/")+"*)/)(\\w*):?",onMatch:function(j,a,b){a=b[0];a.fmtString=j;j=this.splitRegex.exec(j);
a.guard=j[1];a.fmt=j[2];a.flag=j[3];return""},next:"start"},{regex:"`"+a("`")+"*`",onMatch:function(j,a,b){b[0].code=j.splice(1,-1);return""},next:"start"},{regex:"\\?",onMatch:function(j,a,b){b[0]&&(b[0].expectIf=!0)},next:"start"},{regex:"([^:}\\\\]|\\\\.)*:?",token:"",next:"start"}],formatString:[{regex:"/("+a("/")+"+)/",token:"regex"},{regex:"",onMatch:function(j,a,b){b.inFormatString=!0},next:"start"}]});i.prototype.getTokenizer=function(){return i.$tokenizer};return i.$tokenizer};this.tokenizeTmSnippet=
function(j,a){return this.getTokenizer().getLineTokens(j,a).tokens.map(function(j){return j.value||j})};this.$getDefaultValue=function(j,a){if(/^[A-Z]\d+$/.test(a)){var b=a.substr(1);return(this.variables[a[0]+"__"]||{})[b]}if(/^\d+$/.test(a))return(this.variables.__||{})[a];a=a.replace(/^TM_/,"");if(j)switch(b=j.session,a){case "CURRENT_WORD":var e=b.getWordRange();case "SELECTION":case "SELECTED_TEXT":return b.getTextRange(e);case "CURRENT_LINE":return b.getLine(j.getCursorPosition().row);case "PREV_LINE":return b.getLine(j.getCursorPosition().row-
1);case "LINE_INDEX":return j.getCursorPosition().column;case "LINE_NUMBER":return j.getCursorPosition().row+1;case "SOFT_TABS":return b.getUseSoftTabs()?"YES":"NO";case "TAB_SIZE":return b.getTabSize();case "FILENAME":case "FILEPATH":return"";case "FULLNAME":return"Ace"}};this.variables={};this.getVariableValue=function(j,a){return this.variables.hasOwnProperty(a)?this.variables[a](j,a)||"":this.$getDefaultValue(j,a)||""};this.tmStrFormat=function(a,b,e){var f=b.guard,f=RegExp(f,(b.flag||"").replace(/[^gi]/,
"")),i=this.tokenizeTmSnippet(b.fmt,"formatString"),c=this,a=a.replace(f,function(){c.variables.__=arguments;for(var a=c.resolveVariables(i,e),j="E",b=0;b<a.length;b++){var f=a[b];if("object"==typeof f)if(a[b]="",f.changeCase&&f.local){var o=a[b+1];o&&"string"==typeof o&&(a[b]="u"==f.changeCase?o[0].toUpperCase():o[0].toLowerCase(),a[b+1]=o.substr(1))}else f.changeCase&&(j=f.changeCase);else"U"==j?a[b]=f.toUpperCase():"L"==j&&(a[b]=f.toLowerCase())}return a.join("")});this.variables.__=null;return a};
this.resolveVariables=function(a,b){function f(b){b=a.indexOf(b,i+1);-1!=b&&(i=b)}for(var e=[],i=0;i<a.length;i++){var c=a[i];if("string"==typeof c)e.push(c);else if("object"==typeof c)if(c.skip)f(c);else if(!(c.processed<i))if(c.text){var h=this.getVariableValue(b,c.text);h&&c.fmtString&&(h=this.tmStrFormat(h,c));c.processed=i;null==c.expectIf?h&&(e.push(h),f(c)):h?c.skip=c.elseBranch:f(c)}else null!=c.tabstopId?e.push(c):null!=c.changeCase&&e.push(c)}return e};this.insertSnippetForSelection=function(b,
f){var e=b.getCursorPosition(),c=b.session.getLine(e.row),i=b.session.getTabString(),h=c.match(/^\s*/)[0];e.column<h.length&&(h=h.slice(0,e.column));var d=this.tokenizeTmSnippet(f),d=this.resolveVariables(d,b),d=d.map(function(a){return"\n"==a?a+h:"string"==typeof a?a.replace(/\t/g,i):a}),n=[];d.forEach(function(a,b){if("object"==typeof a){var j=a.tabstopId,e=n[j];e||(e=n[j]=[],e.index=j,e.value="");if(-1===e.indexOf(a)&&(e.push(a),j=d.indexOf(a,b+1),-1!==j))if(j=d.slice(b+1,j),j.some(function(a){return"object"===
typeof a})&&!e.value)e.value=j;else if(j.length&&(!e.value||"string"!==typeof e.value))e.value=j.join("")}});n.forEach(function(a){a.length=0});e={};for(c=0;c<d.length;c++){var p=d[c];if("object"==typeof p){var g=p.tabstopId,k=d.indexOf(p,c+1);if(e[g])e[g]===p&&(e[g]=null);else{var m=n[g],l;if("string"==typeof m.value)l=[m.value];else{l=m.value;for(var w=[],t=0;t<l.length;t++){var s=l[t];if("object"==typeof s){if(e[s.tabstopId])continue;var A=l.lastIndexOf(s,t-1),s=w[A]||{tabstopId:s.tabstopId}}w[t]=
s}l=w}l.unshift(c+1,Math.max(0,k-c));l.push(p);e[g]=p;d.splice.apply(d,l);-1===m.indexOf(p)&&m.push(p)}}}var x=0,u=0,y="";d.forEach(function(a){"string"===typeof a?("\n"===a[0]?(u=a.length-1,x++):u+=a.length,y+=a):a.start?a.end={row:x,column:u}:a.start={row:x,column:u}});e=b.getSelectionRange();c=b.session.replace(e,y);(new a(b)).addTabstops(n,e.start,c,b.inVirtualSelectionMode&&b.selection.index)};this.insertSnippet=function(a,b){var e=this;if(a.inVirtualSelectionMode)return e.insertSnippetForSelection(a,
b);a.forEachSelection(function(){e.insertSnippetForSelection(a,b)},null,{keepOrder:!0});a.tabstopManager&&a.tabstopManager.tabNext()};this.$getScope=function(a){var b=a.session.$mode.$id||"",b=b.split("/").pop();if("html"===b||"php"===b){"php"===b&&!a.session.$mode.inlinePhp&&(b="html");var e=a.getCursorPosition(),a=a.session.getState(e.row);"object"===typeof a&&(a=a[0]);a.substring&&("js-"==a.substring(0,3)?b="javascript":"css-"==a.substring(0,4)?b="css":"php-"==a.substring(0,4)&&(b="php"))}return b};
this.getActiveScopes=function(a){var a=this.$getScope(a),b=[a],e=this.snippetMap;e[a]&&e[a].includeScopes&&b.push.apply(b,e[a].includeScopes);b.push("_");return b};this.expandWithTab=function(a,b){var e=this,c=a.forEachSelection(function(){return e.expandSnippetForSelection(a,b)},null,{keepOrder:!0});c&&a.tabstopManager&&a.tabstopManager.tabNext();return c};this.expandSnippetForSelection=function(a,b){var e=a.getCursorPosition(),c=a.session.getLine(e.row),f=c.substring(0,e.column),i=c.substr(e.column),
h=this.snippetMap,d;this.getActiveScopes(a).some(function(a){(a=h[a])&&(d=this.findMatchingSnippet(a,f,i));return!!d},this);if(!d)return!1;if(b&&b.dryRun)return!0;a.session.doc.removeInLine(e.row,e.column-d.replaceBefore.length,e.column+d.replaceAfter.length);this.variables.M__=d.matchBefore;this.variables.T__=d.matchAfter;this.insertSnippetForSelection(a,d.content);this.variables.M__=this.variables.T__=null;return!0};this.findMatchingSnippet=function(a,b,e){for(var c=a.length;c--;){var f=a[c];if(!f.startRe||
f.startRe.test(b))if(!f.endRe||f.endRe.test(e))if(f.startRe||f.endRe)return f.matchBefore=f.startRe?f.startRe.exec(b):[""],f.matchAfter=f.endRe?f.endRe.exec(e):[""],f.replaceBefore=f.triggerRe?f.triggerRe.exec(b)[0]:"",f.replaceAfter=f.endTriggerRe?f.endTriggerRe.exec(e)[0]:"",f}};this.snippetMap={};this.snippetNameMap={};this.register=function(a,b){function e(a){a&&!/^\^?\(.*\)\$?$|^\\b$/.test(a)&&(a="(?:"+a+")");return a||""}function f(a,b,j){a=e(a);b=e(b);j?(a=b+a)&&"$"!=a[a.length-1]&&(a+="$"):
(a+=b)&&"^"!=a[0]&&(a="^"+a);return RegExp(a)}function c(a){a.scope||(a.scope=b||"_");b=a.scope;i[b]||(i[b]=[],h[b]={});var e=h[b];if(a.name){var j=e[a.name];j&&d.unregister(j);e[a.name]=a}i[b].push(a);a.tabTrigger&&!a.trigger&&(!a.guard&&/^\w/.test(a.tabTrigger)&&(a.guard="\\b"),a.trigger=m.escapeRegExp(a.tabTrigger));a.startRe=f(a.trigger,a.guard,!0);a.triggerRe=RegExp(a.trigger,"",!0);a.endRe=f(a.endTrigger,a.endGuard,!0);a.endTriggerRe=RegExp(a.endTrigger,"",!0)}var i=this.snippetMap,h=this.snippetNameMap,
d=this;a||(a=[]);a&&a.content?c(a):Array.isArray(a)&&a.forEach(c);this._signal("registerSnippets",{scope:b})};this.unregister=function(a,b){function e(a){var j=c[a.scope||b];j&&j[a.name]&&(delete j[a.name],a=(j=f[a.scope||b])&&j.indexOf(a),0<=a&&j.splice(a,1))}var f=this.snippetMap,c=this.snippetNameMap;a.content?e(a):Array.isArray(a)&&a.forEach(e)};this.parseSnippetFile=function(a){for(var a=a.replace(/\r/g,""),b=[],e={},f=/^#.*|^({[\s\S]*})\s*$|^(\S+) (.*)$|^((?:\n*\t.*)+)/gm,c;c=f.exec(a);){if(c[1])try{e=
JSON.parse(c[1]),b.push(e)}catch(i){}if(c[4])e.content=c[4].replace(/^\t/gm,""),b.push(e),e={};else{var h=c[2];c=c[3];"regex"==h?(h=/\/((?:[^\/\\]|\\.)*)|$/g,e.guard=h.exec(c)[1],e.trigger=h.exec(c)[1],e.endTrigger=h.exec(c)[1],e.endGuard=h.exec(c)[1]):"snippet"==h?(e.tabTrigger=c.match(/^\S*/)[0],e.name||(e.name=c)):e[h]=c}}return b};this.getSnippetByName=function(a,b){var e=this.snippetNameMap,c;this.getActiveScopes(b).some(function(b){(b=e[b])&&(c=b[a]);return!!c},this);return c}}).call(i.prototype);
var a=function(a){if(a.tabstopManager)return a.tabstopManager;a.tabstopManager=this;this.$onChange=this.onChange.bind(this);this.$onChangeSelection=m.delayedCall(this.onChangeSelection.bind(this)).schedule;this.$onChangeSession=this.onChangeSession.bind(this);this.$onAfterExec=this.onAfterExec.bind(this);this.attach(a)};(function(){this.attach=function(a){this.index=0;this.ranges=[];this.tabstops=[];this.selectedTabstop=this.$openTabstops=null;this.editor=a;this.editor.on("change",this.$onChange);
this.editor.on("changeSelection",this.$onChangeSelection);this.editor.on("changeSession",this.$onChangeSession);this.editor.commands.on("afterExec",this.$onAfterExec);this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)};this.detach=function(){this.tabstops.forEach(this.removeTabstopMarkers,this);this.selectedTabstop=this.tabstops=this.ranges=null;this.editor.removeListener("change",this.$onChange);this.editor.removeListener("changeSelection",this.$onChangeSelection);this.editor.removeListener("changeSession",
this.$onChangeSession);this.editor.commands.removeListener("afterExec",this.$onAfterExec);this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor=this.editor.tabstopManager=null};this.onChange=function(a){var b=a.data.range,a="r"==a.data.action[0],c=b.start,f=b.end,b=c.row,i=f.row-b,h=f.column-c.column;a&&(i=-i,h=-h);if(!this.$inChange&&a){var d=this.selectedTabstop;if(d&&!d.some(function(a){return 0>=e(a.start,c)&&0<=e(a.end,f)}))return this.detach()}for(var d=this.ranges,
n=0;n<d.length;n++){var g=d[n];g.end.row<c.row||(a&&0>e(c,g.start)&&0<e(f,g.end)?(this.removeRange(g),n--):(g.start.row==b&&g.start.column>c.column&&(g.start.column+=h),g.end.row==b&&g.end.column>=c.column&&(g.end.column+=h),g.start.row>=b&&(g.start.row+=i),g.end.row>=b&&(g.end.row+=i),0<e(g.start,g.end)&&this.removeRange(g)))}d.length||this.detach()};this.updateLinkedFields=function(){var a=this.selectedTabstop;if(a&&a.hasLinkedRanges){this.$inChange=!0;for(var b=this.editor.session,e=b.getTextRange(a.firstNonLinked),
c=a.length;c--;){var f=a[c];if(f.linked){var i=d.snippetManager.tmStrFormat(e,f.original);b.replace(f,i)}}this.$inChange=!1}};this.onAfterExec=function(a){a.command&&!a.command.readOnly&&this.updateLinkedFields()};this.onChangeSelection=function(){if(this.editor){for(var a=this.editor.selection.lead,b=this.editor.selection.anchor,e=this.editor.selection.isEmpty(),c=this.ranges.length;c--;)if(!this.ranges[c].linked){var f=this.ranges[c].contains(a.row,a.column),i=e||this.ranges[c].contains(b.row,b.column);
if(f&&i)return}this.detach()}};this.onChangeSession=function(){this.detach()};this.tabNext=function(a){var b=this.tabstops.length,a=this.index+(a||1),a=Math.min(Math.max(a,1),b);a==b&&(a=0);this.selectTabstop(a);0===a&&this.detach()};this.selectTabstop=function(a){this.$openTabstops=null;var b=this.tabstops[this.index];b&&this.addTabstopMarkers(b);this.index=a;if((b=this.tabstops[this.index])&&b.length){this.selectedTabstop=b;if(this.editor.inVirtualSelectionMode)this.editor.selection.setRange(b.firstNonLinked);
else{a=this.editor.multiSelect;a.toSingleRange(b.firstNonLinked.clone());for(var e=b.length;e--;)(!b.hasLinkedRanges||!b[e].linked)&&a.addRange(b[e].clone(),!0);a.ranges[0]&&a.addRange(a.ranges[0].clone())}this.editor.keyBinding.addKeyboardHandler(this.keyboardHandler)}};this.addTabstops=function(a,e,c){this.$openTabstops||(this.$openTabstops=[]);a[0]||(c=k.fromPoints(c,c),b(c.start,e),b(c.end,e),a[0]=[c],a[0].index=0);var f=[this.index+1,0],i=this.ranges;a.forEach(function(a,b){for(var c=this.$openTabstops[b]||
a,h=a.length;h--;){var j=a[h],d=k.fromPoints(j.start,j.end||j.start),g=d.start,n=e;0==g.row&&(g.column+=n.column);g.row+=n.row;g=d.end;n=e;0==g.row&&(g.column+=n.column);g.row+=n.row;d.original=j;d.tabstop=c;i.push(d);c!=a?c.unshift(d):c[h]=d;j.fmtString?(d.linked=!0,c.hasLinkedRanges=!0):c.firstNonLinked||(c.firstNonLinked=d)}c.firstNonLinked||(c.hasLinkedRanges=!1);c===a&&(f.push(c),this.$openTabstops[b]=c);this.addTabstopMarkers(c)},this);2<f.length&&(this.tabstops.length&&f.push(f.splice(2,1)[0]),
this.tabstops.splice.apply(this.tabstops,f))};this.addTabstopMarkers=function(a){var b=this.editor.session;a.forEach(function(a){a.markerId||(a.markerId=b.addMarker(a,"ace_snippet-marker","text"))})};this.removeTabstopMarkers=function(a){var b=this.editor.session;a.forEach(function(a){b.removeMarker(a.markerId);a.markerId=null})};this.removeRange=function(a){var b=a.tabstop.indexOf(a);a.tabstop.splice(b,1);b=this.ranges.indexOf(a);this.ranges.splice(b,1);this.editor.session.removeMarker(a.markerId);
a.tabstop.length||(b=this.tabstops.indexOf(a.tabstop),-1!=b&&this.tabstops.splice(b,1),this.tabstops.length||this.detach())};this.keyboardHandler=new h;this.keyboardHandler.bindKeys({Tab:function(a){(!d.snippetManager||!d.snippetManager.expandWithTab(a))&&a.tabstopManager.tabNext(1)},"Shift-Tab":function(a){a.tabstopManager.tabNext(-1)},Esc:function(a){a.tabstopManager.detach()},Return:function(){return!1}})}).call(a.prototype);var b=function(a,b){a.row==b.row&&(a.column-=b.column);a.row-=b.row};
g("./lib/dom").importCssString(".ace_snippet-marker {    -moz-box-sizing: border-box;    box-sizing: border-box;    background: rgba(194, 193, 208, 0.09);    border: 1px dotted rgba(211, 208, 235, 0.62);    position: absolute;}");d.snippetManager=new i;var n=g("./editor").Editor;(function(){this.insertSnippet=function(a,b){return d.snippetManager.insertSnippet(this,a,b)};this.expandSnippet=function(a){return d.snippetManager.expandWithTab(this,a)}}).call(n.prototype)});
define("lib/ace/autocomplete/popup","require exports module ../edit_session ../virtual_renderer ../editor ../range ../lib/event ../lib/lang ../lib/dom".split(" "),function(g,d){g("../edit_session");var l=g("../virtual_renderer").VirtualRenderer,c=g("../editor").Editor,m=g("../range").Range,k=g("../lib/event"),h=g("../lib/lang"),f=g("../lib/dom"),e=function(e){e=new l(e);e.$maxLines=4;e=new c(e);e.setHighlightActiveLine(!1);e.setShowPrintMargin(!1);e.renderer.setShowGutter(!1);e.renderer.setHighlightGutterLine(!1);
e.$mouseHandler.$focusWaitTimout=0;e.$highlightTagPending=!0;return e};f.importCssString(".ace_editor.ace_autocomplete .ace_marker-layer .ace_active-line {    background-color: #CAD6FA;    z-index: 1;}.ace_editor.ace_autocomplete .ace_line-hover {    border: 1px solid #abbffe;    margin-top: -1px;    background: rgba(233,233,253,0.4);}.ace_editor.ace_autocomplete .ace_line-hover {    position: absolute;    z-index: 2;}.ace_editor.ace_autocomplete .ace_scroller {   background: none;   border: none;   box-shadow: none;}.ace_rightAlignedText {    color: gray;    display: inline-block;    position: absolute;    right: 4px;    text-align: right;    z-index: -1;}.ace_editor.ace_autocomplete .ace_completion-highlight{    color: #000;    text-shadow: 0 0 0.01em;}.ace_editor.ace_autocomplete {    width: 280px;    z-index: 200000;    background: #fbfbfb;    color: #444;    border: 1px lightgray solid;    position: fixed;    box-shadow: 2px 3px 5px rgba(0,0,0,.2);    line-height: 1.4;}");
d.AcePopup=function(c){var a=f.createElement("div"),b=new e(a);c&&c.appendChild(a);a.style.display="none";b.renderer.content.style.cursor="default";b.renderer.setStyle("ace_autocomplete");b.setOption("displayIndentGuides",!1);b.setOption("dragDelay",150);c=function(){};b.focus=c;b.$isFocused=!0;b.renderer.$cursorLayer.restartTimer=c;b.renderer.$cursorLayer.element.style.opacity=0;b.renderer.$maxLines=8;b.renderer.$keepTextAreaAtCursor=!1;b.setHighlightActiveLine(!1);b.session.highlight("");b.session.$searchHighlight.clazz=
"ace_highlight-marker";b.on("mousedown",function(a){var e=a.getDocumentPosition();b.selection.moveToPosition(e);g.start.row=g.end.row=e.row;a.stop()});var d,j=new m(-1,0,-1,Infinity),g=new m(-1,0,-1,Infinity);g.id=b.session.addMarker(g,"ace_active-line","fullLine");b.setSelectOnHover=function(a){a?j.id&&(b.session.removeMarker(j.id),j.id=null):j.id=b.session.addMarker(j,"ace_line-hover","fullLine")};b.setSelectOnHover(!1);b.on("mousemove",function(a){d?d.x==a.x&&d.y==a.y||(d=a,d.scrollTop=b.renderer.scrollTop,
a=d.getDocumentPosition().row,j.start.row!=a&&(j.id||b.setRow(a),r(a))):d=a});b.renderer.on("beforeRender",function(){if(d&&-1!=j.start.row){d.$pos=null;var a=d.getDocumentPosition().row;j.id||b.setRow(a);r(a,!0)}});b.renderer.on("afterRender",function(){var a=b.getRow(),e=b.renderer.$textLayer,a=e.element.childNodes[a-e.config.firstRow];a!=e.selectedNode&&(e.selectedNode&&f.removeCssClass(e.selectedNode,"ace_selected"),(e.selectedNode=a)&&f.addCssClass(a,"ace_selected"))});var a=function(){r(-1)},
r=function(a,e){a!==j.start.row&&(j.start.row=j.end.row=a,e||b.session._emit("changeBackMarker"),b._emit("changeHoverMarker"))};b.getHoveredRow=function(){return j.start.row};k.addListener(b.container,"mouseout",a);b.on("hide",a);b.on("changeSelection",a);b.session.doc.getLength=function(){return b.data.length};b.session.doc.getLine=function(a){a=b.data[a];return"string"==typeof a?a:a&&a.value||""};a=b.session.bgTokenizer;a.$tokenizeRow=function(a){var a=b.data[a],e=[];if(!a)return e;"string"==typeof a&&
(a={value:a});a.caption||(a.caption=a.value||a.name);for(var c=-1,f,d,h=0;h<a.caption.length;h++)d=a.caption[h],f=a.matchMask&1<<h?1:0,c!==f?(e.push({type:a.className||""+(f?"completion-highlight":""),value:d}),c=f):e[e.length-1].value+=d;a.meta&&a.meta.length+a.caption.length<b.renderer.$size.scrollerWidth/b.renderer.layerConfig.characterWidth-2&&e.push({type:"rightAlignedText",value:a.meta});return e};a.$updateOnChange=c;a.start=c;b.session.$computeWidth=function(){return this.screenWidth=0};b.$blockScrolling=
Infinity;b.isOpen=!1;b.isTopdown=!1;b.data=[];b.setData=function(a){b.data=a||[];b.setValue(h.stringRepeat("\n",a.length),-1);b.setRow(0)};b.getData=function(a){return b.data[a]};b.getRow=function(){return g.start.row};b.setRow=function(a){a=Math.max(-1,Math.min(this.data.length,a));g.start.row!=a&&(b.selection.clearSelection(),g.start.row=g.end.row=a||0,b.session._emit("changeBackMarker"),b.moveCursorTo(a||0,0),b.isOpen&&b._signal("select"))};b.on("changeSelection",function(){b.isOpen&&b.setRow(b.selection.lead.row);
b.renderer.scrollCursorIntoView()});b.hide=function(){this.container.style.display="none";this._signal("hide");b.isOpen=!1};b.show=function(a,e,c){var f=this.container,h=window.innerHeight,i=window.innerWidth,j=a.top+this.$borderSize;j+1.4*this.renderer.$maxLines*e>h-e&&!c?(f.style.top="",f.style.bottom=h-j+"px",b.isTopdown=!1):(f.style.top=j+e+"px",f.style.bottom="",b.isTopdown=!0);f.style.display="";this.renderer.$textLayer.checkForSizeChanges();a=a.left;a+f.offsetWidth>i&&(a=i-f.offsetWidth);f.style.left=
a+"px";this._signal("show");d=null;b.isOpen=!0};b.getTextLeftOffset=function(){return this.$borderSize+this.renderer.$padding+this.$imageSize};b.$imageSize=0;b.$borderSize=1;return b}});
define("lib/ace/autocomplete/util",["require","exports","module"],function(g,d){d.parForEach=function(c,d,g){var h=0,f=c.length;0===f&&g();for(var e=0;e<f;e++)d(c[e],function(e,a){h++;h===f&&g(e,a)})};var l=/[a-zA-Z_0-9\$\-\u00A2-\uFFFF]/;d.retrievePrecedingIdentifier=function(c,d,g){for(var g=g||l,h=[],d=d-1;0<=d;d--)if(g.test(c[d]))h.push(c[d]);else break;return h.reverse().join("")};d.retrieveFollowingIdentifier=function(c,d,g){for(var g=g||l,h=[];d<c.length;d++)if(g.test(c[d]))h.push(c[d]);else break;
return h}});
define("lib/ace/autocomplete","require exports module ./keyboard/hash_handler ./autocomplete/popup ./autocomplete/util ./lib/event ./lib/lang ./lib/dom ./snippets".split(" "),function(g,d){var l=g("./keyboard/hash_handler").HashHandler,c=g("./autocomplete/popup").AcePopup,m=g("./autocomplete/util");g("./lib/event");var k=g("./lib/lang"),h=g("./lib/dom"),f=g("./snippets").snippetManager,e=function(){this.autoSelect=this.autoInsert=!0;this.exactMatch=!1;this.keyboardHandler=new l;this.keyboardHandler.bindKeys(this.commands);this.blurListener=
this.blurListener.bind(this);this.changeListener=this.changeListener.bind(this);this.mousedownListener=this.mousedownListener.bind(this);this.mousewheelListener=this.mousewheelListener.bind(this);this.changeTimer=k.delayedCall(function(){this.updateCompletions(!0)}.bind(this));this.tooltipTimer=k.delayedCall(this.updateDocTooltip.bind(this),50)};(function(){this.gatherCompletionsId=0;this.$init=function(){this.popup=new c(document.body||document.documentElement);this.popup.on("click",function(a){this.insertMatch();
a.stop()}.bind(this));this.popup.focus=this.editor.focus.bind(this.editor);this.popup.on("show",this.tooltipTimer.bind(null,null));this.popup.on("select",this.tooltipTimer.bind(null,null));this.popup.on("changeHoverMarker",this.tooltipTimer.bind(null,null));return this.popup};this.getPopup=function(){return this.popup||this.$init()};this.openPopup=function(a,b,e){this.popup||this.$init();this.popup.setData(this.completions.filtered);var c=a.renderer;this.popup.setRow(this.autoSelect?0:-1);if(e)e&&
!b&&this.detach();else{this.popup.setTheme(a.getTheme());this.popup.setFontSize(a.getFontSize());b=c.layerConfig.lineHeight;e=c.$cursorLayer.getPixelPosition(this.base,!0);e.left-=this.popup.getTextLeftOffset();var f=a.container.getBoundingClientRect();e.top+=f.top-c.layerConfig.offset;e.left+=f.left-a.renderer.scrollLeft;e.left+=c.$gutterLayer.gutterWidth;this.popup.show(e,b)}};this.detach=function(){this.editor.keyBinding.removeKeyboardHandler(this.keyboardHandler);this.editor.off("changeSelection",
this.changeListener);this.editor.off("blur",this.blurListener);this.editor.off("mousedown",this.mousedownListener);this.editor.off("mousewheel",this.mousewheelListener);this.changeTimer.cancel();this.hideDocTooltip();this.popup&&this.popup.isOpen&&(this.gatherCompletionsId+=1,this.popup.hide());this.base&&this.base.detach();this.activated=!1;this.completions=this.base=null};this.changeListener=function(){var a=this.editor.selection.lead;(a.row!=this.base.row||a.column<this.base.column)&&this.detach();
this.activated?this.changeTimer.schedule():this.detach()};this.blurListener=function(a){var b=document.activeElement,e=this.editor.textInput.getElement();b!=e&&(b.parentNode!=this.popup.container&&b!=this.tooltipNode&&a.relatedTarget!=this.tooltipNode&&a.relatedTarget!=e)&&this.detach()};this.mousedownListener=function(){this.detach()};this.mousewheelListener=function(){this.detach()};this.goTo=function(a){var b=this.popup.getRow(),e=this.popup.session.getLength()-1;switch(a){case "up":b=0>=b?e:b-
1;break;case "down":b=b>=e?-1:b+1;break;case "start":b=0;break;case "end":b=e}this.popup.setRow(b)};this.insertMatch=function(a){a||(a=this.popup.getData(this.popup.getRow()));if(!a)return!1;if(a.completer&&a.completer.insertMatch)a.completer.insertMatch(this.editor,a);else{if(this.completions.filterText)for(var b=this.editor.selection.getAllRanges(),e=0,c;c=b[e];e++)c.start.column-=this.completions.filterText.length,this.editor.session.remove(c);a.snippet?f.insertSnippet(this.editor,a.snippet):this.editor.execCommand("insertstring",
a.value||a)}this.detach()};this.commands={Up:function(a){a.completer.goTo("up")},Down:function(a){a.completer.goTo("down")},"Ctrl-Up|Ctrl-Home":function(a){a.completer.goTo("start")},"Ctrl-Down|Ctrl-End":function(a){a.completer.goTo("end")},Esc:function(a){a.completer.detach()},Space:function(a){a.completer.detach();a.insert(" ")},Return:function(a){return a.completer.insertMatch()},"Shift-Return":function(a){a.completer.insertMatch(!0)},Tab:function(a){var b=a.completer.insertMatch();if(!b&&!a.tabstopManager)a.completer.goTo("down");
else return b},PageUp:function(a){a.completer.popup.gotoPageUp()},PageDown:function(a){a.completer.popup.gotoPageDown()}};this.gatherCompletions=function(a,b){var e=a.getSession(),c=a.getCursorPosition(),f=e.getLine(c.row),d=m.retrievePrecedingIdentifier(f,c.column);this.base=e.doc.createAnchor(c.row,c.column-d.length);this.base.$insertRight=!0;var h=[],i=a.completers.length;a.completers.forEach(function(f){f.getCompletions(a,e,c,d,function(c,f){c||(h=h.concat(f));var d=a.getCursorPosition(),j=e.getLine(d.row);
b(null,{prefix:m.retrievePrecedingIdentifier(j,d.column,f[0]&&f[0].identifierRegex),matches:h,finished:0===--i})})});return!0};this.showPopup=function(a){this.editor&&this.detach();this.activated=!0;this.editor=a;a.completer!=this&&(a.completer&&a.completer.detach(),a.completer=this);a.keyBinding.addKeyboardHandler(this.keyboardHandler);a.on("changeSelection",this.changeListener);a.on("blur",this.blurListener);a.on("mousedown",this.mousedownListener);a.on("mousewheel",this.mousewheelListener);this.updateCompletions()};
this.updateCompletions=function(a){if(a&&this.base&&this.completions){var b=this.editor.getCursorPosition(),b=this.editor.session.getTextRange({start:this.base,end:b});if(b!=this.completions.filterText){this.completions.setFilter(b);if(!this.completions.filtered.length||1==this.completions.filtered.length&&this.completions.filtered[0].value==b&&!this.completions.filtered[0].snippet)return this.detach();this.openPopup(this.editor,b,a)}}else{var e=this.gatherCompletionsId;this.gatherCompletions(this.editor,
function(b,c){var f=function(){if(c.finished)return this.detach()}.bind(this),d=c.prefix,h=c&&c.matches;if(!h||!h.length)return f();if(!(0!==d.indexOf(c.prefix)||e!=this.gatherCompletionsId)){this.completions=new i(h);this.exactMatch&&(this.completions.exactMatch=!0);this.completions.setFilter(d);h=this.completions.filtered;if(!h.length||1==h.length&&h[0].value==d&&!h[0].snippet)return f();if(this.autoInsert&&1==h.length&&c.finished)return this.insertMatch(h[0]);this.openPopup(this.editor,d,a)}}.bind(this))}};
this.cancelContextMenu=function(){this.editor.$mouseHandler.cancelContextMenu()};this.updateDocTooltip=function(){var a=this.popup,b=a.data,e=b&&(b[a.getHoveredRow()]||b[a.getRow()]),c=null;if(!e||!this.editor||!this.popup.isOpen)return this.hideDocTooltip();this.editor.completers.some(function(a){a.getDocTooltip&&(c=a.getDocTooltip(e));return c});c||(c=e);"string"==typeof c&&(c={docText:c});if(!c||!c.docHTML&&!c.docText)return this.hideDocTooltip();this.showDocTooltip(c)};this.showDocTooltip=function(a){this.tooltipNode||
(this.tooltipNode=h.createElement("div"),this.tooltipNode.className="ace_tooltip ace_doc-tooltip",this.tooltipNode.style.margin=0,this.tooltipNode.style.pointerEvents="auto",this.tooltipNode.tabIndex=-1,this.tooltipNode.onblur=this.blurListener.bind(this));var b=this.tooltipNode;a.docHTML?b.innerHTML=a.docHTML:a.docText&&(b.textContent=a.docText);b.parentNode||document.body.appendChild(b);var a=this.popup,e=a.container.getBoundingClientRect();b.style.top=a.container.style.top;b.style.bottom=a.container.style.bottom;
320>window.innerWidth-e.right?(b.style.right=window.innerWidth-e.left+"px",b.style.left=""):(b.style.left=e.right+1+"px",b.style.right="");b.style.display="block"};this.hideDocTooltip=function(){this.tooltipTimer.cancel();if(this.tooltipNode){var a=this.tooltipNode;!this.editor.isFocused()&&document.activeElement==a&&this.editor.focus();this.tooltipNode=null;a.parentNode&&a.parentNode.removeChild(a)}}}).call(e.prototype);e.startCommand={name:"startAutocomplete",exec:function(a){a.completer||(a.completer=
new e);a.completer.autoInsert=a.completer.autoSelect=!0;a.completer.showPopup(a);a.completer.cancelContextMenu()},bindKey:"Ctrl-Space|Ctrl-Shift-Space|Alt-Space"};var i=function(a,b){this.filtered=this.all=a;this.filterText=b||"";this.exactMatch=!1};(function(){this.setFilter=function(a){var b=a.length>this.filterText&&0===a.lastIndexOf(this.filterText,0)?this.filtered:this.all;this.filterText=a;var b=this.filterCompletions(b,this.filterText),b=b.sort(function(a,b){return b.exactMatch-a.exactMatch||
b.score-a.score}),e=null;this.filtered=b=b.filter(function(a){a=a.snippet||a.caption||a.value;if(a===e)return!1;e=a;return!0})};this.filterCompletions=function(a,b){var e=[],c=b.toUpperCase(),f=b.toLowerCase(),d=0,h;a:for(;h=a[d];d++){var i=h.value||h.caption||h.snippet;if(i){var g=-1,l=0,k=0,m,q;if(this.exactMatch){if(b!==i.substr(0,b.length))continue a}else for(var v=0;v<b.length;v++){m=i.indexOf(f[v],g+1);q=i.indexOf(c[v],g+1);m=0<=m?0>q||m<q?m:q:q;if(0>m)continue a;q=m-g-1;0<q&&(-1===g&&(k+=10),
k+=q);l|=1<<m;g=m}h.matchMask=l;h.exactMatch=k?0:1;h.score=(h.score||0)-k;e.push(h)}}return e}}).call(i.prototype);d.Autocomplete=e;d.FilteredList=i});
define("lib/ace/autocomplete/text_completer",["require","exports","module","../range"],function(g,d){var l=g("../range").Range,c=/[^a-zA-Z_0-9\$\-\u00C0-\u1FFF\u2C00-\uD7FF\w]+/;d.getCompletions=function(d,g,h,f,e){var i=g.getTextRange(l.fromPoints({row:0,column:0},h)).split(c).length-1,a=g.getValue().split(c),b=Object.create(null),n=a[i];a.forEach(function(e,c){if(e&&e!==n){var f=Math.abs(i-c),f=a.length-f;b[e]=b[e]?Math.max(f,b[e]):f}});d=Object.keys(b);e(null,d.map(function(a){return{caption:a,
value:a,score:b[a],meta:"local"}}))}});
define("lib/ace/ext/language_tools","require exports module ../snippets ../autocomplete ../config ../lib/lang ../autocomplete/util ../autocomplete/text_completer ../editor ../config".split(" "),function(g,d){function l(a){var b=a.getCursorPosition(),e=a.session.getLine(b.row),c=f.retrievePrecedingIdentifier(e,b.column);a.completers.forEach(function(a){a.identifierRegexps&&a.identifierRegexps.forEach(function(a){!c&&a&&(c=f.retrievePrecedingIdentifier(e,b.column,a))})});return c}var c=g("../snippets").snippetManager,
m=g("../autocomplete").Autocomplete,k=g("../config"),h=g("../lib/lang"),f=g("../autocomplete/util"),e=g("../autocomplete/text_completer"),i={getCompletions:function(a,b,e,c,f){if(b.$mode.completer)return b.$mode.completer.getCompletions(a,b,e,c,f);a=a.session.getState(e.row);b=b.$mode.getCompletions(a,b,e,c);f(null,b)}},a={getCompletions:function(a,b,e,f,d){var h=c.snippetMap,i=[];c.getActiveScopes(a).forEach(function(a){for(var a=h[a]||[],b=a.length;b--;){var e=a[b],c=e.name||e.tabTrigger;c&&i.push({caption:c,
snippet:e.content,meta:e.tabTrigger&&!e.name?e.tabTrigger+"\u21e5 ":"snippet",type:"snippet"})}},this);d(null,i)},getDocTooltip:function(a){"snippet"==a.type&&!a.docHTML&&(a.docHTML=["<b>",h.escapeHTML(a.caption),"</b><hr></hr>",h.escapeHTML(a.snippet)].join(""))}},b=[a,e,i];d.setCompleters=function(a){b=a||[]};d.addCompleter=function(a){b.push(a)};d.textCompleter=e;d.keyWordCompleter=i;d.snippetCompleter=a;var n={name:"expandSnippet",exec:function(a){return c.expandWithTab(a)},bindKey:"Tab"},j=function(a,
b){o(b.session.$mode)},o=function(a){var b=a.$id;c.files||(c.files={});r(b);a.modes&&a.modes.forEach(o)},r=function(a){if(a&&!c.files[a]){var b=a.replace("mode","snippets");c.files[a]={};k.loadModule(b,function(b){b&&(c.files[a]=b,!b.snippets&&b.snippetText&&(b.snippets=c.parseSnippetFile(b.snippetText)),c.register(b.snippets||[],b.scope),b.includeScopes&&(c.snippetMap[b.scope].includeScopes=b.includeScopes,b.includeScopes.forEach(function(a){r("ace/mode/"+a)})))})}},z=function(a){var b=a.editor,
e=b.completer&&b.completer.activated;"backspace"===a.command.name?e&&!l(b)&&b.completer.detach():"insertstring"===a.command.name&&(l(b)&&!e)&&(b.completer||(b.completer=new m),b.completer.autoSelect=!1,b.completer.autoInsert=!1,b.completer.showPopup(b))},e=g("../editor").Editor;g("../config").defineOptions(e.prototype,"editor",{enableBasicAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:b),this.commands.addCommand(m.startCommand)):this.commands.removeCommand(m.startCommand)},
value:!1},enableLiveAutocompletion:{set:function(a){a?(this.completers||(this.completers=Array.isArray(a)?a:b),this.commands.on("afterExec",z)):this.commands.removeListener("afterExec",z)},value:!1},enableSnippets:{set:function(a){a?(this.commands.addCommand(n),this.on("changeMode",j),j(null,this)):(this.commands.removeCommand(n),this.off("changeMode",j))},value:!1}})});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameinfo",[],function(){var g=function(d){this._name=d};(function(){this.getFullName=function(){return this._name}}).call(g.prototype);return g});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameanchor",["lib/ace/anchor","lib/ace/lib/oop"],function(g,d){var l=g.Anchor,c=function(c,d,h,f){this._info=f;l.call(this,c,d,h)};d.inherits(c,g.Anchor);(function(){this.getSmartNameInfo=function(){return this._info};this.applyDeltas=function(c){if(("removeText"===c.action||"removeLines"===c.action)&&c.range.start.column<=this.column&&c.range.end.column>this.column)return!1;l.prototype.onChange.call(this,{data:c});return!0};
this.onChange=function(){}}).call(c.prototype);return c});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameanchorcontrol",["./smartnameanchor","./smartnameinfo","lib/ace/range"],function(g,d,l){function c(c){void 0===c.smartnameanchors&&(c.smartnameanchors=[]);return c.smartnameanchors}var m=l.Range,k={},h=new d("?");h.unresolved=!0;k.getSmartNameInfoAt=function(f,e,d){for(var f=c(f),a=0;a<f.length;a++){var b=f[a],g=b.getPosition();if(g.row===e&&g.column===d)return b.getSmartNameInfo()}return h};k.setSmartNameInfoAt=function(f,
e,d,a){var b=new g(f,e,d,a);c(f).push(b);e={action:"addSmartName",range:new m(e,d,e,d+1),smartname:{row:e,column:d,info:a}};f._signal("change",{data:e})};k.applyDelta=function(f,e){for(var d=c(f),a=[],b=0;b<d.length;b++){var h=d[b];h.applyDeltas(e)||(a.push(h),d.splice(b,1),b--)}for(b=0;b<a.length;b++){var h=a[b],d=h.row,g=h.column,h=h._info,h={action:"removeSmartName",range:new m(d,g,d,g+1),smartname:{row:d,column:g,info:h}};f._signal("change",{data:h})}};k.undoRedo=function(c,e,d){var a=e.action;
("addSmartName"===a||"removeSmartName"===a)&&d!==("addSmartName"===a)&&k.setSmartNameInfoAt(c,e.smartname.row,e.smartname.column,e.smartname.info)};return k});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/smartnameextensionutils",["component/smartnames/encoding/smartname","component/smartnames/encoding/smartnamestringpart","component/smartnames/encoding/smartnameencoding","./smartnameinfo","./smartnameanchorcontrol"],function(g,d,l,c,m){var k={SMARTNAMECHAR:"\u0010",getSmartNameDisplayString:function(c,f){return void 0!==c.displayFunction?c.displayFunction(f):"["+f.getFullName()+"]"},parseText:function(d,f,e){if(d.isSmartNamesEnabled()){for(var i=
{text:"",smartnames:[]},f=f.replaceAll("\n","").replaceAll("\r",""),d=(!0===e?l.UNIVERSALCOPYPASTEENCODING:d.getSmartNameEncoding()).decodeSmartNameString(f),f=0;f<d.length;f++)e=d[f],e.isTextPart()?i.text+=e.getAsText():(i.smartnames.push({index:i.text.length,info:new c(e.getAsSmartName().getFullName())}),i.text+=k.SMARTNAMECHAR);return i}return{text:f,smartnames:[]}},tryParseText:function(c,f,e){if(c.isSmartNamesEnabled())try{return k.parseText(c,f,e)}catch(d){return{text:f.replaceAll("\n","").replaceAll("\r",
"").replaceAll(""+k.SMARTNAMECHAR,"?"),smartnames:[]}}else return{text:f,smartnames:[]}},recompileText:function(c,f,e,i,a){if(c.isSmartNamesEnabled()){for(var b=[],n=0;n<i.length;n++)if(i.charAt(n)===k.SMARTNAMECHAR){var j=m.getSmartNameInfoAt(f,0,e+n);b.push(d.makeSmartNamePart(new g(j.getFullName())))}else b.push(d.makePlainTextPart(""+i.charAt(n)));return(!0===a?l.UNIVERSALCOPYPASTEENCODING:c.getSmartNameEncoding()).encodeSmartNameString(b)}return i},addSmartNameAnchors:function(c,f,e){for(var d=
0;d<e.length;d++)m.setSmartNameInfoAt(c,0,e[d].index+f.start.column,e[d].info)},startSmartNameChangeGroup:function(c){void 0==c.smartnamechangeready&&(c.smartnamechangeready=0);c.smartnamechangeready++},stopSmartNameChangeGroup:function(c,f){c.smartnamechangeready--;c._signal("change",{data:{action:"changeAfterSmartNames",range:f}})},isInSmartNameChangeReady:function(c){return void 0==c.smartnamechangeready?!0:0===c.smartnamechangeready}};return k});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-editor",["lib/ace/editor","lib/ace/range","./smartnameinfo","./smartnameextensionutils","utils/extendedstring"],function(g,d,l,c){var m=d.Range;(function(){this.insertSmartName=function(d){c.startSmartNameChangeGroup(this.getSession().getDocument());this.insert(c.SMARTNAMECHAR);var f=this.getCursorPosition().column-1,f=new m(0,f,0,f+1);c.addSmartNameAnchors(this.getSession().getDocument(),f,[{index:0,info:new l(d)}]);
c.stopSmartNameChangeGroup(this.getSession().getDocument(),f)};this.getSmartNameEncodedValue=function(){return c.recompileText(this.getSession(),this.getSession().getDocument(),0,this.getValue())};this.isChangeReady=function(){return c.isInSmartNameChangeReady(this.getSession().getDocument())};this.setSmartNameEncodedValue=function(d){d=c.parseText(this.getSession(),d);c.startSmartNameChangeGroup(this.getSession().getDocument());this.setValue(d.text);var f=new m(0,0,0,d.text.length);c.addSmartNameAnchors(this.getSession().getDocument(),
f,d.smartnames);c.stopSmartNameChangeGroup(this.getSession().getDocument(),f);this.navigateFileEnd()};this.insertBase=this.insert;this.insert=function(c,f){this.getSession().isSmartNamesEnabled()&&(c=c.replaceAll("\r","").replaceAll("\n",""));this.insertBase(c,f)};var d=this.onPaste;this.onPaste=function(h){h=c.tryParseText(this.session,h,!0);c.startSmartNameChangeGroup(this.session.getDocument());d.call(this,h.text);var f=this.getCursorPosition().column-h.text.length,f=new m(0,f,0,f+h.text.length);
c.addSmartNameAnchors(this.session.getDocument(),f,h.smartnames);c.stopSmartNameChangeGroup(this.session.getDocument(),f)};this.getCopyText=function(){var d=this.getSelectionRange().start.column,f=this.getSelectedText(),f=c.recompileText(this.getSession(),this.getSession().getDocument(),d,f,!0);this._signal("copy",f);return f}}).call(g.Editor.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-edit_session",["lib/ace/edit_session","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,d,l,c){(function(){var g=d.Range,k=c.SMARTNAMECHAR;this.isSmartNamesEnabled=function(){return void 0===this._smartNamesEnabled?!1:this._smartNamesEnabled};this.enableSmartNames=function(c){void 0!==c&&(this._smartNamesEnabled=!0,this._smartNameEncoding=c)};this.getSmartNameEncoding=function(){return this._smartNameEncoding};
this.$getStringScreenWidth=function(d,f,e){function i(b){if(9==b)e+=a.getScreenTabSize(e);else{var c;if(c=4352<=b)c=4352>b?!1:4352<=b&&4447>=b||4515<=b&&4519>=b||4602<=b&&4607>=b||9001<=b&&9002>=b||11904<=b&&11929>=b||11931<=b&&12019>=b||12032<=b&&12245>=b||12272<=b&&12283>=b||12288<=b&&12350>=b||12353<=b&&12438>=b||12441<=b&&12543>=b||12549<=b&&12589>=b||12593<=b&&12686>=b||12688<=b&&12730>=b||12736<=b&&12771>=b||12784<=b&&12830>=b||12832<=b&&12871>=b||12880<=b&&13054>=b||13056<=b&&19903>=b||19968<=
b&&42124>=b||42128<=b&&42182>=b||43360<=b&&43388>=b||44032<=b&&55203>=b||55216<=b&&55238>=b||55243<=b&&55291>=b||63744<=b&&64255>=b||65040<=b&&65049>=b||65072<=b&&65106>=b||65108<=b&&65126>=b||65128<=b&&65131>=b||65281<=b&&65376>=b||65504<=b&&65510>=b;e=c?e+2:e+1}}if(0==f)return[0,0];null==f&&(f=Infinity);var e=e||0,a=this,b,g;for(g=0;g<d.length;g++){b=d.charCodeAt(g);if(b==k.charCodeAt(0)&&this.isSmartNamesEnabled()){b=l.getSmartNameInfoAt(this.getDocument(),0,g);b=c.getSmartNameDisplayString(this.getDocument(),
b);for(var j=0;j<b.length;j++){var m=b.charCodeAt(j);i(m)}}else i(b);if(e>f)break}return[e,g]};this.getWordRangeBase=this.getWordRange;this.getWordRange=function(c,f){return this.getLine(c).charAt(f)==k&&this.isSmartNamesEnabled()?new g(c,f,c,f+1):this.getWordRangeBase(c,f)};this.moveText=function(d,f,e){var i=this.getTextRange(d),i=c.recompileText(this,this.getDocument(),d.start.column,i,!0),a=this.getFoldsInRange(d),f=g.fromPoints(f,f);if(!e){this.remove(d);var b=d.start.row-d.end.row,l=b?-d.end.column:
d.start.column-d.end.column;l&&(f.start.row==d.end.row&&f.start.column>d.end.column&&(f.start.column+=l),f.end.row==d.end.row&&f.end.column>d.end.column&&(f.end.column+=l));b&&f.start.row>=d.end.row&&(f.start.row+=b,f.end.row+=b)}e=c.parseText(this,i,!0);c.startSmartNameChangeGroup(this.getDocument());i=e.text;f.end=this.insert(f.start,i);i=new g(0,f.start.column,0,f.start.column+e.text.length);c.addSmartNameAnchors(this.getDocument(),i,e.smartnames);c.stopSmartNameChangeGroup(this.getDocument(),
i);if(a.length){var j=d.start,d=f.start,b=d.row-j.row,l=d.column-j.column;this.addFolds(a.map(function(a){a=a.clone();a.start.row==j.row&&(a.start.column+=l);a.end.row==j.row&&(a.end.column+=l);a.start.row+=b;a.end.row+=b;return a}))}return f}}).call(g.EditSession.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-document",["lib/ace/document","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,d,l,c){var m=d.Range,k=l.undoRedo,h=l.applyDelta;(function(){this._insertLinesBase=this._insertLines;this._insertLines=function(d,e){c.startSmartNameChangeGroup(this);var i=this._insertLinesBase(d,e),a=new m(d,0,d+e.length,0);h(this,{action:"insertLines",range:a});c.stopSmartNameChangeGroup(this,a);return i};
this.insertInLineBase=this.insertInLine;this.insertInLine=function(d,e){c.startSmartNameChangeGroup(this);var i=this.insertInLineBase(d,e),a=m.fromPoints(d,i);h(this,{action:"insertText",range:a});c.stopSmartNameChangeGroup(this,a);return i};this.removeInLineBase=this.removeInLine;this.removeInLine=function(d,e,i){if(e!=i){c.startSmartNameChangeGroup(this);var a=new m(d,e,d,i);h(this,{action:"removeText",range:a});d=this.removeInLineBase(d,e,i);c.stopSmartNameChangeGroup(this,a);return d}};this._removeLinesBase=
this._removeLines;this._removeLines=function(d,e){c.startSmartNameChangeGroup(this);var i=new m(d,0,e+1,0);h(this,{action:"removeLines",range:i});var a=this._removeLinesBase(d,e);c.stopSmartNameChangeGroup(this,i);return a};this.applyDeltas=function(c){for(var e=0;e<c.length;e++){var d=c[e],a=m.fromPoints(d.range.start,d.range.end);"insertLines"==d.action?this.insertLines(a.start.row,d.lines):"insertText"==d.action?this.insert(a.start,d.text):"removeLines"==d.action?this._removeLines(a.start.row,
a.end.row-1):"removeText"==d.action?this.remove(a):k(this,d,!1)}};this.revertDeltas=function(c){for(var e=c.length-1;0<=e;e--){var d=c[e],a=m.fromPoints(d.range.start,d.range.end);"insertLines"==d.action?this._removeLines(a.start.row,a.end.row-1):"insertText"==d.action?this.remove(a):"removeLines"==d.action?this._insertLines(a.start.row,d.lines):"removeText"==d.action?this.insert(a.start,d.text):k(this,d,!0)}}}).call(g.Document.prototype)});
define("utils/ConvertUtils",["jquery","underscore"],function(g){return{getLangFormattedDate:function(d,g){var c=[];c[0]=d.t("MONTH1");c[1]=d.t("MONTH2");c[2]=d.t("MONTH3");c[3]=d.t("MONTH4");c[4]=d.t("MONTH5");c[5]=d.t("MONTH6");c[6]=d.t("MONTH7");c[7]=d.t("MONTH8");c[8]=d.t("MONTH9");c[9]=d.t("MONTH10");c[10]=d.t("MONTH11");c[11]=d.t("MONTH12");null==g&&(g=new Date);var m=g.getMonth(),k=g.getDate(),h=g.getFullYear();return""+c[m]+" "+k+", "+h},getLangFormattedDateAndTime:function(d,g){var c=[];c[0]=
d.t("MONTH1");c[1]=d.t("MONTH2");c[2]=d.t("MONTH3");c[3]=d.t("MONTH4");c[4]=d.t("MONTH5");c[5]=d.t("MONTH6");c[6]=d.t("MONTH7");c[7]=d.t("MONTH8");c[8]=d.t("MONTH9");c[9]=d.t("MONTH10");c[10]=d.t("MONTH11");c[11]=d.t("MONTH12");null==g&&(g=new Date);var m=g.getMonth(),k=g.getDate(),h=g.getFullYear(),f=g.getHours();10>f&&(f="0"+f);var e=g.getMinutes();10>e&&(e="0"+e);return d.t("DateAndTimeString",c[m],k,h,f,e)},getEnglishFormattedDate:function(d,l){var c={};c[d.t("MONTH1")]="Jan";c[d.t("MONTH2")]=
"Feb";c[d.t("MONTH3")]="Mar";c[d.t("MONTH4")]="Apr";c[d.t("MONTH5")]="May";c[d.t("MONTH6")]="Jun";c[d.t("MONTH7")]="Jul";c[d.t("MONTH8")]="Aug";c[d.t("MONTH9")]="Sep";c[d.t("MONTH10")]="Oct";c[d.t("MONTH11")]="Nov";c[d.t("MONTH12")]="Dec";var m=g.trim(l).split(" ");return c[m[0]]?(m[0]=c[m[0]],m.join("")):l},capitaliseFirstLetter:function(d){return d.charAt(0).toUpperCase()+d.slice(1)},getCharacterLineCount:function(d){var g=1,c=0;if(d){for(var d=this.convertHTMLStringToRaw(d),d=d.replace(/\r\n/g,
"\n"),c=0,m=d.indexOf("\n",0);-1!=m;)g++,c++,m=d.indexOf("\n",m+1);c=d.length-c}return{lineCount:g,charCount:c}},convertHTMLStringToRaw:function(d,g){void 0===g&&(g="\n");var c=d.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,">$1<"),c=c.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,
"$1"),c=c.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),c=c.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,g),c=c.replace(/<[^>]*>/g,""),c=c.replace(/&nbsp;|&#160;/gi," ");return c=this.decodeHtmlEntities(c)},convertRawStringToHTML:function(d){d=this.encodeHtmlEntities(d);return d=d.replace(/(\r)?\n/g,
"<br />")},decodeHtmlEntities:function(d){return g("<textarea>").html(d).text()},encodeHtmlEntities:function(d){return g("<div>").text(d).html()}}});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-layer-text",["lib/ace/layer/text","lib/ace/lib/lang","./smartnameanchorcontrol","./smartnameextensionutils","utils/ConvertUtils"],function(g,d,l,c){(function(){this.$renderToken=function(g,k,h,f){var e=this,i=/\x10|\t|&|<|( +)|([\x00-\x1f\x80-\xa0\xad\u1680\u180E\u2000-\u200f\u2028\u2029\u202F\u205F\u3000\uFEFF])|[\u1100-\u115F\u11A3-\u11A7\u11FA-\u11FF\u2329-\u232A\u2E80-\u2E99\u2E9B-\u2EF3\u2F00-\u2FD5\u2FF0-\u2FFB\u3000-\u303E\u3041-\u3096\u3099-\u30FF\u3105-\u312D\u3131-\u318E\u3190-\u31BA\u31C0-\u31E3\u31F0-\u321E\u3220-\u3247\u3250-\u32FE\u3300-\u4DBF\u4E00-\uA48C\uA490-\uA4C6\uA960-\uA97C\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFAFF\uFE10-\uFE19\uFE30-\uFE52\uFE54-\uFE66\uFE68-\uFE6B\uFF01-\uFF60\uFFE0-\uFFE6]/g,a=
function(a,b,c,f){if(b)return e.showInvisibles?"<span class='ace_invisible ace_invisible_space'>"+d.stringRepeat(e.SPACE_CHAR,a.length)+"</span>":d.stringRepeat("\u00a0",a.length);if("&"==a)return"&#38;";if("<"==a)return"&#60;";if("\t"==a)return a=e.session.getScreenTabSize(k+f),k+=a-1,e.$tabStrings[a];if("\u3000"==a)return a=e.showInvisibles?"ace_cjk ace_invisible ace_invisible_space":"ace_cjk",b=e.showInvisibles?e.SPACE_CHAR:"",k+=1,"<span class='"+a+"' style='width:"+2*e.config.characterWidth+
"px'>"+b+"</span>";if(c)return"<span class='ace_invisible ace_invisible_space ace_invalid'>"+e.SPACE_CHAR+"</span>";k+=1;return"<span class='ace_cjk' style='width:"+2*e.config.characterWidth+"px'>"+a+"</span>"},b=f.replace(i,function(b,d,f,g,h){return b==c.SMARTNAMECHAR&&e.session.isSmartNamesEnabled()?(b=e.session.screenToDocumentPosition(0,k+g),b=l.getSmartNameInfoAt(e.session.getDocument(),b.row,b.column),b=c.getSmartNameDisplayString(e.session.getDocument(),b),k+=b.length-1,"<span class='ace_smartname'>"+
b.replace(i,a)+"</span>"):a(b,d,f,g,h)});if(this.$textToken[h.type])g.push(b);else{var n="ace_"+h.type.replace(/\./g," ace_"),j="";"fold"==h.type&&(j=" style='width:"+h.value.length*this.config.characterWidth+"px;' ");g.push("<span class='",n,"'",j,">",b,"</span>")}return k+f.length}}).call(g.Text.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-mouse-dragdrop_handler",["lib/ace/config","lib/ace/lib/event","lib/ace/range","./smartnameanchorcontrol","./smartnameextensionutils"],function(g,d,l,c,m){var k=l.Range;g.on("editor",function(c){var f=c.container,e;d.addListener(f,"dragstart",function(d){if(!this.cancelDrag&&f.draggable){var a=c.session.selection.getRange().start.column,d=d.dataTransfer;d.clearData();var b=c.session.getTextRange(),b=m.recompileText(c.session,
c.session.getDocument(),a,b,!0);d.setData("Text",b);e=!0}}.bind(this));d.addListener(f,"dragend",function(){e=!1}.bind(this));d.addListener(f,"drop",function(){if(!e){var d=c.getSelectedText(),a=m.tryParseText(c.session,d,!0);a.text!==d&&(m.startSmartNameChangeGroup(c.session.getDocument()),d=c.getSelectionRange(),d.isEmpty()||c.session.remove(d),c.session.insert(d.start,a.text),d=new k(0,d.start.column,0,d.start.column+a.text.length),m.addSmartNameAnchors(c.session.getDocument(),d,a.smartnames),
m.stopSmartNameChangeGroup(c.session.getDocument(),d))}}.bind(this))})});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-autocomplete",["lib/ace/autocomplete","lib/ace/autocomplete/util","./smartnameextensionutils"],function(g,d,l){d.retrievePrecedingIdentifier=function(c,d){var g=c.lastIndexOf(l.SMARTNAMECHAR,d),h=c.lastIndexOf("[",d);return-1===h||-1!==g&&h<g?"":c.substring(h,d)};(function(){this.insertMatch=function(c){c||(c=this.popup.getData(this.popup.getRow()));if(!c&&(c=this.popup.getData(0),!c))return!1;if(c.completer&&c.completer.insertMatch)c.completer.insertMatch(this.editor,
c);else{if(this.completions.filterText)for(var d=this.editor.selection.getAllRanges(),g=0,h;h=d[g];g++)h.start.column-=this.completions.filterText.length,this.editor.session.remove(h);c.snippet?snippetManager.insertSnippet(this.editor,c.snippet):c.smartname?this.editor.insertSmartName(c.smartname):this.editor.execCommand("insertstring",c.value||c)}this.detach()};delete this.commands.Space}).call(g.Autocomplete.prototype)});
define("component/smartnames/input/ace-modifications-for-smartnamesupport/mod-ace-all","./mod-ace-editor ./mod-ace-edit_session ./mod-ace-document ./mod-ace-layer-text ./mod-ace-mouse-dragdrop_handler ./mod-ace-autocomplete".split(" "),function(){});
define("component/smartnames/input/smartnameinput","component/smartnames/encoding/smartnameencoding component/smartnames/encoding/smartnamestringpart component/smartnames/encoding/smartname jquery lib/ace/ace lib/ace/ext/language_tools ./ace-modifications-for-smartnamesupport/mod-ace-all".split(" "),function(g,d,l,c,m){function k(c){return"["+(new l(c.getFullName())).getDisplayName()+"]"}var h="showSettingsMenu goToNextError goToPreviousError centerselection gotoline fold unfold toggleFoldWidget toggleParentFoldWidget foldall foldOther unfoldall findnext findprevious selectOrFindNext selectOrFindPrevious find togglerecording replaymacro jumptomatching selecttomatching expandToMatching removeline duplicateSelection sortlines togglecomment toggleBlockComment modifyNumberUp modifyNumberDown replace copylinesup movelinesup copylinesdown movelinesdown cut_or_delete removetolinestart removetolineend outdent indent blockoutdent blockindent splitline transposeletters touppercase tolowercase expandtoline".split(" "),
f=function(e,f){e=void 0===e?document.createElement("div"):c(e).get(0);void 0===f&&(f={});void 0===f.readOnly&&(f.readOnly=!1);void 0===f.encoding&&(f.encoding=g.SAVEDSEARCH);this._encoding=f.encoding;this._mark=(this._markaware=!1===f.markaware?!1:!0)&&(!0===f.mark?!0:!1);this._markid=void 0!=f.markid?f.markid:"@";this._marksn=this._encoding.encodeSmartNameString([d.makeSmartNamePart(new l(this._markid))]);var a=m.edit(e);this._editor=a;this._div=c(e);e.SmartNameInput=this;a.$blockScrolling=Infinity;
var b=a.getValue();a.getSession().enableSmartNames(this._encoding);this.setValue(b);a.getSession().getDocument().displayFunction=void 0!==f.displayFunction?f.displayFunction:k;a.setOptions({highlightActiveLine:!1,highlightSelectedWord:!1});this.readOnly=f.readOnly;this.disabled=!1;this.readOnly?(a.setReadOnly(!0),a.setTheme("component/smartnames/input/themes/smartnames-display")):a.setTheme("component/smartnames/input/themes/smartnames-input");a.getSession().gutterRenderer={getWidth:function(){return 0},
getText:function(){return""}};a.renderer.setOptions({showLineNumbers:!1,maxLines:1,printMargin:0,printMarginColumn:0,showPrintMargin:!1,displayIndentGuides:!1,showGutter:!1});a.renderer.setPadding(0);a.commands.removeCommands(h);a.commands.addCommand({name:"myCommand",bindKey:{win:"Ctrl-F",mac:"Command-F"},exec:function(){},readOnly:!0})};(function(){this._addMark=function(c){this._mark&&(!this._encoding.containsSmartName(c)&&0<c.length)&&(c=this._marksn+c);return c};this._removeMark=function(c){if(this._markaware&&
c.length>=this._marksn.length){for(var c=this._encoding.decodeSmartNameString(c),d=0;d<c.length;d++){var a=c[d];a.isSmartNamePart()&&a.getAsSmartName().getName()===this._markid&&(c.splice(d,1),d--)}c=this._encoding.encodeSmartNameString(c)}return c};this.getValue=function(){return this._addMark(this._editor.getSmartNameEncodedValue())};this.setValue=function(c){try{this._encoding.decodeSmartNameString(c)}catch(d){window.console.error("Error: Illegal value used in setValue on SmartField. Falling back to text..."),
c=this._encoding.escapeString(c)}this._editor.setSmartNameEncodedValue(this._removeMark(c))};this.clear=function(){this._editor.setValue("")};this.onBlur=function(c){this._editor.on("blur",function(){try{c()}catch(d){console.error("An error was thrown in a blur listener: "+d)}})};this.onValueChange=function(c){var d=this;this._editor.on("change",function(){try{d._editor.isChangeReady()&&c(d.getValue())}catch(a){console.error("An error was thrown in a change listener: "+a)}})};this.setSmartNames=function(c){var d=
c.map(function(a){return{caption:"["+a.getDisplayName()+"]",value:"["+a.getDisplayName()+"]",score:1,meta:"",smartname:a.getFullName()}});this._editor.setOptions({enableLiveAutocompletion:[{getCompletions:function(a,b,c,e,f){f(null,d)}}]})};this.insertText=function(c){this._editor.insert(c);this._editor.renderer.scrollCursorIntoView()};this.insertSmartName=function(c){this._editor.insertSmartName(c);this._editor.renderer.scrollCursorIntoView()};this.show=function(){this._div.show()};this.hide=function(){this._div.hide()};
this.focus=function(){this._editor.focus()};this.blur=function(){this._editor.blur()};this.resize=function(){this._editor.resize()};this.isDisabled=function(){return this.disabled};this.disable=function(){this.disabled||(this.disabled=!0,this._editor.setReadOnly(!0),this._div.addClass("ace_smartinput_disabled"))};this.enable=function(){this.disabled&&(this.disabled=!1,this._editor.setReadOnly(!1),this._div.removeClass("ace_smartinput_disabled"))};this.destroy=function(){var c=this.getValue();this._editor.destroy();
this.getJQElement().text(c).removeClass("ace_editor").removeClass("ace-smartnamefield-display").removeClass("ace-smartnamefield-input");try{delete this._div.get(0).SmartNameInput}catch(d){}};this.getJQElement=function(){return this._div}}).call(f.prototype);f.wcrinit=function(c){new f(c)};f.wcrdestroy=function(c){c.SmartNameInput.destroy()};return f});