/**
 * (The MIT License)
 * Copyright (c) 2011 hij1nx http://www.twitter.com/hij1nx
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * See https://github.com/hij1nx/EventEmitter2
 */

define("utils/ConvertUtils",["jquery","underscore"],function(f){return{getLangFormattedDate:function(b,f){var a=[];a[0]=b.t("MONTH1");a[1]=b.t("MONTH2");a[2]=b.t("MONTH3");a[3]=b.t("MONTH4");a[4]=b.t("MONTH5");a[5]=b.t("MONTH6");a[6]=b.t("MONTH7");a[7]=b.t("MONTH8");a[8]=b.t("MONTH9");a[9]=b.t("MONTH10");a[10]=b.t("MONTH11");a[11]=b.t("MONTH12");null==f&&(f=new Date);var h=f.getMonth(),k=f.getDate(),e=f.getFullYear();return""+a[h]+" "+k+", "+e},getLangFormattedDateAndTime:function(b,f){var a=[];a[0]=
b.t("MONTH1");a[1]=b.t("MONTH2");a[2]=b.t("MONTH3");a[3]=b.t("MONTH4");a[4]=b.t("MONTH5");a[5]=b.t("MONTH6");a[6]=b.t("MONTH7");a[7]=b.t("MONTH8");a[8]=b.t("MONTH9");a[9]=b.t("MONTH10");a[10]=b.t("MONTH11");a[11]=b.t("MONTH12");null==f&&(f=new Date);var h=f.getMonth(),k=f.getDate(),e=f.getFullYear(),c=f.getHours();10>c&&(c="0"+c);var d=f.getMinutes();10>d&&(d="0"+d);return b.t("DateAndTimeString",a[h],k,e,c,d)},getEnglishFormattedDate:function(b,j){var a={};a[b.t("MONTH1")]="Jan";a[b.t("MONTH2")]=
"Feb";a[b.t("MONTH3")]="Mar";a[b.t("MONTH4")]="Apr";a[b.t("MONTH5")]="May";a[b.t("MONTH6")]="Jun";a[b.t("MONTH7")]="Jul";a[b.t("MONTH8")]="Aug";a[b.t("MONTH9")]="Sep";a[b.t("MONTH10")]="Oct";a[b.t("MONTH11")]="Nov";a[b.t("MONTH12")]="Dec";var h=f.trim(j).split(" ");return a[h[0]]?(h[0]=a[h[0]],h.join("")):j},capitaliseFirstLetter:function(b){return b.charAt(0).toUpperCase()+b.slice(1)},getCharacterLineCount:function(b){var f=1,a=0;if(b){for(var b=this.convertHTMLStringToRaw(b),b=b.replace(/\r\n/g,
"\n"),a=0,h=b.indexOf("\n",0);-1!=h;)f++,a++,h=b.indexOf("\n",h+1);a=b.length-a}return{lineCount:f,charCount:a}},convertHTMLStringToRaw:function(b,f){void 0===f&&(f="\n");var a=b.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,">$1<"),a=a.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,
"$1"),a=a.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),a=a.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,f),a=a.replace(/<[^>]*>/g,""),a=a.replace(/&nbsp;|&#160;/gi," ");return a=this.decodeHtmlEntities(a)},convertRawStringToHTML:function(b){b=this.encodeHtmlEntities(b);return b=b.replace(/(\r)?\n/g,
"<br />")},decodeHtmlEntities:function(b){return f("<textarea>").html(b).text()},encodeHtmlEntities:function(b){return f("<div>").text(b).html()}}});
define("utils/HTTPUtils",["jquery","underscore","utils/ConvertUtils"],function(f,b,j){return{constructURL:function(a,h,k){var e="";k&&(e+=k);var e=e+a,a="?",c;for(c in h){if(h.hasOwnProperty(c))if(b.isArray(h[c]))for(k=0;k<h[c].length;k++)e+=a+encodeURIComponent(c)+"="+encodeURIComponent(j.decodeHtmlEntities(h[c][k]));else e+=a+encodeURIComponent(c)+"="+encodeURIComponent(j.decodeHtmlEntities(h[c]));a="&"}return e}}});
define("utils/XMLUtils",[],function(){var f=null;return f={attributeValue:function(b,f){var a=b.attributes.getNamedItem(f);return a?a.nodeValue:null},nodeTextContent:function(b,j){var a=b.getElementsByTagName(j)[0];return a?f.textContent(a):null},textContent:function(b){var f=b.textContent;void 0===f&&(f=b.nodeTypedValue);return f},xml2obj:function(b,f){for(var a={},h=b.childNodes,k=0;k<h.length;k++){var e=h[k],c=e.nodeName;if("#text"!=c){var d=this.numberOfChildren(e),l=void 0,l=0<d?this.xml2obj(e,
d):this.textContent(e);void 0!==a[c]?("[object Array]"!==Object.prototype.toString.call(a[c])&&(e=a[c],a[c]=[],a[c].push(e)),a[c].push(l)):a[c]=l}}if((void 0!==f||0<this.numberOfChildren(b))&&b.attributes){a.attributes={};for(h=0;h<b.attributes.length;h++)a.attributes[b.attributes[h].name]=b.attributes[h].value}return a},numberOfChildren:function(b){var f=0;if(b.childNodes&&0<b.childNodes.length)for(var a=0;a<b.childNodes.length;a++)1==b.childNodes[a].nodeType&&f++;return f}}});
define("utils/I18n",["utils/HTTPUtils","utils/XMLUtils","underscore","jquery"],function(f,b,j,a){var h=function(a,e,c){this._locale=a?a:"en";this._timestamp=c?c:0;this.wcrInstanceUrl=e;this.bundles={};this.loading={};this.bundleOrder=[];this.bundleLoadedListeners={}};h.prototype.setLocale=function(a){this._locale=a;this.bundles={};for(var a=function(){},e=0;e<this.bundleOrder.length;e++)this.loadBundle(this.bundleOrder[e],a)};h.prototype.getLocale=function(){return this._locale};h.prototype.loadBundle=
function(a,e,c){e&&c&&(e=j.bind(e,c));if(j.isArray(a)){var d=j.after(a.length,j.once(e));j.each(a,j.bind(function(c){this.loadSingleBundle(c,d)},this))}else this.loadSingleBundle(a,e)};h.prototype.loadSingleBundle=function(h,e){if(this.bundles[h])e&&e(this.bundles[h]);else if(e&&this.whenBundleLoaded(h,e),!this.loading[h]){this.bundleOrder.push(h);this.loading[h]=1;var c=this;a.ajax(f.constructURL("DownloadLocKeys.jsp",{scope:h,t:this._timestamp,lk:this._locale},this.wcrInstanceUrl),{dataType:"xml",
success:function(d){if(d){var e=d.getElementsByTagName("code");if(e[0]&&"001"===b.textContent(e[0]))return}for(var e={},d=d.documentElement.getElementsByTagName("lang_string"),a=0;a<d.length;a++){var g=d[a];e[g.getAttribute("key")]=g.getAttribute("value")}c.bundles[h]={};delete c.loading[h];e&&(c.bundles[h]=e);c.fireBundleLoaded(h,c.bundles[h])},error:function(){},cache:!0,type:"GET"})}};h.prototype.whenBundleLoaded=function(a,e){this.bundleLoadedListeners[a]||(this.bundleLoadedListeners[a]=[]);this.bundleLoadedListeners[a].push(e)};
h.prototype.fireBundleLoaded=function(a,e){this.bundleLoadedListeners[a]&&(j.each(this.bundleLoadedListeners[a],function(c){c(e)}),delete this.bundleLoadedListeners[a])};h.prototype.findByKey=function(a){for(var e=this.bundleOrder.length-1;0<=e;e--)if(this.bundles[this.bundleOrder[e]]&&this.bundles[this.bundleOrder[e]][a])return this.bundles[this.bundleOrder[e]][a]};h.prototype.findByKeyInBundle=function(a,e){if(this.bundles[e]&&this.bundles[e][a])return this.bundles[e][a]};h.prototype.t=function(a){var e=
this.findByKey(a);if(void 0!==e){for(var c=1;c<arguments.length;c++)e=e.replace("{"+(c-1)+"}",arguments[c]);return e}return a};h.prototype.d=function(a,e){var c=this.findByKey(a);if(void 0!==c)return e.toString(c)};return h});
define("utils/webi18n",["utils/I18n","jquery"],function(f,b){var j;return j={getInstance:function(){if(!window.webI18n){var a=window,h=function(e,c){void 0===c||null===c||(c instanceof jQuery||(c=b(c)),c.text(e))},k=new f(window.webcenterConfig.userLang,window.webcenterConfig.jspBaseUrl,window.webcenterConfig.languageLoadTimestamp);a.webI18n={loadSingleBundle:function(e,c){k.loadSingleBundle(e,c)},whenBundleLoaded:function(e,c){k.whenBundleLoaded(e,c)},t:function(e,c){var d=k.findByKeyInBundle(e,
c);if(void 0!==d){for(var a=2;a<arguments.length;a++)d=d.replace("{"+(a-2)+"}",arguments[a]);return d}return e},tIn:function(e,c,d){var a=arguments,i=k.findByKeyInBundle(e,c);if(void 0===i)k.whenBundleLoaded(c,function(){i=k.findByKeyInBundle(e,c);if(void 0!==i){for(var g=3;g<a.length;g++)i=i.replace("{"+(g-3)+"}",a[g]);h(i,d)}else h(e,d)}),h(e,d);else{for(var g=3;g<a.length;g++)i=i.replace("{"+(g-3)+"}",a[g]);h(i,d)}},getLocale:function(){return k.getLocale()}}}return window.webI18n},load:function(a,
h,b,e){if(e.isBuild)b();else{var c=j.getInstance();c.loadSingleBundle(a,function(d){b({t:function(d){var e=[d,a].concat(Array.prototype.slice.call(arguments).slice(1));return c.t.apply(c,e)},tFallback:function(d,e){var g=[d,a].concat(Array.prototype.slice.call(arguments).slice(2)),g=c.t.apply(c,g);return g===d?e:g},asMap:function(){return d}})})}}}});
define("doctablex/DocTableXUtils",["jquery","utils/webi18n!DocRefStrings"],function(f,b){var j,a=0;return j={maxBOMCount:2147483647,getNextUniquePrefix:function(){return a++},log:function(a){"undefined"!=typeof console&&console.log(a)},error:function(a){"undefined"!=typeof console?console.error(a):alert(a)},isValidID:function(a){return a&&"string"==typeof a&&16==a.trim().length},getFileExtension:function(a,b){if(null==a||null==a.length||3>a.length||0>a.lastIndexOf(".")||a.lastIndexOf(".")>=a.length-
1)return null;var e=a.substr(a.lastIndexOf(".")),e=e.replace(/^\s+|\s+$/g,"").toLowerCase();b&&(e=e.substring(e.indexOf(".")+1));return e},getRenderItem:function(a,b){if(!a)return null;for(var e=0;e<a.length;e++){var c=a[e];if(c&&c.type){var d=c.type;"DocumentProperty"==d&&(d+="_"+c.typeDetail);if(d==b)return c}}return null},_getFileExtensionsList:function(a){var b=[];if(a&&0<a.length){var e=a.split(",");1==e.length&&(e=a.split(";"));for(a=0;a<e.length;a++){var c=e[a];c&&(c=c.replace(/^\s+|\s+$/g,
"").toLowerCase(),"."==c.substr(0,1)&&(c=c.substr(1)),b.push(c))}}return b},_getDocTemplateNameList:function(a){var b=[];if(a&&0<a.length){var e=a.split(",");1==e.length&&(e=a.split(";"));for(a=0;a<e.length;a++){var c=e[a];c&&(c=c.replace(/^\s+|\s+$/g,"").toLowerCase(),b.push(c))}}return b},preserveFileInputs:function(a){var b=f("#DocTableFileInputsReposElemID");0==b.length&&(b=f('<div id="DocTableFileInputsReposElemID" style="display:none"></div>'),f("body").prepend(b));a=f("#"+a+" input.docTableFileInputToPreserve");
a.appendTo(b);return a.length},reinsertPreservedFileInputs:function(a){f("#DocTableFileInputsReposElemID input.docTableFileInputToPreserve").each(function(b){j.log("Preserved file input"+b+": "+f(this).attr("name"));b=f(this).attr("name");if(!a||0==a.length||0==b.indexOf(a))b=f("input[name="+b+"]").not(this),0<b.length&&(f(this).attr("name",b.attr("name")),f(this).attr("onchange",b.attr("onchange")),b.replaceWith(f(this)))})},getMenuFileParamValue:function(){var a;a="menu_file".replace(/[\[]/,"\\[").replace(/[\]]/,
"\\]");a=RegExp("[\\?&]"+a+"=([^&#]*)").exec(location.search);return null===a?"":decodeURIComponent(a[1].replace(/\+/g," "))},getSourcePageURLEncoded:function(){var a=location.pathname.replace(/\/[^\/]*/i,"");return encodeURIComponent(a+location.search)},getEncodedTranslatedLabel:function(a){var f="",e="DocRefColLabel_"+a;0===a.indexOf("DocRefColLabel_")?f=b.t(a):b.t(e)!=e&&(f=b.t(e));f||(f=a);return WCXML.xmlencode(f)}}});
define("doctablex/DocTableXView",["doctablex/DocTableXUtils","wcr/webcenter_xml","jquery"],function(f,b,j){var a=function(a,b,e){if(!a&&!b&&!e)return this;this.dm=a;this.phElemID=b;this.renderMethodMap={AttributeFlapout:this.renderExpandCollapseButtonHeader,UpDownArrows:this.renderSortingArrowsHeader,SequenceNumber:this.renderSequenceNumberHeader,DocumentName:this.renderDocumentSpecHeader,DocumentActions:this.renderDocumentActionsHeader,DocumentProperty_Thumbnail:this.renderThumbnailHeader,DocumentProperty_Description:this.renderDocumentDescriptionHeader,
DocumentProperty_ApprovalStatus:this.renderApprovalStatusHeader,DocumentProperty_ApprovalStage:this.renderApprovalStageHeader,DocumentProperty_Project:this.renderDocProjectNameHeader,DocumentProperty_VersionRevision:this.renderDocumentVersionHeader,DocumentProperty_VersionAuthor:this.renderDocumentAuthorHeader,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDateHeader,ReferenceProperty:this.renderReferencePropertyHeader,DocumentAttribute:this.renderDocAttributeHeader,LocalRemote:this.renderLocalRemoteButtonHeader,
DeleteButton:this.renderDeleteButtonHeader};this.renderOptions=e;return this};a.prototype.render=function(a){var b=j("#"+this.phElemID);if(0==b.length)return b;this.dm.isInactive&&b.hide();var e=this.renderOptions;a&&(this.renderOptions=a);f.preserveFileInputs(this.phElemID);"list"==this.renderOptions.renderMethod?this.renderSimple(b):"table"==this.renderOptions.renderMethod?this.renderComplex(b):alert("Not supported render method: "+this.renderOptions.renderMethod+".");for(a=0;a<this.dm.docRows.length;a++)this.dm.docRows[a].displayRow(!1);
f.reinsertPreservedFileInputs();this.renderDocSourceLinks();this.renderOptions=e;return b};a.prototype.repaintRemoteDocRows=function(){if(this.dm.docRows)for(var a=0;a<this.dm.docRows.length;a++){var b=this.dm.docRows[a];b.isRemoteDocument()&&b.view.repaintRow()}};a.prototype.renderDocSourceLinks=function(){if(this.dm.isEditable){if(0<j("#"+this.dm.greenLinksPrefix).length){var a=this.dm.getDocumentSourceOptions(this.dm.greenLinksPrefix);this.dm.dshObj.displayLinks(a)}0<j("#"+this.dm.greenLinksPrefix+
"_bottom").length&&(a=this.dm.getDocumentSourceOptions(this.dm.greenLinksPrefix+"_bottom"),this.dm.dshObj.displayLinks(a))}};a.prototype.renderSimple=function(a){try{this.isSingleValueListRendering=!this.dm.allowMultiple,this.renderOptions.hideHeader=!0,this.renderComplex(a)}catch(b){return f.log("Problem in DocTableXView.renderSimple:\n"+b),null}return a};a.prototype.renderComplex=function(a){try{this.dm.destroy();a.html("");this.isSingleValueListRendering||a.append(this.renderGreenLinksPlaceholder("top"));
var b="",b=this.renderOptions.hideHeader?b+"headerlessTable":b+"ordtable docreftable documentsTable",e=j('<table class="'+b+'"></table>');a.append(e);this.renderOptions.hideHeader||this.renderTableHeader(e);b="<tbody>";if(0<this.dm.docRows.length)for(var c=0;c<this.dm.docRows.length;c++)b+='<tr id="'+this.dm.docRows[c].view.phElemID+'"></tr>';else this.isSingleValueListRendering&&(b+="<tr><td>",b+=this.renderGreenLinksPlaceholder("top"),b+="</td></tr>");e.append(b+"</tbody>");this.isSingleValueListRendering||
a.append(this.renderGreenLinksPlaceholder("bottom"));if(!this.dm.isInactive||this.dm.clearValues){var d=this.dm.getTablePrefix();a.append('<input type="hidden" id="'+d+'" name="'+d+'"/>')}}catch(l){return f.log("Problem in DocTableXView.renderComplex:\n"+l),null}return a};a.prototype.renderGreenLinksPlaceholder=function(a){var b="";try{b+='<div class="docrefheader">',this.dm.isEditable&&(-1!=a.indexOf("top")&&this.renderOptions.showGreenLinksOnTop&&(b+='<div class="darktext_greenlink_11 nobr mr10" id="'+
this.dm.greenLinksPrefix+'"></div>'),-1!=a.indexOf("bottom")&&this.renderOptions.showGreenLinksAtBottom&&(b+='<div class="darktext_greenlink_11 nobr mr10" id="'+this.dm.greenLinksPrefix+'_bottom"></div>'),-1!=a.indexOf("inline")&&(b+='<div class="darktext_greenlink_11 nobr mr10" id="'+this.dm.greenLinksPrefix+'_inline"></div>')),b+="</div>"}catch(e){f.log("Problem in DocTableXView.renderGreenLinksPlaceholder:\n"+e),b=""}return b};a.prototype.renderTableHeader=function(a){if(a&&0!=a.length)try{var b=
"";if(0<this.dm.getNumberOfRows()){var b=b+"<thead><tr>",e=this.renderOptions.columns;if(e)for(var c=0;c<e.length;c++){var d=this.renderOptions.columns[c];if(d){var l=d.type;"DocumentProperty"==l&&(l+="_"+d.typeDetail);var i=this.renderMethodMap[l];i&&(b+=i.call(this,d))}}b+="</tr></thead>"}a.html(b)}catch(g){f.log("Problem in DocTableXView.renderTableHeader:\n"+g)}};a.prototype.renderExpandCollapseButtonHeader=function(){var a="javascript: "+this.dm.getThisInDOM()+".expandCollapseAllClicked(this);return false;",
a='<th class="docrefexpandcol">'+('<a class="btn btn12 expandAll" href="#" onclick="'+a+'"><i class="expand-small"></i></a>')+('<a class="btn btn12 collapseAll" href="#" onclick="'+a+'"><i class="collapse-small"></i></a>');return a+="</th>"};a.prototype.renderSortingArrowsHeader=function(){return this.dm.isEditable?'<th class="docrefsortcol"></th>':""};a.prototype.renderSequenceNumberHeader=function(a){return'<th class="docrefsortcol">'+b.xmlencode(a.label)+"</th>"};a.prototype.renderThumbnailHeader=
function(a){return'<th class="docrefthumbcol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentSpecHeader=function(a){return'<th class="docrefdoccol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentActionsHeader=function(a){return'<th class="docrefactionscol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentDescriptionHeader=function(a){return'<th class="docrefdoccol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderApprovalStatusHeader=
function(a){return'<th class="docrefApprovalStatus">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderApprovalStageHeader=function(a){return'<th class="docrefdoccol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocProjectNameHeader=function(a){return'<th class="docrefdoccol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentVersionHeader=function(a){return'<th class="docrefversioncol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentAuthorHeader=
function(a){return'<th class="docrefdoccol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderDocumentModifiedDateHeader=function(a){return'<th class="docrefdoccol">'+f.getEncodedTranslatedLabel(a.label)+"</th>"};a.prototype.renderLocalRemoteButtonHeader=function(){return'<th class="docrefsortcol"></th>'};a.prototype.renderDeleteButtonHeader=function(){return this.dm.isEditable?'<th class="docrefremovecol"></th>':""};a.prototype.renderReferencePropertyHeader=function(a){var f;f='<th class="docrefdoccol">'+
b.xmlencode(a.label);"Required"==a.visibility&&(f+='&nbsp;<font color="red">*</font>');return f+"</th>"};a.prototype.renderDocAttributeHeader=function(a){var f;f='<th class="docrefdoccol">'+b.xmlencode(a.label);"Required"==a.visibility&&(f+='&nbsp;<font color="red">*</font>');return f+"</th>"};return a});
define("doctablex/DocumentTypeUtils",[],function(){var f=!1,b="ard cf2 cff2 ds2 dd3 dxf dwg scb vlm".split(" "),j=[],a=[],h=function(b){for(var e=0;e<a.length;e++)if(b==a[e].id)return!0;return!1};return{initDocumentTypes:function(b,e){if(b&&(!f||e)){b.graphicExtList&&(j=b.graphicExtList);if(b.docTypeList)for(var c=0;c<b.docTypeList.length;c++){var d=b.docTypeList[c];"1"==d.enabled&&a.push(d)}f=!0}},getIsInitialized:function(){return f},getDocTypeIDByExtension:function(a,e){if(!f)return"00001_0000000005";
var c=a?a.toLowerCase():"",d;a:{for(d=0;d<b.length;d++)if(c==b[d]&&h("00001_0000000001")){d=!0;break a}d=!1}if(d)return"00001_0000000001";a:{for(d=0;d<j.length;d++)if(c==j[d]&&h("00001_0000000004")){d=!0;break a}d=!1}if(d)return"00001_0000000004";if("pagelist"==e&&h("00001_0000000014"))return"00001_0000000014";if(e&&e.indexOf&&-1<e.indexOf("00002_0000000"))return e;switch(c){case "a3d":if(h("00001_0000000003"))return"00001_0000000003";break;case "acd":if(h("00001_0000000020"))return"00001_0000000020";
break;case "mfg":if(h("00001_0000000002"))return"00001_0000000002";break;case "clf":if(h("00001_0000000008"))return"00001_0000000008";break;case "zcp":if(h("00001_0000000008"))return"00001_0000000008";break;case "dae":if(h("00001_0000000017"))return"00001_0000000017";break;case "zae":if(h("00001_0000000016"))return"00001_0000000016";break;case "chp":if(h("00001_0000000018"))return"00001_0000000018"}return"00001_0000000005"}}});
define("attributecategory/Attribute",[],function(){function f(b){this.id=b.id;this.name=b.name;this.description=b.description;this.unitId=b.unitId;this.rsId=b.rsId;this.type=b.type;b.value?this.setValue(b.value,b.valueHyperlink):this.setValue("");this.placedOriginally=b.placedOriginally||!1;this.placedArr=b.placedArr||[];this.isRequired=b.isRequired||!1;this.rs=b.rs;this.restrictType=b.restrictType;this.isCheckBox=b.isCheckBox||!1;this.isDocReference()&&b.docTable&&(this.docTableObj=b.docTable)}f.prototype.isDocReference=
function(){return this.type?"documentreference"==this.type.toLowerCase():"00001_0000000022"==this.unitId};f.prototype.isText=function(){return this.type?"text"==this.type.toLowerCase():"00001_0000000001"==this.unitId};f.prototype.isRichText=function(){return this.type?"richtext"==this.type.toLowerCase():"00001_0000000021"==this.unitId};f.prototype.setIsRequired=function(b){this.isRequired=b};f.prototype.getIsRequired=function(){return!this.isRequired?!1:this.isRequired};f.prototype.setValue=function(b,
f){b||(f=b="");this.value!=b&&(this.value=b,this.valueHyperlink=f)};f.prototype.copyValueFrom=function(b){b&&(this.value=b.value,this.valueHyperlink="undefined"==typeof b.valueHyperlink?"":b.valueHyperlink,this.hiddenDate="undefined"==typeof b.hiddenDate?"":b.hiddenDate,this.oldDate="undefined"==typeof b.oldDate?"":b.oldDate)};return f});
define("doctablex/AJAXDataCache","doctablex/DocTableXUtils doctablex/DocumentTypeUtils attributecategory/Attribute wcr/webcenter_xml wcr/webcenter_html wcr/ObjectArrayCloneUtil jquery underscore".split(" "),function(f,b,j,a,h,k,e,c){var d=null,l={},i={},g=[],n=[],m=[],o=[],p=[],r=[],w=null,x=[],t=[],y=[],s=function(d){try{var c=a.GetFirstFirstLevelChild(d,"error");if(c){var e=a.GetElementText(c,"code"),b=a.GetElementText(c,"message");f.log("SDK error "+e+": "+b);return e+": "+b}}catch(g){return f.log("Problem in findAndGetSDKError() private method."),
"000: Undefined error"}return""};return{getInstance:function(){d||(d={resetDocDataByDocVerID:function(d){d&&(p[d]&&(p[d]=null),r[d]&&(r[d]=null))},getProjCreationSysDefaults:function(d){d&&(i=null);var c=i;c||(i=c={});if(c.request)return c.request.promise();c.request=new e.Deferred;try{var g=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetProjectCreationInfo.jsp?action=LoadDefaultSettings&ajax=1",dataType:"xml",context:this});g.fail(function(d,a,c){if(0!=d.status){var d=i,e="Request failed.\n",
e="SESSION_EXP"==c?e+"Session expired, please try again.":e+("Unable to load project creation system defaults.\nServer status: "+a);f.log(e);i=null;d.request.reject(e)}});g.done(function(d){var c=i,e=s(d);if(e)return e="Request failed with SDK error:\n"+e,f.log(e),i=null,c.request.reject(e),c.request.promise();var e={},b=a.GetFirstFirstLevelChild(d,"system_defaults");if(b){e.blankProjectAutoname=a.GetElementText(b,"blank_project_autoname");e.useDefAutoname4BlankProj=a.GetElementText(b,"use_default_autoname_for_blank_project");
e.useDefCategory4BlankProj=a.GetElementText(b,"use_default_category_for_blank_project");if(d=a.GetFirstFirstLevelChild(b,"graphic_files_extensions"))if(d=a.GetFirstLevelChilds(d,"extension")){e.graphicExtList=[];for(var g=0;g<d.length;g++){var p=a.GetElementSelfTextContent(d[g]),p=p.substring(p.indexOf(".")+1);e.graphicExtList.push(p)}}d=[];if(g=a.GetFirstFirstLevelChild(b,"doc_type_list"))if(p=a.GetFirstLevelChilds(g,"doc_type")){e.docTypeList=[];for(var h=0;h<p.length;h++){var m=p[h],g={};g.id=
a.GetElementAttribute(m,"id");d.push(g.id);g.name=a.GetElementText(m,"name");g.labelTag=a.GetElementText(m,"label_tag");g.enabled=a.GetElementText(m,"enabled");g.uploadJSP=a.GetElementText(m,"Upload_JSP");g.typicalExt=a.GetElementText(m,"upload_hint");e.docTypeList.push(g)}}if(e.docTypeList&&0<e.docTypeList.length&&(b=a.GetFirstFirstLevelChild(b,"doctype_autonaming_list")))if(b=a.GetFirstLevelChilds(b,"doctype_autonaming"))for(p=0;p<b.length;p++)if(h=b[p],g=a.GetElementText(h,"doctypeid"))if(g=d.indexOf(g),
!(0>g)&&(g=e.docTypeList[g]))g.anPrefix=a.GetElementText(h,"autoname_prefix"),g.anSuffix=a.GetElementText(h,"autoname_suffix"),g.anCounterLength=a.GetElementText(h,"autoname_counter_length"),g.anOption=a.GetElementText(h,"autoname_option"),g.categoryID=a.GetElementText(h,"category_id"),g.categoryID||(g.categoryID=l),g.categoryOption=a.GetElementText(h,"category_option")}c.request.resolve(e)})}catch(p){alert("Problem in AJAXDataCache.getProjCreationSysDefaults: "+p)}b&&c.request.done(function(a){b.initDocumentTypes(a,
d)});return c.request.promise()},getEffectiveDocTypesSettingsByProjID:function(d,c){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getEffectiveDocTypesSettingsByProjID() method!").promise();c&&(g[d]=null);var b=g[d];b||(b={},g[d]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;try{var i=new e.Deferred,p=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetDocUploadInfo.jsp?action=GetAutonamingSettingsForProject&projectID="+
d+"&ajax=1",dataType:"xml",context:this});p.fail(function(d,a,c){0!=d.status&&(d="Request failed.\n",d="SESSION_EXP"==c?d+"Session expired, please try again.":d+("Unable to load project creation system defaults.\nServer status: "+a),f.log(d),i.reject(d))});p.done(function(c){var e=s(c);if(e)e="Request failed with SDK error:\n"+e,f.log(e),i.reject(e);else{e=[];if(c=a.GetFirstFirstLevelChild(c,"autonaming_info"))if(c=a.GetFirstFirstLevelChild(c,"project_autoname"))if(c=a.GetFirstFirstLevelChild(c,"doctype_autonaming_list"))if(c=
a.GetFirstLevelChilds(c,"doctype_autonaming"))for(var b=0;b<c.length;b++){var g=c[b],p=a.GetElementText(g,"projectid");if(p!=d)alert("Project ID of processed <doctype_autonaming> tag is not the same as 'projectID'!");else{var h={};h.projectID=p;h.id=a.GetElementText(g,"doctypeid");h.anPrefix=a.GetElementText(g,"autoname_prefix");h.anSuffix=a.GetElementText(g,"autoname_suffix");h.anCounterLength=a.GetElementText(g,"autoname_counter_length");h.anOption=a.GetElementText(g,"autoname_option");h.categoryID=
a.GetElementText(g,"category_id");h.categoryID||(h.categoryID=l);h.categoryOption=a.GetElementText(g,"category_option");e.push(h)}}i.resolve(e)}});var h=this.getProjCreationSysDefaults(c);e.when(i,h).done(function(d,c){var a=k.getCloneOfObject(c),e=a.docTypeList;if(d&&e)for(var g=0;g<e.length;g++){var l=e[g].id;if(l)for(var i=0;i<d.length;i++){var f=d[i];if(l==f.id){l=a.docTypeList[g];if("0"==f.anOption||"1"==f.anOption)l.anPrefix=f.anPrefix,l.anSuffix=f.anSuffix,l.anCounterLength=f.anCounterLength,
l.anOption=f.anOption;if("0"==f.categoryOption||"1"==f.categoryOption)l.categoryID=f.categoryID,l.categoryOption=f.categoryOption;break}}}b.request.resolve(a)}).fail(function(d){0!=jqXHR.status&&b.request.reject(d)})}catch(m){alert("Problem in AJAXDataCache.getDocTypeSettingsByProjID: "+m)}return b.request.promise()},getDocTemplatesByProjID:function(d,c,b){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getDocTemplatesByProjID() method!").promise();b&&
(n[d]=null);if((b=n[d])&&!b.isThumbnailsLoaded&&c)b=n[d]=null;b||(b={},n[d]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;b.isThumbnailsLoaded=c;try{var g=window.webcenterConfig.jspBaseUrl+"GetProjectCreationInfo.jsp?action=LoadTemplateDocuments&projectID="+d+"&ajax=1";c&&(g+="&loadThumbnails=1");var i=e.ajax({type:"GET",url:g,dataType:"xml",context:this});i.fail(function(c,a,e){if(0!=c.status){var c=n[d],b="Request failed.\n",b="SESSION_EXP"==e?b+"Session expired, please try again.":
b+("Unable to load project creation system defaults.\nServer status: "+a);f.log(b);n[d]=null;c.request.reject(b)}});i.done(function(e){var b=n[d],g=s(e);if(g)return g="Request failed with SDK error:\n"+g,f.log(g),n[d]=null,b.request.reject(g),b.request.promise();var i=function(d,c){var e={};if(d){e.id=a.GetElementText(d,"document_id");e.docVerID=a.GetElementAttribute(d,"id");e.docVerIdx=a.GetElementText(d,"version_number");e.categoryID=a.GetElementText(d,"category_id");e.categoryID||(e.categoryID=
l);e.docTypeID=a.GetElementText(d,"doctype_id");var b=a.GetFirstFirstLevelChild(d,"document");e.name=a.GetElementText(b,"name");e.thumbnailURL=a.GetElementText(b,"thumbnail_url");c&&(e.folderID=c.id?c.id:"",e.folderName=c.name?c.name:"")}return e},g=[];if(e=a.GetFirstFirstLevelChild(e,"template_documents")){g.tempProjID=a.GetElementText(e,"template_project_id");var h=a.GetFirstFirstLevelChild(e,"template_docs");if(h&&(h=a.GetFirstFirstLevelChild(h,"folder_doc_list"))){var p=a.GetFirstLevelChilds(h,
"folder");if(p)for(var m=0;m<p.length;m++){var o=p[m],j={};j.id=a.GetElementAttribute(o,"id");j.name=a.GetElementText(o,"name");if(o=a.GetFirstFirstLevelChild(o,"doc_version_checkout_list"))if(o=a.GetFirstLevelChilds(o,"doc_version_checkout"))for(var k=0;k<o.length;k++){var u=a.GetFirstFirstLevelChild(o[k],"doc_version");g.push(i(u,j))}}if(o=a.GetFirstFirstLevelChild(h,"doc_version_checkout_list"))if(o=a.GetFirstLevelChilds(o,"doc_version_checkout"))for(k=0;k<o.length;k++)u=a.GetFirstFirstLevelChild(o[k],
"doc_version"),g.push(i(u))}if(c&&(i=a.GetFirstFirstLevelChild(e,"template_docs_thumbnail")))if(i=a.GetFirstLevelChilds(i,"template_doc_thumbnail"))for(e=0;e<i.length;e++){h=i[e];p=a.GetElementText(h,"id");for(m=0;m<g.length;m++)if(j=g[m],p==j.id){j.thumbnailURL=a.GetElementText(h,"thumbnail");break}}}b.request.resolve(g)})}catch(h){alert("Problem in AJAXDataCache.getDocTemplatesByProjID: "+h)}return b.request.promise()},getFoldersByProjID:function(d,c){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getFoldersByProjID() method!").promise();
c&&(m[d]=null);var b=m[d];b||(b={},m[d]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;try{var g=e.ajax({type:"GET",url:"GetDocUploadInfo.jsp?action=GetSingleProjectFolders&projectID="+d+"&ajax=1&loadfolderpermissions=1",dataType:"xml",context:this});g.fail(function(c,a,e){if(0!=c.status){var c=m[d],b="Request failed.\n",b="SESSION_EXP"==e?b+"Session expired, please try again.":b+("Unable to load project upload folders.\nServer status: "+a);f.log(b);m[d]=null;c.request.reject(b)}});
g.done(function(c){var e=m[d],b=s(c);if(b)return b="Request failed with SDK error:\n"+b,f.log(b),m[d]=null,e.request.reject(b),e.request.promise();b=[];if(c=a.GetFirstFirstLevelChild(c,"upload_projects")){var g=a.GetFirstFirstLevelChild(c,"project");if(g){c=a.GetElementText(g,"root_upload_enabled");if(null!=c&&"1"==c){var c={id:"0",name:""},l=a.GetElementText(g,"root_change_prop_enabled");c.changePropPerm=l&&"1"==l;b.push(c)}if(c=a.GetFirstFirstLevelChild(g,"folder_list"))if(g=a.GetFirstLevelChilds(c,
"folder"))for(l=0;l<g.length;l++){var i=g[l],c={};c.id=a.GetElementAttribute(i,"id");c.name=a.GetElementText(i,"name");var h=!1;if((i=a.GetFirstLevelChilds(i,"permission"))&&0<i.length)h=(h=a.GetElementText(i[0],"update"))&&"1"==h;c.changePropPerm=h;b.push(c)}}}e.request.resolve(b)})}catch(l){alert("Problem in AJAXDataCache.getFoldersByProjID: "+l)}return b.request.promise()},getDocVersionsByProjID:function(d,c){if(!d||0==d.length)return e.Deferred().reject("Project ID has to be specified in AJAXDataCache.getDocVersionsByProjID() method!").promise();
c&&(o[d]=null);var b=o[d];b||(b={},o[d]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;try{var g=e.ajax({type:"GET",url:"GetDocumentList.jsp?projectID="+d+"&ajax=1",dataType:"xml",context:this});g.fail(function(c,a,e){if(0!=c.status){var c=o[d],b="Request failed.\n",b="SESSION_EXP"==e?b+"Session expired, please try again.":b+("Unable to load project documents.\nServer status: "+a);f.log(b);o[d]=null;c.request.reject(b)}});g.done(function(c){var e=o[d],b=s(c);if(b)return b="Request failed with SDK error:\n"+
b,f.log(b),o[d]=null,e.request.reject(b),e.request.promise();b=[];if(c=a.GetFirstFirstLevelChild(c,"document_list"))if(c=a.GetFirstLevelChilds(c,"document"))for(var g=0;g<c.length;g++){var l=c[g],i={};i.id=a.GetElementText(l,"document_version_id");i.name=a.GetElementText(l,"document_name");i.versionIndex=a.GetElementText(l,"document_version");i.revisionIndex=a.GetElementText(l,"document_revision");b.push(i)}e.request.resolve(b)})}catch(l){alert("Problem in AJAXDataCache.getdocByProjID: "+l)}return b.request.promise()},
getDocInfoWithThumbnail:function(d,c){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocInfoWithThumbnail() method!").promise();c&&(p[d]=null);var b=p[d];b||(b={},p[d]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;try{var g=window.webcenterConfig.jspBaseUrl+"GetDocumentHistory.jsp?docversionid="+d,i=e.ajax({type:"GET",url:g+"&projectinfo=1&includetemplates=1&approvalinfo=1&limitdocversions=1&thumbnailurl=1&dateformat=2&ajax=1",
dataType:"xml",context:this});i.fail(function(c,a,e){if(0!=c.status){var c=p[d],b="Request failed.\n",b="SESSION_EXP"==e?b+"Session expired, please try again.":b+("Unable to load document details (version "+d+").\nServer status: "+a);f.log(b);p[d]=null;c.request.reject(b)}});i.done(function(c){var e=p[d],b=null,g=s(c);if(g)return 0==g.indexOf("021")||0==g.indexOf("005")?(b=l,e.request.resolve(b)):(b="Request failed with SDK error:\n"+g,f.log(b),p[d]=null,e.request.reject(b)),e.request.promise();if(c=
a.GetFirstFirstLevelChild(c,"document_info")){b={};b.docID=a.GetElementText(c,"docID");b.latestDocVerIdx=a.GetElementText(c,"last_version_number");b.docName=a.GetElementText(c,"document_name");b.docDesc=a.GetElementText(c,"description");b.modDate=a.GetElementText(c,"modification_date");b.docIsUrl=a.GetElementBoolean(c,"is_url");b.docCheckedOutOwner=a.GetElementText(c,"checked_out_owner_id");if(g=a.GetFirstFirstLevelChild(c,"permission")){var i={};i.view="1"==a.GetElementText(g,"view");i.add="1"==
a.GetElementText(g,"add");i.change="1"==a.GetElementText(g,"update");i.remove="1"==a.GetElementText(g,"delete");i.checkout="1"==a.GetElementText(g,"checkout");i.download="1"==a.GetElementText(g,"download");i.changeApp="1"==a.GetElementText(g,"change_approval");i.changeTask="1"==a.GetElementText(g,"change_task");i.changeBOM="1"==a.GetElementText(g,"change_bom");i.isProjMgr="1"==a.GetElementText(g,"can_manage_this_project");b.userPerms=i}if(g=a.GetFirstFirstLevelChild(c,"document_version")){b.docVerID=
a.GetElementText(g,"docVersionID");b.docVerIdx=a.GetElementText(g,"version_number");b.docVerDesc=a.GetElementText(g,"version_comments");b.docRevIdx=a.GetElementText(g,"revision");b.docRevLetter=a.GetElementText(g,"revision_letter");b.docTypeID=a.GetElementText(g,"doc_type_id");b.thumbnailURL=a.GetElementText(g,"thumb_url");b.docSourceId=a.GetElementText(g,"source_id");b.has3dView=a.GetElementText(g,"has_3d_view");var m=a.GetFirstFirstLevelChild(g,"author");if(m){var i={},o=a.GetFirstFirstLevelChild(m,
"user");if(o){i.isUser=!0;i.id=a.GetElementText(o,"userID");var m=a.GetElementText(o,"lastname"),j=a.GetElementText(o,"firstname"),o=a.GetElementText(o,"login");i.fullName=h.getUserNameString(j,m,o)}b.docVerAuthor=i}i={};i.cycleStatusCode=a.GetElementText(g,"document_approval_cycle_code");i.cycleStatus=a.GetElementText(g,"document_approval_cycle_status");i.status=a.GetElementText(g,"document_approval_status");i.statusID=a.GetElementText(g,"document_approval_code");i.cycleStatusStringCode={"-1":"no_approval_rule",
"0":"cycle_started",1:"cycle_stopped",2:"cycle_finished"}[i.cycleStatusCode];i.stageIdx=a.GetElementText(g,"stage_index");if(g=a.GetFirstFirstLevelChild(g,"stages"))if(g=a.GetFirstLevelChilds(g,"stage"))for(m=0;m<g.length;m++)if(j=g[m],a.GetElementText(j,"index")==i.stageIdx){i.stageID=a.GetElementText(j,"stage_id");i.stageName=a.GetElementText(j,"name");break}b.appStatus=i}b.appTypeList=[];if(g=a.GetFirstFirstLevelChild(c,"approvaltypes"))if(i=a.GetFirstLevelChilds(g,"approvaltype"))for(g=0;g<i.length;g++)m=
i[g],j={},j.id=a.GetElementText(m,"approvalid"),j.name=a.GetElementText(m,"type_name"),j.translName=a.GetElementText(m,"approvalname"),j.level=a.GetElementText(m,"approval_level"),j.dispOrder=a.GetElementText(m,"display_order"),j.icon=a.GetElementText(m,"icon"),b.appTypeList.push(j);b.projList=[];if(c=a.GetFirstFirstLevelChild(c,"project_list"))if(c=a.GetFirstLevelChilds(c,"project"))for(g=0;g<c.length;g++)m=c[g],i={},i.id=a.GetElementAttribute(m,"id"),i.name=a.GetElementText(m,"name"),m=a.GetElementText(m,
"is_template"),i.isTemplate=m&&"1"==m,b.projList.push(i)}e.request.resolve(b)})}catch(m){alert("Problem in AJAXDataCache.getDocInfoWithThumbnail: "+m)}return b.request.promise()},getDocAttrCatInfo:function(d,c){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocAttrCatInfo() method!").promise();c&&(r[d]=null);var b=r[d];b||(b={},r[d]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;try{var g=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+
"GetAttributes.jsp?docverid="+d+"&ajax=1",dataType:"xml",context:this});g.fail(function(c,a,b){if(0!=c.status){var c=r[d],e="Request failed.\n",e="SESSION_EXP"==b?e+"Session expired, please try again.":e+("Unable to load attribute category of document version with ID: "+d+").\nServer status: "+a);f.log(e);r[d]=null;c.request.reject(e)}});g.done(function(c){var b=r[d],e=null,g=s(c);if(g)if(0==g.indexOf("043")||0==g.indexOf("005"))e=l;else return e="Request failed with SDK error:\n"+g,f.log(e),r[d]=
null,b.request.reject(e),b.request.promise();null==e&&((c=a.GetFirstFirstLevelChild(c,"attribute_category"))?(e={},e.id=a.GetElementText(c,"id"),e.id?(e.name=a.GetElementText(c,"name"),e.userUnits=a.GetElementText(c,"user_units")):e=l):e=l);b.request.resolve(e)})}catch(i){alert("Problem in AJAXDataCache.getDocAttrCatInfo: "+i)}return b.request.promise()},getGlobalDocumentSettings:function(d){d&&(w=null);d=w;d||(w=d={});if(d.request)return d.request.promise();d.request=new e.Deferred;try{var c=e.ajax({type:"GET",
url:window.webcenterConfig.jspBaseUrl+"GetDocUploadInfo.jsp?action=LoadGlobalDocumentSettings",dataType:"xml",context:this});c.fail(function(d,c,a){if(0!=d.status){var d=w,b="Request failed.\n",b="SESSION_EXP"==a?b+"Session expired, please try again.":b+("Unable to load global settings.\nServer status: "+c);f.log(b);w=null;d.request.reject(b)}});c.done(function(d){var c=w,b=s(d);if(b)return d="Request failed with SDK error:\n"+b,f.log(d),w=null,c.request.reject(d),c.request.promise();b={};(d=a.GetFirstFirstLevelChild(d,
"site_defaults"))?(b.approvalRestartUploaderCanOverrule=a.GetElementText(d,"approval_restart_option"),b.approvalRestartOption=a.GetElementText(d,"approval_restart_enable_checkbox"),b.allowRaiseRevision=a.GetElementText(d,"allow_raise_revision"),b.openCadType=a.GetElementText(d,"open_cad_type")):b=l;c.request.resolve(b)})}catch(b){alert("Problem in AJAXDataCache.getGlobalDocumentSettings: "+b)}return d.request.promise()},getDocDownloadPerspectives:function(d,c,b){if(!d||0==d.length)return e.Deferred().reject("Document version ID has to be specified in AJAXDataCache.getDocDownloadPerspectives() method!").promise();
if(!c||0==c.length)return e.Deferred().reject("Document type ID has to be specified in AJAXDataCache.getDocDownloadPerspectives() method!").promise();b&&(x[c]=null);b=x[c];b||(b={},x[c]=b);if(b.request)return b.request.promise();b.request=new e.Deferred;try{var g=e.ajax({type:"GET",url:window.webcenterConfig.jspBaseUrl+"GetDocumentPerspectives.jsp?docVerID="+d,dataType:"xml",context:this});g.fail(function(a,b,e){if(0!=a.status){var a=x[c],g="Request failed.\n",g="SESSION_EXP"==e?g+"Session expired, please try again.":
g+("Unable to load download perspectives for document version with ID: "+d+").\nServer status: "+b);f.log(g);x[c]=null;a.request.reject(g)}});g.done(function(d){var b=x[c],e=s(d);if(e)return e="Request failed with SDK error:\n"+e,f.log(e),x[c]=null,b.request.reject(e),b.request.promise();e=null;if(d=a.GetFirstFirstLevelChild(d,"perspective_name_list"))for(var e=[],d=a.GetFirstLevelChilds(d,"perspective_name"),g=0;g<d.length;g++){var i=d[g],l={};l.name=a.GetElementText(i,"name");l.longName=a.GetElementText(i,
"long_name");e.push(l)}b.request.resolve(e)})}catch(i){alert("Problem in AJAXDataCache.getDocDownloadPerspectives: "+i)}return b.request.promise()},getAttribute:function(d,c){if(!d||0==d.length)return e.Deferred().reject("Attribute Name has to be specified in AJAXDataCache.getAttribute() method!").promise();c&&(t[d]=null);var a=t[d];a||(a={},t[d]=a);if(a.request)return a.request.promise();a.request=new e.Deferred;y.push(d);this.fetchAttributes();return a.request.promise()},fetchAttributes:c.debounce(function(){for(var d=
window.webcenterConfig.jspBaseUrl+"GetAttributeListXML.jsp?",c=y,b=0;b<y.length;b++)0<b&&(d+="&"),d+="attrname="+encodeURIComponent(y[b]);d=e.ajax({type:"GET",url:d,dataType:"xml",context:this});d.fail(function(d,a,b){if(0!=d.status){d="Request failed.\n";d="SESSION_EXP"==b?d+"Session expired, please try again.":d+("Unable to load attributes with names: "+c+").\nServer status: "+a);f.log(d);for(a=0;a<c.length;a++){var b=c[a],e=t[b];t[b]=null;e.request.reject(d)}}});d.done(function(d){var b=s(d);if(b){var e=
"Request failed with SDK error:\n"+b;f.log(e);for(b=0;b<c.length;b++){var g=c[b],i=t[g];t[g]=null;i.request.reject(e)}}if(b=a.GetFirstFirstLevelChild(d,"attributes"))if(b=a.GetFirstFirstLevelChild(b,"attribute_list")){d=a.GetFirstLevelChilds(b,"attribute");for(b=0;b<d.length;b++)i=d[b],e=new j({name:a.GetElementText(i,"name"),id:a.GetElementAttribute(i,"id"),description:a.GetElementAttribute(i,"description"),unitId:a.GetElementText(i,"attribute_unit_id"),rsId:a.GetElementText(i,"restricted_set_id"),
placedArr:[],value:""}),i=c.indexOf(e.name),-1!=i&&c.splice(i,1),(i=t[e.name])&&i.request.resolve(e)}for(b=0;b<c.length;b++)g=c[b],i=t[g],i.request.reject("Attribute "+g+" not found")});y=[]},50)});return d},isEmptyValue:function(d){return d&&d===l},getEmptyValue:function(){return l}}});
!function(f){function b(){this._events={};this._conf&&j.call(this,this._conf)}function j(b){b&&(this._conf=b,b.delimiter&&(this.delimiter=b.delimiter),b.maxListeners&&(this._events.maxListeners=b.maxListeners),b.wildcard&&(this.wildcard=b.wildcard),b.newListener&&(this.newListener=b.newListener),this.wildcard&&(this.listenerTree={}))}function a(b){this._events={};this.newListener=!1;j.call(this,b)}function h(b,c,d,a){if(!d)return[];var i=[],g,f,m,o;m=c.length;o=c[a];var p=c[a+1];if(a===m&&d._listeners){if("function"===
typeof d._listeners)b&&b.push(d._listeners);else{c=0;for(a=d._listeners.length;c<a;c++)b&&b.push(d._listeners[c])}return[d]}if("*"===o||"**"===o||d[o]){if("*"===o){for(g in d)"_listeners"!==g&&d.hasOwnProperty(g)&&(i=i.concat(h(b,c,d[g],a+1)));return i}if("**"===o){(o=a+1===m||a+2===m&&"*"===p)&&d._listeners&&(i=i.concat(h(b,c,d,m)));for(g in d)"_listeners"!==g&&d.hasOwnProperty(g)&&("*"===g||"**"===g?(d[g]._listeners&&!o&&(i=i.concat(h(b,c,d[g],m))),i=i.concat(h(b,c,d[g],a))):i=g===p?i.concat(h(b,
c,d[g],a+2)):i.concat(h(b,c,d[g],a)));return i}i=i.concat(h(b,c,d[o],a+1))}(f=d["*"])&&h(b,c,f,a+1);if(d=d["**"])if(a<m)for(g in d._listeners&&h(b,c,d,m),d)"_listeners"!==g&&d.hasOwnProperty(g)&&(g===p?h(b,c,d[g],a+2):g===o?h(b,c,d[g],a+1):(m={},m[g]=d[g],h(b,c,{"**":m},a+1)));else d._listeners?h(b,c,d,m):d["*"]&&d["*"]._listeners&&h(b,c,d["*"],m);return i}var k=Array.isArray?Array.isArray:function(b){return"[object Array]"===Object.prototype.toString.call(b)};a.prototype.delimiter=".";a.prototype.setMaxListeners=
function(a){this._events||b.call(this);this._events.maxListeners=a;this._conf||(this._conf={});this._conf.maxListeners=a};a.prototype.event="";a.prototype.once=function(b,c){this.many(b,1,c);return this};a.prototype.many=function(b,c,d){function a(){0===--c&&i.off(b,a);d.apply(this,arguments)}var i=this;if("function"!==typeof d)throw Error("many only accepts instances of Function");a._origin=d;this.on(b,a);return i};a.prototype.emit=function(){this._events||b.call(this);var a=arguments[0];if("newListener"===
a&&!this.newListener&&!this._events.newListener)return!1;if(this._all){for(var c=arguments.length,d=Array(c-1),l=1;l<c;l++)d[l-1]=arguments[l];l=0;for(c=this._all.length;l<c;l++)this.event=a,this._all[l].apply(this,d)}if("error"===a&&!this._all&&!this._events.error&&(!this.wildcard||!this.listenerTree.error)){if(arguments[1]instanceof Error)throw arguments[1];throw Error("Uncaught, unspecified 'error' event.");}var i;this.wildcard?(i=[],c="string"===typeof a?a.split(this.delimiter):a.slice(),h.call(this,
i,c,this.listenerTree,0)):i=this._events[a];if("function"===typeof i){this.event=a;if(1===arguments.length)i.call(this);else if(1<arguments.length)switch(arguments.length){case 2:i.call(this,arguments[1]);break;case 3:i.call(this,arguments[1],arguments[2]);break;default:c=arguments.length;d=Array(c-1);for(l=1;l<c;l++)d[l-1]=arguments[l];i.apply(this,d)}return!0}if(i){c=arguments.length;d=Array(c-1);for(l=1;l<c;l++)d[l-1]=arguments[l];i=i.slice();l=0;for(c=i.length;l<c;l++)this.event=a,i[l].apply(this,
d);return 0<i.length||this._all}return this._all};a.prototype.on=function(a,c){if("function"===typeof a)return this.onAny(a),this;if("function"!==typeof c)throw Error("on only accepts instances of Function");this._events||b.call(this);this.emit("newListener",a,c);if(this.wildcard){a:{for(var d=a,d="string"===typeof d?d.split(this.delimiter):d.slice(),l=0,i=d.length;l+1<i;l++)if("**"===d[l]&&"**"===d[l+1])break a;l=this.listenerTree;for(i=d.shift();i;){l[i]||(l[i]={});l=l[i];if(0===d.length){l._listeners?
"function"===typeof l._listeners?l._listeners=[l._listeners,c]:k(l._listeners)&&(l._listeners.push(c),l._listeners.warned||(d=10,"undefined"!==typeof this._events.maxListeners&&(d=this._events.maxListeners),0<d&&l._listeners.length>d&&(l._listeners.warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",l._listeners.length),console.trace()))):l._listeners=c;break a}i=d.shift()}}return this}this._events[a]?
"function"===typeof this._events[a]?this._events[a]=[this._events[a],c]:k(this._events[a])&&(this._events[a].push(c),this._events[a].warned||(d=10,"undefined"!==typeof this._events.maxListeners&&(d=this._events.maxListeners),0<d&&this._events[a].length>d&&(this._events[a].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[a].length),console.trace()))):this._events[a]=c;return this};
a.prototype.onAny=function(a){this._all||(this._all=[]);if("function"!==typeof a)throw Error("onAny only accepts instances of Function");this._all.push(a);return this};a.prototype.addListener=a.prototype.on;a.prototype.off=function(a,c){if("function"!==typeof c)throw Error("removeListener only takes instances of Function");var d,b=[];if(this.wildcard)d="string"===typeof a?a.split(this.delimiter):a.slice(),b=h.call(this,null,d,this.listenerTree,0);else{if(!this._events[a])return this;d=this._events[a];
b.push({_listeners:d})}for(var i=0;i<b.length;i++){var g=b[i];d=g._listeners;if(k(d)){for(var f=-1,m=0,o=d.length;m<o;m++)if(d[m]===c||d[m].listener&&d[m].listener===c||d[m]._origin&&d[m]._origin===c){f=m;break}if(0>f)break;this.wildcard?g._listeners.splice(f,1):this._events[a].splice(f,1);0===d.length&&(this.wildcard?delete g._listeners:delete this._events[a])}else if(d===c||d.listener&&d.listener===c||d._origin&&d._origin===c)this.wildcard?delete g._listeners:delete this._events[a]}return this};
a.prototype.offAny=function(a){var c=0,d=0,b;if(a&&this._all&&0<this._all.length){b=this._all;c=0;for(d=b.length;c<d;c++)if(a===b[c]){b.splice(c,1);break}}else this._all=[];return this};a.prototype.removeListener=a.prototype.off;a.prototype.removeAllListeners=function(a){if(0===arguments.length)return!this._events||b.call(this),this;if(this.wildcard)for(var c="string"===typeof a?a.split(this.delimiter):a.slice(),c=h.call(this,null,c,this.listenerTree,0),d=0;d<c.length;d++)c[d]._listeners=null;else{if(!this._events[a])return this;
this._events[a]=null}return this};a.prototype.listeners=function(a){if(this.wildcard){var c=[],a="string"===typeof a?a.split(this.delimiter):a.slice();h.call(this,c,a,this.listenerTree,0);return c}this._events||b.call(this);this._events[a]||(this._events[a]=[]);k(this._events[a])||(this._events[a]=[this._events[a]]);return this._events[a]};a.prototype.listenersAny=function(){return this._all?this._all:[]};"function"===typeof define&&define.amd?define("lib/EventEmitter2",[],function(){return a}):f.EventEmitter2=
a}("undefined"!==typeof process&&"undefined"!==typeof process.title&&"undefined"!==typeof exports?exports:window);define("utils/WCEvent",["lib/EventEmitter2"],function(f){if(!window.WCEvent){var b=window,j=new f({wildcard:!0,delimiter:"."});b.WCEvent={on:function(){j.on.apply(j,arguments)},emit:function(){j.emit.apply(j,arguments)}}}return window.WCEvent});
define("component/actionbuttons/AbstractButton",["jquery","underscore","doctablex/DocTableXUtils","doctablex/AJAXDataCache"],function(f,b,j,a){j=function(a,b){this.btnCtx=null;b&&(this.btnCtx=b);this.baseUrl=window.webcenterConfig.jspBaseUrl||"./";this.loaded=!1;this.afterLoadCallbacks=[];this.docVerId=a;this.isVisible=!1;this.loadDocumentInfo()};j.prototype.loadDocumentInfo=function(){if(this.docVerId){var h=a.getInstance().getDocInfoWithThumbnail(this.docVerId);f.when(h).done(b.bind(function(a){this.loaded=
!0;this.updateDocumentInfo(a);this.render();if(0<this.afterLoadCallbacks.length){for(a=0;a<this.afterLoadCallbacks.length;a++)this.afterLoadCallbacks[a]();this.afterLoadCallbacks=[]}},this))}};j.prototype.render=function(){this.renderBtn(this.btnCtx)};j.prototype.renderBtn=function(a){a&&(this.loaded?(a.empty(),this.isVisible&&this._renderBtnImpl(a)):this.afterLoadCallbacks.push(b.bind(this.renderBtn,this,a)))};j.prototype._renderBtnImpl=function(){};j.prototype.openInNewTab=function(a){a=window.open(a,
"_blank");null!=a&&a.focus()};j.prototype.setBtnContext=function(a){this.btnCtx=a;this.render()};j.prototype.updateDocumentInfo=function(){};return j});
define("tpl",["underscore"],function(f){var b={};return{load:function(b,a,h){f.templateSettings.variable="d";a.toUrl(b+".tpl.html");a(["lib/text!"+b+".tpl.html","underscore"],function(a,b){var c=b.template(a);h(c)})},write:function(j,a,h){if(a in b){var k=f.template("define('<%-d.pluginName%>!<%=d.moduleName%>', function(){return <%=d.func%>});");h(k({pluginName:j,moduleName:a,func:b[a]}))}}}});
define("tpl!component/actionbuttons/InlineUploadNewVersionBlock",function(){return function(f){var b,j;j=""+('<input type="hidden" name="originalDocVersionID" value="'+(null==(b=f.docVerId)?"":_.escape(b))+'" />\r\n<input type="hidden" name="docName_'+(null==(b=f.docVerId)?"":_.escape(b))+'" value="'+(null==(b=f.docName)?"":_.escape(b))+'" />\r\n<input type="hidden" name="docID_'+(null==(b=f.docVerId)?"":_.escape(b))+'" value="'+(null==(b=f.docId)?"":_.escape(b))+'" />\r\n<div style="float:left;">\r\n\t<table width="100%">\r\n\t\t<tr>\r\n\t\t\t<td width="1px" class="darktext_darklink_11">\r\n\t\t\t\t<span class="nobr">'+
(null==(b=f.i18n("CHECKINNEWVERWITHCOMMENT"))?"":_.escape(b))+':<span class="esko-green">*</span>&nbsp;</span>\r\n\t\t\t</td>\r\n\t\t\t<td width="1px">\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t<input size="30" type="file" name="newVersionDocFile_'+(null==(b=f.docVerId)?"":_.escape(b))+'" class="datafield" />\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t</td>\r\n\t\t\t<td align="left">\r\n\t\t\t\t<input  size="50" type="text" name="newVersionDocDesc_'+(null==(b=f.docVerId)?"":_.escape(b))+'" value="'+(null==(b=f.formdata.newVersionDocDesc)?
"":_.escape(b))+'" class="datafield" />\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\r\n\t\t<\!-- Raise revision checkbox --\>\r\n\t  \t<\!-- only show this HTML control if the setting is enabled --\>\r\n\t  \t');f.allowRaiseRevision&&(j+='\r\n\t  \t  \t<tr>\r\n\t\t\t\t<td align="left" nowrap="nowrap" class="darktext_darklink_bold_12" style="padding-top: 10px;">\r\n\t\t\t\t\t'+(null==(b=f.i18n("REVISION"))?"":_.escape(b))+':\r\n\t\t\t\t</td>\r\n\t\t\t\t<td class="darktext_darklink_11" style="padding-top: 10px;">\r\n\t\t\t\t\t<label>\r\n\t\t\t\t\t\t<input class="datafield" style="position: relative; vertical-align: middle; bottom: 1px;" type="checkbox" value="true" name="incrementRevision_'+
(null==(b=f.docVerId)?"":_.escape(b))+'" '+(null==(b=f.incrementRevision?'checked="checked"':"")?"":_.escape(b))+"/>\r\n\t\t\t\t\t\t"+(null==(b=f.i18n("INCREMENT_TO"))?"":_.escape(b))+"&nbsp;\r\n\t\t\t\t\t\t\t<b>\r\n\t\t\t\t\t\t\t\t"+(null==(b=f.i18n("REVISION"))?"":_.escape(b))+"&nbsp;"+(null==(b=f.lastRevision)?"":_.escape(b))+"\r\n\t\t\t\t\t\t\t</b>\r\n\t\t\t\t\t</label>\r\n\t\t\t\t</td>\r\n\t\t\t</tr>\r\n\t  \t");j+="\r\n\t\t\r\n\t\t\r\n\t\t<\!-- Show the 'update related projects' checkbox if needed --\>\r\n\t\t";
1<f.projectList.length&&!f.alwayUpdateAllProject&&(j+='\r\n\t\t<tr>\r\n\t\t\t<td >\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(b=f.baseUrl)?"":_.escape(b))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td colspan="2" class="darktext_darklink_11">\r\n\t\t\t\t'+(null==(b=f.i18n("PROJ_TASK_DOC_MULPROJ"))?"":_.escape(b))+'\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td >\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(b=f.baseUrl)?"":_.escape(b))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\r\n\t\t<tr>\r\n\t\t\t<td  colspan="2" class="darktext_darklink_11">\r\n\t\t\t\t<input  type="checkbox" '+
(null==(b=!1===f.updateAllProjects?"":'checked="checked"')?"":_.escape(b))+' class="datafield" name="updateAllProjects_'+(null==(b=f.docVerId)?"":_.escape(b))+'" style="position: relative; vertical-align: middle; bottom: 1px;"/>\r\n\t\t\t\t'+(null==(b=f.i18n("PROJ_TASK_DOC_MULPROJ_UPDATEALL"))?"":_.escape(b))+"\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t");j+='\r\n\t\t\r\n\t\t<tr>\r\n\t\t\t<td height="10">\r\n\t\t\t\t<img width="1" height="1" src="'+(null==(b=f.baseUrl)?"":_.escape(b))+'images/clearpixel.gif" />\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t\r\n\t\t<\!-- APPROVAL --\>\r\n\t\t';
f.approvalRestartEnableCheckbox||(j+='\r\n\t\t\t<\!-- set the default value input field --\>\r\n\t\t\t<tr><td><input type="hidden"  name="startApprovalDefaultValue'+(null==(b=f.docVerId)?"":_.escape(b))+'" id="'+(null==(b=f.idprefix)?"":_.escape(b))+"startApprovalDefaultValue"+(null==(b=f.docVerId)?"":_.escape(b))+'"\r\n\t\t\t\tvalue="'+(null==(b=f.initialStartApprovalValue?"1":"0")?"":_.escape(b))+'"></input>\t</td></tr>\t\r\n\t\t');j+="\r\n\t\t\r\n\t\t";if(2>f.projectList.length){j+=" <\!-- not linked --\>\r\n\t\t\t";
if(f.approvalCycleState){j+="\r\n\t\t\t\t";if("cycle_started"==f.approvalCycleState||"cycle_stopped"==f.approvalCycleState||"cycle_finished"==f.approvalCycleState)j+='\r\n\t\t  \t\t\t<tr id="'+(null==(b=f.idprefix)?"":_.escape(b))+"approvalCheckBox"+(null==(b=f.docVerId)?"":_.escape(b))+'">\r\n\t\t  \t\t\t\t<td class="darktext_darklink_11">&nbsp;</td>\r\n\t\t\t    \t  \t<td class="darktext_darklink_11" valign="top" colspan="2">\r\n\t\t\t    \t  \t\t',j=f.approvalRestartEnableCheckbox?j+('\r\n\t\t\t    \t  \t\t\t<\!-- show checkbox --\>\r\n\t\t\t    \t  \t\t\t<input type="checkbox" name="AppCycleFlag'+
(null==(b=f.docVerId)?"":_.escape(b))+'" id="'+(null==(b=f.idprefix)?"":_.escape(b))+"AppCycleFlag"+(null==(b=f.docVerId)?"":_.escape(b))+'" class="datafield"\r\n\t\t\t    \t  \t\t\t\t'+(null==(b=!0===f.AppCycleFlag||!1!==f.AppCycleFlag&&f.initialStartApprovalValue?' checked="checked"':"")?"":_.escape(b))+' ></input>\r\n\t\t\t  \t\t\t\t\t<img src="'+(null==(b=f.baseUrl)?"":_.escape(b))+'images/clearpixel.gif" width="10" height="1"/>\r\n\t\t\t  \t\t\t\t\t'+(null==(b=f.i18n("DOCCHECKINAPPROVALCYCLE_TAG"))?
"":_.escape(b))+"\r\n\t\t\t    \t  \t\t"):j+("\r\n\t\t\t    \t  \t\t\t<\!-- CheckBox is not enabled, only show a feedback string --\>\r\n\t\t\t    \t  \t\t\t"+(null==(b=f.initialStartApprovalValue?f.i18n("APPROVAL_WILL_AUTO_START"):f.i18n("APPROVAL_WILL_NOT_AUTO_START"))?"":_.escape(b))+"\r\n\t\t\t    \t  \t\t"),j+="\r\n\t\t  \t\t\t\t</td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t\r\n\t\t\t\t\t<\!-- show calendar --\>\r\n\t\t\t\t\t","1"==f.showDueDate&&(j+='\r\n\t\t\t\t\t\t<tr><td height="5"><img src="'+(null==
(b=f.baseUrl)?"":_.escape(b))+'images/clearpixel.gif" width="1" height="10"/></td></tr>   \r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td/>\r\n\t\t\t\t\t\t\t<td class="darktext_darklink_11" align="left" valign="middle" colspan="2">\r\n\t\t\t\t\t\t\t\t<table>\r\n\t\t\t\t\t\t\t\t\t<tr colspan="3" id="'+(null==(b=f.idprefix)?"":_.escape(b))+"approvalDueDate"+(null==(b=f.docVerId)?"":_.escape(b))+'">\r\n\t\t\t\t\t\t\t\t\t\t<td class="darktext_darklink_11" align="left">\t\r\n\t\t\t\t\t\t  \t\t\t\t\t<\!-- specify new due date --\>\r\n\t\t\t\t\t\t    \t  \t\t\t'+
(null==(b=f.i18n("NEW_DUEDATE"))?"":_.escape(b))+':&nbsp;\r\n\t\t\t\t\t\t\t   \t  \t\t</td>\r\n\t\t\t\t\t\t\t    \t  \t<td class="darktext_darklink_11" valign="top" nowrap="nowrap">\r\n\t\t\t\t\t\t\t\t    \t  \t<\!-- due date controls --\>\r\n\t\t\t\t\t\t\t\t\t\t\t<table border="0" cellspacing="0" cellpadding="0" >\r\n\t\t\t\t\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<input type="hidden" name="due_date'+(null==(b=f.docVerId)?"":_.escape(b))+'" size="10" id="'+
(null==(b=f.idprefix)?"":_.escape(b))+"due_date"+(null==(b=f.docVerId)?"":_.escape(b))+'" readonly="readonly" value="'+(null==(b=f.dueDateH1)?"":_.escape(b))+'" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t \t<input type="hidden" name="save_due_date'+(null==(b=f.docVerId)?"":_.escape(b))+'" size="10" id="'+(null==(b=f.idprefix)?"":_.escape(b))+"save_due_date"+(null==(b=f.docVerId)?"":_.escape(b))+'" value="'+(null==(b=f.dueDateH2)?"":_.escape(b))+'" />\r\n\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<\!--Put new calendar there --\>\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t \t<input class="filter datafield" value="'+
(null==(b=f.dueDate)?"":_.escape(b))+'" type="text" name="longFormat_due_date'+(null==(b=f.docVerId)?"":_.escape(b))+'" size="20" id="'+(null==(b=f.idprefix)?"":_.escape(b))+"longFormat_due_date"+(null==(b=f.docVerId)?"":_.escape(b))+'" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<a target="_self" href="#" onclick="javascript:$(\'#'+(null==(b=f.idprefix)?"":_.escape(b))+"longFormat_due_date"+(null==(b=f.docVerId)?"":_.escape(b))+'\')[0].focus(); return false;">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<img height="15" src="'+
(null==(b=f.baseUrl)?"":_.escape(b))+'images/show-calendar.gif"  width="24" border="0" />\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</a>\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t    \t\t<script type="text/javascript">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t$(function() {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$("#'+(null==(b=f.idprefix)?"":_.escape(b))+"longFormat_due_date"+(null==(b=f.docVerId)?"":_.escape(b))+'").datepicker({dateFormat: "M dd, yy", \r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tonClose: function(dateText, inst) {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar element = $("#'+
(null==(b=f.idprefix)?"":_.escape(b))+"due_periodOfDay"+(null==(b=f.docVerId)?"":_.escape(b))+'")[0];\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tif(element && element.selectedIndex == 0){\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\telement.selectedIndex = (36 + 1);\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar dateVal = dateText;\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tif (dateText != \'\')\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t{\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tvar date = new Date(dateText);\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\tdateVal = formatDate(date, "MM/dd/yyyy");\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t$("#'+
(null==(b=f.idprefix)?"":_.escape(b))+"due_date"+(null==(b=f.docVerId)?"":_.escape(b))+'").val(dateVal);\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t}\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t});\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t});\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<\/script>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<style type="text/css">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    #ui-datepicker-div\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    {\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t        z-index: 9999999;\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    }\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</style>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td><img src="'+
(null==(b=f.baseUrl)?"":_.escape(b))+'images/clearpixel.gif" width="5" height="1"/></td>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t<td>\t\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t<input type="hidden" name="save_due_periodOfDay'+(null==(b=f.docVerId)?"":_.escape(b))+'" size="10" id="'+(null==(b=f.idprefix)?"":_.escape(b))+"save_due_periodOfDay"+(null==(b=f.docVerId)?"":_.escape(b))+'" value="0"/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t    <select name="due_periodOfDay'+(null==(b=f.docVerId)?"":_.escape(b))+'" id="'+(null==(b=f.idprefix)?
"":_.escape(b))+"due_periodOfDay"+(null==(b=f.docVerId)?"":_.escape(b))+'" class="datafield">\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="-1">---</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t     \t <option value="0" >00:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="1" >00:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="2" >01:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="3" >01:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="4" >02:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="5" >02:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="6" >03:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="7" >03:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="8" >04:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="9" >04:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="10">05:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="11">05:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="12">06:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="13">06:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="14">07:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="15">07:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="16">08:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="17">08:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="18">09:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="19">09:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="20">10:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="21">10:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="22">11:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="23">11:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="24">12:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="25">12:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="26">13:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="27">13:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="28">14:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="29">14:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="30">15:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="31">15:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="32">16:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="33">16:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="34">17:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="35">17:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="36">18:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="37">18:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="38">19:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="39">19:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="40">20:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="41">20:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="42">21:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="43">21:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="44">22:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="45">22:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="46">23:00</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t     <option value="47">23:30</option>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t   </select>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t\t\t  \t</tr>\r\n\t\t\t\t\t\t\t\t\t\t\t</table>\t\r\n\t\t\t\t\t\t\t    \t  \t</td>\t    \t  \t\r\n\t\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t</table>\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t</tr> \t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t'),
j+=" \r\n\t\t\t\t";j+="\r\n\t\t\t"}j+="\r\n\t\t"}return j+='\t\r\n\t</table>\r\n</div>\r\n<div align="center" valign="middle" width="25" style="float:right;">\r\n\t<a href="#" onclick="return false;">\r\n\t\t<img src="'+(null==(b=f.baseUrl)?"":_.escape(b))+'images/delete_icon_15.png" class="remove" title="'+(null==(b=f.i18n("DELETE_TAG"))?"":_.escape(b))+'" width="15" height="15"/>\r\n\t</a>\r\n</div>'}});
define("component/actionbuttons/UploadNewVersionButton","component/actionbuttons/AbstractButton Template tpl!component/actionbuttons/InlineUploadNewVersionBlock jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils utils/WCEvent".split(" "),function(f,b,j,a,h,k,e,c,d){var l=function(d,a,c,e){this.isExpanded=!1;this.rowCtx=null;this.currentUser=c;this.currentUser||(this.currentUser=gCurrentUser);e&&(this.useInlineForm=e.useInlineForm);this.useInlineForm?
(this.t=new b(k,j),this.t.d.formdata={},this.t.bind("click","img.remove",this.clearRow,this),this.t.bind("change",".datafield",h.bind(this.storeFormData,this))):this.t={d:{}};e&&(e.alwaysUpdateAllProjects&&(this.t.d.alwaysUpdateAllProjects=!0),this.useInlineForm=e.useInlineForm,this.t.d.idprefix=e.uniqueIdPrefix?e.uniqueIdPrefix:"");f.call(this,d,a)};l.prototype=Object.create(f.prototype);l.prototype.constructor=l;l.prototype.loadDocumentInfo=function(){if(this.docVerId){var d=e.getInstance().getDocInfoWithThumbnail(this.docVerId),
c=null;this.useInlineForm&&(c=e.getInstance().getGlobalDocumentSettings());a.when(c,d).done(h.bind(function(d,a){this.loaded=!0;this.updateDocumentInfo(a,d);this.render();if(0<this.afterLoadCallbacks.length){for(var c=0;c<this.afterLoadCallbacks.length;c++)this.afterLoadCallbacks[c]();this.afterLoadCallbacks=[]}},this))}};l.prototype.render=function(){this.renderBtn(this.btnCtx);this.isExpanded&&this.rowCtx&&(this.t.render(),this.fileField&&this.rowCtx.find("input[name^=newVersionDocFile_]").replaceWith(this.fileField),
this.t.d.duePeriod&&this.rowCtx.find("select[name^=due_periodOfDay]").val(this.t.d.duePeriod))};l.prototype._renderBtnImpl=function(d){var c=a('<img src="'+this.baseUrl+'images/round_button_upload.png" />');c.attr("alt",k.t("DOCDETAILSCHECKIN_TAG"));c.attr("title",k.t("DOCDETAILSCHECKIN_TAG"));c.addClass("actionBtn");var b=a('<a href="#"></a>');b.append(c);b.click(h.bind(function(){this.btnClicked();return!1},this));d.append(b)};l.prototype.btnClicked=function(){if(this.useInlineForm)this.isExpanded=
!0,this.render(),d.emit("btnClicked.UploadNewVersion."+this.docVerId);else{var a=c.getMenuFileParamValue(),a=window.open(this.baseUrl+"dodocdetailsactions.jsp?actionVal=DirectCheckinDoc&docVerID="+this.docVerId+"&menu_file="+a,"_blank");null!=a&&a.focus()}};l.prototype.clearRow=function(){this.rowCtx.empty();this.isExpanded=!1};l.prototype.revisionLetters="ABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");l.prototype.getRevisionLetter=function(d){var a="";if(d&&!isNaN(d)){for(;d>this.revisionLetters.length;)a+=
this.revisionLetters[this.revisionLetters.length-1],d-=this.revisionLetters.length;0<d&&(a+=this.revisionLetters[d-1])}else a+=this.revisionLetters[0];return a};l.prototype.setRowContext=function(d){this.rowCtx=d;this.t.setContext(d);this.render()};l.prototype.storeFormData=function(){this.fileField=this.rowCtx.find("input[name^=newVersionDocFile_]");this.t.d.formdata.newVersionDocDesc=this.rowCtx.find("input[name^=newVersionDocDesc_]").val();this.t.d.incrementRevision="checked"==this.rowCtx.find("input[name^=incrementRevision_]").attr("checked");
this.t.d.updateAllProjects="checked"==this.rowCtx.find("input[name^=updateAllProjects_]").attr("checked");this.t.d.AppCycleFlag="checked"==this.rowCtx.find("input[name^=AppCycleFlag]").attr("checked");this.t.d.dueDate=this.rowCtx.find("input[name^=longFormat_due_date]").val();this.t.d.dueDateH1=this.rowCtx.find("input[name^=due_date]").val();this.t.d.dueDateH2=this.rowCtx.find("input[name^=save_due_date]").val();this.t.d.duePeriod=this.rowCtx.find("select[name^=due_periodOfDay]").val()};l.prototype.updateDocumentInfo=
function(d,a){this.t.d.docVerId=this.docVerId;this.t.d.docId=d.docID;this.t.d.docName=d.docName;this.t.d.projectList=d.projList;var c=null;try{c=parseInt(d.docRevIdx)}catch(b){c=0}this.t.d.lastRevision=this.getRevisionLetter(c+1);d.appStatus&&(this.t.d.approvalCycleState=d.appStatus.cycleStatusStringCode);this.t.d.showDueDate=d.userPerms.changeApp?"1":"0";if(!d.docIsUrl&&!("00001_0000000014"==d.docTypeID&&d.docSourceId)&&(!d.docCheckedOutOwner||d.docCheckedOutOwner==this.currentUser.userID)&&(d.userPerms.isProjMgr||
d.userPerms.checkout))this.isVisible=!0;a&&(c=a.approvalRestartOption,this.t.d.initialStartApprovalValue="1"==c?!0:"2"==c?!1:"cycle_started"==a.approvalCycleState||"cycle_finished"==a.approvalCycleState?!0:!1,this.t.d.allowRaiseRevision="1"==a.allowRaiseRevision,this.t.d.approvalRestartEnableCheckbox=a.approvalRestartUploaderCanOverrule);this.t.d.baseUrl=this.baseUrl};l.prototype.validate=function(){var d=[];if(this.isExpanded){var b=this.rowCtx.find("input[name^=newVersionDocFile_]"),e=b.val();e?
c.getFileExtension(e)!=c.getFileExtension(this.t.d.docName)&&(b={isBlocking:!0,msg:k.t("BADCHECKINEXT"),element:b},d.push(b)):(b={isBlocking:!0,msg:k.t("DocRowFileNotChosen"),element:b},d.push(b));b=this.rowCtx.find("input[name^=newVersionDocDesc_]");a.trim(b.val())||(b={isBlocking:!0,msg:k.t("DOCDETAILSCHECKINCOMMENT_TAG"),element:b},d.push(b))}return d};l.wcrinit=function(d){var c=a(d).attr("data-docverid"),b=a(d).attr("data-inlinectx"),e=a(d).attr("data-inline");(new l(c,a(d),window.gCurrentUser,
{useInlineForm:"true"==e})).setRowContext(a("#"+b))};return l});
define("component/actionbuttons/ViewButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/DocTableXUtils doctablex/AJAXDataCache".split(" "),function(f,b,j,a,h){var k=function(a,c){f.call(this,a,c)};k.prototype=Object.create(f.prototype);k.prototype.constructor=k;k.prototype._renderBtnImpl=function(e){var c=b('<img src="'+this.baseUrl+'images/viewmag.png" />');c.attr("alt",a.t("CLICK_HERE_TO_VIEW"));c.attr("title",a.t("CLICK_HERE_TO_VIEW"));c.addClass("actionBtn");
var d=b("<a></a>");d.attr("href","#");d.append(c);d.click(j.bind(function(){this.openViewer();return!1},this));e.append(d)};k.prototype.openViewer=function(){var a=h.getMenuFileParamValue(),c=h.getSourcePageURLEncoded();this.openInNewTab(this.baseUrl+"viewdocument.jsp?docVerID="+this.docVerId+"&menu_file="+a+"&pageIndex=0&sourcePage="+c)};k.prototype.updateDocumentInfo=function(a){this.isVisible=a.userPerms.view&&!a.docIsUrl};k.wcrinit=function(a){var c=b(a).attr("data-docverid");new k(c,b(a))};return k});
define("component/actionbuttons/DownloadButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(f,b,j,a,h,k){var e=function(a,d){this.downloadType="none";f.call(this,a,d)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype._renderBtnImpl=function(c){var d=b('<img src="'+this.baseUrl+'images/round_button_download.png" />');d.attr("alt",a.t("DOWNLOAD"));d.attr("title",
a.t("DOWNLOAD"));d.addClass("actionBtn");var e=j.bind(function(){"pespective"==this.downloadType?this.showDownloadPerspectives():"locked"==this.downloadType?confirm(a.t("CHECKED_OUT_DOWNLOAD_WARNING"))&&this.downloadDocument():(this.downloadType="download")&&this.downloadDocument();return!1},this),i=b('<a href="#"></a>');i.click(e);i.append(d);c.append(i)};e.prototype.downloadDocument=function(){var a=k.getSourcePageURLEncoded();window.location=this.baseUrl+"doprojectdocsactions.jsp?actionVal=DownloadDoc&actionDocVerID="+
this.docVerId+"&projectID="+this.projectId+"&sourcePage="+a};e.prototype.showDownloadPerspectives=function(){var c=h.getInstance().getDocDownloadPerspectives(this.docVerId,this.docTypeId);b.when(c).done(j.bind(function(d){if(null==d)alert(a.t("UNABLETOGETFORMATSFORDOWNLOAD"));else if(0==d.length)alert(a.t("NOFORMATSFORFILETYPE"));else{this.popupContent=b("<div />");for(var c=0;c<d.length;c++){var e=d[c].name,g=d[c].longName;"Native"===e&&(e=a.t("NATIVE_PERSPECTIVE_NAME"),g="");var f=b('<input type="radio" name="selectedDownloadFormat"/>');
f.val(g);this.popupContent.append(f).append("&nbsp;"+e+"<br/>")}this.showDialog()}},this))};e.prototype.showDialog=function(){if(this.popupContent){var c={};c[a.t("CLOSE")]=j.bind(function(){this.popupContent.dialog("close")},this);c[a.t("DOWNLOAD")]=j.bind(function(){this.downloadPerspective()&&this.popupContent.dialog("close")},this);this.popupContent.dialog({autoOpen:!1,dialogClass:"no-close",modal:!0,title:a.t("SELFORMAT_NOTREDUNDANT"),position:"center",buttons:c}).dialog("open")}};e.prototype.downloadPerspective=
function(){var c=this.popupContent.find("input:checked");if(1!=c.length)return alert(a.t("ONEFORMATHASTOBESELECTEDTOPERFORMDOWNLOAD")),!1;window.location=this.baseUrl+"dodocdetailsactions.jsp?actionVal=DoDownloadPerspective&docVerID="+this.docVerId+"&perspectiveName="+c.val();return!0};e.prototype.updateDocumentInfo=function(a){this.docTypeId=a.docTypeID;0<a.projList.length&&(this.projectId=a.projList[0].id);a.userPerms.download&&!a.docIsUrl&&(this.downloadType="00001_0000000001"==a.docTypeID||"00001_0000000002"==
a.docTypeID||"00001_0000000018"==a.docTypeID?"pespective":a.docCheckedOutOwner?"locked":"download");this.isVisible="none"!=this.downloadType};e.wcrinit=function(a){var d=b(a).attr("data-docverid");new e(d,b(a))};return e});
define("component/actionbuttons/Open3DButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(f,b,j,a,h,k){var e=function(a,d){f.call(this,a,d)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype._renderBtnImpl=function(c){var d=b('<img src="'+this.baseUrl+'images/view3d.png" />');d.attr("alt",a.t("CLICK_HERE_TO_VIEW_3D"));d.attr("title",a.t("CLICK_HERE_TO_VIEW_3D"));
d.addClass("actionBtn");var e=j.bind(function(){this.openDocument3D();return!1},this),i=b('<a href="#"></a>');i.click(e);i.append(d);c.append(i)};e.prototype.openDocument3D=function(){var a=k.getMenuFileParamValue(),d=k.getSourcePageURLEncoded();this.openInNewTab(this.baseUrl+"doctypecolladaview.jsp?docVerID="+this.docVerId+"&menu_file="+a+"&sourcePage="+d)};e.prototype.updateDocumentInfo=function(a){this.isVisible="1"==a.has3dView};e.wcrinit=function(a){var d=b(a).attr("data-docverid");new e(d,b(a))};
return e});
define("component/actionbuttons/OpenACADButton","component/actionbuttons/AbstractButton jquery underscore utils/webi18n!ActionBtnStrings doctablex/AJAXDataCache doctablex/DocTableXUtils".split(" "),function(f,b,j,a,h,k){var e=function(a,d){f.call(this,a,d)};e.prototype=Object.create(f.prototype);e.prototype.constructor=e;e.prototype.loadDocumentInfo=function(){if(this.docVerId){var a=h.getInstance().getGlobalDocumentSettings(),d=h.getInstance().getDocInfoWithThumbnail(this.docVerId);b.when(a,d).done(j.bind(function(d,
a){this.loaded=!0;this.updateDocumentInfo(a,d);this.render();if(0<this.afterLoadCallbacks.length){for(var c=0;c<this.afterLoadCallbacks.length;c++)this.afterLoadCallbacks[c]();this.afterLoadCallbacks=[]}},this))}};e.prototype._renderBtnImpl=function(c){var d=b('<img src="'+this.baseUrl+'images/open_acad.png" />');d.attr("alt",a.t("DOCOPENINACAD"));d.attr("title",a.t("DOCOPENINACAD"));d.addClass("actionBtn");var e="",i=j.bind(function(){if("Standard"===this.openType){var d=k.getMenuFileParamValue();
e=this.baseUrl+"doctypeotherview.jsp?docVerID="+this.docVerId+"&menu_file="+d}else"Enterprise"===this.openType&&(e=encodeURI("acade:@"+this.projectName+":"+this.docName));j.defer(function(){window.location=e});return!1},this),g=b('<a href="#"></a>');g.click(i);g.append(d);c.append(g)};e.prototype.updateDocumentInfo=function(a,d){this.docName=a.docName;0<a.projList.length&&(this.projectName=a.projList[0].name);if(a.userPerms.download&&("00001_0000000001"==a.docTypeID||"00001_0000000002"==a.docTypeID||
"00001_0000000003"==a.docTypeID))this.openType=d.openCadType;this.isVisible=this.openType&&"None"!==this.openType};e.wcrinit=function(a){var d=b(a).attr("data-docverid");new e(d,b(a))};return e});
define("doctablex/StaticDocumentRowView","doctablex/DocTableXUtils utils/WCEvent wcr/webcenter_xml wcr/webcenter_html jquery wcr/ObjectArrayCloneUtil component/actionbuttons/UploadNewVersionButton component/actionbuttons/ViewButton component/actionbuttons/DownloadButton component/actionbuttons/Open3DButton component/actionbuttons/OpenACADButton utils/webi18n!DocRefStrings wcr/extpopup wcr/approvalInfoPopup".split(" "),function(f,b,j,a,h,k,e,c,d,l,i,g){var n=function(d,a,c){if(!d&&!a&&!c)return this;
this.dm=d;if(!this.dm)return alert("Cannot initialized view without data model."),null;this.phElemID=a;this.rowIndex=-1;this.renderOptions=c;this.renderOptions||(this.renderOptions=this.dm.renderOptions);this.supportAdvancedThumb=c.supportAdvancedThumb;!this.supportAdvancedThumb&&!1!==this.supportAdvancedThumb&&(this.supportAdvancedThumb=!1,this.constructor==n.prototype.constructor&&(this.supportAdvancedThumb=!0));this.itemRootElemStr=this.renderOptions.itemRootElemStr||"td";this.renderMethodMap=
{AttributeFlapout:this.renderExpandCollapseButton,UpDownArrows:this.renderSortingArrows,SequenceNumber:this.renderSequenceNumber,DocumentName:this.renderDocumentSpec,DocumentActions:this.renderDocumentActions,DocumentProperty_Thumbnail:this.renderThumbnail,DocumentProperty_Description:this.renderDocumentDescription,DocumentProperty_ApprovalStatus:this.renderApprovalStatus,DocumentProperty_ApprovalStage:this.renderApprovalStage,DocumentProperty_Project:this.renderDocProjectName,DocumentProperty_VersionRevision:this.renderDocumentVersion,
DocumentProperty_VersionAuthor:this.renderDocumentAuthor,DocumentProperty_ModifiedDate:this.renderDocumentModifiedDate,ReferenceProperty:this.renderReferenceProperty,DocumentAttribute:this.renderDocAttribute,LocalRemote:this.renderLocalRemoteButton,DeleteButton:this.renderDeleteButton};this._newVersionCell=this._newVersionRow=this.newVersionBtn=this.openAcadBtn=this.open3dBtn=this.downloadBtn=this.viewBtn=null;return this};n.prototype.render=function(d){var a=h("#"+this.phElemID);if(0==a.length)return a;
var c=this.renderOptions;d&&(this.renderOptions=d);this.rowIndex=this.dm.getIndexInTable();"list"==this.renderOptions.renderMethod?this.renderSimple(a):"table"==this.renderOptions.renderMethod?this.renderComplex(a):alert("Not supported render method: "+this.renderOptions.renderMethod+".");this.renderOptions=c;this.renderOptions.styleObj&&a.find("*").not(".darktext_greenlink_12_bold").not(".darktext_greenlink_11").css(this.renderOptions.styleObj);return a};n.prototype.repaintRow=function(){this.renderOptions.isRepaintRow=
!0;this.render();this.renderOptions.isRepaintRow=!1};n.prototype.renderSimple=function(d){if(!d||0==d.length)return d;try{if(d.html(""),this.renderDocAttrCatAndRefPropsPlaceholder(d),this.renderNewVersionPlaceholder(d),this.renderSortingArrows(d),this.renderThumbnail(d,{thumbnailSize:50}),this.renderDocumentSpec(d),this.renderDeleteButton(d),!this.dm.getParentDocTable().allowMultiple&&this.constructor==n){var a="<"+this.itemRootElemStr+' class="darktext_greenlink_11">',c=this.dm.getParentDocTable().view,
a=a+c.renderGreenLinksPlaceholder("inline"),a=a+("</"+this.itemRootElemStr+">");if(0<h(a).appendTo(d).length){var b=this.dm.getParentDocTable(),e=b.getDocumentSourceOptions(b.greenLinksPrefix+"_inline");b.dshObj.displayLinks(e)}}}catch(g){return f.log("Problem in StaticDocumentRowView.renderSimple:\n"+g),null}return d};n.prototype.renderComplex=function(d){if(!d||0==d.length)return d;try{d.html("");this.renderDocAttrCatAndRefPropsPlaceholder(d);this.renderNewVersionPlaceholder(d);var a=this.renderOptions.columns;
if(a)for(var c=0;c<a.length;c++){var b=this.renderOptions.columns[c];if(b){var e=b.type;"DocumentProperty"==e&&(e+="_"+b.typeDetail);var g=this.renderMethodMap[e];g&&g.call(this,d,b)}}var i=d.find(">td").size()-1;h("#"+this.dm.aCatRowID+" > td.attrCategoryColumn").attr("colspan",i)}catch(l){return f.log("Problem in StaticDocumentRowView.renderComplex:\n"+l),null}return d};n.prototype.renderExpandCollapseButton=function(d){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">');if(!this.dm.isInErrorStatus())var c=
this.dm.getThisInDOM()+".expandClicked(this); return false;",b=this.dm.hasAttrCat()?"":" hiddenElement",a=a+('<a class="btn btn16 expandCollapseButton '+b+'" href="#" onclick="'+c+'">'),a=this.dm.dependsOnItself?a+('<i class="cycle" title="'+j.xmlencode(g.t("DocRowCyclicDepTooltip"))+'"></i>'):this.dm.aCatExpanded?a+('<i class="collapse" title="'+j.xmlencode(g.t("DocRowCollapseTooltip"))+'"></i>'):a+('<i class="expand" title="'+j.xmlencode(g.t("DocRowExpandTooltip"))+'"></i>'),a=a+"</a>";a+="</"+
this.itemRootElemStr+">";d.append(a)}catch(e){f.log("Problem in StaticDocumentRowView.renderExpandCollapseButton:\n"+e)}};n.prototype.renderSortingArrows=function(d){try{var a="";if(this.dm.isEditable){var a=a+("<"+this.itemRootElemStr+">"),c=this.dm.getParentInDOM()+".moveUpButtonClicked("+this.rowIndex+");return false;",b=this.dm.getParentInDOM()+".moveDownButtonClicked("+this.rowIndex+");return false;",e=0==this.rowIndex,g=this.rowIndex==this.dm.getParentDocTable().getNumberOfRows()-1;e&&!g?a+=
'<a class="btn btn9x14 float-right" href="#" onclick="'+b+'"><i class="sort-down"></i></a>':g&&!e?a+='<a class="btn btn9x14 float-right" href="#" onclick="'+c+'"><i class="sort-up"></i></a>':!e&&!g&&(a+='<div class="float-right">',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+c+'"><i class="sort-asc"></i></a><br/>',a+='<a class="btn btn9x14 float-right" href="#" onclick="'+b+'"><i class="sort-desc"></i></a>',a+="</div>");a+="</"+this.itemRootElemStr+">"}d.append(a)}catch(i){f.log("Problem in StaticDocumentRowView.renderSortingArrows:\n"+
i)}};n.prototype.renderSequenceNumber=function(d){try{var a="",a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+("<span>"+(this.rowIndex+1)+"</span>"),a=a+("</"+this.itemRootElemStr+">");d.append(a)}catch(c){f.log("Problem in StaticDocumentRowView.renderSequenceNumber:\n"+c)}};n.prototype.renderThumbnail=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+">");if(!this.dm.isInErrorStatus())var b=this.dm.thumbnailURL,c=b&&0<b.length?c+this.customThumbnailHTML(b,a.thumbnailSize):c+'<div class="thumb"></div>';
c+="</"+this.itemRootElemStr+">";d.append(c)}catch(e){f.log("Problem in StaticDocumentRowView.renderThumbnail:\n"+e)}};n.prototype.renderDocumentSpec=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+">"),c=c+this.renderInlineLabel(a);if(this.dm.isInErrorStatus()){c+='<span class="brokenDocRef">';this.dm.docName&&(c+=j.xmlencode(this.dm.docName)+"&nbsp;&nbsp;");var b=j.xmlencode(g.t("DocRowCannotLoadDoc")),c=c+('<img border="0" src="'+window.webcenterConfig.jspBaseUrl+'images/warning.gif" title="'+
b+'"/>'),c=c+"</span>"}else c+='<a class="docrefdoclink" href="'+window.webcenterConfig.jspBaseUrl+"docdetails.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+f.getMenuFileParamValue()+'" target="_blank">',c+=j.xmlencode(this.dm.docName),c+="</a>",this.dm.docCheckedOutOwner&&(c+='&nbsp;<img border="0" style="vertical-align:bottom" title="'+j.xmlencode(g.t("DOC_CHECKED_OUT"))+'" alt="'+j.xmlencode(g.t("DOC_CHECKED_OUT"))+'" src="images/locked_on_white.gif">');c+="</"+this.itemRootElemStr+">";d.append(c)}catch(e){f.log("Problem in StaticDocumentRowView.renderDocumentSpec:\n"+
e)}};n.prototype.renderDocumentActions=function(d,a){var c;c=""+("<"+this.itemRootElemStr+' class="docrefactionscol">');if(!this.dm.isInErrorStatus())for(var b=a.typeDetail.split("|"),e=0;e<b.length;e++){var g=b[e],i=this.phElemID+"_actionBtn_"+f.getNextUniquePrefix();c+='<span id="'+i+'" />';var l=null;switch(g){case "View":l=this.getViewBtn();break;case "Open3d":l=this.getOpen3DBtn();break;case "OpenAcad":l=this.getOpenACADBtn();break;case "Download":l=this.getDownloadBtn();break;case "UploadNewVersion":l=
this.getUploadNewVersionBtn()}l&&_.defer(_.bind(function(d,a){a.renderBtn(h("#"+d))},this,i,l))}c+="</"+this.itemRootElemStr+">";d.append(c)};n.prototype.renderDocumentDescription=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+">"),c=c+this.renderInlineLabel(a);this.dm.isInErrorStatus()||this.dm.docDesc&&(c+="<span>"+j.xmlencode(this.dm.docDesc)+"</span>");c+="</"+this.itemRootElemStr+">";d.append(c)}catch(b){f.log("Problem in StaticDocumentRowView.renderDocumentDescription:\n"+b)}};n.prototype.renderApprovalStatus=
function(d,c){try{var b="",b=b+("<"+this.itemRootElemStr+"  >"),b=b+this.renderInlineLabel(c);if(!this.dm.isInErrorStatus()){var e=this.dm.appStatus;if(e&&e.cycleStatus){for(var i=null,l=this.dm.appTypeList,h=0;h<l.length;h++){var k=l[h];if(k.id==e.statusID){i=k;break}}var n="onclick=\"javascript:showapprovaldetails(this, event,'"+this.dm.docVerID+"', 'Approval Setup "+j.xmlencode(a.encodeForJScript(this.dm.docName))+"')\"",n=n+' onmouseout="javascript:delayhidemenu();"',b=b+'<div class="docrefApprovalStatus">';
if("Not Started"==e.cycleStatus)var v=j.xmlencode(g.t("APPROVAL_STATUS_HOLD")),b=b+('<img border="0" src="images/stopped-approval.png" alt="'+v+'" title="'+v+'" '+n+" />");else i&&(v=j.xmlencode(i.translName),b+='<img border="0" src="images/'+i.icon+'" alt="'+v+'" title="'+v+'" '+n+"/>");b+="</div>";b+="</div>"}}b+="</"+this.itemRootElemStr+">";d.append(b)}catch(A){f.log("Problem in StaticDocumentRowView.renderApprovalStatus:\n"+A)}};n.prototype.renderApprovalStage=function(d,a){try{var c="",c=c+
("<"+this.itemRootElemStr+' class="docrefApprovalStage" >'),c=c+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var b=this.dm.appStatus;b&&b.stageName&&(c+=j.xmlencode(b.stageName))}c+="</"+this.itemRootElemStr+">";d.append(c)}catch(e){f.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+e)}};n.prototype.renderDocProjectName=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+">"),c=c+this.renderInlineLabel(a);if(!this.dm.isInErrorStatus()){var b=this.dm.projects;if(b&&0<
b.length)for(var e=0;e<b.length;e++){var g=b[e];g&&(g.id&&g.name)&&(0<e&&(c+="<br/>"),c+='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+g.id+"&amp;menu_file="+f.getMenuFileParamValue()+'" target="_blank">',c+=j.xmlencode(g.name),c+="</a>")}else this.dm.project.id&&this.dm.project.name&&(c+='<a href="'+window.webcenterConfig.jspBaseUrl+"projdetails.jsp?projectID="+this.dm.project.id+"&amp;menu_file="+f.getMenuFileParamValue()+'" target="_blank">',c+=j.xmlencode(this.dm.project.name),
c+="</a>")}c+="</"+this.itemRootElemStr+">";d.append(c)}catch(i){f.log("Problem in StaticDocumentRowView.renderDocProjectName:\n"+i)}};n.prototype.renderDocumentVersion=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+' class="center">'),c=c+this.renderInlineLabel(a);this.dm.isInErrorStatus()||(this.dm.docVerIdx&&(c+=this.dm.docVerIdx,this.dm.docRevLetter&&(c+="("+this.dm.docRevLetter+")")),a.uploadNewVersion&&(c+='&nbsp;&nbsp;<span id="'+this.phElemID+'_uploadNewVersionBtn" />',_.defer(_.bind(function(){var d=
this.getUploadNewVersionBtn();d&&d.setBtnContext(h("#"+this.phElemID+"_uploadNewVersionBtn"))},this))));c+="</"+this.itemRootElemStr+">";d.append(c)}catch(b){f.log("Problem in StaticDocumentRowView.renderDocumentVersion:\n"+b)}};n.prototype.renderDocumentAuthor=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+' class="Black_11">'),c=c+this.renderInlineLabel(a);!this.dm.isInErrorStatus()&&this.dm.docAuthor&&(c+='<a class="docrefdoclink" href="#" onclick="javascript:ShowUserDetails(\''+this.dm.docAuthor.id+
"');return false;\">",c+=j.xmlencode(this.dm.docAuthor.fullName),c+="</a>");c+="</"+this.itemRootElemStr+">";d.append(c)}catch(b){f.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+b)}};n.prototype.renderDocumentModifiedDate=function(d,c){try{var b="",b=b+("<"+this.itemRootElemStr+' class="center">'),b=b+this.renderInlineLabel(c);this.dm.isInErrorStatus()||this.dm.modDate&&(b+=j.xmlencode(a.getDateHourString(this.dm.modDate)));b+="</"+this.itemRootElemStr+">";d.append(b)}catch(e){f.log("Problem in StaticDocumentRowView.renderDocumentAuthor:\n"+
e)}};n.prototype.renderLocalRemoteButton=function(d,a){try{var c="",c=c+("<"+this.itemRootElemStr+' class="center">');if(!this.dm.isInErrorStatus()&&this.dm.getParentDocTable().hasLocalRemoteButton()&&this.dm.isRemoteDocument()){var b="",e=j.xmlencode(g.t("DocRowLocalRemoteInfoTooltip")),i="docref_info_external.png";this.dm.isEditable&&(this.dm.canUserAddDocuments()&&"ReadOnly"!=a.visibility&&!this.dm.dependsOnItself)&&(b="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+
");",e=j.xmlencode(g.t("DocRowLocalRemoteButtonTooltip")),i="docref_make_internal.png");c+='<img border="0" src="'+window.webcenterConfig.jspBaseUrl+"images/"+i+'"';c+=' title="'+e+'" onclick="'+b+'"/>'}c+="</"+this.itemRootElemStr+">";d.append(c)}catch(l){f.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+l)}};n.prototype.renderDeleteButton=function(d){try{var a="";if(this.dm.isEditable)var c="javascript: "+this.dm.getParentInDOM()+".deleteButtonClicked("+this.rowIndex+");return false;",
a=a+("<"+this.itemRootElemStr+' class="center">'),a=a+('<a class="btn btn15" href="#" onclick="'+c+'"><i class="remove"></i></a>'),a=a+("</"+this.itemRootElemStr+">");d.append(a)}catch(b){f.log("Problem in StaticDocumentRowView.renderDeleteButton:\n"+b)}};n.prototype.renderReferenceProperty=function(d,a){this._renderDocAttrRefPropValue(d,a,!0)};n.prototype.renderDocAttribute=function(d,a){this.dm.isInErrorStatus()||this.dm.dependsOnItself?d.append("<"+this.itemRootElemStr+"/>"):this._renderDocAttrRefPropValue(d,
a,!1)};n.prototype._renderDocAttrRefPropValue=function(d,a,c){try{var b=!1,e=a.typeDetail,i=c?this.dm.propsACatObj:this.dm.aCatObj;if(e&&i&&i.loaded){var l=i.findAttribute(e,a.attributeName);if(l&&!l.isRichText()){var k=i.findCell(l);if(k){var n=k.cellObj,v=k.row,A=k.col,z="ReadOnly"!=a.visibility,z=c?z&&this.dm.canUserEditProperties():z&&this.dm.canUserEditAttributes(),C=c?this.dm.propsACatPrefix:this.dm.aCatPrefix,e=C+"td_"+v+"_"+A,B=h("#"+e);if(1==B.length){var k='<span class="docRefInfo">',u=
j.xmlencode(g.t("DocRowAttributeInColumnInfo")+": "+a.label),k=k+('<img border="0" src="images/doc_ref_info.png" title="'+u+'"/>'),k=k+"</span>";B.removeAttr("id");B.html(k)}else 1<B.length&&alert("More than one HTML element with ID '"+e+"' on the page!");var q="<"+this.itemRootElemStr+' id="'+e+'" class="'+(c?"referencePropertyCell":"documentAttributeCell")+'">',q=q+this.renderInlineLabel(a);l.isDocReference()?l.valueHyperlink&&(q+=l.valueHyperlink.replace(/ \| /g,"<br/>")):q+=i.renderAttributeValueInternal(n,
l,v,A,a.visibility,z);q+="</"+this.itemRootElemStr+">";d.append(q);z&&l.type&&"datetime"==l.type.toLowerCase()&&i.createCalendar("#"+C+"longFormat_adate"+l.id,"#"+C+"date_period_of_day_"+l.id);b=!0}}}b||(q="<"+this.itemRootElemStr+">",q+=this.renderInlineLabel(a),i&&i.loaded?(q+='<span class="brokenDocRef">',u=j.xmlencode(c?g.t("DocRowCannotFindProperty"):g.t("DocRowCannotFindAttribute")),q+='<img border="0" src="images/warning.gif" title="'+u+'"/>',q+="</span>"):!c&&this.dm.hasNoAttrCat()&&(q+='<span class="brokenDocRef">',
u=j.xmlencode(g.t("DocRowNoAttrCategoryInfo")),q+='<img border="0" src="images/warning.gif" title="'+u+'"/>',q+="</span>"),q+="</"+this.itemRootElemStr+">",d.append(q))}catch(D){f.log("Problem in StaticDocumentRowView.renderReferenceProperty "+a.label+":\n"+D)}};n.prototype.renderDocAttrCatAndRefPropsPlaceholder=function(d){try{if(!this.renderOptions.isRepaintRow){this.dm.destroyACatObj();h("#"+this.dm.aCatRowID).remove();var a="",c=this.renderOptions.columns,a=a+('<tr id="'+this.dm.aCatRowID+'" class="hiddenElement">'),
a=a+"<td></td>",a=a+'<td class="attrCategoryColumn">';null!=f.getRenderItem(c,"ReferenceProperty")&&(a+='<div id="'+this.dm.propsACatElemID+'" class="hiddenElement"></div>');if(!this.aCatExpandDisabled||null!=f.getRenderItem(c,"DocumentAttribute"))a+='<div id="'+this.dm.aCatElemID+'"></div>';var a=a+"</td>",b=h(a+"</tr>");this.renderOptions.styleObj&&b.css(this.renderOptions.styleObj);d.after(b)}}catch(e){f.log("Problem in StaticDocumentRowView.renderDocAttrCatAndRefPropsPlaceholder:\n"+e)}};n.prototype.renderNewVersionPlaceholder=
function(d){this.renderOptions.isRepaintRow||(this._newVersionRow&&this._newVersionRow.remove(),this._newVersionRow=h('<tr id="'+this.phElemID+'_newVersionRow"></tr>'),d.after(this._newVersionRow),this._newVersionCell=h("<td colspan="+(this.renderOptions.columns?this.renderOptions.columns.length:1)+' style="padding: 0px 10px">'),this._newVersionRow.append(this._newVersionCell),this.newVersionBtn&&this.newVersionBtn.setRowContext(this._newVersionCell),this.renderOptions.styleObj&&this._newVersionRow.find("*").css(this.renderOptions.styleObj))};
n.prototype.customThumbnailHTML=function(d,c){var b="";if(!c||"0"==c)c="50";if(this.supportAdvancedThumb&&this.dm.docVerID)var e=window.webcenterConfig.jspBaseUrl+"DownloadViewerThumbnail.jsp?docversionid="+this.dm.docVerID+"&amp;pix=500&amp;ajax=1",g=this.dm.docDesc?this.dm.docDesc:"",i=window.webcenterConfig.jspBaseUrl+"viewdocument.jsp?docVerID="+this.dm.docVerID+"&amp;menu_file="+f.getMenuFileParamValue()+"&amp;sourcePage="+f.getSourcePageURLEncoded(),b=b+('<a href="'+i+'" target="_blank">')+
'<img onmouseout="delayhidethumb();"',b=b+(" onmouseover=\"showthumb(event, '"+d+"', '"+j.xmlencode(a.encodeForJScript(this.dm.docName))+"', 202, null, '"+e+"', 500);\""),b=b+(' src="'+window.webcenterConfig.jspBaseUrl+d+'"'),b=b+(' alt="'+j.xmlencode(g)+'" width="'+c+'px" height="'+c+'px" border="0" align="middle">'),b=b+"</a>";else b+='<img src="'+window.webcenterConfig.jspBaseUrl+d+'"',b+=' width="'+c+'px" height="'+c+'px" border="0" align="middle">';return b};n.prototype.renderInlineLabel=function(d){var a=
"";this.renderOptions.hideHeader&&(d&&d.label)&&(a+='<div class="docrefinlinelabel">'+f.getEncodedTranslatedLabel(d.label),"Required"==d.visibility&&(a+='&nbsp;<font color="red">*</font>'),a+="</div>");return a};n.prototype.getUploadNewVersionBtn=function(){if(!this.newVersionBtn&&this.showAdvancedDocumentActions()&&this.dm.canUserUploadNewVersion()){var d={useInlineForm:!0,alwaysUpdateAllProjects:!0,uniqueIdPrefix:f.getNextUniquePrefix()+"_"};this.newVersionBtn=new e(this.dm.docVerID,null,this.dm.parentDocTable.currentUser,
d);b.on("btnClicked.UploadNewVersion."+this.dm.docVerID,this.dm.setIsChanged.bind(this.dm));this._newVersionCell&&this.newVersionBtn.setRowContext(this._newVersionCell)}return this.newVersionBtn};n.prototype.getViewBtn=function(){this.viewBtn||(this.viewBtn=new c(this.dm.docVerID));return this.viewBtn};n.prototype.getDownloadBtn=function(){this.downloadBtn||(this.downloadBtn=new d(this.dm.docVerID));return this.downloadBtn};n.prototype.getOpen3DBtn=function(){this.open3dBtn||(this.open3dBtn=new l(this.dm.docVerID));
return this.open3dBtn};n.prototype.getOpenACADBtn=function(){this.openAcadBtn||(this.openAcadBtn=new i(this.dm.docVerID));return this.openAcadBtn};n.prototype.showAdvancedDocumentActions=function(){return!0};return n});
define("doctablex/StaticDocumentRow","doctablex/DocTableXUtils doctablex/StaticDocumentRowView doctablex/AJAXDataCache utils/webi18n!DocRefStrings wcr/ObjectArrayCloneUtil wcr/webcenter_xml jquery".split(" "),function(f,b,j,a,h,k,e){var c=function(d){if(!d)return this;this.setStatus("init");this.rowID=d.origDocRow?d.origDocRow.rowID:f.getNextUniquePrefix();if(this.parentDocTable=d.parentDocTable){this.prefix=this.getParentDocTable().getTablePrefix()+"_"+this.rowID;this.isChanged=!1;this.isEditable=
this.getParentDocTable().isEditable;"undefined"!=typeof d.isEditable&&(this.isEditable=!0===d.isEditable);this.aCatNotExpandedYet=!0;this.dependsOnItself=!1;this.renderOptions=d.renderOptions;this.renderOptions||(this.renderOptions=this.getParentDocTable().renderOptions);this.renderOptions||(this.renderOptions={});this.drID=d.drID;this.docVerID=d.docVerID;this.docID=d.docID;this.docName=d.docName;this.docDesc=d.docDesc;this.docVerIdx=d.docVerIdx;this.latestDocVerIdx=d.latestDocVerIdx;this.docRevLetter=
d.docRevLetter;this.appStatus=d.appStatus;this.thumbnailURL=d.thumbnailURL;this.docAuthor=d.docVerAuthor;this.modDate=d.modDate;this.appTypeList=d.appTypeList;this.userPerms=d.userPerms||{};this.docCheckedOutOwner=this.docType=this.docTypeID=null;this.project={id:d.projectID||null,name:d.projectID?d.projectName:null,isTemplate:d.isInTemplate||null};this.projects=d.projects||[];var a=[],e=this.renderOptions.columns;if(e)for(var g=0;g<e.length;g++){var h=e[g];if(h&&h.type&&"ReferenceProperty"==h.type){var j=
h.typeDetail,k=this.findPropertyByID(j,d.properties);k?(k.name=h.label,k.isRequired="Required"==h.visibility):k={id:j,name:h.label,isRequired:"Required"==h.visibility,value:""};a.push(k)}}this.props=a;this.propsValuesInitialized=!1;a=f.getRenderItem(this.renderOptions.columns,"AttributeFlapout");this.aCatExpandDisabled=!a;this.aCatExpanded=d.aCatExpanded||!1;this.aCatView=this.getParentDocTable().aCatView;a&&a.typeDetail&&(this.aCatView=a.typeDetail);this.aCatPrefix=this.getRowPrefix()+"_ACat_";this.aCatRowID=
this.getRowPrefix()+"_ACatRow";this.aCatElemID=this.getRowPrefix()+"_ACatPanel";this.aCatID=d.aCatID||null;this.aCatObj=null;this.renderedAttrCat={id:"",isEditable:!1};this.isExpandedAttrsEditable=!0;a&&(this.isExpandedAttrsEditable="Editable"==a.visibility);this.propsACatPrefix=this.getRowPrefix()+"_PropsACat_";this.propsACatElemID=this.getRowPrefix()+"_PropsACatID";this.propsACatID=this.getParentDocTable().propsACatID;this.propsACatObj=null;this.view=new (d.viewClass||b)(this,this.getRowPrefix(),
this.renderOptions);this.constructor==c.prototype.constructor&&this.updateDocInfoFromServer(!0);return this}alert("StaticDocumentRow cannot be initialized without parent table reference!")};c.prototype.setCustomView=function(d,a){d&&(this.view=d,this.view.dm=this,this.view.phElemID||(this.view.phElemID=this.getRowPrefix()),a&&this.displayRow())};c.prototype.setIsEditable=function(d){void 0!==d&&d!=this.isEditable&&(this.isEditable=d)};c.prototype.isInactive=function(){return this.getParentDocTable().isInactive};
c.prototype.displayRow=function(d){this.view.render();this.propsACatID&&this._prepareReferenceCategoryObj(!1);this.showDocAttributeCategory(!1,d)};c.prototype.resetDocument=function(){j.getInstance().resetDocDataByDocVerID(this.docVerID);this.dependsOnItself=!1;this.modDate=this.docDesc=this.thumbnailURL=this.docVerIdx=this.appStatus=this.docName=this.docID=this.docVerID="";this.appTypeList=[];this.userPerms={};this.project={};this.projects=[];this.docType=this.docTypeID=null;this.resetDocumentAttrCategory();
this.isChanged=!1};c.prototype.resetDocumentAttrCategory=function(){this.aCatID=null;this.aCatObj&&this.aCatObj.destroy();this.aCatObj=null};c.prototype.setIsChanged=function(){this.isChanged=!0;this.getParentDocTable()&&this.getParentDocTable().setIsChanged()};c.prototype.getIsChanged=function(){return this.isChanged};c.prototype.setStatus=function(d){this.isInErrorStatus()||(this.status=d,this.isInErrorStatus()&&(this.view.repaintRow(),this.hideDocAttributeCategory()))};c.prototype.isInErrorStatus=
function(){return"noperm"==this.status||"error"==this.status};c.prototype.getParentDocTable=function(){return this.parentDocTable};c.prototype.getIndexInTable=function(){return this.getParentDocTable()?this.getParentDocTable().docRows.indexOf(this):-1};c.prototype.getRowPrefix=function(){return this.prefix};c.prototype.getThisInDOM=function(){return this.getParentInDOM()+".getRowByID("+this.rowID+")"};c.prototype.getParentInDOM=function(){if(this.getParentDocTable())return this.getParentDocTable().getThisInDOM();
f.log("Error: Cannot find itself in parent documents table!");return"window"};c.prototype.findPropertyByID=function(d,a){a||(a=this.props);if(a)for(var c=0;c<a.length;c++){var b=a[c];if(b.id==d)return b}return null};c.prototype._updateDocInfo=function(d){var a=!1;if(d&&d.docVerID&&d.docVerID==this.docVerID){this.docID!=d.docID&&(a=!0,this.docID=d.docID);this.docName!=d.docName&&(a=!0,this.docName=d.docName);this.docDesc!=d.docDesc&&(a=!0,this.docDesc=d.docDesc);this.docVerIdx!=d.docVerIdx&&(a=!0,
this.docVerIdx=d.docVerIdx);this.latestDocVerIdx!=d.latestDocVerIdx&&(a=!0,this.latestDocVerIdx=d.latestDocVerIdx);this.docRevLetter!=d.docRevLetter&&(a=!0,this.docRevLetter=d.docRevLetter);this.appStatus!=d.appStatus&&(a=!0,this.appStatus=d.appStatus);this.thumbnailURL!=d.thumbnailURL&&(a=!0,this.thumbnailURL=d.thumbnailURL);this.docTypeID!=d.docTypeID&&(a=!0,this.docTypeID=d.docTypeID);!this.project.id&&(d.projList[0]&&this.project.id!=d.projList[0].id)&&(a=!0,this.project=d.projList[0]);d.projList&&
""+this.projects!=""+d.projList&&(a=!0,this.projects=d.projList);if(d.docVerAuthor&&(!this.docAuthor||this.docAuthor.id!=d.docVerAuthor.id))a=!0,this.docAuthor=d.docVerAuthor;if(this.modDate!=d.modDate)try{a=!0,this.modDate=d.modDate?new Date(parseInt(d.modDate)):""}catch(c){f.log("Failed to parse '"+d.modDate+"' to a Date object."),this.modDate=""}d.userPerms&&(this.userPerms=d.userPerms);d.appTypeList&&(this.appTypeList=d.appTypeList);d.docCheckedOutOwner&&(this.docCheckedOutOwner=d.docCheckedOutOwner)}else j.isEmptyValue(d)&&
this.setStatus("noperm");return a};c.prototype.updateDocInfoFromServer=function(a,c){this.setStatus("loading");if(!this.docVerID)return e.Deferred().reject("Cannot update document info from server, this.docVerID is not known!").promise();var b=j.getInstance().getDocInfoWithThumbnail(this.docVerID,c);b.done(function(c){this._updateDocInfo(c)&&a&&this.view.repaintRow()}.bind(this));b.fail(function(a){this.setStatus("error");f.log(a)}.bind(this));return b};c.prototype.isInConfigPreview=function(){return this.getParentDocTable().isInConfigPreview};
c.prototype.isRemoteDocument=function(){return this.project.id&&this.project.id!=this.getParentDocTable().projectID};c.prototype.isLatestDocVersion=function(){return this.latestDocVerIdx&&this.docVerIdx==this.latestDocVerIdx};c.prototype.hasAttrCat=function(){return!!this.aCatID&&!j.isEmptyValue(this.aCatID)&&f.isValidID(this.aCatID)};c.prototype.hasNoAttrCat=function(){return!!this.aCatID&&j.isEmptyValue(this.aCatID)};c.prototype.setDocumentHasNoAttrCategory=function(){this.aCatID=j.getEmptyValue();
this.aCatObj&&this.aCatObj.destroy();this.aCatObj=null};c.prototype.isAttrCatNeeded=function(){return f.getRenderItem(this.renderOptions.columns,"AttributeFlapout")||f.getRenderItem(this.renderOptions.columns,"DocumentAttribute")?!0:!1};c.prototype.isAttrCatUpdateNeeded=function(){return this.renderedAttrCat.id!=this.aCatID||this.renderedAttrCat.isEditable!=this.canUserEditExpandedAttributes()};c.prototype.canUserEditAttributes=function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&
!this.dependsOnItself&&this.userPerms.change};c.prototype.canUserEditExpandedAttributes=function(){return this.canUserEditAttributes()&&this.isExpandedAttrsEditable};c.prototype.canUserEditProperties=function(){return!this.isInactive()&&this.isEditable&&!this.dependsOnItself};c.prototype.canUserAddDocuments=function(){return this.getParentDocTable().canUserAddDocuments};c.prototype.canUserUploadNewVersion=function(){return!this.isInactive()&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&
this.isEditable&&this.userPerms.checkout};c.prototype.updateDocAttrCategoryFromServer=function(a){return!this.docVerID?null:j.getInstance().getDocAttrCatInfo(this.docVerID,a).pipe(function(a){var d=!1;a?a.id?(this.aCatID!=a.id&&(d=!0),this.aCatID=a.id):(j.isEmptyValue(this.aCatID)||(d=!0),this.setDocumentHasNoAttrCategory()):(j.isEmptyValue(this.aCatID)||(d=!0),this.setDocumentHasNoAttrCategory());return d}.bind(this),function(a){alert(a)})};c.prototype._initializeAndRenderAttrCategoryObj=function(a,
c){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=e("#"+this.aCatElemID).length)if(this.hasAttrCat()){this.setStatus("loading");var b=h.getCloneOfObject(this.getParentDocTable().currentUser);b.canEditAttributes=this.canUserEditExpandedAttributes();var g=[],j=this.getParentDocTable().parentDocVerIDs;j&&0<j.length&&(g=h.getCloneOfArray(j));g.push(this.docVerID?this.docVerID:"newID_"+f.getNextUniquePrefix());var k={};k.prefix=this.aCatPrefix;k.ACatObj=this.aCatElemID;k.ACatPanel=this.aCatElemID;
k.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+this.aCatID+"&ajax=1";k.valuesURL=this.generateDocAttributeValuesAJAXURL();k.valuesURL||(k.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.aCatID+"&ajax=1");k.currentUser=b;k.view=this.getAttCatView();k.type="document";k.projectID=this.project.id;k.documentID=this.docID;this.docVerID&&(k.docVersionID=this.docVerID);a&&(k.callbackOnRender=a);c&&(k.callbackOnFail=c);k.docTableParentDocVerIDs=
g;k.isInactive=this.isInactive();k.aCatNotExpandedYet=this.aCatNotExpandedYet;this.renderOptions.styleObj&&(k.defaultStyleObject=this.renderOptions.styleObj.inlineStyleObject);require(["attributecategory/AttributeCategory"],function(a){this.aCatObj=new a(k);this.aCatObj.valueChangedListeners.push(function(){this.setIsChanged()}.bind(this))}.bind(this));this.renderedAttrCat.id=this.aCatID;this.renderedAttrCat.isEditable=b.canEditAttributes}else f.log("Attempt to render attribute category when its ID is not known!")};
c.prototype._initializeAndRenderReferenceCategoryObj=function(a,c){if(!this.getParentDocTable().parentACatNotExpandedYet&&0!=e("#"+this.propsACatElemID).length)if(this.propsACatID){this.setStatus("loading");this.propsValuesInitialized=!1;var b=h.getCloneOfObject(this.currentUser);b.canEditAttributes=this.canUserEditProperties();var g={};g.prefix=this.propsACatPrefix;g.ACatObj=this.propsACatElemID;g.ACatPanel=this.propsACatElemID;g.readURL=window.webcenterConfig.jspBaseUrl+"GetAttributeCategoryXML.jsp?categoryid="+
this.propsACatID+"&ajax=1";g.valuesURL=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?categoryid="+this.propsACatID+"&ajax=1";g.currentUser=b;a&&(g.callbackOnRender=a);c&&(g.callbackOnFail=c);require(["attributecategory/AttributeCategory"],function(a){this.propsACatObj=new a(g);this.propsACatObj.valueChangedListeners.push(function(){this.setIsChanged()}.bind(this))}.bind(this))}else f.log("Attempt to initialize reference properties when reference category ID is not known!")};c.prototype.generateDocAttributeValuesAJAXURL=
function(){var a=null;this.docVerID&&(a=window.webcenterConfig.jspBaseUrl+"GetAttributes.jsp?docverid="+this.docVerID);return a};c.prototype.showDocAttributeCategory=function(a,c){this.aCatExpandDisabled&&(c=!1);if(this.docVerID&&!this.aCatID){var b=this.updateDocAttrCategoryFromServer();b&&(b.done(function(b){this._showDocAttributeCategory(a||b,c)}.bind(this)),b.fail(function(){this.hideDocAttributeCategory()}.bind(this)))}else this.hasAttrCat()?this._showDocAttributeCategory(a,c):this.hideDocAttributeCategory()};
c.prototype.getExpColButton=function(){return e("#"+this.getRowPrefix()+" > "+this.view.itemRootElemStr+" > a.expandCollapseButton > i")};c.prototype._expandDocAttrCat=function(d){d||(d=this.getExpColButton());this.dependsOnItself?d.removeClass("expand").addClass("cycle").attr("title",k.xmlencode(a.t("DocRowCyclicDepTooltip"))):d.removeClass("expand cycle").addClass("collapse").attr("title",k.xmlencode(a.t("DocRowCollapseTooltip")));e("#"+this.aCatRowID).removeClass("hiddenElement");this.aCatExpanded=
!0;this.aCatNotExpandedYet&&this.setACatIsExpanded()};c.prototype.setACatIsExpanded=function(){this.aCatNotExpandedYet=!1;this.aCatObj&&this.aCatObj.setACatIsExpanded();this.displayRow()};c.prototype._collapseDocAttrCat=function(d){d||(d=this.getExpColButton());this.dependsOnItself?d.removeClass("collapse").addClass("cycle").attr("title",k.xmlencode(a.t("DocRowCyclicDepTooltip"))):d.removeClass("collapse cycle").addClass("expand").attr("title",k.xmlencode(a.t("DocRowExpandTooltip")));e("#"+this.aCatRowID).addClass("hiddenElement");
this.aCatExpanded=!1};c.prototype._showDocAttributeCategory=function(a,c){if(a||this.isAttrCatUpdateNeeded())this.aCatObj&&this.aCatObj.destroy(),this.aCatObj=null;if(!this.hasAttrCat()||!this.isAttrCatNeeded())this.hideDocAttributeCategory();else{var b=this.getExpColButton();b.parent().removeClass("hiddenElement");if(this.dependsOnItself)this._collapseDocAttrCat(b);else if(c||this.aCatExpanded?this._expandDocAttrCat(b):this._collapseDocAttrCat(b),b=null!=f.getRenderItem(this.renderOptions.columns,
"DocumentAttribute"),!this.aCatNotExpandedYet||b)if(this.aCatObj){var b=!1,g=e("#"+this.aCatElemID);1==g.length&&g[0].ACatObj!=this.aCatObj&&(g[0].ACatObj=this.aCatObj,b=!0);b&&(this.aCatObj.isInactive=this.isInactive(),this.aCatObj.displayAttributeCategory())}else this._initializeAndRenderAttrCategoryObj(this._onAttrCategoryReady.bind(this,!1),this._onAttrCategoryLoadFailed.bind(this))}};c.prototype._prepareReferenceCategoryObj=function(a){this.propsACatID?(a&&(this.propsACatObj&&this.propsACatObj.destroy(),
this.propsACatObj=null),this.propsACatObj?(a=e("#"+this.propsACatElemID),1==a.length&&a[0].ACatObj!=this.propsACatObj&&(a[0].ACatObj=this.propsACatObj)):this._initializeAndRenderReferenceCategoryObj(this._onAttrCategoryReady.bind(this,!0),this._onAttrCategoryLoadFailed.bind(this))):f.log("StaticDocumentRow._prepareReferenceCategoryObj() called when no reference category ID known (or it was nullified)")};c.prototype._onAttrCategoryReady=function(a){if(a&&this.propsACatObj&&this.propsACatObj.loaded){if(!this.propsValuesInitialized){for(a=
0;a<this.props.length;a++){var c=this.props[a];if(c&&c.id){var b=this.propsACatObj.findAttribute(c.id,c.name);b&&b.copyValueFrom(c)}}this.propsValuesInitialized=!0}this.propsACatObj.destroy();e("#"+this.propsACatElemID).html("")}this.setStatus("ready");this.view.repaintRow()};c.prototype._onAttrCategoryLoadFailed=function(){this.setStatus("error");f.log("Failed to load attribute category.")};c.prototype.hideDocAttributeCategory=function(){var a=this.getExpColButton();this._collapseDocAttrCat(a);this.hasAttrCat()||
(a.parent().addClass("hiddenElement"),a=e("#"+this.aCatElemID),a.ACatObj&&a.ACatObj.destroy(),a.ACatObj=null,a.html(""))};c.prototype.collapseAllDescendants=function(){this.aCatObj&&this.aCatObj.executeOnAllDocReferences(function(a){a.collapseAllRows()},this);this._collapseDocAttrCat()};c.prototype.deleteItself=function(a){this.destroy();a?e("#"+this.view.phElemID).empty():e("#"+this.view.phElemID).remove();e("#"+this.aCatRowID).remove();this.view._newVersionRow.remove()};c.prototype.swapWith=function(a){this.aCatObj&&
this.aCatObj.beforeMove();e("#"+this.view.phElemID).insertAfter(e("#"+a.aCatRowID));this.view._newVersionRow?(this.view._newVersionRow.insertAfter(e("#"+this.view.phElemID)),e("#"+this.aCatRowID).insertAfter(this.view._newVersionRow)):e("#"+this.aCatRowID).insertAfter(e("#"+this.view.phElemID));this.view.repaintRow();a.view.repaintRow();this.aCatObj&&this.aCatObj.afterMove()};c.prototype.setDependsOnItself=function(a){this.dependsOnItself=!0==a};c.prototype.convertRefPropertiesToXML=function(){var a=
"";try{if(this.props&&0<this.props.length){for(var a=a+"<refatts>",c=0;c<this.props.length;c++){var b=this.props[c];b&&b.id&&(a+="<att>",a+=k.ElementEncode("id",b.id),a+="</att>")}a+="</refatts>";a+=k.ElementEncode("refprefix",this.propsACatPrefix)}}catch(e){f.log("Problem in StaticDocumentRow.convertRefPropertiesToXML:\n"+e),a=""}return a};c.prototype.convertUploadNewVersionToXML=function(){var a="";if(this.view.newVersionBtn&&this.view.newVersionBtn.isExpanded&&this.view._newVersionCell){var c=
this.view._newVersionCell,a=a+"<ds>"+k.ElementEncode("action","UploadNewVersion"),a=a+k.ElementEncode("file_form_field","newVersionDocFile_"+this.docVerID),a=a+k.ElementEncode("version_comment",c.find("input[name=newVersionDocDesc_"+this.docVerID+"]").val()),a=a+k.ElementEncode("raise_revision","checked"==c.find("input[name=incrementRevision_"+this.docVerID+"]").attr("checked")?"1":"0");0<e("input[name=AppCycleFlag"+this.docVerID+"]").length?(a+=k.ElementEncode("start_approval","checked"==c.find("input[name=AppCycleFlag"+
this.docVerID+"]").attr("checked")?"1":"0"),a+=k.ElementEncode("approval_due_date",c.find("input[name=due_date"+this.docVerID+"]").val()),a+=k.ElementEncode("approval_due_period",c.find("select[name=due_periodOfDay"+this.docVerID+"]").val())):a+=k.ElementEncode("start_approval",c.find("input[name=startApprovalDefaultValue"+this.docVerID+"]").val());a+="</ds>"}return a};c.prototype.convertToXML=function(a){var c="";try{c+="<dr>",this.drID&&(c+=k.ElementEncode("id",this.drID)),a&&0<a.length&&(c+=a),
this.docVerID&&(c+=k.ElementEncode("dv",this.docVerID),this.docVerIdx&&(c+=k.ElementEncode("dvidx",this.docVerIdx)),this.docID&&(c+=k.ElementEncode("doc_id",this.docID)),this.docName&&(c+=k.ElementEncode("dn",this.docName))),this.appStatus&&this.appStatus.cycleStatus&&(c+=k.ElementEncode("astat",this.appStatus.cycleStatus)),this.isEditable&&(c+=this.convertUploadNewVersionToXML(),c+=this.convertRefPropertiesToXML()),this.isInErrorStatus()||(c+=k.ElementEncode("daprefix",this.aCatPrefix)),c+="</dr>"}catch(b){f.log("Problem in StaticDocumentRow.convertToXML:\n"+
b),c=""}return c};c.prototype.validateDocRow=function(c,b){var i=!0;if(this.isInactive())return i;if(this.aCatObj&&this.aCatObj.loaded){var g=[];if(this.canUserEditAttributes()&&!c.isTemplate){var f=this.renderOptions.columns;if(f)for(var h=0;h<f.length;h++){var k=f[h];if(k&&k.type&&"DocumentAttribute"==k.type){var j=k.typeDetail;g.push(j);if("Required"==k.visibility&&(k=this.aCatObj.findAttribute(j,k.attributeName))&&!k.value)i={level:b,attrLabel:this.aCatObj.getAttributeLabel(k),element:e("#"+this.aCatObj.prefix+
k.id).closest("td").find("*"),docRowObj:this},c.errors.push(i),i=!1}}}this.aCatObj.validateAttributes(!1,c,g,this,b+1)||(i=!1)}if(this.canUserEditProperties()&&!c.isTemplate&&this.props&&this.propsACatObj&&this.propsACatObj.loaded)for(h=0;h<this.props.length;h++)if((g=this.props[h])&&g.id&&g.isRequired)if((f=this.propsACatObj.findAttribute(g.id,g.name))&&!f.value)i={level:b,msg:a.t("DocRowPropertyRequiredButNull",g.name),element:e("#"+this.propsACatObj.prefix+f.id).closest("td").find("*"),docRowObj:this},
c.errors.push(i),i=!1;if(this.view.newVersionBtn&&(g=this.view.newVersionBtn.validate())&&0<g.length){for(h=0;h<g.length;h++)i=g[h],i.level=b,i.docRowObj=this,c.errors.push(i);i=!1}return i};c.prototype.expandBranchTillThis=function(a){for(var c=this.getRowPrefix().split("_"),b=1,g=0,f="";g+2<c.length&&b<a;){var h=c[g]+"_"+c[++g],k=f+h+"_docTable",j=c[++g],k=e("#"+k);if(1==k.length&&(k=k[0].docTable))(k=k.getRowByID(j))&&k.showDocAttributeCategory(!1,!0);f+=h+"_"+j+"_ACat_";g+=2;b++}};c.prototype._onSubmit=
function(){this.aCatObj&&!this.isInactive()&&this.aCatObj.convertDocReferencesToXML()};c.prototype.expandClicked=function(a){a&&(a=e(a).find("i"),a.hasClass("cycle")||(a.hasClass("expand")?this.showDocAttributeCategory(!1,!0):this.hideDocAttributeCategory()))};c.prototype.destroy=function(){this.destroyACatObj()};c.prototype.destroyACatObj=function(){this.aCatObj&&this.aCatObj.destroy()};c.prototype.reconstruct=function(){this.aCatObj&&this.aCatObj.reconstruct()};c.prototype.getAttCatView=function(){return this.aCatView||
"Default"};return c});
define("doctablex/DocumentRowView",["doctablex/StaticDocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(f,b,j,a){var h=function(a,b,c){if(!a&&!b&&!c)return this;f.call(this,a,b,c);return this};h.prototype=new f;h.prototype.constructor=h;h.prototype.parent=f.prototype;h.prototype.renderDocTemplateSelector=function(){var f="";try{var e=this.dm.docTemplates;if(!e||0==e.length)return f;if("FixedDocTemplate"==this.dm.docTempType)f+="<span>"+a.xmlencode(j.t("PROJ_CREATION_DOCUMENT_TEMPLATE"))+
":&nbsp;</span>",f+="<span>"+a.xmlencode(e[0].name)+"</span>";else{f='<select class="form-control form-field-medium form-dropdown-field" onChange="'+("javascript: "+this.dm.getThisInDOM()+".docTemplateSelected(this.value);")+'">';f+='<option value="-1"'+(!this.dm.selDocTemplate?' selected="selected"':"")+">"+a.xmlencode(j.t("SELECTDOCTEMPLATE"))+"...</option>";if(e)for(var c=0;c<e.length;c++)var d=e[c],f=f+('<option value="'+c+'"'+(this.dm.selDocTemplate==d?' selected="selected"':"")+">"+a.xmlencode(d.name)+
"</option>");f+="</select>"}}catch(l){b.log("Problem in DocumentRowView.renderDocTemplateSelector:\n"+l),f=""}return f};h.prototype.renderDocFolderSelector=function(){var f="";try{var e=this.dm.targetFolders;if(!e||0==e.length)return f;if(1==e.length){var c=e[0].name;"0"==e[0].id&&(c=j.t("DEFAULT_FOLDER_ROOT"));f+="<label>"+a.xmlencode(j.t("FOLDER"))+":&nbsp;"+a.xmlencode(c)+"</label>"}else{var f='<select class="form-control form-field-medium form-dropdown-field" onChange="'+("javascript: "+this.dm.getThisInDOM()+
".targetFolderSelected(this.value);")+'">',d=e[0].id;this.dm.selTargetFolder&&(d=this.dm.selTargetFolder.id);c=!1;this.dm.selDocTemplate&&(this.dm.selTargetFolder.isDefaultFromDocTempl&&(c=!0),f+='<option value="-1"'+(c?' selected="selected"':"")+">",f+=a.xmlencode(j.t("DEFAULT_FOLDER_TEMPLATE")),f+="</option>");for(var l=0;l<e.length;l++)var i=e[l],f=f+('<option value="'+l+'"'+(d==i.id&&!c?' selected="selected"':"")+">"),f="0"==i.id?f+a.xmlencode(j.t("DEFAULT_FOLDER_ROOT")):f+a.xmlencode(i.name),
f=f+"</option>";f+="</select>"}}catch(g){b.log("Problem in DocumentRowView.renderDocFolderSelector:\n"+g),f=""}return f};h.prototype.showAdvancedDocumentActions=function(){return!1};return h});
define("utils/EventBasedValidator",["utils/webi18n!validatorStrings","jquery","utils/WCEvent"],function(f,b,j){return{getInstance:function(){window.eventBasedValidator||(window.eventBasedValidator={onValidateUniqueDocName:function(a){j.on("validation.uniqueDocName",a)},createUniqueNamesObj:function(){return{errors:[],newDocs:[],newDocsDOMElems:{},excludedProjects:{},localClashFound:!1,addDoc:function(a,b){if(a.val()){var j=a.val().toLowerCase();this.newDocsDOMElems[b+"_"+j]?(this.newDocsDOMElems[b+
"_"+j].push(a[0]),this.localClashFound||(j={msg:f.t("PROJ_CREATION_SPECIFY_UNIQUE_DOCNAMES"),element:this.newDocsDOMElems[this.projectID+"_"+j],docRowObj:this},this.errors.splice(0,0,j),this.localClashFound=!0)):(this.newDocsDOMElems[b+"_"+j]=a,b&&!this.excludedProjects[b]&&this.newDocs.push({docName:j,projectId:b}))}},excludeProject:function(a){this.excludedProjects[a]=!0},isOk:function(){return 0==this.errors.length}}},validateNamesGlobally:function(a){a||(a=this.createUniqueNamesObj());j.emit("validation.uniqueDocName",
a);0<a.newDocs.length&&b.ajax({url:"GetDocumentsByNameAndProjectID.jsp",dataType:"json",method:"POST",async:!1,data:{data:JSON.stringify({docs:a.newDocs})}}).done(function(c){if(c.docs&&0<c.docs.length)for(var d=0;d<c.docs.length;d++){var b={msg:f.t("NAMECONFLICTEXCEPTION_ADV_TAG",c.docs[d].docName,c.docs[d].projectName),element:a.newDocsDOMElems[c.docs[d].projectId+"_"+c.docs[d].docName.toLowerCase()]};a.errors.push(b)}});for(var h="",k=0;k<a.errors.length;k++){var e=a.errors[k];e.msg&&(h+=e.msg+
"\n");e.element&&e.element.addClass("validationHighlight")}h&&alert(h)}});return window.eventBasedValidator}}});
define("doctablex/DocumentRow","doctablex/StaticDocumentRow doctablex/DocumentRowView doctablex/DocTableXUtils wcr/webcenter_xml utils/EventBasedValidator utils/webi18n!DocRefStrings underscore".split(" "),function(f,b,j,a,h,k,e){var c=function(a){if(!a)return this;a.viewClass||(a.viewClass=b);f.call(this,a);this.docOperation=a.operation||null;this.useDocTypeDefaultACat=!1;this.origDocRow=a.origDocRow||null;this.docVerIdx="1";this.docRevLetter="";this.latestDocVerIdx="1";this.fieldsModByUser=[];this.docNameSuffix=
null;this.anPrefix=a.anPrefix||null;this.anSuffix=a.anSuffix||null;this.anCounterLength=a.anCounterLength||0;this.docTempType=a.docTempType;this.docTempType||(this.docTempType="AnyDocTemplate");this.docTempNames=a.docTempNames||"";this.selDocTemplate=this.docTemplates=null;this.targetFolderName=a.targetFolderName||"";this.selTargetFolder=this.targetFolders=null;this.constructor==c.prototype.constructor&&this.setStatus("ready");h.getInstance().onValidateUniqueDocName(e.bind(function(a){this.validateDocRowUniqueName(a)},
this));return this};c.prototype=new f;c.prototype.constructor=c;c.prototype.parent=f.prototype;c.prototype.resetDocument=function(a){this.anSuffix=this.anPrefix=null;this.anCounterLength=0;a&&(c.prototype.parent.resetDocument.call(this),this.fieldsModByUser=[])};c.prototype.canUserEditAttributes=function(){var a=this.selTargetFolder?this.selTargetFolder.changePropPerm:!1;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&a};c.prototype.generateDocAttributeValuesAJAXURL=function(){var a=
window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&j.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):j.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:j.log("Cannot generate URL in DocumentRowNew.generateDocAttributeValuesAJAXURL().");return a};
c.prototype.isModifiedByUser=function(a){return-1<this.fieldsModByUser.indexOf(a)};c.prototype.setFieldModByUser=function(a,c){if(c){var b=this.fieldsModByUser.indexOf(a);-1<b&&this.fieldsModByUser.splice(b,1)}else this.fieldsModByUser.push(a)};c.prototype.isAutonamingEnabled=function(){return this.anPrefix&&0<this.anPrefix.length};c.prototype.hasAutonameSuffix=function(){return this.anSuffix&&-1<this.anSuffix.toLowerCase().indexOf("[editfield]")};c.prototype.updateDocumentType=function(a,c){var b=
a.docTypeList;if(b&&this.docTypeID)for(var e=0;e<b.length;e++){var f=b[e];if(this.docTypeID==f.id){this.docType=f;this.anPrefix=f.anPrefix;this.anSuffix=f.anSuffix;this.anCounterLength=f.anCounterLength;this.selDocTemplate&&(this.aCatID=this.selDocTemplate.categoryID);!this.hasAttrCat()&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID);c&&(this.view.repaintRow(),this.showDocAttributeCategory(!1,!0));break}}};c.prototype.updateDocTemplates=function(a){this.docTemplates=[];if(a&&!(0==
a.length||this.isInConfigPreview()))if(!this.docTempType||"AnyDocTemplate"==this.docTempType)this.docTemplates=a;else if("NoDocTemplate"!=this.docTempType)if("FixedDocTemplate"==this.docTempType){var c=this.docTempNames[0];if(c){for(var b=0;b<a.length;b++){var e=a[b];if(e&&e.name&&e.name.toLowerCase()==c){this.docTemplates.push(e);break}}1==this.docTemplates.length&&this.updateDocTemplateSelection(0)}}else if("ListDocTemplate"==this.docTempType)for(b=0;b<a.length;b++)(e=a[b])&&(e.name&&0<=this.docTempNames.indexOf(e.name.toLowerCase()))&&
this.docTemplates.push(e)};c.prototype.preselectDocTemplate=function(){if(!this.docTempType||!("NoDocTemplate"==this.docTempType||"FixedDocTemplate"==this.docTempType)){var a=this.origFileExt;a||(a=this.fileExt);a=this._matchDocTemplate("default."+a);0>a&&(a=this._matchDocTemplate("default"));this.updateDocTemplateSelection(a)}};c.prototype._matchDocTemplate=function(a){if(this.docTemplates)for(var c=0;c<this.docTemplates.length;c++)if(this.docTemplates[c].name.toLowerCase()==a)return c;return-1};
c.prototype.updateDocTemplateSelection=function(a){var c=this.aCatID;-1==a?(this.selDocTemplate=null,this.docType&&this.useDocTypeDefaultACat&&(this.aCatID=this.docType.categoryID)):this.docTemplates&&(0<=a&&a<this.docTemplates.length)&&(this.selDocTemplate=a=this.docTemplates[a],this.aCatID=a.categoryID,!this.hasAttrCat()&&(this.docType&&this.useDocTypeDefaultACat)&&(this.aCatID=this.docType.categoryID));this.aCatID!=c&&(this.aCatObj&&this.aCatObj.destroy(),this.aCatObj=null);this.preselectTargetFolder()};
c.prototype.updateTargetFolders=function(a){a&&0<a.length&&!this.isInConfigPreview()?this.targetFolders=a:(this.targetFolders=[],this.selTargetFolder=null)};c.prototype.preselectTargetFolder=function(){if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else if(!this.isModifiedByUser("targetFolder")){var a=this._findTargetFolderByName(this.targetFolderName);this.setSelectedTargetFolder(a,!a)}};c.prototype._findTargetFolderByName=function(a){if(this.targetFolders&&a)for(var a=
a.toLowerCase(),c=0;c<this.targetFolders.length;c++){var b=this.targetFolders[c];if(b&&b.name.toLowerCase()==a)return b}return null};c.prototype.setSelectedTargetFolder=function(a,c){this.selTargetFolder&&(this.selTargetFolder.isDefaultFromDocTempl=!1);if(!this.targetFolders||0==this.targetFolders.length)this.selTargetFolder=null;else{if(c){if(this.selDocTemplate&&(this.selTargetFolder=this._findTargetFolderByName(this.selDocTemplate.folderName)))this.selTargetFolder.isDefaultFromDocTempl=!0}else this.selTargetFolder=
a;this.selTargetFolder||(this.selTargetFolder=this.targetFolders[0],c&&(this.selTargetFolder.isDefaultFromDocTempl=!0))}};c.prototype.convertToXML=function(c){var b="";try{if(this.isInErrorStatus())return b;b+="<dr>";this.origDocRow?(this.origDocRow.drID&&(b+=a.ElementEncode("id",this.origDocRow.drID)),this.origDocRow.docVerID&&(b+=a.ElementEncode("dv",this.origDocRow.docVerID))):this.drID&&(b+=a.ElementEncode("id",this.drID));c&&0<c.length&&(b+=c);b+=this.convertRefPropertiesToXML();this.canUserEditAttributes()&&
(b+=a.ElementEncode("daprefix",this.aCatPrefix));b+="</dr>"}catch(e){j.log("Problem in StaticDocumentRow.convertToXML:\n"+e),b=""}return b};c.prototype.validateDocRow=function(a,b){var e=!0,g=$("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first");1==g.length&&(!g.val()&&!this.isAutonamingEnabled())&&(e={isBlocking:!0,level:b,msg:k.t("DocRowDocNameRequired"),element:g,docRowObj:this},a.errors.push(e),e=!1);c.prototype.parent.validateDocRow.call(this,a,b)||(e=!1);return e};c.prototype.validateDocRowUniqueName=
function(a){if(!this.isAutonamingEnabled()&&this.isEditable&&!this.isInactive()){var c=$("#"+this.getRowPrefix()+" div.DocumentNameRow > input:first");a.addDoc(c,this.project.id)}};c.prototype.docNameChanged=function(a){this.docName!=a&&(this.docName=a,this.setIsChanged(),this.setFieldModByUser("docName",!a))};c.prototype.docNameSuffixChanged=function(a){this.docNameSuffix!=a&&(this.docNameSuffix=a,this.setIsChanged(),this.setFieldModByUser("docNameSuffix",!a))};c.prototype.docDescChanged=function(a){this.docDesc!=
a&&(this.docDesc=a,this.setIsChanged(),this.setFieldModByUser("docDescription",!a))};c.prototype.docTemplateSelected=function(a){this.setIsChanged();this.setFieldModByUser("docTemplate",-1==a);this.resetDocumentAttrCategory();this.updateDocTemplateSelection(a);this.view.repaintRow();this.showDocAttributeCategory(!1,!0)};c.prototype.targetFolderSelected=function(a){this.setIsChanged();this.setFieldModByUser("targetFolder",-1==a);-1==a?this.setSelectedTargetFolder(null,!0):this.setSelectedTargetFolder(this.targetFolders[a]);
this.showDocAttributeCategory(!1,!1)};return c});
define("doctablex/DocumentRowSearchView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(f,b,j,a){var h=function(a,b,c){if(!a&&!b&&!c)return this;f.call(this,a,b,c);return this};h.prototype=new f;h.prototype.constructor=h;h.prototype.parent=f.prototype;h.prototype.renderDocumentSpec=function(f){try{var e="",c="Copy"==this.dm.docOperation,d="Move"==this.dm.docOperation,h="Link"==this.dm.docOperation,e=e+("<"+this.itemRootElemStr+">"),
e=e+'<div class="form-docref">',e=this.dm.origDocRow?e+('<span class="form-label">'+a.xmlencode(j.t("DocRowLocalRemoteMakeLocal"))+":</span>"):e+('<span class="form-label">'+a.xmlencode(this.dm.dlsName)+" ("+a.xmlencode(this.dm.docOperation)+"):</span>"),e=e+('<span class="form-inline-field">'+a.xmlencode(this.dm.selDocName)+"</span>"),e=e+'<div class="DocumentNameRow">';if(c||d)if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var i="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",
g=this.dm.docNameSuffix?this.dm.docNameSuffix:"",e=e+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentSuffix"))),e=e+('" maxlength="250" size="40" onchange="'+i+'" value="'+a.xmlencode(g)+'"/>');else e+='<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName")),e+='" maxlength="250" size="40" disabled="disabled"/>';else var n=this.dm.docName?this.dm.docName:"",m="javascript: "+this.dm.getThisInDOM()+
".docNameChanged(this.value);",e=e+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName"))),e=e+('" maxlength="250" size="40" onchange="'+m+'" value="'+a.xmlencode(n)+'"/>');var o="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",p=this.dm.docDesc?this.dm.docDesc:"";c?e+='<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+
o+'" value="'+a.xmlencode(p)+'"/>':0<p.length&&(d||(e+='<div class="DocumentDescriptionRow">'),e+="<span>"+a.xmlencode(j.t("DocRowDocumentDescription"))+":</span>",e+='<span class="form-inline-field-indent">'+a.xmlencode(p)+"</span>",d||(e+="</div>"));e+="</div>";if(c||d||h)e+='<div id="'+(this.phElemID+"_docTempFolderSelPHID")+'" class=DocumentTemplateAndFolderRow">',c&&(e+=this.renderDocTemplateSelector()),e+=this.renderDocFolderSelector(),e+="</div>";e+="</div>";e+="</"+this.itemRootElemStr+">";
f.append(e)}catch(r){b.log("Problem in DocumentRowSearchView.renderDocumentSpec:\n"+r)}};h.prototype.renderLocalRemoteButton=function(f){try{var e="",e=e+("<"+this.itemRootElemStr+' class="center">');if(this.dm.origDocRow)var c="javascript: "+this.dm.getParentInDOM()+".localRemoteButtonClicked("+this.rowIndex+");",d=a.xmlencode(j.t("DocRowLocalRemoteResetButtonTooltip")),e=e+('<img border="0" src="'+window.webcenterConfig.jspBaseUrl+'images/round_button_reset.png"'),e=e+(' title="'+d+'" onclick="'+
c+'"/>');e+="</"+this.itemRootElemStr+">";f.append(e)}catch(h){b.log("Problem in StaticDocumentRowView.renderLocalRemoteButton:\n"+h)}};return h});
define("doctablex/DocumentRowSearch","doctablex/DocumentRow doctablex/DocTableXUtils doctablex/DocumentRowSearchView doctablex/AJAXDataCache wcr/webcenter_xml jquery".split(" "),function(f,b,j,a,h,k){var e=function(a){if(!a)return this;a.viewClass||(a.viewClass=j);f.call(this,a);this.dlsName=a.dlsName||"Search";this.docOperation||(this.docOperation="Copy");if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.fileExt=b.getFileExtension(this.docName,!0);this.selDocName=
this.docName;this.hasOrigDocACat=!1;this.constructor==e.prototype.constructor&&this._initializeFromServer();return this};e.prototype=new f;e.prototype.constructor=e;e.prototype.parent=f.prototype;e.prototype._initializeFromServer=function(){this.setStatus("loading");var c=this.updateDocInfoFromServer(!1);c.done(function(){this.docDesc="";"Copy"==this.docOperation&&(this.docVerIdx="1",this.docRevLetter="");var c=a.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),b=null,e=null;"Copy"==
this.docOperation&&(b=a.getInstance().getDocTemplatesByProjID(this.project.id));var g=null;"Reference"!=this.docOperation&&(g=a.getInstance().getFoldersByProjID(this.project.id));e=this.updateDocAttrCategoryFromServer();k.when(c,b,g,e).done(function(a,c,b){this.useDocTypeDefaultACat=this.hasNoAttrCat()&&"Copy"==this.docOperation;this.hasOrigDocACat=this.hasAttrCat();this.updateDocumentType(a,!1);c&&(this.updateDocTemplates(c),this.preselectDocTemplate());this.updateTargetFolders(b);this.preselectTargetFolder();
this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Failed to load document configuration from the server.\n"+a)}.bind(this))}.bind(this));c.fail(function(a){this.setStatus("error");b.log("Failed to process basic info about document loaded from the server.\n"+a)}.bind(this))};e.prototype.isAutonamingEnabled=function(){return this.anPrefix&&0<this.anPrefix.length&&"Copy"==this.docOperation};e.prototype.canUserEditAttributes=
function(){var a=!1,a=this.userPerms?this.userPerms.change:!1,b=this.selTargetFolder?this.selTargetFolder.changePropPerm:!1,a="Reference"==this.docOperation?a:"Link"==this.docOperation?a||b:b;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};e.prototype.generateDocAttributeValuesAJAXURL=function(){var a=window.webcenterConfig.jspBaseUrl;this.selDocTemplate&&this.selDocTemplate.docVerID&&b.isValidID(this.selDocTemplate.categoryID)?(a=a+"GetAttributes.jsp?doctemplate=1"+
("&projectid="+this.project.id),a+="&documentid="+this.selDocTemplate.id,a+="&docverid="+this.selDocTemplate.docVerID,a+="&categoryid="+this.selDocTemplate.categoryID):this.hasOrigDocACat&&this.docVerID?a+="GetAttributes.jsp?docverid="+this.docVerID:b.isValidID(this.aCatID)?a+="GetAttributes.jsp?categoryid="+this.aCatID:b.log("Cannot generate URL in DocumentRowSearch.generateDocAttributeValuesAJAXURL().");return a};e.prototype.convertToXML=function(){var a="";try{if(this.isInErrorStatus())return a;
var d="<ds>",d=d+h.ElementEncode("action",this.docOperation);this.docVerID&&(d+=h.ElementEncode("source_dv_id",this.docVerID));this.project.id&&(d+=h.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(d+=h.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?d+=h.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(d+=h.ElementEncode("doc_name",this.docName));this.docDesc&&(d+=h.ElementEncode("doc_description",
this.docDesc));this.hasAttrCat()&&(d+=h.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(d+=h.ElementEncode("doc_temp_id",this.selDocTemplate.id),d+=h.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));a=e.prototype.parent.convertToXML.call(this,d+"</ds>")}catch(f){b.log("Problem in DocumentRowSearch.convertToXML:\n"+f),a=""}return a};e.prototype.getAttCatView=function(){var a=!1,d=b.getRenderItem(this.renderOptions.columns,"AttributeFlapout");d&&!1===d.useCreationView&&
(a=!0);return!a&&"Copy"==this.docOperation?"Creation":this.aCatView||"Default"};return e});
define("doctablex/DocumentRowBrowseView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(f,b,j,a){var h=function(a,b,c){if(!a&&!b&&!c)return this;f.call(this,a,b,c);return this};h.prototype=new f;h.prototype.constructor=h;h.prototype.parent=f.prototype;h.prototype.render=function(a){b.preserveFileInputs(this.phElemID);h.prototype.parent.render.call(this,a);b.reinsertPreservedFileInputs(this.dm.fileInputName)};h.prototype.renderThumbnail=
function(a,e){try{var c="",c=c+("<"+this.itemRootElemStr+">"),c=c+this.customThumbnailHTML("thumbnails/other.gif",e.thumbnailSize),c=c+("</"+this.itemRootElemStr+">");a.append(c)}catch(d){b.log("Problem in DocumentRowBrowseView.renderThumbnail:\n"+d)}};h.prototype.renderDocumentSpec=function(f){try{var e=this.dm.fileInputName,c="",c=c+("<"+this.itemRootElemStr+">"),c=c+'<div class="form-docref">',c=c+('<label for="'+e+'" class="form-label">'+this.dm.dlsName+":</label>"),d="javascript: "+this.dm.getThisInDOM()+
".fileChanged(this);",c=c+('<input type="file" name="'+e+'" size="30" onchange="'+d+'"/>'),c=c+'<div class="DocumentNameRow">';if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var h="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",i=this.dm.docNameSuffix?this.dm.docNameSuffix:"",c=c+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentSuffix"))),c=c+('" maxlength="250" size="40" onchange="'+h+'" value="'+
i+'"/>');else c+='<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName")),c+='" maxlength="250" size="40" disabled="disabled"/>';else var g="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",n=this.dm.docName?this.dm.docName:"",c=c+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName"))),c=c+('" maxlength="250" size="40" onchange="'+g+'" value="'+n+'"/>');var m="javascript: "+
this.dm.getThisInDOM()+".docDescChanged(this.value);",o=this.dm.docDesc?this.dm.docDesc:"",c=c+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+m+'" value="'+o+'"/>'),c=c+"</div>",c=c+('<div id="'+(this.phElemID+"_docTempFolderSelPHID")+'" class="DocumentTemplateAndFolderRow">'),c=c+this.renderDocTemplateSelector(),c=c+this.renderDocFolderSelector(),c=c+"</div>",c=c+("</"+this.itemRootElemStr+
">");f.append(c)}catch(p){b.log("Problem in DocumentRowBrowseView.renderDocumentSpec:\n"+p)}};return h});
define("doctablex/DocumentRowBrowse","doctablex/DocumentRow doctablex/DocumentRowBrowseView doctablex/AJAXDataCache doctablex/DocTableXUtils doctablex/DocumentTypeUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(f,b,j,a,h,k,e,c){var d=function(a){if(!a)return this;a.viewClass||(a.viewClass=b);f.call(this,a);this.isValidFileSelected=!1;this.fileInputName=this.getRowPrefix()+"_fileForm";this.dlsName=a.dlsName||"Upload";this.docOperation="Upload";this.allowedFileExts=a.allowedFileExts||
[];this.origFileExt=null;this.project={id:this.getParentDocTable().projectID};this.useDocTypeDefaultACat=!0;this.constructor==d.prototype.constructor&&this._initializeFromServer();return this};d.prototype=new f;d.prototype.constructor=d;d.prototype.parent=f.prototype;d.prototype._initializeFromServer=function(){if(!this.docTemplates&&this.project.id){this.setStatus("loading");var a=j.getInstance().getDocTemplatesByProjID(this.project.id),b=j.getInstance().getFoldersByProjID(this.project.id);c.when(a,
b).done(function(a,c){this.updateDocTemplates(a);this.preselectDocTemplate();this.updateTargetFolders(c);this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Problem with retrieving document templates:\n"+a)}.bind(this))}else this.docTemplates?this.setStatus("ready"):this.setStatus("error")};d.prototype.getIsValidFileSelected=function(){return this.isValidFileSelected};d.prototype.resetDocument=
function(a){this.isValidFileSelected=!1;c(a).removeClass("docTableFileInputToPreserve");this.docType=this.docTypeID=null;d.prototype.parent.resetDocument.call(this,!1)};d.prototype.convertToXML=function(){var c="";try{if(this.isInErrorStatus()||!this.getIsValidFileSelected())return c;var b="<ds>",b=b+e.ElementEncode("action",this.docOperation);this.fileInputName&&(b+=e.ElementEncode("file_form_field",this.fileInputName));this.project.id&&(b+=e.ElementEncode("project_id",this.project.id));this.selTargetFolder&&
(b+=e.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?b+=e.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(b+=e.ElementEncode("doc_name",this.docName));this.docDesc&&(b+=e.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(b+=e.ElementEncode("doc_attr_cat_id",this.aCatID));this.selDocTemplate&&(b+=e.ElementEncode("doc_temp_id",this.selDocTemplate.id),b+=e.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName));
c=d.prototype.parent.convertToXML.call(this,b+"</ds>")}catch(g){a.log("Problem in DocumentRow.convertToXML:\n"+g),c=""}return c};d.prototype.validateDocRow=function(a,b){var e=!0,f=c("input[name="+this.fileInputName+"]");1==f.length&&!f.val()&&(e={isBlocking:!0,level:b,msg:k.t("DocRowFileNotChosen"),element:f,docRowObj:this},a.errors.push(e),e=!1);d.prototype.parent.validateDocRow.call(this,a,b)||(e=!1);return e};d.prototype.fileChanged=function(b){if(this.isInConfigPreview())alert(k.t("DocSrcHdlNoProjectInConfig"));
else{this.setStatus("loading");var d=b.value;d&&(this.resetDocument(b),-1!=d.lastIndexOf("\\")?d=d.substring(d.lastIndexOf("\\")+1):-1!=d.lastIndexOf("/")?d=d.substring(d.lastIndexOf("/")+1):-1!=d.lastIndexOf(":")&&(d=d.substring(d.lastIndexOf(":")+1)),this.origFileExt=a.getFileExtension(d,!0),this.allowedFileExts&&0<this.allowedFileExts.length&&-1==this.allowedFileExts.indexOf(this.origFileExt)?(alert(k.t("notAllowedDocExtension")+this.allowedFileExts.toString()),this.view.repaintRow()):(this.docName=
d,this.setIsChanged(),c(b).addClass("docTableFileInputToPreserve"),this.isValidFileSelected=!0,d=j.getInstance(),b=d.getEffectiveDocTypesSettingsByProjID(this.project.id),d=d.getDocTemplatesByProjID(this.project.id),c.when(b,d).done(function(a,c){this.docTypeID=h.getDocTypeIDByExtension(this.origFileExt);this.updateDocumentType(a,!1);this.updateDocTemplates(c);this.isModifiedByUser("docTemplate")||this.preselectDocTemplate();this.preselectTargetFolder();this.setStatus("ready");this.view.repaintRow();
this.showDocAttributeCategory(!1,!0)}.bind(this)).fail(function(a){this.setStatus("error");alert("Failed to process document configuration from the server.\n"+a)}.bind(this))))}};d.prototype.getAttCatView=function(){var c=a.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return c&&!1===c.useCreationView?this.aCatView||"Default":"Creation"};return d});
define("doctablex/DocumentRowNewView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml","jquery"],function(f,b,j,a,h){var k=function(a,c,b){if(!a&&!c&&!b)return this;f.call(this,a,c,b);return this};k.prototype=new f;k.prototype.constructor=k;k.prototype.parent=f.prototype;k.prototype.getDocTemplateDialogPlaceholder=function(){var b=h("#"+this.dm.docTempDialogPHID);0==b.length&&(b=h('<div id="'+this.dm.docTempDialogPHID+'"></div>').appendTo("body"),
b.attr("style","display: none; background-color: #F7F7F7; border-collapse: collapse; border-bottom: 1px solid #dfdfdf;"),b.attr("title",a.xmlencode(j.t("SELECTDOCTEMPLATE"))));return b};k.prototype.renderDocTemplateDialog=function(){var b=h("#"+this.dm.docTempDialogPHID);if(!this.dm.docTemplates||0==this.dm.docTemplates.length||1!=b.length)return null;h("#docTemplateDialogFilter").off();h(".docTemplatesList").off();b.empty();var c=h('<div class="docTemplatesFilterRow darktext_darklink_11"></div>'),
d="<span>"+a.xmlencode(j.t("PROJDETAILSTOTALDOCS_TAG"))+": "+this.dm.docTemplates.length+"</span>",d=d+('<span class="form-inline-field-indent">'+a.xmlencode(j.t("FILTER"))+":</span>");c.html(d+'<input class="form-field-small form-inline-field-indent" id="docTemplateDialogFilter" name="docTemplateDialogFilter"/>');c.find("#docTemplateDialogFilter").on("keyup",function(){var a=h(this).val().toLowerCase();0<a.length?h("div.docTemplateRow").each(function(c,b){-1!=h(b).find("div.docTemplateName").text().toLowerCase().indexOf(a)?
h(b).show():h(b).hide()}):h("div.docTemplateRow").show()});b.append(c);c=h('<div class="docTemplatesList" style="overflow: auto; height: 350px; background-color: #FFFFFF;"></div>');c.on("click",function(a){h('input[name="docTemplateSelectOption"]:checked').attr("checked",!1);a.target.checked=!0});for(var d="",f=0;f<this.dm.docTemplates.length;f++){var i=this.dm.docTemplates[f],d=d+'<div class="docTemplateRow">',d=d+('<input type="radio" value="'+f+'" name="docTemplateSelectOption"');0==f&&(d+=" checked");
d+="/>";d+='<img class="form-inline-field-indent" src="'+i.thumbnailURL+'" width="50" height="50" border="0" align="middle">';d+='<div class="docTemplateName form-inline-field-indent">'+a.xmlencode(i.name)+"</div>";d+="</div>"}c.html(d);b.append(c);h("#popitmenu").css("z-index",1200);return b};k.prototype.renderDocumentSpec=function(e){try{var c="",c=c+("<"+this.itemRootElemStr+">"),c=c+'<div class="form-docref">',c=c+('<span class="form-label">'+a.xmlencode(this.dm.dlsName)+":</span>"),c=c+('<span class="form-inline-field">'+
a.xmlencode(this.dm.selDocTemplate.name)+"</span>"),c=c+'<div class="DocumentNameRow">';if(this.dm.isAutonamingEnabled())if(this.dm.hasAutonameSuffix())var d="javascript: "+this.dm.getThisInDOM()+".docNameSuffixChanged(this.value);",f=this.dm.docNameSuffix?this.dm.docNameSuffix:"",c=c+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentSuffix"))),c=c+('" maxlength="250" size="40" onchange="'+d+'" value="'+a.xmlencode(f)+'"/>');else c+='<input type="text" class="form-control form-field-medium" placeholder="'+
a.xmlencode(j.t("DocRowDocumentName")),c+='" maxlength="250" size="40" disabled="disabled"/>';else var i=this.dm.docName?this.dm.docName:"",g="javascript: "+this.dm.getThisInDOM()+".docNameChanged(this.value);",c=c+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentName"))),c=c+('" maxlength="250" size="40" onchange="'+g+'" value="'+a.xmlencode(i)+'"/>');var h="javascript: "+this.dm.getThisInDOM()+".docDescChanged(this.value);",k=this.dm.docDesc?
this.dm.docDesc:"",c=c+('<input type="text" class="form-control form-field-medium" placeholder="'+a.xmlencode(j.t("DocRowDocumentDescription"))+'" maxlength="250" size="40" onchange="'+h+'" value="'+a.xmlencode(k)+'"/>'),c=c+"</div>",c=c+('<div id="'+(this.phElemID+"_folderSelPHID")+'" class="FolderRow">'),c=c+this.renderDocFolderSelector(),c=c+"</div>",c=c+"</div>",c=c+("</"+this.itemRootElemStr+">");e.append(c)}catch(o){b.log("Problem in DocumentRowNewView.renderDocumentSpec:\n"+o)}};return k});
define("doctablex/DocumentRowNew","doctablex/DocumentRow doctablex/DocumentRowNewView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(f,b,j,a,h,k,e){var c=function(a){if(!a)return this;a.viewClass||(a.viewClass=b);f.call(this,a);this.dlsName=a.dlsName||"New";this.docOperation="New";if(!this.project||!this.project.id)this.project={id:this.getParentDocTable().projectID};this.docTempDialogPHID=a.docTempDialogPHID;this.docTempDialogPHID||
(this.docTempDialogPHID="docTemplateDialogPHID");this.isDocTempDialogInitialized=!1;this.constructor==c.prototype.constructor&&this._initializeFromServer();return this};c.prototype=new f;c.prototype.constructor=c;c.prototype.parent=f.prototype;c.prototype._initializeFromServer=function(){this.setStatus("loading");var a=j.getInstance().getDocTemplatesByProjID(this.project.id,!0),b=j.getInstance().getFoldersByProjID(this.project.id);e.when(a,b).done(function(a,b){this.updateDocTemplates(a);this.updateTargetFolders(b);
this.showDocTemplateDialog()}.bind(this)).fail(function(a){this.isInConfigPreview()?alert(h.t("DocSrcHdlNoDocTempInConfig")):(this.setStatus("error"),alert("Failed to load document templates from the server.\n"+a))}.bind(this))};c.prototype.showDocTemplateDialog=function(){if(this.docTemplates)if(0==this.docTemplates.length)alert(h.t("DocSrcHdlNoDocTempComplyFilter"));else if(1==this.docTemplates.length)this.updateDocTemplateSelection(0),this.preselectTargetFolder(),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!0,!0);else{var a=this.view.getDocTemplateDialogPlaceholder();if(!this.isDocTempDialogInitialized){var b={};b[h.t("CANCEL")]=function(){a.dialog("close")}.bind(this);b[h.t("OK")]=function(){this.setStatus("loading");var b=e('input[name="docTemplateSelectOption"]:checked:visible');0==b.length?alert(h.t("SELECTDOCTEMPLATE")+"."):(this.updateDocTemplateSelection(b.val()),this.preselectTargetFolder(),a.dialog("close"),this.parentDocTable.addDocTemplateRow(this),
this.setStatus("ready"),this.showDocAttributeCategory(!0,!0))}.bind(this);a.dialog({autoOpen:!1,modal:!1,draggable:!0,resizable:!0,overflow:scroll,width:500,buttons:b});null!=this.view.renderDocTemplateDialog()&&(this.isDocTempDialogInitialized=!0)}a.dialog("open");this.setStatus("wait4user")}};c.prototype.updateDocTemplateSelection=function(a){c.prototype.parent.updateDocTemplateSelection.call(this,a);this.selDocTemplate&&(this.docName=this.selDocTemplate.name,this.thumbnailURL=this.selDocTemplate.thumbnailURL,
this.docTypeID=this.selDocTemplate.docTypeID);var a=j.getInstance().getEffectiveDocTypesSettingsByProjID(this.project.id),b="resolved"==a.state();a.done(function(a){this.updateDocumentType(a,!b)}.bind(this));a.fail(function(a){alert("Failed to load document templates from the server.\n"+a)})};c.prototype.convertToXML=function(){var b="";try{if(this.isInErrorStatus())return b;var e="<ds>",e=e+k.ElementEncode("action",this.docOperation),e=e+k.ElementEncode("template_dv_id",this.selDocTemplate.docVerID);
this.project.id&&(e+=k.ElementEncode("project_id",this.project.id));this.selTargetFolder&&(e+=k.ElementEncode("target_folder_name",this.selTargetFolder.name));this.isAutonamingEnabled()?e+=k.ElementEncode("doc_name_suffix",this.docNameSuffix?this.docNameSuffix:""):this.docName&&(e+=k.ElementEncode("doc_name",this.docName));this.docDesc&&(e+=k.ElementEncode("doc_description",this.docDesc));this.hasAttrCat()&&(e+=k.ElementEncode("doc_attr_cat_id",this.aCatID));e+=k.ElementEncode("doc_temp_id",this.selDocTemplate.id);
e+=k.ElementEncode("doc_temp_folder_name",this.selDocTemplate.folderName);b=c.prototype.parent.convertToXML.call(this,e+"</ds>")}catch(f){a.log("Problem in DocumentRowNew.convertToXML:\n"+f),b=""}return b};c.prototype.getAttCatView=function(){var b=a.getRenderItem(this.renderOptions.columns,"AttributeFlapout");return b&&!1===b.useCreationView?this.aCatView||"Default":"Creation"};return c});
define("doctablex/DocumentRowLinkView",["doctablex/DocumentRowView","doctablex/DocTableXUtils","utils/webi18n!DocRefStrings","wcr/webcenter_xml"],function(f,b,j,a){var h=function(a,b,c){if(!a&&!b&&!c)return this;f.call(this,a,b,c);return this};h.prototype=new f;h.prototype.constructor=h;h.prototype.parent=f.prototype;h.prototype.renderDocumentSpec=function(f,e){try{var c="",c=c+("<"+this.itemRootElemStr+">"),c=c+this.renderInlineLabel(e);if(this.dm.isInErrorStatus())c=this.dm.isInConfigPreview()?
c+("<span>"+j.t("DocSrcHdlNoProjectInConfig")+"</span>"):c+("<span>"+j.t("DocRowLoadingDocsError")+"</span>");else{c+='<div class="form-docref">';c+='<div class="DocumentNameRow">';if(this.dm.docsInCurrentProject)if(0==this.dm.docsInCurrentProject.length)c+="<span>"+j.t("DocRowNoDocsAvailable")+"</span>";else{for(var d="javascript: "+this.dm.getThisInDOM()+".docVersionSelected(this.value);",c=c+('<select class="form-control form-field-medium form-dropdown-field" onChange="'+d+'">'),c=c+('<option value="">'+
a.xmlencode(j.t("DocRowPleaseSelect"))+"</option>"),d=0;d<this.dm.docsInCurrentProject.length;d++)var h=this.dm.docsInCurrentProject[d].id,i=this.dm.docsInCurrentProject[d].name,c=c+('<option value="'+h+'"'+(this.dm.docVerID==h?' selected="selected"':"")+">"),c=c+(a.xmlencode(i)+"</option>");c+="</select>"}else c+="<span>"+j.t("DocRowLoadingDocs")+"</span>";c+="</div>";c+="</div>"}c+="</"+this.itemRootElemStr+">";f.append(c)}catch(g){b.log("Problem in DocumentRowLinkView.renderDocumentSpec:\n"+g)}};
h.prototype.renderThumbnail=function(a,e){try{if(this.dm.docVerID)h.prototype.parent.renderThumbnail.call(this,a,e);else{var c="<"+this.itemRootElemStr+">",c=c+this.customThumbnailHTML("thumbnails/other.gif",e.thumbnailSize),c=c+("</"+this.itemRootElemStr+">");a.append(c)}}catch(d){b.log("Problem in DocumentRowLinkView.renderThumbnail:\n"+d)}};return h});
define("doctablex/DocumentRowLink","doctablex/DocumentRow doctablex/DocumentRowLinkView doctablex/AJAXDataCache doctablex/DocTableXUtils utils/webi18n!DocRefStrings wcr/webcenter_xml jquery".split(" "),function(f,b,j,a,h,k,e){var c=function(a){if(!a)return this;a.viewClass||(a.viewClass=b);f.call(this,a);this.dlsName=a.dlsName||"Link";this.docOperation="Reference";this.project={id:this.getParentDocTable().projectID};this.docsInCurrentProject=null;this.constructor==c.prototype.constructor&&this._initializeFromServer();
return this};c.prototype=new f;c.prototype.constructor=c;c.prototype.parent=f.prototype;c.prototype._initializeFromServer=function(){if(this.project.id){this.setStatus("loading");var a=j.getInstance().getDocVersionsByProjID(this.project.id);a.done(function(a){this.initDocsInCurrentProject(a);this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this));a.fail(function(a){this.setStatus("error");alert(h.t("DocRowLoadingDocsError")+":\n"+a)}.bind(this))}else this.setStatus("error")};
c.prototype.resetDocument=function(){c.prototype.parent.resetDocument.call(this,!0)};c.prototype.initDocsInCurrentProject=function(a){this.docsInCurrentProject=!a||0==a.length?[]:a};c.prototype.canUserEditAttributes=function(){var a=this.userPerms?this.userPerms.change:!1;return this.isEditable&&!this.isInErrorStatus()&&this.isLatestDocVersion()&&!this.dependsOnItself&&a};c.prototype.generateDocAttributeValuesAJAXURL=function(){return c.prototype.parent.parent.generateDocAttributeValuesAJAXURL.call(this)};
c.prototype.convertToXML=function(){var b="";try{if(this.isInErrorStatus()||!this.docVerID)return b;var e="<ds>",e=e+k.ElementEncode("action",this.docOperation);this.docVerID&&(e+=k.ElementEncode("source_dv_id",this.docVerID));b=c.prototype.parent.convertToXML.call(this,e+"</ds>")}catch(f){a.log("Problem in DocumentRowLink.convertToXML:\n"+f),b=""}return b};c.prototype.validateDocRow=function(a,b){var f=!0,g=e("#"+this.getRowPrefix()+" div.DocumentNameRow > select:first");1==g.length&&!g.val()&&(f=
{isBlocking:!0,level:b,msg:h.t("DocRowDocNotSelected"),element:g,docRowObj:this},a.errors.push(f),f=!1);c.prototype.parent.validateDocRow.call(this,a,b)||(f=!1);return f};c.prototype.docVersionSelected=function(b){this.docVerID!=b&&(this.resetDocument(),this.setStatus("loading"),this.docVerID=b,this.getParentDocTable().isDocDependentOnItself(this)&&(confirm(h.t("DocRowDocDependentOnItself"))?this.setDependsOnItself(!0):this.docVerID=""),""==this.docVerID?(this.setStatus("ready"),this.view.repaintRow(),
this.hideDocAttributeCategory()):(b=this.updateDocInfoFromServer(!1),b.done(function(){this.setStatus("ready");this.view.repaintRow();this.showDocAttributeCategory(!0,!0)}.bind(this)),b.fail(function(b){this.setStatus("error");a.error("Failed to load document information from the server:\n"+b)})))};return c});
define("doctablex/DocTableX","wcr/webcenter_xml doctablex/DocTableXView doctablex/DocTableXUtils doctablex/AJAXDataCache doctablex/DocumentRowSearch doctablex/DocumentRowBrowse doctablex/DocumentRowNew doctablex/DocumentRowLink utils/webi18n!DocRefStrings jquery wcr/search wcr/extpopup".split(" "),function(f,b,j,a,h,k,e,c,d,l){var i=function(a){if(!a)return this;this.isInConfigPreview=a.isInConfigPreview||!1;this.currentUser=a.currentUser||null;this.onChangeCallback=a.onChangeCallback||null;this.docRows=
[];this.isChanged=!1;this.parentDocVerIDs=a.parentDocVerIDs||[];this.phElemID=a.phElemID;this.saveXMLRootTag="dtval";a.saveXMLRootTag&&(this.saveXMLRootTag=f.xmlencode(a.saveXMLRootTag));this.thisInDOM="document.getElementById('"+this.phElemID+"').docTable";this.greenLinksPrefix;this._setPrefix(a.prefix);this.dshObj=a.dshObj;if(!this.dshObj)return alert("Document table cannot be created without DocumentSourceHandler reference!"),null;this.isEditable=a.isEditable||!1;this.currentUser&&!1==this.currentUser.canEditAttributes&&
(this.isEditable=!1);this.isInactive=a.isInactive||!1;this.parentACatNotExpandedYet=a.parentACatNotExpandedYet||!1;this.clearValues=a.clearValues||!1;this.allowMultiple=a.allowMultiple||!1;this.projectID=a.projectID||null;this.canUserAddDocuments=this.hasDocumentTemplates=this.isInConfigPreview;this.aCatView=a.aCatView;var c={renderMethod:"list",showGreenLinksOnTop:!0,showGreenLinksAtBottom:!1};this.renderOptions=a.renderOptions||c;this.propsACatID=a.propsACatID||null;null==j.getRenderItem(this.renderOptions.columns,
"ReferenceProperty")&&(this.propsACatID=null);this.constructor==i.prototype.constructor&&(this.view=new b(this,this.phElemID,this.renderOptions),this._initializeFromServer());return this};i.prototype._initializeFromServer=function(){if(!this.isInConfigPreview)if(this.projectID){var b=a.getInstance().getDocTemplatesByProjID(this.projectID,!0),c=a.getInstance().getFoldersByProjID(this.projectID);l.when(b,c).done(function(a,b){var c=this.hasDocumentTemplates,d=this.canUserAddDocuments;this.hasDocumentTemplates=
a&&0<a.length;this.canUserAddDocuments=b&&0<b.length;if(this.hasDocumentTemplates!=c||this.canUserAddDocuments!=d)this.view.renderDocSourceLinks(),this.canUserAddDocuments!=d&&this.view.repaintRemoteDocRows()}.bind(this)).fail(function(a){alert("Failed to load data needed to initialize DocTableX instance from the server.\n"+a)})}else j.log("DocTableX._initializeFromServer(): There is no project ID to load configuration for.")};i.prototype.setIsChanged=function(){if(this.onChangeCallback)this.onChangeCallback();
this.isChanged=!0};i.prototype.getIsChanged=function(){if(this.isChanged)return!0;for(var a=0;a<this.docRows.length;a++){var b=this.docRows[a];if(b&&b.getIsChanged())return!0}return!1};i.prototype._setPrefix=function(a){a||(a="");this.prefix=a;this.greenLinksPrefix=a+"_greenLinks"};i.prototype.getTablePrefix=function(){return this.prefix};i.prototype.getThisInDOM=function(){return this.thisInDOM};i.prototype.getRowByID=function(a){for(var b=0;b<this.docRows.length;b++){var c=this.docRows[b];if(c.rowID==
a)return c}return null};i.prototype.getDocumentSourceOptions=function(a){return{docTable:this,hasDocumentTemplates:this.hasDocumentTemplates,canUserAddDocuments:this.canUserAddDocuments,linksId:a}};i.prototype.hasLocalRemoteButton=function(){return null!=j.getRenderItem(this.renderOptions.columns,"LocalRemote")};i.prototype.reset=function(){this.docRows=[];this.parentDocVerIDs=[];this.isChanged=!1};i.prototype.setCustomView=function(a,b){a&&(a.dm=this,a.phElemID||(a.phElemID=this.phElemID),a.renderOptions||
(a.renderOptions=this.renderOptions),this.view=a,b&&this.displayTable())};i.prototype.setIsEditable=function(a,b){if(void 0!==a&&a!=this.isEditable){this.isEditable=a;for(var c=0;c<this.docRows.length;c++)this.docRows[c].setIsEditable(a)}b&&this.displayTable()};i.prototype.setIsInactive=function(a){void 0!==a&&a!=this.isInactive&&(this.isInactive=a)};i.prototype.hasSameContentAs=function(a){if(this.docRows&&!a||!this.docRows&&a||this.docRows&&this.docRows.length!=a.length)return!1;for(var b=0;b<this.docRows.length;b++){var c=
this.docRows[b],d=a[b];if(c&&!d||!c&&d||c&&c.docVerID!=d.docVerID)return!1;var e=c.props?c.props:[];if(e.length!=(d.props?d.props:[]).length)return!1;for(var f=0;f<e.length;f++){var h=e[f];if(h&&h.id){var i=d.findPropertyByID(h.id);if(!i)return!1;if(c.propsACatObj&&c.propsACatObj.loaded){if((h=c.propsACatObj.findAttribute(h.id,h.name))&&h.value!=i.value)return!1}else if(h.value!=i.value)return!1}}}return!0};i.prototype.initWithDocRows=function(a,b){if(!a)return!1;for(var c=0;c<a.length;c++){var d=
a[c];if(d){if(this!==d.getParentDocTable())return!1;this.isDocDependentOnItself(d)&&d.setDependsOnItself(!0);this.docRows.push(d)}}b&&this.displayTable();return!0};i.prototype._insertRow=function(a,b,c){this.isDocDependentOnItself(a)&&a.setDependsOnItself(!0);if(this.allowMoreToAdd())null!=b&&b<this.getNumberOfRows()?(0>b&&(b=0),this.docRows.splice(b,0,a)):this.docRows.push(a);else if(confirm(d.t("DocTableReplaceSingleValueQ")))this.docRows[this.getNumberOfRows()-1]=a;else return!1;c&&this.displayTable();
return!0};i.prototype.appendDocRow=function(a,b,c){a.parentDocTable=this;a=new b(a);return this._insertRow(a,null,c)};i.prototype.addDocRow=function(a,b,c,e,f){a.parentDocTable=this;a=new b(a);if(e&&this.isDocDependentOnItself(a)&&!confirm(d.t("DocTableCycleDependencyWarning")))return!1;f||(f=0);return this._insertRow(a,f,c)};i.prototype.addDocRows=function(a,b,c){for(var d=!1,e=0;e<a.length;e++)this.addDocRow(a[e],b,e==a.length-1,c,e)&&(d=!0);d&&c&&this.setIsChanged()};i.prototype.addSearchDocRows=
function(a,b){this.addDocRows(a,h,b)};i.prototype.addBrowseRow=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,allowedFileExts:j._getFileExtensionsList(a.documentType),docTempType:a.docTemplateType,docTempNames:j._getDocTemplateNameList(a.docTemplateName)};this.addDocRow(a,k,!0,!0)&&this.setIsChanged()};i.prototype.addLinkRow=function(a){a={parentDocTable:this,dlsName:a.dlsObj.label.getLabel()};this.addDocRow(a,c,!0,!0)&&this.setIsChanged()};
i.prototype.addDocTemplateRow=function(a){a&&this._insertRow(a,0,!0)&&this.setIsChanged()};i.prototype.openDocTemplateDialog=function(a){a=a.dlsObj;a={parentDocTable:this,dlsName:a.label.getLabel(),targetFolderName:a.targetFolder,docTempType:a.docTemplateType,docTempNames:j._getDocTemplateNameList(a.docTemplateName)};new e(a)};i.prototype.getDocTemplateNameList=function(a){return j._getDocTemplateNameList(a)};i.prototype.isDocDependentOnItself=function(a){var b=this.parentDocVerIDs;return a.docVerID&&
b&&-1!=b.indexOf(a.docVerID)};i.prototype.getNumberOfRows=function(){return this.docRows.length};i.prototype.allowMoreToAdd=function(){return this.allowMultiple||1>this.getNumberOfRows()};i.prototype.displayTable=function(){var a=this.view.render();a&&1==a.length&&(a[0].docTable=this)};i.prototype.convertToXML=function(){var a="";try{a+="<"+this.saveXMLRootTag+">";this.isEditable||(a+=f.ElementEncode("readonly","1"));for(var b=0;b<this.docRows.length;b++)a+=this.docRows[b].convertToXML();a+="</"+
this.saveXMLRootTag+">"}catch(c){j.log("Problem in DocTableX.convertToXML:\n"+c),a=""}return a};i.prototype.validateDocTable=function(a,b){if(!this.isInactive)for(var c=0;c<this.docRows.length;c++)this.docRows[c].validateDocRow(a,b)};i.prototype.onSubmit=function(){this.clearValues&&(this.docRows=[]);if(!this.isInactive||this.clearValues){var a=this.getTablePrefix(),a=l("#"+a);0<a.length&&a.val(this.convertToXML())}if(!this.isInactive)for(a=0;a<this.docRows.length;a++)this.docRows[a]._onSubmit()};
i.prototype.localRemoteButtonClicked=function(a){if(!(0>a)){var b=this.docRows[a];b.deleteItself(!0);b.origDocRow?this.docRows[a]=b.origDocRow:(b={parentDocTable:this,docVerID:b.docVerID,docID:b.docID,docName:b.docName,dlsName:d.t("DocRowMakeLocalAction"),targetFolderName:b.targetFolderName,projectID:this.projectID,operation:"Copy",docTempType:b.docTempType,docTempNames:b.docTempNames,properties:b.props,origDocRow:b},this.docRows[a]=new h(b));this.docRows[a].displayRow()}};i.prototype.deleteButtonClicked=
function(a){if(!(0>a))if(this.docRows[a].deleteItself(),this.docRows.splice(a,1),this.setIsChanged(),0<this.getNumberOfRows())for(a=0>a-1?0:a-1;a<this.getNumberOfRows();a++)this.docRows[a].view.repaintRow();else this.displayTable()};i.prototype.moveUpButtonClicked=function(a){if(0<a){var b=this.docRows[a-1];this.docRows[a-1]=this.docRows[a];this.docRows[a]=b;this.docRows[a].swapWith(this.docRows[a-1]);this.setIsChanged()}};i.prototype.moveDownButtonClicked=function(a){if(a<this.getNumberOfRows()-
1){var b=this.docRows[a+1];this.docRows[a+1]=this.docRows[a];this.docRows[a]=b;this.docRows[a+1].swapWith(this.docRows[a]);this.setIsChanged()}};i.prototype.expandCollapseAllClicked=function(a){a=l(a);a.hasClass("expandAll")?this.expandAllRows():a.hasClass("collapseAll")&&this.collapseAllRows()};i.prototype.expandAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].showDocAttributeCategory(!1,!0)};i.prototype.collapseAllRows=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].collapseAllDescendants()};
i.prototype.destroy=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].destroy()};i.prototype.reconstruct=function(){for(var a=0;a<this.docRows.length;a++)this.docRows[a].reconstruct()};return i});