/* ***** BEGIN LICENSE BLOCK *****
 * Distributed under the BSD license:
 *
 * Copyright (c) 2010, Ajax.org B.V.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Ajax.org B.V. nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL AJAX.ORG B.V. BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 * ***** END LICENSE BLOCK ***** */

define("require exports module ./lib/oop ./lib/lang ./config ./lib/event_emitter ./selection ./mode/text ./range ./document ./background_tokenizer ./search_highlight ./edit_session/folding ./edit_session/bracket_match".split(" "),function(k,p){var q=k("./lib/oop"),o=k("./lib/lang"),n=k("./config"),r=k("./lib/event_emitter").EventEmitter,s=k("./selection").Selection,t=k("./mode/text").Mode,l=k("./range").Range,u=k("./document").Document,v=k("./background_tokenizer").BackgroundTokenizer,w=k("./search_highlight").SearchHighlight,
m=function(g,k){this.$breakpoints=[];this.$decorations=[];this.$frontMarkers={};this.$backMarkers={};this.$markerId=1;this.$undoSelect=!0;this.$foldData=[];this.$foldData.toString=function(){return this.join("\n")};this.on("changeFold",this.onChangeFold.bind(this));this.$onChange=this.onChange.bind(this);if("object"!=typeof g||!g.getLine)g=new u(g);this.setDocument(g);this.selection=new s(this);n.resetOptions(this);this.setMode(k);n._signal("session",this)};(function(){function g(a){return 4352>a?
!1:4352<=a&&4447>=a||4515<=a&&4519>=a||4602<=a&&4607>=a||9001<=a&&9002>=a||11904<=a&&11929>=a||11931<=a&&12019>=a||12032<=a&&12245>=a||12272<=a&&12283>=a||12288<=a&&12350>=a||12353<=a&&12438>=a||12441<=a&&12543>=a||12549<=a&&12589>=a||12593<=a&&12686>=a||12688<=a&&12730>=a||12736<=a&&12771>=a||12784<=a&&12830>=a||12832<=a&&12871>=a||12880<=a&&13054>=a||13056<=a&&19903>=a||19968<=a&&42124>=a||42128<=a&&42182>=a||43360<=a&&43388>=a||44032<=a&&55203>=a||55216<=a&&55238>=a||55243<=a&&55291>=a||63744<=
a&&64255>=a||65040<=a&&65049>=a||65072<=a&&65106>=a||65108<=a&&65126>=a||65128<=a&&65131>=a||65281<=a&&65376>=a||65504<=a&&65510>=a}q.implement(this,r);this.setDocument=function(a){this.doc&&this.doc.removeListener("change",this.$onChange);this.doc=a;a.on("change",this.$onChange);this.bgTokenizer&&this.bgTokenizer.setDocument(this.getDocument());this.resetCaches()};this.getDocument=function(){return this.doc};this.$resetRowCache=function(a){if(a){var b=this.$docRowCache.length,a=this.$getRowCacheIndex(this.$docRowCache,
a)+1;b>a&&(this.$docRowCache.splice(a,b),this.$screenRowCache.splice(a,b))}else this.$docRowCache=[],this.$screenRowCache=[]};this.$getRowCacheIndex=function(a,b){for(var c=0,d=a.length-1;c<=d;){var e=c+d>>1,f=a[e];if(b>f)c=e+1;else if(b<f)d=e-1;else return e}return c-1};this.resetCaches=function(){this.$modified=!0;this.$wrapData=[];this.$rowLengthCache=[];this.$resetRowCache(0);this.bgTokenizer&&this.bgTokenizer.start(0)};this.onChangeFold=function(a){this.$resetRowCache(a.data.start.row)};this.onChange=
function(a){var b=a.data;this.$modified=!0;this.$resetRowCache(b.range.start.row);var c=this.$updateInternalDataOnChange(a);!this.$fromUndo&&(this.$undoManager&&!b.ignore)&&(this.$deltasDoc.push(b),c&&0!=c.length&&this.$deltasFold.push({action:"removeFolds",folds:c}),this.$informUndoManager.schedule());this.bgTokenizer&&this.bgTokenizer.$updateOnChange(b);this._signal("change",a)};this.setValue=function(a){this.doc.setValue(a);this.selection.moveTo(0,0);this.$resetRowCache(0);this.$deltas=[];this.$deltasDoc=
[];this.$deltasFold=[];this.setUndoManager(this.$undoManager);this.getUndoManager().reset()};this.getValue=this.toString=function(){return this.doc.getValue()};this.getSelection=function(){return this.selection};this.getState=function(a){return this.bgTokenizer.getState(a)};this.getTokens=function(a){return this.bgTokenizer.getTokens(a)};this.getTokenAt=function(a,b){var c=this.bgTokenizer.getTokens(a),d=0;if(null==b)e=c.length-1,d=this.getLine(a).length;else for(var e=0;e<c.length&&!(d+=c[e].value.length,
d>=b);e++);c=c[e];if(!c)return null;c.index=e;c.start=d-c.value.length;return c};this.setUndoManager=function(a){this.$undoManager=a;this.$deltas=[];this.$deltasDoc=[];this.$deltasFold=[];this.$informUndoManager&&this.$informUndoManager.cancel();if(a){var b=this;this.$syncInformUndoManager=function(){b.$informUndoManager.cancel();b.$deltasFold.length&&(b.$deltas.push({group:"fold",deltas:b.$deltasFold}),b.$deltasFold=[]);b.$deltasDoc.length&&(b.$deltas.push({group:"doc",deltas:b.$deltasDoc}),b.$deltasDoc=
[]);0<b.$deltas.length&&a.execute({action:"aceupdate",args:[b.$deltas,b],merge:b.mergeUndoDeltas});b.mergeUndoDeltas=!1;b.$deltas=[]};this.$informUndoManager=o.delayedCall(this.$syncInformUndoManager)}};this.markUndoGroup=function(){this.$syncInformUndoManager&&this.$syncInformUndoManager()};this.$defaultUndoManager={undo:function(){},redo:function(){},reset:function(){}};this.getUndoManager=function(){return this.$undoManager||this.$defaultUndoManager};this.getTabString=function(){return this.getUseSoftTabs()?
o.stringRepeat(" ",this.getTabSize()):"\t"};this.setUseSoftTabs=function(a){this.setOption("useSoftTabs",a)};this.getUseSoftTabs=function(){return this.$useSoftTabs&&!this.$mode.$indentWithTabs};this.setTabSize=function(a){this.setOption("tabSize",a)};this.getTabSize=function(){return this.$tabSize};this.isTabStop=function(a){return this.$useSoftTabs&&0===a.column%this.$tabSize};this.$overwrite=!1;this.setOverwrite=function(a){this.setOption("overwrite",a)};this.getOverwrite=function(){return this.$overwrite};
this.toggleOverwrite=function(){this.setOverwrite(!this.$overwrite)};this.addGutterDecoration=function(a,b){this.$decorations[a]||(this.$decorations[a]="");this.$decorations[a]+=" "+b;this._signal("changeBreakpoint",{})};this.removeGutterDecoration=function(a,b){this.$decorations[a]=(this.$decorations[a]||"").replace(" "+b,"");this._signal("changeBreakpoint",{})};this.getBreakpoints=function(){return this.$breakpoints};this.setBreakpoints=function(a){this.$breakpoints=[];for(var b=0;b<a.length;b++)this.$breakpoints[a[b]]=
"ace_breakpoint";this._signal("changeBreakpoint",{})};this.clearBreakpoints=function(){this.$breakpoints=[];this._signal("changeBreakpoint",{})};this.setBreakpoint=function(a,b){void 0===b&&(b="ace_breakpoint");b?this.$breakpoints[a]=b:delete this.$breakpoints[a];this._signal("changeBreakpoint",{})};this.clearBreakpoint=function(a){delete this.$breakpoints[a];this._signal("changeBreakpoint",{})};this.addMarker=function(a,b,c,d){var e=this.$markerId++,a={range:a,type:c||"line",renderer:"function"==
typeof c?c:null,clazz:b,inFront:!!d,id:e};d?(this.$frontMarkers[e]=a,this._signal("changeFrontMarker")):(this.$backMarkers[e]=a,this._signal("changeBackMarker"));return e};this.addDynamicMarker=function(a,b){if(a.update){var c=this.$markerId++;a.id=c;a.inFront=!!b;b?(this.$frontMarkers[c]=a,this._signal("changeFrontMarker")):(this.$backMarkers[c]=a,this._signal("changeBackMarker"));return a}};this.removeMarker=function(a){var b=this.$frontMarkers[a]||this.$backMarkers[a];if(b){var c=b.inFront?this.$frontMarkers:
this.$backMarkers;b&&(delete c[a],this._signal(b.inFront?"changeFrontMarker":"changeBackMarker"))}};this.getMarkers=function(a){return a?this.$frontMarkers:this.$backMarkers};this.highlight=function(a){if(!this.$searchHighlight){var b=new w(null,"ace_selected-word","text");this.$searchHighlight=this.addDynamicMarker(b)}this.$searchHighlight.setRegexp(a)};this.highlightLines=function(a,b,c,d){"number"!=typeof b&&(c=b,b=a);c||(c="ace_step");a=new l(a,0,b,Infinity);a.id=this.addMarker(a,c,"fullLine",
d);return a};this.setAnnotations=function(a){this.$annotations=a;this._signal("changeAnnotation",{})};this.getAnnotations=function(){return this.$annotations||[]};this.clearAnnotations=function(){this.setAnnotations([])};this.$detectNewLine=function(a){this.$autoNewLine=(a=a.match(/^.*?(\r?\n)/m))?a[1]:"\n"};this.getWordRange=function(a,b){var c=this.getLine(a),d=!1;0<b&&(d=!!c.charAt(b-1).match(this.tokenRe));d||(d=!!c.charAt(b).match(this.tokenRe));var d=d?this.tokenRe:/^\s+$/.test(c.slice(b-1,
b+1))?/\s/:this.nonTokenRe,e=b;if(0<e){do e--;while(0<=e&&c.charAt(e).match(d));e++}for(var f=b;f<c.length&&c.charAt(f).match(d);)f++;return new l(a,e,a,f)};this.getAWordRange=function(a,b){for(var c=this.getWordRange(a,b),d=this.getLine(c.end.row);d.charAt(c.end.column).match(/[ \t]/);)c.end.column+=1;return c};this.setNewLineMode=function(a){this.doc.setNewLineMode(a)};this.getNewLineMode=function(){return this.doc.getNewLineMode()};this.setUseWorker=function(a){this.setOption("useWorker",a)};this.getUseWorker=
function(){return this.$useWorker};this.onReloadTokenizer=function(a){this.bgTokenizer.start(a.data.first);this._signal("tokenizerUpdate",a)};this.$modes={};this.$modeId=this.$mode=null;this.setMode=function(a,b){if(a&&"object"===typeof a){if(a.getTokenizer)return this.$onChangeMode(a);var c=a,d=c.path}else d=a||"ace/mode/text";this.$modes["ace/mode/text"]||(this.$modes["ace/mode/text"]=new t);this.$modes[d]&&!c?(this.$onChangeMode(this.$modes[d]),b&&b()):(this.$modeId=d,n.loadModule(["mode",d],function(a){if(this.$modeId!==
d)return b&&b();this.$modes[d]&&!c?this.$onChangeMode(this.$modes[d]):a&&a.Mode&&(a=new a.Mode(c),c||(this.$modes[d]=a,a.$id=d),this.$onChangeMode(a));b&&b()}.bind(this)),this.$mode||this.$onChangeMode(this.$modes["ace/mode/text"],!0))};this.$onChangeMode=function(a,b){b||(this.$modeId=a.$id);if(this.$mode!==a){this.$mode=a;this.$stopWorker();this.$useWorker&&this.$startWorker();var c=a.getTokenizer();if(void 0!==c.addEventListener){var d=this.onReloadTokenizer.bind(this);c.addEventListener("update",
d)}if(this.bgTokenizer)this.bgTokenizer.setTokenizer(c);else{this.bgTokenizer=new v(c);var e=this;this.bgTokenizer.addEventListener("update",function(a){e._signal("tokenizerUpdate",a)})}this.bgTokenizer.setDocument(this.getDocument());this.tokenRe=a.tokenRe;this.nonTokenRe=a.nonTokenRe;b||(a.attachToSession&&a.attachToSession(this),this.$options.wrapMethod.set.call(this,this.$wrapMethod),this.$setFolding(a.foldingRules),this.bgTokenizer.start(0),this._emit("changeMode"))}};this.$stopWorker=function(){this.$worker&&
(this.$worker.terminate(),this.$worker=null)};this.$startWorker=function(){try{this.$worker=this.$mode.createWorker(this)}catch(a){n.warn("Could not load worker",a),this.$worker=null}};this.getMode=function(){return this.$mode};this.$scrollTop=0;this.setScrollTop=function(a){this.$scrollTop===a||isNaN(a)||(this.$scrollTop=a,this._signal("changeScrollTop",a))};this.getScrollTop=function(){return this.$scrollTop};this.$scrollLeft=0;this.setScrollLeft=function(a){this.$scrollLeft===a||isNaN(a)||(this.$scrollLeft=
a,this._signal("changeScrollLeft",a))};this.getScrollLeft=function(){return this.$scrollLeft};this.getScreenWidth=function(){this.$computeWidth();return this.lineWidgets?Math.max(this.getLineWidgetMaxWidth(),this.screenWidth):this.screenWidth};this.getLineWidgetMaxWidth=function(){if(null!=this.lineWidgetsWidth)return this.lineWidgetsWidth;var a=0;this.lineWidgets.forEach(function(b){b&&b.screenWidth>a&&(a=b.screenWidth)});return this.lineWidgetWidth=a};this.$computeWidth=function(a){if(this.$modified||
a){this.$modified=!1;if(this.$useWrapMode)return this.screenWidth=this.$wrapLimit;for(var a=this.doc.getAllLines(),b=this.$rowLengthCache,c=0,d=0,e=this.$foldData[d],f=e?e.start.row:Infinity,i=a.length,j=0;j<i;j++){if(j>f){j=e.end.row+1;if(j>=i)break;f=(e=this.$foldData[d++])?e.start.row:Infinity}null==b[j]&&(b[j]=this.$getStringScreenWidth(a[j])[0]);b[j]>c&&(c=b[j])}this.screenWidth=c}};this.getLine=function(a){return this.doc.getLine(a)};this.getLines=function(a,b){return this.doc.getLines(a,b)};
this.getLength=function(){return this.doc.getLength()};this.getTextRange=function(a){return this.doc.getTextRange(a||this.selection.getRange())};this.insert=function(a,b){return this.doc.insert(a,b)};this.remove=function(a){return this.doc.remove(a)};this.undoChanges=function(a,b){if(a.length){this.$fromUndo=!0;for(var c=null,d=a.length-1;-1!=d;d--){var e=a[d];"doc"==e.group?(this.doc.revertDeltas(e.deltas),c=this.$getUndoSelection(e.deltas,!0,c)):e.deltas.forEach(function(a){this.addFolds(a.folds)},
this)}this.$fromUndo=!1;c&&this.$undoSelect&&!b&&this.selection.setSelectionRange(c);return c}};this.redoChanges=function(a,b){if(a.length){this.$fromUndo=!0;for(var c=null,d=0;d<a.length;d++){var e=a[d];"doc"==e.group&&(this.doc.applyDeltas(e.deltas),c=this.$getUndoSelection(e.deltas,!1,c))}this.$fromUndo=!1;c&&this.$undoSelect&&!b&&this.selection.setSelectionRange(c);return c}};this.setUndoSelect=function(a){this.$undoSelect=a};this.$getUndoSelection=function(a,b,c){function d(a){a="insertText"===
a.action||"insertLines"===a.action;return b?!a:a}var e=a[0],f,i;f=d(e)?l.fromPoints(e.range.start,e.range.end):l.fromPoints(e.range.start,e.range.start);for(var j=1;j<a.length;j++)e=a[j],d(e)?(i=e.range.start,-1==f.compare(i.row,i.column)&&f.setStart(e.range.start),i=e.range.end,1==f.compare(i.row,i.column)&&f.setEnd(e.range.end)):(i=e.range.start,-1==f.compare(i.row,i.column)&&(f=l.fromPoints(e.range.start,e.range.start)));null!=c&&(0===l.comparePoints(c.start,f.start)&&(c.start.column+=f.end.column-
f.start.column,c.end.column+=f.end.column-f.start.column),a=c.compareRange(f),1==a?f.setStart(c.start):-1==a&&f.setEnd(c.end));return f};this.replace=function(a,b){return this.doc.replace(a,b)};this.moveText=function(a,b,c){var d=this.getTextRange(a),e=this.getFoldsInRange(a),b=l.fromPoints(b,b);if(!c){this.remove(a);var f=a.start.row-a.end.row,i=f?-a.end.column:a.start.column-a.end.column;i&&(b.start.row==a.end.row&&b.start.column>a.end.column&&(b.start.column+=i),b.end.row==a.end.row&&b.end.column>
a.end.column&&(b.end.column+=i));f&&b.start.row>=a.end.row&&(b.start.row+=f,b.end.row+=f)}b.end=this.insert(b.start,d);if(e.length){var j=a.start,a=b.start,f=a.row-j.row,i=a.column-j.column;this.addFolds(e.map(function(a){a=a.clone();a.start.row==j.row&&(a.start.column+=i);a.end.row==j.row&&(a.end.column+=i);a.start.row+=f;a.end.row+=f;return a}))}return b};this.indentRows=function(a,b,c){for(c=c.replace(/\t/g,this.getTabString());a<=b;a++)this.insert({row:a,column:0},c)};this.outdentRows=function(a){for(var a=
a.collapseRows(),b=new l(0,0,0,0),c=this.getTabSize(),d=a.start.row;d<=a.end.row;++d){var e=this.getLine(d);b.start.row=d;b.end.row=d;for(var f=0;f<c&&" "==e.charAt(f);++f);f<c&&"\t"==e.charAt(f)?(b.start.column=f,b.end.column=f+1):(b.start.column=0,b.end.column=f);this.remove(b)}};this.$moveLines=function(a,b,c){a=this.getRowFoldStart(a);b=this.getRowFoldEnd(b);if(0>c){var d=this.getRowFoldStart(a+c);if(0>d)return 0;var e=d-a}else if(0<c){d=this.getRowFoldEnd(b+c);if(d>this.doc.getLength()-1)return 0;
e=d-b}else a=this.$clipRowToDocument(a),b=this.$clipRowToDocument(b),e=b-a+1;d=new l(a,0,b,Number.MAX_VALUE);d=this.getFoldsInRange(d).map(function(a){a=a.clone();a.start.row+=e;a.end.row+=e;return a});b=0==c?this.doc.getLines(a,b):this.doc.removeLines(a,b);this.doc.insertLines(a+e,b);d.length&&this.addFolds(d);return e};this.moveLinesUp=function(a,b){return this.$moveLines(a,b,-1)};this.moveLinesDown=function(a,b){return this.$moveLines(a,b,1)};this.duplicateLines=function(a,b){return this.$moveLines(a,
b,0)};this.$clipRowToDocument=function(a){return Math.max(0,Math.min(a,this.doc.getLength()-1))};this.$clipColumnToRow=function(a,b){return 0>b?0:Math.min(this.doc.getLine(a).length,b)};this.$clipPositionToDocument=function(a,b){b=Math.max(0,b);if(0>a)b=a=0;else{var c=this.doc.getLength();a>=c?(a=c-1,b=this.doc.getLine(c-1).length):b=Math.min(this.doc.getLine(a).length,b)}return{row:a,column:b}};this.$clipRangeToDocument=function(a){0>a.start.row?(a.start.row=0,a.start.column=0):a.start.column=this.$clipColumnToRow(a.start.row,
a.start.column);var b=this.doc.getLength()-1;a.end.row>b?(a.end.row=b,a.end.column=this.doc.getLine(b).length):a.end.column=this.$clipColumnToRow(a.end.row,a.end.column);return a};this.$wrapLimit=80;this.$useWrapMode=!1;this.$wrapLimitRange={min:null,max:null};this.setUseWrapMode=function(a){a!=this.$useWrapMode&&(this.$useWrapMode=a,this.$modified=!0,this.$resetRowCache(0),a&&(a=this.getLength(),this.$wrapData=Array(a),this.$updateWrapData(0,a-1)),this._signal("changeWrapMode"))};this.getUseWrapMode=
function(){return this.$useWrapMode};this.setWrapLimitRange=function(a,b){if(this.$wrapLimitRange.min!==a||this.$wrapLimitRange.max!==b)this.$wrapLimitRange={min:a,max:b},this.$modified=!0,this._signal("changeWrapMode")};this.adjustWrapLimit=function(a,b){var c=this.$wrapLimitRange;0>c.max&&(c={min:b,max:b});c=this.$constrainWrapLimit(a,c.min,c.max);return c!=this.$wrapLimit&&1<c?(this.$wrapLimit=c,this.$modified=!0,this.$useWrapMode&&(this.$updateWrapData(0,this.getLength()-1),this.$resetRowCache(0),
this._signal("changeWrapLimit")),!0):!1};this.$constrainWrapLimit=function(a,b,c){b&&(a=Math.max(b,a));c&&(a=Math.min(c,a));return a};this.getWrapLimit=function(){return this.$wrapLimit};this.setWrapLimit=function(a){this.setWrapLimitRange(a,a)};this.getWrapLimitRange=function(){return{min:this.$wrapLimitRange.min,max:this.$wrapLimitRange.max}};this.$updateInternalDataOnChange=function(a){var b=this.$useWrapMode,c,d=a.data.action,e=a.data.range.start.row,f=a.data.range.end.row,i=a.data.range.start,
j=a.data.range.end,h=null;-1!=d.indexOf("Lines")?(f="insertLines"==d?e+a.data.lines.length:e,c=a.data.lines?a.data.lines.length:f-e):c=f-e;this.$updating=!0;if(0!=c)if(-1!=d.indexOf("remove")){this[b?"$wrapData":"$rowLengthCache"].splice(e,c);d=this.$foldData;h=this.getFoldsInRange(a.data.range);this.removeFolds(h);var a=this.getFoldLine(j.row),g=0;if(a){a.addRemoveChars(j.row,j.column,i.column-j.column);a.shiftRow(-c);if((f=this.getFoldLine(e))&&f!==a)f.merge(a),a=f;g=d.indexOf(a)+1}for(g;g<d.length;g++)a=
d[g],a.start.row>=j.row&&a.shiftRow(-c);f=e}else{d=Array(c);d.unshift(e,0);a=b?this.$wrapData:this.$rowLengthCache;a.splice.apply(a,d);d=this.$foldData;a=this.getFoldLine(e);g=0;if(a){g=a.range.compareInside(i.row,i.column);if(0==g){if(a=a.split(i.row,i.column))a.shiftRow(c),a.addRemoveChars(f,0,j.column-i.column)}else-1==g&&(a.addRemoveChars(e,0,j.column-i.column),a.shiftRow(c));g=d.indexOf(a)+1}for(g;g<d.length;g++)a=d[g],a.start.row>=e&&a.shiftRow(c)}else c=Math.abs(a.data.range.start.column-a.data.range.end.column),
-1!=d.indexOf("remove")&&(h=this.getFoldsInRange(a.data.range),this.removeFolds(h),c=-c),(a=this.getFoldLine(e))&&a.addRemoveChars(e,i.column,c);b&&this.$wrapData.length!=this.doc.getLength()&&console.error("doc.getLength() and $wrapData.length have to be the same!");this.$updating=!1;b?this.$updateWrapData(e,f):this.$updateRowLengthCache(e,f);return h};this.$updateRowLengthCache=function(a,b){this.$rowLengthCache[a]=null;this.$rowLengthCache[b]=null};this.$updateWrapData=function(a,b){for(var c=
this.doc.getAllLines(),d=this.getTabSize(),e=this.$wrapData,f=this.$wrapLimit,i,j,h=a,b=Math.min(b,c.length-1);h<=b;)(j=this.getFoldLine(h,j))?(i=[],j.walk(function(a,b,d,e){if(null!=a){a=this.$getDisplayTokens(a,i.length);a[0]=k;for(b=1;b<a.length;b++)a[b]=m}else a=this.$getDisplayTokens(c[b].substring(e,d),i.length);i=i.concat(a)}.bind(this),j.end.row,c[j.end.row].length+1),e[j.start.row]=this.$computeWrapSplits(i,f,d),h=j.end.row+1):(i=this.$getDisplayTokens(c[h]),e[h]=this.$computeWrapSplits(i,
f,d),h++)};var k=3,m=4;this.$computeWrapSplits=function(a,b){function c(b){var c=a.slice(f,b),e=c.length;c.join("").replace(/12/g,function(){e-=1}).replace(/2/g,function(){e-=1});i+=e;d.push(i);f=b}if(0==a.length)return[];for(var d=[],e=a.length,f=0,i=0,j=this.$wrapAsCode;e-f>b;){var h=f+b;if(10<=a[h-1]&&10<=a[h])c(h);else if(a[h]==k||a[h]==m){for(h;h!=f-1&&a[h]!=k;h--);if(!(h>f)){h=f+b;for(h;h<a.length&&a[h]==m;h++);if(h==a.length)break}c(h)}else{for(var g=Math.max(h-(j?10:b-(b>>2)),f-1);h>g&&a[h]<
k;)h--;if(j){for(;h>g&&a[h]<k;)h--;for(;h>g&&9==a[h];)h--}else for(;h>g&&10>a[h];)h--;h>g?c(++h):(h=f+b,2==a[h]&&h--,c(h))}}return d};this.$getDisplayTokens=function(a,b){for(var c=[],d,b=b||0,e=0;e<a.length;e++)if(d=a.charCodeAt(e),9==d){d=this.getScreenTabSize(c.length+b);c.push(11);for(var f=1;f<d;f++)c.push(12)}else 32==d?c.push(10):39<d&&48>d||57<d&&64>d?c.push(9):4352<=d&&g(d)?c.push(1,2):c.push(1);return c};this.$getStringScreenWidth=function(a,b,c){if(0==b)return[0,0];null==b&&(b=Infinity);
var c=c||0,d,e;for(e=0;e<a.length&&!(d=a.charCodeAt(e),c=9==d?c+this.getScreenTabSize(c):4352<=d&&g(d)?c+2:c+1,c>b);e++);return[c,e]};this.lineWidgets=null;this.getRowLength=function(a){var b=this.lineWidgets?this.lineWidgets[a]&&this.lineWidgets[a].rowCount||0:0;return!this.$useWrapMode||!this.$wrapData[a]?1+b:this.$wrapData[a].length+1+b};this.getRowLineCount=function(a){return!this.$useWrapMode||!this.$wrapData[a]?1:this.$wrapData[a].length+1};this.getScreenLastRowColumn=function(a){a=this.screenToDocumentPosition(a,
Number.MAX_VALUE);return this.documentToScreenColumn(a.row,a.column)};this.getDocumentLastRowColumn=function(a,b){var c=this.documentToScreenRow(a,b);return this.getScreenLastRowColumn(c)};this.getDocumentLastRowColumnPosition=function(a,b){var c=this.documentToScreenRow(a,b);return this.screenToDocumentPosition(c,Number.MAX_VALUE/10)};this.getRowSplitData=function(a){if(this.$useWrapMode)return this.$wrapData[a]};this.getScreenTabSize=function(a){return this.$tabSize-a%this.$tabSize};this.screenToDocumentRow=
function(a,b){return this.screenToDocumentPosition(a,b).row};this.screenToDocumentColumn=function(a,b){return this.screenToDocumentPosition(a,b).column};this.screenToDocumentPosition=function(a,b){if(0>a)return{row:0,column:0};var c,d=0,e=0,f,i=0;c=0;var g=this.$screenRowCache,h=this.$getRowCacheIndex(g,a),k=g.length;k&&0<=h?(i=g[h],d=this.$docRowCache[h],h=a>g[k-1]):h=!k;for(var k=this.getLength()-1,l=(g=this.getNextFoldLine(d))?g.start.row:Infinity;i<=a;){c=this.getRowLength(d);if(i+c>a||d>=k)break;
else i+=c,d++,d>l&&(d=g.end.row+1,l=(g=this.getNextFoldLine(d,g))?g.start.row:Infinity);h&&(this.$docRowCache.push(d),this.$screenRowCache.push(i))}if(g&&g.start.row<=d)c=this.getFoldDisplayLine(g),d=g.start.row;else{if(i+c<=a||d>k)return{row:k,column:this.getLine(k).length};c=this.getLine(d);g=null}if(this.$useWrapMode&&(h=this.$wrapData[d]))i=Math.floor(a-i),f=h[i],0<i&&h.length&&(e=h[i-1]||h[h.length-1],c=c.substring(e));e+=this.$getStringScreenWidth(c,b)[1];this.$useWrapMode&&e>=f&&(e=f-1);return g?
g.idxToPosition(e):{row:d,column:e}};this.documentToScreenPosition=function(a,b){var c="undefined"===typeof b?this.$clipPositionToDocument(a.row,a.column):this.$clipPositionToDocument(a,b),a=c.row,b=c.column,c=0,d=null,d=null;if(d=this.getFoldAt(a,b,1))a=d.start.row,b=d.start.column;var e,d=0;e=this.$docRowCache;var f=this.$getRowCacheIndex(e,a),g=e.length;if(g&&0<=f)var d=e[f],c=this.$screenRowCache[f],j=a>e[g-1];else j=!g;for(g=(f=this.getNextFoldLine(d))?f.start.row:Infinity;d<a;){if(d>=g){e=f.end.row+
1;if(e>a)break;g=(f=this.getNextFoldLine(e,f))?f.start.row:Infinity}else e=d+1;c+=this.getRowLength(d);d=e;j&&(this.$docRowCache.push(d),this.$screenRowCache.push(c))}e="";f&&d>=g?(e=this.getFoldDisplayLine(f,a,b),d=f.start.row):(e=this.getLine(a).substring(0,b),d=a);if(this.$useWrapMode&&(d=this.$wrapData[d])){for(f=0;e.length>=d[f];)c++,f++;e=e.substring(d[f-1]||0,e.length)}return{row:c,column:this.$getStringScreenWidth(e)[0]}};this.documentToScreenColumn=function(a,b){return this.documentToScreenPosition(a,
b).column};this.documentToScreenRow=function(a,b){return this.documentToScreenPosition(a,b).row};this.getScreenLength=function(){var a=0,b=null;if(this.$useWrapMode)for(var c=this.$wrapData.length,d=0,e=0,f=(b=this.$foldData[e++])?b.start.row:Infinity;d<c;){var g=this.$wrapData[d],a=a+(g?g.length+1:1);d++;d>f&&(d=b.end.row+1,f=(b=this.$foldData[e++])?b.start.row:Infinity)}else for(var a=this.getLength(),c=this.$foldData,e=0;e<c.length;e++)b=c[e],a-=b.end.row-b.start.row;this.lineWidgets&&(a+=this.$getWidgetScreenLength());
return a};this.$setFontMetrics=function(){};this.destroy=function(){this.bgTokenizer&&(this.bgTokenizer.setDocument(null),this.bgTokenizer=null);this.$stopWorker()}}).call(m.prototype);k("./edit_session/folding").Folding.call(m.prototype);k("./edit_session/bracket_match").BracketMatch.call(m.prototype);n.defineOptions(m.prototype,"session",{wrap:{set:function(g){!g||"off"==g?g=!1:"free"==g?g=!0:"printMargin"==g?g=-1:"string"==typeof g&&(g=parseInt(g,10)||!1);if(this.$wrap!=g){if(g){var k="number"==
typeof g?g:null;this.setWrapLimitRange(k,k);this.setUseWrapMode(!0)}else this.setUseWrapMode(!1);this.$wrap=g}},get:function(){return this.getUseWrapMode()?-1==this.$wrap?"printMargin":!this.getWrapLimitRange().min?"free":this.$wrap:"off"},handlesSet:!0},wrapMethod:{set:function(g){g="auto"==g?"text"!=this.$mode.type:"text"!=g;g!=this.$wrapAsCode&&(this.$wrapAsCode=g,this.$useWrapMode&&(this.$modified=!0,this.$resetRowCache(0),this.$updateWrapData(0,this.getLength()-1)))},initialValue:"auto"},firstLineNumber:{set:function(){this._signal("changeBreakpoint")},
initialValue:1},useWorker:{set:function(g){this.$useWorker=g;this.$stopWorker();g&&this.$startWorker()},initialValue:!0},useSoftTabs:{initialValue:!0},tabSize:{set:function(g){isNaN(g)||this.$tabSize===g||(this.$modified=!0,this.$rowLengthCache=[],this.$tabSize=g,this._signal("changeTabSize"))},initialValue:4,handlesSet:!0},overwrite:{set:function(){this._signal("changeOverwrite")},initialValue:!1},newLineMode:{set:function(g){this.doc.setNewLineMode(g)},get:function(){return this.doc.getNewLineMode()},
handlesSet:!0},mode:{set:function(g){this.setMode(g)},get:function(){return this.$modeId}}});p.EditSession=m});