/*
  php.js 0.1.0 <http://phpjs.hertzen.com/>
  Copyright (c) 2013 Niklas von Hertzen

  Released under MIT License

  This file contains:
  - [var PHP = {Constants:{}};]
  - src/modules/tokenizer/constants.js
  - src/parser/lexer.js
  - src/parser/parser.js
  - src/parser/yyn.js
  - src/parser/yyn_stmt.js
  - src/parser/yyn_expr.js
  - src/parser/yyn_scalar.js
*/

define(["require","exports","module"],function(y,r){var a={Constants:{}};a.Constants.T_INCLUDE=262;a.Constants.T_INCLUDE_ONCE=261;a.Constants.T_EVAL=260;a.Constants.T_REQUIRE=259;a.Constants.T_REQUIRE_ONCE=258;a.Constants.T_LOGICAL_OR=263;a.Constants.T_LOGICAL_XOR=264;a.Constants.T_LOGICAL_AND=265;a.Constants.T_PRINT=266;a.Constants.T_PLUS_EQUAL=277;a.Constants.T_MINUS_EQUAL=276;a.Constants.T_MUL_EQUAL=275;a.Constants.T_DIV_EQUAL=274;a.Constants.T_CONCAT_EQUAL=273;a.Constants.T_MOD_EQUAL=272;a.Constants.T_AND_EQUAL=
271;a.Constants.T_OR_EQUAL=270;a.Constants.T_XOR_EQUAL=269;a.Constants.T_SL_EQUAL=268;a.Constants.T_SR_EQUAL=267;a.Constants.T_BOOLEAN_OR=278;a.Constants.T_BOOLEAN_AND=279;a.Constants.T_IS_EQUAL=283;a.Constants.T_IS_NOT_EQUAL=282;a.Constants.T_IS_IDENTICAL=281;a.Constants.T_IS_NOT_IDENTICAL=280;a.Constants.T_IS_SMALLER_OR_EQUAL=285;a.Constants.T_IS_GREATER_OR_EQUAL=284;a.Constants.T_SL=287;a.Constants.T_SR=286;a.Constants.T_INSTANCEOF=288;a.Constants.T_INC=297;a.Constants.T_DEC=296;a.Constants.T_INT_CAST=
295;a.Constants.T_DOUBLE_CAST=294;a.Constants.T_STRING_CAST=293;a.Constants.T_ARRAY_CAST=292;a.Constants.T_OBJECT_CAST=291;a.Constants.T_BOOL_CAST=290;a.Constants.T_UNSET_CAST=289;a.Constants.T_NEW=299;a.Constants.T_CLONE=298;a.Constants.T_EXIT=300;a.Constants.T_IF=301;a.Constants.T_ELSEIF=302;a.Constants.T_ELSE=303;a.Constants.T_ENDIF=304;a.Constants.T_LNUMBER=305;a.Constants.T_DNUMBER=306;a.Constants.T_STRING=307;a.Constants.T_STRING_VARNAME=308;a.Constants.T_VARIABLE=309;a.Constants.T_NUM_STRING=
310;a.Constants.T_INLINE_HTML=311;a.Constants.T_CHARACTER=312;a.Constants.T_BAD_CHARACTER=313;a.Constants.T_ENCAPSED_AND_WHITESPACE=314;a.Constants.T_CONSTANT_ENCAPSED_STRING=315;a.Constants.T_ECHO=316;a.Constants.T_DO=317;a.Constants.T_WHILE=318;a.Constants.T_ENDWHILE=319;a.Constants.T_FOR=320;a.Constants.T_ENDFOR=321;a.Constants.T_FOREACH=322;a.Constants.T_ENDFOREACH=323;a.Constants.T_DECLARE=324;a.Constants.T_ENDDECLARE=325;a.Constants.T_AS=326;a.Constants.T_SWITCH=327;a.Constants.T_ENDSWITCH=
328;a.Constants.T_CASE=329;a.Constants.T_DEFAULT=330;a.Constants.T_BREAK=331;a.Constants.T_CONTINUE=332;a.Constants.T_GOTO=333;a.Constants.T_FUNCTION=334;a.Constants.T_CONST=335;a.Constants.T_RETURN=336;a.Constants.T_TRY=337;a.Constants.T_CATCH=338;a.Constants.T_THROW=339;a.Constants.T_USE=340;a.Constants.T_GLOBAL=341;a.Constants.T_STATIC=347;a.Constants.T_ABSTRACT=346;a.Constants.T_FINAL=345;a.Constants.T_PRIVATE=344;a.Constants.T_PROTECTED=343;a.Constants.T_PUBLIC=342;a.Constants.T_VAR=348;a.Constants.T_UNSET=
349;a.Constants.T_ISSET=350;a.Constants.T_EMPTY=351;a.Constants.T_HALT_COMPILER=352;a.Constants.T_CLASS=353;a.Constants.T_TRAIT=382;a.Constants.T_INTERFACE=354;a.Constants.T_EXTENDS=355;a.Constants.T_IMPLEMENTS=356;a.Constants.T_OBJECT_OPERATOR=357;a.Constants.T_DOUBLE_ARROW=358;a.Constants.T_LIST=359;a.Constants.T_ARRAY=360;a.Constants.T_CLASS_C=361;a.Constants.T_TRAIT_C=381;a.Constants.T_METHOD_C=362;a.Constants.T_FUNC_C=363;a.Constants.T_LINE=364;a.Constants.T_FILE=365;a.Constants.T_COMMENT=366;
a.Constants.T_DOC_COMMENT=367;a.Constants.T_OPEN_TAG=368;a.Constants.T_OPEN_TAG_WITH_ECHO=369;a.Constants.T_CLOSE_TAG=370;a.Constants.T_WHITESPACE=371;a.Constants.T_START_HEREDOC=372;a.Constants.T_END_HEREDOC=373;a.Constants.T_DOLLAR_OPEN_CURLY_BRACES=374;a.Constants.T_CURLY_OPEN=375;a.Constants.T_PAAMAYIM_NEKUDOTAYIM=376;a.Constants.T_DOUBLE_COLON=376;a.Constants.T_NAMESPACE=377;a.Constants.T_NS_C=378;a.Constants.T_DIR=379;a.Constants.T_NS_SEPARATOR=380;a.Lexer=function(d,b){var c,f=void 0===b||
/^(on|true|1)$/i.test(b.short_open_tag)?/(\<\?php\s|\<\?|\<\%|\<script language\=('|")?php('|")?\>)/i:/(\<\?php\s|<\?=|\<script language\=('|")?php('|")?\>)/i,n=void 0===b||/^(on|true|1)$/i.test(b.short_open_tag)?/^(\<\?php\s|\<\?|\<\%|\<script language\=('|")?php('|")?\>)/i:/^(\<\?php\s|<\?=|\<script language\=('|")?php('|")?\>)/i,n=[{value:a.Constants.T_NAMESPACE,re:/^namespace(?=\s)/i},{value:a.Constants.T_USE,re:/^use(?=\s)/i},{value:a.Constants.T_ABSTRACT,re:/^abstract(?=\s)/i},{value:a.Constants.T_IMPLEMENTS,
re:/^implements(?=\s)/i},{value:a.Constants.T_INTERFACE,re:/^interface(?=\s)/i},{value:a.Constants.T_CONST,re:/^const(?=\s)/i},{value:a.Constants.T_STATIC,re:/^static(?=\s)/i},{value:a.Constants.T_FINAL,re:/^final(?=\s)/i},{value:a.Constants.T_VAR,re:/^var(?=\s)/i},{value:a.Constants.T_GLOBAL,re:/^global(?=\s)/i},{value:a.Constants.T_CLONE,re:/^clone(?=\s)/i},{value:a.Constants.T_THROW,re:/^throw(?=\s)/i},{value:a.Constants.T_EXTENDS,re:/^extends(?=\s)/i},{value:a.Constants.T_AND_EQUAL,re:/^&=/},
{value:a.Constants.T_AS,re:/^as(?=\s)/i},{value:a.Constants.T_ARRAY_CAST,re:/^\(array\)/i},{value:a.Constants.T_BOOL_CAST,re:/^\((bool|boolean)\)/i},{value:a.Constants.T_DOUBLE_CAST,re:/^\((real|float|double)\)/i},{value:a.Constants.T_INT_CAST,re:/^\((int|integer)\)/i},{value:a.Constants.T_OBJECT_CAST,re:/^\(object\)/i},{value:a.Constants.T_STRING_CAST,re:/^\(string\)/i},{value:a.Constants.T_UNSET_CAST,re:/^\(unset\)/i},{value:a.Constants.T_TRY,re:/^try(?=\s*{)/i},{value:a.Constants.T_CATCH,re:/^catch(?=\s*\()/i},
{value:a.Constants.T_INSTANCEOF,re:/^instanceof(?=\s)/i},{value:a.Constants.T_LOGICAL_OR,re:/^or(?=\s)/i},{value:a.Constants.T_LOGICAL_AND,re:/^and(?=\s)/i},{value:a.Constants.T_LOGICAL_XOR,re:/^xor(?=\s)/i},{value:a.Constants.T_BOOLEAN_AND,re:/^&&/},{value:a.Constants.T_BOOLEAN_OR,re:/^\|\|/},{value:a.Constants.T_CONTINUE,re:/^continue(?=\s|;)/i},{value:a.Constants.T_BREAK,re:/^break(?=\s|;)/i},{value:a.Constants.T_ENDDECLARE,re:/^enddeclare(?=\s|;)/i},{value:a.Constants.T_ENDFOR,re:/^endfor(?=\s|;)/i},
{value:a.Constants.T_ENDFOREACH,re:/^endforeach(?=\s|;)/i},{value:a.Constants.T_ENDIF,re:/^endif(?=\s|;)/i},{value:a.Constants.T_ENDSWITCH,re:/^endswitch(?=\s|;)/i},{value:a.Constants.T_ENDWHILE,re:/^endwhile(?=\s|;)/i},{value:a.Constants.T_CASE,re:/^case(?=\s)/i},{value:a.Constants.T_DEFAULT,re:/^default(?=\s|:)/i},{value:a.Constants.T_SWITCH,re:/^switch(?=[ (])/i},{value:a.Constants.T_EXIT,re:/^(exit|die)(?=[ \(;])/i},{value:a.Constants.T_CLOSE_TAG,re:/^(\?\>|\%\>|\<\/script\>)\s?\s?/i,func:function(a){o=
!1;return a}},{value:a.Constants.T_DOUBLE_ARROW,re:/^\=\>/},{value:a.Constants.T_DOUBLE_COLON,re:/^\:\:/},{value:a.Constants.T_METHOD_C,re:/^__METHOD__/},{value:a.Constants.T_LINE,re:/^__LINE__/},{value:a.Constants.T_FILE,re:/^__FILE__/},{value:a.Constants.T_FUNC_C,re:/^__FUNCTION__/},{value:a.Constants.T_NS_C,re:/^__NAMESPACE__/},{value:a.Constants.T_TRAIT_C,re:/^__TRAIT__/},{value:a.Constants.T_DIR,re:/^__DIR__/},{value:a.Constants.T_CLASS_C,re:/^__CLASS__/},{value:a.Constants.T_INC,re:/^\+\+/},
{value:a.Constants.T_DEC,re:/^\-\-/},{value:a.Constants.T_CONCAT_EQUAL,re:/^\.\=/},{value:a.Constants.T_DIV_EQUAL,re:/^\/\=/},{value:a.Constants.T_XOR_EQUAL,re:/^\^\=/},{value:a.Constants.T_MUL_EQUAL,re:/^\*\=/},{value:a.Constants.T_MOD_EQUAL,re:/^\%\=/},{value:a.Constants.T_SL_EQUAL,re:/^<<=/},{value:a.Constants.T_START_HEREDOC,re:/^<<<[A-Z_0-9]+\s/i,func:function(a){c=a.substring(3,a.length-1);return a}},{value:a.Constants.T_SL,re:/^<</},{value:a.Constants.T_IS_SMALLER_OR_EQUAL,re:/^<=/},{value:a.Constants.T_SR_EQUAL,
re:/^>>=/},{value:a.Constants.T_SR,re:/^>>/},{value:a.Constants.T_IS_GREATER_OR_EQUAL,re:/^>=/},{value:a.Constants.T_OR_EQUAL,re:/^\|\=/},{value:a.Constants.T_PLUS_EQUAL,re:/^\+\=/},{value:a.Constants.T_MINUS_EQUAL,re:/^-\=/},{value:a.Constants.T_OBJECT_OPERATOR,re:/^\-\>/i},{value:a.Constants.T_CLASS,re:/^class(?=[\s\{])/i,afterWhitespace:!0},{value:a.Constants.T_TRAIT,re:/^trait(?=[\s]+[A-Za-z])/i},{value:a.Constants.T_PUBLIC,re:/^public(?=[\s])/i},{value:a.Constants.T_PRIVATE,re:/^private(?=[\s])/i},
{value:a.Constants.T_PROTECTED,re:/^protected(?=[\s])/i},{value:a.Constants.T_ARRAY,re:/^array(?=\s*?\()/i},{value:a.Constants.T_EMPTY,re:/^empty(?=[ \(])/i},{value:a.Constants.T_ISSET,re:/^isset(?=[ \(])/i},{value:a.Constants.T_UNSET,re:/^unset(?=[ \(])/i},{value:a.Constants.T_RETURN,re:/^return(?=[ "'(;])/i},{value:a.Constants.T_FUNCTION,re:/^function(?=[ "'(;])/i},{value:a.Constants.T_ECHO,re:/^echo(?=[ "'(;])/i},{value:a.Constants.T_LIST,re:/^list(?=\s*?\()/i},{value:a.Constants.T_PRINT,re:/^print(?=[ "'(;])/i},
{value:a.Constants.T_INCLUDE,re:/^include(?=[ "'(;])/i},{value:a.Constants.T_INCLUDE_ONCE,re:/^include_once(?=[ "'(;])/i},{value:a.Constants.T_REQUIRE,re:/^require(?=[ "'(;])/i},{value:a.Constants.T_REQUIRE_ONCE,re:/^require_once(?=[ "'(;])/i},{value:a.Constants.T_NEW,re:/^new(?=[ ])/i},{value:a.Constants.T_COMMENT,re:/^\/\*([\S\s]*?)(?:\*\/|$)/},{value:a.Constants.T_COMMENT,re:/^\/\/.*(\s)?/},{value:a.Constants.T_COMMENT,re:/^\#.*(\s)?/},{value:a.Constants.T_ELSEIF,re:/^elseif(?=[\s(])/i},{value:a.Constants.T_GOTO,
re:/^goto(?=[\s(])/i},{value:a.Constants.T_ELSE,re:/^else(?=[\s{:])/i},{value:a.Constants.T_IF,re:/^if(?=[\s(])/i},{value:a.Constants.T_DO,re:/^do(?=[ {])/i},{value:a.Constants.T_WHILE,re:/^while(?=[ (])/i},{value:a.Constants.T_FOREACH,re:/^foreach(?=[ (])/i},{value:a.Constants.T_ISSET,re:/^isset(?=[ (])/i},{value:a.Constants.T_IS_IDENTICAL,re:/^===/},{value:a.Constants.T_IS_EQUAL,re:/^==/},{value:a.Constants.T_IS_NOT_IDENTICAL,re:/^\!==/},{value:a.Constants.T_IS_NOT_EQUAL,re:/^(\!=|\<\>)/},{value:a.Constants.T_FOR,
re:/^for(?=[ (])/i},{value:a.Constants.T_DNUMBER,re:/^[0-9]*\.[0-9]+([eE][-]?[0-9]*)?/},{value:a.Constants.T_LNUMBER,re:/^(0x[0-9A-F]+|[0-9]+)/i},{value:a.Constants.T_OPEN_TAG_WITH_ECHO,re:/^(\<\?=|\<\%=)/i},{value:a.Constants.T_OPEN_TAG,re:n},{value:a.Constants.T_VARIABLE,re:/^\$[a-zA-Z_\x7f-\uffff][a-zA-Z0-9_\x7f-\uffff]*/},{value:a.Constants.T_WHITESPACE,re:/^\s+/},{value:a.Constants.T_CONSTANT_ENCAPSED_STRING,re:/^("(?:[^"\\]|\\[\s\S])*"|'(?:[^'\\]|\\[\s\S])*')/,func:function(d){var b=0,c,f=0;
if("'"===d.substring(0,1))return d;var h=d.match(/(?:[^\\]|\\.)*[^\\]\$[a-zA-Z_\x7f-\uffff][a-zA-Z0-9_\x7f-\uffff]*/g);if(null!==h)for(;0<d.length;){c=d.length;h=d.match(/^[\[\]\;\:\?\(\)\!\.\,\>\<\=\+\-\/\*\|\&\@\^\%\"\'\{\}]/);null!==h&&(i.push(h[0]),d=d.substring(1),0<b&&"}"===h[0]&&b--,"["===h[0]&&f++,"]"===h[0]&&f--);h=d.match(/^\$[a-zA-Z_\x7f-\uffff][a-zA-Z0-9_\x7f-\uffff]*/);if(null!==h&&(i.push([parseInt(a.Constants.T_VARIABLE,10),h[0],g]),d=d.substring(h[0].length),h=d.match(/^(\-\>)\s*([a-zA-Z_\x7f-\uffff][a-zA-Z0-9_\x7f-\uffff]*)\s*(\()/),
null!==h&&(i.push([parseInt(a.Constants.T_OBJECT_OPERATOR,10),h[1],g]),i.push([parseInt(a.Constants.T_STRING,10),h[2],g]),h[3]&&i.push(h[3]),d=d.substring(h[0].length)),null!==d.match(/^\[/g)))continue;var j;j=0<b?/^([^\\\$"{}\]\(\)\->]|\\.)+/g:/^([^\\\$"{]|\\.|{[^\$]|\$(?=[^a-zA-Z_\x7f-\uffff]))+/g;for(var m,k;null!==(h=d.match(j));){if(1===d.length)throw Error(h);m=0;0<b?(k=h[0].match(/^[\[\]\;\:\?\(\)\!\.\,\>\<\=\+\-\/\*\|\&\{\}\@\^\%\$\~]/))?i.push(k[0]):m=a.Constants.T_STRING:m=a.Constants.T_ENCAPSED_AND_WHITESPACE;
m&&i.push([parseInt(m,10),h[0].replace(/\n/g,"\\n").replace(/\r/g,""),g]);g+=h[0].split("\n").length-1;d=d.substring(h[0].length)}0<b&&null!==d.match(/^\->/)&&(i.push([parseInt(a.Constants.T_OBJECT_OPERATOR,10),"->",g]),d=d.substring(2));null!==d.match(/^{\$/)&&(i.push([parseInt(a.Constants.T_CURLY_OPEN,10),"{",g]),d=d.substring(1),b++);if(c===d.length&&null!==d.match(/^(([^\\]|\\.)*?[^\\]\$[a-zA-Z_\x7f-\uffff][a-zA-Z0-9_\x7f-\uffff]*)/g))break}else return d=d.replace(/\r/g,"")}},{value:a.Constants.T_NS_SEPARATOR,
re:/^\\(?=[a-zA-Z_])/},{value:a.Constants.T_STRING,re:/^[a-zA-Z_\x7f-\uffff][a-zA-Z0-9_\x7f-\uffff]*/},{value:-1,re:/^[\[\]\;\:\?\(\)\!\.\,\>\<\=\+\-\/\*\|\&\{\}\@\^\%\"\'\$\~]/}],i=[],g=1,o=!1,p=!0;if(null===d)return i;for("string"!==typeof d&&(d=d.toString());0<d.length&&!0===p;)if(!0===o)if(void 0!==c){var j=d.match(RegExp("([\\S\\s]*?)(\\r\\n|\\n|\\r)("+c+")(;|\\r\\n|\\n)","i"));null!==j&&(i.push([parseInt(a.Constants.T_ENCAPSED_AND_WHITESPACE,10),j[1].replace(/^\n/g,"").replace(/\\\$/g,"$")+
"\n",g]),g+=j[1].split("\n").length,i.push([parseInt(a.Constants.T_END_HEREDOC,10),j[3],g]),d=d.substring(j[1].length+j[2].length+j[3].length),c=void 0);if(null===j)throw Error("sup");}else p=n.some(function(b){if(!0===b.afterWhitespace){var c=i[i.length-1];if(!Array.isArray(c)||c[0]!==a.Constants.T_WHITESPACE&&c[0]!==a.Constants.T_OPEN_TAG&&c[0]!==a.Constants.T_COMMENT)return!1}c=d.match(b.re);if(null!==c){if(-1!==b.value){var f=c[0];void 0!==b.func&&(f=b.func(f,b));void 0!==f&&(i.push([parseInt(b.value,
10),f,g]),g+=f.split("\n").length-1)}else i.push(c[0]);d=d.substring(c[0].length);return!0}return!1});else if(j=f.exec(d),null!==j){if(0<j.index){var q=d.substring(0,j.index);i.push([parseInt(a.Constants.T_INLINE_HTML,10),q,g]);g+=q.split("\n").length-1;d=d.substring(j.index)}o=!0}else{i.push([parseInt(a.Constants.T_INLINE_HTML,10),d.replace(/^\n/,""),g]);break}return i};a.Parser=function(d,b){var c=this.yybase,f=this.yydefault,n=this.yycheck,i=this.yyaction,g=this.yylen,o=this.yygbase,p=this.yygcheck,
j=this.yyp,q=this.yygoto,r=this.yylhs,u=this.terminals,v=this.translate,w=this.yygdefault;this.pos=-1;this.line=1;this.tokenMap=this.createTokenMap();this.dropTokens={};this.dropTokens[a.Constants.T_WHITESPACE]=1;this.dropTokens[a.Constants.T_OPEN_TAG]=1;var h=[];d.forEach(function(d){"object"===typeof d&&d[0]===a.Constants.T_OPEN_TAG_WITH_ECHO?(h.push([a.Constants.T_OPEN_TAG,d[1],d[2]]),h.push([a.Constants.T_ECHO,d[1],d[2]])):h.push(d)});this.tokens=h;var l=this.TOKEN_NONE;this.startAttributes={startLine:1};
this.endAttributes={};var m=[this.startAttributes],k=0,s=[k];this.yyastk=[];this.stackPos=0;for(var e;;){if(0===c[k])e=f[k];else if(l===this.TOKEN_NONE&&(l=this.getNextToken(),l=0<=l&&l<this.TOKEN_MAP_SIZE?v[l]:this.TOKEN_INVALID,m[this.stackPos]=this.startAttributes),(0<=(e=c[k]+l)&&e<this.YYLAST&&n[e]===l||k<this.YY2TBLSTATE&&0<=(e=c[k+this.YYNLSTATES]+l)&&e<this.YYLAST&&n[e]===l)&&(e=i[e])!==this.YYDEFAULT)if(0<e){++this.stackPos;s[this.stackPos]=k=e;this.yyastk[this.stackPos]=this.tokenValue;
m[this.stackPos]=this.startAttributes;l=this.TOKEN_NONE;if(e<this.YYNLSTATES)continue;e-=this.YYNLSTATES}else e=-e;else e=f[k];for(;;){if(0===e)return this.yyval;if(e!==this.YYUNEXPECTED){for(var t in this.endAttributes)m[this.stackPos-g[e]][t]=this.endAttributes[t];try{this["yyn"+e](m[this.stackPos-g[e]])}catch(x){throw x;}this.stackPos-=g[e];e=r[e];k=0<=(j=o[e]+s[this.stackPos])&&j<this.YYGLAST&&p[j]===e?q[j]:w[e];++this.stackPos;s[this.stackPos]=k;this.yyastk[this.stackPos]=this.yyval;m[this.stackPos]=
this.startAttributes}else{if(!0!==b){f=[];for(g=0;g<this.TOKEN_MAP_SIZE;++g)if((0<=(e=c[k]+g)&&e<this.YYLAST&&n[e]==g||k<this.YY2TBLSTATE&&(e=c[k+this.YYNLSTATES]+g)&&e<this.YYLAST&&n[e]==g)&&i[e]!=this.YYUNEXPECTED){if(4==f.length){f=[];break}f.push(this.terminals[g])}c="";f.length&&(c=", expecting "+f.join(" or "));throw new a.ParseError("syntax error, unexpected "+u[l]+c,this.startAttributes.startLine);}return this.startAttributes.startLine}if(k<this.YYNLSTATES)break;e=k-this.YYNLSTATES}}};a.ParseError=
function(a,b){this.message=a;this.line=b};a.Parser.prototype.MODIFIER_PUBLIC=1;a.Parser.prototype.MODIFIER_PROTECTED=2;a.Parser.prototype.MODIFIER_PRIVATE=4;a.Parser.prototype.MODIFIER_STATIC=8;a.Parser.prototype.MODIFIER_ABSTRACT=16;a.Parser.prototype.MODIFIER_FINAL=32;a.Parser.prototype.getNextToken=function(){this.startAttributes={};this.endAttributes={};for(var d,b;void 0!==this.tokens[++this.pos];){d=this.tokens[this.pos];if("string"===typeof d){this.startAttributes.startLine=this.line;this.endAttributes.endLine=
this.line;if('b"'===d)return this.tokenValue='b"',34;this.tokenValue=d;return d.charCodeAt(0)}this.line+=null===(b=d[1].match(/\n/g))?0:b.length;if(a.Constants.T_COMMENT===d[0])Array.isArray(this.startAttributes.comments)||(this.startAttributes.comments=[]),this.startAttributes.comments.push({type:"comment",comment:d[1],line:d[2]});else if(a.Constants.T_DOC_COMMENT===d[0])this.startAttributes.comments.push(new PHPParser_Comment_Doc(d[1],d[2]));else if(void 0===this.dropTokens[d[0]])return this.tokenValue=
d[1],this.startAttributes.startLine=d[2],this.endAttributes.endLine=this.line,this.tokenMap[d[0]]}this.startAttributes.startLine=this.line;return 0};a.Parser.prototype.tokenName=function(d){var b="UNKNOWN";"T_INCLUDE T_INCLUDE_ONCE T_EVAL T_REQUIRE T_REQUIRE_ONCE T_LOGICAL_OR T_LOGICAL_XOR T_LOGICAL_AND T_PRINT T_PLUS_EQUAL T_MINUS_EQUAL T_MUL_EQUAL T_DIV_EQUAL T_CONCAT_EQUAL T_MOD_EQUAL T_AND_EQUAL T_OR_EQUAL T_XOR_EQUAL T_SL_EQUAL T_SR_EQUAL T_BOOLEAN_OR T_BOOLEAN_AND T_IS_EQUAL T_IS_NOT_EQUAL T_IS_IDENTICAL T_IS_NOT_IDENTICAL T_IS_SMALLER_OR_EQUAL T_IS_GREATER_OR_EQUAL T_SL T_SR T_INSTANCEOF T_INC T_DEC T_INT_CAST T_DOUBLE_CAST T_STRING_CAST T_ARRAY_CAST T_OBJECT_CAST T_BOOL_CAST T_UNSET_CAST T_NEW T_CLONE T_EXIT T_IF T_ELSEIF T_ELSE T_ENDIF T_LNUMBER T_DNUMBER T_STRING T_STRING_VARNAME T_VARIABLE T_NUM_STRING T_INLINE_HTML T_CHARACTER T_BAD_CHARACTER T_ENCAPSED_AND_WHITESPACE T_CONSTANT_ENCAPSED_STRING T_ECHO T_DO T_WHILE T_ENDWHILE T_FOR T_ENDFOR T_FOREACH T_ENDFOREACH T_DECLARE T_ENDDECLARE T_AS T_SWITCH T_ENDSWITCH T_CASE T_DEFAULT T_BREAK T_CONTINUE T_GOTO T_FUNCTION T_CONST T_RETURN T_TRY T_CATCH T_THROW T_USE T_INSTEADOF T_GLOBAL T_STATIC T_ABSTRACT T_FINAL T_PRIVATE T_PROTECTED T_PUBLIC T_VAR T_UNSET T_ISSET T_EMPTY T_HALT_COMPILER T_CLASS T_TRAIT T_INTERFACE T_EXTENDS T_IMPLEMENTS T_OBJECT_OPERATOR T_DOUBLE_ARROW T_LIST T_ARRAY T_CALLABLE T_CLASS_C T_TRAIT_C T_METHOD_C T_FUNC_C T_LINE T_FILE T_COMMENT T_DOC_COMMENT T_OPEN_TAG T_OPEN_TAG_WITH_ECHO T_CLOSE_TAG T_WHITESPACE T_START_HEREDOC T_END_HEREDOC T_DOLLAR_OPEN_CURLY_BRACES T_CURLY_OPEN T_PAAMAYIM_NEKUDOTAYIM T_DOUBLE_COLON T_NAMESPACE T_NS_C T_DIR T_NS_SEPARATOR".split(" ").some(function(c){return a.Constants[c]===
d?(b=c,!0):!1});return b};a.Parser.prototype.createTokenMap=function(){var d={},b,c,f=a.Constants.T_PAAMAYIM_NEKUDOTAYIM;for(c=256;1E3>c;++c)if(f===c)d[c]=this.T_PAAMAYIM_NEKUDOTAYIM;else if(a.Constants.T_OPEN_TAG_WITH_ECHO===c)d[c]=a.Constants.T_ECHO;else if(a.Constants.T_CLOSE_TAG===c)d[c]=59;else if("UNKNOWN"!==(b=this.tokenName(c)))d[c]=this[b];return d};a.Parser.prototype.MakeArray=function(a){return Array.isArray(a)?a:[a]};a.Parser.prototype.parseString=function(a){var b=0;"b"===a[0]&&(b=1);
return a="'"===a[b]?a.replace(["\\\\","\\'"],["\\","'"]):this.parseEscapeSequences(a,'"')};a.Parser.prototype.parseEscapeSequences=function(a,b){void 0!==b&&(a=a.replace(RegExp("\\"+b,"g"),b));var c={"\\":"\\",$:"$",n:"\n",r:"\r",t:"\t",f:"\f",v:"\v",e:"\u001b"};return a.replace(/~\\\\([\\\\$nrtfve]|[xX][0-9a-fA-F]{1,2}|[0-7]{1,3})~/g,function(a){a=a[1];return void 0!==c[a]?c[a]:"x"===a[0]||"X"===a[0]?chr(hexdec(a)):chr(octdec(a))})};a.Parser.prototype.TOKEN_NONE=-1;a.Parser.prototype.TOKEN_INVALID=
149;a.Parser.prototype.TOKEN_MAP_SIZE=384;a.Parser.prototype.YYLAST=913;a.Parser.prototype.YY2TBLSTATE=328;a.Parser.prototype.YYGLAST=415;a.Parser.prototype.YYNLSTATES=544;a.Parser.prototype.YYUNEXPECTED=32767;a.Parser.prototype.YYDEFAULT=-32766;a.Parser.prototype.YYERRTOK=256;a.Parser.prototype.T_INCLUDE=257;a.Parser.prototype.T_INCLUDE_ONCE=258;a.Parser.prototype.T_EVAL=259;a.Parser.prototype.T_REQUIRE=260;a.Parser.prototype.T_REQUIRE_ONCE=261;a.Parser.prototype.T_LOGICAL_OR=262;a.Parser.prototype.T_LOGICAL_XOR=
263;a.Parser.prototype.T_LOGICAL_AND=264;a.Parser.prototype.T_PRINT=265;a.Parser.prototype.T_PLUS_EQUAL=266;a.Parser.prototype.T_MINUS_EQUAL=267;a.Parser.prototype.T_MUL_EQUAL=268;a.Parser.prototype.T_DIV_EQUAL=269;a.Parser.prototype.T_CONCAT_EQUAL=270;a.Parser.prototype.T_MOD_EQUAL=271;a.Parser.prototype.T_AND_EQUAL=272;a.Parser.prototype.T_OR_EQUAL=273;a.Parser.prototype.T_XOR_EQUAL=274;a.Parser.prototype.T_SL_EQUAL=275;a.Parser.prototype.T_SR_EQUAL=276;a.Parser.prototype.T_BOOLEAN_OR=277;a.Parser.prototype.T_BOOLEAN_AND=
278;a.Parser.prototype.T_IS_EQUAL=279;a.Parser.prototype.T_IS_NOT_EQUAL=280;a.Parser.prototype.T_IS_IDENTICAL=281;a.Parser.prototype.T_IS_NOT_IDENTICAL=282;a.Parser.prototype.T_IS_SMALLER_OR_EQUAL=283;a.Parser.prototype.T_IS_GREATER_OR_EQUAL=284;a.Parser.prototype.T_SL=285;a.Parser.prototype.T_SR=286;a.Parser.prototype.T_INSTANCEOF=287;a.Parser.prototype.T_INC=288;a.Parser.prototype.T_DEC=289;a.Parser.prototype.T_INT_CAST=290;a.Parser.prototype.T_DOUBLE_CAST=291;a.Parser.prototype.T_STRING_CAST=292;
a.Parser.prototype.T_ARRAY_CAST=293;a.Parser.prototype.T_OBJECT_CAST=294;a.Parser.prototype.T_BOOL_CAST=295;a.Parser.prototype.T_UNSET_CAST=296;a.Parser.prototype.T_NEW=297;a.Parser.prototype.T_CLONE=298;a.Parser.prototype.T_EXIT=299;a.Parser.prototype.T_IF=300;a.Parser.prototype.T_ELSEIF=301;a.Parser.prototype.T_ELSE=302;a.Parser.prototype.T_ENDIF=303;a.Parser.prototype.T_LNUMBER=304;a.Parser.prototype.T_DNUMBER=305;a.Parser.prototype.T_STRING=306;a.Parser.prototype.T_STRING_VARNAME=307;a.Parser.prototype.T_VARIABLE=
308;a.Parser.prototype.T_NUM_STRING=309;a.Parser.prototype.T_INLINE_HTML=310;a.Parser.prototype.T_CHARACTER=311;a.Parser.prototype.T_BAD_CHARACTER=312;a.Parser.prototype.T_ENCAPSED_AND_WHITESPACE=313;a.Parser.prototype.T_CONSTANT_ENCAPSED_STRING=314;a.Parser.prototype.T_ECHO=315;a.Parser.prototype.T_DO=316;a.Parser.prototype.T_WHILE=317;a.Parser.prototype.T_ENDWHILE=318;a.Parser.prototype.T_FOR=319;a.Parser.prototype.T_ENDFOR=320;a.Parser.prototype.T_FOREACH=321;a.Parser.prototype.T_ENDFOREACH=322;
a.Parser.prototype.T_DECLARE=323;a.Parser.prototype.T_ENDDECLARE=324;a.Parser.prototype.T_AS=325;a.Parser.prototype.T_SWITCH=326;a.Parser.prototype.T_ENDSWITCH=327;a.Parser.prototype.T_CASE=328;a.Parser.prototype.T_DEFAULT=329;a.Parser.prototype.T_BREAK=330;a.Parser.prototype.T_CONTINUE=331;a.Parser.prototype.T_GOTO=332;a.Parser.prototype.T_FUNCTION=333;a.Parser.prototype.T_CONST=334;a.Parser.prototype.T_RETURN=335;a.Parser.prototype.T_TRY=336;a.Parser.prototype.T_CATCH=337;a.Parser.prototype.T_THROW=
338;a.Parser.prototype.T_USE=339;a.Parser.prototype.T_INSTEADOF=340;a.Parser.prototype.T_GLOBAL=341;a.Parser.prototype.T_STATIC=342;a.Parser.prototype.T_ABSTRACT=343;a.Parser.prototype.T_FINAL=344;a.Parser.prototype.T_PRIVATE=345;a.Parser.prototype.T_PROTECTED=346;a.Parser.prototype.T_PUBLIC=347;a.Parser.prototype.T_VAR=348;a.Parser.prototype.T_UNSET=349;a.Parser.prototype.T_ISSET=350;a.Parser.prototype.T_EMPTY=351;a.Parser.prototype.T_HALT_COMPILER=352;a.Parser.prototype.T_CLASS=353;a.Parser.prototype.T_TRAIT=
354;a.Parser.prototype.T_INTERFACE=355;a.Parser.prototype.T_EXTENDS=356;a.Parser.prototype.T_IMPLEMENTS=357;a.Parser.prototype.T_OBJECT_OPERATOR=358;a.Parser.prototype.T_DOUBLE_ARROW=359;a.Parser.prototype.T_LIST=360;a.Parser.prototype.T_ARRAY=361;a.Parser.prototype.T_CALLABLE=362;a.Parser.prototype.T_CLASS_C=363;a.Parser.prototype.T_TRAIT_C=364;a.Parser.prototype.T_METHOD_C=365;a.Parser.prototype.T_FUNC_C=366;a.Parser.prototype.T_LINE=367;a.Parser.prototype.T_FILE=368;a.Parser.prototype.T_COMMENT=
369;a.Parser.prototype.T_DOC_COMMENT=370;a.Parser.prototype.T_OPEN_TAG=371;a.Parser.prototype.T_OPEN_TAG_WITH_ECHO=372;a.Parser.prototype.T_CLOSE_TAG=373;a.Parser.prototype.T_WHITESPACE=374;a.Parser.prototype.T_START_HEREDOC=375;a.Parser.prototype.T_END_HEREDOC=376;a.Parser.prototype.T_DOLLAR_OPEN_CURLY_BRACES=377;a.Parser.prototype.T_CURLY_OPEN=378;a.Parser.prototype.T_PAAMAYIM_NEKUDOTAYIM=379;a.Parser.prototype.T_NAMESPACE=380;a.Parser.prototype.T_NS_C=381;a.Parser.prototype.T_DIR=382;a.Parser.prototype.T_NS_SEPARATOR=
383;a.Parser.prototype.terminals="$EOF error T_INCLUDE T_INCLUDE_ONCE T_EVAL T_REQUIRE T_REQUIRE_ONCE ',' T_LOGICAL_OR T_LOGICAL_XOR T_LOGICAL_AND T_PRINT '=' T_PLUS_EQUAL T_MINUS_EQUAL T_MUL_EQUAL T_DIV_EQUAL T_CONCAT_EQUAL T_MOD_EQUAL T_AND_EQUAL T_OR_EQUAL T_XOR_EQUAL T_SL_EQUAL T_SR_EQUAL '?' ':' T_BOOLEAN_OR T_BOOLEAN_AND '|' '^' '&' T_IS_EQUAL T_IS_NOT_EQUAL T_IS_IDENTICAL T_IS_NOT_IDENTICAL '<' T_IS_SMALLER_OR_EQUAL '>' T_IS_GREATER_OR_EQUAL T_SL T_SR '+' '-' '.' '*' '/' '%' '!' T_INSTANCEOF '~' T_INC T_DEC T_INT_CAST T_DOUBLE_CAST T_STRING_CAST T_ARRAY_CAST T_OBJECT_CAST T_BOOL_CAST T_UNSET_CAST '@' '[' T_NEW T_CLONE T_EXIT T_IF T_ELSEIF T_ELSE T_ENDIF T_LNUMBER T_DNUMBER T_STRING T_STRING_VARNAME T_VARIABLE T_NUM_STRING T_INLINE_HTML T_ENCAPSED_AND_WHITESPACE T_CONSTANT_ENCAPSED_STRING T_ECHO T_DO T_WHILE T_ENDWHILE T_FOR T_ENDFOR T_FOREACH T_ENDFOREACH T_DECLARE T_ENDDECLARE T_AS T_SWITCH T_ENDSWITCH T_CASE T_DEFAULT T_BREAK T_CONTINUE T_GOTO T_FUNCTION T_CONST T_RETURN T_TRY T_CATCH T_THROW T_USE T_INSTEADOF T_GLOBAL T_STATIC T_ABSTRACT T_FINAL T_PRIVATE T_PROTECTED T_PUBLIC T_VAR T_UNSET T_ISSET T_EMPTY T_HALT_COMPILER T_CLASS T_TRAIT T_INTERFACE T_EXTENDS T_IMPLEMENTS T_OBJECT_OPERATOR T_DOUBLE_ARROW T_LIST T_ARRAY T_CALLABLE T_CLASS_C T_TRAIT_C T_METHOD_C T_FUNC_C T_LINE T_FILE T_START_HEREDOC T_END_HEREDOC T_DOLLAR_OPEN_CURLY_BRACES T_CURLY_OPEN T_PAAMAYIM_NEKUDOTAYIM T_NAMESPACE T_NS_C T_DIR T_NS_SEPARATOR ';' '{' '}' '(' ')' '$' ']' '`' '\"' ???".split(" ");
a.Parser.prototype.translate=[0,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,47,148,149,145,46,30,149,143,144,44,41,7,42,43,45,149,149,149,149,149,149,149,149,149,149,25,140,35,12,37,24,59,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,60,149,146,29,149,147,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,
141,28,142,49,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,149,
149,149,149,149,149,149,149,1,2,3,4,5,6,8,9,10,11,13,14,15,16,17,18,19,20,21,22,23,26,27,31,32,33,34,36,38,39,40,48,50,51,52,53,54,55,56,57,58,61,62,63,64,65,66,67,68,69,70,71,72,73,74,149,149,75,76,77,78,79,80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,111,112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127,128,129,130,149,149,149,149,149,149,131,132,133,134,135,136,137,138,139];a.Parser.prototype.yyaction=[61,62,363,63,64,-32766,
-32766,-32766,509,65,708,709,710,707,706,705,-32766,-32766,-32766,-32766,-32766,-32766,132,-32766,-32766,-32766,-32766,-32766,-32767,-32767,-32767,-32767,-32766,335,-32766,-32766,-32766,-32766,-32766,66,67,351,663,664,40,68,548,69,232,233,70,71,72,73,74,75,76,77,30,246,78,336,364,-112,0,469,833,834,365,641,890,436,590,41,835,53,27,366,294,367,687,368,921,369,923,922,370,-32766,-32766,-32766,42,43,371,339,126,44,372,337,79,297,349,292,293,-32766,918,-32766,-32766,373,374,375,376,377,391,199,361,338,
573,613,378,379,380,381,845,839,840,841,842,836,837,253,-32766,87,88,89,391,843,838,338,597,519,128,80,129,273,332,257,261,47,673,90,91,92,93,94,95,96,97,98,99,100,101,102,103,104,105,106,107,108,109,110,799,247,884,108,109,110,226,247,21,-32766,310,-32766,-32766,-32766,642,548,-32766,-32766,-32766,-32766,56,353,-32766,-32766,-32766,55,-32766,-32766,-32766,-32766,-32766,58,-32766,-32766,-32766,-32766,-32766,-32766,-32766,-32766,-32766,557,-32766,-32766,518,-32766,548,890,-32766,390,-32766,228,252,
-32766,-32766,-32766,-32766,-32766,275,-32766,234,-32766,587,588,-32766,-32766,-32766,-32766,-32766,-32766,-32766,46,236,-32766,-32766,281,-32766,682,348,-32766,390,-32766,346,333,521,-32766,-32766,-32766,271,911,262,237,446,911,-32766,894,59,700,358,135,548,123,538,35,-32766,333,122,-32766,-32766,-32766,271,-32766,124,-32766,692,-32766,-32766,-32766,-32766,700,273,22,-32766,-32766,-32766,-32766,239,-32766,-32766,612,-32766,548,134,-32766,390,-32766,462,354,-32766,-32766,-32766,-32766,-32766,227,
-32766,238,-32766,845,542,-32766,856,611,200,-32766,-32766,-32766,259,280,-32766,-32766,201,-32766,855,129,-32766,390,130,202,333,206,-32766,-32766,-32766,271,-32766,-32766,-32766,125,601,-32766,136,299,700,489,28,548,105,106,107,-32766,498,499,-32766,-32766,-32766,207,-32766,133,-32766,525,-32766,-32766,-32766,-32766,663,664,527,-32766,-32766,-32766,-32766,528,-32766,-32766,610,-32766,548,427,-32766,390,-32766,532,539,-32766,-32766,-32766,-32766,-32766,240,-32766,247,-32766,697,543,-32766,554,523,
608,-32766,-32766,-32766,686,535,-32766,-32766,54,-32766,57,60,-32766,390,246,-155,278,345,-32766,-32766,-32766,506,347,-152,471,402,403,-32766,405,404,272,493,416,548,318,417,505,-32766,517,548,-32766,-32766,-32766,549,-32766,562,-32766,916,-32766,-32766,-32766,-32766,564,826,848,-32766,-32766,-32766,-32766,694,-32766,-32766,485,-32766,548,487,-32766,390,-32766,504,802,-32766,-32766,-32766,-32766,-32766,279,-32766,911,-32766,502,492,-32766,413,483,269,-32766,-32766,-32766,243,337,-32766,-32766,418,
-32766,454,229,-32766,390,274,373,374,344,-32766,-32766,-32766,360,614,-32766,573,613,378,379,-274,548,615,-332,844,-32766,258,51,-32766,-32766,-32766,270,-32766,346,-32766,52,-32766,260,0,-32766,-333,-32766,-32766,-32766,-32766,-32766,-32766,205,-32766,-32766,49,-32766,548,424,-32766,390,-32766,-266,264,-32766,-32766,-32766,-32766,-32766,409,-32766,343,-32766,265,312,-32766,470,513,-275,-32766,-32766,-32766,920,337,-32766,-32766,530,-32766,531,600,-32766,390,592,373,374,578,581,-32766,-32766,644,
629,-32766,573,613,378,379,635,548,636,576,627,-32766,625,693,-32766,-32766,-32766,691,-32766,591,-32766,582,-32766,203,204,-32766,584,583,-32766,-32766,-32766,-32766,586,599,-32766,-32766,589,-32766,690,558,-32766,390,197,683,919,86,520,522,-32766,524,833,834,529,533,-32766,534,537,541,835,48,111,112,113,114,115,116,117,118,119,120,121,127,31,633,337,330,634,585,-32766,32,291,337,330,478,373,374,917,291,891,889,875,373,374,553,613,378,379,737,739,887,553,613,378,379,824,451,675,839,840,841,842,836,
837,320,895,277,885,23,33,843,838,556,277,337,330,-32766,34,-32766,555,291,36,37,38,373,374,39,45,50,81,82,83,84,553,613,378,379,-32767,-32767,-32767,-32767,103,104,105,106,107,337,85,131,137,337,138,198,224,225,277,373,374,-332,230,373,374,24,337,231,573,613,378,379,573,613,378,379,373,374,235,248,249,250,337,251,0,573,613,378,379,276,329,331,373,374,-32766,337,574,490,792,337,609,573,613,378,379,373,374,25,300,373,374,319,337,795,573,613,378,379,573,613,378,379,373,374,516,355,359,445,482,796,507,
573,613,378,379,508,548,337,890,775,791,337,604,803,808,806,698,373,374,888,807,373,374,-32766,-32766,-32766,573,613,378,379,573,613,378,379,873,832,804,872,851,-32766,809,-32766,-32766,-32766,-32766,805,20,26,29,298,480,515,770,778,827,457,0,900,455,774,0,0,0,874,870,886,823,915,852,869,488,0,391,793,0,338,0,0,0,340,0,273];a.Parser.prototype.yycheck=[2,3,4,5,6,8,9,10,70,11,104,105,106,107,108,109,8,9,10,8,9,24,60,26,27,28,29,30,31,32,33,34,24,7,26,27,28,29,30,41,42,7,123,124,7,47,70,49,50,51,52,
53,54,55,56,57,58,59,60,61,62,63,64,144,0,75,68,69,70,25,72,70,74,7,76,77,78,79,7,81,142,83,70,85,72,73,88,8,9,10,92,93,94,95,7,97,98,95,100,7,7,103,104,24,142,26,27,105,106,111,112,113,136,7,7,139,114,115,116,117,122,123,132,125,126,127,128,129,130,131,8,8,9,10,136,137,138,139,140,141,25,143,141,145,142,147,148,24,72,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,144,48,72,44,45,46,30,48,144,64,72,8,9,10,140,70,8,9,10,74,60,25,77,78,79,60,81,24,83,26,85,60,24,88,26,27,28,92,93,94,
64,140,97,98,70,100,70,72,103,104,74,145,7,77,78,79,111,81,7,83,30,85,140,140,88,8,9,10,92,93,94,133,134,97,98,145,100,140,7,103,104,24,139,96,141,140,141,111,101,75,75,30,70,75,64,70,60,110,121,12,70,141,25,143,74,96,141,77,78,79,101,81,141,83,140,85,140,141,88,110,145,144,92,93,94,64,7,97,98,142,100,70,141,103,104,74,145,141,77,78,79,111,81,7,83,30,85,132,25,88,132,142,12,92,93,94,120,60,97,98,12,100,148,141,103,104,141,12,96,12,140,141,111,101,8,9,10,141,25,64,90,91,110,65,66,70,41,42,43,74,65,
66,77,78,79,12,81,25,83,25,85,140,141,88,123,124,25,92,93,94,64,25,97,98,142,100,70,120,103,104,74,25,25,77,78,79,111,81,30,83,48,85,140,141,88,140,141,30,92,93,94,140,141,97,98,60,100,60,60,103,104,61,72,75,70,140,141,111,67,70,87,99,70,70,64,70,72,102,89,70,70,71,70,70,74,70,70,77,78,79,70,81,70,83,70,85,140,141,88,70,144,70,92,93,94,64,70,97,98,72,100,70,72,103,104,74,72,72,77,78,79,111,81,75,83,75,85,89,86,88,79,101,118,92,93,94,87,95,97,98,87,100,87,87,103,104,118,105,106,95,140,141,111,95,115,
64,114,115,116,117,135,70,115,120,132,74,120,140,77,78,79,119,81,139,83,140,85,120,-1,88,120,140,141,92,93,94,64,121,97,98,121,100,70,122,103,104,74,135,135,77,78,79,111,81,139,83,139,85,135,135,88,135,135,135,92,93,94,142,95,97,98,140,100,140,140,103,104,140,105,106,140,140,141,111,140,140,64,114,115,116,117,140,70,140,140,140,74,140,140,77,78,79,140,81,140,83,140,85,41,42,88,140,140,141,92,93,94,140,140,97,98,140,100,140,140,103,104,60,140,142,141,141,141,111,141,68,69,141,141,72,141,141,141,76,
12,13,14,15,16,17,18,19,20,21,22,23,141,143,142,95,96,142,140,141,143,101,95,96,142,105,106,142,101,142,142,142,105,106,114,115,116,117,50,51,142,114,115,116,117,142,123,142,125,126,127,128,129,130,131,142,136,142,144,143,137,138,142,136,95,96,143,143,145,142,101,143,143,143,105,106,143,143,143,143,143,143,143,114,115,116,117,35,36,37,38,39,40,41,42,43,95,143,143,143,95,143,143,143,143,136,105,106,120,143,105,106,144,95,143,114,115,116,117,114,115,116,117,105,106,143,143,143,143,95,143,-1,114,115,
116,117,143,143,143,105,106,143,95,142,80,146,95,142,114,115,116,117,105,106,144,144,105,106,144,95,142,114,115,116,117,114,115,116,117,105,106,82,144,144,144,144,142,84,114,115,116,117,144,70,95,72,144,144,95,142,144,146,144,142,105,106,146,144,105,106,8,9,10,114,115,116,117,114,115,116,117,144,144,144,144,144,24,104,26,27,28,29,144,144,144,144,144,144,144,144,144,144,144,-1,144,144,144,-1,-1,-1,146,146,146,146,146,146,146,146,-1,136,147,-1,139,-1,-1,-1,143,-1,145];a.Parser.prototype.yybase=[0,574,
581,623,655,2,718,402,747,659,672,688,743,701,705,483,483,483,483,483,351,356,366,366,367,366,344,-2,-2,-2,200,200,231,231,231,231,231,231,231,231,200,231,451,482,532,316,370,115,146,285,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,401,
401,401,401,401,401,401,401,401,401,401,44,474,429,476,481,487,488,739,740,741,734,733,416,736,539,541,342,542,543,552,557,559,536,567,737,755,569,735,738,123,123,123,123,123,123,123,123,123,122,11,336,336,336,336,336,336,336,336,336,336,336,336,336,336,336,227,227,173,577,577,577,577,577,577,577,577,577,577,577,79,178,846,8,-3,-3,-3,-3,642,706,706,706,706,157,179,242,431,431,360,431,525,368,767,767,767,767,767,767,767,767,767,767,767,767,350,375,315,315,652,652,-81,-81,-81,-81,251,185,188,184,-62,
348,195,195,195,408,392,410,1,192,129,129,129,-24,-24,-24,-24,499,-24,-24,-24,113,108,108,12,161,349,526,271,398,529,438,130,206,265,427,76,414,427,288,295,76,166,44,262,422,141,491,372,494,413,71,92,93,267,135,100,34,415,745,746,742,-38,420,-10,135,147,744,498,107,26,493,144,377,363,369,332,363,400,377,588,377,376,377,360,37,582,376,377,374,376,388,363,364,412,369,377,441,443,390,106,332,377,390,377,400,64,590,591,323,592,589,593,649,608,362,500,399,407,620,625,636,365,354,614,524,425,359,355,423,
570,578,357,406,414,394,352,403,531,433,403,653,434,385,417,411,444,310,318,501,425,668,757,380,637,684,403,609,387,87,325,638,382,403,639,403,696,503,615,403,697,384,435,425,352,352,352,700,66,699,583,702,707,704,748,721,749,584,750,358,583,722,751,682,215,613,422,436,389,447,221,257,752,403,403,506,499,403,395,685,397,426,753,392,391,647,683,403,418,754,221,723,587,724,450,568,507,648,509,327,725,353,497,610,454,622,455,461,404,510,373,732,612,247,361,664,463,405,692,641,464,465,511,343,437,335,
409,396,665,293,467,468,472,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,0,0,0,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,123,123,123,
123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,0,0,0,0,0,0,0,0,0,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,123,767,767,767,767,767,767,767,767,767,767,767,123,123,123,123,123,123,123,123,0,129,129,129,129,-94,-94,-94,767,767,767,767,767,767,0,0,0,0,0,0,0,0,0,0,0,0,-94,-94,129,129,767,767,-24,-24,-24,-24,-24,108,108,108,-24,108,145,145,145,108,108,108,100,100,0,0,0,0,0,0,0,145,0,0,0,376,0,0,0,145,260,260,221,
260,260,135,0,0,425,376,0,364,376,0,0,0,0,0,0,531,0,87,637,241,425,0,0,0,0,0,0,0,425,289,289,306,0,358,0,0,0,306,241,0,0,221];a.Parser.prototype.yydefault=[3,32767,32767,1,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,104,96,110,95,106,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,358,358,122,122,122,122,122,122,122,122,316,32767,32767,32767,32767,32767,32767,32767,32767,32767,173,173,173,32767,348,348,348,348,348,348,348,32767,32767,32767,32767,32767,32767,32767,
32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,363,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,
32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,232,233,235,236,172,125,349,362,171,199,201,250,200,177,182,183,184,185,186,187,188,189,190,191,192,176,229,228,197,313,313,316,32767,32767,32767,32767,32767,32767,32767,32767,198,202,204,203,219,220,217,218,175,221,222,223,224,157,157,157,357,357,32767,357,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,158,32767,211,212,276,276,117,117,117,117,117,32767,32767,32767,
32767,284,32767,32767,32767,32767,32767,286,32767,32767,206,207,205,32767,32767,32767,32767,32767,32767,32767,32767,32767,285,32767,32767,32767,32767,32767,32767,32767,32767,334,321,272,32767,32767,32767,265,32767,107,109,32767,32767,32767,32767,302,339,32767,32767,32767,17,32767,32767,32767,370,334,32767,32767,19,32767,32767,32767,32767,227,32767,338,332,32767,32767,32767,32767,32767,32767,63,32767,32767,32767,32767,32767,63,281,63,32767,63,32767,315,287,32767,63,74,32767,72,32767,32767,76,32767,
63,93,93,254,315,54,63,254,63,32767,32767,32767,32767,4,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,267,32767,323,32767,337,336,324,32767,265,32767,215,194,266,32767,196,32767,32767,270,273,32767,32767,32767,134,32767,268,180,32767,32767,32767,32767,365,32767,32767,174,32767,32767,32767,130,32767,61,332,32767,32767,355,32767,32767,332,269,208,209,210,32767,121,32767,310,32767,32767,32767,32767,32767,32767,327,32767,333,32767,32767,32767,32767,111,
32767,302,32767,32767,32767,75,32767,32767,178,126,32767,32767,364,32767,32767,32767,320,32767,32767,32767,32767,32767,62,32767,32767,77,32767,32767,32767,32767,332,32767,32767,32767,115,32767,169,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,32767,332,32767,32767,32767,32767,32767,32767,32767,4,32767,151,32767,32767,32767,32767,32767,32767,32767,25,25,3,137,3,137,25,101,25,25,137,93,93,25,25,25,144,25,25,25,25,25,25,25,25];a.Parser.prototype.yygoto=[141,141,173,173,173,
173,173,173,173,173,141,173,142,143,144,148,153,155,181,175,172,172,172,172,174,174,174,174,174,174,174,168,169,170,171,179,757,758,392,760,781,782,783,784,785,786,787,789,725,145,146,147,149,150,151,152,154,177,178,180,196,208,209,210,211,212,213,214,215,217,218,219,220,244,245,266,267,268,430,431,432,182,183,184,185,186,187,188,189,190,191,192,156,157,158,159,176,160,194,161,162,163,164,195,165,193,139,166,167,452,452,452,452,452,452,452,452,452,452,452,453,453,453,453,453,453,453,453,453,453,453,
551,551,551,464,491,394,394,394,394,394,394,394,394,394,394,394,394,394,394,394,394,394,394,407,552,552,552,810,810,662,662,662,662,662,594,283,595,510,399,399,567,679,632,849,850,863,660,714,426,222,622,622,622,622,223,617,623,494,395,395,395,395,395,395,395,395,395,395,395,395,395,395,395,395,395,395,465,472,514,904,398,398,425,425,459,425,419,322,421,421,393,396,412,422,428,460,463,473,481,501,5,476,284,327,1,15,2,6,7,550,550,550,8,9,10,668,16,11,17,12,18,13,19,14,704,328,881,881,643,628,626,626,
624,626,526,401,652,647,847,847,847,847,847,847,847,847,847,847,847,437,438,441,447,477,479,497,290,910,910,400,400,486,880,880,263,913,910,303,255,723,306,822,821,306,896,896,896,861,304,323,410,913,913,897,316,420,769,658,559,879,671,536,324,466,565,311,311,311,801,241,676,496,439,440,442,444,448,475,631,858,311,285,286,603,495,712,0,406,321,0,0,0,314,0,0,429,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,411];a.Parser.prototype.yygcheck=
[15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,35,35,35,35,35,35,35,35,35,35,35,86,86,86,86,86,86,86,86,86,86,86,6,6,6,21,21,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,35,71,7,7,7,35,35,35,35,35,35,35,29,44,29,35,
86,86,12,12,12,12,12,12,12,12,75,40,35,35,35,35,40,35,35,35,82,82,82,82,82,82,82,82,82,82,82,82,82,82,82,82,82,82,36,36,36,104,82,82,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,28,13,42,42,42,2,13,2,13,13,5,5,5,13,13,13,54,13,13,13,13,13,13,13,13,67,67,83,83,5,5,5,5,5,5,5,5,5,5,93,93,93,93,93,93,93,93,93,93,93,52,52,52,52,52,52,52,4,105,105,89,89,94,84,84,92,105,105,26,92,71,4,91,91,4,84,84,84,97,30,70,30,105,105,102,27,30,72,50,10,84,55,46,9,30,11,90,90,90,80,30,56,30,85,85,85,85,85,85,43,
96,90,44,44,34,77,69,-1,4,90,-1,-1,-1,4,-1,-1,4,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,71];a.Parser.prototype.yygbase=[0,0,-286,0,10,239,130,154,0,-10,25,-23,-29,-289,0,-30,0,0,0,0,0,83,0,0,0,0,245,84,-11,142,-28,0,0,0,-13,-88,-42,0,0,0,-344,0,-38,-12,-188,0,23,0,0,0,66,0,247,0,205,24,-18,0,0,0,0,0,0,0,0,0,0,13,0,-15,85,74,70,0,0,148,0,-14,0,0,-6,0,-35,11,47,278,-77,
0,0,44,68,43,38,72,94,0,-16,109,0,0,0,0,87,0,170,34,0];a.Parser.prototype.yygdefault=[-32768,362,3,546,382,570,571,572,307,305,560,566,467,4,568,140,295,575,296,500,577,414,579,580,308,309,415,315,216,593,503,313,596,357,602,301,449,383,350,461,221,423,456,630,282,638,540,646,649,450,657,352,433,434,667,672,677,680,334,325,474,684,685,256,689,511,512,703,242,711,317,724,342,788,790,397,408,484,797,326,800,384,385,386,387,435,818,815,289,866,287,443,254,853,468,356,903,862,288,388,389,302,898,341,
905,912,458];a.Parser.prototype.yylhs=[0,1,2,2,4,4,3,3,3,3,3,3,3,3,3,8,8,10,10,10,10,9,9,11,13,13,14,14,14,14,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,5,33,33,34,27,27,30,30,6,7,7,7,37,37,37,38,38,41,41,39,39,42,42,22,22,29,29,32,32,31,31,43,23,23,23,23,44,44,45,45,46,46,20,20,16,16,47,18,18,48,17,17,19,19,36,36,49,49,50,50,51,51,51,51,52,52,53,53,54,54,24,24,55,55,55,25,25,56,56,40,40,57,57,57,57,62,62,63,63,64,64,64,64,65,66,66,61,61,58,58,60,60,68,68,67,67,67,67,67,67,59,59,69,69,
26,26,21,21,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,71,77,77,79,79,80,81,81,81,81,81,81,86,86,35,35,35,72,72,87,87,82,82,88,88,88,88,88,73,73,73,76,76,76,78,78,93,93,93,93,93,93,93,93,93,93,93,93,93,93,12,12,12,12,12,12,74,74,74,74,94,94,96,96,95,95,97,97,28,28,28,28,99,99,98,98,98,98,98,100,100,84,84,89,89,
83,83,101,101,101,101,90,90,90,90,85,85,91,91,91,70,70,102,102,102,75,75,103,103,104,104,104,104,92,92,92,92,105,105,105,105,105,105,105,106,106,106];a.Parser.prototype.yylen=[1,1,2,0,1,3,1,1,1,1,3,5,4,3,3,3,1,1,3,2,4,3,1,3,2,0,1,1,1,1,3,7,10,5,7,9,5,2,3,2,3,2,3,3,3,3,1,2,5,7,8,10,5,1,5,3,3,2,1,2,8,1,3,0,1,9,7,6,5,1,2,2,0,2,0,2,0,2,1,3,1,4,1,4,1,4,1,3,3,3,4,4,5,0,2,4,3,1,1,1,4,0,2,5,0,2,6,0,2,0,3,1,0,1,3,3,5,0,1,1,1,1,0,1,3,1,2,3,1,1,2,4,3,1,1,3,2,0,3,3,8,3,1,3,0,2,4,5,4,4,3,1,1,1,3,1,1,0,1,1,2,1,
1,1,1,1,1,1,3,1,3,3,1,0,1,1,6,3,4,4,1,2,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,3,2,2,2,2,3,3,3,3,3,3,3,3,3,3,3,5,4,4,4,2,2,4,2,2,2,2,2,2,2,2,2,2,2,1,4,3,3,2,9,10,3,0,4,1,3,2,4,6,8,4,4,4,1,1,1,2,3,1,1,1,1,1,1,0,3,3,4,4,0,2,3,0,1,1,0,3,1,1,1,1,1,1,1,1,1,1,1,3,2,1,1,3,2,2,4,3,1,3,3,3,0,2,0,1,3,1,3,1,1,1,1,1,6,4,3,6,4,4,4,1,3,1,2,1,1,4,1,3,6,4,4,4,4,1,4,0,1,1,3,1,3,1,1,4,0,0,2,3,1,3,1,4,2,2,2,1,2,1,4,3,3,3,6,3,1,1,1];a.Parser.prototype.yyn0=function(){this.yyval=this.yyastk[this.stackPos]};
a.Parser.prototype.yyn1=function(){this.yyval=this.Stmt_Namespace_postprocess(this.yyastk[this.stackPos-0])};a.Parser.prototype.yyn2=function(){Array.isArray(this.yyastk[this.stackPos-0])?this.yyval=this.yyastk[this.stackPos-1].concat(this.yyastk[this.stackPos-0]):(this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]),this.yyval=this.yyastk[this.stackPos-1])};a.Parser.prototype.yyn3=function(){this.yyval=[]};a.Parser.prototype.yyn4=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn5=
function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn6=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn7=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn8=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn9=function(a){this.yyval=this.Node_Stmt_HaltCompiler(a)};a.Parser.prototype.yyn10=function(a){this.yyval=this.Node_Stmt_Namespace(this.Node_Name(this.yyastk[this.stackPos-
1],a),null,a)};a.Parser.prototype.yyn11=function(a){this.yyval=this.Node_Stmt_Namespace(this.Node_Name(this.yyastk[this.stackPos-3],a),this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn12=function(a){this.yyval=this.Node_Stmt_Namespace(null,this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn13=function(a){this.yyval=this.Node_Stmt_Use(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn14=function(a){this.yyval=this.Node_Stmt_Const(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn15=
function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn16=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn17=function(a){this.yyval=this.Node_Stmt_UseUse(this.Node_Name(this.yyastk[this.stackPos-0],a),null,a)};a.Parser.prototype.yyn18=function(a){this.yyval=this.Node_Stmt_UseUse(this.Node_Name(this.yyastk[this.stackPos-2],a),this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn19=function(a){this.yyval=
this.Node_Stmt_UseUse(this.Node_Name(this.yyastk[this.stackPos-0],a),null,a)};a.Parser.prototype.yyn20=function(a){this.yyval=this.Node_Stmt_UseUse(this.Node_Name(this.yyastk[this.stackPos-2],a),this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn21=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn22=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn23=function(a){this.yyval=this.Node_Const(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn24=function(){Array.isArray(this.yyastk[this.stackPos-0])?this.yyval=this.yyastk[this.stackPos-1].concat(this.yyastk[this.stackPos-0]):(this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]),this.yyval=this.yyastk[this.stackPos-1])};a.Parser.prototype.yyn25=function(){this.yyval=[]};a.Parser.prototype.yyn26=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn27=function(){this.yyval=this.yyastk[this.stackPos-
0]};a.Parser.prototype.yyn28=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn29=function(){throw Error("__halt_compiler() can only be used from the outermost scope");};a.Parser.prototype.yyn30=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn31=function(a){this.yyval=this.Node_Stmt_If(this.yyastk[this.stackPos-4],{stmts:Array.isArray(this.yyastk[this.stackPos-2])?this.yyastk[this.stackPos-2]:[this.yyastk[this.stackPos-2]],elseifs:this.yyastk[this.stackPos-
1],Else:this.yyastk[this.stackPos-0]},a)};a.Parser.prototype.yyn32=function(a){this.yyval=this.Node_Stmt_If(this.yyastk[this.stackPos-7],{stmts:this.yyastk[this.stackPos-4],elseifs:this.yyastk[this.stackPos-3],"else":this.yyastk[this.stackPos-2]},a)};a.Parser.prototype.yyn33=function(a){this.yyval=this.Node_Stmt_While(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn34=function(a){this.yyval=this.Node_Stmt_Do(this.yyastk[this.stackPos-2],Array.isArray(this.yyastk[this.stackPos-
5])?this.yyastk[this.stackPos-5]:[this.yyastk[this.stackPos-5]],a)};a.Parser.prototype.yyn35=function(a){this.yyval=this.Node_Stmt_For({init:this.yyastk[this.stackPos-6],cond:this.yyastk[this.stackPos-4],loop:this.yyastk[this.stackPos-2],stmts:this.yyastk[this.stackPos-0]},a)};a.Parser.prototype.yyn36=function(a){this.yyval=this.Node_Stmt_Switch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn37=function(a){this.yyval=this.Node_Stmt_Break(null,a)};a.Parser.prototype.yyn38=
function(a){this.yyval=this.Node_Stmt_Break(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn39=function(a){this.yyval=this.Node_Stmt_Continue(null,a)};a.Parser.prototype.yyn40=function(a){this.yyval=this.Node_Stmt_Continue(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn41=function(a){this.yyval=this.Node_Stmt_Return(null,a)};a.Parser.prototype.yyn42=function(a){this.yyval=this.Node_Stmt_Return(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn43=function(a){this.yyval=this.Node_Stmt_Global(this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn44=function(a){this.yyval=this.Node_Stmt_Static(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn45=function(a){this.yyval=this.Node_Stmt_Echo(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn46=function(a){this.yyval=this.Node_Stmt_InlineHTML(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn47=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn48=function(a){this.yyval=this.Node_Stmt_Unset(this.yyastk[this.stackPos-2],a)};a.Parser.prototype.yyn49=
function(a){this.yyval=this.Node_Stmt_Foreach(this.yyastk[this.stackPos-4],this.yyastk[this.stackPos-2],{keyVar:null,byRef:!1,stmts:this.yyastk[this.stackPos-0]},a)};a.Parser.prototype.yyn50=function(a){this.yyval=this.Node_Stmt_Foreach(this.yyastk[this.stackPos-5],this.yyastk[this.stackPos-2],{keyVar:null,byRef:!0,stmts:this.yyastk[this.stackPos-0]},a)};a.Parser.prototype.yyn51=function(a){this.yyval=this.Node_Stmt_Foreach(this.yyastk[this.stackPos-7],this.yyastk[this.stackPos-2],{keyVar:this.yyastk[this.stackPos-
5],byRef:this.yyastk[this.stackPos-3],stmts:this.yyastk[this.stackPos-0]},a)};a.Parser.prototype.yyn52=function(a){this.yyval=this.Node_Stmt_Declare(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn53=function(){this.yyval=[]};a.Parser.prototype.yyn54=function(a){this.yyval=this.Node_Stmt_TryCatch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn55=function(a){this.yyval=this.Node_Stmt_Throw(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn56=
function(a){this.yyval=this.Node_Stmt_Goto(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn57=function(a){this.yyval=this.Node_Stmt_Label(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn58=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn59=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn60=function(a){this.yyval=this.Node_Stmt_Catch(this.yyastk[this.stackPos-5],this.yyastk[this.stackPos-
4].substring(1),this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn61=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn62=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn63=function(){this.yyval=!1};a.Parser.prototype.yyn64=function(){this.yyval=!0};a.Parser.prototype.yyn65=function(a){this.yyval=this.Node_Stmt_Function(this.yyastk[this.stackPos-6],{byRef:this.yyastk[this.stackPos-
7],params:this.yyastk[this.stackPos-4],stmts:this.yyastk[this.stackPos-1]},a)};a.Parser.prototype.yyn66=function(a){this.yyval=this.Node_Stmt_Class(this.yyastk[this.stackPos-5],{type:this.yyastk[this.stackPos-6],Extends:this.yyastk[this.stackPos-4],Implements:this.yyastk[this.stackPos-3],stmts:this.yyastk[this.stackPos-1]},a)};a.Parser.prototype.yyn67=function(a){this.yyval=this.Node_Stmt_Interface(this.yyastk[this.stackPos-4],{Extends:this.yyastk[this.stackPos-3],stmts:this.yyastk[this.stackPos-
1]},a)};a.Parser.prototype.yyn68=function(a){this.yyval=this.Node_Stmt_Trait(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn69=function(){this.yyval=0};a.Parser.prototype.yyn70=function(){this.yyval=this.MODIFIER_ABSTRACT};a.Parser.prototype.yyn71=function(){this.yyval=this.MODIFIER_FINAL};a.Parser.prototype.yyn72=function(){this.yyval=null};a.Parser.prototype.yyn73=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn74=function(){this.yyval=
[]};a.Parser.prototype.yyn75=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn76=function(){this.yyval=[]};a.Parser.prototype.yyn77=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn78=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn79=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn80=function(){this.yyval=Array.isArray(this.yyastk[this.stackPos-
0])?this.yyastk[this.stackPos-0]:[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn81=function(){this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn82=function(){this.yyval=Array.isArray(this.yyastk[this.stackPos-0])?this.yyastk[this.stackPos-0]:[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn83=function(){this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn84=function(){this.yyval=Array.isArray(this.yyastk[this.stackPos-0])?this.yyastk[this.stackPos-0]:[this.yyastk[this.stackPos-
0]]};a.Parser.prototype.yyn85=function(){this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn86=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn87=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn88=function(a){this.yyval=this.Node_Stmt_DeclareDeclare(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn89=function(){this.yyval=this.yyastk[this.stackPos-
1]};a.Parser.prototype.yyn90=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn91=function(){this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn92=function(){this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn93=function(){this.yyval=[]};a.Parser.prototype.yyn94=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn95=function(a){this.yyval=this.Node_Stmt_Case(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn96=function(a){this.yyval=this.Node_Stmt_Case(null,this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn97=function(){this.yyval=this.yyastk[this.stackPos]};a.Parser.prototype.yyn98=function(){this.yyval=this.yyastk[this.stackPos]};a.Parser.prototype.yyn99=function(){this.yyval=Array.isArray(this.yyastk[this.stackPos-0])?this.yyastk[this.stackPos-0]:[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn100=function(){this.yyval=this.yyastk[this.stackPos-
2]};a.Parser.prototype.yyn101=function(){this.yyval=[]};a.Parser.prototype.yyn102=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn103=function(a){this.yyval=this.Node_Stmt_ElseIf(this.yyastk[this.stackPos-2],Array.isArray(this.yyastk[this.stackPos-0])?this.yyastk[this.stackPos-0]:[this.yyastk[this.stackPos-0]],a)};a.Parser.prototype.yyn104=function(){this.yyval=[]};a.Parser.prototype.yyn105=function(){this.yyastk[this.stackPos-
1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn106=function(a){this.yyval=this.Node_Stmt_ElseIf(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn107=function(){this.yyval=null};a.Parser.prototype.yyn108=function(a){this.yyval=this.Node_Stmt_Else(Array.isArray(this.yyastk[this.stackPos-0])?this.yyastk[this.stackPos-0]:[this.yyastk[this.stackPos-0]],a)};a.Parser.prototype.yyn109=function(){this.yyval=null};a.Parser.prototype.yyn110=
function(a){this.yyval=this.Node_Stmt_Else(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn111=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn112=function(){this.yyval=[]};a.Parser.prototype.yyn113=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn114=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn115=function(a){this.yyval=this.Node_Param(this.yyastk[this.stackPos-
0].substring(1),null,this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn116=function(a){this.yyval=this.Node_Param(this.yyastk[this.stackPos-2].substring(1),this.yyastk[this.stackPos-0],this.yyastk[this.stackPos-4],this.yyastk[this.stackPos-3],a)};a.Parser.prototype.yyn117=function(){this.yyval=null};a.Parser.prototype.yyn118=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn119=function(){this.yyval="array"};a.Parser.prototype.yyn120=function(){this.yyval=
"callable"};a.Parser.prototype.yyn121=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn122=function(){this.yyval=[]};a.Parser.prototype.yyn123=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn124=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn125=function(a){this.yyval=this.Node_Arg(this.yyastk[this.stackPos-0],!1,a)};a.Parser.prototype.yyn126=function(a){this.yyval=
this.Node_Arg(this.yyastk[this.stackPos-0],!0,a)};a.Parser.prototype.yyn127=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn128=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn129=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-0].substring(1),a)};a.Parser.prototype.yyn130=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn131=
function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn132=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn133=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn134=function(a){this.yyval=this.Node_Stmt_StaticVar(this.yyastk[this.stackPos-0].substring(1),null,a)};a.Parser.prototype.yyn135=function(a){this.yyval=this.Node_Stmt_StaticVar(this.yyastk[this.stackPos-
2].substring(1),this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn136=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn137=function(){this.yyval=[]};a.Parser.prototype.yyn138=function(a){this.yyval=this.Node_Stmt_Property(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn139=function(a){this.yyval=this.Node_Stmt_ClassConst(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn140=
function(a){this.yyval=this.Node_Stmt_ClassMethod(this.yyastk[this.stackPos-4],{type:this.yyastk[this.stackPos-7],byRef:this.yyastk[this.stackPos-5],params:this.yyastk[this.stackPos-2],stmts:this.yyastk[this.stackPos-0]},a)};a.Parser.prototype.yyn141=function(a){this.yyval=this.Node_Stmt_TraitUse(this.yyastk[this.stackPos-1],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn142=function(){this.yyval=[]};a.Parser.prototype.yyn143=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn144=
function(){this.yyval=[]};a.Parser.prototype.yyn145=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn146=function(a){this.yyval=this.Node_Stmt_TraitUseAdaptation_Precedence(this.yyastk[this.stackPos-3][0],this.yyastk[this.stackPos-3][1],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn147=function(a){this.yyval=this.Node_Stmt_TraitUseAdaptation_Alias(this.yyastk[this.stackPos-4][0],this.yyastk[this.stackPos-
4][1],this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn148=function(a){this.yyval=this.Node_Stmt_TraitUseAdaptation_Alias(this.yyastk[this.stackPos-3][0],this.yyastk[this.stackPos-3][1],this.yyastk[this.stackPos-1],null,a)};a.Parser.prototype.yyn149=function(a){this.yyval=this.Node_Stmt_TraitUseAdaptation_Alias(this.yyastk[this.stackPos-3][0],this.yyastk[this.stackPos-3][1],null,this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn150=function(){this.yyval=array(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0])};a.Parser.prototype.yyn151=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn152=function(){this.yyval=array(null,this.yyastk[this.stackPos-0])};a.Parser.prototype.yyn153=function(){this.yyval=null};a.Parser.prototype.yyn154=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn155=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn156=function(){this.yyval=this.MODIFIER_PUBLIC};a.Parser.prototype.yyn157=
function(){this.yyval=this.MODIFIER_PUBLIC};a.Parser.prototype.yyn158=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn159=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn160=function(){this.Stmt_Class_verifyModifier(this.yyastk[this.stackPos-1],this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]|this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn161=function(){this.yyval=this.MODIFIER_PUBLIC};a.Parser.prototype.yyn162=function(){this.yyval=
this.MODIFIER_PROTECTED};a.Parser.prototype.yyn163=function(){this.yyval=this.MODIFIER_PRIVATE};a.Parser.prototype.yyn164=function(){this.yyval=this.MODIFIER_STATIC};a.Parser.prototype.yyn165=function(){this.yyval=this.MODIFIER_ABSTRACT};a.Parser.prototype.yyn166=function(){this.yyval=this.MODIFIER_FINAL};a.Parser.prototype.yyn167=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn168=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-
2]};a.Parser.prototype.yyn169=function(a){this.yyval=this.Node_Stmt_PropertyProperty(this.yyastk[this.stackPos-0].substring(1),null,a)};a.Parser.prototype.yyn170=function(a){this.yyval=this.Node_Stmt_PropertyProperty(this.yyastk[this.stackPos-2].substring(1),this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn171=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn172=function(){this.yyval=[this.yyastk[this.stackPos-
0]]};a.Parser.prototype.yyn173=function(){this.yyval=[]};a.Parser.prototype.yyn174=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn175=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn176=function(a){this.yyval=this.Node_Expr_AssignList(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn177=function(a){this.yyval=this.Node_Expr_Assign(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn178=
function(a){this.yyval=this.Node_Expr_AssignRef(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn179=function(a){this.yyval=this.Node_Expr_AssignRef(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn180=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn181=function(a){this.yyval=this.Node_Expr_Clone(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn182=function(a){this.yyval=this.Node_Expr_AssignPlus(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn183=function(a){this.yyval=this.Node_Expr_AssignMinus(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn184=function(a){this.yyval=this.Node_Expr_AssignMul(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn185=function(a){this.yyval=this.Node_Expr_AssignDiv(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn186=function(a){this.yyval=this.Node_Expr_AssignConcat(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn187=function(a){this.yyval=this.Node_Expr_AssignMod(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn188=function(a){this.yyval=this.Node_Expr_AssignBitwiseAnd(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn189=function(a){this.yyval=this.Node_Expr_AssignBitwiseOr(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn190=function(a){this.yyval=
this.Node_Expr_AssignBitwiseXor(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn191=function(a){this.yyval=this.Node_Expr_AssignShiftLeft(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn192=function(a){this.yyval=this.Node_Expr_AssignShiftRight(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn193=function(a){this.yyval=this.Node_Expr_PostInc(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn194=
function(a){this.yyval=this.Node_Expr_PreInc(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn195=function(a){this.yyval=this.Node_Expr_PostDec(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn196=function(a){this.yyval=this.Node_Expr_PreDec(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn197=function(a){this.yyval=this.Node_Expr_BooleanOr(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn198=function(a){this.yyval=this.Node_Expr_BooleanAnd(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn199=function(a){this.yyval=this.Node_Expr_LogicalOr(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn200=function(a){this.yyval=this.Node_Expr_LogicalAnd(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn201=function(a){this.yyval=this.Node_Expr_LogicalXor(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn202=function(a){this.yyval=this.Node_Expr_BitwiseOr(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn203=function(a){this.yyval=this.Node_Expr_BitwiseAnd(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn204=function(a){this.yyval=this.Node_Expr_BitwiseXor(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn205=function(a){this.yyval=this.Node_Expr_Concat(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn206=function(a){this.yyval=this.Node_Expr_Plus(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn207=function(a){this.yyval=this.Node_Expr_Minus(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn208=function(a){this.yyval=this.Node_Expr_Mul(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn209=function(a){this.yyval=this.Node_Expr_Div(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn210=function(a){this.yyval=this.Node_Expr_Mod(this.yyastk[this.stackPos-
2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn211=function(a){this.yyval=this.Node_Expr_ShiftLeft(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn212=function(a){this.yyval=this.Node_Expr_ShiftRight(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn213=function(a){this.yyval=this.Node_Expr_UnaryPlus(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn214=function(a){this.yyval=this.Node_Expr_UnaryMinus(this.yyastk[this.stackPos-
0],a)};a.Parser.prototype.yyn215=function(a){this.yyval=this.Node_Expr_BooleanNot(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn216=function(a){this.yyval=this.Node_Expr_BitwiseNot(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn217=function(a){this.yyval=this.Node_Expr_Identical(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn218=function(a){this.yyval=this.Node_Expr_NotIdentical(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn219=
function(a){this.yyval=this.Node_Expr_Equal(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn220=function(a){this.yyval=this.Node_Expr_NotEqual(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn221=function(a){this.yyval=this.Node_Expr_Smaller(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn222=function(a){this.yyval=this.Node_Expr_SmallerOrEqual(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-
0],a)};a.Parser.prototype.yyn223=function(a){this.yyval=this.Node_Expr_Greater(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn224=function(a){this.yyval=this.Node_Expr_GreaterOrEqual(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn225=function(a){this.yyval=this.Node_Expr_Instanceof(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn226=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn227=
function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn228=function(a){this.yyval=this.Node_Expr_Ternary(this.yyastk[this.stackPos-4],this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn229=function(a){this.yyval=this.Node_Expr_Ternary(this.yyastk[this.stackPos-3],null,this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn230=function(a){this.yyval=this.Node_Expr_Isset(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn231=function(a){this.yyval=
this.Node_Expr_Empty(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn232=function(a){this.yyval=this.Node_Expr_Include(this.yyastk[this.stackPos-0],"Node_Expr_Include",a)};a.Parser.prototype.yyn233=function(a){this.yyval=this.Node_Expr_Include(this.yyastk[this.stackPos-0],"Node_Expr_IncludeOnce",a)};a.Parser.prototype.yyn234=function(a){this.yyval=this.Node_Expr_Eval(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn235=function(a){this.yyval=this.Node_Expr_Include(this.yyastk[this.stackPos-
0],"Node_Expr_Require",a)};a.Parser.prototype.yyn236=function(a){this.yyval=this.Node_Expr_Include(this.yyastk[this.stackPos-0],"Node_Expr_RequireOnce",a)};a.Parser.prototype.yyn237=function(a){this.yyval=this.Node_Expr_Cast_Int(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn238=function(a){this.yyval=this.Node_Expr_Cast_Double(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn239=function(a){this.yyval=this.Node_Expr_Cast_String(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn240=
function(a){this.yyval=this.Node_Expr_Cast_Array(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn241=function(a){this.yyval=this.Node_Expr_Cast_Object(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn242=function(a){this.yyval=this.Node_Expr_Cast_Bool(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn243=function(a){this.yyval=this.Node_Expr_Cast_Unset(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn244=function(a){this.yyval=this.Node_Expr_Exit(this.yyastk[this.stackPos-
0],a)};a.Parser.prototype.yyn245=function(a){this.yyval=this.Node_Expr_ErrorSuppress(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn246=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn247=function(a){this.yyval=this.Node_Expr_Array(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn248=function(a){this.yyval=this.Node_Expr_Array(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn249=function(a){this.yyval=this.Node_Expr_ShellExec(this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn250=function(a){this.yyval=this.Node_Expr_Print(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn251=function(a){this.yyval=this.Node_Expr_Closure({"static":!1,byRef:this.yyastk[this.stackPos-7],params:this.yyastk[this.stackPos-5],uses:this.yyastk[this.stackPos-3],stmts:this.yyastk[this.stackPos-1]},a)};a.Parser.prototype.yyn252=function(a){this.yyval=this.Node_Expr_Closure({"static":!0,byRef:this.yyastk[this.stackPos-7],params:this.yyastk[this.stackPos-5],uses:this.yyastk[this.stackPos-
3],stmts:this.yyastk[this.stackPos-1]},a)};a.Parser.prototype.yyn253=function(a){this.yyval=this.Node_Expr_New(this.yyastk[this.stackPos-1],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn254=function(){this.yyval=[]};a.Parser.prototype.yyn255=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn256=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn257=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-
2]};a.Parser.prototype.yyn258=function(a){this.yyval=this.Node_Expr_ClosureUse(this.yyastk[this.stackPos-0].substring(1),this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn259=function(a){this.yyval=this.Node_Expr_FuncCall(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn260=function(a){this.yyval=this.Node_Expr_StaticCall(this.yyastk[this.stackPos-5],this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn261=function(a){this.yyval=
this.Node_Expr_StaticCall(this.yyastk[this.stackPos-7],this.yyastk[this.stackPos-4],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn262=function(a){if("Node_Expr_StaticPropertyFetch"===this.yyastk[this.stackPos-3].type)this.yyval=this.Node_Expr_StaticCall(this.yyastk[this.stackPos-3].Class,this.Node_Expr_Variable(this.yyastk[this.stackPos-3].name,a),this.yyastk[this.stackPos-1],a);else if("Node_Expr_ArrayDimFetch"===this.yyastk[this.stackPos-3].type){for(var b=this.yyastk[this.stackPos-3];"Node_Expr_ArrayDimFetch"===
b.variable.type;)b=b.variable;this.yyval=this.Node_Expr_StaticCall(b.variable.Class,this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a);b.variable=this.Node_Expr_Variable(b.variable.name,a)}else throw new Exception;};a.Parser.prototype.yyn263=function(a){this.yyval=this.Node_Expr_FuncCall(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn264=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};
a.Parser.prototype.yyn265=function(a){this.yyval=this.Node_Name("static",a)};a.Parser.prototype.yyn266=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn267=function(a){this.yyval=this.Node_Name(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn268=function(a){this.yyval=this.Node_Name_FullyQualified(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn269=function(a){this.yyval=this.Node_Name_Relative(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn270=function(){this.yyval=
this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn271=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn272=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn273=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn274=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn275=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn276=function(){this.yyval=this.yyastk[this.stackPos]};a.Parser.prototype.yyn277=
function(a){this.yyval=this.Node_Expr_PropertyFetch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn278=function(a){this.yyval=this.Node_Expr_PropertyFetch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn279=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn280=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],
this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn281=function(){this.yyval=null};a.Parser.prototype.yyn282=function(){this.yyval=null};a.Parser.prototype.yyn283=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn284=function(){this.yyval=[]};a.Parser.prototype.yyn285=function(){this.yyval=[this.Scalar_String_parseEscapeSequences(this.yyastk[this.stackPos-0],"`")]};a.Parser.prototype.yyn286=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn287=function(){this.yyval=
[]};a.Parser.prototype.yyn288=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn289=function(a){this.yyval=this.Node_Scalar_LNumber(this.Scalar_LNumber_parse(this.yyastk[this.stackPos-0]),a)};a.Parser.prototype.yyn290=function(a){this.yyval=this.Node_Scalar_DNumber(this.Scalar_DNumber_parse(this.yyastk[this.stackPos-0]),a)};a.Parser.prototype.yyn291=function(a){this.yyval=this.Scalar_String_create(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn292=function(a){this.yyval=
{type:"Node_Scalar_LineConst",attributes:a}};a.Parser.prototype.yyn293=function(a){this.yyval={type:"Node_Scalar_FileConst",attributes:a}};a.Parser.prototype.yyn294=function(a){this.yyval={type:"Node_Scalar_DirConst",attributes:a}};a.Parser.prototype.yyn295=function(a){this.yyval={type:"Node_Scalar_ClassConst",attributes:a}};a.Parser.prototype.yyn296=function(a){this.yyval={type:"Node_Scalar_TraitConst",attributes:a}};a.Parser.prototype.yyn297=function(a){this.yyval={type:"Node_Scalar_MethodConst",
attributes:a}};a.Parser.prototype.yyn298=function(a){this.yyval={type:"Node_Scalar_FuncConst",attributes:a}};a.Parser.prototype.yyn299=function(a){this.yyval={type:"Node_Scalar_NSConst",attributes:a}};a.Parser.prototype.yyn300=function(a){this.yyval=this.Node_Scalar_String(this.Scalar_String_parseDocString(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-1]),a)};a.Parser.prototype.yyn301=function(a){this.yyval=this.Node_Scalar_String("",a)};a.Parser.prototype.yyn302=function(a){this.yyval=this.Node_Expr_ConstFetch(this.yyastk[this.stackPos-
0],a)};a.Parser.prototype.yyn303=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn304=function(a){this.yyval=this.Node_Expr_ClassConstFetch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn305=function(a){this.yyval=this.Node_Expr_UnaryPlus(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn306=function(a){this.yyval=this.Node_Expr_UnaryMinus(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn307=function(a){this.yyval=this.Node_Expr_Array(this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn308=function(a){this.yyval=this.Node_Expr_Array(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn309=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn310=function(a){this.yyval=this.Node_Expr_ClassConstFetch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn311=function(a){this.yyval=this.Node_Scalar_Encapsed(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn312=function(a){this.yyval=this.Node_Scalar_Encapsed(this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn313=function(){this.yyval=[]};a.Parser.prototype.yyn314=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn315=function(){this.yyval=this.yyastk[this.stackPos]};a.Parser.prototype.yyn316=function(){this.yyval=this.yyastk[this.stackPos]};a.Parser.prototype.yyn317=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn318=function(){this.yyval=[this.yyastk[this.stackPos-
0]]};a.Parser.prototype.yyn319=function(a){this.yyval=this.Node_Expr_ArrayItem(this.yyastk[this.stackPos-0],this.yyastk[this.stackPos-2],!1,a)};a.Parser.prototype.yyn320=function(a){this.yyval=this.Node_Expr_ArrayItem(this.yyastk[this.stackPos-0],null,!1,a)};a.Parser.prototype.yyn321=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn322=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn323=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn324=
function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn325=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-4],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn326=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn327=function(a){this.yyval=this.Node_Expr_PropertyFetch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn328=function(a){this.yyval=
this.Node_Expr_MethodCall(this.yyastk[this.stackPos-5],this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn329=function(a){this.yyval=this.Node_Expr_FuncCall(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn330=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn331=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn332=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn333=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn334=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn335=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn336=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn337=function(){this.yyval=this.yyastk[this.stackPos-0]};
a.Parser.prototype.yyn338=function(a){this.yyval=this.Node_Expr_StaticPropertyFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn339=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn340=function(a){this.yyval=this.Node_Expr_StaticPropertyFetch(this.yyastk[this.stackPos-2],this.yyastk[this.stackPos-0].substring(1),a)};a.Parser.prototype.yyn341=function(a){this.yyval=this.Node_Expr_StaticPropertyFetch(this.yyastk[this.stackPos-5],this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn342=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn343=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn344=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn345=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.yyastk[this.stackPos-
3],this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn346=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-0].substring(1),a)};a.Parser.prototype.yyn347=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn348=function(){this.yyval=null};a.Parser.prototype.yyn349=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn350=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn351=function(){this.yyval=
this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn352=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn353=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn354=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn355=function(){this.yyval=this.yyastk[this.stackPos-0]};a.Parser.prototype.yyn356=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn357=
function(){this.yyval=null};a.Parser.prototype.yyn358=function(){this.yyval=[]};a.Parser.prototype.yyn359=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn360=function(){this.yyastk[this.stackPos-2].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-2]};a.Parser.prototype.yyn361=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn362=function(a){this.yyval=this.Node_Expr_ArrayItem(this.yyastk[this.stackPos-0],this.yyastk[this.stackPos-
2],!1,a)};a.Parser.prototype.yyn363=function(a){this.yyval=this.Node_Expr_ArrayItem(this.yyastk[this.stackPos-0],null,!1,a)};a.Parser.prototype.yyn364=function(a){this.yyval=this.Node_Expr_ArrayItem(this.yyastk[this.stackPos-0],this.yyastk[this.stackPos-3],!0,a)};a.Parser.prototype.yyn365=function(a){this.yyval=this.Node_Expr_ArrayItem(this.yyastk[this.stackPos-0],null,!0,a)};a.Parser.prototype.yyn366=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-
1]};a.Parser.prototype.yyn367=function(){this.yyastk[this.stackPos-1].push(this.yyastk[this.stackPos-0]);this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn368=function(){this.yyval=[this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn369=function(){this.yyval=[this.yyastk[this.stackPos-1],this.yyastk[this.stackPos-0]]};a.Parser.prototype.yyn370=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-0].substring(1),a)};a.Parser.prototype.yyn371=function(a){this.yyval=
this.Node_Expr_ArrayDimFetch(this.Node_Expr_Variable(this.yyastk[this.stackPos-3].substring(1),a),this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn372=function(a){this.yyval=this.Node_Expr_PropertyFetch(this.Node_Expr_Variable(this.yyastk[this.stackPos-2].substring(1),a),this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn373=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-1],a)};a.Parser.prototype.yyn374=function(a){this.yyval=this.Node_Expr_Variable(this.yyastk[this.stackPos-
1],a)};a.Parser.prototype.yyn375=function(a){this.yyval=this.Node_Expr_ArrayDimFetch(this.Node_Expr_Variable(this.yyastk[this.stackPos-4],a),this.yyastk[this.stackPos-2],a)};a.Parser.prototype.yyn376=function(){this.yyval=this.yyastk[this.stackPos-1]};a.Parser.prototype.yyn377=function(a){this.yyval=this.Node_Scalar_String(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn378=function(a){this.yyval=this.Node_Scalar_String(this.yyastk[this.stackPos-0],a)};a.Parser.prototype.yyn379=function(a){this.yyval=
this.Node_Expr_Variable(this.yyastk[this.stackPos-0].substring(1),a)};a.Parser.prototype.Stmt_Namespace_postprocess=function(a){return a};a.Parser.prototype.Node_Stmt_Echo=function(a,b){return{type:"Node_Stmt_Echo",exprs:a,attributes:b}};a.Parser.prototype.Node_Stmt_If=function(a,b,c){return{type:"Node_Stmt_If",cond:a,stmts:b.stmts,elseifs:b.elseifs,Else:b.Else||null,attributes:c}};a.Parser.prototype.Node_Stmt_For=function(a,b){return{type:"Node_Stmt_For",init:a.init,cond:a.cond,loop:a.loop,stmts:a.stmts,
attributes:b}};a.Parser.prototype.Node_Stmt_Function=function(a,b,c){return{type:"Node_Stmt_Function",name:a,byRef:b.byRef,params:b.params,stmts:b.stmts,attributes:c}};a.Parser.prototype.Stmt_Class_verifyModifier=function(){};a.Parser.prototype.Node_Stmt_Namespace=function(a,b,c){return{type:"Node_Stmt_Namespace",name:a,attributes:c}};a.Parser.prototype.Node_Stmt_Use=function(a,b,c){return{type:"Node_Stmt_Use",name:a,attributes:c}};a.Parser.prototype.Node_Stmt_UseUse=function(a,b,c){return{type:"Node_Stmt_UseUse",
name:a,as:b,attributes:c}};a.Parser.prototype.Node_Stmt_TraitUseAdaptation_Precedence=function(a,b,c){return{type:"Node_Stmt_TraitUseAdaptation_Precedence",name:a,attributes:c}};a.Parser.prototype.Node_Stmt_TraitUseAdaptation_Alias=function(a,b,c){return{type:"Node_Stmt_TraitUseAdaptation_Alias",name:a,attributes:c}};a.Parser.prototype.Node_Stmt_Trait=function(a,b,c){return{type:"Node_Stmt_Trait",name:a,attributes:c}};a.Parser.prototype.Node_Stmt_TraitUse=function(a,b,c){return{type:"Node_Stmt_TraitUse",
name:a,attributes:c}};a.Parser.prototype.Node_Stmt_Class=function(a,b,c){return{type:"Node_Stmt_Class",name:a,Type:b.type,Extends:b.Extends,Implements:b.Implements,stmts:b.stmts,attributes:c}};a.Parser.prototype.Node_Stmt_ClassMethod=function(a,b,c){return{type:"Node_Stmt_ClassMethod",name:a,Type:b.type,byRef:b.byRef,params:b.params,stmts:b.stmts,attributes:c}};a.Parser.prototype.Node_Stmt_ClassConst=function(a,b){return{type:"Node_Stmt_ClassConst",consts:a,attributes:b}};a.Parser.prototype.Node_Stmt_Interface=
function(a,b,c){return{type:"Node_Stmt_Interface",name:a,Extends:b.Extends,stmts:b.stmts,attributes:c}};a.Parser.prototype.Node_Stmt_Throw=function(a,b){return{type:"Node_Stmt_Throw",expr:a,attributes:b}};a.Parser.prototype.Node_Stmt_Catch=function(a,b,c,f){return{type:"Node_Stmt_Catch",Type:a,variable:b,stmts:c,attributes:f}};a.Parser.prototype.Node_Stmt_TryCatch=function(a,b,c){return{type:"Node_Stmt_TryCatch",stmts:a,catches:b,attributes:c}};a.Parser.prototype.Node_Stmt_Foreach=function(a,b,c,
f){return{type:"Node_Stmt_Foreach",expr:a,valueVar:b,keyVar:c.keyVar,byRef:c.byRef,stmts:c.stmts,attributes:f}};a.Parser.prototype.Node_Stmt_While=function(a,b,c){return{type:"Node_Stmt_While",cond:a,stmts:b,attributes:c}};a.Parser.prototype.Node_Stmt_Do=function(a,b,c){return{type:"Node_Stmt_Do",cond:a,stmts:b,attributes:c}};a.Parser.prototype.Node_Stmt_Break=function(a,b){return{type:"Node_Stmt_Break",num:a,attributes:b}};a.Parser.prototype.Node_Stmt_Continue=function(a,b){return{type:"Node_Stmt_Continue",
num:a,attributes:b}};a.Parser.prototype.Node_Stmt_Return=function(a,b){return{type:"Node_Stmt_Return",expr:a,attributes:b}};a.Parser.prototype.Node_Stmt_Case=function(a,b,c){return{type:"Node_Stmt_Case",cond:a,stmts:b,attributes:c}};a.Parser.prototype.Node_Stmt_Switch=function(a,b,c){return{type:"Node_Stmt_Switch",cond:a,cases:b,attributes:c}};a.Parser.prototype.Node_Stmt_Else=function(a,b){return{type:"Node_Stmt_Else",stmts:a,attributes:b}};a.Parser.prototype.Node_Stmt_ElseIf=function(a,b){return{type:"Node_Stmt_ElseIf",
cond:a,stmts:b,attributes:b}};a.Parser.prototype.Node_Stmt_InlineHTML=function(a,b){return{type:"Node_Stmt_InlineHTML",value:a,attributes:b}};a.Parser.prototype.Node_Stmt_StaticVar=function(a,b,c){return{type:"Node_Stmt_StaticVar",name:a,def:b,attributes:c}};a.Parser.prototype.Node_Stmt_Static=function(a,b){return{type:"Node_Stmt_Static",vars:a,attributes:b}};a.Parser.prototype.Node_Stmt_Global=function(a,b){return{type:"Node_Stmt_Global",vars:a,attributes:b}};a.Parser.prototype.Node_Stmt_PropertyProperty=
function(a,b,c){return{type:"Node_Stmt_PropertyProperty",name:a,def:b,attributes:c}};a.Parser.prototype.Node_Stmt_Property=function(a,b,c){return{type:"Node_Stmt_Property",Type:a,props:b,attributes:c}};a.Parser.prototype.Node_Stmt_Unset=function(a,b){return{type:"Node_Stmt_Unset",variables:a,attributes:b}};a.Parser.prototype.Node_Expr_Variable=function(a,b){return{type:"Node_Expr_Variable",name:a,attributes:b}};a.Parser.prototype.Node_Expr_FuncCall=function(a,b,c){return{type:"Node_Expr_FuncCall",
func:a,args:b,attributes:c}};a.Parser.prototype.Node_Expr_MethodCall=function(a,b,c,f){return{type:"Node_Expr_MethodCall",variable:a,name:b,args:c,attributes:f}};a.Parser.prototype.Node_Expr_StaticCall=function(a,b,c,f){return{type:"Node_Expr_StaticCall",Class:a,func:b,args:c,attributes:f}};a.Parser.prototype.Node_Expr_Ternary=function(a,b,c,f){return{type:"Node_Expr_Ternary",cond:a,If:b,Else:c,attributes:f}};a.Parser.prototype.Node_Expr_AssignList=function(a,b,c){return{type:"Node_Expr_AssignList",
assignList:a,expr:b,attributes:c}};a.Parser.prototype.Node_Expr_Assign=function(a,b,c){return{type:"Node_Expr_Assign",variable:a,expr:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignConcat=function(a,b,c){return{type:"Node_Expr_AssignConcat",variable:a,expr:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignMinus=function(a,b,c){return{type:"Node_Expr_AssignMinus",variable:a,expr:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignPlus=function(a,b,c){return{type:"Node_Expr_AssignPlus",variable:a,
expr:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignDiv=function(a,b,c){return{type:"Node_Expr_AssignDiv",variable:a,expr:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignRef=function(a,b,c){return{type:"Node_Expr_AssignRef",variable:a,refVar:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignMul=function(a,b,c){return{type:"Node_Expr_AssignMul",variable:a,expr:b,attributes:c}};a.Parser.prototype.Node_Expr_AssignMod=function(a,b,c){return{type:"Node_Expr_AssignMod",variable:a,expr:b,attributes:c}};
a.Parser.prototype.Node_Expr_Plus=function(a,b,c){return{type:"Node_Expr_Plus",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Minus=function(a,b,c){return{type:"Node_Expr_Minus",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Mul=function(a,b,c){return{type:"Node_Expr_Mul",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Div=function(a,b,c){return{type:"Node_Expr_Div",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Mod=function(a,b,c){return{type:"Node_Expr_Mod",
left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Greater=function(a,b,c){return{type:"Node_Expr_Greater",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Equal=function(a,b,c){return{type:"Node_Expr_Equal",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_NotEqual=function(a,b,c){return{type:"Node_Expr_NotEqual",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Identical=function(a,b,c){return{type:"Node_Expr_Identical",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_NotIdentical=
function(a,b,c){return{type:"Node_Expr_NotIdentical",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_GreaterOrEqual=function(a,b,c){return{type:"Node_Expr_GreaterOrEqual",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_SmallerOrEqual=function(a,b,c){return{type:"Node_Expr_SmallerOrEqual",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Concat=function(a,b,c){return{type:"Node_Expr_Concat",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Smaller=function(a,
b,c){return{type:"Node_Expr_Smaller",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_PostInc=function(a,b){return{type:"Node_Expr_PostInc",variable:a,attributes:b}};a.Parser.prototype.Node_Expr_PostDec=function(a,b){return{type:"Node_Expr_PostDec",variable:a,attributes:b}};a.Parser.prototype.Node_Expr_PreInc=function(a,b){return{type:"Node_Expr_PreInc",variable:a,attributes:b}};a.Parser.prototype.Node_Expr_PreDec=function(a,b){return{type:"Node_Expr_PreDec",variable:a,attributes:b}};a.Parser.prototype.Node_Expr_Include=
function(a,b,c){return{expr:a,type:b,attributes:c}};a.Parser.prototype.Node_Expr_ArrayDimFetch=function(a,b,c){return{type:"Node_Expr_ArrayDimFetch",variable:a,dim:b,attributes:c}};a.Parser.prototype.Node_Expr_StaticPropertyFetch=function(a,b,c){return{type:"Node_Expr_StaticPropertyFetch",Class:a,name:b,attributes:c}};a.Parser.prototype.Node_Expr_ClassConstFetch=function(a,b,c){return{type:"Node_Expr_ClassConstFetch",Class:a,name:b,attributes:c}};a.Parser.prototype.Node_Expr_StaticPropertyFetch=function(a,
b,c){return{type:"Node_Expr_StaticPropertyFetch",Class:a,name:b,attributes:c}};a.Parser.prototype.Node_Expr_ConstFetch=function(a,b){return{type:"Node_Expr_ConstFetch",name:a,attributes:b}};a.Parser.prototype.Node_Expr_ArrayItem=function(a,b,c,f){return{type:"Node_Expr_ArrayItem",value:a,key:b,byRef:c,attributes:f}};a.Parser.prototype.Node_Expr_Array=function(a,b){return{type:"Node_Expr_Array",items:a,attributes:b}};a.Parser.prototype.Node_Expr_PropertyFetch=function(a,b,c){return{type:"Node_Expr_PropertyFetch",
variable:a,name:b,attributes:c}};a.Parser.prototype.Node_Expr_New=function(a,b,c){return{type:"Node_Expr_New",Class:a,args:b,attributes:c}};a.Parser.prototype.Node_Expr_Print=function(a,b){return{type:"Node_Expr_Print",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Exit=function(a,b){return{type:"Node_Expr_Exit",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Cast_Bool=function(a,b){return{type:"Node_Expr_Cast_Bool",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Cast_Int=function(a,b){return{type:"Node_Expr_Cast_Int",
expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Cast_String=function(a,b){return{type:"Node_Expr_Cast_String",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Cast_Double=function(a,b){return{type:"Node_Expr_Cast_Double",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Cast_Array=function(a,b){return{type:"Node_Expr_Cast_Array",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Cast_Object=function(a,b){return{type:"Node_Expr_Cast_Object",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_ErrorSuppress=
function(a,b){return{type:"Node_Expr_ErrorSuppress",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Isset=function(a,b){return{type:"Node_Expr_Isset",variables:a,attributes:b}};a.Parser.prototype.Node_Expr_UnaryMinus=function(a,b){return{type:"Node_Expr_UnaryMinus",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_UnaryPlus=function(a,b){return{type:"Node_Expr_UnaryPlus",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_Empty=function(a,b){return{type:"Node_Expr_Empty",variable:a,attributes:b}};
a.Parser.prototype.Node_Expr_BooleanOr=function(a,b,c){return{type:"Node_Expr_BooleanOr",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_LogicalOr=function(a,b,c){return{type:"Node_Expr_LogicalOr",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_LogicalAnd=function(a,b,c){return{type:"Node_Expr_LogicalAnd",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_LogicalXor=function(a,b,c){return{type:"Node_Expr_LogicalXor",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_BitwiseAnd=
function(a,b,c){return{type:"Node_Expr_BitwiseAnd",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_BitwiseOr=function(a,b,c){return{type:"Node_Expr_BitwiseOr",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_BitwiseXor=function(a,b,c){return{type:"Node_Expr_BitwiseXor",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_BitwiseNot=function(a,b){return{type:"Node_Expr_BitwiseNot",expr:a,attributes:b}};a.Parser.prototype.Node_Expr_BooleanNot=function(a,b){return{type:"Node_Expr_BooleanNot",
expr:a,attributes:b}};a.Parser.prototype.Node_Expr_BooleanAnd=function(a,b,c){return{type:"Node_Expr_BooleanAnd",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Instanceof=function(a,b,c){return{type:"Node_Expr_Instanceof",left:a,right:b,attributes:c}};a.Parser.prototype.Node_Expr_Clone=function(a,b){return{type:"Node_Expr_Clone",expr:a,attributes:b}};a.Parser.prototype.Scalar_LNumber_parse=function(a){return a};a.Parser.prototype.Scalar_DNumber_parse=function(a){return a};a.Parser.prototype.Scalar_String_parseDocString=
function(a,b){return'"'+b.replace(/([^"\\]*(?:\\.[^"\\]*)*)"/g,'$1\\"')+'"'};a.Parser.prototype.Node_Scalar_String=function(a,b){return{type:"Node_Scalar_String",value:a,attributes:b}};a.Parser.prototype.Scalar_String_create=function(a,b){return{type:"Node_Scalar_String",value:a,attributes:b}};a.Parser.prototype.Node_Scalar_LNumber=function(a,b){return{type:"Node_Scalar_LNumber",value:a,attributes:b}};a.Parser.prototype.Node_Scalar_DNumber=function(a,b){return{type:"Node_Scalar_DNumber",value:a,attributes:b}};
a.Parser.prototype.Node_Scalar_Encapsed=function(a,b){return{type:"Node_Scalar_Encapsed",parts:a,attributes:b}};a.Parser.prototype.Node_Name=function(a,b){return{type:"Node_Name",parts:a,attributes:b}};a.Parser.prototype.Node_Name_FullyQualified=function(a,b){return{type:"Node_Name_FullyQualified",parts:a,attributes:b}};a.Parser.prototype.Node_Name_Relative=function(a,b){return{type:"Node_Name_Relative",parts:a,attributes:b}};a.Parser.prototype.Node_Param=function(a,b,c,f,n){return{type:"Node_Param",
name:a,def:b,Type:c,byRef:f,attributes:n}};a.Parser.prototype.Node_Arg=function(a,b,c){return{type:"Node_Name",value:a,byRef:b,attributes:c}};a.Parser.prototype.Node_Const=function(a,b,c){return{type:"Node_Const",name:a,value:b,attributes:c}};r.PHP=a});