/**
 * (The MIT License)
 * Copyright (c) 2011 hij1nx http://www.twitter.com/hij1nx
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
 * THE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 * See https://github.com/hij1nx/EventEmitter2
 */

/**
	 * Create a new AnimationOptions object of the given type
	 * see http://greweb.me/2012/02/bezier-curve-based-easing-functions-from-concept-to-implementation/
	 * 
	 * MIT License
	 *
	 * KeySpline - use bezier curve for transition easing function
	 * Copyright (c) 2012 Gaetan Renaudeau <renaudeau.gaetan@gmail.com>
	 *
	 * Permission is hereby granted, free of charge, to any person obtaining a
	 * copy of this software and associated documentation files (the "Software"),
	 * to deal in the Software without restriction, including without limitation
	 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
	 * and/or sell copies of the Software, and to permit persons to whom the
	 * Software is furnished to do so, subject to the following conditions:
	 *
	 * The above copyright notice and this permission notice shall be included in
	 * all copies or substantial portions of the Software.
	 *
	 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
	 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL
	 * THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	 * DEALINGS IN THE SOFTWARE.
	 * 
	 * Notice: changed by Esko to become prototyped
	 */

!function(g){function e(){this._events={};this._conf&&d.call(this,this._conf)}function d(a){a&&(this._conf=a,a.delimiter&&(this.delimiter=a.delimiter),a.maxListeners&&(this._events.maxListeners=a.maxListeners),a.wildcard&&(this.wildcard=a.wildcard),a.newListener&&(this.newListener=a.newListener),this.wildcard&&(this.listenerTree={}))}function c(a){this._events={};this.newListener=!1;d.call(this,a)}function f(a,b,c,d){if(!c)return[];var e=[],g,j,n,m;n=b.length;m=b[d];var p=b[d+1];if(d===n&&c._listeners){if("function"===
typeof c._listeners)a&&a.push(c._listeners);else{b=0;for(d=c._listeners.length;b<d;b++)a&&a.push(c._listeners[b])}return[c]}if("*"===m||"**"===m||c[m]){if("*"===m){for(g in c)"_listeners"!==g&&c.hasOwnProperty(g)&&(e=e.concat(f(a,b,c[g],d+1)));return e}if("**"===m){(m=d+1===n||d+2===n&&"*"===p)&&c._listeners&&(e=e.concat(f(a,b,c,n)));for(g in c)"_listeners"!==g&&c.hasOwnProperty(g)&&("*"===g||"**"===g?(c[g]._listeners&&!m&&(e=e.concat(f(a,b,c[g],n))),e=e.concat(f(a,b,c[g],d))):e=g===p?e.concat(f(a,
b,c[g],d+2)):e.concat(f(a,b,c[g],d)));return e}e=e.concat(f(a,b,c[m],d+1))}(j=c["*"])&&f(a,b,j,d+1);if(c=c["**"])if(d<n)for(g in c._listeners&&f(a,b,c,n),c)"_listeners"!==g&&c.hasOwnProperty(g)&&(g===p?f(a,b,c[g],d+2):g===m?f(a,b,c[g],d+1):(n={},n[g]=c[g],f(a,b,{"**":n},d+1)));else c._listeners?f(a,b,c,n):c["*"]&&c["*"]._listeners&&f(a,b,c["*"],n);return e}var b=Array.isArray?Array.isArray:function(a){return"[object Array]"===Object.prototype.toString.call(a)};c.prototype.delimiter=".";c.prototype.setMaxListeners=
function(a){this._events||e.call(this);this._events.maxListeners=a;this._conf||(this._conf={});this._conf.maxListeners=a};c.prototype.event="";c.prototype.once=function(a,b){this.many(a,1,b);return this};c.prototype.many=function(a,b,c){function f(){0===--b&&d.off(a,f);c.apply(this,arguments)}var d=this;if("function"!==typeof c)throw Error("many only accepts instances of Function");f._origin=c;this.on(a,f);return d};c.prototype.emit=function(){this._events||e.call(this);var a=arguments[0];if("newListener"===
a&&!this.newListener&&!this._events.newListener)return!1;if(this._all){for(var b=arguments.length,c=Array(b-1),d=1;d<b;d++)c[d-1]=arguments[d];d=0;for(b=this._all.length;d<b;d++)this.event=a,this._all[d].apply(this,c)}if("error"===a&&!this._all&&!this._events.error&&(!this.wildcard||!this.listenerTree.error)){if(arguments[1]instanceof Error)throw arguments[1];throw Error("Uncaught, unspecified 'error' event.");}var g;this.wildcard?(g=[],b="string"===typeof a?a.split(this.delimiter):a.slice(),f.call(this,
g,b,this.listenerTree,0)):g=this._events[a];if("function"===typeof g){this.event=a;if(1===arguments.length)g.call(this);else if(1<arguments.length)switch(arguments.length){case 2:g.call(this,arguments[1]);break;case 3:g.call(this,arguments[1],arguments[2]);break;default:b=arguments.length;c=Array(b-1);for(d=1;d<b;d++)c[d-1]=arguments[d];g.apply(this,c)}return!0}if(g){b=arguments.length;c=Array(b-1);for(d=1;d<b;d++)c[d-1]=arguments[d];g=g.slice();d=0;for(b=g.length;d<b;d++)this.event=a,g[d].apply(this,
c);return 0<g.length||this._all}return this._all};c.prototype.on=function(a,c){if("function"===typeof a)return this.onAny(a),this;if("function"!==typeof c)throw Error("on only accepts instances of Function");this._events||e.call(this);this.emit("newListener",a,c);if(this.wildcard){a:{for(var f=a,f="string"===typeof f?f.split(this.delimiter):f.slice(),d=0,g=f.length;d+1<g;d++)if("**"===f[d]&&"**"===f[d+1])break a;d=this.listenerTree;for(g=f.shift();g;){d[g]||(d[g]={});d=d[g];if(0===f.length){d._listeners?
"function"===typeof d._listeners?d._listeners=[d._listeners,c]:b(d._listeners)&&(d._listeners.push(c),d._listeners.warned||(f=10,"undefined"!==typeof this._events.maxListeners&&(f=this._events.maxListeners),0<f&&d._listeners.length>f&&(d._listeners.warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",d._listeners.length),console.trace()))):d._listeners=c;break a}g=f.shift()}}return this}this._events[a]?
"function"===typeof this._events[a]?this._events[a]=[this._events[a],c]:b(this._events[a])&&(this._events[a].push(c),this._events[a].warned||(f=10,"undefined"!==typeof this._events.maxListeners&&(f=this._events.maxListeners),0<f&&this._events[a].length>f&&(this._events[a].warned=!0,console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.",this._events[a].length),console.trace()))):this._events[a]=c;return this};
c.prototype.onAny=function(a){this._all||(this._all=[]);if("function"!==typeof a)throw Error("onAny only accepts instances of Function");this._all.push(a);return this};c.prototype.addListener=c.prototype.on;c.prototype.off=function(a,c){if("function"!==typeof c)throw Error("removeListener only takes instances of Function");var d,k=[];if(this.wildcard)d="string"===typeof a?a.split(this.delimiter):a.slice(),k=f.call(this,null,d,this.listenerTree,0);else{if(!this._events[a])return this;d=this._events[a];
k.push({_listeners:d})}for(var e=0;e<k.length;e++){var g=k[e];d=g._listeners;if(b(d)){for(var j=-1,n=0,m=d.length;n<m;n++)if(d[n]===c||d[n].listener&&d[n].listener===c||d[n]._origin&&d[n]._origin===c){j=n;break}if(0>j)break;this.wildcard?g._listeners.splice(j,1):this._events[a].splice(j,1);0===d.length&&(this.wildcard?delete g._listeners:delete this._events[a])}else if(d===c||d.listener&&d.listener===c||d._origin&&d._origin===c)this.wildcard?delete g._listeners:delete this._events[a]}return this};
c.prototype.offAny=function(a){var b=0,c=0,f;if(a&&this._all&&0<this._all.length){f=this._all;b=0;for(c=f.length;b<c;b++)if(a===f[b]){f.splice(b,1);break}}else this._all=[];return this};c.prototype.removeListener=c.prototype.off;c.prototype.removeAllListeners=function(a){if(0===arguments.length)return!this._events||e.call(this),this;if(this.wildcard)for(var b="string"===typeof a?a.split(this.delimiter):a.slice(),b=f.call(this,null,b,this.listenerTree,0),c=0;c<b.length;c++)b[c]._listeners=null;else{if(!this._events[a])return this;
this._events[a]=null}return this};c.prototype.listeners=function(a){if(this.wildcard){var c=[],a="string"===typeof a?a.split(this.delimiter):a.slice();f.call(this,c,a,this.listenerTree,0);return c}this._events||e.call(this);this._events[a]||(this._events[a]=[]);b(this._events[a])||(this._events[a]=[this._events[a]]);return this._events[a]};c.prototype.listenersAny=function(){return this._all?this._all:[]};"function"===typeof define&&define.amd?define("lib/EventEmitter2",[],function(){return c}):g.EventEmitter2=
c}("undefined"!==typeof process&&"undefined"!==typeof process.title&&"undefined"!==typeof exports?exports:window);
define("web-viewer/core/CoreConstants",{TOOLS:{PAN:"pan",ZOOM:"zoom",TOUCH:"touch",NOTOUCH:"notouch",ANNOTATION:"annotationtool",ANNOTATION_TOUCH_DRAW:"annotationTouchDrawTool",ANNOTATION_TOUCH:"annotationTouchTool",ANNOTATION_DRAW:"annotationdrawtool",ANNOTATION_NOTE_DRAW:"annotationnotetool",ANNOTATION_INDICATOR:"annotationindicatortool",COMPARE_ANCHOR_ALIGNMENT:"compareAnchorTool",MEASURE_BARCODE:"measureBarcodeTool",MEASURE_BRAILLE:"measureBrailleTool",MEASURE_EYEDROPPER:"measureEyeDropperTool",
MEASURE_RULER:"measureRulerTool",MEASURE_CALIPER:"measureCaliperTool",MEASURE_SCREEN_RULING:"measureScreenRulingTool",INTERRUPT:"interruptTool",NAVIGATIONPAN:"navigationPanTool",MOUSE_LOCATOR:"mouseLocatorTool"},SizeUnits:{MM:0,CM:1,INCH:2,PIXELS:3,POINTS:4},EyeDropperUnits:{SQMM:0,SQCM:1,SQINCH:2,PIXELS:3,PERCENT:5},ResolutionUnits:{PPI:0,PPMM:1,PPCM:2},UnitsLocNames:["Unitmm","Unitcm","UnitInchShort","UnitPixelsShort","UnitPoint"],UnitsFixes:[2,3,3,0,1],ResUnitsLocNames:["UnitResInch","UnitResmm",
"UnitRescm"],ResUnitsFixes:[3,2,3],ScreenUnitsLocNames:["UnitScreenInch","UnitScreenmm","UnitScreencm"],ScreenUnitsFixes:[2,1,2],EyeDropperUnitsLocNames:"Unitmm2 Unitcm2 UnitInch2 UnitPixels  UnitPercent".split(" "),EyeDropperUnitsShortLocNames:"Unitmm2 Unitcm2 UnitInch2Short UnitPixelsShort  UnitPercent".split(" "),EyeDropperUnitsFixes:[2,3,3,0,0,2]});
define("web-viewer/layout/LayoutConstants",{LayoutItemType:{WIDGET:0,TOOLBARCOMPONENT:1},Widget:{CHANNELS:"channelsWidget",CAD:"cadWidget",APPROVAL:"approvalDetailsWidget",HELP:"help/helpWidget",ANNOTATION:"annotationWidget",COMPARE:"compareWidget",PAGELIST:"pagelist/pagelistWidget",DEBUG:"debugWidget",INFO:"infoWidget",VIEWPORT:"ViewportWidget",ALIGNWIZARD:"compareAlignmentWizardWidget",DOCUMENTINFO:"documentInfo/DocumentInfoWidget",MESSAGE:"message/MessageWidget",NAVIGATOR:"navigation/NavigatorWidget",
VIEWCONTROLS:"viewControlsWidget",ATTRIBUTE_CATEGORY:"attributeCategoryWidget",VIEW3D:"View3DWidget"},ToolbarComponent:{ANNOTATION:"annotationControls",APPROVAL:"approvalControls",COMPARE:"compareControls",MEASURE:"measureControls",NAVIGATE:"navigationControls",PAGELIST:"pagelistControls",DOCUMENTSELECTOR:"documentSelector",PAGESELECTION:"pageselectionControls",VIEW3D:"view3DControls"},LayoutMode:{BASIC:0,RESTRICTED:1,WIZARD:2,MOBILE_VIEW:3,MOBILE_READERSPREAD:4,MOBILE_ANNOTATION:5,MOBILE_COMPARE:6,
MOBILE_3D:7},LayoutType:{AUTOMATIC:"automatic",DESKTOP:"desktop",MOBILE:"mobile"},MobileLayoutModeBarOrder:[3,6,4,7,5],ViewerStyle:{ADVANCED:0,NORMAL:1,RESTRICTED:2}});
define("web-viewer/core/ViewerFacade",["web-viewer/core/CoreConstants","web-viewer/layout/LayoutConstants"],function(g,e){var d=function(c,f,b){this.emit=function(){f.emit.apply(f,arguments)};this.eDelimiter=f.delimiter;this.on=function(){f.on.apply(f,arguments)};this.off=function(){f.off.apply(f,arguments)};this.once=function(){f.once.apply(f,arguments)};this.many=function(){f.many.apply(f,arguments)};this.listeners=function(){return f.listeners.apply(f,arguments)};this.removeAllListeners=function(){f.removeAllListeners.apply(f,
arguments)};this.openDocuments=function(a){c.openDocuments(a)};this.getDocumentController=function(){return c.getDocumentController()};this.getConfig=function(){return c.getConfig()};this.getCurrentUser=function(){return c.getCurrentUser()};this.debug=b;this.getProperty=function(a){return c.getProperty(a)};this.getDataAdapter=function(){return c.getDataAdapter()};this.getContext=function(){return c.getAppContext()};this.requestModule=function(a,b,f){void 0===f&&(f=!0);c.requestModule(a,b,f)};this.getModule=
function(a){return c.getModuleIfAvailable(a)};this.whenModuleAvailable=function(a,b,f){return c.whenModuleAvailable(a,b,f)};this.whenAllModulesAreLoaded=function(a){return c.whenAllModulesAreLoaded(a)};this.getLoadedModules=function(){return c.getLoadedModules()};this.injectState=function(a){return c.injectState(a)};this.getViewerState=function(){return c.getState()};this.ajax=function(a,b){c.ajax(a,b)};this.startMode=function(a){return c.startMode(a)};this.stopMode=function(a){return c.stopMode(a)};
this.stopActiveMode=function(){return c.stopActiveMode()};this.getActiveMode=function(){return c.getActiveMode()};this.getLayoutType=function(){return c.getLayoutType()};this.isMobile=function(){return c.getLayoutType()===e.LayoutType.MOBILE};this.switchLayout=function(a){c.switchLayout(a)};this.getFeatureDetector=function(){return c.getFeatureDetector()};this.canFetchFragments=function(){return c.canFetchFragments()}};d.prototype.getOption=function(c){return this.getCurrentUser().getOption(c)};d.prototype.setOption=
function(c,f,b){return this.getCurrentUser().setOption(c,f,b)};d.prototype.setOptionCallback=function(c,f,b){return this.getCurrentUser().setOption(c,f,!1,b)};d.prototype.resetOption=function(c){return this.getCurrentUser().resetOption(c)};d.prototype.getActiveDocument=function(){return this.getDocumentController().getActiveDocument()};d.prototype.getActivePage=function(){return this.getDocumentController().getActivePage()};d.prototype.getUnits=function(){var c=this.getCurrentUser().getOption("PREFERENCES_UNIT_SIZE");
isNaN(c)&&(c=this.getProperty("units"),c=isNaN(c)?g.SizeUnits.MM:parseInt(c,10));return c};d.prototype.getUnitsLocName=function(c){void 0===c&&(c=this.getUnits());return c===g.SizeUnits.PIXELS&&this.getActivePage()&&this.getActivePage().hasCad()&&!this.getActivePage().hasGraphics()?g.UnitsLocNames[g.SizeUnits.POINTS]:g.UnitsLocNames[c]};d.prototype.getUnitsFix=function(c){return void 0!==c?g.UnitsFixes[c]:g.UnitsFixes[this.getUnits()]};d.prototype.getResolutionUnits=function(){return this.getCurrentUser().getOption("PREFERENCES_UNIT_RESOLUTION")};
d.prototype.getResolutionUnitsLocName=function(){return g.ResUnitsLocNames[this.getResolutionUnits()]};d.prototype.getResolutionUnitsFix=function(c){return void 0!==c?g.ResUnitsFixes[c]:g.ResUnitsFixes[this.getResolutionUnits()]};d.prototype.getScreenUnits=function(){return this.getCurrentUser().getOption("PREFERENCES_UNIT_SCREENRULING")};d.prototype.getScreenUnitsLocName=function(){return g.ScreenUnitsLocNames[this.getScreenUnits()]};d.prototype.getScreenUnitsFix=function(c){return void 0!==c?g.ScreenUnitsFixes[c]:
g.ScreenUnitsFixes[this.getScreenUnits()]};d.prototype.loadBundle=function(c,f,b){this.i18n.loadBundle(c,f,b)};d.prototype.t=function(c,f,b){return this.i18n.t.apply(this.i18n,arguments)};d.prototype.isParameterUpdateOngoing=function(){return this.getDocumentController().isParameterUpdateOngoing()};return d});
define("web-viewer/core/PrivateChannel",["underscore"],function(g){return{installTo:function(e,d,c){function f(b){return b&&0<b.length?(g.isArray(b)&&(b=b.join(d.eDelimiter)),[c,b].join(d.eDelimiter)):c}d&&g.isArray(c)&&(c=c.join(d.eDelimiter));e._emit=function(b){arguments[0]=f(b);d.emit.apply(d,arguments)};e.on=function(b){arguments[0]=f(b);d.on.apply(d,arguments)};e.off=function(b){arguments[0]=f(b);d.off.apply(d,arguments)};e.once=function(b){arguments[0]=f(b);d.once.apply(d,arguments)};e.many=
function(b){arguments[0]=f(b);d.many.apply(d,arguments)};e.listeners=function(b){arguments[0]=f(b);return d.listeners.apply(d,arguments)};e.removeAllListeners=function(b){arguments[0]=f(b);d.removeAllListeners.apply(d,arguments)};e.getPrivateChannelName=function(){return c};e.getPrivateChannelNameAsArray=function(){return c.split(d.eDelimiter)}}}});
define("web-viewer/utils/Map",["underscore"],function(g){var e=function(){this._map={}};e.prototype.add=function(d,c){if(void 0===c)throw Error("value parameter should not be undefined!");this._map[d]=c};e.prototype.has=function(d){return void 0!==this._map[d]};e.prototype.get=function(d){return this._map[d]};e.prototype.remove=function(d){var c=this._map[d];delete this._map[d];return c};e.prototype.clear=function(){this._map={}};e.prototype.entries=function(){return g.keys(this._map)};e.prototype.values=
function(){return g.values(this._map)};e.prototype.size=function(){return g.size(this._map)};return e});define("web-viewer/utils/StringSet",["web-viewer/utils/Map"],function(g){var e=function(){g.call(this)};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.prototype.add=function(d){g.prototype.add.call(this,d,!0)};e.prototype.get=function(d){if(this.has(d))return d};e.prototype.values=function(){return this.entries()};return e});
define("web-viewer/data/DocumentController",["web-viewer/core/PrivateChannel","web-viewer/utils/Map","web-viewer/utils/StringSet","underscore"],function(g,e,d,c){var f=function(b,a){this.f=b;g.installTo(this,b,"doc");this._nextIID=0;this._documents=new e;this._linkedDocuments=new e;this._adapter=a;this._pendingParameterUpdateOrigins=new d;this._parameterUpdateOngoing=!0;this._documentsLoading=0;this._debouncedExecuteParameterUpdateIfAllowed=c.debounce(c.bind(this._executeParameterUpdateIfAllowed,
this),20);var h=c.debounce(c.bind(this._notifyParametersUpdated,this),20);this.on("**.page.*.parameters.changed",c.bind(function(){this._parameterUpdateOngoing||h()},this));var f=c.debounce(c.bind(this._notifyStateParametersUpdated,this),20);this.on("**.page.*.stateParameter.changed",c.bind(function(a){f(a)},this));this.f.on("intercept.fragmentURL",c.bind(this.interceptFragmentURL,this))};f.prototype.openDocuments=function(b){this._documentsLoading=this._adapter.getNumberOfDocuments(b);this._adapter.openDocuments(b,
c.bind(function(a,b){this._documentsLoading--;this.addDocument(a,b);if(a.hasLinkedDocument()){var c=a.getLinkedDocument();this._linkedDocuments.add(c.getIID(),c)}},this))};f.prototype.createNewLinkedCadFromOverlay=function(b,a){if(this._cadOverlay||a){a||(a=this._cadOverlay);var c=this._activePage.getDocument().getLinkedDocumentPage(),f=this._adapter.getDeepCopy(a,void 0,void 0,this.getNextIID());this._activePage.getDocument().setLinkedDocumentPage(f);this._linkedDocuments.add(f.getDocument().getIID(),
f.getDocument());b||this.changeCadOverlay(f);this._emit("newLinkedCad",c,f)}else c=this._activePage.getDocument().getLinkedDocumentPage(),this._activePage.getDocument().setLinkedDocumentPage(null),this._cadOverlay=null,this._emit("newLinkedCad",c,null)};f.prototype.addNewLinkedDocument=function(b,a){var c=this._activePage.getDocument().getLinkedDocumentPage(),f=b.getDocumentVersion().getPage();this._activePage.getDocument().setLinkedDocumentPage(f);this._linkedDocuments.add(b.getIID(),b);a||this.changeCadOverlay(f);
this._emit("newLinkedCad",c,f)};f.prototype.loadDocumentPages=function(b,a){var h=this.getDocument(b);void 0!==h&&(h=h.getDocumentVersion(a),void 0!==h&&this._adapter.getPagesOfDocumentVersion(h,c.bind(function(){this._emit("loaded")},this)))};f.prototype.getLinkedDocuments=function(){return this._linkedDocuments.values()};f.prototype.getDocument=function(b){var a=this._documents.get(b);return a?a:this._linkedDocuments.get(b)};f.prototype.getDocumentPage=function(b){var b=b.split("_"),a=this.getDocument(b[0]);
if(a&&(a=a.getDocumentVersion(b[1])))return a.getPage(b[2])};f.prototype.willNeedParameterUpdate=function(b){this._pendingParameterUpdateOrigins.has(b)||(this._pendingParameterUpdateOrigins.add(b),this._parameterUpdateOngoing=!0,c.each([this._activePage,this._differencePage,this._cadOverlay],function(a){a&&a.setParametersAvailable(!1)},this),this._emit("parameters.willChange",b),this._adapter.cancelDocumentParametersUpdate())};f.prototype.readyForParameterUpdate=function(b,a,c){void 0!==this._pendingParameterUpdateOrigins.remove(b)&&
(this._emit("parameters.readyForUpdate",b),a&&this.whenParametersAvailable(a,c),0===this._pendingParameterUpdateOrigins.size()&&this._debouncedExecuteParameterUpdateIfAllowed())};f.prototype._executeParameterUpdateIfAllowed=function(){0===this._pendingParameterUpdateOrigins.size()&&(this._emit("parameters.startUpdate"),this._updateParameters(c.bind(function(){var b;c.each([this._activePage,this._differencePage,this._cadOverlay],function(a){a&&a.setParametersAvailable(!0)},this);this._emit("parameters.beforeEndUpdate",
this._activePageHasChanged,this._differencePageHasChanged,this._cadOverlayHasChanged);this._emit("parameters.endUpdate",this._activePageHasChanged,this._differencePageHasChanged,this._cadOverlayHasChanged);this._emit("parameters.afterEndUpdate",this._activePageHasChanged,this._differencePageHasChanged,this._cadOverlayHasChanged);var a=this.getActivePage(),h=this.getDifferencePage();a&&this._emit("activePageParametersChange",a,h);this._activePageHasChanged&&this._emit("activePageChangedAndParametersAvailable",
this._previousActivePage,a);(a||this._activePageHasChanged)&&this._emit("activePageChangedAndParametersAvailableOrChange",this._previousActivePage,a);h&&this._emit("differencePageParametersChange",a,h);this._differencePageHasChanged&&this._emit("differencePageChangedAndParametersAvailable",this._previousDifferencePage,h);(h||this._differencePageHasChanged)&&this._emit("differencePageChangedAndParametersAvailableOrChange",this._previousDifferencePage,h);if(this._activePageHasChanged||this._differencePageHasChanged)b=
this._activePageHasChanged?this._previousActivePage:this._previousDifferencePage,this._emit("activeOrDifferencePageChangedAndParametersAvailable",a,h,b,this._activePageHasChanged);if(a||h||this._activePageHasChanged||this._differencePageHasChanged)b=this._activePageHasChanged?this._previousActivePage:this._differencePageHasChanged?this._previousDifferencePage:void 0,this._emit("activeOrDifferencePageChangedAndParametersAvailableOrChange",a,h,b,this._activePageHasChanged);this._cadOverlayHasChanged&&
this._emit("cadOverlayChangedAndParametersAvailable",this._previousCadOverlay,this._cadOverlay);(this._activePageHasChanged||this._differencePageHasChanged||this._cadOverlayHasChanged)&&this._emit("activeOrDifferenceOrCadOverlayChangedAndParametersAvailable",a,h,this._cadOverlay);this._parameterUpdateOngoing=!1;this._emit("parameters.changed",a,h);this._cadOverlayHasChanged=this._differencePageHasChanged=this._activePageHasChanged=!1;this._previousDifferencePage=this._previousActivePage=void 0},this)))};
f.prototype._notifyParametersUpdated=function(){if(!this._parameterUpdateOngoing){var b=this.getActivePage(),a=this.getDifferencePage();b&&(this._emit("activePageParametersChange",b,a),this._emit("activePageChangedAndParametersAvailableOrChange",b,b));a&&(this._emit("differencePageParametersChange",b,a),this._emit("differencePageChangedAndParametersAvailableOrChange",a,a));(b||a)&&this._emit("activeOrDifferencePageChangedAndParametersAvailableOrChange",b,a,a,!1)}};f.prototype._notifyStateParametersUpdated=
function(b){var a=this.getDifferencePage(),c=this.getCadOverlay();b===a?this._emit("referencePageStateParametersChanged",this.getActivePage(),this.getDifferencePage()):b===c&&this._emit("cadOverlayPageStateParametersChanged",this.getActivePage(),this.getDifferencePage(),this.getCadOverlay())};f.prototype.isParameterUpdateOngoing=function(){return this._parameterUpdateOngoing};f.prototype.whenParametersAvailable=function(b,a){a&&(b=c.bind(b,a));if(this.isParameterUpdateOngoing())this.once("parameters.changed",
b);else b(this.getActivePage(),this.getDifferencePage())};f.prototype._updateParameters=function(b){this._adapter.updateDocumentParameters(this._activePage,this._differencePage,this._cadOverlay,b)};f.prototype.getActivePage=function(){return this._activePage};f.prototype.hasActiveDocumentPage=function(){return void 0!==this._activePage};f.prototype.hasActiveDocumentPageWithParametersAvailable=function(){return void 0!==this._activePage&&this._activePage.isParametersAvailable()};f.prototype.hasCadOverlaywWithParametersAvailable=
function(){return this._cadOverlay&&this._cadOverlay.isParametersAvailable()};f.prototype.hasDifferenceDocumentPage=function(){return void 0!==this._differencePage};f.prototype.hasDifferenceDocumentPageWithParametersAvailable=function(){return void 0!==this._differencePage&&this._differencePage.isParametersAvailable()};f.prototype.getDifferencePage=function(){return this._differencePage};f.prototype.getNextIID=function(){return this._nextIID++};f.prototype.addDocument=function(b,a){this._documents.add(b.getIID(),
b);this._emit("loaded",b);a&&void 0!==b.getDocumentVersion()&&void 0!==b.getDocumentVersion().getFirstPage()&&this.changeActivePage(b.getDocumentVersion().getFirstPage())};f.prototype.getActiveDocument=function(){if(this.hasActiveDocumentPage()){var b=this._activePage.getDocument();return!this.hasDocument(b)?(this.f.emit("error.WARNING","Trying to get an already removed document"),null):b}return null};f.prototype.getDifferenceDocument=function(){if(this.hasDifferenceDocumentPage()){var b=this._differencePage.getDocument();
return!this.hasDocument(b)?(this.f.emit("error.WARNING","Trying to get an already removed document"),null):b}return null};f.prototype.getActiveDocumentVersion=function(){if(this.hasActiveDocumentPage()){var b=this._activePage.getDocumentVersion();return!this.hasDocument(b.getDocument())?(this.f.emit("error.WARNING","Trying to get an already removed document version"),null):b}return null};f.prototype.getDifferenceDocumentVersion=function(){if(this.hasDifferenceDocumentPage()){var b=this._differencePage.getDocumentVersion();
return!this.hasDocument(b.getDocument())?(this.f.emit("error.WARNING","Trying to get an already removed document version"),null):b}return null};f.prototype.hasDocument=function(b){return this._documents.has(b.getIID())};f.prototype.changeActivePage=function(b){if(b){var a=b.getDocument(),h=this._activePage,f=null;h&&(f=h.getDocumentVersion());if(this.hasDocument(a)){b={oldActivePage:this._activePage,newActivePage:b,diffPage:this._differencePage};this.f.emit("intercept.activePageChange",b);b.diffPage!==
this._differencePage&&this.changeDifferencePage(b.diffPage);this._activePage=b.newActivePage;var d=this._activePage.getDocumentVersion();if(h!=this._activePage){this.willNeedParameterUpdate("ACTIVE_PAGE_CHANGE");this._activePageHasChanged=!0;(this._previousActivePage=h)&&h.resetState();var e=c.bind(function(){if(this._activePage.hasLinkedPage()){var a=this._activePage.getLinkedPage();this.changeCadOverlay(a)}else this.changeCadOverlay();this._emit("page.active",h,this._activePage);f!=d&&this._emit("documentVersion.active",
f,d);this.readyForParameterUpdate("ACTIVE_PAGE_CHANGE")},this);this._activePage.needsDataUpdate()?this._adapter.updateDocumentData(this._activePage,c.bind(function(){e()},this)):e();return!0}return!1}}else this.f.emit("error.WARNING","Trying to change the active page to undefined")};f.prototype.resetDifferencePage=function(){var b=this._differencePage;void 0!==b&&(this.willNeedParameterUpdate("RESET_DIFFERENCE_PAGE"),this._differencePageHasChanged=!0,this._previousDifferencePage=b,this._differencePage=
void 0,b.resetState(),this._emit("page.difference",b,this._differencePage),this.readyForParameterUpdate("RESET_DIFFERENCE_PAGE"))};f.prototype.changeDifferencePage=function(b){if(void 0===b)this.resetDifferencePage();else{var a=b.getDocument(),c=this._differencePage;this.hasDocument(a)&&(this._differencePage=b,c!=this._differencePage&&(this.willNeedParameterUpdate("DIFFERENCE_PAGE_CHANGE"),this._differencePageHasChanged=!0,(this._previousDifferencePage=c)&&c.resetState(),this._emit("page.difference",
c,this._differencePage),this.readyForParameterUpdate("DIFFERENCE_PAGE_CHANGE")))}};f.prototype.whenActiveDocumentVersionChanged=function(b,a){a&&(b=c.bind(b,a));var h=this.getActiveDocumentVersion();h&&b(void 0,h);this.on("documentVersion.active",b)};f.prototype.whenDocumentsLoaded=function(b,a,h){a&&(b=c.bind(b,a));0===this._documentsLoading&&0<this._documents.size()&&b(this.getAllDocuments());if(h||0!==this._documentsLoading)this.on("loaded",c.bind(function(){0===this._documentsLoading&&b(this.getAllDocuments())},
this))};f.prototype.whenDocumentsLoadedOrChange=function(b,a){this.whenDocumentsLoaded(b,a,!0)};f.prototype.loadedDocumentChanged=function(){this._emit("loaded")};f.prototype.changeCadOverlay=function(b){var a=this._cadOverlay;b&&this._activePage.hasCad()&&(this.f.debug.error("Setting a CAD overlay is not allowed when the active document is a CAD document"),b=void 0);a!==b&&(this._cadOverlay=b,this.willNeedParameterUpdate("CAD_OVERLAY_CHANGE"),this._cadOverlayHasChanged=!0,(this._previousCadOverlay=
a)&&a.resetState(),this._emit("page.cadOverlay",a,this._cadOverlay),this.readyForParameterUpdate("CAD_OVERLAY_CHANGE"))};f.prototype.getCadOverlay=function(){return this._cadOverlay};f.prototype.whenActivePageChanged=function(b,a){a&&(b=c.bind(b,a));var h=this.getActivePage();h&&b(void 0,h);this.on("page.active",b)};f.prototype.whenDifferencePageChanged=function(b,a){a&&(b=c.bind(b,a));var h=this.getDifferencePage();h&&b(void 0,h);this.on("page.difference",b)};f.prototype.whenActiveOrDifferencePageChanged=
function(b,a){a&&(b=c.bind(b,a));(this.getActivePage()||this.getDifferencePage())&&b();this.on("page.difference",b);this.on("page.active",b)};f.prototype.whenActivePageParametersChange=function(b,a){a&&(b=c.bind(b,a));this.on("activePageParametersChange",b)};f.prototype.whenReferencePageStateParametersChange=function(b,a){a&&(b=c.bind(b,a));this.on("referencePageStateParametersChanged",b)};f.prototype.whenCadOverlayPageStateParametersChange=function(b,a){a&&(b=c.bind(b,a));this.on("cadOverlayPageStateParametersChanged",
b)};f.prototype.whenDifferencePageParametersChange=function(b,a){a&&(b=c.bind(b,a));this.on("differencePageParametersChange",b)};f.prototype.whenActivePageChangedAndParametersAvailable=function(b,a){a&&(b=c.bind(b,a));this.on("activePageChangedAndParametersAvailable",b);this.hasActiveDocumentPageWithParametersAvailable()?b(void 0,this.getActivePage()):this.isParameterUpdateOngoing()&&!this._activePageHasChanged&&this.whenParametersAvailable(function(a){b(void 0,a)})};f.prototype.whenActivePageChangedAndParametersAvailableOrChange=
function(b,a){a&&(b=c.bind(b,a));this.on("activePageChangedAndParametersAvailableOrChange",b);this.hasActiveDocumentPageWithParametersAvailable()&&b(void 0,this.getActivePage())};f.prototype.whenDifferencePageChangedAndParametersAvailable=function(b,a){a&&(b=c.bind(b,a));this.on("differencePageChangedAndParametersAvailable",b);this.hasDifferenceDocumentPageWithParametersAvailable()?b(void 0,this.getCadOverlay()):this.isParameterUpdateOngoing()&&(this._differencePage&&!this._differencePageHasChanged)&&
this.whenParametersAvailable(function(a,c){b(void 0,c)})};f.prototype.whenDifferencePageChangedAndParametersAvailableOrChange=function(b,a){a&&(b=c.bind(b,a));this.on("differencePageChangedAndParametersAvailableOrChange",b);this.hasDifferenceDocumentPageWithParametersAvailable()&&b(void 0,this.getDifferencePage())};f.prototype.whenCadOverlayChanged=function(b,a){a&&(b=c.bind(b,a));this.on("page.cadOverlay",b);this._cadOverlay&&b(void 0,this._cadOverlay)};f.prototype.whenCadOverlayChangedAndParametersAvailable=
function(b,a){a&&(b=c.bind(b,a));this.on("cadOverlayChangedAndParametersAvailable",b);this.hasCadOverlaywWithParametersAvailable()?b(void 0,this.getCadOverlay()):this.isParameterUpdateOngoing()&&(this._cadOverlay&&!this._cadOverlayHasChanged)&&this.whenParametersAvailable(function(){b(void 0,this._cadOverlay)},this)};f.prototype.whenActiveOrDifferencePageChangedAndParametersAvailable=function(b,a){a&&(b=c.bind(b,a));this.on("activeOrDifferencePageChangedAndParametersAvailable",b);this.hasActiveDocumentPageWithParametersAvailable()||
this.hasDifferenceDocumentPageWithParametersAvailable()?b(this.getActivePage(),this.getDifferencePage(),void 0,!0):this.isParameterUpdateOngoing()&&(!this._activePageHasChanged&&!this._differencePageHasChanged)&&this.whenParametersAvailable(function(a,c){b(a,c,void 0,!0)})};f.prototype.whenActiveOrDifferenceOrCadOverlayChangedAndParametersAvailable=function(b,a){a&&(b=c.bind(b,a));this.on("activeOrDifferenceOrCadOverlayChangedAndParametersAvailable",b);this.hasActiveDocumentPageWithParametersAvailable()||
this.hasDifferenceDocumentPageWithParametersAvailable()||this.hasCadOverlaywWithParametersAvailable()?b(this.getActivePage(),this.getDifferencePage(),this.getCadOverlay()):this.isParameterUpdateOngoing()&&(!this._activePageHasChanged&&!this._differencePageHasChanged&&!this._cadOverlayHasChanged)&&this.whenParametersAvailable(function(){b(this._activePage,this._differencePage,this._cadOverlay)},this)};f.prototype.whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=function(b,a){a&&(b=c.bind(b,
a));this.on("activeOrDifferencePageChangedAndParametersAvailableOrChange",b);(this.hasActiveDocumentPageWithParametersAvailable()||this.hasDifferenceDocumentPageWithParametersAvailable())&&b(this.getActivePage(),this.getDifferencePage(),void 0,!0)};f.prototype.interceptFragmentURL=function(b){this._activePage&&this._activePage.interceptFragmentURL(b)};f.prototype.hasDocumentMultipleVersions=function(b){return this._documents.get(b).hasMultipleVersions()};f.prototype.getDocumentCount=function(){return this._documents.size()};
f.prototype.getDocuments=function(){return this._documents.values()};f.prototype.getAllDocuments=function(){return c.sortBy(this._documents.values(),function(b){return b.get("docname")?b.get("docname").toLowerCase():b.getIID()})};return f});define("web-viewer/core/Extendable",[],function(){return{installTo:function(g){g._override=function(e,d){var c=this[e];void 0===c&&(c=function(){});this[e]=function(){var f=this._super;this._super=c;var b=d.apply(this,arguments);this._super=f;return b}}}}});
define("web-viewer/data/AbstractDocument",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","underscore"],function(g,e){var d=function(c,f,b){e.installTo(this,c,["doc",f]);this.f=c;this.documentID=f;this._documentType=b;this._documentVersions=[];this._data={};this._linkedDocumentPage=null};d.prototype.getIID=function(){return this.documentID};d.prototype.get=function(c){if(void 0!==this._data[c])return this._data[c]};d.prototype.setLinkedDocumentPage=function(c){this._linkedDocumentPage=
c};d.prototype.getLinkedDocument=function(){return this._linkedDocumentPage?this._linkedDocumentPage.getDocument():void 0};d.prototype.getLinkedDocumentPage=function(){return this._linkedDocumentPage};d.prototype.hasLinkedDocument=function(){return null!==this._linkedDocumentPage&&void 0!==this._linkedDocumentPage};d.prototype.getDocumentType=function(){return this._documentType};d.prototype.set=function(c,f){var b=this._data[c];if(void 0===b||void 0!=b&&b!=f)this._data[c]=f;return!0};d.prototype.addDocumentVersion=
function(c){this._documentVersions[c.getVersionId()]=c};d.prototype.addDocumentPage=function(c,f){this._documentVersions[c].addPage(f.getPagenum(),f)};d.prototype.getDocumentVersion=function(c){if(void 0===c&&0<this._documentVersions.length)return _.last(this._documentVersions);if(this._documentVersions[c])return this._documentVersions[c]};d.prototype.hasDocumentVersion=function(c){return void 0!==this._documentVersions[c]};d.prototype.hasMultipleVersions=function(){return 2<_.size(this._documentVersions)};
d.prototype.getAllDocumentVersions=function(){return this._documentVersions.slice(0)};d.prototype.loadVersionsForDocumentPage=function(){};return d});
define("web-viewer/data/AbstractDocumentVersion",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","underscore"],function(g,e){var d=function(c,f,b){e.installTo(this,c,["doc",f.getIID(),"version",b]);this._f=c;this._doc=f;this._versionId=b;this._versionData={};this._pages=[]};d.prototype.get=function(c){if(void 0!==this._versionData[c])return this._versionData[c]};d.prototype.set=function(c,f){var b=this._versionData[c];if(void 0===b||void 0!==b&&b!=f)this._versionData[c]=f;return!0};
d.prototype.getDocument=function(){return this._doc};d.prototype.getVersionId=function(){return this._versionId};d.prototype.requestPage=function(c,f){var b=this.getPage(c);if(void 0===b)this.once(["page",c,"loaded"],_.bind(function(){f(this.getPage(c))},this)),this.loadPage(c);else if(null===b)this.once(["page",c,"loaded"],_.bind(function(){f(this.getPage(c))},this));else f(b)};d.prototype.loadPage=function(c){this._pages[c]=null;this._emit("page.loading",c);this._pages[c]=void 0};d.prototype.addPage=
function(c,f){this._pages[c]=f;this._emit("page."+c+".loaded",f)};d.prototype.getPage=function(c){return void 0===c?this.getFirstPage():this._pages[c]};d.prototype.hasPage=function(c){return void 0!==this._pages[c]};d.prototype.getPageCount=function(){};d.prototype.isLatestVersion=function(){return this._doc.getDocumentVersion().getVersionId()===this._versionId};d.prototype.isMultiPage=function(){return 1<this.getPageCount()};d.prototype.isPageList=function(){return void 0!==this.get("isPageList")&&
this.get("isPageList")};d.prototype.getFirstPage=function(){for(var c=0;c<this._pages.length&&!this._pages[c];)c++;return this._pages[c]};d.prototype.getFirstNotBlankPage=function(){for(var c=0;c<this._pages.length&&(!this._pages[c]||this._pages[c].isBlankPage());)c++;return this._pages[c]};d.prototype.getLastPage=function(){return _.last(this._pages)};d.prototype.getAllPages=function(){return _.without(this._pages.slice(0),null,void 0)};return d});
define("web-viewer/layout/component/LoadingIndicator",["jquery","underscore","web-viewer/core/PrivateChannel","web-viewer/utils/StringSet"],function(g,e,d,c){var f=function(b,a){d.installTo(this,b,a);this._ongoingLoads=new c;this.element=g("<div />").addClass("loadingIndicator").text(" ").hide();this.updateLoadingIndicatorDebounced=e.debounce(e.bind(function(){this.updateLoadingIndicator()},this),40);this.on("start",e.bind(function(a){this._ongoingLoads.add(a);this.updateLoadingIndicator()},this));
this.on("stop",e.bind(function(a){this._ongoingLoads.remove(a);this.updateLoadingIndicatorDebounced()},this))};f.prototype.updateLoadingIndicator=function(){0<this._ongoingLoads.size()?this.element.fadeIn(200):this.element.fadeOut(200)};return f});
define("web-viewer/utils/ListenerUtil",["underscore"],function(g){return{mixin:function(e,d){g.each({_registerListener:function(c,f,b,a){var h=null,h=b?g.bind(f,b):f;void 0===a&&(a=d);c={object:a,channel:c,callback:h};c.object.on(c.channel,c.callback);this._registeredListeners.push(c);return c},_unregisterListener:function(c,f){c.object.off(c.channel,c.callback);if(void 0===f||!0===f)this._registeredListeners=g.without(this._registeredListeners,c)},_unregisterAllListeners:function(){g.each(this._registeredListeners,
function(c){this._unregisterListener(c,!1)},this);this._registeredListeners=[]},_unregisterAllListenersForObject:function(c){var f=[];g.each(this._registeredListeners,function(b){b.object===c&&(this._unregisterListener(b,!1),f.push(b))},this);this._registeredListeners=g.difference(this._registeredListeners,f)},_registeredListeners:[]},function(c,f){e[f]=c})}}});
define("web-viewer/layout/LayoutItem",["web-viewer/layout/LayoutConstants"],function(g){var e=function(d,c,f){this.name=d;this.type=c;this._factory=f;this._itemLayoutType=this._item=null};e.prototype.getItem=function(d){if(null===this._item||this._itemLayoutType!=d)this._item=this._factory(d),this._itemLayoutType=d;return this._item};e.prototype.isWidget=function(){return this.type===g.LayoutItemType.WIDGET};e.prototype.isToolbarComponent=function(){return this.type===g.LayoutItemType.TOOLBARCOMPONENT};
return e});
define("web-viewer/layout/LayoutModel",["web-viewer/core/PrivateChannel","web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutItem"],function(g,e,d){var c=function(c){g.installTo(this,c,["layoutModel"]);this.f=c;this._items={};this._layoutModes={}};c.prototype.hasItem=function(c){return void 0!==this._items[c]};c.prototype.addWidget=function(c,b){var a=new d(c,e.LayoutItemType.WIDGET,b);this._items[a.name]=a;this._emit("itemAdded",a)};c.prototype.addToolbarComponent=function(c,b){var a=new d(c,
e.LayoutItemType.TOOLBARCOMPONENT,b);this._items[a.name]=a;this._emit("itemAdded",a)};c.prototype.getLayoutItemType=function(c){if(this.hasItem(c))return this._items[c].type};c.prototype.getLayoutItem=function(c){if(this.hasItem(c))return this._items[c].getItem()};c.prototype.registerLayoutMode=function(c){this._layoutModes[c.getName()]=c};c.prototype.getLayoutMode=function(c){return this._layoutModes[c]};return c});
define("web-viewer/layout/Layout",["web-viewer/utils/ListenerUtil"],function(g){var e=function(d,c,f){g.mixin(this,d);this.f=d;this._context=f;this._layoutModel=c;this._notVisibleItems=[];this._activeMode=null;this._registerListener("itemAdded",function(b){this._activeMode.isItemAllowed(b.name)?this._addItem(b):this._notVisibleItems.push(b)},this,this._layoutModel);this._registerListener("layout.switchLayoutMode",_.bind(this._switchLayoutMode,this),this,this.f)};e.prototype._addItem=function(){};
e.prototype._updateItemVisibility=function(){};e.prototype._emitLayoutChanged=function(){this._emit("layout.changed")};e.prototype.isLayoutStatePersisted=function(){return this._activeMode.isPersisted()};e.prototype.getLayoutState=function(){};e.prototype._switchLayoutMode=function(d){if(null===this._activeMode||d!==this._activeMode.getName()){var c=null,c=void 0!==d?this._layoutModel.getLayoutMode(d):this._getDefaultLayoutMode();if(void 0!==c){null!==this._activeMode&&this._activeMode.toggle(!1);
this._activeMode=c;this._activeMode.toggle(!0);var f=[];_.each(this._notVisibleItems,function(b){this._activeMode.isItemAllowed(b.name)&&(this._addItem(b),f.push(b))},this);f.length&&(this._notVisibleItems=_.difference(this._notVisibleItems,f));this._updateItemVisibility();this._emit("changed.layoutMode")}}};e.prototype._getDefaultLayoutMode=function(){};e.prototype.getActiveLayoutMode=function(){return this._activeMode};e.prototype.getLayoutType=function(){return-1};return e});
define("web-viewer/layout/DraggableWidgets",["jquery","jqueryUI","underscore"],function(g){function e(c){this.wrapper=c;this.ghost=g("<div/>").addClass("ghostWrapper");this.sizeBeforeDrag={width:void 0,height:void 0}}e.prototype.updateGhost=function(){this.ghost.css({width:this.wrapper.element.outerWidth(!0),height:this.wrapper.element.outerHeight(!0)})};var d=function(c){this.container=c;this.hoveredSortableDropzone=void 0};d.prototype.enableDragging=function(c){c.drag=new e(c);g(c.element).draggable({containment:this.container,
distance:20,scroll:!1,revert:"invalid",helper:function(){var f=c.element.clone();f.css({width:c.element.innerWidth(),opacity:0.9});return f},appendTo:this.container,start:_.bind(function(){this.drag.updateGhost();this.drag.sizeBeforeDrag.width=this.element.innerWidth();this.drag.sizeBeforeDrag.height=this.element.innerHeight();this.element.hide()},c),drag:_.bind(function(f,b){this.hoveredSortableDropzone&&this.insertAt(this.hoveredSortableDropzone,c.drag.ghost,b.offset.top-this.hoveredSortableDropzone.offset().top)},
this),stop:_.bind(function(c,b){this.drag.ghost.detach();this.element.show();this.widget.dragged(b.offset.top,b.offset.left);b.helper.detach()},c),handle:".header"})};d.prototype.addSortableWidgetDropzone=function(c,f,b){g(c).droppable({accept:".widgetWrapper",drop:_.bind(function(a,h){var d=this.findSibling(c,h.draggable,h.offset.top-c.offset().top),k=h.draggable[0].wrapper;void 0===d?b.moveItem(k.getID(),f,void 0,!0):d.wrapper&&(d=d.wrapper,b.moveItem(k.getID(),f,d.getID(),!0))},this),over:_.bind(function(){this.hoveredSortableDropzone=
c},this),out:_.bind(function(){this.hoveredSortableDropzone=void 0},this),tolerance:"touch"})};d.prototype.addModalWidgetDropzone=function(c,f,b){g(c).droppable({accept:".widgetWrapper",drop:_.bind(function(a,c){var d=c.draggable[0].wrapper;d.setModal(!0,c.offset.top,c.offset.left,d.drag.sizeBeforeDrag.width);b.moveItem(d.getID(),f);d.widget.fireModalResize()},this)})};d.prototype.removeDropzone=function(c){g(c).droppable("disable")};d.prototype.insertAt=function(c,f,b){b=this.findSibling(c,f,b);
void 0===b?c.append(f):g(b).before(f)};d.prototype.findSibling=function(c,f,b){var a=0,h,d=!0;c.children(".widgetWrapper").each(function(c,f){var e=g(f).outerHeight(!0);d&&b<=a+e/2&&(h=f,d=!1);a+=e});return h};return d});
define("web-viewer/utils/ShapeUtils",["underscore"],function(){var g=function(b,a){this.x=b?b:0;this.y=a?a:0};g.prototype.toString=function(){return this.x+"x"+this.y};g.prototype.copy=function(){return new g(this.x,this.y)};g.prototype.equals=function(b){return this.x==b.x&&this.y==b.y};g.prototype.sizeTo=function(b){return new f.Size(b.x-this.x,b.y-this.y)};g.prototype.offset=function(b){this.x+=b.width;this.y+=b.height};g.prototype.offsetXY=function(b,a){this.x+=b;this.y+=a};g.prototype.near=function(b,
a){return Math.abs(this.x-b.x)<=a&&Math.abs(this.y-b.y)<=a};g.prototype.getDistance=function(b){return Math.sqrt(Math.pow(this.x-b.x,2)+Math.pow(this.y-b.y,2))};var e=function(b,a){this.width=b?b:0;this.height=a?a:0};e.prototype.toString=function(){return this.width+" x "+this.height};e.prototype.copy=function(){return new e(this.width,this.height)};e.prototype.equals=function(b){return this.width==b.width&&this.height==b.height};e.prototype.add=function(b){this.width+=b.width;this.height+=b.height};
var d=function(b,a){this.origin=b?b:new g;this.size=a?a:new e};d.prototype.normalize=function(){0>this.size.width&&(this.origin.x+=this.size.width,this.size.width=Math.abs(this.size.width));0>this.size.height&&(this.origin.y+=this.size.height,this.size.height=Math.abs(this.size.height))};d.prototype.containsPoint=function(b){var a=!1;this.origin.x<=b.x&&b.x<=Number(this.origin.x)+Number(this.size.width)&&this.origin.y<=b.y&&b.y<=Number(this.origin.y)+Number(this.size.height)&&(a=!0);return a};d.prototype.toString=
function(){return"Origin: "+this.origin.toString()+" size: "+this.size.toString()};d.prototype.rectEquals=function(b,a){if(void 0===b||null===b)return!1;void 0===a&&(a=1E-6);return Math.abs(b.origin.x-this.origin.x)<=a&&Math.abs(b.origin.y-this.origin.y)<=a&&Math.abs(b.size.width-this.size.width)<=a&&Math.abs(b.size.height-this.size.height)<=a};d.prototype.rectIntersect=function(b){return!(b.normLeft()>this.normRight()||b.normRight()<this.normLeft()||b.normTop()>this.normBottom()||b.normBottom()<
this.normTop())};d.prototype.right=function(){return this.origin.x+this.size.width};d.prototype.left=function(){return this.origin.x};d.prototype.top=function(){return this.origin.y};d.prototype.bottom=function(){return this.origin.y+this.size.height};d.prototype.width=function(){return this.size.width};d.prototype.height=function(){return this.size.height};d.prototype.topleft=function(){return new g(this.left(),this.top())};d.prototype.topright=function(){return new g(this.right(),this.top())};d.prototype.bottomleft=
function(){return new g(this.left(),this.bottom())};d.prototype.bottomright=function(){return new g(this.right(),this.bottom())};d.prototype.topcenter=function(){return new g(this.center().x,this.top())};d.prototype.bottomcenter=function(){return new g(this.center().x,this.bottom())};d.prototype.centerleft=function(){return new g(this.left(),this.center().y)};d.prototype.centerright=function(){return new g(this.right(),this.center().y)};d.prototype.normRight=function(){return 0<=this.size.width?this.origin.x+
this.size.width:this.origin.x};d.prototype.normLeft=function(){return 0<=this.size.width?this.origin.x:this.origin.x+this.size.width};d.prototype.normTop=function(){return 0<=this.size.height?this.origin.y:this.origin.y+this.size.height};d.prototype.normBottom=function(){return 0<=this.size.height?this.origin.y+this.size.height:this.origin.y};d.prototype.normHeight=function(){return Math.abs(this.size.height)};d.prototype.normWidth=function(){return Math.abs(this.size.height)};d.prototype.center=
function(){return new g(this.origin.x+this.size.width/2,this.origin.y+this.size.height/2)};d.prototype.setCenter=function(b){this.origin.x=b.x-this.size.width/2;this.origin.y=b.y-this.size.height/2};d.prototype.containsRect=function(b,a){a||(a=0);var c=this.origin.x-a,f=this.origin.y-a,d=this.size.width+a,e=this.size.height+a,g=b.origin.x,j=b.origin.y,n=b.size.width,m=b.size.height;if(0>(d|e|n|m)||g<c||j<f)return!1;d+=c;n+=g;if(n<=g){if(d>=c||n>d)return!1}else if(d>=c&&n>d)return!1;e+=f;m+=j;if(m<=
j){if(e>=f||m>e)return!1}else if(e>=f&&m>e)return!1;return!0};d.prototype.copy=function(){return new d(this.origin.copy(),this.size.copy())};d.prototype.update=function(b,a){1==arguments.length?(this.size.width=b.x-this.origin.x,this.size.height=b.y-this.origin.y):(this.origin.x=b.x,this.origin.y=b.y,this.size.width=a.x-b.x,this.size.height=a.y-a.y)};d.prototype.calculateOverlap=function(b){var a=new g(Math.max(this.normLeft(),b.normLeft()),Math.max(this.normTop(),b.normTop())),b=new g(Math.min(this.normRight(),
b.normRight()),Math.min(this.normBottom(),b.normBottom())),a=new d(a);a.update(b);return a};d.prototype.calculateArea=function(b){var a=new g(Math.min(this.normLeft(),b.normLeft()),Math.min(this.normTop(),b.normTop())),b=new g(Math.max(this.normRight(),b.normRight()),Math.max(this.normBottom(),b.normBottom())),a=new d(a);a.update(b);return a};var c=function(b,a,c){this.x=b?b:0;this.y=a?a:0;this.angleWhenZero=0==this.x&&0==this.y?c?c:0:this.getAngleInRadians()};c.prototype.toString=function(){return this.x+
","+this.y};c.prototype.copy=function(){return new c(this.x,this.y,this.angleWhenZero)};c.prototype.equals=function(b){return this.x==b.x&&this.y==b.y&&this.getAngleInRadians()==b.getAngleInRadians()};c.prototype.getLength=function(){return Math.sqrt(Math.pow(this.x,2)+Math.pow(this.y,2))};c.prototype.setLength=function(b){var a=this.getLength(),c=this.getAngleInRadians();0===a?(this.x=Math.cos(c)*b,this.y=Math.sin(c)*b):(b/=a,this.x*=b,this.y*=b);this.angleWhenZero=c};c.prototype.getAngleInDegrees=
function(){return 180*this.getAngleInRadians()/Math.PI};c.prototype.getAngleInRadians=function(){return 0===this.x&&0===this.y?this.angleWhenZero:Math.atan2(this.y,this.x)};c.prototype.setAngleInDegrees=function(b){this.setAngleInRadians(b*Math.PI/180)};c.prototype.setAngleInRadians=function(b){var a=this.getLength();this.angleWhenZero=b;this.x=a*Math.cos(b);this.y=a*Math.sin(b)};var f={Point:g,Size:e,Rect:d,Vector:c,rectMake:function(b,a,c,f){return new d(new g(b,a),new e(c,f))},rectIntersection:function(b,
a){var c,f,d,e;c=Math.max(b.left(),a.left());d=Math.max(b.top(),a.top());f=Math.min(b.right(),a.right());e=Math.min(b.bottom(),a.bottom());return this.rectMake(c,d,f-c,e-d)},rectIsNull:function(b){return 0==b.origin.x&&0==b.origin.y&&0==b.size.width&&0==b.size.height}};return f});
define("web-viewer/layout/WidgetWrapper",["jquery","web-viewer/utils/ShapeUtils"],function(g,e){var d=function(c,f,b){this._headerEnabled=!0;this.element=g("<div/>").addClass("widgetWrapper");this.element[0].wrapper=this;this.element.scroll(function(){g(this).scrollTop(0)});this.name=f;this.header=g("<div/>").addClass("header");this.headerText=g("<h3>").text(c.getTitle());this.headerHandle=g("<div/>").addClass("headerHandle").append(this.headerText);b&&this.headerHandle.click(_.bind(function(){this.toggle()},
this));this.header.append(this.headerHandle);this.headerExtra=g("<div/>").addClass("headerExtra");this.header.append(this.headerExtra);c.on("titlechanged",_.bind(function(a){this.headerText.text(a)},this));this.content=g("<div/>").addClass("content");this.element.append(this.header,this.content);c.setContext(this.content,this.headerExtra);this.resizable=!1;this.widget=c;this.isCollapsed=this.isModal=!1;this._isVisible=!0;this._locationWhenHidden=new e.Point};d.prototype.setModal=function(c,f,b,a,
h){this.widget.setModal(c);c?(this.element.css({position:"absolute",top:f,left:b,width:a||this.element.width()||void 0,height:h||this.element.height()||void 0}),c=h||this.element.height()||0,this.content.css("height",c-this.getHeaderHeight()),this.setResizable(!this.isCollapsed),this.isModal=!0):(this.isModal=!1,this.element.css({position:"relative",top:"",left:"",width:"auto"}),this.setResizable(!1))};d.prototype.toggle=function(){this.setCollapsed(!this.isCollapsed)};d.prototype.setVisible=function(c){(this._isVisible=
c)?this.element.show():(c=this.element.offset(),this._locationWhenHidden=new e.Point(c.left,c.top),this.element.hide())};d.prototype.isVisible=function(){return this._isVisible};d.prototype.setCollapsed=function(c){var f=this.isCollapsed;this.element.toggleClass("collapsed",c);this.isCollapsed=c;this.widget.setCollapsed(c);this.isModal&&f!==c&&(f=Math.min(g(window).height()-(this.element.offset().top-g(window).scrollTop()),this.getPreferredSize().height),this.setHeight(f),c||this.setResizable(!0),
this.setResizable(!this.isCollapsed),this.widget.fireModalResize())};d.prototype.setResizable=function(c){this.resizable&&!c?(this.element.resizable("destroy"),this.resizable=!1):!this.resizable&&c&&(c=this.getMinimumSize(),this.element.resizable({minWidth:Math.max(100,c.width),minHeight:Math.max(40,c.height),stop:_.bind(function(c,b){this.setHeight(b.size.height);this.widget.fireModalResize()},this),resize:_.throttle(_.bind(function(c,b){this.setHeight(b.size.height);this.widget.resizing()},this),
40)}),this.resizable=!0)};d.prototype.getID=function(){return this.widget.getID()};d.prototype.getMinimumSize=function(){if(this.isCollapsed)return new e.Size(0,this.getHeaderHeight());var c=this.widget.getMinimumSize().copy();c.height+=this.getHeaderHeight()+3;return c};d.prototype.getPreferredSize=function(){if(this.isCollapsed)return new e.Size(0,this.getHeaderHeight());var c=this.widget.getPreferredSize();if(c)return c=c.copy(),c.height+=this.getHeaderHeight()+3,c};d.prototype.getMaximumSize=
function(){if(this.isCollapsed)return new e.Size(1E3,this.getHeaderHeight());var c=this.widget.getMaximumSize();if(c)return c=c.copy(),c.height+=this.getHeaderHeight()+3,c};d.prototype.getHeaderHeight=function(){return this._headerEnabled?this.header.outerHeight(!0):0};d.prototype.getContentHeight=function(){return this.content.getOuterHeight(!0)};d.prototype.willFill=function(){return this.widget.willFill()};d.prototype.setHeight=function(c){var f=this.content.height(),b=c-this.getHeaderHeight();
this.element.css("height",c);this.content.css("height",b);b!=f&&(this.widget.resized(),this.content.css("overflow","hidden"),_.defer(function(a){a.css("overflow","auto")},this.content))};d.prototype.getSize=function(){return new e.Size(this.element.width(),this.element.height())};d.prototype.getOuterSize=function(){return new e.Size(this.element.outerWidth(!0),this.element.outerHeight(!0))};d.prototype.getLocation=function(){if(this._isVisible){var c=this.element.offset();return new e.Point(c.left,
c.top)}return this._locationWhenHidden};d.prototype.setHeaderEnabled=function(c){this._headerEnabled=c;this.header.toggleClass("displayNone",!c)};return d});
define("web-viewer/layout/desktop/Panel",["web-viewer/core/PrivateChannel"],function(g){var e=function(d,c,f){this.f=d;g.installTo(this,d,["panel",c]);this.name=c;this.el=f;this.height=this.width=0;this._visible=!0;this._disabled=!1};e.prototype.show=function(){var d=this.isVisible();this._visible=!0;this._updateVisibility();d!=this.isVisible()&&this._emit("changed.visibility",d,this.isVisible())};e.prototype.hide=function(){var d=this.isVisible();this._visible=!1;this._updateVisibility();d!=this.isVisible()&&
this._emit("changed.visibility",d,this.isVisible())};e.prototype.toggle=function(d){void 0===d&&(d=!this.getVisibility());d?this.show():this.hide()};e.prototype.getVisibility=function(){return this._visible};e.prototype.setDisabled=function(d){var c=this.isVisible();this._disabled=d;this._updateVisibility();c!=this.isVisible()&&this._emit("changed.visibility",c,this.isVisible())};e.prototype.isDisabled=function(){return this._disabled};e.prototype.setWidth=function(d){this.width!==d&&(this.width=
d,this.el.css("width",d))};e.prototype.setHeight=function(d){this.height!==d&&(this.height=d,this.el.css("height",d))};e.prototype.getHeight=function(){return this.isVisible()?this.height:0};e.prototype.getWidth=function(){return this.isVisible()?this.width:0};e.prototype.getWidthWhenVisible=function(){return this.width};e.prototype.getHeightWhenVisible=function(){return this.height};e.prototype.outerWidth=function(){return this.isVisible()?this.el.outerWidth(!0):0};e.prototype.innerWidth=function(){return this.isVisible()?
this.el.innerWidth():0};e.prototype.outerHeight=function(){return this.isVisible()?this.el.outerHeight(!0):0};e.prototype.position=function(){return this.el.position()};e.prototype.setDim=function(d,c){void 0!==d&&this.setWidth(d);void 0!==c&&this.setHeight(c)};e.prototype.isVisible=function(){return this._visible&&!this._disabled};e.prototype._updateVisibility=function(){this.el.toggle(this.isVisible())};e.prototype.getState=function(){return{visible:this._visible}};e.prototype.restoreState=function(d){this.toggle(d.visible)};
return e});
define("web-viewer/layout/component/Popover",["web-viewer/utils/ShapeUtils","jquery","underscore"],function(g,e,d){var c=function(c,b,a,h,o,k,g,i,j){this.context=c;this.container=b;this.restrict=a;this.minHeight=i;this._placementOptions=["top","right","bottom","left"];this._hasCustomPlacementOptions=!1;this.placement=h?h:"bottom";this.element=e("<div />").addClass("popover");(this.color=o)&&this.element.css("background-color",o);(this.cssClass=k)&&this.element.addClass(k);this.maxSizeOverwritesCss=j;
this.element.on("contentResized",d.bind(function(a){this._recalculatePositions();a.stopPropagation()},this));this.restrictBorder=void 0===g?10:g;this._arrow=e("<div />");this._content=e("<div />").addClass("content");void 0===this.minHeight&&this.element.append(this._arrow);this.element.append(this._content);if(void 0===k||j)c=800,b=this.restrict.innerHeight()-2*this.restrictBorder,c=Math.min(c,this.restrict.innerWidth()-2*this.restrictBorder),this._content.css({"max-height":b,"max-width":c});this._placements=
void 0;this._createPlacements();this.MAX_DEPTH=this._placements.length;this._addedToContainer=!1;this._onAddedToContainerCallbacks=[];this._onDestroyCallbacks=[]};c.prototype._createPlacements=function(){this._placements=this._placementOptions.slice(0);if(!this._hasCustomPlacementOptions){var c=d.indexOf(this._placements,this.placement);0>c&&(c=0);this._placements.splice(c,0,"innerLeft")}};c.prototype.setPlacementOptions=function(c){this._placementOptions=c.splice(0);this.placement=this._placementOptions[0]?
this._placementOptions[0]:"bottom";this._hasCustomPlacementOptions=!0;this._createPlacements()};c.prototype._getContextRect=function(){return g.rectMake(this.context.offset().left,this.context.offset().top,this.context.outerWidth(!0),this.context.outerHeight(!0))};c.prototype._getRestrictRect=function(){return g.rectMake(this.restrict.offset().left,this.restrict.offset().top,this.restrict.innerWidth(),this.restrict.innerHeight())};c.prototype._getElementSize=function(){return new g.Size(this.element.outerWidth(!0),
this.element.outerHeight(!0))};c.prototype._getArrowSize=function(){return new g.Size(this._arrow.outerWidth(!0),this._arrow.outerHeight(!0))};c.prototype._restrictToBorders=function(c,b,a){c.left<a.left()+this.restrictBorder&&(c.left=a.left()+this.restrictBorder);c.top<a.top()+this.restrictBorder&&(c.top=a.top()+this.restrictBorder);c.left+b.width>a.right()-this.restrictBorder&&(c.left=Math.max(0,a.right()-b.width-this.restrictBorder));if((void 0===this.minHeight||a.bottom()-this.restrictBorder-
c.top<this.minHeight)&&c.top+b.height>a.bottom()-this.restrictBorder)c.top=Math.max(0,a.bottom()-b.height-this.restrictBorder)};c.prototype._getNextPlacement=function(c){return this._placements[(d.indexOf(this._placements,c)+1)%this._placements.length]};c.prototype._resetArrowColor=function(){this._arrow.css("border-top-color","");this._arrow.css("border-bottom-color","");this._arrow.css("border-left-color","");this._arrow.css("border-right-color","")};c.prototype._setArrow=function(c){this._resetArrowColor();
this._arrow.removeClass();switch(c){case "top":this._arrow.addClass("arrow-down");this.color&&this._arrow.css("border-top-color",this.color);break;case "bottom":this._arrow.addClass("arrow-up");this.color&&this._arrow.css("border-bottom-color",this.color);break;case "left":this._arrow.addClass("arrow-right");this.color&&this._arrow.css("border-left-color",this.color);break;case "right":this._arrow.addClass("arrow-left");this.color&&this._arrow.css("border-right-color",this.color);break;case "innerLeft":this._arrow.addClass("arrow-left"),
this.color&&this._arrow.css("border-right-color",this.color)}};c.prototype._calculatePositions=function(c,b){if(c>=this.MAX_DEPTH)this._setArrow(this.placement);else{this._setArrow(b);var a=this._getContextRect(),h=this._getArrowSize(),d=this._getElementSize(),k=this._getRestrictRect(),e=void 0,g=void 0;switch(b){case "top":e={top:a.top()-h.height,left:a.left()+a.size.width/2-h.width/2};g={top:a.top()-h.height-d.height,left:a.left()+a.size.width/2-d.width/2};break;case "bottom":e={top:a.top()+a.size.height,
left:a.left()+a.size.width/2-h.width/2};g={top:a.top()+h.height+a.size.height,left:a.left()+a.size.width/2-d.width/2};break;case "left":e={top:a.top()+a.size.height/2-h.height/2,left:a.left()-h.width};g={top:a.top()+a.size.height/2-d.height/2,left:a.left()-h.width-d.width};break;case "right":e={top:a.top()+a.size.height/2-h.height/2,left:a.left()+a.size.width};g={top:a.top()+a.size.height/2-d.height/2,left:a.left()+a.size.width+h.width};break;case "innerLeft":e={top:a.top()+a.size.height/2-h.height/
2,left:a.left()};g={top:a.top()+a.size.height/2-d.height/2,left:a.left()+h.width};break;case "bottomLeft":e={top:a.top()+a.size.height/2-h.height/2,left:a.left()+h.width/2},g={top:a.top()+h.height+a.size.height,left:a.left()}}if(e.top<=k.top()+this.restrictBorder||e.top+h.height>=k.bottom()-this.restrictBorder||e.left<=k.left()+this.restrictBorder||e.left+h.width>=k.right()-this.restrictBorder)return this._calculatePositions(c+1,this._getNextPlacement(b));this._restrictToBorders(g,d,k,this.minHeight);
switch(b){case "top":if(g.top+(void 0===this.minHeight?d.height:Math.min(d.height,this.minHeight))>e.top)return this._calculatePositions(c+1,this._getNextPlacement(b));break;case "bottom":if(g.top<e.top+h.height)return this._calculatePositions(c+1,this._getNextPlacement(b));break;case "left":if(g.left+d.width>e.left)return this._calculatePositions(c+1,this._getNextPlacement(b));break;case "right":if(g.left<e.left+h.width)return this._calculatePositions(c+1,this._getNextPlacement(b));break;case "innerLeft":if(g.left<
e.left+h.width)return this._calculatePositions(c+1,this._getNextPlacement(b))}e.top=Math.floor(e.top);e.left=Math.floor(e.left);g.top=Math.floor(g.top);g.left=Math.floor(g.left);a={arrow:e,content:g};void 0!==this.cssClass&&this.maxSizeOverwritesCss&&(a.contentMaxHeight=this.restrict.innerHeight()-this.restrictBorder-g.top);return a}};c.prototype._recalculatePositions=function(){if(this._addedToContainer){var c=this._content.scrollTop();this.element.css({"max-height":"","max-width":""});this._content.css({"max-height":"",
"max-width":""});var b=this._calculatePositions(0,this.placement);b?(this.element.offset(b.content),this._arrow.offset(b.arrow),void 0!==b.contentMaxHeight&&this._content.css("max-height",b.contentMaxHeight)):this.element.hide();this._content.scrollTop(c)}};c.prototype.setContext=function(c){this.context=c};c.prototype.setPreferredPlacement=function(c){this.placement=c;this._createPlacements()};c.prototype.show=function(){this._addedToContainer||(this.container.append(this.element),this._addedToContainer=
!0,d.each(this._onAddedToContainerCallbacks,function(c){c()}));this.element.show();this._recalculatePositions()};c.prototype.hide=function(){this.element.hide()};c.prototype.destroy=function(){d.each(this._onDestroyCallbacks,function(c){c()});this._content.detach();this.element.remove()};c.prototype.setContent=function(c){this._content.empty().append(c)};c.prototype.setContainer=function(c){this._container=c};c.prototype.appendContent=function(c){this._content.append(c)};c.prototype.onAddedToContainer=
function(c){this._onAddedToContainerCallbacks.push(c)};c.prototype.onDestroy=function(c){this._onDestroyCallbacks.push(c)};c.prototype.getContentDiv=function(){return this._content};return c});
define("web-viewer/layout/component/Tooltip",["web-viewer/layout/component/Popover","jquery","underscore"],function(g,e){var d=function(c,d,b,a,h){g.call(this,d,c.getContext(),c.getContext(),c.isMobile()?"top":"bottom","#333","tooltip",3);this.MAX_CHARS=65;this.f=c;this.tooltip=e("<div>");this.setTooltipContent(b,a,h);this._show=_.bind(this.show,this);this._hide=_.bind(this.hide,this);this._touchAndHoldShow=_.bind(this._delayedShow,this);this._timer=null;this._enabled=!1;this.enableTooltip()};d.prototype=
Object.create(g.prototype);d.prototype.constructor=d;d.prototype.setTooltipContent=function(c,d,b){void 0!==d?this.f.i18n.loadBundle(c,function(){void 0===b?b=[d]:b.unshift(d);var a=this.f.i18n.t.apply(this.f.i18n,b);this.tooltip.empty().append(this._fitLine(a));this.setContent(this.tooltip)},this):(this.tooltip.empty().append(this._fitLine(c)),this.setContent(this.tooltip))};d.prototype._fitLine=function(c){if(c.length<this.MAX_CHARS||-1!==c.lastIndexOf("<br/>"))return c;var d="";do{var b=c.lastIndexOf(" ",
this.MAX_CHARS);-1!=b?(d+=c.substr(0,b)+"<br />",c=c.substr(b)):(d+=c,c="")}while(c.length>=this.MAX_CHARS);0<c.length&&(d+=c);return d};d.prototype.disableTooltip=function(){this.context.removeClass("hasTooltip");this.f.isMobile()?this._disableTooltipTouch():this._disableTooltipMouse();this._enabled=!1};d.prototype.enableTooltip=function(){this._enabled||(this.context.addClass("hasTooltip"),this.f.isMobile()?this._enableTooltipTouch():this._enableTooltipMouse(),this._enabled=!0)};d.prototype._delayedShow=
function(){this._timer||(this._timer=setTimeout(_.bind(function(){this._show();setTimeout(this._hide,2500)},this),600))};d.prototype.hide=function(){this._timer&&(clearTimeout(this._timer),this._timer=null);g.prototype.hide.call(this)};d.prototype.refereshListeners=function(){this.disableTooltip();this.enableTooltip()};d.prototype._disableTooltipMouse=function(){this.context.off("mouseover",this._show);this.context.off("mouseout",this._hide)};d.prototype._enableTooltipMouse=function(){this.context.on("mouseover",
this._show);this.context.on("mouseout",this._hide)};d.prototype._disableTooltipTouch=function(){this.context.off("touchstart pointerdown",this._touchAndHoldShow);this.context.off("touchend touchcancel",this._hide);this.context.off("contextmenu",this.contextMenuListener)};d.prototype._enableTooltipTouch=function(){this.context.on("touchstart pointerdown",this._touchAndHoldShow);this.context.on("touchend touchcancel",this._hide);this.context.on("contextmenu",this.contextMenuListener)};d.prototype.contextMenuListener=
function(c){c.stopPropagation();c.preventDefault();return!1};return d});
define("web-viewer/layout/component/Button",["web-viewer/layout/component/Tooltip","jquery","underscore"],function(g,e,d){var c=function(c,b,a,h,o){this.f=c;this.name=b;this.content=a;this.forMobile=void 0===h?!0:h;this.action=o;this.element=e("<a/>").attr("name",b);this.enabled=!0;this.tooltip=void 0;this._enabledTooltipContent=[];this._disabledTooltipContent=[];if(this.forMobile&&this.f.isMobile())this.element.on("pointerup touchend",d.bind(this.onClick,this));else this.element.on("click",d.bind(this.onClick,
this));this.element.append(this.content)};c.prototype.addClass=function(c){this.element.addClass(c)};c.prototype.setContent=function(c){this.content=c;this.element.empty();this.element.append(this.content)};c.prototype.onClick=function(c){this.isEnabled()&&(this.tooltip&&this.tooltip.hide(),this.action&&this.action(c),this.f.isMobile()||c.stopPropagation())};c.prototype.setEnabled=function(c){this.element.toggleClass("disabled",!c);void 0!==this.tooltip&&(0<this._disabledTooltipContent.length?(this.tooltip.enableTooltip(),
c?this.tooltip.setTooltipContent(this._enabledTooltipContent[0],this._enabledTooltipContent[1],this._enabledTooltipContent[2]):this.tooltip.setTooltipContent(this._disabledTooltipContent[0],this._disabledTooltipContent[1],this._disabledTooltipContent[2])):c?this.tooltip.enableTooltip():this.tooltip.disableTooltip());this.enabled=c;this._updateIcon()};c.prototype.isEnabled=function(){return this.enabled};c.prototype._updateIcon=function(){};c.prototype.setAction=function(c){this.action=c};c.prototype.setTooltip=
function(c,b,a){this._enabledTooltipContent=[c,b,a];void 0===this.tooltip?this.tooltip=new g(this.f,this.element,c,b,a):this.enabled&&this.tooltip.setTooltipContent(c,b,a)};c.prototype.setDisabledTooltip=function(c,b,a){this._disabledTooltipContent=[c,b,a];!this.enabled&&this.tooltip&&(this.tooltip.enableTooltip(),this.tooltip.setTooltipContent(c,b,a))};c.prototype.isActive=function(){return this.element.hasClass("active")};c.prototype.setActive=function(c){this.isEnabled()&&(c?this.isActive()||this.element.addClass("active"):
this.isActive()&&this.element.removeClass("active"))};c.prototype.moved=function(){};c.prototype.show=function(){this.element.show()};c.prototype.hide=function(){this.element.hide()};return c});
define("web-viewer/layout/component/MiniButton",["web-viewer/layout/component/Tooltip","web-viewer/layout/component/Button","jquery","underscore"],function(g,e,d){g=function(c,f,b,a,h,o,k){e.call(this,c,f,"",a,h);this.element.addClass("mini-btn");this.defaultIcon=b;this.disabledIcon=o||b;this.icon=d("<i />").addClass(b);this.badge=d("<span />").addClass("badge").hide();this.icon.append(this.badge);this.badgeText=k||"";this.element.append(this.icon)};g.prototype=Object.create(e.prototype);g.prototype.constructor=
g;g.prototype.setBadge=function(c){this.badgeText=c;this._updateIcon()};g.prototype.setIcon=function(c){this.defaultIcon=c;this._updateIcon()};g.prototype.setDisabledIcon=function(c){this.disabledIcon=c;this._updateIcon()};g.prototype._updateIcon=function(){this.isEnabled()?this.badgeText?(this.badge.text(this.badgeText),this.badge.show()):this.badge.hide():this.badge.hide();this.icon.removeClass();this.icon.addClass(this.isEnabled()?this.defaultIcon:this.disabledIcon);this.element.toggleClass("disabled",
!this.isEnabled())};g.prototype.addButtonClass=function(c){this.element.addClass(c)};return g});
define("web-viewer/layout/LayoutUtils",["underscore"],function(g){return{layoutWidgets:function(e,d){for(var c=e.find(".widgetWrapper"),f=e.innerHeight()-d,b=[],a,h=0,o=[],k=[],l=0;l<c.length;l++){var i=c[l].wrapper;i.isVisible()&&(a=void 0,i.getMaximumSize()&&(a=i.getMaximumSize().height),a={widget:i,min:i.getMinimumSize().height,pref:i.getPreferredSize().height,max:a,height:0},b.push(a),a.height=Math.max(a.min,a.pref),a.max&&(a.height=Math.min(a.max,a.height)),a.height=Math.min(a.height,f),a.widget.willFill()&&
a.height>a.min&&o.push(a),h+=a.height+d)}var j=0;a=function(){for(j=h-f;0<j&&0<o.length;){var a=g.first(o),b=g.reduce(o,function(a,b){return a+b.pref},0),b=Math.ceil(a.pref/b*j);o=g.rest(o,1);var c=a.height;a.height=Math.max(a.min,a.height-b);b=c-a.height;j-=b;h-=b;a.height>a.min&&o.push(a)}};a();0<j&&(o=g.filter(b,function(a){return a.height>a.min}),a());j=h-f;0<j?e.css("overflow-y","auto"):e.css("overflow-y","hidden");c=f-h;if(0<c)for(g.each(b,function(a){(!a.max||a.height<a.max)&&(a.height<a.pref||
a.widget.willFill())&&k.push(a)});0<c&&0<k.length;)l=Math.ceil(c/k.length),a=g.first(k),k=g.rest(k,1),i=a.height,a.height=a.max?Math.min(a.height+l,a.max):a.height+l,c-=a.height-i,(!a.max||a.height<a.max)&&(a.height<a.pref||a.widget.willFill())&&k.push(a);g.each(b,function(a){a.widget.setHeight(a.height)})}}});
define("web-viewer/layout/desktop/SidePanel",["web-viewer/layout/desktop/Panel","web-viewer/layout/component/MiniButton","web-viewer/layout/LayoutUtils","underscore"],function(g,e,d,c){var f=function(b,a,h,d){g.call(this,b,a,h);this.toggleButton=new e(this.f,"toggleHide"+a,"west"==a?"icon-WCR_Panel-Left":"icon-WCR_Panel-Right",!1,c.bind(function(){this.toggle()},this));this.toggleButton.setTooltip("viewer","west"==a?"LayoutToggleLeftSidebar":"LayoutToggleRightSidebar");this.toggleButton.element.addClass("panelToggleButton");
this.inner=d;this._autoCollapsed=!1};f.prototype=Object.create(g.prototype);f.prototype.constructor=f;f.prototype.setAutoCollapsed=function(b){this._autoCollapsed=b;this._updateVisibility()};f.prototype.isAutoCollapsed=function(){return this._autoCollapsed};f.prototype.isVisible=function(){return g.prototype.isVisible.call(this)&&!this._autoCollapsed};f.prototype._updateVisibility=function(){g.prototype._updateVisibility.call(this);var b=this.inner.find(".widgetWrapper");c.each(b,function(a){a=a.wrapper;
this.isVisible()?a.widget.isEnabled()&&a.widget.setVisible(!0):a.widget.setVisible(!1)},this);this.isDisabled()?this.toggleButton.element.hide():this.toggleButton.element.show()};f.prototype.invalidate=function(){this.isVisible()&&d.layoutWidgets(this.inner,4)};f.prototype.getState=function(){var b=g.prototype.getState.call(this);b.width=this.width;return b};f.prototype.restoreState=function(b){g.prototype.restoreState.call(this,b);this.setWidth(b.width)};f.prototype.getWidthWhenNotAutoCollapsed=
function(){return!this.isDisabled()&&this.getVisibility()?this.getWidthWhenVisible():0};f.prototype.setHeight=function(b){g.prototype.setHeight.call(this,b);this.inner.css("height",b)};return f});
define("web-viewer/layout/LayoutMode",["web-viewer/layout/LayoutConstants"],function(g){var e=function(d,c,f){this.f=d;this._name=f;this._isActive=!1;this._layout=c;this._isModePanelExpanded=!0};e.prototype.getName=function(){return this._name};e.prototype.toggle=function(){};e.prototype.isItemAllowed=function(){};e.prototype.isPersisted=function(){};e.prototype.isActive=function(){return this._isActive};e.prototype.isModePanelEnabled=function(){return!1};e.prototype.isModePanelExpanded=function(){return this._isModePanelExpanded};
e.prototype.showModePanelWidgetTitles=function(){return!0};e.prototype.setIsmodePanelExpanded=function(d){this._isModePanelExpanded=d};e.prototype.getModePanelContent=function(){return[]};e.prototype.getMainPanelContent=function(){return g.Widget.VIEWPORT};return e});
define("web-viewer/layout/desktop/BasicMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.BASIC)};d.prototype=new e;d.prototype.constructor=d;d.prototype.toggle=function(c){void 0===c&&(c=!this._isActive);this._isActive=c};d.prototype.isItemAllowed=function(){return!0};d.prototype.isPersisted=function(){return!0};return d});
define("web-viewer/layout/desktop/RestrictedMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.RESTRICTED)};d.prototype=new e;d.prototype.constructor=d;d.prototype.toggle=function(c){void 0===c&&(c=!this._isActive);this._isActive=c};d.prototype.isItemAllowed=function(c){return c===g.Widget.CHANNELS||c===g.Widget.CAD||c===g.Widget.VIEWCONTROLS?!1:!0};d.prototype.isPersisted=function(){return!0};return d});
define("web-viewer/layout/desktop/WizardMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode","underscore"],function(g,e,d){var c=function(c,b){e.call(this,c,b,g.LayoutMode.WIZARD);this._hiddenModalWidgets=[];this._wasToolbarComponentVisible=d.invert(d.values(g.ToolbarComponent));this._openPopups=[]};c.prototype=new e;c.prototype.constructor=c;c.prototype.toggle=function(c){(this._isActive=c=void 0===c?!this._isActive:c)?(this._layout.disablePanelInteraction(),this._layout.disablePanel("east"),
this._layout.disablePanel("west"),this._layout.showItem(g.Widget.ALIGNWIZARD),this._hiddenModalWidgets=this._layout.hideAllModalWidgets(),this._openPopups=this._layout.getAllVisiblePopups(),this._openPopups.hide(),d.each(this._wasToolbarComponentVisible,function(b,a){this._wasToolbarComponentVisible[a]=this._layout.isItemVisible(a);this._wasToolbarComponentVisible[a]&&a!==g.ToolbarComponent.NAVIGATE&&this._layout.hideItem(a)},this)):(this._layout.initializePanelInteraction(),this._layout.enablePanel("east"),
this._layout.enablePanel("west"),this._openPopups.show(),this._openPopups=[],this._layout.hideItem(g.Widget.ALIGNWIZARD),d.each(this._wasToolbarComponentVisible,function(b,a){b&&this._layout.showItem(a)},this),d.each(this._hiddenModalWidgets,function(b){this._layout.showItem(b)},this))};c.prototype.isItemAllowed=function(c){return c===g.Widget.ALIGNWIZARD};c.prototype.isPersisted=function(){return!1};return c});
define("web-viewer/layout/desktop/DesktopLayout","web-viewer/layout/Layout web-viewer/layout/DraggableWidgets web-viewer/layout/WidgetWrapper web-viewer/layout/LayoutConstants web-viewer/layout/desktop/Panel web-viewer/layout/desktop/SidePanel web-viewer/layout/desktop/BasicMode web-viewer/layout/desktop/RestrictedMode web-viewer/layout/desktop/WizardMode web-viewer/core/PrivateChannel web-viewer/utils/ShapeUtils web-viewer/utils/ListenerUtil underscore jquery".split(" "),function(g,e,d,c,f,b,a,h,
o,k,l,i,j,n){var m=function(c,d,e,l,m){g.call(this,c,d,e);i.mixin(this,c);k.installTo(this,c,"layout.desktop");this._defaultLayout={};this._layoutState=l;this._sectionMapping={};this._layoutModel=d;this._items={};this._loadingIndicator=m;this._mainContent=null;this._layoutModel.registerLayoutMode(new h(this.f,this));this._layoutModel.registerLayoutMode(new a(this.f,this));this._layoutModel.registerLayoutMode(new o(this.f,this));this._cssLoaded=!1;this._switchLayoutMode();this._wrapper=n("<div/>").addClass("wrapper disableTextSelection");
this._north=n("<div/>").addClass("northPane");this._mainWrapper=n("<div/>");this._topbar=n("<div/>").addClass("topbar");this._messagebar=n("<div />").addClass("messagebar");this._west=n("<div/>").addClass("westPane");this._innerWest=n("<div/>").addClass("accordeon").addClass("inner");this._center=n("<div/>").addClass("centerPane");this._east=n("<div/>").addClass("eastPane");this._innerEast=n("<div/>").addClass("accordeon").addClass("inner");this._aboveCenter=n("<div/>").addClass("aboveCenter");this._west.append(this._innerWest);
this._east.append(this._innerEast);this._mainWrapper.append(this._west).append(this._aboveCenter).append(this._center).append(this._east);this._wrapper.append(this._topbar).append(this._north).append(this._messagebar).append(this._mainWrapper).append(this._loadingIndicator.element);this._layout={width:0,height:0,top:new f(c,"topbar",this._topbar),north:new f(c,"north",this._north),east:new b(c,"east",this._east,this._innerEast),west:new b(c,"west",this._west,this._innerWest),center:new f(c,"center",
this._center)};this._layout.east.setWidth(300);this._layout.west.setWidth(300);this._enforceRestrictedMode();this._sections={"default":this._innerWest,west:this._innerWest,north:this._north,east:this._innerEast,center:this._mainWrapper};this._debouncedInvalidate=j.debounce(j.bind(this._invalidateLayout,this),200);this._deferredInvalidate=function(){j.defer(j.bind(this._invalidateLayout,this))};this._debouncedPanelInvalidate=j.debounce(j.bind(function(){this._layout.east.invalidate();this._layout.west.invalidate();
this._emitLayoutChanged()},this),100);this.f.emit("layout.loadCSS","web-viewer/layout/desktop/css/desktop.css",j.bind(function(){this._cssLoaded=!0;this._context.empty().append(this._wrapper);this._deferredInvalidate()},this));n(window).resize(j.bind(function(a){a.target===window&&this._debouncedInvalidate()},this));n(window).resize(j.debounce(j.bind(function(a){a.target===window&&this._constrainAllModalWidgets()},this),500));this._initializeDefaultLayout();this._initializeSectionMapping(this._layoutState);
this._initializeDragging();this._initializePanels();this.initializePanelInteraction();this._registerOnLayoutEvents();e.scroll(function(){n(this).scrollTop(0)});this._invalidateLayout()};m.prototype=Object.create(g.prototype);m.prototype.constructor=m;m.prototype._initializeDefaultLayout=function(){this._defaultLayout={north:[],east:[],center:[],west:[]};this._defaultLayout.north=[c.ToolbarComponent.PAGELIST,c.ToolbarComponent.NAVIGATE,c.ToolbarComponent.MEASURE,c.ToolbarComponent.COMPARE,c.ToolbarComponent.ANNOTATION,
c.ToolbarComponent.VIEW3D,c.ToolbarComponent.APPROVAL];this._defaultLayout.east=[c.Widget.NAVIGATOR,c.Widget.VIEW3D,c.Widget.VIEWCONTROLS,c.Widget.CHANNELS,c.Widget.CAD,c.Widget.DEBUG,c.Widget.APPROVAL,c.Widget.INFO,c.Widget.HELP];this._defaultLayout.west=[c.Widget.COMPARE,c.Widget.ATTRIBUTE_CATEGORY,c.Widget.ANNOTATION,c.Widget.PAGELIST]};m.prototype._initializeSectionMapping=function(a){void 0!==a&&(""!==a&&a!={})&&j.each(a,function(a,b){j.each(a.items,function(a){this._sectionMapping[a.name]=b},
this)},this);j.each(this._defaultLayout,function(a,b){j.each(a,function(a){void 0===this._sectionMapping[a]&&(this._sectionMapping[a]=b)},this)},this)};m.prototype._registerOnLayoutEvents=function(){this.f.on("layout.disableTextSelection",j.bind(function(){this._disableTextSelection()},this));this.f.on("layout.enableTextSelection",j.bind(function(){this._enableTextSelection()},this));this.f.on("layout.resetToDefault",j.bind(this.resetToDefault,this))};m.prototype._initializeDragging=function(){this._draggableWidgets=
new e(this._wrapper);this._draggableWidgets.addModalWidgetDropzone(this._center,"center",this);this._draggableWidgets.addSortableWidgetDropzone(this._innerWest,"west",this);this._draggableWidgets.addSortableWidgetDropzone(this._innerEast,"east",this)};m.prototype.initializePanelInteraction=function(){var a,b,c,h=1,d=j.bind(function(a,b){return this._layout.west.isVisible()&&7>Math.abs(a-this._layout.west.getWidth())&&b>=this._layout.west.position().top},this),f=j.bind(function(a,b){return this._layout.east.isVisible()&&
7>Math.abs(a-this._layout.west.getWidth()-this._layout.center.getWidth())&&b>=this._layout.east.position().top},this);this._registerListener("mousedown",function(e){d(e.clientX,e.clientY)?(a=this._layout.west,h=1):f(e.clientX,e.clientY)&&(a=this._layout.east,h=-1);a&&(b=e.clientX,c=a.getWidth()+this._layout.center.getWidth()-50,this.f.emit("layout.disableTextSelection"))},this,this._wrapper);this._registerListener("mousemove",function(e){void 0!==a||d(e.clientX,e.clientY)||f(e.clientX,e.clientY)?
this._wrapper.toggleClass("panelResize",!0):this._wrapper.toggleClass("panelResize",!1);if(void 0!==a){var k=h*(e.clientX-b),k=a.getWidth()+k;100<k&&k<c&&(b=e.clientX,a.setWidth(k),this._layout.center.setWidth(this._layout.width-this._layout.east.outerWidth(!0)-this._layout.west.outerWidth(!0)));30>k&&(a.hide(),a.setWidth(300),a=void 0,this.f.emit("layout.enableTextSelection"),this._deferredInvalidate())}},this,this._wrapper);this._registerListener("mouseout",function(b){this._wrapper.toggleClass("panelResize",
!1);a&&b.target==this._wrapper[0]&&(a=void 0,this.f.emit("layout.enableTextSelection"),this._deferredInvalidate())},this,this._wrapper);this._registerListener("mouseup",function(){a&&(this.f.emit("layout.enableTextSelection"),a=void 0,this._deferredInvalidate())},this,this._wrapper)};m.prototype.disablePanelInteraction=function(){this._unregisterAllListenersForObject(this._wrapper)};m.prototype._initializePanels=function(){this._layoutState&&j.each(this._layoutState,function(a,b){void 0!==this._layout[b]&&
this._layout[b].restoreState(a)},this);this._registerListener("changed.visibility",this._deferredInvalidate,this,this._layout.west);this._registerListener("changed.visibility",this._deferredInvalidate,this,this._layout.east);this._toggleButtonWest=this._layout.west.toggleButton.element;this._toggleButtonEast=this._layout.east.toggleButton.element;this._wrapper.append(this._toggleButtonWest);this._wrapper.append(this._toggleButtonEast)};g.prototype._getDefaultLayoutMode=function(){return this.f.getProperty("viewerStyle")==
c.ViewerStyle.RESTRICTED?this._layoutModel.getLayoutMode(c.LayoutMode.RESTRICTED):this._layoutModel.getLayoutMode(c.LayoutMode.BASIC)};m.prototype._addItem=function(a){if(a.type===c.LayoutItemType.WIDGET){var b=a.getItem(this.getLayoutType());switch(b.getWidgetType()){case "topbar":b.setContext(this._topbar);break;case "maincontent":b.setContext(this._center);this._mainContent=b;break;case "messagebar":b.setContext(this._messagebar);break;case "wizard":b.setContext(this._aboveCenter);this._items[b.getID()]=
b;break;default:var h=new d(b,a.name,!0);this._draggableWidgets.enableDragging(h);this._items[a.name]=h;this._layout[this._sectionMapping[a.name]].isVisible()||h.widget.setVisible(!1);this._addLayoutItem(a.name);this._registerListener("collapsed",function(){h.isModal?this._emitLayoutChanged():this._debouncedPanelInvalidate()},this,b);this._registerListener("modalResize",function(){h.isModal&&this._emitLayoutChanged()},this,b);this._registerListener("dragged",function(){h.isModal&&this._emitLayoutChanged()},
this,b);this._registerListener("enabled",function(b){this._toggleWidget(a.name,h,b);this._debouncedPanelInvalidate()},this,b);this._registerListener("resized",this._debouncedPanelInvalidate,this,b);this._registerListener("makeVisible",j.bind(this._makeWidgetVisible,this,a.name,h),void 0,b);b.didRequestMakeVisible()&&this._makeWidgetVisible(a.name,h)}}else a.type===c.LayoutItemType.TOOLBARCOMPONENT&&(b=a.getItem(this.getLayoutType()),b.element[0].name=a.name,this._items[a.name]=b,this._addLayoutItem(a.name),
this._registerListener("changed.visibility",function(){this._invalidateNorthPane();this._debouncedInvalidate()},this,b),this._invalidateNorthPane())};m.prototype._addLayoutItem=function(a){var b=this._sectionMapping[a];if(void 0!==b){var c=null,h=null;this._layoutState?(c=j.map(this._layoutState[b].items,function(a){return a.name}),h=j.find(this._layoutState[b].items,function(b){return b.name===a})):c=this._defaultLayout[b];if(null!==c&&void 0!==c){var d=j.indexOf(c,a),f=null;if(-1===d){d=j.indexOf(this._defaultLayout[b],
a);for(f=this._items[this._defaultLayout[b][++d]];d<this._defaultLayout[b].length&&void 0===f;)f=this._items[this._defaultLayout[b][++d]]}else for(f=this._items[c[++d]];d<c.length&&void 0===f;)f=this._items[c[++d]];void 0===f?this._appendItemToSection(a,b):this._prependItemBeforeItem(f.name,a,b);null!==h&&void 0!==h&&(this._setCollapsed(a,h.isCollapsed),(void 0!==h.width||void 0!==h.height)&&this._setSize(a,new l.Size(h.width,h.height)),(void 0!==h.left||void 0!==h.top)&&this._setLocation(a,new l.Point(h.left,
h.top)))}}};m.prototype._appendItemToSection=function(a,b){var c=this._items[a];c.widget&&c.widget.movingStarted();this._sections[b].append(c.element);c.widget&&c.widget.movingStopped()};m.prototype._prependItemBeforeItem=function(a,b){var c=this._items[b];c.widget&&c.widget.movingStarted();this._items[a].element.before(c.element);c.widget&&c.widget.movingStopped()};m.prototype.moveItem=function(a,b,c,h,d){a!==c&&(h&&(this._setLocation(a,null),this._setSize(a,null)),d&&this._setCollapsed(a,!1),this._detachItem(a,
this._sectionMapping[a]),this._sectionMapping[a]=b,void 0===c||this._sectionMapping[c]!==b?this._appendItemToSection(a,b):this._prependItemBeforeItem(c,a,b))};m.prototype._setLocation=function(a,b){var c=this._items[a];void 0!==c&&c.widget&&(null===b||void 0===b?c.setModal(!1):this._constrainModalWidgetWrapper(c,b))};m.prototype._constrainModalWidgetWrapper=function(a,b){var c=a.getOuterSize();b.x>this._context.innerWidth()-c.width&&(b.x=this._context.innerWidth()-c.width);b.y>this._context.innerHeight()-
c.height&&(b.y=this._context.innerHeight()-c.height);a.setModal(!0,b.y,b.x)};m.prototype._constrainAllModalWidgets=function(){j.each(this._items,function(a){if(a.isModal){var b=this._items[a.name];void 0!==b&&b.widget&&this._constrainModalWidgetWrapper(b,a.getLocation())}},this)};m.prototype._setCollapsed=function(a,b){var c=this._items[a];void 0!==c&&c.widget&&c.setCollapsed(b)};m.prototype.disablePanel=function(a){this._layout[a].setDisabled(!0)};m.prototype.enablePanel=function(a){this._layout[a].setDisabled(!1)};
m.prototype.isPanelVisible=function(a){return this._layout[a].isVisible()};m.prototype._setSize=function(a,b){var c=this._items[a];if(void 0!==c&&c.widget)if(null===b||void 0===b)c.setModal(!1);else{var h=c.getLocation();c.setModal(!0,h.y,h.x,b.width,b.height)}};m.prototype._detachItem=function(a){var b=this._items[a];b&&(b.widget&&b.widget.movingStarted(),this._items[a].element.detach(),b.widget&&b.widget.movingStopped(),j.defer(j.bind(function(){this._invalidateLayout()},this)))};m.prototype.hideItem=
function(a){a=this._items[a];void 0!==a&&void 0!==a.context?a.context.hide():void 0!==a&&void 0!==a.element&&a.element.hide()};m.prototype.showItem=function(a){a=this._items[a];void 0!==a&&void 0!==a.context?a.context.show():void 0!==a&&void 0!==a.element&&a.element.show()};m.prototype.isItemVisible=function(a){a=this._items[a];if(void 0!==a)return a.isVisible()};m.prototype.hideAllModalWidgets=function(){var a=[];j.each(this._items,function(b){b.isModal&&(a.push(b.name),this.hideItem(b.name))},this);
return a};m.prototype.getAllVisiblePopups=function(){return this._context.find(".popup:visible")};m.prototype._disableTextSelection=function(){this._context.find(".enableTextSelection").toggleClass("enableTextSelection",!1).toggleClass("enableTextSelectionTempDisabled",!0)};m.prototype._enableTextSelection=function(){this._context.find(".enableTextSelectionTempDisabled").toggleClass("enableTextSelection",!0).toggleClass("enableTextSelectionTempDisabled",!1)};m.prototype.restore=function(a){j.each(a,
j.bind(function(a,b){this._layout[b].restoreState(a);j.each(a.items,j.bind(function(a){void 0!==this._items[a.name]&&this._activeMode.isItemAllowed(a.name)&&(a.isCollapsed&&this._items[a.name].setCollapsed(a.isCollapsed),a.width&&a.height&&this._items[a.name].setSize(new l.Size(a.width,a.height)),a.left&&a.top&&this._items[a.name].setLocation(new l.Point(a.left,a.top)),this.moveItem(a.name,b))},this))},this))};m.prototype.resetToDefault=function(){j.each(this._defaultLayout,function(a,b){this._layout[b].setDisabled(!1);
this._layout[b].toggle(!0);if("west"===b||"east"===b)this._layout[b].setWidth(300),this._layout[b].show();j.each(a,function(a){void 0!==this._items[a]&&this._activeMode.isItemAllowed(a)&&this.moveItem(a,b,void 0,!0,!0)},this)},this);this._layoutState=void 0;this._enforceRestrictedMode();this._invalidateLayout()};m.prototype.getLayoutState=function(){var a={};j.each(this._sections,j.bind(function(b,c){void 0!==this._layout[c]&&(a[c]=this._layout[c].getState(),a[c].items=[],j.each(this._sections[c].children(),
j.bind(function(b){if(null!==b&&void 0!==b){var h=b.wrapper,d={};void 0===h?(d.name=b.name,d.isCollapsed=!n(b).is(":visible")):(d.name=h.name,d.isCollapsed=h.isCollapsed,b=h.getLocation(),null!==b&&h.isModal&&(d.left=b.x,d.top=b.y),b=h.getSize(),null!==b&&h.isModal&&(d.width=b.width,d.height=b.height));void 0!==d.name&&a[c].items.push(d)}},this)))},this));var b={};j.each(this._layoutState,function(a,c){b[c]=[];j.each(a.items,function(a){b[c].push(a.name)})});this._layoutState&&j.each(this._layoutState,
function(c,h){j.each(c.items,function(c){if(void 0===this._items[c.name]&&void 0!==this._layout[h]&&this._sectionMapping[c.name]){var d=b[this._sectionMapping[c.name]],f=j.indexOf(d,c.name);for(f++;f<d.length&&void 0===this._items[d[f]];)f++;f<d.length?(d=j.findWhere(a[h].items,{name:d[f]}),d=j.indexOf(a[h].items,d),a[h].items.splice(d,0,c)):a[h].items.push(c)}},this)},this);return this._layoutState=a};m.prototype._invalidateLayout=function(){this._layout.height=n(this._context).innerHeight();this._layout.width=
n(this._context).innerWidth();if(!(0===this._layout.width||0===this._layout.height||!this._cssLoaded)){this._wrapper.css({height:this._layout.height,width:this._layout.width});var a=this._layout.height,b=this._layout.west.el.get(0).getBoundingClientRect().width,b=b+parseFloat(getComputedStyle(this._layout.west.el.get(0)).borderRightWidth),b=Math.ceil(b),h=this._layout.east.el.get(0).getBoundingClientRect().width,h=h+parseFloat(getComputedStyle(this._layout.east.el.get(0)).borderLeftWidth),h=Math.ceil(h),
b=Math.floor(n(this._context).get(0).getBoundingClientRect().width)-b-h;if(45>b){if(!this._layout.west.isAutoCollapsed()||!this._layout.east.isAutoCollapsed()){this._layout.west.setAutoCollapsed(!0);this._layout.east.setAutoCollapsed(!0);this._invalidateLayout();this.f.loadBundle("viewer",function(){this.f.emit("userMessage","info",this.f.t("infoSidepanelsAutoCollapsed"),void 0,!1,"AUTOCOLLAPSE",!0)},this);return}}else if((this._layout.west.isAutoCollapsed()||this._layout.east.isAutoCollapsed())&&
45<this._layout.width-this._layout.west.getWidthWhenNotAutoCollapsed()-this._layout.east.getWidthWhenNotAutoCollapsed()){this._layout.west.setAutoCollapsed(!1);this._layout.east.setAutoCollapsed(!1);this.f.emit("userMessage.markObsolete","AUTOCOLLAPSE");this._invalidateLayout();return}this._invalidateNorthPane();a-=this._layout.top.outerHeight();a-=this._layout.north.outerHeight();this._aboveCenter.is(":visible")&&(a-=this._aboveCenter.outerHeight());this._layout.west.setHeight(a);this._layout.east.setHeight(a);
this._layout.center.setDim(b,a-1);a=this._layout.center.position();this._messagebar.css({width:this._layout.center.outerWidth()-36,top:n(this._context).position().top+this._layout.top.outerHeight()+this._layout.north.outerHeight()+18,left:a.left+18});this._loadingIndicator.element.css({top:a.top+5,left:a.left+this._layout.center.width-29});this._toggleButtonWest.css({left:3,top:a.top-16});this._toggleButtonEast.css({left:this._layout.width-21,top:a.top-16});this._layout.east.invalidate();this._layout.west.invalidate();
null!==this._mainContent&&this._mainContent.resized();j.each(this._items,function(a,b){this._layoutModel.getLayoutItemType(b)===c.LayoutItemType.WIDGET&&void 0!==a.widget?a.widget.resized():this._layoutModel.getLayoutItemType(b)===c.LayoutItemType.TOOLBARCOMPONENT&&a.moved()},this);this._emitLayoutChanged()}};m.prototype._invalidateNorthPane=function(){var a=0;this._layout.north.el.children().each(function(){n(this).is(":visible")&&(a+=n(this).outerWidth(!0)+2)});0===a&&(a=this._layout.north.outerWidth());
var b=this._layout.west.outerWidth(),c=this._layout.width-60;b+a>=c&&(b-=b+a-c);b=Math.max(b,30);this._layout.north.el.css("padding-left",b)};m.prototype.getLayoutType=function(){return c.LayoutType.DESKTOP};m.prototype._toggleWidget=function(a,b,c){c?this._activeMode.isItemAllowed(a)&&b.setVisible(!0):b.setVisible(!1)};m.prototype._enforceRestrictedMode=function(){this.f.getProperty("viewerStyle")==c.ViewerStyle.RESTRICTED&&(this._layout.east.toggle(!1),this._layout.west.toggle(!1))};m.prototype._makeWidgetVisible=
function(a,b){if(!b.isModal&&!this._layout[this._sectionMapping[a]].isVisible()){this.moveItem(b.getID(),"center");var c,h=350;c=Math.min(this._layout.center.width-20,450);var h=Math.min(this._layout.center.height-20,h),d=this._layout.center.position(),f=d.top+10,d=d.left+this._layout.center.width-10-c;b.setCollapsed(!1);b.setModal(!0,f,d,c,h)}b.widget.setMakeVisibleRequestAccepted();b.setCollapsed(!1)};return m});
define("web-viewer/layout/component/ToolbarButton",["web-viewer/layout/component/Tooltip","web-viewer/layout/component/Button","web-viewer/layout/component/Popover","jquery"],function(g,e,d,c){g=function(d,b,a,h,o){_.isString(a)&&(this.iconClass=a,a=c("<i/>").addClass("icon").addClass(a));e.call(this,d,b,a,h,o);this.icon=a;this.element.addClass("btn");this.subtoolbarComponents=[];this.subtoolbar=void 0;this.badgeText="";this._listeningToToolOptionValue=void 0};g.prototype=Object.create(e.prototype);
g.prototype.constructor=g;g.prototype.addSubtoolbarComponent=function(c){this.subtoolbarComponents.push(c);this.subtoolbar||(this.subtoolbar=new d(this.element,this.f.getContext(),this.f.getContext(),"bottom","#bbbbbb","subtoolbar"));this.subtoolbar.appendContent(c.element)};g.prototype.detachSubtoolbarComponent=function(c){this.subtoolbarComponents=_.without(this.subtoolbarComponents,c);c.element.detach()};g.prototype.setIcon=function(c){this.icon.removeClass();this.iconClass=c;this.icon.addClass("icon").addClass(c)};
g.prototype.listenToTool=function(c,b){var a=_.bind(function(a){a||this.setActive(!0)},this),h=_.bind(function(a){a||this.setActive(!1)},this);if(c){var d=_.bind(function(){this.isActive()?b&&this.f.emit("toolManager.deactivateTool",c):this.f.emit("toolManager.activateTool",c)},this);this.action?(this.origaction=this.action,this.action=_.bind(function(){this.origaction();d()},this)):this.action=d;c.on("activated",a);c.on("deactivated",h);this.f.emit("toolManager.activeTool",function(b){b&&b===c?a():
h()})}else c.off("activated",a),c.off("deactivated",h)};g.prototype.listenToToolOption=function(c,b,a){this._listeningToToolOptionValue=a;var h=_.bind(function(a,b){this.setActive(b==this._listeningToToolOptionValue)},this);if(c&&b&&void 0!==typeof a)this.f.getCurrentUser().on(["options","changed",b],h);else this.f.getCurrentUser().off(["options","changed",b],h);this.setActive(this.f.getOption(b)==this._listeningToToolOptionValue)};g.prototype.setActive=function(c){this.isEnabled()&&(c?this.isActive()||
(this.element.addClass("active"),this.subtoolbar&&this.subtoolbar.show()):this.isActive()&&(this.element.removeClass("active"),this.subtoolbar&&this.subtoolbar.hide()))};g.prototype.moved=function(){void 0!==this.subtoolbar&&this.isActive()&&this.subtoolbar.show()};g.prototype.show=function(){this.element.css("display","inline-block")};g.prototype.setBadge=function(d,b){(this.badgeText=d)?(this.badge||(this.badge=c("<span />"),this.icon.append(this.badge)),this.badge.removeClass().addClass("badge"),
b&&this.badge.addClass(b),this.badge.text(this.badgeText),this.badge.show()):this.badge&&this.badge.hide()};return g});
define("web-viewer/layout/mobile/ModeBar",["web-viewer/layout/LayoutConstants","web-viewer/core/PrivateChannel","web-viewer/layout/component/ToolbarButton","underscore","jquery"],function(g,e,d,c,f){d=function(b,a,h){this.f=b;e.installTo(this,b,"layout.mobile.modebar");this.element=a;this.element.addClass("modeBar");this._mobileLayout=h;this._visible=!0;this._availableModes={};this.switchMode(g.LayoutMode.MOBILE_VIEW);this.renderModeBar();this.f.on("layout.modeAvailabilityChanged",c.bind(function(a,
b,c){b?this._registerMode(a,c.icon,c.title):this._unregisterMode(a.getName())},this));h.on("changed.layoutMode",c.bind(this.renderModeBar,this));this.f.loadBundle("viewer",this.renderModeBar,this)};d.prototype.toggle=function(){this.setVisible(!this.isVisible())};d.prototype.setVisible=function(b){var a=this._visible;this._visible=b;a!==b&&this._emit("visible",b)};d.prototype.isVisible=function(){return this._visible};d.prototype.getWidth=function(){return this.isVisible()?this.element.outerWidth(!0):
0};d.prototype.getState=function(){return{visible:this.isVisible()}};d.prototype.setState=function(b){this.setVisible(b.visible)};d.prototype._registerMode=function(b,a,c){this._availableModes[b.getName()]={mode:b,icon:a,title:c};this.renderModeBar()};d.prototype._unregisterMode=function(b){this._availableModes[b]&&delete this._availableModes[b];this.renderModeBar()};d.prototype.renderModeBar=function(){this.element.html("");c.each(g.MobileLayoutModeBarOrder,c.bind(function(b){if(b=this._availableModes[b]){var a=
f("<div>").addClass("mode");b.mode.isActive()&&a.addClass("active");a.append(f("<i>").addClass(b.icon).addClass("icon-large"));a.append(f("<span>").html(this.f.i18n.t(b.title)));a.on("touchstart pointerdown",c.bind(function(a){this.switchMode(a)},this,b.mode.getName()));this.element.append(a)}},this))};d.prototype.switchMode=function(b){this.f.emit("layout.switchLayoutMode",b);this.renderModeBar()};return d});
define("web-viewer/utils/ConversionConstants",{MM_TO_INCH:25.4,MM_TO_CM:10,DEFAULT_POSTSCRIPT_PPI:72,DEFAULT_SCREEN_PPI:96,FIXED_BARCODE_DPMM:300/25.4,POINTS_TO_MM_RATIO:25.4/72,MM_TO_POINT_RATIO:72/25.4,PX_TO_MM_RATIO:25.4/96,MM_TO_PX_RATIO:96/25.4});define("web-viewer/utils/GEOUtils",["underscore","web-viewer/utils/ShapeUtils","web-viewer/utils/ConversionConstants"],function(g,e,d){return{convertPSPointsToMM:function(c){return c*d.POINTS_TO_MM_RATIO},convertMMToPSPoints:function(c){return c*d.MM_TO_POINT_RATIO}}});
define("web-viewer/utils/ViewerUtils","web-viewer/utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/core/CoreConstants web-viewer/utils/ConversionConstants underscore jquery".split(" "),function(g,e,d,c,f){return{rgbToHex:function(b,a,c){return this.toHex(b)+this.toHex(a)+this.toHex(c)},toHex:function(b){b=parseInt(b,10);if(isNaN(b))return"00";b=Math.max(0,Math.min(b,255));return"0123456789ABCDEF".charAt((b-b%16)/16)+"0123456789ABCDEF".charAt(b%16)},hexFromInt:function(b){return this.rgbToHex(b>>
16&255,b>>8&255,b>>0&255)},intFromHex:function(b){b=this.rgbColor(b);return(b.r&255)<<16|(b.g&255)<<8|(b.b&255)<<0},rgbIntToBgrInt:function(b){var a=this.toHex(b>>16&255),c=this.toHex(b>>8&255),b=this.toHex(b>>0&255);return parseInt(b+c+a,16)},rgbColor:function(b){return(b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(b))?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null},trim:function(b){b=b.replace(/(^\s*)|(\s*$)/gi,"");b=b.replace(/[ ]{2,}/gi," ");return b=b.replace(/\n /,"\n")},
convertFromMmValue:function(b,a,h,f){var e=b;if(a==d.SizeUnits.INCH)e=b/c.MM_TO_INCH;else if(a==d.SizeUnits.CM)e=b/c.MM_TO_CM;else if(a==d.SizeUnits.PIXELS||a==d.SizeUnits.POINTS)e=isNaN(f)?b*c.MM_TO_POINT_RATIO:b*f;return void 0!==h?e.toFixed(h):e.toString()},convertToMmValue:function(b,a,h,f){var e=b;if(a==d.SizeUnits.INCH)e=b*c.MM_TO_INCH;else if(a==d.SizeUnits.CM)e=b*c.MM_TO_CM;else if(a==d.SizeUnits.PIXELS||a==d.SizeUnits.POINTS)e=isNaN(f)?b*c.POINTS_TO_MM_RATIO:b/f;return void 0!==h?e.toFixed(h):
e.toString()},convertFromInchToMm:function(b,a){return(b*c.MM_TO_INCH).toFixed(a)},convertResolutionFromPpmmValue:function(b,a,h){a===d.ResolutionUnits.PPMM?b*=1:a===d.ResolutionUnits.PPCM?b*=c.MM_TO_CM:a===d.ResolutionUnits.PPI&&(b*=c.MM_TO_INCH);return void 0!==h?b.toFixed(h):b.toString()},convertResolutionToPpmmValue:function(b,a,h){a===d.ResolutionUnits.PPMM?b/=1:a===d.ResolutionUnits.PPCM?b/=c.MM_TO_CM:a===d.ResolutionUnits.PPI&&(b/=c.MM_TO_INCH);return void 0!==h?b.toFixed(h):b.toString()},
closestAngle:function(b,a){var c=360*Math.round(b/360*a)/a;360<=c&&(c-=360);return c},pointAtLength:function(b,a,c){var d=a*Math.PI/180,a=c.x+b*Math.cos(d),b=c.y+b*Math.sin(d);return new g.Point(a,b)},startsWith:function(b,a){return 0===b.indexOf(a)},generateUniqueDOMId:function a(c){for(var d=Math.floor(1E4*Math.random()),d=c+d;document.getElementById(d);)return a(c);return d},dateFromString:function(a){var c=a.substring(2,6),d=a.substring(6,8),f=a.substring(8,10),e=a.substring(10,12),g=a.substring(12,
14),j=a.substring(14,16),n=a.substring(16,19),a=a.substring(20,22);return new Date(c+"-"+d+"-"+f+"T"+e+":"+g+":"+j+".000"+n+":"+a)},twoDigits:function(a){return 9<a?""+a:"0"+a},stringFromDate:function(a){var c=a.getTimezoneOffset(),d=0>=c?"+":"-",c=Math.abs(c),f=Math.floor(c/60),c=c-60*f,d=d+(this.twoDigits(f)+"'"+this.twoDigits(c)+"'");return"D:"+a.getUTCFullYear()+this.twoDigits(a.getUTCMonth()+1)+this.twoDigits(a.getUTCDate())+this.twoDigits(a.getHours())+this.twoDigits(a.getMinutes())+this.twoDigits(a.getUTCSeconds())+
d},randomString:function(a){for(var c="";0<a;--a)c+="0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"[Math.round(61*Math.random())];return c},rectToString:function(a){var c=e.convertMMToPSPoints(a.origin.x),d=e.convertMMToPSPoints(a.origin.y),f=e.convertMMToPSPoints(a.right()),a=e.convertMMToPSPoints(a.bottom());return c+","+d+","+f+","+a},parseFloat:function(a){if(f.isString(a)){if(a=a.trim())return+a.replace(/,/,".")}else if(f.isNumber(a))return a},parseFirstFloat:function(a){if(f.isString(a)){if(a=
a.trim())return parseFloat(a.replace(/,/,"."))}else if(f.isNumber(a))return a},isCloseTo:function(a,c,d){return Math.abs(c-a)<Math.pow(10,-d)/2}}});
define("web-viewer/layout/mobile/NavigationBar",["web-viewer/layout/component/ToolbarButton","web-viewer/layout/LayoutConstants","web-viewer/utils/ViewerUtils","underscore","jquery"],function(g,e,d,c,f){d=function(b,a,h){this.f=b;this._mobileLayout=h;this._components={};this.element=a;this.element.addClass("navigationBar");this._mobileLayout=h;this._left=f("<div>").addClass("navigationLeft").appendTo(this.element);this._right=f("<div>").addClass("navigationRight").appendTo(this.element);this._hamburger=
new g(this.f,"menu","icon-WCR_Hamburger",!0,c.bind(function(){this._mobileLayout.toggleModeBar()},this));this._hamburger.element.addClass("hamburgerButton");this._left.append(this._hamburger.element);b.getProperty("returnurl")&&(this._returnButton=new g(this.f,"exit","icon-WCR_Exit",!1,c.bind(function(){this.f.emit("viewer.request.close",b.getProperty("returnurl"))},this)),this._right.append(this._returnButton.element));h.supportsFullscreen()&&(this._fullscreenButton=new g(this.f,"fullscreen","icon-WCR_FullScreen",
!1,c.bind(function(){h.toggleFullscreen(!h.isFullscreen());this._updateFullscreenButton()},this)),f(window).on("resize",c.debounce(c.bind(this._updateFullscreenButton,this),100)),this._updateFullscreenButton(),this._right.prepend(this._fullscreenButton.element));this.f.requestModule("featureDetector",c.bind(function(a){if(!a.isMobile()||!a.hasTouch())this._switchLayoutModeButton=new g(this.f,"switchToDesktop","icon-WCR_Desktop",!1,c.bind(function(){this.f.switchLayout(e.LayoutType.DESKTOP)},this)),
this._right.prepend(this._switchLayoutModeButton.element)},this));this._mobileLayout.on("changed.layoutMode",c.bind(this._updateButtonVisibility,this))};d.prototype._updateFullscreenButton=function(){this._fullscreenButton.setIcon(this._mobileLayout.isFullscreen()?"icon-WCR_NormalScreen":"icon-WCR_FullScreen")};d.prototype._updateButtonVisibility=function(){var b=this._mobileLayout.getActiveLayoutMode();b&&b.getName()===e.LayoutMode.MOBILE_VIEW?this._fullscreenButton&&this._fullscreenButton.show():
this._fullscreenButton&&this._fullscreenButton.hide()};d.prototype.appendToolbarLeft=function(b){var a=f("<div />");this._left.append(a.append(b.element));this._components[b.name]=a};d.prototype.prependToolbarRight=function(b){var a=f("<div />");this._right.prepend(a.append(b.element));this._components[b.name]=a};d.prototype.toggleComponent=function(b,a){this._components[b]&&(a?this._components[b].show():this._components[b].hide())};return d});
define("web-viewer/layout/mobile/MobileViewMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.MOBILE_VIEW);this.setIsmodePanelExpanded(!1);this.f.emit("layout.modeAvailabilityChanged",this,!0,{icon:"icon-WCR_View",title:"ViewControlsTitle"})};d.prototype=new e;d.prototype.constructor=d;d.prototype.toggle=function(c){void 0===c&&(c=!this._isActive);this._isActive=c};d.prototype.isItemAllowed=function(c){return c===
g.Widget.VIEWPORT||(c===g.ToolbarComponent.DOCUMENTSELECTOR||c===g.ToolbarComponent.APPROVAL||c===g.Widget.MESSAGE)||(c===g.Widget.CHANNELS||c===g.Widget.CAD)&&this.f.getProperty("viewerStyle")!=g.ViewerStyle.RESTRICTED};d.prototype.isPersisted=function(){return!0};d.prototype.isModePanelEnabled=function(){return this.f.getProperty("viewerStyle")!=g.ViewerStyle.RESTRICTED};d.prototype.getModePanelContent=function(){return[g.Widget.CAD,g.Widget.CHANNELS]};return d});
define("web-viewer/layout/mobile/AnnotationViewMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.MOBILE_ANNOTATION);this.f.emit("layout.modeAvailabilityChanged",this,!0,{icon:"icon-WCR_Annotate",title:"AnnToolsTitle"})};d.prototype=new e;d.prototype.constructor=d;d.prototype.toggle=function(c){void 0===c&&(c=!this._isActive);this._isActive=c};d.prototype.isItemAllowed=function(c){return c===g.Widget.VIEWPORT||
c===g.Widget.ANNOTATION||c===g.ToolbarComponent.DOCUMENTSELECTOR||c===g.ToolbarComponent.APPROVAL||c===g.ToolbarComponent.ANNOTATION||c===g.Widget.MESSAGE};d.prototype.isPersisted=function(){return!1};d.prototype.isModePanelEnabled=function(){return!0};d.prototype.showModePanelWidgetTitles=function(){return!1};d.prototype.getModePanelContent=function(){return[g.Widget.ANNOTATION]};return d});
define("web-viewer/layout/mobile/MobileCompareMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.MOBILE_COMPARE);this._emitModeAvailability(!1);this.f.whenModuleAvailable("compare",function(b){var a=b.isCompareAvailable();this._emitModeAvailability(a);b.on("changed.mode",_.bind(function(a,c){c&&!b.isReaderSpreadActive()&&this.f.emit("layout.switchLayoutMode",g.LayoutMode.MOBILE_COMPARE)},this));if(!a)b.on("compareAvailable",
_.bind(function(){this._emitModeAvailability(!0)},this));_.defer(_.bind(function(){b.getActiveMode()&&!b.isReaderSpreadActive()&&this.f.emit("layout.switchLayoutMode",g.LayoutMode.MOBILE_COMPARE)},this))},this)};d.prototype=new e;d.prototype.constructor=d;d.prototype._emitModeAvailability=function(c){this.f.emit("layout.modeAvailabilityChanged",this,c,{icon:"icon-WCR_Compare",title:"CompareToolsTitle"})};d.prototype.toggle=function(c){void 0===c&&(c=!this._isActive);this._isActive=c;var d=this.f.getModule("compare");
c?d.getActiveMode()||d.activateLastUsedCompareMode():d.activateModeByName()};d.prototype.isItemAllowed=function(c){return c===g.Widget.VIEWPORT||c===g.Widget.COMPARE||c===g.ToolbarComponent.COMPARE||c===g.ToolbarComponent.APPROVAL||c===g.Widget.MESSAGE};d.prototype.isPersisted=function(){return!1};d.prototype.isModePanelEnabled=function(){return!0};d.prototype.showModePanelWidgetTitles=function(){return!0};d.prototype.getModePanelContent=function(){return[g.Widget.COMPARE]};return d});
define("web-viewer/layout/mobile/Mobile3DViewMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.MOBILE_3D);this._emitModeAvailability(!1);var b=_.bind(function(){this._emitModeAvailability(this.f.getActivePage().get("has3DPerspective"))},this);this.f.on("doc.activePageParametersChange",b);this.f.getActivePage()&&this.f.getActivePage().isParametersAvailable()&&b();this.f.whenModuleAvailable("view3D",function(a){this.f.off("doc.activePageParametersChange",
b);a.on("start3D",_.bind(function(){this._emitModeAvailability(!0);this.f.emit("layout.switchLayoutMode",g.LayoutMode.MOBILE_3D)},this));a.on("stop3D",_.bind(function(){this.isActive()&&a.has3DPerspective()&&a.show3D()},this));a.on("has3DPerspective",_.bind(function(a){this._emitModeAvailability(a)},this));this._emitModeAvailability(a.has3DPerspective())},this)};d.prototype=new e;d.prototype.constructor=d;d.prototype._emitModeAvailability=function(c){this.f.emit("layout.modeAvailabilityChanged",this,
c,{icon:"icon-WCR_3D-Create",title:"View3DBtnGroupTitle"});this.isActive()&&!c&&this.f.emit("layout.switchLayoutMode")};d.prototype.toggle=function(c){void 0===c&&(c=!this._isActive);(this._isActive=c)&&this.f.requestModule("view3D",_.bind(function(c){c.show3D()},this),!1)};d.prototype.isItemAllowed=function(c){return c===g.Widget.VIEWPORT||c===g.ToolbarComponent.DOCUMENTSELECTOR||c===g.ToolbarComponent.APPROVAL||c===g.Widget.MESSAGE||c===g.Widget.VIEW3D};d.prototype.isPersisted=function(){return!1};
d.prototype.isModePanelEnabled=function(){return!1};d.prototype.showModePanelWidgetTitles=function(){return!1};d.prototype.getModePanelContent=function(){return[]};d.prototype.getMainPanelContent=function(){return g.Widget.VIEW3D};return d});
define("web-viewer/layout/mobile/ModePanel","web-viewer/core/PrivateChannel web-viewer/layout/component/MiniButton web-viewer/layout/LayoutUtils web-viewer/utils/ShapeUtils jquery underscore".split(" "),function(g,e,d,c,f,b){c=function(a,c){g.installTo(this,a,["modePanel",c]);this.f=a;this.name=c;this.element=f("<div/>").addClass("modePanel");this._content=f("<div/>");this._contentMap={};this._activeContent=null;this.element.append(this._content);this._collapseButton=new e(a,"collapseButton","icon-WCR_Widget-Collapse",
!0,b.bind(function(){this._togglePanel()},this));this._collapseButtonElement=f("<div>").addClass("collapseButton").append(this._collapseButton.element);this.element.append(this._collapseButtonElement);this._expanded=!0;this._disabled=!1;this.invalidate=b.debounce(b.bind(this._invalidate,this),50)};c.prototype.setExpanded=function(a){this._expanded!==a&&this._togglePanel()};c.prototype._togglePanel=function(){var a=this.isVisible();this.element.toggleClass("collapsed");this._expanded=!this._expanded;
this._collapseButton.setIcon(this._expanded?"icon-WCR_Widget-Collapse":"icon-WCR_Widget-Expand");var b=this.isVisible();a!=b&&this._emit("changed.expanded",a,b)};c.prototype.isEnabled=function(){return!this._disabled};c.prototype.isVisible=function(){return this._expanded&&!this._disabled};c.prototype.getWidth=function(){return this.isVisible()?this.element.outerWidth(!0):0};c.prototype.getHeight=function(){return this.element.outerHeight(!0)};c.prototype.setEnabled=function(a){a?this.enable():this.disable()};
c.prototype.enable=function(){var a=this.isVisible();this.element.show();this._disabled=!1;var b=this.isVisible();a!=b&&this._emit("changed.expanded",a,b)};c.prototype.disable=function(){var a=this.isVisible();this.element.hide();this._disabled=!0;var b=this.isVisible();a!=b&&this._emit("changed.expanded",a,b)};c.prototype._invalidate=function(){this.isEnabled()&&d.layoutWidgets(this._content,0)};c.prototype.append=function(a){this._content.append(a)};return c});
define("web-viewer/layout/mobile/MobileReaderSpreadMode",["web-viewer/layout/LayoutConstants","web-viewer/layout/LayoutMode"],function(g,e){var d=function(c,d){e.call(this,c,d,g.LayoutMode.MOBILE_READERSPREAD);this.f.getDocumentController().whenActivePageChanged(function(b,a){this.f.emit("layout.modeAvailabilityChanged",this,a.getDocumentVersion().isMultiPage(),{icon:"icon-WCR_ReaderSpread",title:"ReaderSpreadModeTitle"})},this)};d.prototype=new e;d.prototype.constructor=d;d.prototype.toggle=function(c){void 0===
c&&(c=!this._isActive);this._isActive=c;this.f.requestModule("pagelist",_.bind(function(c){c.toggleReaderspread(this._isActive)},this))};d.prototype.isItemAllowed=function(c){return c===g.Widget.VIEWPORT||c===g.Widget.PAGELIST||c===g.Widget.MESSAGE||c===g.ToolbarComponent.PAGESELECTION||c===g.ToolbarComponent.APPROVAL};d.prototype.isPersisted=function(){return!0};d.prototype.isModePanelEnabled=function(){return!0};d.prototype.getModePanelContent=function(){return[g.Widget.PAGELIST]};return d});
define("web-viewer/layout/mobile/MobileLayout","web-viewer/layout/Layout web-viewer/layout/LayoutConstants web-viewer/layout/mobile/ModeBar web-viewer/layout/mobile/NavigationBar web-viewer/core/PrivateChannel web-viewer/utils/ListenerUtil web-viewer/layout/mobile/MobileViewMode web-viewer/layout/mobile/AnnotationViewMode web-viewer/layout/mobile/MobileCompareMode web-viewer/layout/mobile/Mobile3DViewMode web-viewer/layout/WidgetWrapper web-viewer/layout/mobile/ModePanel web-viewer/utils/ShapeUtils web-viewer/layout/mobile/MobileReaderSpreadMode underscore jquery".split(" "),
function(g,e,d,c,f,b,a,h,o,k,l,i,j,n,m,p){j=function(e,j,l,w,r){g.call(this,e,j,l);f.installTo(this,e,"layout.mobile");b.mixin(this,e);this._layoutState=w?w:this._getDefaultLayout();this._layoutModel=j;this._items={};this._loadingIndicator=r;this._mainContent=null;this._mainContentWidgetWrappers=[];this._centerContent=p("<div>").addClass("centerContent");this._modeBar=new d(this.f,p("<div>"),this);this._modeBar.setState(this._layoutState.modeBar);this._appContentWrapper=p("<div>").addClass("appContentWrapper");
this._messagebar=p("<div />").addClass("messagebar");this._navigationBar=new c(this.f,p("<div>"),this);this._modePanel=new i(e,"modePanel");p(l).bind("touchmove",m.bind(function(a){if(a.target===this._modeBar.element[0]||0<this._modeBar.element.find(a.target).length&&0===p(a.target).parentsUntil(this._modeBar.element,".btn,.interactive").length||a.target===this._navigationBar.element[0]||0<this._navigationBar.element.find(a.target).length&&0===p(a.target).parentsUntil(this._navigationBar.element,
".btn,.interactive,.mode").length)a.preventDefault(),a.stopPropagation()},this));this._appContentWrapper.append(this._navigationBar.element);this._centerContent.append(this._modePanel.element);this._appContentWrapper.append(this._centerContent);this._appContentWrapper.append(this._messagebar);this._loadingIndicator=r;this._activeMode=new a(this.f,this);this._activeMode.toggle(!0);this._layoutModel.registerLayoutMode(this._activeMode);this._layoutModel.registerLayoutMode(new h(this.f,this));this._layoutModel.registerLayoutMode(new n(this.f,
this));this._layoutModel.registerLayoutMode(new o(this.f,this));this._layoutModel.registerLayoutMode(new k(this.f,this));this._debouncedInvalidate=m.debounce(m.bind(this._invalidateLayout,this),200);this.f.emit("layout.loadCSS","web-viewer/layout/mobile/css/mobile.css",m.bind(function(){this._cssLoaded=!0;this._context.empty().append(this._modeBar.element).append(this._appContentWrapper).addClass("disableTextSelection").append(this._loadingIndicator.element);this._debouncedInvalidate()},this));p(window).resize(m.bind(function(a){a.target===
window&&this._debouncedInvalidate()},this));this._registerOnLayoutEvents();this._registerListener("visible",this._debouncedInvalidate,this,this._modeBar);this._registerListener("changed.visibility",this._invalidateLayout,this,this._modePanel);this._invalidateLayout();this._updateModePanel();this._modeBar.element.on("webkitAnimationEnd oanimationend msAnimationEnd animationend transitionend ",this._debouncedInvalidate);this._modePanel.element.on("webkitAnimationEnd oanimationend msAnimationEnd animationend transitionend ",
this._debouncedInvalidate);this._registerListener("changed.expanded",this._modePanelChanged,this,this._modePanel)};j.prototype=Object.create(g.prototype);j.prototype.constructor=j;j.prototype._registerOnLayoutEvents=function(){this.f.on("layout.disableTextSelection",m.bind(function(){this._disableTextSelection()},this));this.f.on("layout.enableTextSelection",m.bind(function(){this._enableTextSelection()},this));this.f.on("layout.resetToDefault",m.bind(this.resetToDefault,this));this.f.on("layout.switchLayoutMode",
m.bind(function(){this._updateModePanel();this._updateMainContent()},this))};j.prototype._addItem=function(a){if(a.type===e.LayoutItemType.WIDGET){var b=a.getItem(this.getLayoutType()),c=b.getWidgetType();if("messagebar"==c)b.setContext(this._messagebar);else{var d=new l(b,a.name,!1);this._items[a.name]=d;this._modePanel.element.find(".widgetWrapper:visible").removeClass("first").first().addClass("first");this._modePanel.invalidate();this._registerListener("enabled",function(b){this._toggleWidget(a.name,
d,b)},this,b);this._registerListener("resized",this._invalidateModePanel,this,b);if("maincontent"==c||a.name===this._activeMode.getMainPanelContent())d.setHeaderEnabled(!1),this._centerContent.append(d.element),this._mainContentWidgetWrappers.push(d),this._updateMainContent();else{for(var b=this._activeMode.getModePanelContent(),h,c=m.indexOf(b,a.name);c<b.length&&!h;)h=this._items[b[++c]];h?h.element.before(d.element):this._modePanel.append(d.element)}}}else if(a.type===e.LayoutItemType.TOOLBARCOMPONENT)switch(h=
a.getItem(this.getLayoutType()),this._items[a.name]=a,h.name){case e.ToolbarComponent.APPROVAL:case e.ToolbarComponent.ANNOTATION:this._navigationBar.prependToolbarRight(h);break;default:this._navigationBar.appendToolbarLeft(h)}};j.prototype._invalidateModePanel=function(){this._modePanel.invalidate()};j.prototype._updateItemVisibility=function(){m.each(this._items,m.bind(function(a){if(a.type===e.LayoutItemType.TOOLBARCOMPONENT){var b=a.getItem(this.getLayoutType());this._navigationBar.toggleComponent(b.name,
this._activeMode.isItemAllowed(a.name))}else a.type===e.LayoutItemType.WIDGET&&(b=a.getItem(this.getLayoutType()),b.setVisible(this._activeMode.isItemAllowed(a.name)&&b.widget.isVisible()))},this))};j.prototype._disableTextSelection=function(){this._context.find(".enableTextSelection").toggleClass("enableTextSelection",!1).toggleClass("enableTextSelectionTempDisabled",!0)};j.prototype._enableTextSelection=function(){this._context.find(".enableTextSelectionTempDisabled").toggleClass("enableTextSelection",
!0).toggleClass("enableTextSelectionTempDisabled",!1)};j.prototype.restore=function(a){this._modeBar.setState(a)};j.prototype.resetToDefault=function(){this._layoutState=this._getDefaultLayout();this._modeBar.setState(this._layoutState.modeBar);this._invalidateLayout()};j.prototype._getDefaultLayout=function(){return{modeBar:{visible:!0}}};j.prototype.getLayoutState=function(){return{modeBar:this._modeBar.getState()}};j.prototype.toggleModeBar=function(){this._modeBar.toggle()};j.prototype._invalidateLayout=
function(){if(this._cssLoaded){this._context.toggleClass("hideModeBar",!this._modeBar.isVisible());this._modePanel.element.css("height",this._context.innerHeight()-this._navigationBar.element.outerHeight(!0));var a=this._modePanel.getWidth();this._activeMainPanelContent&&(this._activeMainPanelContent.content.css({height:this._context.innerHeight()-this._navigationBar.element.outerHeight(!0),width:this._context.innerWidth()-this._modeBar.getWidth()-a}),null!==this._activeMainPanelContent.widget&&this._activeMainPanelContent.widget.resized());
a=this._navigationBar.element.outerHeight(!0);this._loadingIndicator.element.css({top:a+5,left:this._context.innerWidth()-29});var b=this._appContentWrapper.position();this._messagebar.css({width:this._appContentWrapper.outerWidth()-20,top:b.top+a+10,left:b.left+10});this._modePanel.invalidate();this._emitLayoutChanged()}};j.prototype.getLayoutType=function(){return e.LayoutType.MOBILE};j.prototype.toggleFullscreen=function(a){a?this._requestFullscreen():this._exitFullscreen()};j.prototype.isFullscreen=
function(){return document.fullscreenElement||document.mozFullScreenElement||document.webkitFullscreenElement||document.msFullscreenElement};j.prototype.supportsFullscreen=function(){var a=this.f.getContext().get(0);return a.requestFullscreen||a.mozRequestFullScreen||a.webkitRequestFullscreen||a.msRequestFullscreen};j.prototype._requestFullscreen=function(){var a=this.f.getContext().get(0);a.requestFullscreen?a.requestFullscreen():a.mozRequestFullScreen?a.mozRequestFullScreen():a.webkitRequestFullscreen?
a.webkitRequestFullscreen():a.msRequestFullscreen&&a.msRequestFullscreen()};j.prototype._exitFullscreen=function(){document.exitFullscreen?document.exitFullscreen():document.msExitFullscreen?document.msExitFullscreen():document.mozCancelFullScreen?document.mozCancelFullScreen():document.webkitExitFullscreen&&document.webkitExitFullscreen()};j.prototype._updateModePanel=function(){this._modePanel.setEnabled(this._activeMode.isModePanelEnabled());this._modePanel.element.find(".widgetWrapper").each(function(a,
b){b.wrapper.setVisible(!1)});var a=this._activeMode.getModePanelContent(),b=!0;m.each(a,function(a){if(this._items[a]){a=this._items[a];this._modePanel.append(a.element);var c=a.widget.isVisible()&&a.widget.isEnabled();a.setVisible(c);c&&(a.element.toggleClass("first",b),b=!1)}},this);this._modePanel.element.toggleClass("hideWidgetTitles",!this._activeMode.showModePanelWidgetTitles());this._modePanel.invalidate();this._modePanel.setExpanded(this._activeMode.isModePanelExpanded())};j.prototype._updateMainContent=
function(){var a=this._activeMode.getMainPanelContent();this._activeMainPanelContent=null;m.each(this._mainContentWidgetWrappers,function(b){b.widget.getID()===a?(b.setVisible(!0),this._activeMainPanelContent=b):b.setVisible(!1)},this);!this._activeMainPanelContent&&this._items[a]?(this._mainContentWidgetWrappers.push(this._items[a]),this._centerContent.append(this._items[a].element),this._updateMainContent()):this._debouncedInvalidate()};j.prototype._modePanelChanged=function(a,b){this._activeMode.setIsmodePanelExpanded(b);
this._debouncedInvalidate()};j.prototype._toggleWidget=function(a,b,c){c?this._activeMode.isItemAllowed(a)&&b.setVisible(!0):b.setVisible(!1)};j.prototype._getDefaultLayoutMode=function(){return this._layoutModel.getLayoutMode(e.LayoutMode.MOBILE_VIEW)};return j});
define("utils/DomUtils",[],function(){return{loadCss:function(g,e){this.loadCssFromUrl(requirejs.toUrl(g),e)},loadCssFromUrl:function(g,e){var d=null,c=null,f=document.createElement("link");f.setAttribute("rel","stylesheet");f.setAttribute("type","text/css");c=function(){for(var b=0;b<document.styleSheets.length;b++)if(d=document.styleSheets[b].href,null!==d&&d.substr(d.length-g.length)==g){e&&(e(),e=null);return}setTimeout(c,50)};document.all?f.attachEvent("onreadystatechange",function(){if(("complete"==
f.readyState||"loaded"==f.readyState)&&e)e(),e=null}):setTimeout(c,50);f.setAttribute("href",g);document.getElementsByTagName("head")[0].appendChild(f)}}});
define("web-viewer/layout/LayoutManager","domReady! web-viewer/utils/ListenerUtil web-viewer/layout/LayoutModel web-viewer/layout/desktop/DesktopLayout web-viewer/layout/mobile/MobileLayout web-viewer/layout/LayoutConstants utils/DomUtils underscore jquery".split(" "),function(g,e,d,c,f,b,a,h,o){g=function(a,g,o){e.mixin(this,a);this.f=a;this._layoutModel=new d(this.f);this._registerListener("layout.loadCSS",this.loadCSS,this);this._layout=null;this._layoutType=this.f.getLayoutType();a=this._getLayoutStatePreference();
this._layout=this._layoutType===b.LayoutType.MOBILE?new f(this.f,this._layoutModel,g,a.layout[b.LayoutType.MOBILE],o):new c(this.f,this._layoutModel,g,a.layout[b.LayoutType.DESKTOP],o);this._registerListener("layout.addWidget",function(a,b){this._layoutModel.hasItem(a)||this._layoutModel.addWidget(a,b)},this,this.f);this._registerListener("layout.addToolbarComponent",function(a,b){this._layoutModel.hasItem(a)||this._layoutModel.addToolbarComponent(a,b)},this,this.f);this._registerListener("layout.changed",
this._persistLayout,this,this._layout);this._registerListener("layout.resetToDefault",h.partial(this._persistLayout,!0),this,this.f)};g.prototype.loadCSS=function(b,c){a.loadCss(b,c)};g.prototype._persistLayout=h.debounce(function(a){if(this._layout.isLayoutStatePersisted()){var b=this._getLayoutStatePreference();b.layout[this._layoutType]=a?void 0:this._layout.getLayoutState();this.f.setOption("LAYOUT_STATE",JSON.stringify(b))}},100);g.prototype._getLayoutStatePreference=function(){var a=this.f.getOption("LAYOUT_STATE");
if(void 0!==a&&""!==a)try{if(a=o.parseJSON(a),!a.layout){var c=a,a={layout:{}};a.layout[b.LayoutType.DESKTOP]=c}}catch(d){this.f.emit("error.SEVERE","Could not restore layout configuration",d),a={layout:{}}}else a={layout:{}};return a};g.prototype.switchLayout=function(a){if(this._layoutType!=a){var b=o("<div/>").show().addClass("modalOverlay").text(this.f.t("Loading"));this.f.getContext().append(b);this.f.setOptionCallback("LAYOUT_PREFERENCE",a,h.bind(function(a){a&&this.f.emit("viewer.request.close",
window.location,"SaveAndSwitchLayout","SwitchLayoutWithoutSave");b.remove()},this))}};return g});
define("web-viewer/core/AbstractModule",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","underscore"],function(g,e,d){var c=function(c,b,a){this.f=c;this.silenced=b||!1;this.name=a;this._onUnsilence=[];g.installTo(this);e.installTo(this,c,"module."+a)};c.prototype._publish=function(){this.silenced?this._onUnsilence.push(arguments):this.f.emit.apply(this.f,arguments)};c.prototype._unSilence=function(){d.each(this._onUnsilence,d.bind(function(c){this.f.emit.apply(this.f,c)},this));this._onUnsilence=
[];this.silenced=!1};c.prototype.setSilenced=function(c){c?this.silenced=!0:this._unSilence()};c.prototype._publishWidget=function(c,b){this._publish("layout.addWidget",c,b)};c.prototype._publishToolbarComponent=function(c,b){this._publish("layout.addToolbarComponent",c,b)};c.prototype._publishTool=function(c){this._publish("toolManager.addTool",c)};c.prototype._unpublishTool=function(c){this._publish("toolManager.removeTool",c)};c.prototype.hasUnsavedElements=function(){return!1};c.prototype.getUnsavedElementsName=
function(){return this.name};c.prototype.saveAllUnsavedElements=function(c){c&&c()};c.prototype.getState=function(){};c.prototype.setState=function(){};return c});
define("web-viewer/featureDetector/FeatureDetectorModule",["web-viewer/core/AbstractModule","modernizr"],function(g,e){var d=function(c,d){g.call(this,c,d,"featureDetector")};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.isMobile=function(){return!0===this.f.getProperty("isMobile")};d.prototype.isIOS=function(){return/(iPad|iPhone|iPod)/i.test(navigator.userAgent)};d.prototype.hasTouch=function(){return e.touch||0<=navigator.userAgent.indexOf("Trident")&&0<=navigator.userAgent.indexOf("Touch")};
d.prototype.hasCanvas=function(){return e.canvas};return d});
define("web-viewer/layout/AbstractWidget","web-viewer/core/Extendable web-viewer/core/PrivateChannel jquery web-viewer/utils/ShapeUtils Mousetrap underscore".split(" "),function(g,e,d,c,f,b){d=function(a,c){g.installTo(this);e.installTo(this,a,["widget",c]);this.collapsed=!1;this.visible=!0;this._isModal=!1;this.f=a;this._enabled=!0;this._title=c;this._currentCursor="cursor-default";this._options={};this.getID=function(){return c};this.setOption=function(a,b){var c=this._options[a];c!==b&&(this._options[a]=
b,this._emit("options.changed."+a,c,b))};this.getOption=function(a){return this._options[a]};this.getOptions=function(){return b.clone(this._options)}};d.prototype.setOptions=function(a){b.each(a,function(a,b){this.setOption(b,a)},this)};d.prototype.getTitle=function(){return this._title};d.prototype.setTitle=function(a){this._title!==a&&(this._title=a,this._emit("titlechanged",a))};d.prototype.setContext=function(a,b){a?(this.context=a,this.headerExtra=b,this.setCursor(this._currentCursor),this._emit("contextAvailable")):
this.f.emit("error.WARNING","Can't call setContext without context!")};d.prototype.destroy=function(){this._emit("destroyed")};d.prototype.isContextAvailable=function(){return void 0!==this.context};d.prototype.whenContextAvailable=function(a,c){c&&(a=b.bind(a,c));if(this.isContextAvailable())a();else this.once("contextAvailable",a)};d.prototype.setVisible=function(a){this.visible!==a&&(this.visible=a,this._emit("visible",a))};d.prototype.isVisible=function(){return this.visible};d.prototype.setCollapsed=
function(a){this.collapsed!==a&&(this.collapsed=a,this._emit("collapsed",a))};d.prototype.isCollapsed=function(){return this.collapsed};d.prototype.setModal=function(a){this._isModal=a};d.prototype.resized=function(){};d.prototype._fireResized=function(){this._emit("resized")};d.prototype.fireModalResize=function(){this._emit("modalResize")};d.prototype.resizing=function(){};d.prototype.setCursor=function(a){this.whenContextAvailable(b.bind(function(){a!=this._currentCursor&&(this.context.removeClass(this._currentCursor),
this.context.addClass(a),this._currentCursor=a)},this))};d.prototype.getWidgetType=function(){return"dockable"};d.prototype.getMinimumSize=function(){return new c.Size(100,30)};d.prototype.getPreferredSize=function(){var a=this.context.clone(!1);a.css({position:"absolute",visibility:"hidden",overflow:"auto",height:"auto",width:this.context.width()-2});this.f.getContext().append(a);a.css({overflow:"hidden"});a.css({overflow:"auto"});var b=new c.Size(a.outerWidth(!0),a.outerHeight(!0));a.remove();return b};
d.prototype.willFill=function(){return!1};d.prototype.getMaximumSize=function(){};d.prototype.movingStarted=function(){this._emit("movingStarted")};d.prototype.movingStopped=function(){this._emit("movingStopped")};d.prototype.dragged=function(a,b){this._emit("dragged",a,b)};d.prototype.bindKeys=function(a){for(var b=0;b<a.length;b++)f.bind(a[b][0],a[b][1],a[b][2])};d.prototype.unbindKeys=function(a){for(var b=0;b<a.length;b++)f.unbind(a[b][0],a[b][1],a[b][2])};d.prototype.setEnabled=function(a){this._enabled!==
a&&(this._enabled=a,this._emit("enabled",a))};d.prototype.isEnabled=function(){return this._enabled};d.prototype.makeVisible=function(){this.isEnabled()||this.setEnabled(!0);this._didRequestMakeVisible=!0;this._emit("makeVisible")};d.prototype.didRequestMakeVisible=function(){return this._didRequestMakeVisible};d.prototype.setMakeVisibleRequestAccepted=function(){this._didRequestMakeVisible=!1};return d});
define("web-viewer/message/Message",[],function(){return function(g,e,d,c,f){this.type=g;this.message=e;this.action=d;this.autoHide=c;this.tag=f}});
define("web-viewer/message/MessageWidget",["web-viewer/layout/AbstractWidget","web-viewer/layout/LayoutConstants","web-viewer/message/Message","jquery","underscore"],function(g,e,d,c,f){d=function(b,a){g.call(this,b,e.Widget.MESSAGE);var d={error:"alert-danger",warn:"",info:"alert-info",success:"alert-success"},o={error:"Error",warn:"Warn",info:"Info",success:"Success"},k=!1,l=void 0,i=null,j=function(a){l.fadeOut("fast",function(){l.remove();k=!1;a()})},n=f.bind(function(a){k=!0;i=a;var f=c("<button />").attr("type",
"button").addClass("close").html("&times;"),e=c("<strong />").append(b.i18n.t(o[a.type])),e=c("<span />").append(e).append(" ");if(a.action){var g=c("<a/>").addClass("alert-link").text(a.message);if("string"===typeof a.action)g.attr("href",a.action);else g.attr("href","#").on("click",function(b){b.stopPropagation();j(function(){a.action();m()})});e.append(g)}else e.append(a.message);l=c("<div />").addClass("alert").addClass(d[a.type]).append(f).append(e).hide();var n=void 0;a.autoHide&&(n=setTimeout(function(){j(function(){m()})},
3E3));f.on("click",function(a){a.stopPropagation();n&&clearTimeout(n);j(function(){m()})});this.context.empty().append(l);l.fadeIn("fast")},this),m=function(){if(!k){var b=a.getNextMessage();b&&n(b)}};this.showNextMessage=m;this.getWidgetType=function(){return"messagebar"};this._override("setContext",function(a){this._super(a);this.context.addClass("enableTextSelection");this.showNextMessage()});this.isShownMessageWithTag=function(a){return k&&l&&i&&i.tag===a};this.markObsolete=function(a){this.isShownMessageWithTag(a)&&
j(function(){m()})}};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.widgetName=e.Widget.MESSAGE;return d});
define("web-viewer/message/MessageModule",["web-viewer/core/AbstractModule","web-viewer/message/MessageWidget","web-viewer/message/Message","underscore"],function(g,e,d,c){var f=function(b,a){g.call(this,b,a,"message");this._messageQueue=[];this._publishWidget(e.widgetName,c.bind(function(){return this._messageWidget=new e(b,this)},this));this.f.on("userMessage",c.bind(this.handleMessageEvent,this));this.f.on("userMessage.markObsolete",c.bind(this.markObsolete,this));this.f.on("error.SEVERE",c.bind(function(a){this.addToMessageQueue(new d("error",
a))},this));this.f.on("error.WARNING",c.bind(function(a,b){this.addToMessageQueue(new d("warn",a,void 0,b))},this))};f.prototype=Object.create(g.prototype);f.prototype.constructor=f;f.prototype.addToMessageQueue=function(b){this.f.debug.log("Message received",b);this._messageQueue.push(b);this._messageWidget&&this._messageWidget.isContextAvailable()&&this._messageWidget.showNextMessage()};f.prototype.handleMessageEvent=function(){var b=arguments.length;if(1===b)c.isString(arguments[0])?this.addToMessageQueue(new d("info",
arguments[0])):this.addToMessageQueue(arguments[0]);else if(2===b)this.addToMessageQueue(new d(arguments[0],arguments[1]));else if(3===b)c.isBoolean(arguments[2])?this.addToMessageQueue(new d(arguments[0],arguments[1],!1,arguments[2])):this.addToMessageQueue(new d(arguments[0],arguments[1],arguments[2],!1));else if(4===b)this.addToMessageQueue(new d(arguments[0],arguments[1],arguments[2],arguments[3]));else if(5===b)this.addToMessageQueue(new d(arguments[0],arguments[1],arguments[2],arguments[3],
arguments[4]));else if(6===b){var a=arguments[4];(!arguments[5]||!c.some(this._messageQueue,function(b){return b.tag===a})&&(!this._messageWidget||!this._messageWidget.isShownMessageWithTag(a)))&&this.addToMessageQueue(new d(arguments[0],arguments[1],arguments[2],arguments[3],arguments[4]))}else this.f.debug.debug("Unrecognized userMessage event",arguments)};f.prototype.getNextMessage=function(){return this._messageQueue.shift()};f.prototype.markObsolete=function(b){this._messageQueue=c.filter(this._messageQueue,
function(a){return!a.tag||a.tag!==b});this._messageWidget&&this._messageWidget.markObsolete(b)};return f});
define("web-viewer/utils/Transformation",["underscore","web-viewer/utils/ShapeUtils"],function(g,e){var d=function(c,d,b,a,h,e){this.a=void 0!==c?c:1;this.b=void 0!==d?d:0;this.c=void 0!==b?b:0;this.d=void 0!==a?a:1;this.e=void 0!==h?h:0;this.f=void 0!==e?e:0};d.prototype.setTransform=function(c,d,b,a,h,e){this.a=c?c:1;this.b=d?d:0;this.c=b?b:0;this.d=a?a:1;this.e=h?h:0;this.f=e?e:0};d.prototype.copy=function(){return new d(this.a,this.b,this.c,this.d,this.e,this.f)};d.prototype.equals=function(c){return this.a==
c.a&&this.b==c.b&&this.c==c.c&&this.d==c.d&&this.e==c.e&&this.f==c.f};d.prototype.createInverse=function(){var c=this.copy(),d=1/(this.a*this.d-this.b*this.c),b=-this.b*d,a=-this.c*d,h=this.a*d,e=d*(this.c*this.f-this.d*this.e),g=d*(this.b*this.e-this.a*this.f);c.a=this.d*d;c.b=b;c.c=a;c.d=h;c.e=e;c.f=g;return c};d.prototype.setScale=function(c,d){this.a=c;this.d=d};d.prototype.scale=function(c,d){this.a*=c;this.b*=c;this.c*=d;this.d*=d};d.prototype.preScale=function(c,d){this.a*=c;this.b*=c;this.e*=
c;this.c*=d;this.d*=d;this.f*=d};d.prototype.setTranslate=function(c,d){this.e=c;this.f=d};d.prototype.translate=function(c,d){this.e+=c*this.a+d*this.c;this.f+=c*this.b+d*this.d};d.prototype.preTranslate=function(c,d){this.e+=c;this.f+=d};d.prototype.rotationTransformation=function(c,f,b){var f=void 0===f?0:f,b=void 0===b?0:b,a=Math.cos(c),c=Math.sin(c);return new d(a,c,-c,a,f-f*a+b*c,b-f*c-b*a)};d.prototype.translateTransformation=function(c,f){return new d(1,0,0,1,c,f)};d.prototype.rotate=function(c,
d,b){c=this.rotationTransformation(c,d,b);this.concatenate(c)};d.prototype.preRotate=function(c,d,b){return this.preConcatenate(this.rotationTransformation(c,d,b))};d.prototype.flipTransformation=function(c,f){return new d(-1,0,0,1,c,f)};d.prototype.flip=function(c,d){this.concatenate(this.flipTransformation(c,d))};d.prototype.preFlip=function(c,d){this.preConcatenate(this.flipTransformation(c,d))};d.prototype.toString=function(){return"Transformation[["+this.a+", "+this.c+", "+this.e+"], ["+this.b+
", "+this.d+", "+this.f+"]]"};d.prototype.concatenate=function(c){var d=this.b*c.a+this.d*c.b,b=this.a*c.c+this.c*c.d,a=this.b*c.c+this.d*c.d,h=this.a*c.e+this.c*c.f+this.e,e=this.b*c.e+this.d*c.f+this.f;this.a=this.a*c.a+this.c*c.b;this.b=d;this.c=b;this.d=a;this.e=h;this.f=e};d.prototype.preConcatenate=function(c){var d=c.a*this.c+c.c*this.d,b=c.a*this.e+c.c*this.f+c.e,a=c.b*this.a+c.d*this.b,h=c.b*this.c+c.d*this.d,e=c.b*this.e+c.d*this.f+c.f;this.a=c.a*this.a+c.c*this.b;this.c=d;this.e=b;this.b=
a;this.d=h;this.f=e;return this};d.prototype.transformedPoint=function(c){var d=c.x,c=c.y;return new e.Point(d*this.a+c*this.c+this.e,d*this.b+c*this.d+this.f)};d.prototype.preTransformedPoint=function(c){return new e.Point(this.a*c.x+this.b*c.y+this.e,this.c*c.x+this.d*c.y+this.f)};d.prototype.transformedSize=function(c){var d=this.transformedPoint(new e.Point),c=this.transformedPoint(new e.Point(c.width,c.height));return new e.Size(c.x-d.x,c.y-d.y)};d.prototype.transformedRect=function(c){var c=
c.copy(),d=this.transformedPoint(c.origin),b=d.x,a=d.y,h=d.x,d=d.y,g=this.transformedPoint(new e.Point(c.right(),c.top())),b=Math.min(b,g.x),a=Math.min(a,g.y),h=Math.max(h,g.x),d=Math.max(d,g.y),g=this.transformedPoint(new e.Point(c.left(),c.bottom())),b=Math.min(b,g.x),a=Math.min(a,g.y),h=Math.max(h,g.x),d=Math.max(d,g.y),g=this.transformedPoint(new e.Point(c.right(),c.bottom())),b=Math.min(b,g.x),a=Math.min(a,g.y),h=Math.max(h,g.x),d=Math.max(d,g.y),b=new e.Point(b,a),h=new e.Point(h,d);c.origin=
b;c.size=new e.Size(h.x-b.x,h.y-b.y);return c};d.prototype.getScaleX=function(){return Math.sqrt(this.a*this.a+this.b*this.b)};d.prototype.getScaleY=function(){return Math.sqrt(this.c*this.c+this.d*this.d)};d.prototype.getRotation=function(){return Math.atan2(this.c,this.d)};return d});
define("lib/AnimationOptions",["underscore"],function(){var g=function(e){this._types={ease:[0.25,0.1,0.25,1],linear:[0,0,1,1],"ease-in":[0.42,0,1,1],"ease-out":[0,0,0.58,1],"ease-in-out":[0.42,0,0.58,1]};this._options=this._types[e];this._options||(this._options=this._types.linear);this._mX1=this._options[0];this._mY1=this._options[1];this._mX2=this._options[2];this._mY2=this._options[3]};g.prototype.get=function(e){return this._mX1==this._mY1&&this._mX2==this._mY2?e:this._calcBezier(this._getTForX(e),
this._mY1,this._mY2)};g.prototype._a=function(e,d){return 1-3*d+3*e};g.prototype._b=function(e,d){return 3*d-6*e};g.prototype._c=function(e){return 3*e};g.prototype._calcBezier=function(e,d,c){return((this._a(d,c)*e+this._b(d,c))*e+this._c(d))*e};g.prototype._getSlope=function(e,d,c){return 3*this._a(d,c)*e*e+2*this._b(d,c)*e+this._c(d)};g.prototype._getTForX=function(e){for(var d=e,c=0;4>c;++c){var f=this._getSlope(d,this._mX1,this._mX2);if(0==f)break;var b=this._calcBezier(d,this._mX1,this._mX2)-
e,d=d-b/f}return d};return g});
define("web-viewer/viewport/ViewportWorld","underscore web-viewer/utils/Transformation web-viewer/utils/ShapeUtils web-viewer/core/PrivateChannel web-viewer/utils/ViewerUtils lib/AnimationOptions".split(" "),function(g,e,d,c,f,b){var a=function(a,b,f){c.installTo(this,a,["transform",b]);this._initialStartZoom=this._minZoom=this._maxZoom=this._transform=this._initialTransformation=void 0;this._initialZoom=f?f:1;this._allowAnimation=!0;this._animationFramerate=45;this._defaultAnimationDuration=250;
this._currentAnimation=null;this._rotation=0;this._offsetSize=new d.Size;this._zoom=1;this._flipViewFromBack=this._flip=!1;this._worldSize=new d.Size;this._sceneSize=new d.Size;this._worldOrigin=new d.Point;this._worldResolution={x:0,y:0};this._didChangeSinceLastZoomToFit=!1;this._animationTimer=null};a.prototype.recalculateInitialStartZoom=function(){if(0===this._worldSize.width||0===this._worldSize.height)return this._zoom;var a=!0;0===this._rotation%180&&(a=!1);var a=Math.min((a?this._sceneSize.height:
this._sceneSize.width)/this._worldSize.width,(a?this._sceneSize.width:this._sceneSize.height)/this._worldSize.height),a=a*this._initialZoom,b=this.getIntegerZoom(-this.getNumberOfMinZoomLevels()),c=this.getIntegerZoom(this.getNumberOfMaxZoomLevels());if(this._minZoom!==b||this._maxZoom!==c)this._minZoom=b,this._maxZoom=c,this._emit("minMaxZoomChanged",this,this._minZoom,this._maxZoom);return this._initialStartZoom=a};a.prototype.isFullView=function(){return this._zoom===this._initialStartZoom};a.prototype.isSmallerThanFullView=
function(){return this._zoom<this._initialStartZoom};a.prototype.getInitialStartZoom=function(){return this._initialStartZoom};a.prototype.getInitialZoom=function(){return this._initialZoom};a.prototype.zoomToFit=function(a){this._offsetSize=new d.Size;this.transform({fixedzoom:this.recalculateInitialStartZoom(),animated:a});this._didChangeSinceLastZoomToFit=!1};a.prototype.zoomToFitWidth=function(a){this._reportChange();var b=!0;0===this._rotation%180&&(b=!1);var c=null;b?0!==this._worldSize.height&&
(c=this._worldSize.height):0!==this._worldSize.width&&(c=this._worldSize.width);this._offsetSize=new d.Size;null!==c?(b=this._sceneSize.width/c,b*=this._initialZoom,this.transform({fixedzoom:b,animated:a})):this.updateTransformation(a)};a.prototype.zoomToFitHeight=function(a){this._reportChange();var b=!0;0===this._rotation%180&&(b=!1);var c=null;b?0!==this._worldSize.width&&(c=this._worldSize.width):0!==this._worldSize.height&&(c=this._worldSize.height);this._offsetSize=new d.Size;null!==c?(b=this._sceneSize.height/
c,b*=this._initialZoom,this.transform({fixedzoom:b,animated:a})):this.updateTransformation(a)};a.prototype.zoomOneToOne=function(a,b){this._reportChange();var c=b;void 0===c&&(this._worldResolution&&0!==this._worldResolution.x)&&(c=this._worldResolution.x);this.transform({fixedzoom:c,animated:a})};a.prototype.getZoom=function(){return this._zoom};a.prototype.getZoomPercentage=function(){return this._worldResolution&&0!==this._worldResolution.x?100*(this._zoom/this._worldResolution.x):0};a.prototype.getNumberOfZoomLevels=
function(){return this.getNumberOfMinZoomLevels()+this.getNumberOfMaxZoomLevels()+1};a.prototype.getNumberOfMinZoomLevels=function(){return 16};a.prototype.getNumberOfMaxZoomLevels=function(){return 9};a.prototype.getMaxZoom=function(){return this._maxZoom};a.prototype.getMinZoom=function(){return this._minZoom};a.prototype.zoomToSceneRect=function(a,b){this._reportChange();var c=this.getWorldRectFromScene(a),d=Math.abs(this._sceneSize.width/c.size.width),f=Math.abs(this._sceneSize.height/c.size.height),
e=this.getRotation()%360;if(90===e||270===e)d=Math.abs(this._sceneSize.width/c.size.height),f=Math.abs(this._sceneSize.height/c.size.width);this.transform({fixedzoom:Math.min(d,f),middle:c.center(),animated:b})};a.prototype.setSceneSize=function(a){this._sceneSize=a;this.updateTransformation(!1,!0)};a.prototype.getSceneSize=function(){return this._sceneSize};a.prototype.getSceneBounds=function(){return new d.Rect(null,this._sceneSize.copy())};a.prototype.getWorldSize=function(){return this._worldSize};
a.prototype.getWorldBounds=function(){return new d.Rect(this._worldOrigin.copy(),this._worldSize.copy())};a.prototype.setWorldBounds=function(a){this._worldSize=a.size.copy();this._worldOrigin=a.origin.copy();this.updateTransformation(!1);this._emit("worldBoundsChanged")};a.prototype.isAnimating=function(){return null!=this._currentAnimation&&!this._currentAnimation.done};a.prototype.isAnimatingRotation=function(){var a=this.getTransformation(),b=this.calculateCurrentTransformation(),a=a.getRotation(),
b=b.getRotation();return a!=b};a.prototype.getRotation=function(){return this._rotation};a.prototype.getTransformation=function(){this._transform||this.updateTransformation();return this._transform.copy()};a.prototype.rubber=function(a,b,c){var d=(a-b)/(c-b);return 0>=d?a:b+(c-b)*(d/(1+d))};a.prototype.constrainZoom=function(a){return this._zoom>this._maxZoom?(this._zoom=a?this.rubber(this._zoom,this._maxZoom,1.6*this._maxZoom):this._maxZoom,!0):this._zoom<this._minZoom?(this._zoom=a?this.rubber(this._zoom,
this._minZoom,this._minZoom/1.6):this._minZoom,!0):!1};a.prototype.constrainRotation=function(a){a&&0!==this._rotation%90&&(this._rotation=parseInt(this._rotation,10)%360,0>this._rotation&&(this._rotation+=360),this._rotation=f.closestAngle(this._rotation,4))};a.prototype.constrainPan=function(a){var b=this.getMiddle();if(this.isSmallerThanFullView())this._offsetSize=new d.Size;else{var c=this._worldSize.copy(),f=!1;90===this._rotation%180&&(f=!0);var e=this.recalculateInitialStartZoom();this._zoom<
e&&(e=this._zoom*this._initialZoom);var g=0.5*(c.width-this._sceneSize.width/e+this._sceneSize.width/this._zoom),n=0.5*(c.width+this._sceneSize.width/e-this._sceneSize.width/this._zoom),m=0.5*(c.height-this._sceneSize.height/e+this._sceneSize.height/this._zoom),p=0.5*(c.height+this._sceneSize.height/e-this._sceneSize.height/this._zoom);f&&(g=0.5*(c.height-this._sceneSize.width/e-this._sceneSize.width/this._zoom),n=0.5*(c.height+this._sceneSize.width/e+this._sceneSize.width/this._zoom),m=0.5*(c.width-
this._sceneSize.height/e-this._sceneSize.height/this._zoom),p=0.5*(c.width+this._sceneSize.height/e+this._sceneSize.height/this._zoom));e=b.copy();b.offset(new d.Size(-this._worldOrigin.x,-this._worldOrigin.y));e.offset(new d.Size(-this._worldOrigin.x,-this._worldOrigin.y));90===this._rotation%360?e=new d.Point(c.height-b.y,b.x):180===this._rotation%360?e=new d.Point(c.width-b.x,c.height-b.y):270===this._rotation%360&&(e=new d.Point(b.y,c.width-b.x));e.x<g&&(e.x=g);e.x>n&&(e.x=n);e.y<m&&(e.y=m);e.y>
p&&(e.y=p);f?(g=0,n=c.height,m=0,p=c.width):(g=0,n=c.width,m=0,p=c.height);e.x<g&&(e.x=g);e.x>n&&(e.x=n);e.y<m&&(e.y=m);e.y>p&&(e.y=p);b=e;90===this._rotation%360?b=new d.Point(e.y,c.height-e.x):180===this._rotation%360?b=new d.Point(c.width-e.x,c.height-e.y):270===this._rotation%360&&(b=new d.Point(c.width-e.y,e.x));b.offset(new d.Size(this._worldOrigin.x,this._worldOrigin.y));if(a){a=this.getMiddle();c=new d.Point;c.x=Math.round(a.x-b.x);c.y=Math.round(a.y-b.y);a=b;b=Math.sqrt(c.x*c.x+c.y*c.y);
if(0.01>b)return!1;f=this.rubber(b,0,200/this._zoom);c.x*=f/b;c.y*=f/b;a.x+=c.x;a.y+=c.y;this.setMiddle(a);return!0}a=this.getMiddle();if(a.equals(b))return!1;this.setMiddle(b);return!0}};a.prototype.setMiddle=function(a){this._reportChange();var b=this.getWorldBounds().center();this._offsetSize=new d.Size(b.x-a.x,b.y-a.y)};a.prototype.getMiddle=function(){var a=this.getWorldBounds().center();return new d.Point(a.x-this._offsetSize.width,a.y-this._offsetSize.height)};a.prototype.updateTransformation=
function(a,c,d){d||(this.constrainZoom(!1),this.constrainPan(!1),this.constrainRotation(c));c=this.calculateCurrentTransformation();void 0===this._transform&&(this._transform=c);c.equals(this._transform)&&(a=!1);this.isAnimationAllowed()||(a=!1);if(a){g.isBoolean(a)&&(a={});a.duration||(a.duration=this._defaultAnimationDuration);d=100/(a.duration/this._animationFramerate)/100;a.type||(a.type="ease-in-out");var f=new b(a.type);f.from=a.interrupt&&this._currentAnimation&&!this._currentAnimation.done?
this._currentAnimation.to:this._transform;f.to=c;f.gain=d;f.progress=0;f.done=!1;this.updateTransformationAnimated(f);this._currentAnimation&&(this._currentAnimation.done=!0);this._currentAnimation=f}else this.isAnimating()&&this.cancelAnimation(!0),this._transform=c,this.fireTransformChanged()};a.prototype.calculateCurrentTransformation=function(){var a=new d.Rect(null,new d.Size(this._sceneSize.width/this._zoom,this._sceneSize.height/this._zoom)),b=(a.size.width-this._worldSize.width)/2,c=(a.size.height-
this._worldSize.height)/2,f=new e;f.scale(this._zoom,this._zoom);f.translate(a.size.width/2,a.size.height/2);f.rotate(this._rotation*(Math.PI/180));this.isFlip()&&f.scale(-1,1);this.isFlipViewFromBack()&&(0===this._rotation%180?f.scale(-1,1):f.scale(1,-1));f.translate(-a.size.width/2,-a.size.height/2);f.translate(b,c);this._worldOrigin&&f.translate(-this._worldOrigin.x,-this._worldOrigin.y);f.translate(this._offsetSize.width,this._offsetSize.height);f.e=Math.floor(f.e);f.f=Math.floor(f.f);return f};
a.prototype.updateTransformationAnimated=g.throttle(function(a){if(!a.done){if(0.9999<a.progress||1<=a.progress)a.progress=1;a.from.equals(a.to)&&(a.progress=1);var b=a.get(a.progress),c=new e;c.a=a.from.a*(1-b)+a.to.a*b;c.b=a.from.b*(1-b)+a.to.b*b;c.c=a.from.c*(1-b)+a.to.c*b;c.d=a.from.d*(1-b)+a.to.d*b;c.e=a.from.e*(1-b)+a.to.e*b;c.f=a.from.f*(1-b)+a.to.f*b;this._transform=c;1<=a.progress?(a.done=!0,this._currentAnimation==a&&(this._currentAnimation=null),this.fireTransformChanged()):(this.fireTransformChanged(),
this._animationTimer=setTimeout(g.bind(function(){a.progress+=a.gain;this.updateTransformationAnimated(a)},this),this._animationFramerate))}},0);a.prototype.transform=function(a,b){this._reportChange();a.rotate&&(this._rotation=(this._rotation+a.rotate+360)%360,this._emit("rotated"));a.fixedrotation&&(this._rotation=a.fixedrotation%360,this._emit("rotated"));a.flip&&(this._flip=!this._flip,this._emit("flipped"));if(a.offsetX||a.offsetY){var c=a.offsetY?a.offsetY:0;this._offsetSize.width+=a.offsetX?
a.offsetX:0;this._offsetSize.height+=c}void 0!==a.flipViewFromBack&&(this._flipViewFromBack=a.flipViewFromBack,this._emit("flippedViewFromBack"));a.zoom&&(this._worldResolution&&0!==this._worldResolution.x?(c=Math.round(Math.log(this._zoom/this._worldResolution.x)/Math.log(2)),this._zoom=this.getIntegerZoom(c+a.zoom)):this._zoom*=Math.pow(2,a.zoom));a.fixedzoom&&(this._zoom=a.fixedzoom);this.isAnimationAllowed()||this.cancelAnimation();a.fixedoffset&&(this._offsetSize=a.fixedoffset);a.middle&&this.setMiddle(a.middle);
b||this.updateTransformation(a.animated,a.constrainRotation,a.tmpDisableConstraints)};a.prototype.getIntegerZoom=function(a){return this._worldResolution.x*Math.pow(2,a)};a.prototype.setInitialTransformation=function(a){this._reportChange();this._initialTransformation=a};a.prototype.getInitialTransformation=function(){return this._initialTransformation};a.prototype.fitInRect=function(a,b,c){this._reportChange();var d=Math.abs(this._sceneSize.width/a.size.width),f=Math.abs(this._sceneSize.height/a.size.height),
d=Math.min(d,f);c&&(d=Math.min(0.8*d,this._maxZoom));this.transform({fixedzoom:d,middle:a.center(),animated:b})};a.prototype.getOffsetSize=function(){return this._offsetSize.copy()};a.prototype.setOffsetSize=function(a,b){this._reportChange();this._offsetSize=a;this.updateTransformation(b)};a.prototype.getTargetViewPort=function(a){var b=this.getWorldRectFromScene(this.getSceneBounds(),this.calculateCurrentTransformation());a||(b=b.calculateOverlap(this.getWorldBounds()));return b};a.prototype.getAnimationDestinationTargetViewPort=
function(){if(this.isAnimating()){var a=this.getWorldRectFromScene(this.getSceneBounds(),this._currentAnimation.to);return a=a.calculateOverlap(this.getWorldBounds())}return this.getTargetViewPort()};a.prototype.getWorldSizeFromScene=function(a,b){b||(b=this.getTransformation());var c=this.getWorldPointFromScene(new d.Point,b),f=this.getWorldPointFromScene(new d.Point(a.width,a.height),b);return new d.Size(f.x-c.x,f.y-c.y)};a.prototype.getWorldPointFromScene=function(a,b){b||(b=this.getTransformation());
return b.createInverse().transformedPoint(a)};a.prototype.getWorldRectFromScene=function(a,b){b||(b=this.getTransformation());var c=b.createInverse().transformedRect(a),d=this.getZoom();1E-6>1-c.origin.y*d&&(c.origin.y+=1E-6/d);1E-6>1-c.origin.x*d&&(c.origin.x+=1E-6/d);return c};a.prototype.getSceneRectFromWorld=function(a,b){b||(b=this.getTransformation());return b.transformedRect(a)};a.prototype.getScenePointFromWorld=function(a,b){b||(b=this.getTransformation());return b.transformedPoint(a)};a.prototype.fireTransformChanged=
function(){this._emit("transformChanged",this)};a.prototype.toggleAnimation=function(a){(this._allowAnimation=a)||this.cancelAnimation()};a.prototype.isFlip=function(){return this._flip};a.prototype.isFlipViewFromBack=function(){return this._flipViewFromBack};a.prototype.setWorldResolution=function(a){this._worldResolution=a};a.prototype.getWorldResolution=function(){return this._worldResolution};a.prototype.isDeepZoom=function(){return 16<=this._zoom/this._worldResolution.x||16<=this._zoom/this._worldResolution.y};
a.prototype._reportChange=function(){this._didChangeSinceLastZoomToFit=!0};a.prototype.didChangeTransformSinceLastZoomToFit=function(){return this._didChangeSinceLastZoomToFit};a.prototype.cancelAnimation=function(a){this._animationTimer&&this._currentAnimation&&(clearTimeout(this._animationTimer),!this._currentAnimation.done&&!a&&(this._transform=this._currentAnimation.to,this.fireTransformChanged()),this._currentAnimation.done=!0,this._currentAnimation=null)};a.prototype.isAnimationAllowed=function(){return this._allowAnimation&&
1E3>this.getZoomPercentage()};a.prototype.resetOrientation=function(){this._flip=!1;this._emit("flipped");this._rotation=0;this._emit("rotated");this._flipViewFromBack=!1;this._emit("flippedViewFromBack")};return a});
define("web-viewer/viewport/tools/AbstractTool",["underscore","web-viewer/utils/ShapeUtils","web-viewer/core/Extendable","web-viewer/core/PrivateChannel","Mousetrap"],function(g,e,d,c,f){var b=function(a,b){d.installTo(this);c.installTo(this,a,["tool",b]);this.f=a;var f=!1;this.isActive=function(){return f};this.getIID=function(){return b};this.requestActivation=function(){a.emit("toolManager.request.activation",this)};this.requestDeactivation=function(){a.emit("toolManager.request.deactivation",
this)};this.passiveEvents={};this.passiveKeyEvents=[];this.activeEvents={};this.activeKeyEvents=[];this.persistentKeyEvents=[];this.activate=function(a){f=!0;this._widget.whenContextAvailable(g.bind(function(){this.doActivation();this.isActive()&&this._emit("activated",a)},this))};this.deactivate=function(a){this.doDeactivation();f=!1;this._emit("deactivated",a)};var e={},l;this.registerActiveEvents=function(a){g.each(a,function(a){this.activeEvents[a]=g.bind(function(b){this.getState(l)[a](b)},this)},
this)};this.registerPassiveEvents=function(a){g.each(a,function(a){this.passiveEvents[a]=g.bind(function(b){this.getState(l)[a](b)},this)},this)};this.registerState=function(a,b){e[a]=b};this.changeState=function(a){if(l!==a){var b=l;e[b]&&e[b].leaveState&&e[b].leaveState(a);l=a;this._emit('State changed to "'+a+'"');e[a]&&e[a].enterState&&e[a].enterState(b);this.cursorShouldChange()}};this.getState=function(a){return e[a]};this.getCurrentState=function(){return this.getState(l)};this.getCurrentStateName=
function(){return l}};b.prototype.sceneToWorld=function(a){if(this._widget)return this._widget.getWorld().getWorldPointFromScene(a);this.f.emit("error.SEVERE","Requesting world point with no widget present");return a};b.prototype.sceneToWorldRect=function(a){if(this._widget)return this._widget.getWorld().getWorldRectFromScene(a);this.f.emit("error.SEVERE","Requesting world rectangle with no widget present");return null};b.prototype.sceneToWorldSize=function(a){if(this._widget)return this._widget.getWorld().getWorldSizeFromScene(a);
this.f.emit("error.SEVERE","Requesting world rectangle with no widget present");return null};b.prototype.getWorldResolution=function(){if(this._widget)return this._widget.getWorld().getWorldResolution();this.f.emit("error.SEVERE","Requesting world resolution with no widget present");return null};b.prototype.keepPointWithinWorldBounds=function(a,b){var c=this._widget.getWorld().getWorldBounds();return this.keepPointWithinRect(a,c,b)};b.prototype.keepPointWithinRect=function(a,b,c){var d=0,d=a.x<b.left()||
a.x>b.right()?a.x<b.left()?b.left():b.right():a.x,f=0,f=a.y<b.top()||a.y>b.bottom()?a.y<b.top()?b.top():b.bottom():a.y;return c?this._widget.getWorld().getScenePointFromWorld(new e.Point(d,f)):new e.Point(d,f)};b.prototype.keepMoveSizeWithinRect=function(a,b,c){var d=b.left()+c.width,f=b.right()+c.width,g=b.top()+c.height,b=b.bottom()+c.height,j=new e.Size;Math.min(d,f)>=a.left()&&(Math.max(d,f)<=a.right()&&Math.min(g,b)>=a.top()&&Math.max(g,b)<=a.bottom())&&(j.width=c.width,j.height=c.height);return j};
b.prototype.canBeInterrupted=function(){return!0};b.prototype.canBeActivated=function(){return!0};b.prototype.setCursor=function(a){this._widget&&this._widget.setCursor(a)};b.prototype.cursorShouldChange=function(){this.isActive()&&this.setCursor(this.getDefaultCursor())};b.prototype.getDefaultCursor=function(){return"cursor-default"};b.prototype.passivate=function(){this._widget.whenContextAvailable(g.bind(function(){this.doPassivation();this._emit("passivated")},this))};b.prototype.doPassivation=
function(){this._context=this._widget.context;this._context.on(this.passiveEvents);this.bindKeys(this.persistentKeyEvents);this.bindKeys(this.passiveKeyEvents)};b.prototype.depassivate=function(){this._context&&this._context.off(this.passiveEvents);this.unbindKeys(this.passiveKeyEvents);this._emit("depassivated")};b.prototype.doActivation=function(){this._context=this._widget.context;this._context.off(this.passiveEvents);this._context.on(this.activeEvents);this.unbindKeys(this.passiveKeyEvents);this.bindKeys(this.activeKeyEvents)};
b.prototype.doDeactivation=function(){this._context&&(this._context.off(this.activeEvents),this._context.on(this.passiveEvents));this.unbindKeys(this.activeKeyEvents);this.bindKeys(this.passiveKeyEvents)};b.prototype.requestView=function(a){return this._widget.requestView(a)};b.prototype.requestCanvasLayer=function(a){if(this._viewForActiveCanvasLayer=this.requestView(a))this._layer=this._viewForActiveCanvasLayer.addLayer(this.getIID())};b.prototype.releaseCanvasLayer=function(){this._layer&&(this._viewForActiveCanvasLayer.removeLayer(this.getIID()),
this._layer=void 0)};b.prototype.getCanvasCtx=function(){if(this._layer)return this._layer.getCanvasContext()};b.prototype.getCanvasSize=function(){if(this._layer)return new e.Size(this._layer.getCanvas()[0].width,this._layer.getCanvas()[0].height)};b.prototype.getScenePoint=function(a){var b=this.getIconOffset(),a=void 0!==a.pageX?b?new e.Point(a.pageX+b.width,a.pageY+b.height):new e.Point(a.pageX,a.pageY):void 0!==a.clientX?b?new e.Point(a.clientX+b.width,a.clientY+b.height):new e.Point(a.clientX,
a.clientY):new e.Point;return(b=this._widget.requestView(a))?(b=b.getViewContext().offset(),a.offsetXY(-b.left,-b.top),a):new e.Point};b.prototype.getIconOffset=function(){return null};b.prototype.getWorldPoint=function(a){return this.sceneToWorld(this.getScenePoint(a))};b.prototype.bindKeys=function(a){for(var b=0;b<a.length;b++)f.bind(a[b][0],a[b][1],a[b][2])};b.prototype.unbindKeys=function(a){for(var b=0;b<a.length;b++)f.unbind(a[b][0],a[b][1],a[b][2])};b.prototype.getPanelAt=function(a){a=a.pageX?
new e.Point(a.pageX,a.pageY):new e.Point(a.clientX,a.clientY);return this._widget.getPanelAt(a)};b.prototype.initialize=function(a,b){this._widget=a;this._toolManager=b};return b});define("web-viewer/viewport/tools/InterruptTool",["web-viewer/viewport/tools/AbstractTool","web-viewer/core/CoreConstants"],function(g,e){var d=function(c){g.call(this,c,e.TOOLS.INTERRUPT)};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.canBeInterrupted=function(){return!1};return d});
define("web-viewer/viewport/tools/ToolManager",["web-viewer/core/PrivateChannel","web-viewer/viewport/tools/InterruptTool","web-viewer/core/CoreConstants","web-viewer/layout/LayoutConstants","underscore"],function(g,e,d,c,f){var b=function(a,b){g.installTo(this,a,"toolManager");this.f=a;this._widget=b;this._defaultTool=this.f.getLayoutType()===c.LayoutType.MOBILE?d.TOOLS.TOUCH:d.TOOLS.ZOOM;this._loadedTools={};this._toolStack=[];this._disallowedTools=this._allowedTools=null;this._interruptTool=new e(a);
this._addTool(this._interruptTool);this.on("addTool",f.bind(function(a){this._addTool(a)},this));this.on("removeTool",f.bind(function(a){this._removeTool(a)},this));this.on("request.activation",f.bind(function(a){this._requestActivation(a)},this));this.on("request.deactivation",f.bind(function(a){this._deactivateToolImpl(a,!1,!0,!1)},this));this.on("deactivateTool",f.bind(function(a){this._deactivateToolImpl(a,!1,!0)},this));this.on("activeTool",f.bind(function(a){a(this.getActiveTool())},this));
this.on("activateTool",f.bind(function(a,b){void 0===b&&(b=!1);this._activateToolImpl(a,b,!1)},this));this.on("requestTool",f.bind(function(a,b){b(this._loadedTools[a])},this));this.on("interruptTools",f.bind(function(a){a?this._activateInterruptTool():this._deactivateInterruptTool()},this));this.on("request.allowAllTools",f.bind(function(){this.allowAllToolsExcept(null)},this));this.on("request.allowAllToolsExcept",f.bind(function(a){this.allowAllToolsExcept(a)},this));this.on("request.disallowAllToolsExcept",
f.bind(function(a){this.disallowAllToolsExcept(a)},this))};b.prototype._addTool=function(a){a&&(this._loadedTools[a.getIID()]=a,a.initialize(this._widget,this),a.passivate(),a.getIID()==this._defaultTool&&this._isToolAllowed(this._defaultTool)&&this._activateTool(a))};b.prototype._removeTool=function(a){if(f.isString(a)&&(a=this._loadedTools[a],!a)){this.f.emit("error.WARNING","Trying to deactivate a tool which isn't loaded");return}a.isActive()&&this._deactivateToolImpl(a,!1,!0,!1);this._toolStack=
f.without(this._toolStack,a);a.depassivate();delete this._loadedTools[a.getIID()]};b.prototype._activateTool=function(a){this._activateToolImpl(a,!1,!1)};b.prototype._activateToolImpl=function(a,b,c,d){if(this._isToolAllowed(a)){if(f.isString(a)&&(a=this._loadedTools[a],!a)){this.f.emit("error.WARNING","Trying to activate a tool which isn't loaded");return}if(a)if(a.canBeActivated()){var e=this.getActiveTool();if(e&&!c){if(e==a)return;this._deactivateToolImpl(void 0,b,!1,d)}f.last(this._toolStack)!=
a&&this._toolStack.push(a);a.activate(d);this.getActiveTool()===a&&(this._widget.setCursor(a.getDefaultCursor()),this.f.emit("toolManager.activated",a))}else this.f.debug.warn("Trying to activate tool which refuses to activate",a);else this.f.emit("error.SEVERE","Can't activate tool.",a)}else this._emit("request.denied",a)};b.prototype._deactivateToolImpl=function(a,b,c,d){if(f.isString(a)&&(a=this._loadedTools[a],!a)){this.f.emit("error.WARNING","Trying to deactivate a tool which isn't loaded");
return}if(a){if(a!=this.getActiveTool()){this.f.emit("error.WARNING","Trying to deactive a tool which is not the current active tool",a);return}}else a=this.getActiveTool();if(a&&(a.deactivate(d),b||this._toolStack.pop(),this.f.emit("toolManager.deactivated",a),c)){for(a=f.last(this._toolStack);a&&!this._isToolAllowed(a);)this._toolStack.pop(),a=f.last(this._toolStack);this._toolStack.pop();a||this._isToolAllowed(this._defaultTool)&&(a=this._loadedTools[this._defaultTool]);a&&this._activateToolImpl(a,
!1,!0)}};b.prototype._activateInterruptTool=function(){this._activateToolImpl(this._interruptTool,!0,!1,!0)};b.prototype._deactivateInterruptTool=function(){this._deactivateToolImpl(this._interruptTool,!1,!0,!1)};b.prototype.getActiveTool=function(){return f.last(this._toolStack)};b.prototype._requestActivation=function(a){if(this._isToolAllowed(a)){var b=this.getActiveTool();b&&b!=a&&!b.canBeInterrupted(a)?this._emit("request.denied",a):this._activateToolImpl(a,!0,!1,!0)}else this._emit("request.denied",
a)};b.prototype._isToolAllowed=function(a){f.isString(a)||(a=a.getIID());if(a===d.TOOLS.INTERRUPT)return!0;var b=!0;this._allowedTools&&(b=f.contains(this._allowedTools,a));this._disallowedTools&&f.contains(this._disallowedTools,a)&&(b=!1);return b};b.prototype.allowAllToolsExcept=function(a){this._allowedTools=null;this._disallowedTools=a;this._emit("allowedAllToolsExcept",a);this._enforceToolAllowance()};b.prototype.disallowAllToolsExcept=function(a){this._allowedTools=a;this._disallowedTools=null;
this._emit("disallowedAllToolsExcept",a);this._enforceToolAllowance()};b.prototype._enforceToolAllowance=function(){var a=this.getActiveTool();a&&!this._isToolAllowed(a)&&this._deactivateToolImpl(a,!1,!0,!1);!a&&this._isToolAllowed(this._defaultTool)&&this._activateTool(this._defaultTool)};return b});define("web-viewer/viewport/ViewportConstants",{ViewsLayoutMode:{AUTOMATIC:0,HORIZONTAL:1,VERTICAL:2},PanelsLayoutMode:{AUTOMATIC:0,VERTICAL:1,HORIZONTAL:2},PanelBorderWidth:2});
define("web-viewer/utils/OrderedObject",["underscore"],function(){var g=function(){this.array=[];this.object={}};g.prototype.addItemAtIndex=function(e,d,c){if(0<=this.getIndexByKey(e))throw Error("Duplicate key exception");this.array.splice(c,0,e);this.object[e]=d};g.prototype.addItem=function(e,d){if(0<=this.getIndexByKey(e))throw Error("Duplicate key exception");this.array.push(e);this.object[e]=d};g.prototype.addOrReplaceItem=function(e,d){0<=this.getIndexByKey(e)?this.object[e]=d:this.addItem(e,
d)};g.prototype.setOrder=function(e){if(0==_.difference(this.array,e).length)this.array=e.slice(0);else throw Error("Invalid array given for order. Should contain the same elements as in the ordered object.");};g.prototype.removeByKey=function(e){var d=void 0,c=this.getIndexByKey(e);void 0!==this.object[e]&&0<=c&&(this.array.splice(c,1),d=this.object[e],delete this.object[e]);return d};g.prototype.removeByIndex=function(e){var d=void 0;if(this.array[e]){var c=this.array[e],d=this.object[c];delete this.object[c];
this.array.splice(e,1)}return d};g.prototype.omitOthers=function(e){e=_.difference(this.array,e);this.array=_.difference(this.array,e);this.object=_.omit(this.object,e)};g.prototype.clear=function(){this.array=[];this.object={}};g.prototype.getIndexByKey=function(e){return this.array.indexOf(e)};g.prototype.getKeyByIndex=function(e){return this.array[e]};g.prototype.getKeyByValue=function(e){for(var d in this.array)if(e===this.object[this.array[d]])return this.array[d]};g.prototype.getItemByIndex=
function(e){return this.object[this.array[e]]};g.prototype.getItemByKey=function(e){return this.object[e]};g.prototype.containsKey=function(e){return void 0!==this.object[e]};g.prototype.getKeys=function(){return this.array.slice(0)};g.prototype.getItemsAsObject=function(){return _.clone(this.object)};g.prototype.getLength=function(){return this.array.length};g.prototype.moveItemByIndex=function(e,d){var c=this.array.splice(e,1)[0];this.array.splice(d,0,c)};g.prototype.moveItemByKeyToIndex=function(e,
d){this.moveItemByIndex(this.getIndexByKey(e),d)};g.prototype.moveItemByKeyToEnd=function(e){this.moveItemByKeyToIndex(e,this.array.length-1)};g.prototype.getNext=function(e){if(this.hasNext(e))return e=this.getIndexByKey(e),e=this.array[++e],this.object[e]};g.prototype.getPrevious=function(e){if(this.hasPrevious(e))return e=this.getIndexByKey(e),e=this.array[--e],this.object[e]};g.prototype.hasNext=function(e){e=this.getIndexByKey(e);return-1!==e&&++e<this.array.length};g.prototype.hasPrevious=function(e){e=
this.getIndexByKey(e);return-1!==e&&0<=--e};g.prototype.getOrderedObjectList=function(){var e=[];_.each(this.array,_.bind(function(d){e.push(this.object[d])},this));return e};g.prototype.getFirst=function(){return this.getItemByIndex(0)};g.prototype.getLast=function(){return this.getItemByIndex(this.getLength()-1)};return g});
define("web-viewer/utils/Cache",["web-viewer/utils/OrderedObject","underscore"],function(g,e){var d=function(c,d){this.store=new g;this.deletedItems={};this.executeCallbackIfInCache=void 0!==d?d:!0;c=c||30;this.getCacheSize=function(){return c}};d.prototype.get=function(c,d){var b=this.store.getItemByKey(c);if(!b){var a=this.getAlternativeName(c);null!==a&&(b=this.store.getItemByKey(a))}b?(b.loaded?d&&this.executeCallbackIfInCache&&d(b.item):d&&b.callbacks.push(d),this.store.moveItemByKeyToEnd(c)):
(b={name:c,item:void 0,callbacks:[],loaded:!1,error:!1},this.store.addItem(c,b),d&&b.callbacks.push(d),this._loadItem(c));return b.item};d.prototype._loadItem=function(){console.error("This method should be overriden!")};d.prototype._registerItem=function(c,d){var b=!0,a=this.store.getItemByKey(c);if(void 0===a){b=!1;a=this.deletedItems[c];if(void 0===a)throw Error("Trying to register item that was never requested");delete this.deletedItems[c]}a.loaded=!0;a.item=d;a.error=void 0===d;if(b)if(a.error)this.store.removeByKey(c);
else for(;this.store.getLength()>this.getCacheSize();)b=this.store.removeByIndex(0),!b.loaded&&0<b.callbacks.length&&(this.deletedItems[b.name]=b);e.each(a.callbacks,function(a){a(d)});a.callbacks=[]};d.prototype.remove=function(c){c=this.store.removeByKey(c);!c.loaded&&0<c.callbacks.length&&(this.deletedItems[c.name]=c)};d.prototype.getAlternativeName=function(){return null};return d});
define("web-viewer/utils/DrawUtils",["underscore","web-viewer/utils/ShapeUtils","web-viewer/utils/ViewerUtils","web-viewer/utils/Cache"],function(g,e,d,c){function f(a,b,c,d,f){var e=a.width,h=a.height,g=document.createElement("canvas");g.width=e;g.height=h;var s=g.getContext("2d");s.drawImage(a,0,0,e,h);a=s.getImageData(0,0,e,h);for(e=0;e<a.data.length;e+=4)a.data[e]*=b/255,a.data[e+1]*=c/255,a.data[e+2]*=d/255;s.putImageData(a,0,0);void 0===f&&(f=new Image);f.src=g.toDataURL();return f}function b(a,
b,c,d,f,e,h){e||(e=[10,5]);void 0!==h&&null!==h&&(e=g.map(e,function(a){return Math.abs(a/h)}));a.save();a.beginPath();var d=d-b,p=f-c,f=Math.sqrt(d*d+p*p),d=Math.atan2(p,d);a.translate(b,c);a.moveTo(0,0);a.rotate(d);c=e.length;d=0;p=!0;for(b=0;f>b;)b+=e[d++%c],b>f&&(b=f),p?a.lineTo(b,0):a.moveTo(b,0),p=!p;a.stroke();a.restore()}var a=new c(30,!1);a._loadItem=function(a){var b=new Image;b.onload=g.bind(function(){this._registerItem(a,b)},this);b.src=a};var h=new c(30,!1);h._loadItem=function(b){var c=
b.split("|"),d={r:c[1],g:c[2],b:c[3]},e=g.bind(function(a,c){var d=new Image;d.onload=g.bind(function(){this._registerItem(b,d)},this);f(a,c.r,c.g,c.b,d)},this);(c=a.get(c[0],function(a){e(a,d)}))&&e(c,d)};return{LWTYPE_RECT:-1,LWTYPE_ELLIPSE:-2,LWTYPE_LINEARRAY:-3,LWTYPE_LINE:-4,LWTYPE_ARROW:-5,LWTYPE_IMAGE:-7,LWTYPE_TEXT:-21,LWTYPE_DASHEDBOX:-100,LWTYPE_DASHEDLINE:-101,LWANCHOR_TOPLEFT:1,LWANCHOR_TOPRIGHT:2,LWANCHOR_TOPCENTER:3,LWANCHOR_BOTTOMLEFT:4,LWANCHOR_BOTTOMRIGHT:5,LWANCHOR_BOTTOMCENTER:6,
LWANCHOR_CENTERLEFT:7,LWANCHOR_CENTERRIGHT:8,LWANCHOR_CENTERCENTER:9,LWANCHOR_CENTERFREE:10,LWANCHOR_HORIZONTAL:11,LWANCHOR_VERTICAL:12,LWANCHOR_START:13,LWANCHOR_END:14,drawOverlay:function(b,c,f,g,j,n,m,p,s){var v=0;n||(n=1);c.save();if(void 0!==g){var q=g.left(),w=g.top(),q=q*n,r=w*n;if(1E-6>Math.abs(q%1)||1E-6>Math.abs(1-q%1))q=Math.round(q);if(1E-6>Math.abs(r%1)||1E-6>Math.abs(1-r%1))r=Math.round(r);w=0.5+q%1;q=0.5+r%1;c.translate(w/n,q/n)}c.globalAlpha=s?s:1;for(s=0;s<f.length;s++)if(r=f[s],
null!=r){var u=r.rect.copy();if(r.staticsize)var y=u.center(),u=new e.Size(u.size.width/n,u.size.height/n),u=new e.Rect(new e.Point(y.x-u.width/2,y.y-u.height/2),u);if(!g||!u||e.rectIsNull(u)||g.rectIntersect(r.rect)||r.type==this.LWTYPE_TEXT){v++;c.save();var t=Math.floor(r.linewidth);0===t&&(t=1);r.staticwidth||(t=1<n?t/Math.ceil(n):t/n);var x=r.color,A=r.fillcolor;null!==p&&void 0!==p&&(x=p,A&&(A=p));var y=A?!0:!1,z=x?!0:!1;x&&(c.strokeStyle=x);if(y)if(p){var F=d.rgbColor(A);c.fillStyle="rgba("+
F.r+", "+F.g+", "+F.b+", 0.5)"}else c.fillStyle=A;t&&(c.lineWidth=t);switch(r.type){case this.LWTYPE_RECT:x=r.cornerRadius?r.cornerRadius:0;this.drawRect(c,u.origin.x,u.origin.y,u.size.width,u.size.height,x,y,z);break;case this.LWTYPE_ELLIPSE:this.drawEllipse(c,u.origin.x,u.origin.y,u.size.width,u.size.height,y,z);break;case this.LWTYPE_IMAGE:z=r.imageRef;y=a.get(z,j);if(!y)continue;t=void 0;r.color&&(t=r.rgbColor(),t=h.get([z,t.r,t.g,t.b].join("|"),j));z=u.origin.x;x=u.origin.y;x-=y.naturalHeight/
n;0==u.size.width||0==u.size.height?(c.save(),z=u,m&&(x=m.copy(),x.translate(w/n,q/n),z=x.transformedRect(z)),c.setTransform(1,0,0,1,0,0),A=x=0,r.imageOffset&&(x=r.imageOffset.width,A=r.imageOffset.height),c.drawImage(t?t:y,Math.ceil(z.origin.x-0.5)-x,Math.ceil(z.origin.y-0.5)-A),c.restore()):c.drawImage(t?t:y,z,x,u.size.width,u.size.height);break;case this.LWTYPE_TEXT:A||(c.fillStyle=x);t=d.parseFloat(r.textoptions["font-size"]);r.staticsize&&(t*=n);c.font=t+"px "+r.textoptions["font-family"];y=
d.trim(r.textoptions.text);c.textAlign=r.textoptions.textAlignment;g&&(z=c.measureText(y).width,t=new e.Size(z,t),t=e.rectMake(u.origin.x-t.width/2,u.origin.y-t.height/2,t.width,t.height),g.rectIntersect(t));c.save();r.staticsize?(z=u,m&&(z=m.transformedRect(z)),c.setTransform(1,0,0,1,0,0),c.fillText(y,z.origin.x,z.origin.y),c.restore()):(c.translate(u.origin.x,u.origin.y),c.rotate(r.textoptions.rotate*Math.PI/180),c.translate(-u.origin.x,-u.origin.y),c.fillText(y,u.origin.x,u.origin.y));c.restore();
break;case this.LWTYPE_DASHEDBOX:z=r.dash;c.save();c.lineWidth=t;this.drawDashedRect(c,u,z,!r.staticwidth?n:null);c.restore();break;case this.LWTYPE_DASHEDLINE:z=r.dash;c.beginPath();0==u.size.width?this.drawDash(c,u.origin.x,u.origin.y,u.origin.x,u.origin.y+u.size.height,z):this.drawDash(c,u.origin.x,u.origin.y,u.origin.x+u.size.width,u.origin.y,z);c.stroke();break;default:t=r.type==this.LWTYPE_ARROW?!0:!1,x=r.pointArray,z=r.dash,c.beginPath(),0<x.length&&this.drawLine(b,c,x,t,m,n,y,z)}r.showIndicator&&
(c.save(),c.setTransform(1,0,0,1,0,0),t=14,c.font=t+"px Arial",c.textAlign="center",y=r.indicatorText,x=c.measureText(y).width,z=t=72*t/96,A=0.5*z,x+=A,z+=A,A=u,m&&(A=m.transformedRect(A)),u=A.origin,r.type==this.LWTYPE_ELLIPSE?u.x=A.center().x-x/2:r.pointArray&&0<r.pointArray.length&&(u=m.transformedPoint(r.pointArray[0])),A=new e.Rect(new e.Point(u.x,u.y),new e.Size(x,z)),c.fillStyle=r.indicatorColor,c.strokeStyle="black",c.lineWidth=2,x=0,this.drawRect(c,A.origin.x,A.origin.y,A.size.width,A.size.height,
x,!0,!0),c.fillStyle=r.indicatorTextColor,c.fillText(y,A.center().x,u.y+z/2+t/2),c.restore());c.restore()}}c.restore()},generateTintImage:f,drawRect:function(a,b,c,d,f,e,h,g){"undefined"==typeof g&&(g=!0);"undefined"===typeof e&&(e=5);a.save();a.beginPath();a.moveTo(b+e,c);a.lineTo(b+d-e,c);a.quadraticCurveTo(b+d,c,b+d,c+e);a.lineTo(b+d,c+f-e);a.quadraticCurveTo(b+d,c+f,b+d-e,c+f);a.lineTo(b+e,c+f);a.quadraticCurveTo(b,c+f,b,c+f-e);a.lineTo(b,c+e);a.quadraticCurveTo(b,c,b+e,c);a.closePath();g&&a.stroke();
h&&a.fill();a.restore()},drawLine:function(a,b,c,f,h,n,m,p){b.beginPath();for(var s=0;s<c.length;s++){var v=c[s],q=new e.Point(v.x,v.y),w=Math.ceil(v.x*n)/n,r=Math.ceil(v.y*n)/n;void 0===this.dashedLineWarning&&(this.dashedLineWarning=g.once(function(){a.i18n.loadBundle("viewer",function(){a.emit("error.WARNING",a.i18n.t("DashedLineSupport"))})}));var u=p;p&&n&&(u=g.map(p,function(a){return a/n}));var y=!0;u&&(void 0!==b.setLineDash?b.setLineDash(u):void 0!==b.mozDash?b.mozDash=u:y=!1);switch(v.type){case 0:b.moveTo(w,
r);break;case 1:if(y)b.lineTo(w,r);else{var t=c[s-1],t=new e.Point(t.x,t.y);this.drawDash(b,t.x,t.y,w,r,u)}break;case 2:t=new e.Point(v.v1,v.v2);w=new e.Point(v.v3,v.v4);y||this.dashedLineWarning();b.bezierCurveTo(q.x,q.y,t.x,t.y,w.x,w.y);break;case 3:t=c[s-1];t=new e.Point(t.x,t.y);w=v.v1;r=v.v3;u=v.v4;v=v.v5;y||this.dashedLineWarning();this.drawArcFrom(b,t,q,w,u,v,r);break;case 4:q=new e.Point(v.x,v.y);t=q.copy();t.x-=10*v.v3;t.y-=10*v.v2;w=t.copy();w.x-=5*v.v3;w.y-=5*v.v2;y=Math.atan2(t.y-q.y,
t.x-q.x)+Math.PI/2;b.moveTo(q.x,q.y);b.lineTo(t.x,t.y);b.save();b.translate(w.x,w.y);b.rotate(y);b.translate(-w.x,-w.y);b.font="8px Arial";b.textAlign="center";b.fillStyle="blue";q=d.parseFloat(v.v1).toFixed(2);b.fillText(q,w.x,w.y);b.restore();break;default:console.log("a line that is not supported: "+v.type)}}m||b.stroke();f&&1<c.length&&(b.beginPath(),q=c[0],c=c[1],2==c.type?(f=new e.Point(c.v1,c.v2),q=new e.Point(c.v3,c.v4)):(f=new e.Point(q.x,q.y),q=new e.Point(c.x,c.y)),c=q,h&&(f=h.transformedPoint(f),
c=h.transformedPoint(c),b.save(),b.setTransform(1,0,0,1,0,0)),f=new e.Point(c.x-f.x,c.y-f.y),q=Math.sqrt(f.x*f.x+f.y*f.y),0===q?(f.x=0,f.y=0):(f.x/=q,f.y/=q),p=new e.Point(-f.y,f.x),f.x*=8,f.y*=8,p.x*=8,p.y*=8,q=new e.Point(c.x,c.y),q.x+=-f.x+p.x,q.y+=-f.y+p.y,t=new e.Point(q.x,q.y),t.x-=2*p.x,t.y-=2*p.y,b.moveTo(q.x,q.y),b.lineTo(c.x,c.y),b.lineTo(t.x,t.y),h&&b.restore());m?b.fill():b.stroke()},drawArcFrom:function(a,b,c,d,f,h){if(0!=Math.abs(b.x-c.x).toFixed(2)){var f=new e.Point(c.x-b.x,c.y-b.y),
f=Math.sqrt(f.x*f.x+f.y*f.y),g=new e.Point((c.x+b.x)/2,(c.y+b.y)/2),p=Math.sqrt(d*d-f/2*(f/2));h||(p=-p);f=new e.Point(g.x-p*(b.y-c.y)/f,g.y-p*(c.x-b.x)/f);p=(b.x-f.x)/d;g=(c.x-f.x)/d;p=1<p?1:p;g=1<g?1:g;g=-1>g?-1:g;p=Math.acos(-1>p?-1:p);g=Math.acos(g);b.y<f.y&&(p=-p);c.y<f.y&&(g=-g);a.lineTo(b.x,b.y);a.arc(f.x,f.y,d,p,g,h)}a.lineTo(c.x,c.y)},drawDash:function(a,b,c,d,f,e){var h=e.length,g=d-b,s=f-c,v=g>s,q=v?s/g:g/s;9999<q?q=9999:-9999>q&&(q=-9999);for(var w=Math.sqrt(g*g+s*s),r=0,u=!0;0.1<=w;){var y=
e[r++%h];0===y&&(y=0.001);y>w&&(y=w);var t=Math.sqrt(y*y/(1+q*q));v?(b+=0>g&&0>s?-1*t:t,c+=0>g&&0>s?-1*q*t:q*t):(b+=0>g&&0>s?-1*q*t:q*t,c+=0>g&&0>s?-1*t:t);a[u?"lineTo":"moveTo"](b,c);w-=y;u=!u}a.moveTo(d,f)},drawEllipse:function(a,b,c,d,f,e,h){var g=0.5522848*(d/2),s=0.5522848*(f/2),v=b+d,q=c+f,d=b+d/2,f=c+f/2;a.beginPath();a.moveTo(b,f);a.bezierCurveTo(b,f-s,d-g,c,d,c);a.bezierCurveTo(d+g,c,v,f-s,v,f);a.bezierCurveTo(v,f+s,d+g,q,d,q);a.bezierCurveTo(d-g,q,b,f+s,b,f);a.closePath();e&&a.fill();h&&
a.stroke()},distanceFromPointToSegment:function(a,b,c,d){if(b.x>c.x){if(a.x<c.x-d||a.x>b.x+d)return d+1}else if(a.x<b.x-d||a.x>c.x+d)return d+1;if(b.y>c.y){if(a.y<c.y-d||a.y>b.y+d)return d+1}else if(a.y<b.y-d||a.y>c.y+d)return d+1;var f=new e.Point;f.x=c.x-b.x;f.y=c.y-b.y;c=new e.Point;c.x=a.x-b.x;c.y=a.y-b.y;if(0!=f.x||0!=f.y)if(a=f.x*f.x+f.y*f.y,b=f.x*c.x+f.y*c.y,0<b&&b<a)return f=f.y*c.x-f.x*c.y,f*f>d*d*a?d+1:Math.abs(f/Math.sqrt(a));f=c.x*c.x+c.y*c.y;return f>d*d?d+1:Math.sqrt(f)},distanceFromPointToEllipse:function(a,
b,c){if(0==b.size.width||0==b.size.height||a.x<b.origin.x-c||a.y<b.origin.y-c||a.x>b.origin.x+b.size.width+c||a.y>b.origin.y+b.size.height+c)return c+1;var d=new e.Point(0,0);d.x=b.origin.x+b.size.width/2;d.y=b.origin.y+b.size.height/2;var f=new e.Point;f.x=a.x-d.x;f.y=a.y-d.y;f.x*=2/b.size.width;f.y*=2/b.size.height;a=Math.sqrt(f.x*f.x+f.y*f.y);if(1E-4>a)return 0;f.x*=b.size.width*(1-a)/(2*a);f.y*=b.size.height*(1-a)/(2*a);a=f.x*f.x+f.y*f.y;return a>c*c?c+1:Math.sqrt(a)},distanceOfScenePoint:function(a,
b,c,d){d||(d=6);var f=-1,h=a.pointArray;if(h&&0!=h.length)if(1==h.length){var g=c.transformedPoint(h[0].point),g=new e.Point(g.x,g.y);Math.abs(g.x-b.x)<d&&Math.abs(g.y-b.y)<d&&(f=999)}else for(a=0;a<h.length-1;a++){var g=c.transformedPoint(h[a]),p=c.transformedPoint(h[a+1]),g=new e.Point(g.x,g.y),p=new e.Point(p.x,p.y),g=this.distanceFromPointToSegment(b,g,p,d);g<=d&&(f=g)}else if(c=c.transformedRect(a.rect),a.staticsize&&(c=c.center(),h=new e.Size(a.rect.size.width,a.rect.size.height),c=new e.Rect(new e.Point(c.x-
h.width/2,c.y-h.height/2),h)),h=new e.Rect(new e.Point(c.origin.x-d,c.origin.y-d),new e.Size(c.size.width+2*d,c.size.height+2*d)),c.normalize(),h.normalize(),a.type==this.LWTYPE_ELLIPSE)a.fillcolor?c.containsPoint(b)?f=1:h.containsPoint(b)&&(f=999):(g=this.distanceFromPointToEllipse(b,c,d),g<=d&&(f=g));else{if(a.type==this.LWTYPE_IMAGE&&a.imagetouchspot)var g=a.imagetouchspot,p=g.size.width,s=g.size.height,h=new e.Rect(new e.Point(h.origin.x+g.origin.x,h.origin.y+g.origin.y),new e.Size(p+2*d,s+2*
d));h.containsPoint(b)&&((a.fillcolor||a.type==this.LWTYPE_IMAGE)&&!a.treatAsOutline?f=999:(new e.Rect(new e.Point(c.origin.x+d,c.origin.y+d),new e.Size(c.size.width-2*d,c.size.height-2*d))).containsPoint(b)||(f=999))}return f},drawDashedLine:b,drawDashedRect:function(a,c,d,f){var e=c.left()+0.5*a.lineWidth,h=c.right()-0.5*a.lineWidth,g=c.top()+0.5*a.lineWidth,c=c.bottom()-0.5*a.lineWidth;b(a,e,g,h,g,d,f);b(a,e,c,h,c,d,f);b(a,e,g+0.5*a.lineWidth,e,c-0.5*a.lineWidth,d,f);b(a,h,g+0.5*a.lineWidth,h,
c-0.5*a.lineWidth,d,f)}}});
define("web-viewer/utils/Fragment",["web-viewer/utils/Cache","underscore"],function(g,e){var d=new Image,c=function(c,b){this.rect=c;this.zoom=b;this.image=new Image;this.dirty=this.fetched=!1};c.prototype.fetchImage=function(c,b,a,h){this.image=d;c.get(b,e.bind(function(b){void 0===b||b.error?h.call(void 0):(this.image=b,this.fetched=!0,a.call(b))},this))};c.prototype.getImage=function(){return this.image};c.prototype.setImage=function(c){this.image=$("<img>").attr("src",c)[0];this.fetched=!0};c.prototype.isFetched=
function(){return this.fetched};c.prototype.isDirty=function(){return this.dirty};c.prototype.makeDirty=function(){this.dirty=!0};c.prototype.getRect=function(){return this.rect};c.prototype.getZoom=function(){return this.zoom};c.prototype.getNaturalWidth=function(){return this.image.naturalWidth};c.prototype.getNaturalHeight=function(){return this.image.naturalHeight};return c});
define("web-viewer/viewport/model/ViewportFragmentManager",["underscore","web-viewer/utils/ShapeUtils","web-viewer/utils/Fragment"],function(g,e,d){function c(a,b){return Math.abs(a-b)<=f}var f=1E-5,b=function(a,b,c){this.f=a;this.delegate=b;this.world=c;this.fragments=[];this.dirtyInitialFragment=this.initialFragment=null;this.fragmentCache=this.f.getModule("viewport").getImageCache()};b.prototype.getAllFragments=function(){var a=this.fragments.slice(0);a.prepend(this.intialFragment);return a};b.prototype.getInitialFragment=
function(){return!this.initialFragment||!this.initialFragment.isFetched()?this.dirtyInitialFragment:this.initialFragment};b.prototype.isRectCoveredBy=function(a,b){return a.rectEquals(b)||b.containsRect(a)};b.prototype.isFragmentCoveredBy=function(a,b){return c(a.getZoom(),b.getZoom())&&this.isRectCoveredBy(a.getRect(),b.getRect())};b.prototype.preloadFragment=function(a,b){if(!(0===a.size.width||0===a.size.height)){var c=new d(a,b),f=this.getInitialFragment();if(!f||f.isDirty()||!this.isFragmentCoveredBy(c,
f)){for(f=0;f<this.fragments.length;f++){var e=this.fragments[f];if(!e.isDirty()&&this.isFragmentCoveredBy(c,e))return}for(f=0;f<this.fragments.length&&c.getZoom()>=this.fragments[f].getZoom();)f++;this.fragments.splice(f,0,c);c.age=0;c.fetchImage(this.fragmentCache,this.getUrlForFragment(c),g.bind(this._fragmentFetched,this),g.bind(this._removeFragment,this,c))}}};b.prototype.getApplicableFragments=function(a,b){var d=[],f,l=null,i=this.getInitialFragment();if(i&&i.isFetched()){if(!i.isDirty()&&
a.rectEquals(i.getRect())&&c(i.getZoom(),b))return i.perfectFit=!0,d.push(i),d;i.perfectFit=!1}else i=null;var j=[],n=[],m=0,p=0,s=function(a){a.isDirty()?n.push(a):j.push(a);a.age--},v=a.calculateOverlap(this.world.getWorldBounds());for(f=0;f<this.fragments.length;f++){var q=this.fragments[f];q.age+=3;if(!l&&q.isFetched())if(m++,q.isDirty()&&p++,q.getZoom()<=b){if(e.rectIntersection(q.getRect(),a)&&(!i||!(q.getZoom()<i.getZoom()&&i.getZoom()>b)))c(q.getZoom(),b)&&this.isRectCoveredBy(v,q.getRect())?
(q.perfectFit=!0,q.isDirty()||(l=q)):q.perfectFit=!1,s(q)}else this.world.isAnimating()&&3*q.getZoom()<=b&&e.rectIntersection(q.getRect(),a)&&s(q)}if(l)i&&d.push(i),l.age=-3,d.push(l);else{f=q=0;l=n[q];for(s=j[f];l&&(!s||l.getZoom()<s.getZoom());)l.age-=1,d.push(l),l=n[++q];for(;f<j.length;){q=j[f+1];if(!q||!this.isRectCoveredBy(a.calculateOverlap(j[f].getRect()),q.getRect()))j[f].age-=1,d.push(j[f]);f++}}if(i&&(0==d.length||i.getZoom()<=b)){for(f=0;f<d.length&&d[f].getZoom()<i.getZoom();)f++;d.splice(f,
0,i)}m=m-p-5;if(0<m){p=g.sortBy(this.fragments,function(a,b,c){return 100*a.age+(c.length-b)});for(f=p.length-1;0<=f&&0<m;f--)q=p[f],q!==i&&(q.isFetched()&&!q.isDirty()&&!g.contains(d,q))&&(this._removeFragment(q),m--)}return d};b.prototype.getUrlForFragment=function(a){return this.delegate.getURLForFragment(a)};b.prototype._fragmentFetched=function(){this.cleanupDirtyFragments();this.delegate.fragmentsChanged()};b.prototype._removeFragment=function(a){a=g.indexOf(this.fragments,a);0<=a&&this.removeFragmentAtIndex(a)};
b.prototype.removeFragmentAtIndex=function(a){this.fragments.splice(a,1)};b.prototype.cleanupDirtyFragments=function(){var a=g.filter(this.fragments,function(a){return!a.isDirty()});a.length!=this.fragments.length&&g.some(a,function(a){return a.isFetched()})&&(this.fragments=a);this.dirtyInitialFragment=null};b.prototype.markAllAsDirty=function(){this.cleanupDirtyFragments();g.each(this.fragments,function(a){a.makeDirty()});(this.dirtyInitialFragment=this.initialFragment)&&this.dirtyInitialFragment.makeDirty();
this.initialFragment=null};b.prototype.cleanupFragments=function(){this.fragments=[];this.dirtyInitialFragment=this.initialFragment=null};b.prototype.calculateRoundedWorldBounds=function(){var a=this.world.getWorldBounds(),b=this.world.getInitialStartZoom();a.size.width=Math.floor(a.size.width*b)/b;a.size.height=Math.floor(a.size.height*b)/b;return a};b.prototype.updateInitialFragment=function(){var a=this.calculateRoundedWorldBounds();if(0<this.world.getInitialStartZoom()&&(!this.initialFragment||
!c(this.initialFragment.getZoom(),this.world.getInitialStartZoom())||!this.initialFragment.getRect().rectEquals(a)))this.dirtyInitialFragment=this.initialFragment,this.initialFragment=new d(a,this.world.getInitialStartZoom()),this.initialFragment.isInitial=!0,this.initialFragment.fetchImage(this.fragmentCache,this.getUrlForFragment(this.initialFragment),g.bind(this._fragmentFetched,this),g.bind(function(){this.initialFragment=null},this))};return b});
define("utils/ConvertUtils",["jquery","underscore"],function(g){return{getLangFormattedDate:function(e,d){var c=[];c[0]=e.t("MONTH1");c[1]=e.t("MONTH2");c[2]=e.t("MONTH3");c[3]=e.t("MONTH4");c[4]=e.t("MONTH5");c[5]=e.t("MONTH6");c[6]=e.t("MONTH7");c[7]=e.t("MONTH8");c[8]=e.t("MONTH9");c[9]=e.t("MONTH10");c[10]=e.t("MONTH11");c[11]=e.t("MONTH12");null==d&&(d=new Date);var f=d.getMonth(),b=d.getDate(),a=d.getFullYear();return""+c[f]+" "+b+", "+a},getLangFormattedDateAndTime:function(e,d){var c=[];c[0]=
e.t("MONTH1");c[1]=e.t("MONTH2");c[2]=e.t("MONTH3");c[3]=e.t("MONTH4");c[4]=e.t("MONTH5");c[5]=e.t("MONTH6");c[6]=e.t("MONTH7");c[7]=e.t("MONTH8");c[8]=e.t("MONTH9");c[9]=e.t("MONTH10");c[10]=e.t("MONTH11");c[11]=e.t("MONTH12");null==d&&(d=new Date);var f=d.getMonth(),b=d.getDate(),a=d.getFullYear(),h=d.getHours();10>h&&(h="0"+h);var g=d.getMinutes();10>g&&(g="0"+g);return e.t("DateAndTimeString",c[f],b,a,h,g)},getEnglishFormattedDate:function(e,d){var c={};c[e.t("MONTH1")]="Jan";c[e.t("MONTH2")]=
"Feb";c[e.t("MONTH3")]="Mar";c[e.t("MONTH4")]="Apr";c[e.t("MONTH5")]="May";c[e.t("MONTH6")]="Jun";c[e.t("MONTH7")]="Jul";c[e.t("MONTH8")]="Aug";c[e.t("MONTH9")]="Sep";c[e.t("MONTH10")]="Oct";c[e.t("MONTH11")]="Nov";c[e.t("MONTH12")]="Dec";var f=g.trim(d).split(" ");return c[f[0]]?(f[0]=c[f[0]],f.join("")):d},capitaliseFirstLetter:function(e){return e.charAt(0).toUpperCase()+e.slice(1)},getCharacterLineCount:function(e){var d=1,c=0;if(e){for(var e=this.convertHTMLStringToRaw(e),e=e.replace(/\r\n/g,
"\n"),c=0,f=e.indexOf("\n",0);-1!=f;)d++,c++,f=e.indexOf("\n",f+1);c=e.length-c}return{lineCount:d,charCount:c}},convertHTMLStringToRaw:function(e,d){void 0===d&&(d="\n");var c=e.replace(/>[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*([ ]*)[\f\n\r\t\v\u00a0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]*</g,">$1<"),c=c.replace(/.*<body>((\r\n|\n|.)*)<\/body>.*/i,
"$1"),c=c.replace(/^<(blockquote|body|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/,""),c=c.replace(/<(blockquote|body|br|center|dd|dir|div|dl|dt|form|h1|h2|h3|h4|h5|h6|head|hr|html|isindex|li|menu|noframes|ol|p|pre|td|th|title|ul)[^>]*>/g,d),c=c.replace(/<[^>]*>/g,""),c=c.replace(/&nbsp;|&#160;/gi," ");return c=this.decodeHtmlEntities(c)},convertRawStringToHTML:function(e){e=this.encodeHtmlEntities(e);return e=e.replace(/(\r)?\n/g,
"<br />")},decodeHtmlEntities:function(e){return g("<textarea>").html(e).text()},encodeHtmlEntities:function(e){return g("<div>").text(e).html()}}});
define("utils/HTTPUtils",["jquery","underscore","utils/ConvertUtils"],function(g,e,d){return{constructURL:function(c,f,b){var a="";b&&(a+=b);var a=a+c,c="?",h;for(h in f){if(f.hasOwnProperty(h))if(e.isArray(f[h]))for(b=0;b<f[h].length;b++)a+=c+encodeURIComponent(h)+"="+encodeURIComponent(d.decodeHtmlEntities(f[h][b]));else a+=c+encodeURIComponent(h)+"="+encodeURIComponent(d.decodeHtmlEntities(f[h]));c="&"}return a}}});
define("web-viewer/viewport/ViewportLayer","jquery underscore web-viewer/utils/DrawUtils web-viewer/utils/ShapeUtils web-viewer/utils/Transformation web-viewer/utils/ListenerUtil web-viewer/utils/Fragment web-viewer/utils/ConversionConstants web-viewer/viewport/model/ViewportFragmentManager utils/HTTPUtils web-viewer/layout/component/Popover".split(" "),function(g,e,d,c,f,b,a,h,o,k,l){var i=function(a,c,d,f,h){this.f=a;b.mixin(this,a);this._id=h;this._canvas=g("<canvas>").css({position:"absolute",
top:0,left:0}).attr("id",this._id);this._layerModel=null;this._view=c;this._canvasIsShown=this._visible=!0;this._listeners=[];this._world=d;this._transform=f;this._shouldBuffer=this._enableBuffer=!1;this._buffer=null;this._interactive=this._dirty=this._debugBuffer=!1;this.throttledRender=e.throttle(e.bind(this.render,this),40);this.debouncedRepaint=e.debounce(e.bind(function(){var a=this._dirty;this._dirty=!1;this.preloadViewportFragment();this.throttledRender();a&&this.f.emit("viewportLayer.finishedImageDataRequest",
this._id)},this),40);this._fragmentManager=new o(this.f,{getURLForFragment:e.bind(function(a){return this.generateFragmentURL(a)},this),fragmentsChanged:this.throttledRender},this._world);this._overwriteOptions={}};i.prototype.getLayerModel=function(){return this._layerModel};i.prototype.setLayerModel=function(a){this._unregisterAllListeners();this._layerModel=a;this._registerListener("modelChanged",this.onLayerModelChange,this,this._layerModel);this._registerListener("popoverAdded",this.onPopoverAdded,
this,this._layerModel);this._registerListener("popoverRemoved",this.onPopoverRemoved,this,this._layerModel);this._registerListener("repaint",this.repaint,this,this._layerModel);this._registerListener("fragmentsDirty",this.markAllFragmentsAsDirty,this,this._layerModel);this._registerListener("cleanupFragments",this.cleanupFragments,this,this._layerModel);this._registerListener("overwriteOption.**",this.markAllFragmentsAsDirty,this,this._layerModel);this._registerListener("changed.visible",function(){this.repaint()},
this,this._layerModel);this.repaint()};i.prototype.destroy=function(){this._unregisterAllListeners();this.hideAllPopovers();this._canvas.remove()};i.prototype.onLayerModelChange=function(){this.throttledRender()};i.prototype.startInteractive=function(){this._interactive=this._shouldBuffer=!0;this.hideAllNonInteractivePopovers();this.hideAllPopups()};i.prototype.stopInteractive=function(){this._interactive=this._shouldBuffer=!1;this._world.isAnimating()||(this.drawPopovers(),this.drawPopups(),this.preloadViewportFragment())};
i.prototype.setVisible=function(a){this._visible=a;this.repaint()};i.prototype.setSize=function(a){if(this._canvas[0].width!=a.width||this._canvas[0].height!=a.height)this._canvas[0].width=a.width,this._canvas[0].height=a.height,this.render()};i.prototype.getCanvas=function(){return this._canvas};i.prototype.getCanvasContext=function(){return this._canvas[0].getContext("2d")};i.prototype.setOverwriteOptions=function(a){this._overwriteOptions=a;this.markAllFragmentsAsDirty()};i.prototype.isVisible=
function(){return this._visible&&(!this._layerModel||this._layerModel.isVisible())};i.prototype.getClosestLineworkFromPoint=function(a,b){if(this._layerModel){for(var c=null,f=-1,e=this.getTransformMatrix(),h=this._world.getWorldRectFromScene(this._world.getSceneBounds(),e),g=this._layerModel.getLinework(),k=0;k<g.length;k++){var i=g[k];if(!i.rect||!(0<i.rect.size.width&&0<i.rect.size.height)||h.rectIntersect(i.rect)){var o=d.distanceOfScenePoint(i,a,e,b);if(0<o&&(0>f||o<=f))c=i,f=o}}return c}};i.prototype.getClosestLineworkPointFromPoint=
function(a,b){var d=null;if(null!==this._layerModel)for(var f=this.getTransformMatrix(),f=this._world.getWorldRectFromScene(this._world.getSceneBounds(),f),e=new c.Size(b,b),h=new c.Rect(new c.Point(a.x-b/2,a.y-b/2),e),e=this.getWorldPointFromScene(a),h=this.getWorldRectFromScene(h),g=this._layerModel.getLinework(),k=0;k<g.length;k++){var i=g[k];if(i.snapable&&(i.pointArray&&0<i.pointArray.length)&&(!i.rect||!(0<i.rect.size.width&&0<i.rect.size.height&&!f.rectIntersect(i.rect))))for(var i=i.pointArray,
o=0;o<i.length;o++){var l=i[o];if(h.containsPoint(l)&&(l=new c.Point(l.x,l.y),!d||l.getDistance(e)<d.getDistance(e)))d=l}}return d?this.getScenePointFromWorld(d):null};i.prototype.getWorldPointFromScene=function(a){return this._world.getWorldPointFromScene(a,this.getTransformMatrix())};i.prototype.getWorldRectFromScene=function(a){return this._world.getWorldRectFromScene(a,this.getTransformMatrix())};i.prototype.getSceneRectFromWorld=function(a){return this._world.getSceneRectFromWorld(a,this.getTransformMatrix())};
i.prototype.getScenePointFromWorld=function(a){return this._world.getScenePointFromWorld(a,this.getTransformMatrix())};i.prototype.getLayerTransform=function(){var a=this._layerModel.getTransform().copy(),b=new f,c=this._world.getWorldSize().width/2-a.e,d=this._world.getWorldSize().height/2-a.f;b.translate(c,d);b.concatenate(a);b.translate(-c,-d);return b};i.prototype.convertLayerRectToWorld=function(a){return this.getLayerTransform().transformedRect(a)};i.prototype.convertWorldRectToLayer=function(a){return this.getLayerTransform().createInverse().transformedRect(a)};
i.prototype.convertLayerPointToWorld=function(a){return this.getLayerTransform().transformedPoint(a)};i.prototype.convertWorldPointToLayer=function(a){return this.getLayerTransform().createInverse().transformedPoint(a)};i.prototype.getTransformMatrix=function(){var a=new f;if(this._layerModel){var b=this._layerModel.getTransform();a.preConcatenate(b)}var b=this._world.getWorldSize().width/2-this._transform.e,c=this._world.getWorldSize().height/2-this._transform.f;a.preTranslate(-b,-c);a.preConcatenate(this._transform);
a.preTranslate(b,c);a.preConcatenate(this._world.getTransformation());return a};i.prototype.getZoom=function(){var a=this._world.getTransformation();return Math.sqrt(a.c*a.c+a.d*a.d)};i.prototype.addFragment=function(a,b){if(!isNaN(b)){var c=this._layerModel.getMaximumResolution();0<=c&&(b=Math.min(c,b));this._fragmentManager.preloadFragment(a,b,!0)}};i.prototype.generateFragmentURL=function(a){var a=this._layerModel.getContextForFragment(a),b=a.params.color;void 0===a.params.file&&void 0!==a.params.diff&&
(a.params.file=a.params.diff,delete a.params.diff,a.params.rs=1==a.params.rs?2:1);a.params=e.extend(a.params,this._overwriteOptions);delete a.params.colorBITWISE;void 0!==this._overwriteOptions.colorBITWISE&&(b=void 0!==b?a.params.color&this._overwriteOptions.colorBITWISE:this._overwriteOptions.colorBITWISE,a.params.color=b);delete a.params.isDefaultView;a=k.constructURL(a.servlet,a.params);return a=a.replace(/%2C/g,",")};i.prototype.getApplicableFragments=function(a,b){return this._fragmentManager.getApplicableFragments(a,
b)};i.prototype.markAllFragmentsAsDirty=function(){this._dirty||(this._dirty=!0,this.canFetchFragments()&&this.f.emit("viewportLayer.startImageDataRequest",this._id));this._fragmentManager.markAllAsDirty();this.repaint()};i.prototype.cleanupFragments=function(){this._fragmentManager.cleanupFragments();this.repaint()};i.prototype.repaint=function(a,b){a&&(this._world=a);b&&(this._transform=b);this._canvasIsShown!=this.isVisible()&&(this._canvasIsShown=this.isVisible(),this._canvas.toggle(this._canvasIsShown));
this.debouncedRepaint();this.throttledRender()};i.prototype.canFetchFragments=function(){return null!==this._layerModel&&!this._interactive&&this.isVisible()&&void 0!==this._world&&null!==this._world&&this._layerModel.hasGraphics()&&0<this._world.getZoom()&&this.f.canFetchFragments()};i.prototype.preloadViewportFragment=function(){if(this.canFetchFragments()){var a=this._world.getZoom(),b=this._world.getAnimationDestinationTargetViewPort();b.size.width=Math.floor(b.size.width*a)/a;b.size.height=Math.floor(b.size.height*
a)/a;this._layerModel.shouldAutoFetchFragments()?(this.addFragment(b,a),this._world.isAnimating()||this._fragmentManager.updateInitialFragment()):this._layerModel.preloadFragment(b,a)}};i.prototype.zoomingStarted=function(){this._isZooming=!0};i.prototype.zoomingStopped=function(){this._isZooming=!1};i.prototype.panningStarted=function(){if(null!==this._layerModel&&this._layerModel.hasLinework(this._view.getPanel().getModel().getName())&&!this._layerModel.hasBuffer(this._view.getPanel().getModel().getName())&&
this._canvasIsShown){var b=this._world.getZoom(),d=this._world.getTargetViewPort(!0),f=this._world.getRotation(),e=this._world.isFlip();if(this._world.isFlipViewFromBack()){if(90===f||270===f)f=(f+180)%360;e=!e}var f=(360+f)%360,h=d.size.width,g=d.size.height;270===f%360?(g>h&&!e&&(d.origin.x-=g-h),d.size=new c.Size(g,h)):90===f%360&&(h>g?d.origin.y+=g-h:g>h&&e&&(d.origin.x-=g-h),d.size=new c.Size(g,h));b=new a(d,b);h=this._world.getSceneBounds();d=document.createElement("canvas");g=Math.max(h.size.width,
h.size.height);90===f%360||270===f%360?(d.width=g,d.height=g):(d.width=h.size.width,d.height=h.size.height);h=d.getContext("2d");h.translate(d.width/2,d.height/2);e&&h.scale(-1,1);h.rotate((360-f%360)/180*Math.PI);h.translate(-d.width/2,-d.height/2);h.drawImage(this._canvas[0],0,0);b.image=d;b.fetched=!0;void 0!==this._layerModel.setBuffer&&this._layerModel.setBuffer(b)}};i.prototype.panningStopped=function(){null!==this._layerModel&&(this._layerModel.hasLinework(this._view.getPanel().getModel().getName())&&
void 0!==this._layerModel.setBuffer)&&(this._layerModel.setBuffer(null),this.throttledRender())};i.prototype.render=function(){if(this._layerModel&&this._world&&this._transform&&!(0===this._world.getWorldSize().width&&0===this._world.getWorldSize().height)&&this.isVisible()){this._world.isAnimating()&&(this.hideAllPopovers(),this.hideAllPopups());var a=this.getCanvasContext();a.setTransform(1,0,0,1,0,0);a.clearRect(0,0,this._canvas.width(),this._canvas.height());var b=this.getTransformMatrix();a.transform(b.a,
b.b,b.c,b.d,b.e,b.f);var c=b.getScaleX(),d=this._world.getWorldRectFromScene(this._world.getSceneBounds(),b);this._renderBackground(a);this._renderFragments(a,d,c);this._renderLinework(a,d,c,b);this._layerModel.render(a,d,c,b);this._world.isAnimating()||(this.drawPopovers(),this.drawPopups())}};i.prototype._renderBackground=function(a){var b=this._layerModel.getBackgroundOptions();if(0<e.size(b)){a.save();for(var c in b)b.hasOwnProperty(c)&&(a[c]=b[c]);b=this._world.getWorldBounds();b=this._layerModel.getTransform().createInverse().transformedRect(b);
a.fillRect(b.origin.x,b.origin.y,b.size.width,b.size.height);a.restore()}};i.prototype._renderFragments=function(a,b,c){if(this._layerModel.hasGraphics()){b=this._layerModel.shouldAutoFetchFragments()?this.getApplicableFragments(b,c):this._layerModel.fragments(b,c);a.save();c=this._world.getZoom();a.scale(1/c,1/c);for(var d=0;d<b.length;d++){var f=b[d];if(f.isFetched()){var e=f.getRect(),h=Math.floor(e.origin.x*c),g=Math.floor(e.origin.y*c),k=Math.ceil(e.size.width*c),e=Math.ceil(e.size.height*c);
5E-4>Math.abs(f.getZoom()-c)&&(k=f.getNaturalWidth(),e=f.getNaturalHeight());a.drawImage(f.image,h,g,k,e)}}a.restore()}};i.prototype._renderLinework=function(a,b,c,f){if(!this._layerModel.hasBuffer(this._view.getPanel().getModel().getName())||!this._layerModel.hasLinework(this._view.getPanel().getModel().getName())){var h=this._layerModel.getLinework(this._world.isAnimating(),this._world.isAnimatingRotation(),b,this._view.getModel().getID(),this._view.getPanel().getModel().getName(),this._isZooming);
h&&0<h.length&&(this._buffer=null,d.drawOverlay(this.f,a,h,b,e.bind(this.throttledRender,this),c,f,this._layerModel.getLineworkColor(),this._layerModel.getAlpha()))}else this._layerModel.hasLinework(this._view.getPanel().getModel().getName())&&this._layerModel.hasBuffer(this._view.getPanel().getModel().getName())&&this._renderBuffer(a,c,f)};i.prototype._renderBuffer=function(a,b,c){var d=this._layerModel.getBuffer();if(null!==d){a.save();b=this._world.getZoom();c=this._world.getTransformation();a.setTransform(1,
0,0,1,0,0);a.transform(c.a,c.b,c.c,c.d,c.e,c.f);a.scale(1/b,1/b);if(d.isFetched()){var f=d.getRect(),c=f.origin.x*b,e=f.origin.y*b,h=f.size.width*b,f=f.size.height*b,g=d.getImage();5E-4>Math.abs(d.getZoom()-b)&&(h=g.width,f=g.height);a.drawImage(g,c,e,h,f)}a.restore()}};i.prototype.onPopoverAdded=function(a){var b=this._layerModel.getPopoverModel(a);if(void 0===this._layerModel.getPopover(a)){var c={},d=g("<div>").css("pointer-events","none");this.f.getContext().find(".viewport").append(d);c.popoverDiv=
d;d=new l(d,b.getContext(),this._canvas,b.getPreferredPosition(),"#fff",b.getClass(),b.getRestrictBorder());d.element.mouseenter(function(a){g(this).hide();a=document.elementFromPoint(a.clientX,a.clientY);g(this).show();g(a).mouseenter()});if(b.onAddedToContainer)d.onAddedToContainer(b.onAddedToContainer);if(b.onDestroy)d.onDestroy(b.onDestroy);d.setContent(b.getContent());c.popover=d;this._layerModel.savePopover(c,a);this.drawPopovers()}};i.prototype.onPopoverRemoved=function(a){var b=this._layerModel.getPopover(a);
b&&(b.popover.hide(),b.popover.destroy(),b.popoverDiv.remove(),this._layerModel.removePopover(a))};i.prototype.hideAllPopovers=function(){null!==this._layerModel&&e.each(this._layerModel.getAllPopovers(),function(a){a.popover.hide();a.popoverDiv.hide()})};i.prototype.hideAllNonInteractivePopovers=function(){null!==this._layerModel&&e.each(this._layerModel.getAllPopovers(),function(a,b){this._layerModel.getPopoverModel(b).isInteractive()||(a.popover.hide(),a.popoverDiv.hide())},this)};i.prototype.drawPopovers=
function(){this._layerModel&&(this.isVisible()&&this._view.isActive())&&e.each(this._layerModel.getAllPopovers(),function(a,b){a.popover.restrict=this._canvas;a.popoverDiv.show();var c=this._layerModel.getPopoverModel(b),d=c.getFrame();if(d){var d=this._world.getSceneRectFromWorld(d,this.getTransformMatrix()),f=this._view.getViewLocation(),e=0;this._view.isTitleVisible()&&(e=this._view.getTitleHeight());a.popoverDiv.css({position:"absolute",width:d.size.width+10+"px",height:d.size.height+10+"px",
top:d.origin.y+f.y+e-5+"px",left:d.origin.x+f.x-5+"px"});a.popover.setPreferredPlacement(c.getPreferredPosition());a.popover.show()}},this)};i.prototype.hideAllPopups=function(){this._layerModel&&e.each(this._layerModel.getPopupModels(),function(a){a.getPopup(this).hide()},this)};i.prototype.drawPopups=function(){this._layerModel&&this._canvasIsShown&&e.each(this._layerModel.getPopupModels(),function(a){if(a.isShown()&&!this._interactive){var b=this.getScenePointFromWorld(a.getWorldOrigin()),d=a.getWorldSize().copy();
d.width*=h.MM_TO_PX_RATIO;d.height*=h.MM_TO_PX_RATIO;var f=a.getSceneOffset();f&&(b.x+=f.width,b.y+=f.height);a.getPopup(this).setRect(new c.Rect(b,d));if(0===a.getPopup(this).listeners("resized").length)a.getPopup(this).on("resized",e.bind(function(b,d){var f=a.getSceneOffset();f&&(b.origin.x-=f.width,b.origin.y-=f.height);f=this.getWorldRectFromScene(b);f.size.width=b.size.width*h.PX_TO_MM_RATIO;f.size.height=b.size.height*h.PX_TO_MM_RATIO;var f=this.getWorldPointFromScene(b.origin),e=b.size.copy();
e.width*=h.PX_TO_MM_RATIO;e.height*=h.PX_TO_MM_RATIO;a.onResized(new c.Rect(f,e),d)},this));if(0===a.getPopup(this).listeners("dragged").length)a.getPopup(this).on("dragged",e.bind(function(b){var c=a.getSceneOffset();c&&(b.x-=c.width,b.y-=c.height);a.onDragged(this.getWorldPointFromScene(b))},this));a.getPopup(this).show()}else a.getPopup(this).hide()},this)};return i});
define("web-viewer/viewport/ViewportView",["underscore","web-viewer/viewport/ViewportLayer","web-viewer/utils/ShapeUtils","web-viewer/utils/ListenerUtil"],function(g,e,d,c){var f=function(b,a,d,f){this._world=a;this.f=b;this.id=d;c.mixin(this,b);this.element=this._viewWrapper=$("<div />").addClass("view").attr("name",this.id);this._title=null;this._viewTitle=$("<div />").addClass("viewTitle");this._viewWrapper.append(this._viewTitle);this._titleShown=!1;this._viewDiv=$("<div />").css({position:"relative"});
this._viewWrapper.append(this._viewDiv);this.borders={left:!1,right:!1};this._isActive=!1;this._rect=null;this._viewportPanel=f;this.layers={};this._disabledLayers=[];this._isPanning=!1;this._viewportViewModel=void 0;this._overwriteOptions={};this._throttledRender=g.throttle(this._renderView,40);this.recalculateViewSize();this._registerListener("viewport.startInteractive",function(){g.each(this.layers,function(a){a.startInteractive()})},this);this._registerListener("viewport.stopInteractive",function(){g.each(this.layers,
function(a){a.stopInteractive()})},this);this.element.mouseenter(g.bind(function(){this._isActive=!0},this));this.element.mouseleave(g.bind(function(){this._isActive=!1},this))};f.prototype.getLayer=function(b){return this.layers[b]};f.prototype.isActive=function(){return this._isActive||this.isDefaultView()&&!this._viewportPanel.isViewportWidgetActive()};f.prototype.getClosestLineworkPointFromPoint=function(b,a,c){var d=null,f;f=c?g.filter(this.layers,function(a){return a.getLayerModel()?g.contains(c,
a.getLayerModel().getName()):!1}):this.layers;g.each(f,function(c){if((c=c.getClosestLineworkPointFromPoint(b,a))&&(!d||c.getDistance(b)<d.getDistance(b)))return d=c,!0});return d};f.prototype.getClosestLineworkFromPoint=function(b,a,c){var d=null,f;f=a?g.filter(this.layers,function(b){return b.getLayerModel()?g.contains(a,b.getLayerModel().getName()):!1}):this.layers;g.each(f,function(a){d||(d=a.getClosestLineworkFromPoint(b,c))});return d};f.prototype.recalculateViewSize=function(){var b={width:this._viewWrapper.innerWidth(),
height:this._viewWrapper.innerHeight()-this._viewTitle.outerHeight(!0)};this.borders.left&&(b.width--,b["border-left"]="1px solid");this.borders.right&&(b.width--,b["border-right"]="1px solid");this._viewDiv.css(b)};f.prototype.hideLayer=function(b,a){this.layers[b]&&this.layers[b].setVisible(!a)};f.prototype.hideAllLayers=function(b){g.each(this.layers,function(a,c){this.hideLayer(c,b)},this)};f.prototype.setRect=function(b){this._viewWrapper.css({position:"absolute",width:b.size.width,height:b.size.height,
top:b.top(),left:b.left()});this._rect=b;this.resizeLayers();this.repaint()};f.prototype.getViewLocation=function(){var b=new d.Point;null!==this._rect&&(b=this._rect.origin.copy());var a=this._viewportPanel.getPosition();void 0!==a&&(b.x+=a.x,b.y+=a.y);return b};f.prototype.getWrapperContext=function(){return this._viewWrapper};f.prototype.getViewContext=function(){return this._viewDiv};f.prototype.resizeLayers=function(){this.recalculateViewSize();g.each(this.layers,g.bind(function(b){this._resizeLayer(b)},
this))};f.prototype._resizeLayer=function(b){b.setSize(new d.Size($(this._viewDiv).width(),$(this._viewDiv).height()))};f.prototype._insertLayerAtIndex=function(b,a){var c=this._viewDiv.children().size();0>b&&(b=Math.max(0,c+1+b));b<c?this._viewDiv.children().eq(Math.max(0,b)).before(a):this._viewDiv.append(a)};f.prototype.addLayer=function(b){var a=this.layers[b];if(!a){a=new e(this.f,this,this._world,this._viewportViewModel.getTransform(),this.id+"_"+b);a.setOverwriteOptions(this._getOverwriteOptions());
var c=this._viewportViewModel.indexForLayer(b,this.layers);this._insertLayerAtIndex(c,a.getCanvas());a.setVisible(this.isLayerVisible(b));this.layers[b]=a}(b=this._viewportViewModel.modelForLayer(b))&&a.setLayerModel(b);this.recalculateViewSize();this._resizeLayer(a);return a};f.prototype._getOverwriteOptions=function(){return this._overwriteOptions};f.prototype.repaint=function(b,a){this._viewportViewModel.isShown()&&(void 0!==b&&(this._world=b),this._throttledRender(a))};f.prototype.setModel=function(b){this._viewportViewModel&&
this._unregisterAllListenersForObject(this._viewportViewModel);this._viewportViewModel=b;this._registerListener("layerAdded",this._addLayerToView,this,this._viewportViewModel);this._registerListener("layerRemoved",this.removeLayer,this,this._viewportViewModel);this._registerListener("titleChanged",this._repaintTitle,this,this._viewportViewModel);this._registerListener("showChanged",this._showHide,this,this._viewportViewModel);for(b=0;b<this._viewportViewModel.numberOfLayers();b++){var a=this._viewportViewModel.nameForLayerAtIndex(b);
this.addLayer(a)}};f.prototype.getModel=function(){return this._viewportViewModel};f.prototype.removeLayer=function(b){this.layers[b]?(this.layers[b].destroy(),delete this.layers[b]):this.f.debug.debug("Trying to remove a layer that does not exists: "+b)};f.prototype._addLayerToView=function(b){this.addLayer(b);this._throttledRender(b)};f.prototype._showHide=function(){this._viewportViewModel.isShown()?(this._viewWrapper.show(),this.hideAllLayers(!1)):(this.hideAllLayers(!0),this._viewWrapper.hide())};
f.prototype.getTitleHeight=function(){return $(this._viewTitle).outerHeight(!0)};f.prototype.isTitleVisible=function(){return this._titleShown};f.prototype._repaintTitle=function(){var b=this._viewportViewModel.getTitle();null!==this._title&&(b=this._title);b?(this._viewTitle.text(b),this._viewTitle.attr("title",b),this._titleShown||(this._viewTitle.show(),this._titleShown=!0,this.recalculateViewSize(),this.resizeLayers())):(this._viewTitle.empty(),this._titleShown&&(this._viewTitle.hide(),this._titleShown=
!1,this.recalculateViewSize(),this.resizeLayers()))};f.prototype._renderView=function(b){this._repaintTitle();b?(b=this.layers[b])&&b.repaint(this._world,this._viewportViewModel.getTransform()):g.each(this.layers,function(a){a.repaint(this._world,this._viewportViewModel.getTransform())},this)};f.prototype.isPanning=function(){return this._isPanning};f.prototype.setBorderVisibility=function(b,a){this.borders.left=b;this.borders.right=a};f.prototype.destroy=function(){this._unregisterAllListeners();
g.each(this.layers,function(b){b.destroy()});this.element.remove()};f.prototype.getID=function(){return this.id};f.prototype.setOverwriteOptions=function(b){this._overwriteOptions=b;g.each(this.layers,function(a){a.setOverwriteOptions(b)})};f.prototype.toggleLayer=function(b,a){var c=this.layers[b];c&&c.setVisible(a);a?this._disabledLayers=g.without(this._disabledLayers,b):this._disabledLayers.push(b)};f.prototype.toggleLayers=function(b,a){g.each(b,function(b){this.toggleLayer(b,a)},this)};f.prototype.isLayerVisible=
function(b){return 0>g.indexOf(this._disabledLayers,b)};f.prototype.setTitle=function(b){this._title=b;this._repaintTitle()};f.prototype.isDefaultView=function(){return this._viewportViewModel.isDefaultView()&&this._overwriteOptions.isDefaultView};f.prototype.panningStarted=function(){this._isPanning=!0;g.each(this.layers,function(b){b.panningStarted()})};f.prototype.panningStopped=function(){this._isPanning=!0;g.each(this.layers,function(b){b.panningStopped()})};f.prototype.zoomingStarted=function(){this._isZooming=
!0;g.each(this.layers,function(b){b.zoomingStarted()})};f.prototype.zoomingStopped=function(){this._isZooming=!1;g.each(this.layers,function(b){b.zoomingStopped()})};f.prototype.getPanel=function(){return this._viewportPanel};return f});
define("web-viewer/viewport/ViewportPanel","web-viewer/utils/ListenerUtil web-viewer/utils/ShapeUtils web-viewer/viewport/ViewportView web-viewer/viewport/ViewportConstants underscore jquery".split(" "),function(g,e,d,c,f,b){var a=function(a,c,d,e){this.f=a;g.mixin(this,a);this._viewObjects={};this._widgetModel=d;this._panelModel=c;this._viewportWorld=e;this.element=b("<div/>").attr("name",c.getName()).css({top:0,left:0}).addClass("viewportPanel");this.container=b("<div />").addClass("viewportPanelContainer");
this.element.append(this.container);this._debouncedLayout=f.debounce(this._layout,50);this.updateOverwriteOptions=f.debounce(this._updateOverwriteOptions,20);this._registerListener("changed.overwriteOption.**",this.updateOverwriteOptions,this,this._panelModel);this._registerListener("changed.disabledLayers",this.updateDisabledLayers,this,this._panelModel);this._registerListener("changed.headerText",this.updatePanelHeader,this,this._panelModel);this._registerListener("changed.view.toggle.*",this.layout,
this,this._widgetModel);this._registerListener("changed.view.order",this.layout,this,this._widgetModel);this._registerListener("changed.view.remove",function(a){this._destroyView(a.getID())},this,this._widgetModel);this._registerListener("changed.layout.*",this.layout,this,this._widgetModel);this._registerListener("viewport.startPanning",f.bind(function(){this._isPanning=!0;f.each(this._viewObjects,function(a){a.panningStarted()})},this));this._registerListener("viewport.stopPanning",f.bind(function(){this._isPanning=
!1;f.each(this._viewObjects,function(a){a.panningStopped()})},this));this._registerListener("viewport.startZooming",f.bind(function(){this._isZooming=!0;f.each(this._viewObjects,function(a){a.zoomingStarted()})},this));this._registerListener("viewport.stopZooming",f.bind(function(){this._isZooming=!1;f.each(this._viewObjects,function(a){a.zoomingStopped()})},this));this.repaint=f.throttle(f.bind(function(){this._repaint()},this),40)};a.prototype.destroy=function(){this._unregisterAllListeners();f.each(this._viewObjects,
function(a){a.destroy()});this.element.remove()};a.prototype.isViewportWidgetActive=function(){return this._widgetModel.isWidgetActive()};a.prototype.layout=function(){this.hasBeenLayouted?this._debouncedLayout():this._layout()};a.prototype.getModel=function(){return this._panelModel};a.prototype._layout=function(){var a=this._widgetModel.getResolvedViewsLayoutMode(),b=this._widgetModel.getShownViewKeys();this.viewCount={total:b.length};a===c.ViewsLayoutMode.HORIZONTAL?this._layoutViewsHorizontal(b):
a===c.ViewsLayoutMode.VERTICAL?this._layoutViewsVertical(b):this._layoutViewsAutomatic(b);0<this.viewCount.total&&(this.hasBeenLayouted=!0);this.updatePanelHeader()};a.prototype._layoutViewsVertical=function(a){var b=new e.Size(this.container.width(),this.container.height()),c=a.length;this.viewCount.x=c;this.viewCount.y=1;var d=Math.ceil(b.width/c),g=Math.ceil(b.height/1),b=new e.Size(d,g);this._widgetModel.setSizeForView(b);f.each(a,function(b,c){var f=this.getView(b);f.setBorderVisibility(!1,c<
a.length-1);f.setRect(e.rectMake(d*c,0,d,g))},this)};a.prototype._layoutViewsHorizontal=function(a){var b=new e.Size(this.container.width(),this.container.height()),c=a.length;this.viewCount.x=1;this.viewCount.y=c;var d=Math.ceil(b.width/1),g=Math.ceil(b.height/c),b=new e.Size(d,g);this._widgetModel.setSizeForView(b);f.each(a,function(a,b){var c=this.getView(a);c.setBorderVisibility(!1,!1);c.setRect(e.rectMake(0,g*b,d,g))},this)};a.prototype._layoutViewsAutomatic=function(a){var b=new e.Size(this.container.width(),
this.container.height()),c=a.length,d=c,g=1;if(1<c){d=Math.floor(Math.round(Math.sqrt(c)*b.width/b.height));1>d&&(d=1);var g=Math.floor((c+d-1)/d),d=Math.floor((c+g-1)/g),j=d*g-c;if(1<d&&1<g&&0<j){var n=d+1,m=Math.floor((c+n-1)/n),p=n*m-c,s=g+1,v=Math.floor((c+s-1)/s),c=v*s-c;Math.min(p,c)<j&&(p<=c?(d=n,g=m):(d=v,g=s))}}this.viewCount.x=d;this.viewCount.y=g;var q=Math.ceil(b.width/d),w=Math.ceil(b.height/g),b=new e.Size(q,w);this._widgetModel.setSizeForView(b);f.each(a,function(a,b){var c=this.getView(a);
c.setBorderVisibility(!1,b%d<d-1);c.setRect(e.rectMake(q*Math.floor(b%d),w*Math.floor(b/d),q,w))},this)};a.prototype._repaint=function(){f.each(this._widgetModel.getShownViewKeys(),function(a){this.getView(a).repaint(this._viewportWorld)},this)};a.prototype._updateOverwriteOptions=function(){var a=this._panelModel.getOverwriteOptions();f.each(this._widgetModel.getShownViewKeys(),function(b){this.getView(b).setOverwriteOptions(a)},this)};a.prototype.updateDisabledLayers=function(a,b){var c=f.difference(a,
b);f.each(this._viewObjects,function(a){a.toggleLayers(c,!0);a.toggleLayers(b,!1)})};a.prototype.getView=function(a){return this._viewObjects[a]?this._viewObjects[a]:this._createView(a)};a.prototype._createView=function(a){var b=new d(this.f,this._viewportWorld,this._panelModel.getName()+"_"+a,this);b.setModel(this._widgetModel.getViewModel(a));b.setOverwriteOptions(this._panelModel.getOverwriteOptions());b.toggleLayers(this._panelModel.getDisabledLayers(),!1);this._viewObjects[a]=b;this.container.append(b.element);
return b};a.prototype._destroyView=function(a){this._viewObjects[a]&&(this._viewObjects[a].destroy(),delete this._viewObjects[a])};a.prototype.getViewAt=function(a){var a=a.copy(),b=this.element.offset();a.x-=b.left;a.y-=b.top;var b=this._widgetModel.getResolvedViewsLayoutMode(),d=this._widgetModel.getSizeForView();if(!(0===d.width||0===d.height)){var f=0,f=b===c.ViewsLayoutMode.HORIZONTAL?Math.floor(a.y/d.height):b===c.ViewsLayoutMode.VERTICAL?Math.floor(a.x/d.width):Math.floor(a.y/d.height)*this.viewCount.x+
Math.floor(a.x/d.width);return this._viewObjects[this._widgetModel.getIDForShownViewsAtIndex(f)]}};a.prototype.getViewIfExists=function(a){return this._viewObjects[a]};a.prototype.setBounds=function(a,b){this.element.css({left:a.x,top:a.y,width:b.width,height:b.height});this.position=a;this.layout()};a.prototype.getPosition=function(){return void 0!==this.position?this.position.copy():new e.Point};a.prototype.updatePanelHeader=function(){var a=this._panelModel.getHeaderText(),b=this._widgetModel.getShownViewKeys().length,
c=this._widgetModel.getIDForViewAtIndex(0);null!==a&&0<b?this._viewObjects[c].setTitle(a):1<b?this.f.i18n.loadBundle("viewer",function(){this._viewObjects[c].setTitle(this.f.i18n.t("CaptionComposite"))},this):1===b&&this._viewObjects[c].setTitle(null)};return a});
define("web-viewer/viewport/ViewportWidget","web-viewer/layout/AbstractWidget web-viewer/viewport/ViewportWorld web-viewer/utils/ShapeUtils web-viewer/viewport/tools/ToolManager web-viewer/viewport/ViewportConstants web-viewer/viewport/ViewportPanel web-viewer/utils/OrderedObject web-viewer/utils/ListenerUtil web-viewer/layout/LayoutConstants jquery underscore".split(" "),function(g,e,d,c,f,b,a,h,o,k,l){e=function(a,b){g.call(this,a,o.Widget.VIEWPORT);h.mixin(this,a);this._toolManager=new c(this.f,
this);this._world=b;this._widgetModel=null;this._panelObjects={};this._element=k("<div />").addClass("viewport");this.repaint=l.throttle(l.bind(function(){this._repaint()},this),40);this.layout=l.debounce(l.bind(function(){this._layout()},this),40);this._didZoomToFit=!1;this._registerListener("transformChanged",this.repaint,this,this._world);this.f.getDocumentController().whenActivePageChanged(function(a,b){a!==b&&(this._didZoomToFit=!1)},this);this.f.getDocumentController().whenDifferencePageChanged(function(a,
b){a!==b&&(this._didZoomToFit=!1)},this);this._registerListener("parameters.endUpdate",this._verifyWorld,this,this.f.getDocumentController());this._verifyWorld();this._element.mouseenter(l.bind(function(){this._widgetModel.setWidgetActive(!0)},this));this._element.mouseleave(l.bind(function(){this._widgetModel.setWidgetActive(!1)},this))};e.prototype=Object.create(g.prototype);e.prototype.constructor=e;e.widgetName=o.Widget.VIEWPORT;e.prototype.setWidgetModel=function(a){this._widgetModel&&this._unregisterAllListenersForObject(this._widgetModel);
this._widgetModel=a;this._registerListener("changed.panel.order",this.layout,this,this._widgetModel);this._registerListener("changed.panel.remove",this._destroyPanel,this,this._widgetModel);this._registerListener("changed.view.size",this._verifyWorld,this,this._widgetModel);this._registerListener("changed.layout.*",this.layout,this,this._widgetModel);this.layout();this.repaint()};e.prototype.getSize=function(){return new d.Size(this._element.innerWidth(),this._element.innerHeight())};e.prototype.requestView=
function(a){if(l.isString(a))return this.getFirstViewOccurrence(a);var b=null,b=a instanceof d.Point?a.copy():a.pageX?new d.Point(a.pageX,a.pageY):new d.Point(a.clientX,a.clientY);if(a=this.getPanelAt(b))return a.getViewAt(b)};e.prototype._verifyWorld=function(){if(!this._widgetModel)return!1;var a=this._widgetModel.getWorldBounds();if(!a)return!1;var b=!1,c=this._widgetModel.getSizeForView();c.equals(this._world.getSceneSize())||(this._world.setSceneSize(c),b=!0);var d=this._widgetModel.getWorldResolution();
void 0!==d&&this._world.setWorldResolution(d);a.rectEquals(this._world.getWorldBounds())||(this._world.setWorldBounds(a),b=!0);a=0!==this._world.getWorldSize().width&&0!==this._world.getWorldSize().height;d=0!==this._world.getSceneSize().width&&0!==this._world.getSceneSize().height;if((!this._didZoomToFit||b&&!this._world.didChangeTransformSinceLastZoomToFit())&&a&&d)this._world.zoomToFit(!1),0<c.width&&(0<c.height&&!this.f.isParameterUpdateOngoing())&&(this._didZoomToFit=!0);b&&this._world.getInitialTransformation()&&
this._world.transform(this._world.getInitialTransformation());return b};e.prototype.getWorld=function(){return this._world};e.prototype.setContext=function(a){g.prototype.setContext.call(this,a);this.context.append(this._element)};e.prototype.getWidgetType=function(){return"maincontent"};e.prototype.resized=function(){this.layout()};e.prototype.getPanel=function(a){return void 0!==this._panelObjects[a]?this._panelObjects[a]:this._createPanel(a)};e.prototype._createPanel=function(a){var c=new b(this.f,
this._widgetModel.getPanelModel(a),this._widgetModel,this._world);this._panelObjects[a]=c;this._element.append(c.element);return c};e.prototype._destroyPanel=function(a){a=a.getName();void 0!==this._panelObjects[a]&&(this._panelObjects[a].destroy(),delete this._panelObjects[a],this.layout())};e.prototype.getPanelAt=function(a){var a=a.copy(),b=this._element.offset();a.x-=b.left;a.y-=b.top;b=0;b=this._widgetModel.getResolvedPanelsLayoutMode()===f.PanelsLayoutMode.HORIZONTAL?Math.floor(a.y/(Math.ceil(this._element.height()/
this._widgetModel.getPanelCount())+f.PanelBorderWidth)):Math.floor(a.x/(Math.ceil(this._element.width()/this._widgetModel.getPanelCount())+f.PanelBorderWidth));return this._panelObjects[this._widgetModel.getPanelNameAtIndex(b)]};e.prototype._layout=function(){if(void 0!==this._widgetModel&&this._widgetModel.getWorldBounds()){var a=this._widgetModel.getPanelOrder(),b=a.length;0<b&&(this._widgetModel.getResolvedPanelsLayoutMode()===f.PanelsLayoutMode.HORIZONTAL?this._layoutPanelsHorizontal(a,b):this._layoutPanelsVertical(a,
b))}};e.prototype._layoutPanelsVertical=function(a,b){var c=new d.Size(Math.ceil((this._element.width()-(b-1)*f.PanelBorderWidth)/b),this._element.height());l.each(a,function(a,e){var g=this.getPanel(a);g.setBounds(new d.Point((c.width+f.PanelBorderWidth)*e,0),c);e<b-1&&(g.element.css("border-right-width",f.PanelBorderWidth+"px"),g.element.css("border-right-style","solid"));g.element.css("border-bottom",0)},this)};e.prototype._layoutPanelsHorizontal=function(a,b){var c=new d.Size(this._element.width(),
Math.ceil((this._element.height()-(b-1)*f.PanelBorderWidth)/b));l.each(a,function(a,e){var g=this.getPanel(a),h=new d.Point(0,(c.height+f.PanelBorderWidth)*e);g.setBounds(h,c);e<b-1&&(g.element.css("border-bottom-width",f.PanelBorderWidth+"px"),g.element.css("border-bottom-style","solid"));g.element.css("border-right",0)},this)};e.prototype._repaint=function(){this._widgetModel&&this._widgetModel.getWorldBounds()&&(this._verifyWorld(),l.each(this._widgetModel.getPanelOrder(),function(a){this.getPanel(a).repaint()},
this))};e.prototype.getFirstViewOccurrence=function(a){for(var b=this._widgetModel.getPanelOrder(),c=0;c<b.length;c++){var d=this._panelObjects[b[c]];if(d&&(d=d.getViewIfExists(a)))return d}return null};e.prototype.getElement=function(){return this._element};e.prototype.setBackgroundColor=function(a){this._element.css({"background-color":void 0===a?"":"#"+a})};return e});
define("web-viewer/core/AbstractModel",["web-viewer/core/PrivateChannel","underscore"],function(g,e){var d=function(c,d){this.f=c;this.channelName=d;g.installTo(this,this.f,this.channelName)};d.prototype._fireChange=function(c,d,b,a){if(!c){var g=!1;if(b===a)g=!1;else if(void 0!==a&&void 0!==b&&null!==a&&null!==b&&e.isFunction(a.equals)&&a.constructor===b.constructor)g=!b.equals(a);else if(e.isArray(b)&&e.isArray(a))if(b.length===a.length)for(var o=0;o<b.length&&!g;o++)b[o]!=a[o]&&(g=!0);else g=!0;
else g=b!==a;g&&(arguments[1].unshift("changed"),this._emit.apply(this,e.rest(arguments)))}};d.mixin=function(c){c._fireChange=function(c,b,a,e){d.prototype._fireChange.apply(this,c,b,a,e)}};return d});
define("web-viewer/viewport/model/ViewportPanelModel",["web-viewer/core/AbstractModel","underscore"],function(g,e){var d=function(c,d,b,a){g.call(this,c,["module","viewport","panel",d]);this._name=d;this._overwriteOptions={};void 0!==b&&(this._overwriteOptions=e.clone(b));this._disabledLayers=[];void 0!==a&&(this._disabledLayers=a.slice(0));this._headerText=null};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.getName=function(){return this._name};d.prototype.toggleLayer=
function(c,d){var b=this._disabledLayers.slice(0);d?this._disabledLayers=e.without(this._disabledLayers,c):0>e.indexOf(this._disabledLayers,c)&&this._disabledLayers.push(c);this._fireChange(!1,["disabledLayers"],b,this._disabledLayers.slice(0))};d.prototype.isLayerEnabled=function(c){return!this.isLayerDisabled(c)};d.prototype.isLayerdisabled=function(c){return 0<=e.indexOf(this._disabledLayers,c)};d.prototype.getDisabledLayers=function(){return this._disabledLayers.slice(0)};d.prototype.getOverwriteOptions=
function(c){return c?this._overwriteOptions:e.clone(this._overwriteOptions)};d.prototype.getOverwriteOption=function(c){return this._overwriteOptions[c]};d.prototype.setOverwriteOption=function(c,d){var b=this.getOverwriteOption(c);this._overwriteOptions[c]=d;this._fireChange(!1,["overwriteOption",c],b,d)};d.prototype.setOverwriteOptions=function(c){e.each(c,function(c,b){this.setOverwriteOption(b,c)},this)};d.prototype.deleteOverwriteOption=function(c){var d=this.getOverwriteOption(c);delete this._overwriteOptions[c];
this._fireChange(!1,["overwriteOption",c],d,void 0)};d.prototype.getHeaderText=function(){return this._headerText};d.prototype.setHeaderText=function(c){var d=this._headerText;this._headerText=c;this._fireChange(!1,["headerText"],d,c)};return d});
define("web-viewer/viewport/model/ViewportWidgetModel","web-viewer/core/AbstractModel web-viewer/utils/ShapeUtils web-viewer/viewport/ViewportConstants web-viewer/utils/OrderedObject web-viewer/viewport/model/ViewportPanelModel underscore".split(" "),function(g,e,d,c,f,b){var a=function(a,b){g.call(this,a,["viewport","widget","model"]);this.id=b;this._viewportViewModels=new c;this._globalLayers={};this._viewsLayoutMode=d.ViewsLayoutMode.AUTOMATIC;this._panelsLayoutMode=d.PanelsLayoutMode.AUTOMATIC;
this._sizeForView=new e.Size;this._panels=new c;this.addPanel("default",{isDefaultView:!0});this._isActive=!1};a.prototype=Object.create(g.prototype);a.prototype.constructor=a;a.prototype.getWorldSize=function(){};a.prototype.getWorldBounds=function(){};a.prototype.getWorldResolution=function(){return{x:0,y:0}};a.prototype.setWidgetActive=function(a){this._isActive=a};a.prototype.isWidgetActive=function(){return this._isActive};a.prototype.createView=function(a,b,c){b=this.createModelForView(a,b,
c);this._addView(a,b)};a.prototype._addView=function(a,c){if(this._viewportViewModels.getItemByKey(a))throw"Trying to add view with already existing name";var d=this.getViewsOrder();this._viewportViewModels.addItem(a,c);b.each(this._globalLayers,function(b,c){this.addLayer(c,b,a)},this);this._fireChange(!1,["view","add"],void 0,c);this._fireChange(!1,["view","order"],d,this.getViewsOrder())};a.prototype.toggleView=function(a,b){if(void 0!==this._viewportViewModels.getItemByKey(a)){var c=this._viewportViewModels.getItemByKey(a).isShown();
this._viewportViewModels.getItemByKey(a).setShown(b);this._fireChange(!1,["view","toggle",a],c,b)}};a.prototype.removeView=function(a){var b=this.getViewsOrder(),a=this._viewportViewModels.removeByKey(a);this._fireChange(!1,["view","remove"],a,void 0);this._fireChange(!1,["view","order"],b,this.getViewsOrder())};a.prototype.getViewCount=function(){return this._viewportViewModels.getLength()};a.prototype.getViewModel=function(a){return this._viewportViewModels.getItemByKey(a)};a.prototype.getIDForViewAtIndex=
function(a){return this._viewportViewModels.getKeyByIndex(a)};a.prototype.getModelForViewAtIndex=function(a){return this._viewportViewModels.getItemByIndex(a)};a.prototype.getViews=function(){return this._viewportViewModels.getOrderedObjectList()};a.prototype.getShownViewKeys=function(){return b.filter(this._viewportViewModels.getKeys(),function(a){return this._viewportViewModels.getItemByKey(a).isShown()},this)};a.prototype.getIDForShownViewsAtIndex=function(a){return this.getShownViewKeys()[a]};
a.prototype.createModelForView=function(){throw"Not Implemented";};a.prototype.setViewsOrder=function(a){var c=this.getViewsOrder(),d=this._viewportViewModels.getKeys(),f=b.difference(d,a,["Main"]);0<=b.indexOf(d,"Main")&&(a=b.without(a,"Main"),a.unshift("Main"));a=a.concat(f);this._viewportViewModels.setOrder(a);this._fireChange(!1,["view","order"],c,this.getViewsOrder())};a.prototype.getViewsOrder=function(){return this._viewportViewModels.getKeys()};a.prototype.setSizeForView=function(a){var b=
this._sizeForView;this._sizeForView=a;this._fireChange(!1,["view","size"],b,a)};a.prototype.getSizeForView=function(){return this._sizeForView};a.prototype.getViewsLayoutMode=function(){return this._viewsLayoutMode};a.prototype.setViewsLayoutMode=function(a){var b=this._viewsLayoutMode;this._viewsLayoutMode=a;this._fireChange(!1,["layout","views"],b,this._viewsLayoutMode)};a.prototype.getResolvedViewsLayoutMode=function(){return 1<this.getPanelCount()&&this._viewsLayoutMode===d.PanelsLayoutMode.AUTOMATIC?
this._panelsLayoutMode===d.PanelsLayoutMode.HORIZONTAL?d.ViewsLayoutMode.VERTICAL:d.ViewsLayoutMode.HORIZONTAL:this._viewsLayoutMode};a.prototype.getPanelsLayoutMode=function(){return this._panelsLayoutMode};a.prototype.getResolvedPanelsLayoutMode=function(){var a=this._panelsLayoutMode;a===d.PanelsLayoutMode.AUTOMATIC&&(a=this._viewsLayoutMode===d.ViewsLayoutMode.VERTICAL?d.PanelsLayoutMode.HORIZONTAL:d.PanelsLayoutMode.VERTICAL);return a};a.prototype.setPanelsLayoutMode=function(a){var b=this._panelsLayoutMode;
this._panelsLayoutMode=a;this._fireChange(!1,["layout","panels"],b,this._panelsLayoutMode)};a.prototype.addPanel=function(a,b,c){var d=this._panels.getKeys(),e=this._panels.getItemByKey(a);void 0!==e?this._panels.moveItemByKeyToEnd(a):(e=new f(this.f,a,b,c),this._panels.addItem(a,e),this._fireChange(!1,["panel","add"],void 0,e));this._fireChange(!1,["panel","order"],d,this._panels.getKeys());return e};a.prototype.getPanelModel=function(a){return this._panels.getItemByKey(a)};a.prototype.removePanel=
function(a){var b=this._panels.getKeys(),a=this._panels.removeByKey(a);this._fireChange(!1,["panel","remove"],a,void 0);this._fireChange(!1,["panel","order"],b,this._panels.getKeys())};a.prototype.setPanelOrder=function(a){var b=this._panels.getKeys();this._panels.setOrder(a);this._fireChange(!1,["panel","order"],b,this._panels.getKeys())};a.prototype.getPanelOrder=function(){return this._panels.getKeys()};a.prototype.getPanelCount=function(){return this._panels.getLength()};a.prototype.getPanelNameAtIndex=
function(a){return this._panels.getKeyByIndex(a)};a.prototype.getPanelAtIndex=function(a){return this._panels.getItemByIndex(a)};a.prototype.addLayer=function(a,c,d){void 0!==d?this._viewportViewModels.getItemByKey(d)&&this._viewportViewModels.getItemByKey(d).addLayer(a,c):(b.each(this._viewportViewModels.getItemsAsObject(),function(b){b.addLayer(a,c)}),this._globalLayers[a]=c)};a.prototype.removeLayer=function(a,c){void 0!==c?this._viewportViewModels.getItemByKey(c)&&this._viewportViewModels.getItemByKey(c).removeLayer(a):
(b.each(this._viewportViewModels.getItemsAsObject(),function(b){b.removeLayer(a)}),delete this._globalLayers[a])};a.prototype.toggleLayer=function(a,c,d){void 0!==d?this._viewportViewModels.getItemByKey(d)&&this._viewportViewModels.getItemByKey(d).toggleLayer(a):(d=this._globalLayers[a])?d.toggle(c):b.each(this._viewportViewModels.getItemsAsObject(),function(b){b.toggleLayer(a,c)})};return a});
define("web-viewer/viewport/ViewportModule","web-viewer/core/AbstractModule web-viewer/viewport/ViewportWidget web-viewer/viewport/model/ViewportWidgetModel web-viewer/viewport/ViewportWorld web-viewer/utils/ViewerUtils web-viewer/utils/ShapeUtils web-viewer/utils/StringSet jquery web-viewer/utils/Cache web-viewer/utils/ListenerUtil underscore".split(" "),function(g,e,d,c,f,b,a,h,o,k,l){d=function(b,d){g.call(this,b,d,"viewport");k.mixin(this,b);this._initializeImageCache();this.widgetModel=null;
this._disabledAnimationSources=[];this._ongoingImageDataLoads=0;this._pendingImageRequests=new a;this.world=new c(this.f,"viewportWidget",b.getProperty("initialZoom"));this.widget=new e(b,this.world);b.requestModule("featureDetector",function(a){a.hasCanvas()?b.debug.log("Canvas feature available"):(b.debug.log("Canvas feature NOT available"),b.i18n.loadBundle("viewer",function(){b.emit("userMessage","error",b.i18n.t("CanvasNotAvailable"),b.getProperty("javaViewerURL"))}))});this._publishWidget(e.widgetName,
l.bind(function(){return this.widget},this));this._registerListener("viewport.transform",this.transform,this);this._registerListener("viewport.toggleAnimation",this.toggleAnimations,this);this._registerListener("viewport.zoomToFit",function(a){this.zoomToFit(a.animated)},this);this._registerListener("viewport.zoomToFitWidth",function(a){this.zoomToFitWidth(a.animated)},this);this._registerListener("viewport.zoomToFitHeight",function(a){this.zoomToFitHeight(a.animated)},this);this._registerListener("viewport.zoomOneToOne",
function(a){this.zoomOneToOne(a.animated,a.worldResolution)},this);this._registerListener("viewport.fitInRect",function(a){this.fitInRect(a.rect,a.animated,a.constrain)},this);this._registerListener("viewport.repaint",function(){this.widget&&this.widget.repaint()},this);this._registerListener("viewportLayer.startImageDataRequest",function(a){this._pendingImageRequests.add(a);0===this._ongoingImageDataLoads&&this._emit("startLoadingImageData")},this);this._registerListener("viewportLayer.finishedImageDataRequest",
function(a){this._pendingImageRequests.remove(a)&&(0===this._pendingImageRequests.size()&&0===this._ongoingImageDataLoads)&&this._emit("finishedLoadingImageData")},this);this.f.getDocumentController().whenActivePageChanged(function(){this.world&&this.world.resetOrientation()},this);this.f.getDocumentController().whenActiveOrDifferenceOrCadOverlayChangedAndParametersAvailable(function(){this.world.zoomToFit(!1)},this)};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.setWidgetModel=
function(a){this.widget.setWidgetModel(a);(this.widgetModel=a)&&this._emit("widgetModelAvailable")};d.prototype.getWidgetModel=function(){return this.widgetModel};d.prototype._initializeImageCache=function(){this._imageCache=new o(75,!0);this._imageCache.getAlternativeName=function(a){if(0<a.indexOf("dmode=7")&&0<a.indexOf("rs=")){var b=a.replace(/.*file=([^&]+).*/,"$1"),c=a.replace(/.*diff=([^&]+).*/,"$1"),d=a.replace(/.*rs=([^&]+).*/,"$1");return a.replace(/file=([^&]+)/,"file="+c).replace(/diff=([^&]+)/,
"diff="+b).replace(/rs=([^&]+)/,"rs="+("2"==d?1:2))}return null};var a=this;this._imageCache._loadItem=l.partial(function(b,c){var d=new Image,f="viewportImageCache_"+c;d.onload=l.bind(function(){this._registerItem(c,d);a._stopLoadingImageData(f)},this);d.onerror=l.bind(function(){d.error=!0;this._registerItem(c,void 0);a._stopLoadingImageData(f)},this);a._startLoadingImageData(f);d.src=c},this.f)};d.prototype._startLoadingImageData=function(a){this.f.emit("loading.start",a);0===this._ongoingImageDataLoads&&
0<this._pendingImageRequests.size()&&this._emit("startLoadingImageData");this._ongoingImageDataLoads++};d.prototype._stopLoadingImageData=function(a){this.f.emit("loading.stop",a);this._ongoingImageDataLoads--;0===this._ongoingImageDataLoads&&this._emit("finishedLoadingImageData")};d.prototype.whenFinishedLoadingImageData=function(a,b){b&&(a=l.bind(a,b));if(0===this._ongoingImageDataLoads&&0===this._pendingImageRequests.size())a();else this.once("finishedLoadingImageData",a)};d.prototype.getImageCache=
function(){return this._imageCache};d.prototype.createView=function(a,b,c){this.widgetModel&&this.widgetModel.createView(a,b,c)};d.prototype.removeView=function(a){this.widgetModel&&this.widgetModel.removeView(a)};d.prototype.getFirstViewOccurrence=function(a){if(this.widget)return this.widget.getFirstViewOccurrence(a)};d.prototype.toggleView=function(a,b){this.widgetModel&&this.widgetModel.toggleView(a,b)};d.prototype.setViewsOrder=function(a){this.widgetModel&&this.widgetModel.setViewsOrder(a)};
d.prototype.setViewsLayoutMode=function(a){this.widgetModel&&this.widgetModel.setViewsLayoutMode(a)};d.prototype.addLayer=function(a,b,c){this.widgetModel&&this.widgetModel.addLayer(a,b,c)};d.prototype.removeLayer=function(a,b){this.widgetModel&&this.widgetModel.removeLayer(a,b)};d.prototype.toggleLayer=function(a,b,c){this.widgetModel&&this.widgetModel.toggleLayer(a,b,c)};d.prototype.transform=function(a){this.world.transform(a)};d.prototype.toggleAnimations=function(a,b){b?this._disabledAnimationSources=
l.without(this._disabledAnimationSources,a):this._disabledAnimationSources.push(a);this.world.toggleAnimation(0===this._disabledAnimationSources.length)};d.prototype.zoomToFit=function(a){this.world.zoomToFit(a)};d.prototype.zoomToFitWidth=function(a){this.world.zoomToFitWidth(a)};d.prototype.zoomToFitHeight=function(a){this.world.zoomToFitHeight(a)};d.prototype.zoomOneToOne=function(a,b){this.world.zoomOneToOne(a,b)};d.prototype.getZoomPercentage=function(){return this.world.getZoomPercentage()};
d.prototype.getNumberOfZoomLevels=function(){return this.world.getNumberOfZoomLevels()};d.prototype.getMinZoom=function(){return this.world.getMinZoom()};d.prototype.getMaxZoom=function(){return this.world.getMaxZoom()};d.prototype.getResolution=function(){return this.world.getZoom()};d.prototype.getRotation=function(){return this.world.getRotation()};d.prototype.isFlip=function(){return this.world.isFlip()};d.prototype.fitInRect=function(a,b,c){this.world.fitInRect(a,b,c)};d.prototype.setPanelsLayoutMode=
function(a){this.widgetModel&&this.widgetModel.setPanelsLayoutMode(a)};d.prototype.getPanelModel=function(a){if(this.widgetModel)return this.widgetModel.getPanelModel(a)};d.prototype.addPanel=function(a,b,c){if(this.widgetModel)return this.widgetModel.addPanel(a,b,c)};d.prototype.removePanel=function(a){this.widgetModel&&this.widgetModel.removePanel(a)};d.prototype.getVisibleRect=function(){return this.world.getTargetViewPort()};d.prototype.getWorldBounds=function(){return this.world.getWorldBounds()};
d.prototype.getMiddle=function(){return this.world.getMiddle()};d.prototype.getZoom=function(){return this.world.getZoom()};d.prototype.getState=function(){return{world:{rotation:this.world.getRotation(),offsetSize:this.world.getOffsetSize(),zoom:this.world.getZoom(),isFullView:this.world.isFullView(),sceneSize:this.widget.getSize(),worldBounds:this.world.getWorldBounds(),flip:this.world.isFlip(),flipViewFromBack:this.world.isFlipViewFromBack(),visibleRect:this.world.getTargetViewPort()}}};d.prototype.setState=
function(a){this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(l.bind(function(){this.f.whenModuleAvailable("viewport",function(){if(void 0!==a){var c=a.world;void 0!==c&&(this.world.setWorldBounds(c.worldBounds),this.world.setInitialTransformation({fixedrotation:c.rotation,fixedoffset:c.offsetSize,fixedzoom:c.zoom,flip:c.flip,flipViewFromBack:c.flipViewFromBack}),this.world.setSceneSize(new b.Size(c.visibleRect.size.width,c.visibleRect.size.height)))}},this)},this))};d.prototype.getWorld=
function(){return this.world};d.prototype.setWidgetBackgroundColor=function(a){this.widget.setBackgroundColor(a)};d.prototype.whenWidgetModelAvailable=function(a,b){b&&(a=l.bind(a,b));if(this.widgetModel)a();else this.once("widgetModelAvailable",a)};return d});
define("web-viewer/layout/component/Popup","web-viewer/core/PrivateChannel web-viewer/utils/ShapeUtils web-viewer/layout/component/MiniButton underscore jquery jqueryUI".split(" "),function(g,e,d,c,f){var b=function(a,b,d){g.installTo(this,a,["popup",b]);this.containment=d;this.f=a;this._isInitialized=!1;this.element=f("<div />").addClass("popup");this.element.hide();this.header=f("<td />").addClass("popup-header");this.headerWrapper=f("<tr/>");this.headerIcons=f("<td />").addClass("popup-headerIcons");
this._outerContent=f("<div>").addClass("popup-content");this.content=f("<div />").addClass("inner-popup-content");this._outerContent.append(this.content);this._popupBtns=f("<div>");this._outerContent.append(this._popupBtns);this.visible=!1;this._outerContent.on("makeMeVisible",c.partial(function(a,b){var c=f(b.target).position().top,d=f(b.target).outerHeight(),g=f(this).position().top,h=f(this).outerHeight();if(d>h){var o={position:{left:a.element.position().left,top:a.element.position().top},size:{width:a.element.outerWidth(),
height:d+a.header.outerHeight()}};a.setRect(new e.rectMake(o.position.left-a.containment.offset().left,o.position.top-a.containment.offset().top,o.size.width,o.size.height));a._fireResized(o,!0)}if(0>c-g||c+d>g+h)c=f(this).scrollTop()+c-g,f(this).scrollTop(c);b.preventDefault();b.stopPropagation()},this));this.content.on("contentResized",c.bind(function(a){this._fireContentResized();a.preventDefault();a.stopPropagation()},this))};b.prototype._initialize=function(){this._isInitialized||(this.element.on("click",
c.bind(function(){this._emit("clicked")},this)),this.element.append(f("<table />").addClass("popup-headerWrapper").append(this.headerWrapper)),this.headerWrapper.append(this.header),this.headerWrapper.append(this.headerIcons),this.close=new d(this.f,"close","icon-WCR_Close12",!0,c.bind(function(a){this._emit("closed");a.stopPropagation()},this)),this.close.setTooltip("viewer","ClosePopupTT"),this.headerIcons.append(this.close.element),this.element.append(this._outerContent),this.element.resizable({handles:"all",
autoHide:!0,minWidth:100,minHeight:30,maxWidth:this.containment.innerWidth(),maxHeight:this.containment.innerHeight(),start:c.bind(function(a){this.f.emit("toolManager.interruptTools",!0);a.stopPropagation()},this),resize:c.throttle(c.bind(function(a){this._onResized();a.stopPropagation()},this),10),stop:c.bind(function(a,b){this.f.emit("toolManager.interruptTools",!1);this._fireResized(b,!1);a.stopPropagation()},this)}),this.element.draggable({containment:this.containment,handle:this.headerWrapper,
start:c.bind(function(){this.f.emit("toolManager.interruptTools",!0)},this),stop:c.bind(function(a,b){this.f.emit("toolManager.interruptTools",!1);this._fireDragged(b);a.stopPropagation()},this)}),this._isInitialized=!0,this.f.getContext().append(this.element),this._onResized())};b.prototype._fireDragged=function(a){this._emit("dragged",new e.Point(a.position.left-this.containment.offset().left,a.position.top-this.containment.offset().top))};b.prototype._fireResized=function(a,b){this._emit("resized",
new e.Rect(new e.Point(a.position.left-this.containment.offset().left,a.position.top-this.containment.offset().top),new e.Size(a.size.width,a.size.height)),b)};b.prototype.setHeader=function(a){this.header.empty().append(a)};b.prototype.setContent=function(a){this.content.empty().append(a)};b.prototype.hide=function(){this._isInitialized&&this.visible&&this.element.hide();this.visible=!1};b.prototype.show=function(a,b){this._isInitialized||this._initialize();this.visible||this.element.show();this.visible=
!0;a&&b&&this.recalculateSize(a,b)};b.prototype.isVisible=function(){return this.visible};b.prototype.remove=function(){this.removeAllListeners("clicked");this.removeAllListeners("dragged");this.removeAllListeners("resized");this.removeAllListeners("closed");this.element.remove()};b.prototype._onResized=function(){this.visible||this.element.show();this._outerContent.css({width:this.element.innerWidth(),height:this.element.innerHeight()-this.header.outerHeight(!0)});this._fireContentResized();this.visible||
this.element.hide()};b.prototype._fireContentResized=function(){this._emit("contentResized",new e.Size(this._outerContent.width(),this._outerContent.height()))};b.prototype.setRect=function(a){this._isInitialized||this._initialize();a=this._restrictRectToContainment(a);this.element.css({width:a.size.width,height:a.size.height,left:a.origin.x,top:a.origin.y,position:"absolute"});this._onResized()};b.prototype.setSize=function(a){this._isInitialized||this._initialize();a=a.copy();this._restrictSizeToContainment(a);
this.element.css({width:a.width,height:a.height,position:"absolute"});this._onResized()};b.prototype._restrictSizeToContainment=function(a){var b=this.containment.innerWidth(),c=this.containment.innerHeight();a.width>b&&(a.width=b);a.height>c&&(a.height=c)};b.prototype._restrictRectToContainment=function(a){var b=a.copy();this._restrictSizeToContainment(b.size);b.origin.x=a.origin.x+this.containment.offset().left;b.origin.y=a.origin.y+this.containment.offset().top;b.origin.x+a.size.width>this.containment.offset().left+
this.containment.innerWidth()&&(b.origin.x=this.containment.offset().left+this.containment.innerWidth()-a.size.width);b.origin.y+a.size.height>this.containment.offset().top+this.containment.innerHeight()&&(b.origin.y=this.containment.offset().top+this.containment.innerHeight()-a.size.height);b.origin.x<this.containment.offset().left&&(b.origin.x=this.containment.offset().left);b.origin.y<this.containment.offset().top&&(b.origin.y=this.containment.offset().top);b.origin.x=Math.max(0,b.origin.x);b.origin.y=
Math.max(0,b.origin.y);return b};b.prototype.setContainment=function(a){this.containment!==a&&(this.containment=a,this._isInitialized&&(this.element.resizable("option","maxWidth",this.containment.innerWidth()),this.element.resizable("option","maxHeight",this.containment.innerHeight()),this.element.draggable("option","containment",this.containment)))};b.prototype.recalculateSize=function(a,b){this._outerContent.outerWidth(b);var c=this.content.outerHeight(!0)+this.header.outerHeight(!0)+this._popupBtns.outerHeight(!0);
this._outerContent.css("overflow","hidden");this.setRect(new e.Rect(a,new e.Size(b,c)));this._outerContent.css("overflow","auto")};b.prototype.addButton=function(a){this._popupBtns.addClass("popupBtns");this._popupBtns.append(a)};b.prototype.toggleHeaderIcons=function(a){this.headerIcons.toggleClass("displayNone",!a)};return b});
define("web-viewer/layout/component/ModalPopup","web-viewer/layout/component/Popup web-viewer/layout/component/ToolbarButton web-viewer/utils/ShapeUtils web-viewer/utils/ListenerUtil Mousetrap jquery underscore".split(" "),function(g,e,d,c,f,b){var a=function(a,d,k,l,i){g.call(this,a,d,k);c.mixin(this,a);this._background=b("<div/>").addClass("modalBackground");this._removeFromDomAfterUsage=!1;this.element.addClass("modalPopup");this._popupContent=b("<div/>");this._actionBtns=b("<div/>").addClass("pull-right").addClass("modalPopupBtns");
this._popupContentContainer=b("<div/>").addClass("popupContentContainer clearfix");this._okAction=null;this._cancelAction=function(){};(this._maxHeight=i)&&this.element.css("max-height",this._maxHeight);this._okBtn=new e(this.f,"ok",b("<span/>"),!1,_.bind(function(){this._okAction()},this));this._okBtn.addClass("btn-success");f.bind("esc",_.bind(function(a){this.hide();a.preventDefault();a.stopPropagation()},this),"keydown");this._cancelBtn=null;l||(this._cancelBtn=new e(this.f,"cancel",b("<span/>"),
!1,_.bind(this.cancelAction,this)),a.i18n.loadBundle("viewer",_.bind(function(){this._cancelBtn.element.html(a.i18n.t("AppDialogCancel"))},this)),this._actionBtns.append(this._cancelBtn.element));this._actionBtns.append(this._okBtn.element);this.element.addClass("modal");this.content.append(this._popupContentContainer.append(this._popupContent).append(this._actionBtns))};a.prototype=Object.create(g.prototype);a.prototype.constructor=a;a.prototype.setOkBtnText=function(a){this._okBtn.element.html(a)};
a.prototype.setCancelBtnText=function(a){this._cancelBtn&&this._cancelBtn.element.html(a)};a.prototype.show=function(){this._isInitialized||(this.on("closed",_.bind(this.cancelAction,this)),this._initialize());this.f.getContext().append(this._background);this._background.show();g.prototype.show.call(this);this.recalculateSize()};a.prototype.recalculateSize=function(a){var b=0,b=void 0===a?Math.ceil(0.55*this.containment.innerWidth()):a;this._popupContentContainer.outerWidth(b);a=this._popupContentContainer.outerHeight(!0)+
this.header.outerHeight(!0);this._popupContentContainer.outerWidth("auto");a>this._maxHeight&&(a=this._maxHeight);var c=this.containment.innerWidth()/2-b/2,f=this.containment.innerHeight()/2-a/2;this.content.css("overflow","hidden");this.setRect(new d.Rect(new d.Point(c,f),new d.Size(b,a)));this.content.css("overflow","auto")};a.prototype.hide=function(){this._background.hide();g.prototype.hide.call(this);this._removeFromDomAfterUsage&&(this.element.remove(),this._background.remove())};a.prototype.setOkAction=
function(a){this._okAction=a};a.prototype.setCancelAction=function(a){this._cancelAction=a};a.prototype.cancelAction=function(){this._cancelAction();this.hide()};a.prototype.setContent=function(a){this._popupContent.html(a)};a.prototype.addButton=function(a){this._okBtn.element.before(a.element)};a.prototype.enableOkBtn=function(a){this._okBtn.setEnabled(a)};a.prototype.setRemoveFromDomAfterUsage=function(a){this._removeFromDomAfterUsage=a};a.prototype.toggleButtons=function(a){this._actionBtns.toggleClass("displayNone",
!a)};return a});
define("web-viewer/core/ViewerModeManager",["web-viewer/core/PrivateChannel","underscore"],function(g){var e=function(d){this.f=d;g.installTo(this,d,"viewerModeManager");this._activeMode=null};e.prototype.startMode=function(d){d!=this._activeMode&&(this.stopActiveMode(),this._activeMode=d,this._activeMode.toggle(!0),this._emit("start",d))};e.prototype.stopMode=function(d){this._activeMode===d?this.stopActiveMode():this.f.debug.warn("Stopping a mode which isn't the active mode")};e.prototype.stopActiveMode=function(){if(this._activeMode){var d=
this._activeMode;this._activeMode.toggle(!1);this._activeMode=null;this._emit("stop",d)}};e.prototype.getActiveMode=function(){return this._activeMode};return e});
define("utils/XMLUtils",[],function(){var g=null;return g={attributeValue:function(e,d){var c=e.attributes.getNamedItem(d);return c?c.nodeValue:null},nodeTextContent:function(e,d){var c=e.getElementsByTagName(d)[0];return c?g.textContent(c):null},textContent:function(e){var d=e.textContent;void 0===d&&(d=e.nodeTypedValue);return d},xml2obj:function(e,d){for(var c={},f=e.childNodes,b=0;b<f.length;b++){var a=f[b],g=a.nodeName;if("#text"!=g){var o=this.numberOfChildren(a),k=void 0,k=0<o?this.xml2obj(a,
o):this.textContent(a);void 0!==c[g]?("[object Array]"!==Object.prototype.toString.call(c[g])&&(a=c[g],c[g]=[],c[g].push(a)),c[g].push(k)):c[g]=k}}if((void 0!==d||0<this.numberOfChildren(e))&&e.attributes){c.attributes={};for(f=0;f<e.attributes.length;f++)c.attributes[e.attributes[f].name]=e.attributes[f].value}return c},numberOfChildren:function(e){var d=0;if(e.childNodes&&0<e.childNodes.length)for(var c=0;c<e.childNodes.length;c++)1==e.childNodes[c].nodeType&&d++;return d}}});
define("utils/I18n",["utils/HTTPUtils","utils/XMLUtils","underscore","jquery"],function(g,e,d,c){var f=function(b,a,c){this._locale=b?b:"en";this._timestamp=c?c:0;this.wcrInstanceUrl=a;this.bundles={};this.loading={};this.bundleOrder=[];this.bundleLoadedListeners={}};f.prototype.setLocale=function(b){this._locale=b;this.bundles={};for(var b=function(){},a=0;a<this.bundleOrder.length;a++)this.loadBundle(this.bundleOrder[a],b)};f.prototype.getLocale=function(){return this._locale};f.prototype.loadBundle=
function(b,a,c){a&&c&&(a=d.bind(a,c));if(d.isArray(b)){var f=d.after(b.length,d.once(a));d.each(b,d.bind(function(a){this.loadSingleBundle(a,f)},this))}else this.loadSingleBundle(b,a)};f.prototype.loadSingleBundle=function(b,a){if(this.bundles[b])a&&a(this.bundles[b]);else if(a&&this.whenBundleLoaded(b,a),!this.loading[b]){this.bundleOrder.push(b);this.loading[b]=1;var d=this;c.ajax(g.constructURL("DownloadLocKeys.jsp",{scope:b,t:this._timestamp,lk:this._locale},this.wcrInstanceUrl),{dataType:"xml",
success:function(a){if(a){var c=a.getElementsByTagName("code");if(c[0]&&"001"===e.textContent(c[0]))return}for(var c={},a=a.documentElement.getElementsByTagName("lang_string"),f=0;f<a.length;f++){var g=a[f];c[g.getAttribute("key")]=g.getAttribute("value")}d.bundles[b]={};delete d.loading[b];c&&(d.bundles[b]=c);d.fireBundleLoaded(b,d.bundles[b])},error:function(){},cache:!0,type:"GET"})}};f.prototype.whenBundleLoaded=function(b,a){this.bundleLoadedListeners[b]||(this.bundleLoadedListeners[b]=[]);this.bundleLoadedListeners[b].push(a)};
f.prototype.fireBundleLoaded=function(b,a){this.bundleLoadedListeners[b]&&(d.each(this.bundleLoadedListeners[b],function(b){b(a)}),delete this.bundleLoadedListeners[b])};f.prototype.findByKey=function(b){for(var a=this.bundleOrder.length-1;0<=a;a--)if(this.bundles[this.bundleOrder[a]]&&this.bundles[this.bundleOrder[a]][b])return this.bundles[this.bundleOrder[a]][b]};f.prototype.findByKeyInBundle=function(b,a){if(this.bundles[a]&&this.bundles[a][b])return this.bundles[a][b]};f.prototype.t=function(b){var a=
this.findByKey(b);if(void 0!==a){for(var c=1;c<arguments.length;c++)a=a.replace("{"+(c-1)+"}",arguments[c]);return a}return b};f.prototype.d=function(b,a){var c=this.findByKey(b);if(void 0!==c)return a.toString(c)};return f});
define("web-viewer/compare/CompareConstants",[],function(){return{diffMode:{UNDEFINED:-1,CURRENTVERSION:0,DIFFVERSION:1,SHOWBOTHCHANGES:2,SHOWBOTHCHANGESHIGHLIGHT:3,SHOWBOTHCHANGESONLY:4,SHOWBOTHSIDEBYSIDE:5,RECTOVERSOATSIDE:6,SHOWBOTHONTOP:7,RECTOVERSOATTOP:8,READERSPREAD:9,BLINKING_CURRENT:10,SHOWBOTHSIDEBYSIDEHIGHLIGHT:11,SHOWBOTHSIDEBYSIDECHANGESONLY:12},blinkingSpeed:1E3,mode:{SHOW_CURRENT:"showCurrent",SHOW_DIFFERENCE:"showDifference",BLINKING:"blinking",DIFFERENCE:"difference",SIDEBYSIDE:"sidebyside",
READERSPREAD:"readerspread",ALIGNMENT:"alignment",SHOWBOTHONTOP:"showBothOnTop"},modeNameToLanguageKey:{showCurrent:"DiffCurrentTT",showDifference:"DiffPrevTT",blinking:"DiffBothBlinkingTT",difference:"compareDifferenceMode",sidebyside:"DiffBothSplitTT",showBothOnTop:"DiffShowBothOnTopTT",alignment:"AnchorAlignWizardTitle",readerspread:"ReaderSpreadModeTitle"},sideBySideToDiffMode:{5:2,11:3,12:4},colorSpace:{DEFAULT:0,CHANNELS:1,HSV:2,AUTOMATIC:3},channelsMode:{AUTO:0},showDifferenceMode:{SHOW:2,
HIGHLIGHT:3,ONLY:4},diffModeToMode:{UNDEFINED:"SHOW_CURRENT",CURRENTVERSION:"SHOW_CURRENT",DIFFVERSION:"SHOW_DIFFERENCE",SHOWBOTHCHANGES:"DIFFERENCE",SHOWBOTHCHANGESHIGHLIGHT:"DIFFERENCE",SHOWBOTHCHANGESONLY:"DIFFERENCE",SHOWBOTHSIDEBYSIDE:"SIDEBYSIDE",RECTOVERSOATSIDE:null,SHOWBOTHONTOP:"SHOWBOTHONTOP",RECTOVERSOATTOP:null,READERSPREAD:"READERSPREAD",BLINKING_CURRENT:"BLINKING",SHOWBOTHSIDEBYSIDEHIGHLIGHT:"SIDEBYSIDE",SHOWBOTHSIDEBYSIDECHANGESONLY:"SIDEBYSIDE"},cornerAutoAlign:{TOPLEFT:0,TOPCENTER:1,
TOPRIGHT:2,CENTERLEFT:3,CENTERED:4,CENTERRIGHT:5,BOTTOMLEFT:6,BOTTOMCENTER:7,BOTTOMRIGHT:8},cornerAlignIcons:{"0":"icon-WCR_Align-TopLeft",1:"icon-WCR_Align-TopCenter",2:"icon-WCR_Align-TopRight",3:"icon-WCR_Align-MiddleLeft",4:"icon-WCR_Align-MiddleCenter",5:"icon-WCR_Align-MiddleRight",6:"icon-WCR_Align-BottomLeft",7:"icon-WCR_Align-BottomCenter",8:"icon-WCR_Align-BottomRight"},referenceRotation:{NOTROTATED:0,ROTATED90:90,ROTATED180:180,ROTATED270:270},pagelistCompareRange:{CURRENT:0,CURRENTANDFOLLOWING:1,
ALL:2},pagelistSide:{LEFTPAGE:1,RIGHTPAGE:2},anchorAlignment:{DEFAULT:"/wcr-static/web-viewer/layout/img/crosshair.png",ACTIVE:"/wcr-static/web-viewer/layout/img/crosshair_active.png",SIZE:{width:14,height:14},OFFSET:{width:7,height:7}}}});
define("web-viewer/utils/Coordinates",["web-viewer/utils/ViewerUtils","web-viewer/compare/CompareConstants"],function(g,e){var d=function(c){this.f=c;this._compareModule=this._viewportModule=this._cadModule=null};d.prototype.getTransformedPoint=function(c){if(c){var d=this.f.getDocumentController(),b=d.getActivePage(),a=d.getDifferencePage(),d=d.getCadOverlay();if(b.hasCad()||d)if(this._cadModule||(this._cadModule=this.f.getModule("cad")),this._viewportModule||(this._viewportModule=this.f.getModule("viewport")),
this._cadModule&&this._viewportModule)if(b.hasCad()){this._compareModule||(this._compareModule=this.f.getModule("compare"));if(this._compareModule&&(d=this._compareModule.getDiffMode(),a&&(a.hasCad()&&a.getCad())&&d===e.diffMode.DIFFVERSION&&(d=this._cadModule.getReferenceTransform())&&a.getCad()))return c=d.createInverse().transformedPoint(c),c.y-=a.getCad().getSize().height,c.y=-c.y,c;if((a=this._cadModule.getCurrentPageCadModel())&&a.getCad()&&b.getCad())a=a.getCad().getOrigin(),c=c.copy(),c.x+=
a.x,c.y-=a.y,c.y-=b.getCad().getSize().height,c.y=-c.y}else if((b=this._cadModule.getOverlayTransform())&&d.getCad())c=b.createInverse().transformedPoint(c),c.y-=d.getCad().getSize().height,c.y=-c.y}return c};d.prototype._calculateTransformedPoint=function(){};return d});
define("web-viewer/viewport/model/ViewportPopoverModel",["underscore","web-viewer/core/PrivateChannel","web-viewer/utils/Coordinates"],function(g,e,d){return function(c,f){e.installTo(this,c,["popoverModel",f]);this.f=c;this._coordinates=new d(this.f);this.getID=function(){return f};this.getFrame=function(){return null};this.getContent=function(){return null};this.onAddedToContainer=function(){};this.onDestroy=function(){};this.getPreferredPosition=function(){return"left"};this.getRestrictBorder=
function(){};this.getContext=function(){return c.getContext()};this.getClass=function(){};this.isInteractive=function(){return!1}}});
define("web-viewer/viewport/model/ViewportLayerModel","underscore web-viewer/core/AbstractModel web-viewer/utils/Transformation web-viewer/utils/ShapeUtils web-viewer/core/PrivateChannel web-viewer/viewport/model/ViewportPopoverModel".split(" "),function(g,e,d,c){var f=function(b,a){e.call(this,b,["layerModel",a]);this.f=b;this._name=a;this.transform=new d;this.popoverModels={};this.popupModels={};this.fragmentUrlOverwriteOptions={};this._visible=!0;this._popovers={}};f.prototype=Object.create(e.prototype);
f.prototype.constructor=f;f.prototype.getName=function(){return this._name};f.prototype.savePopover=function(b,a){this._popovers[a]=b};f.prototype.getPopover=function(b){return this._popovers[b]};f.prototype.getAllPopovers=function(){return this._popovers};f.prototype.removePopover=function(b){delete this._popovers[b]};f.prototype.addPopoverModel=function(b){this.popoverModels[b.getID()]||(this.popoverModels[b.getID()]=b,this._emit("popoverAdded",b.getID()))};f.prototype.removePopoverModel=function(b){delete this.popoverModels[b];
this._emit("popoverRemoved",b)};f.prototype.getPopoverModel=function(b){return this.popoverModels[b]};f.prototype.addPopupModel=function(b){this.popupModels[b.getId()]=b};f.prototype.removePopupModel=function(b){this.popupModels[b].onDestroy();delete this.popupModels[b]};f.prototype.removeAllPopupModels=function(){g.each(this.popupModels,function(b){this.removePopupModel(b.getId())},this)};f.prototype.getPopupModel=function(b){return this.popupModels[b]};f.prototype.getPopupModels=function(){return this.popupModels};
f.prototype.getLinework=function(){return[]};f.prototype.getBackgroundOptions=function(){return{}};f.prototype.getTransform=function(){return this.transform};f.prototype.getRotation=function(){return 0};f.prototype.isFlipped=function(){return!1};f.prototype.resetTransformation=function(){this.transform=new d};f.prototype.getMaximumResolution=function(){return-1};f.prototype.modelChanged=function(){this._emit("modelChanged")};f.prototype.preloadFragment=function(){};f.prototype.getContextForFragment=
function(b){b={rectangle:b.getRect(),resolution:b.getZoom(),servlet:"",params:{x1:0,x2:0,y1:0,y2:0}};this.f.emit("intercept.fragmentURL",b);b.params=g.extend(b.params,this.fragmentUrlOverwriteOptions);return b};f.prototype.getLineworkColor=function(){return null};f.prototype.getAlpha=function(){};f.prototype.setOverwriteOption=function(b,a){var c=this.fragmentUrlOverwriteOptions[b];this.fragmentUrlOverwriteOptions[b]=a;this._fireChange(!1,["overwriteOption",b],c,a)};f.prototype.setOverwriteOptions=
function(b){var a=this.fragmentUrlOverwriteOptions.slice(0);this.fragmentUrlOverwriteOptions=b;this._fireChange(!1,["overwriteOption"],a,b.slice(0))};f.prototype.getOverwriteOptions=function(){return this.fragmentUrlOverwriteOptions};f.prototype.removeOverwriteOption=function(b){var a=this.fragmentUrlOverwriteOptions[b];delete this.fragmentUrlOverwriteOptions[b];this._fireChange(!1,["overwriteOption",b],a,void 0)};f.prototype.destroy=function(){};f.prototype.shouldAutoFetchFragments=function(){return!1};
f.prototype.hasGraphics=function(){return!1};f.prototype.hasLinework=function(){return!1};f.prototype.hasBuffer=function(){return!1};f.prototype.getBuffer=function(){return null};f.prototype._markAllAsDirty=function(){this._emit("fragmentsDirty")};f.prototype._cleanupFragments=function(){this._emit("cleanupFragments")};f.prototype.toggle=function(b){var a=this._visible;this._visible=b;this._fireChange(!1,["visible"],a,b)};f.prototype.isVisible=function(){return this._visible};f.prototype.render=function(){};
f.prototype.calculateTransformation=function(b,a,d,f,e,g,i,j,n){void 0!==b&&(void 0!==b.size&&void 0!==a)&&(this.offset=d,this.getTransform().rotate(-f*(Math.PI/180),b.size.width/2,-b.size.height/2),e&&(this.getTransform().translate(b.size.width/2,-b.size.height/2),this.getTransform().flip(0,0)),90===f%180&&e?(this.getTransform().translate(b.size.width/2,-b.size.height/2),this.getTransform().translate(-this.offset.width,-this.offset.height)):(e&&this.getTransform().translate(-b.size.width/2,b.size.height/
2),this.getTransform().translate(this.offset.width,this.offset.height)),b=new c.Size(b.size.width/2-this.getTransform().e,b.size.height/2-this.getTransform().f),this.getTransform().translate(-b.width,-b.height),this.getTransform().preTranslate(b.width,b.height),i&&(n&&this.getTransform().preTranslate(-n.x,-n.y),this.getTransform().preFlip(0,0),n&&this.getTransform().preTranslate(n.x,n.y)),g&&(j?this.getTransform().preRotate(g*(Math.PI/180),j.x,j.y):this.getTransform().preRotate(g*(Math.PI/180),0,
0)))};return f});
define("web-viewer/viewport/model/ViewportViewModel",["web-viewer/utils/Transformation","web-viewer/core/PrivateChannel","underscore","web-viewer/viewport/model/ViewportLayerModel"],function(g,e,d){var c=function(c,b,a,d){e.installTo(this,c,["viewport","viewmodel",b]);this._layers={};this._title=a;this._IID=b;this._shown=!0;this._isDefaultView=d;this._transform=new g};c.prototype.getLayers=function(){return this._layers};c.prototype.addLayer=function(c,b){this._layers[c]=b;this._emit("layerAdded",c)};
c.prototype.removeLayer=function(c){delete this._layers[c];this._emit("layerRemoved",c)};c.prototype.getLayer=function(c){return this._layers[c]};c.prototype.numberOfLayers=function(){return d.keys(this._layers).length};c.prototype.nameForLayerAtIndex=function(c){return d.keys(this._layers)[c]};c.prototype.modelForLayer=function(c){return this._layers[c]};c.prototype.modelForLayerAtIndex=function(c){return this._layers[this.nameForLayerAtIndex(c)]};c.prototype.transformLayer=function(c,b){var a=this._layers[c];
a&&a.getTransform().transform(b)};c.prototype.getID=function(){return this._IID};c.prototype.indexForLayer=function(c){return d.indexOf(d.keys(this._layers),c)};c.prototype.getTransform=function(){return this._transform};c.prototype.setTitle=function(c){this._title!==c&&(this._title=c,this._emit("titleChanged"))};c.prototype.getTitle=function(){return this._title};c.prototype.setShown=function(c){this._shown!==c&&(this._shown=c,this._emit("showChanged"))};c.prototype.isShown=function(){return this._shown};
c.prototype.toggleLayer=function(c,b){var a=this.getLayer(c);void 0!==a&&a.toggle(b)};c.prototype.isDefaultView=function(){return this._isDefaultView};return c});
define("web-viewer/webviewer/WebviewerViewModel",["web-viewer/viewport/model/ViewportViewModel","underscore"],function(g,e){var d=function(c,d,b,a){g.call(this,c,d,b,a);var h="Graphics Cad currentDiffCad referenceDiffCad referenceCad CadOverlay Annotations AnnotationPopups".split(" ");this.indexForLayer=function(a,b){var c=e.keys(b);c.push(a);c=e.intersection(h,c);return e.indexOf(c,a)}};d.prototype=Object.create(g.prototype);return d.prototype.constructor=d});
define("web-viewer/webviewer/WebviewerWidgetModel","underscore web-viewer/webviewer/WebviewerViewModel web-viewer/viewport/model/ViewportWidgetModel web-viewer/utils/ShapeUtils web-viewer/utils/ViewerUtils web-viewer/utils/ConversionConstants".split(" "),function(g,e,d,c,f,b){g=function(a){d.call(this,a,"webviewer");this.f=a};g.prototype=Object.create(d.prototype);g.prototype.constructor=g;g.prototype.createModelForView=function(a,b,c){return new e(this.f,a,b,c)};g.prototype.getWorldBounds=function(){var a=
this.f.getActivePage(),b=this.f.getDocumentController().getDifferencePage(),d=this.f.getDocumentController().getCadOverlay();if(void 0!==a&&void 0!==b&&a.hasCad()&&b.hasCad()){var d=a.getOrigin(!0),e=b.getOrigin(!0),g=a.getPageSize(),a=b.getPageSize();if(null!==d&&null!==e)return b.getCad()&&b.getCad().getLocation()?(e=b.getCad().getLocation().origin,a=b.getCad().getLocation().size):e=new c.Point(e.x-d.x,d.y+g.height-(e.y+a.height)),b=new c.Rect(null,g),e=new c.Rect(e,a),b.calculateArea(e)}else{if(a.hasCad())return new c.Rect(a.getOrigin(),
a.getPageSize());e=new c.Rect(a.getOrigin(),new c.Size(f.parseFloat(a.getParam("sizex")),f.parseFloat(a.getParam("sizey"))));if(a.isBlankPage()&&(!b||b.isBlankPage()))b=a.getMargins(),e.size.height+=b.top+b.bottom,e.size.width+=b.left+b.right,a.isReaderSpread()&&(e.size.width*=2);return d&&d.getCad&&d.getCad()?(d.getCad()&&d.getCad().getLocation()?b=d.getCad().getLocation():(b=d.getCad().getOrigin(),a=new c.Size(f.parseFloat(d.get("offsetx")),f.parseFloat(d.get("offsety"))),d=d.getPageSize(),b=new c.Rect(new c.Point(-a.width+
b.x,a.height-(d.height+b.y)),d)),e=new c.Rect(new c.Point,e.size),b.calculateArea(e)):e}};g.prototype.getWorldResolution=function(){var a={x:0,y:0},c=this.f.getActivePage();if(void 0!==c&&c.isParametersAvailable()){var d=c.getParam("resolutionx"),c=c.getParam("resolutiony");a.x=void 0!==d?f.parseFloat(d):b.DEFAULT_POSTSCRIPT_PPI;a.y=void 0!==c?f.parseFloat(c):b.DEFAULT_POSTSCRIPT_PPI;return a}};return g});
define("web-viewer/webviewer/WebviewerModule",["web-viewer/core/AbstractModule","web-viewer/webviewer/WebviewerWidgetModel"],function(g,e){var d=function(c,d){g.call(this,c,d,"webviewer");this.webviewerWidgetModel=new e(c);c.getModule("viewport").setWidgetModel(this.webviewerWidgetModel);this.f.getDocumentController().whenActivePageChanged(this._pageChanged,this);this.f.getDocumentController().whenCadOverlayChanged(this._pageChanged,this)};d.prototype=Object.create(g.prototype);d.prototype.constructor=
d;d.prototype._pageChanged=function(c,d){var b=this.webviewerWidgetModel.getViewModel("Main");(void 0===b||null===b)&&this.webviewerWidgetModel.createView("Main","",!0);d&&((d.hasCad()||d.hasLinkedPage())&&this.f.requestModule("cad",void 0,!1),(d.hasGraphics()||d.isBlankPage())&&this.f.requestModule("graphics",void 0,!1),this.f.getProperty("allowAttributeCategory")&&(!this.f.isMobile()&&d.getAttributeCategoryID&&d.getAttributeCategoryID())&&this.f.requestModule("attributeCategory",void 0,!1),d.get("has3DPerspective")&&
this.f.requestModule("view3D",void 0,!1),d.whenParametersAvailable(_.bind(function(){(d.hasGraphics()||d.isBlankPage())&&d.getDocumentVersion().isMultiPage()&&this.f.requestModule("pagelist",void 0,!1)},this)))};return d});
define("web-viewer/core/AbstractDebug",[],function(){var g=function(e){e.on("error.SEVERE",function(){console.error?console.error.apply?console.error.apply(console,arguments):console.error("ERROR",arguments):console.log&&console.log.apply?console.log.apply(console,arguments):console.log("ERROR",arguments)})};g.prototype.log=function(){};g.prototype.warn=function(){};g.prototype.error=function(){};g.prototype.debug=function(){};return g});
define("web-viewer/core/DevDebug",["web-viewer/core/AbstractDebug","jquery","underscore"],function(g){var e=function(d){g.call(this,d);window.gViewerDebug=window.gViewerDebug||[];window.gViewerDebug.push(this)};e.prototype=Object.create(g.prototype);return e.prototype.constructor=e});
define("web-viewer/core/Core","lib/EventEmitter2 web-viewer/core/ViewerFacade web-viewer/data/DocumentController web-viewer/data/AbstractDocument web-viewer/data/AbstractDocumentVersion web-viewer/layout/component/LoadingIndicator web-viewer/layout/LayoutManager web-viewer/featureDetector/FeatureDetectorModule web-viewer/message/MessageModule web-viewer/viewport/ViewportModule web-viewer/layout/component/ToolbarButton web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/core/ViewerModeManager utils/I18n utils/XMLUtils utils/ConvertUtils jquery web-viewer/webviewer/WebviewerModule web-viewer/core/DevDebug underscore".split(" "),function(g,
e,d,c,f,b,a,h,o,k,l,i,j,n,m,p,s,v,q,w,r){return function(c,f){function t(a,b){var c="loadSourceFile_"+a;D.emit("loading.start",c);requirejs(["web-viewer/"+a],function(a){b&&b(a);D.emit("loading.stop",c)},function(d){B.emit("error.SEVERE","Failed loading source "+a,d);b&&b(null);D.emit("loading.stop",c)})}function x(a,b,c){D.emit(["module",b,"startInitialization"]);a=new a(B,c);G[b]=a;D.emit(["module","loaded",b],a);return a}function A(a,b,c){c=c||!1;if(G.hasOwnProperty(a)){var d=G[a];c||d.setSilenced(!1);
b&&b(d)}else I.hasOwnProperty(a)?(K.hasOwnProperty(a)&&!c&&delete K[a],b&&I[a].push(b)):(I[a]=[],c&&(K[a]=1),b&&I[a].push(b),D.emit(["module","loading",a]),t(a+"/"+s.capitaliseFirstLetter(a)+"Module",function(b){var c=null;b?(c=K.hasOwnProperty(a),c=x(b,a,c)):D.emit("error.SEVERE","Failed to load module "+a);for(var b=I[a],d=0;d<b.length;d++)b[d](c);delete I[a];delete K[a]}))}function z(){var a="";r.each(G,function(b){b.hasUnsavedElements()&&(a+="\r\n"+b.getUnsavedElementsName())});if(0<a.length)return B.i18n.t("ExitViewer")+
a}var F=v("<div>").css({background:"url('"+requirejs.toUrl("web-viewer/layout/img/loaderTransparent.gif")+"') no-repeat 2px center","padding-left":"20px",font:"normal 11px/20px Verdana,Arial,Helvetica,sans-serif",margin:"20px",height:"20px"}).text("Loading...");c.empty().append(F);var D=new g({wildcard:!0,delimiter:".",newListener:!0});D.setMaxListeners(0);var C={getProperty:function(a){return f.get(a)},getConfig:function(){return f},getAppContext:function(){return c}},J,L,H;v.ajaxSetup({beforeSend:function(){D.emit("loading.start",
this.url)},complete:function(){D.emit("loading.stop",this.url)},timeout:6E4});var E=new w(D);E.log("CORE","Debugger activated",E);E.log("CORE","Initializing ViewerFacade",E);var B=new e(C,D,E),P=new b(B,"loading");E.log("CORE","Initializing viewerModeManager");var M=new n(B),N=!1;C.stopMode=function(a){return M.stopMode(a)};C.startMode=function(a){return M.startMode(a)};C.stopActiveMode=function(){return M.stopActiveMode()};C.getActiveMode=function(){return M.getActiveMode()};C.canFetchFragments=
function(){return!H.isParameterUpdateOngoing()&&!N};D.on("core.loadSourceFile",t);var G={},I={},K={};C.requestModule=function(){};C.ajax=function(a,b){b=r.extend({dataType:"xml",success:function(){},error:function(){},cache:!1,processData:!0,contentType:"application/x-www-form-urlencoded; charset=UTF-8",type:"GET",data:"",noAjaxParam:!1},b);b.noAjaxParam||(a=0>a.indexOf("?")?a+"?ajax=1":a+"&ajax=1");v.ajax(a,{dataType:b.dataType,success:function(a,c,d){if(a&&"xml"===b.dataType){var f=a.getElementsByTagName("code");
if(f[0]&&"001"===p.textContent(f[0])){B.i18n.loadBundle("viewer",function(){B.emit("error.SEVERE",B.i18n.t("WCSessionLostError"),a)});return}}b.success(a,c,d)},error:function(a,c,d){b.error(a,c,d)},cache:b.cache,processData:b.processData,contentType:b.contentType,type:b.type,data:b.data,timeout:b.timeout})};C.whenAllModulesAreLoaded=function(a){B.once("allModulesAreLoaded",a)};C.getModuleIfAvailable=function(a){return G[a]};C.whenModuleAvailable=function(a,b,c){void 0!==c&&(b=r.bind(b,c));c=G[a];
if(void 0!==c)b(c);else D.once(["module","loaded",a],b)};C.getLoadedModules=function(){return G};C.injectState=function(a){C.whenAllModulesAreLoaded(r.bind(function(){if(void 0!==a.compare){var b=G.compare;void 0!==b&&b.setState(a.compare);delete a.compare}b=a.measure;delete a.measure;r.each(a,r.bind(function(a,b){void 0!==a&&C.whenModuleAvailable(b,function(b){b.setState(a)},this)},this));if(void 0!==b){var c=G.measure;void 0!==c&&c.setState(b)}},this))};C.getState=function(){var a=this.getLoadedModules(),
b={};r.each(a,function(a,c){b[c]=a.getState()});return b};E.debug("CORE","Initializing Message module");o||window.alert("Couldn't load Message module.");var O=x(o,"message",!0);E.debug("CORE","Initializing user object");J=f.getUser();J.setFacade(B);C.getCurrentUser=function(){return J};E.debug("CORE","Initializing DataAdapter");L=f.intializeAdapter(B);C.getDataAdapter=function(){return L};E.debug("CORE","Initializing I18N");B.i18n=new m(J.getLocale(),L.getInstance(),f.get("languageLoadTimestamp"));
B.i18n.loadBundle("viewer",function(){E.debug("I18N","General language bundle loaded");F.text(B.i18n.t("Loading"))});E.debug("CORE","Initializing DocumentController");H=new d(B,L);C.getDocumentController=function(){return H};C.openDocuments=function(a){H.openDocuments(a)};B.i18n.loadBundle("viewer",function(){v(window).on("beforeunload",z)});B.on("viewer.request.close",function(a,b,c){var d={};r.each(G,function(a,b){a.hasUnsavedElements()&&(d[b]=a)});var b=b?b:"SaveAndExit",c=c?c:"ExitWithoutSave",
f=function(){window.location===a?window.location.reload():window.location=a};r.isEmpty(d)?f():B.i18n.loadBundle("viewer",function(){var a=new i(B,"unsavedItemsPopup",B.getContext());a.setRemoveFromDomAfterUsage(!0);a.setOkBtnText(B.i18n.t(b));var e=new l(B,"exit",v("<span/>").text(B.i18n.t(c)),!1,function(){v(window).off("beforeunload",z);f()});a.addButton(e);a.setOkAction(function(){r.isEmpty(d)||(a.enableOkBtn(!1),r.each(d,function(a,b){a.saveAllUnsavedElements(function(){delete d[b];r.isEmpty(d)&&
(v(window).off("beforeunload",z),f())})}))});a.setHeader(v("<span/>").addClass("popupTitle").html(B.i18n.t("UnsavedItems")));a.setContent(v("<div/>").addClass("unsavedItemsContent").append(B.i18n.t("UnsavedItemsContent")));a.show();a.recalculateSize(400)})});E.debug("CORE","Core is now listening to module requests");C.requestModule=A;J.loadOptions(function(){E.debug("CORE","Initializing Feature detector module");var b=x(h,"featureDetector",!0);C.getFeatureDetector=function(){return b};E.debug("CORE",
"Detecting layout type");var d=J.getOption("LAYOUT_PREFERENCE"),d=d===j.LayoutType.MOBILE&&b.hasTouch()||d===j.LayoutType.AUTOMATIC&&b.isMobile()?j.LayoutType.MOBILE:j.LayoutType.DESKTOP;C.getLayoutType=function(){return d};H.whenDocumentsLoaded(function(){if(1<H.getDocumentCount()||r.some(H.getDocuments(),function(a){return a.hasLinkedDocument()||a.hasMultipleVersions()||a.getDocumentVersion().isMultiPage()||a.getDocumentVersion().isPageList()}))N=!0,A("compare",function(){N=!1},!0),C.whenModuleAvailable("viewport",
function(a){a.whenWidgetModelAvailable(function(){A("compare",function(){N=!1;a.widget.repaint()},!1)})})});E.debug("CORE","Initializing LayoutManager");var e=new a(B,c,P);E.debug("CORE","Initialized LayoutManager",e);C.switchLayout=function(a){e.switchLayout(a)};O&&O.setSilenced(!1);E.debug("CORE","Start loading viewport module");k||D.emit("error.SEVERE","Couldn't load viewport module!");x(k,"viewport",!1);E.debug("CORE","Start loading webviewer module, this intializes the viewport widget with the correct widgetmodel");
x(q,"webviewer",!1);E.debug("CORE","The viewport should be loaded and initialized now, start loading other modules");var g=f.getModules(),n=r.after(g.length,function(){B.emit("allModulesAreLoaded")});r.each(g,function(a){A(a,n)})});return B}});define("web-viewer/App",["web-viewer/core/Core"],function(g){var e=function(d,c,f){this._f=new g(d,f);this._f.openDocuments(c)};e.prototype.injectState=function(d){this._f.injectState(d)};return e});
define("web-viewer/annotation/AnnotationConstants",{AccessRight:{READ_ONLY:0,READ_WRITE:1},AnnotationType:{ANNOT_RECT:0,ANNOT_ELLIPSE:4,ANNOT_HIGHLIGHT:6,ANNOT_LINE:1,ANNOT_ARROW:5,ANNOT_PIN:11,ANNOT_FREEFORM:3},AnnotationPin:{normal:"/wcr-static/web-viewer/layout/img/comment-raw.gif",highlighted:"/wcr-static/web-viewer/layout/img/commentselected-raw.gif",imagehotspotx:0,imagehotspoty:0,imagetouchspotx:0,imagetouchspoty:0,imagetouchspotw:26,imagetouchspoth:24,imagewidth:26,imageheight:24},AnnotationElementName:{"0":"square",
4:"circle",6:"highlight",1:"line",5:"line",11:"text",3:"ink"},AnnotationReplyName:{"0":"Rectangle",4:"Oval",6:"Highlight",1:"Line",5:"Arrow",11:"Note",3:"Freehand"},AnnotationReviewState:{STATUS_ACCEPTED:"Accepted",STATUS_REJECTED:"Rejected",STATUS_CANCELLED:"Cancelled",STATUS_COMPLETED:"Completed",STATUS_NONE:"None"},AnnotationReviewStateIcons:{STATUS_ACCEPTED:"icon-WCR_Approve",STATUS_REJECTED:"icon-WCR_Reject",STATUS_CANCELLED:"icon-WCR_Canceled",STATUS_COMPLETED:"icon-WCR_Approve WCR_Completed",
STATUS_NONE:"None"},AnnotationReviewStateLocs:{STATUS_ACCEPTED:"AnnStatusAccepted",STATUS_REJECTED:"AnnStatusRejected",STATUS_CANCELLED:"AnnStatusCancelled",STATUS_COMPLETED:"AnnStatusCompleted",STATUS_NONE:"AnnStatusNone"},AnnotationSortType:{SORT_BY_MODIFICATION_DATE:0,SORT_BY_CREATION_DATE:1},StepThroughMode:{WITH_REPLIES:0,BY_THREAD:1,WITH_ZOOM:2,WITH_LINKED:3},AnnotationViewType:{VIEWTYPE_ALL:0,VIEWTYPE_ONLYFILE:1,VIEWTYPE_ONLYDIFF:2,VIEWTYPE_NONE:3},AnnotationComments:{"0":"AnnCommRect",4:"AnnCommOval",
6:"AnnCommHighlight",1:"AnnCommLine",5:"AnnCommArrow",11:"AnnCommNote",3:"AnnCommFreehand"},AnnotationIcons:{"0":"annotRect",4:"annotOval",6:"annotHighlight",1:"annotLine",5:"annotArrow",11:"annotNote",3:"annotFreehand"},AnnotationToolIcons:{"0":"addRectangle",4:"addOval",6:"addHighlight",1:"addLine",5:"addArrow",11:"addNote",3:"addFreehand"},annotateMode:{NO_RESTRICTIONS:0,IF_APPROVED_SHOW_WARNING:1,IF_APPROVED_DISABLE:2,ALWAYS_DISABLE:3,IF_APPROVED_OR_REJECTED_SHOW_WARNING:4,IF_APPROVED_OR_REJECTED_DISABLE:5},
allowedAnnotators:{ALL:0,ALL_APPROVERS:1,ALL_APPROVERS_AND_MASTER:2,PENDING_APPROVERS:3,PENDING_APPROVERS_AND_MASTER:4},FilterOperators:{ALL:0,ANY:1},FilterTypes:{AUTHOR:0,REVIEWSTATE:1,REVIEWAUTHORANDSTATE:2},FilterTypeNameLocs:{AUTHOR:"AnnotFilterAuthor",REVIEWSTATE:"AnnotFilterReviewState",REVIEWAUTHORANDSTATE:"AnnotFilterReviewAuthorAndState"},FilterCondition:{IS:0,ISNOT:1}});
define("web-viewer/approval/ApprovalConstants",{ViewerStateToComplexApprovalState:{"00001_0000000001":"Rejected","00001_0000000002":"Pending","00001_0000000003":"Approved","00001_0000000004":"ForceRejected","00001_0000000005":"ForceApproved","00001_0000000006":"ApprovedConditional","00001_0000000007":"ForceApprovedConditional"},ComplexApprovalStateToViewerState:{Rejected:"00001_0000000001",Pending:"00001_0000000002",MustApprove:"00001_0000000002",Approved:"00001_0000000003",ForceRejected:"00001_0000000004",
ForceApproved:"00001_0000000005",ApprovedConditional:"00001_0000000006",ForceApprovedConditional:"00001_0000000007"}});
define("web-viewer/cad/CadConstants",{CadLayerLocName:{MAIN:"LayerMain",SHEET:"LayerSheet",L1:"LayerL1",DIE:"LayerDie",STRIP:"LayerStrip",FSTRIP:"LayerFStrip",MSTRIP:"LayerMStrip",GUILL:"LayerGuill",VARNISH:"LayerVarnish",FINGERS:"LayerFingers",BLANK:"LayerBlank",USER1:"LayerUser1",USER2:"LayerUser2",USER3:"LayerUser3",USERDEFINED:"LayerUser",RULEPATH:"LayerRulepath"},CadClassName:{"0":"ClassMain",1:"ClassManufacturing",2:"ClassCutouts",3:"ClassDimensions",4:"ClassOverall",5:"ClassAnnotation",6:"ClassRegistration",
7:"ClassBleed",8:"ClassGraphics",9:"ClassCounter",10:"ClassCoating1",11:"ClassDiagram",12:"ClassOutsideGraphics",13:"ClassOutputLayer",14:"ClassCoating2",15:"ClassCoating3",16:"ClassInsideBleed",17:"ClassInsideGraphics",18:"ClassInsideCoating",19:"ClassCross",20:"ClassLabelGraphics",21:"ClassShrinkWrapGraphics"},CadDocType:{OneUp:1,Layout:2},CadTypes:{Nick:-11},ShowBridgesNicks:{NONE:1,BRIDGES:2,NICKS:3,BOTH:4},LineTypes:{1:[6,6],2:[6,3,3,3],3:[3,3],10:[11,3,3,3,3,3],20:[11,11],30:[16,1],40:[14,3],
50:[14,7],60:[11,3,3,3,3,3,3,3]},CadGraphicsMode:{BOTH:1,GRAPHICS_ONLY:2,CAD_ONLY:3},DefaultSide:{OUTSIDE:"-1",INSIDE:"1"},GrainFluteDirection:{VERTICAL:"1",HORIZONTAL:"2"},DieSide:{BACKSIDE:"1",KNIFESIDE:"-1"}});define("web-viewer/data/DataConstants",{documentPageType:{CAD:0,GRAPHICS:1,PAGELIST:2},imageType:{OTHER:0,GRAPHICS:1},charsequencePreferences:["LAYOUT_STATE","LAYOUT_PREFERENCE","ANNOTATION_FILTER"]});
define("web-viewer/data/AbstractDataAdapter",["web-viewer/core/PrivateChannel"],function(g){var e=function(d,c){this.f=d;this._instance=c;g.installTo(this,d,["doc"])};e.prototype.openDocuments=function(){};e.prototype.getInstance=function(){return this._instance};e.prototype.loadDocument=function(){};e.prototype.loadDocuments=function(){};e.prototype.getDeepCopy=function(){};e.prototype.loadVersionsOfDocumentPage=function(){};e.prototype.updateDocumentParameters=function(){};e.prototype.updateDocumentData=
function(){};e.prototype.cancelDocumentParametersUpdate=function(){};e.prototype.saveCadOverlay=function(){};e.prototype.show3DView=function(){};return e});
define("web-viewer/data/AbstractDocumentPage",["web-viewer/core/Extendable","web-viewer/core/PrivateChannel","web-viewer/data/DataConstants","underscore","web-viewer/utils/ShapeUtils"],function(g,e,d,c,f){g=function(b,a,c){this.f=b;var d=["doc",a.getDocument().getIID()];d.push("version",a.getVersionId());d.push("page",c);e.installTo(this,b,d);this._data={};this._parameters=null;this._state={};this._hasAnnotations=!1;this._docVersion=a;this._pagenum=parseInt(c,10);this._isReaderSpread=!1;this._linkedComparePage=
null;this._isParametersAvailable=this._isBlankPage=!1};g.prototype.get=function(b){if(void 0!==this._data[b])return this._data[b]};g.prototype.set=function(b,a){var c=this._data[b];this._data[b]=a;c!=a&&this._emit(["property",b,"changed"],c,a)};g.prototype.reset=function(b){delete this._data[b]};g.prototype.getData=function(){return c.clone(this._data)};g.prototype.getDocumentVersion=function(){return this._docVersion};g.prototype.getPagenum=function(){return this._pagenum};g.prototype.getDocument=
function(){return this._docVersion.getDocument()};g.prototype.getParam=function(b){if(null!==this._parameters&&void 0!==this._parameters[b])return this._parameters[b]};g.prototype.hasParam=function(b){return null!==this._parameters&&void 0!==this._parameters[b]};g.prototype.getParams=function(){return c.clone(this._parameters)};g.prototype.setParam=function(b,a){this._parameters[b]=a;this._emit("parameters.changed",this)};g.prototype.resetParam=function(b){delete this._parameters[b];this._emit("parameters.changed",
this)};g.prototype.rotatePage=function(b){this.setRotation(this.getRotation()+b)};g.prototype.setRotation=function(b){this.setStateParam("rotation",b%360)};g.prototype.flipPage=function(b){void 0===b&&(b=!this.getStateParam("flipped"));this.setStateParam("flipped",b)};g.prototype.getRotation=function(){var b=this.getStateParam("rotation");return b?1*b:0};g.prototype.isFlipped=function(){return void 0===this.getStateParam("flipped")?!1:this.getStateParam("flipped")&&!0};g.prototype.getOrigin=function(){return new f.Point};
g.prototype.getPageSize=function(){return new f.Size};g.prototype.getOriginalSize=function(){return new f.Size};g.prototype.getImageType=function(){return null!==this._parameters?parseInt(this._parameters.imagetype,10):-1};g.prototype.getImageURL=function(){this.f.emit("error.SEVERE","No getImageURL implementation is provided");return"UNDEFINED"};g.prototype.getInfoURL=function(){this.f.emit("error.SEVERE","No getInfoURL implementation is provided");return"UNDEFINED"};g.prototype.getMargins=function(){};
g.prototype.hasGraphics=function(){return void 0!==this._data.file};g.prototype.hasAnnotations=function(){return this._hasAnnotations};g.prototype.hasCad=function(){return this._data.cad?!0:!1};g.prototype.hasLinkedPage=function(){return this.getDocument().hasLinkedDocument()};g.prototype.getLinkedPage=function(){return this.getDocument().getLinkedDocumentPage()};g.prototype.getUniqueID=function(){return this._docVersion.getDocument().getIID()+"_"+this._docVersion.getVersionId()+"_"+this._pagenum};
g.prototype.isParametersAvailable=function(){return null!==this._parameters&&this._isParametersAvailable};g.prototype.whenParametersAvailable=function(b,a){a&&(b=c.bind(b,a));if(this.isParametersAvailable())b(this);else this.once("parameters.available",c.bind(function(){b(this)},this))};g.prototype.setParameters=function(b){this._parameters=b;this._emit("parameters.changed",this)};g.prototype.resetParameters=function(){this._parameters=null};g.prototype.interceptFragmentURL=function(){};g.prototype.setHasAnnotations=
function(b){b!==this._hasAnnotations&&(this._hasAnnotations=b,this._emit("hasAnnotations.changed",this))};g.prototype.equals=function(b){return b&&this.getUniqueID()==b.getUniqueID()&&this._docVersion==b._docVersion&&this._hasAnnotations==b._hasAnnotations&&c.every(this._data,function(a,c){return a==b._data[c]})?!0:!1};g.prototype.setParametersAvailable=function(b){(this._isParametersAvailable=b)&&this._emit("parameters.available")};g.prototype.setCadDataAvailable=function(){this._emit("cadData.available")};
g.prototype.setReaderSpread=function(b){this._isReaderSpread=b};g.prototype.isReaderSpread=function(){return this._isReaderSpread};g.prototype.getNextPage=function(b,a){var c=this.getDocumentVersion();void 0===b&&(b=1);for(var d=Math.min(this.getPagenum()+b,c.getPageCount()),f=c.getPage(d);(void 0===f||a&&f.isBlankPage())&&++d<=c.getPageCount();)f=c.getPage(d);return f};g.prototype.getPreviousPage=function(b,a){var c=this.getDocumentVersion();void 0===b&&(b=1);for(var d=Math.max(this.getPagenum()-
b,1),f=c.getPage(d);(void 0===f||a&&f.isBlankPage())&&1<=--d;)f=c.getPage(d);return f};g.prototype.getLinkedComparePage=function(){return this._linkedComparePage};g.prototype.setLinkedComparePage=function(b){this._linkedComparePage=b};g.prototype.resetLinkedComparePage=function(){this._linkedComparePage=null};g.prototype.hasLinkedComparePage=function(){return null!==this._linkedComparePage};g.prototype.isRectOnPage=function(){};g.prototype.getPageVersionId=function(){return null};g.prototype.isBlankPage=
function(){return this._isBlankPage};g.prototype.isDigitalFilmPage=function(){return!1};g.prototype.setStateParam=function(b,a){this._state[b]=a;this._emit("stateParameter.changed",this,b)};g.prototype.hasStateParam=function(b){return void 0!==this._state[b]};g.prototype.getStateParam=function(b){return this._state[b]};g.prototype.resetStateParam=function(b){delete this._state[b]};g.prototype.resetState=function(){this._state={}};g.prototype.getThumbnailUrl=function(){return null};g.prototype.getInformationForDocumentSelector=
function(){return null};g.prototype.canSaveCadOverlay=function(){return!1};g.prototype.needsDataUpdate=function(){return!1};return g});
define("web-viewer/data/PreferencesConstants",{PREFERENCES_UNIT_SIZE:1,PREFERENCES_UNIT_RESOLUTION:2,PREFERENCES_VIEW_ZOOM_MODE:3,PREFERENCES_ANNOTATION_NEXT_MODE:4,PREFERENCES_CHANNELS_SINGESEPBLACK:5,PREFERENCES_FILEOPEN_RECENTPATH:6,PREFERENCES_FILEOPEN_FILTER:7,PREFERENCES_IMAGE_BACKGROUNDCOLOR:8,PREFERENCES_WINDOW_BACKGROUNDCOLOR:9,PREFERENCES_UNIT_SCREEN:10,PREFERENCES_UNIT_ANGLE:11,PREFERENCES_DISPLAY_MARGINS:12,PREFERENCES_MERGEFILES:13,PREFERENCES_HELPBLOCKERWARNING:14,PREFERENCES_DIFFMODE:15,
PREFERENCES_RULER_DISPLAY_MODE:16,PREFERENCES_RULER_DISPLAY_COLOR:17,PREFERENCES_UPDATE_PALETTE:18,PREFERENCES_ENABLE_BACKGROUNDCOLOR:19,PREFERENCES_SCREEN_ORIENTATION:20,PREFERENCES_DIFFMODE_COMPARE:21,PREFERENCES_DOCUMENTHISTORYDIALOG_DETAILSMODE:22,PREFERENCES_DOCUMENTHISTORYDIALOG_DOCKED:23,PREFERENCES_DOCUMENTSELECTDIALOG_DOCKED:24,PREFERENCES_RULER_ANGLE_MODE:25,PREFERENCES_RECTOVERSO_MODE:26,PREFERENCES_CHANNELNAME_MODE:27,PREFERENCES_COLORMATCHING:28,PREFERENCES_COLORMATCHING_PROMPT:29,PREFERENCES_DOCUMENTHISTORYDIALOG_REOPEN:30,
PREFERENCES_DOCUMENTSELECTDIALOG_REOPEN:31,PREFERENCES_PAGELISTDIALOG_REOPEN:32,PREFERENCES_PAGELISTDIALOG_DOCKED:33,PREFERENCES_PAGELIST_ICON_SIZE:34,PREFERENCES_READOUTDIALOG_SCREEN_VISIBLE:35,PREFERENCES_READOUTDIALOG_DOT_VISIBLE:36,PREFERENCES_SHOWBRIDGES_MODE:37,PREFERENCES_ANNOTATION_NOTE_COLOR:38,PREFERENCES_ANNOTATION_RECTANGLE_COLOR:39,PREFERENCES_DOCUMENTANNOTATIONDIALOG_REOPEN:40,PREFERENCES_DOCUMENTANNOTATIONDIALOG_DOCKED:41,PREFERENCES_ANNOTATION_FITVIEW:42,PREFERENCES_ANNOTATION_SHOWSELECTEDONLY:43,
PREFERENCES_ZOOMTOOLS_VISIBLE:44,PREFERENCES_TOOLSPANEL_VISIBLE:45,PREFERENCES_MARGIN_CLIP_MODE:46,PREFERENCES_MARGIN_DISPLAY_MODE:47,PREFERENCES_PANELMAINTOOLS_SKOWMASK:48,PREFERENCES_TOOLSPANELTOP_VISIBLE:49,PREFERENCES_ANNOTATION_SHOWCOUNT:50,PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY:51,PREFERENCES_ANNOTATIONTOOLS_VISIBLE:52,PREFERENCES_ANNOTATION_TOOLMODE:53,PREFERENCES_ANNOTATION_DATESORT_MODE:54,PREFERENCES_READOUTDIALOG_BARCODE_VISIBLE:55,PREFERENCES_DIFF_SPLITMODE:56,PREFERENCES_INKBOOKPATH:57,
PREFERENCES_READOUTDIALOG_BRAILLE_VISIBLE:58,PREFERENCES_VIEWX_PARAMETERS:59,PREFERENCES_VIEWXTOOLS_VISIBLE:60,PREFERENCES_BRAILLE_LANGUAGE:61,PREFERENCES_MERGE_SIMILAR_INKS:62,PREFERENCES_VIEWXTOOLS_ENABLE1BIT:63,PREFERENCES_ANTIALIASING:64,PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE:65,PREFERENCES_PILOT_SELECTSERVER:66,PREFERENCES_PILOT_SERVERNAME:67,PREFERENCES_RULER_DISPLAY_MODE_DA:68,PREFERENCES_RULER_DISPLAY_MODE_XY:69,PREFERENCES_RULER_DISPLAY_MODE_WH:70,PREFERENCES_CALIPER_DISPLAY_MODE:71,PREFERENCE_MONITOR_RES:72,
PREFERENCES_ZOOM_REALSIZE:73,PREFERENCES_PRINT_SPLITVIEW:78,PREFERENCES_PRINT_MAGNIFICATION:79,PREFERENCES_PRINT_MARG_TOP:80,PREFERENCES_PRINT_MARG_LEFT:81,PREFERENCES_PRINT_MARG_BOTTOM:82,PREFERENCES_PRINT_MARG_RIGHT:83,PREFERENCES_PRINT_ORIENTATION:84,PREFERENCES_PRINT_TYPE:85,PREFERENCES_PRINT_AREA:86,PREFERENCES_PRINT_CHANNELS:87,PREFERENCES_PRINT_RESOLUTION:88,PREFERENCES_PRINT_SCALETOFIT:89,PREFERENCES_HIGHLIGHTCOLORS:90,PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD:91,PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB:92,
PREFERENCES_HIGHLIGHTCOLORS_SEAMLESS_GUIDELINES:93,PREFERENCES_HIGHLIGHTCOLORS_MARGINS:94,PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF:95,LAYOUT_EXPAND_PAGETOOLS_STATE:100,LAYOUT_EXPAND_CHANNELS_STATE:101,LAYOUT_EXPAND_NAVIGATOR_STATE:102,LAYOUT_WINDOW_SIZE_X:103,LAYOUT_WINDOW_SIZE_Y:104,LAYOUT_MODE:105,LAYOUT_MAIN_PANEL_RIGHT_SPLITTER:106,LAYOUT_EXPAND_ANNOTATIONS_STATE:107,LAYOUT_EXPAND_APPROVAL_STATE:108,LAYOUT_NAVIGATOR_SIZE_X:109,LAYOUT_NAVIGATOR_SIZE_Y:110,LAYOUT_EXPAND_CAD_STATE:111,LAYOUT_LAYERSTABLE_SIZE:112,
LAYOUT_CLASSESTABLE_SIZE:113,LAYOUT_FRAME_SIZE_X:114,LAYOUT_FRAME_SIZE_Y:115,LAYOUT_FRAME_MAXIMIZED:116,LAYOUT_EXPAND_PAGEVIEW_STATE:117,LAYOUT_EXPAND_INFO_STATE:118,LAYOUT_LOOK_AND_FEEL:119,LAYOUT_CHANNELEDITDIALOG_WIDTH:120,LAYOUT_DOCUMENTSELECTDIALOG_WIDTH:121,LAYOUT_DOCUMENTSELECTDIALOG_HEIGHT:122,LAYOUT_DOCUMENTHISTORYDIALOG_WIDTH:123,LAYOUT_DOCUMENTHISTORYDIALOG_HEIGHT:124,LAYOUT_MAIN_PANEL_LEFT_SPLITTER:125,LAYOUT_EXPAND_DIFFADJUST:126,LAYOUT_PAGELISTDIALOG_WIDTH:127,LAYOUT_PAGELISTDIALOG_HEIGHT:128,
LAYOUT_DOCUMENTANNOTATIONDIALOG_WIDTH:129,LAYOUT_DOCUMENTANNOTATIONDIALOG_HEIGHT:130,MRU_COUNT:200,MRU_ENTRY1:201,PML_ENTRY1:301,PML_MAXENTRY:399,CONFIG_ISGRAPHOLAS:400,CONFIG_GRAPHOLASHOME:401,CONFIG_SHOWDIFFADJUST:402,CONFIG_COLORMATCHING:403,CONFIG_TOOLTIP_INITIAL:404,CONFIG_TOOLTIP_RESHOW:405,CONFIG_TOOLTIP_DISMISS:406,CONFIG_DIFF_PERCENTAGE:407,CONFIG_DIFF_COMPAREMODE:408,CONFIG_GRAPHOLAS_CENTERLINE:409,CONFIG_GRAPHOLAS_MICROCROSS:410,LAYOUT_STATE:1E3,LAYOUT_PREFERENCE:1010,CALIPER_PRESETS:1100,
PREFERENCES_UNIT_EYEDROPPER:1200,PREFERENCES_UNIT_SCREENRULING:1201,ANNOTATION_FILTER:1300,PREFERENCES_DIFFMODE_THRESHOLD:1400});
define("web-viewer/data/PreferencesDefaults",{PREFERENCES_ANNOTATION_NEXT_MODE:1,PREFERENCES_UNIT_RESOLUTION:2,PREFERENCES_READOUTDIALOG_DOT_VISIBLE:1,PREFERENCES_DISPLAY_MARGINS:0,LAYOUT_EXPAND_PAGEVIEW_STATE:1,PREFERENCES_ANNOTATIONTOOLS_VISIBLE:1,PREFERENCES_DOCUMENTSELECTDIALOG_DOCKED:1,PREFERENCES_READOUTDIALOG_SCREEN_VISIBLE:1,PREFERENCES_MERGE_SIMILAR_INKS:-1,PREFERENCES_ANNOTATION_FITVIEW:1,PREFERENCES_PANELMAINTOOLS_SKOWMASK:127,PREFERENCES_DOCUMENTANNOTATIONDIALOG_REOPEN:1,LAYOUT_EXPAND_CHANNELS_STATE:1,
PREFERENCES_ZOOMTOOLS_VISIBLE:0,PREFERENCES_MERGEFILES:1,LAYOUT_MODE:1,PREFERENCES_CHANNELNAME_MODE:0,PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE:0,LAYOUT_NAVIGATOR_SIZE_Y:128,PREFERENCES_ANNOTATION_RECTANGLE_COLOR:-65536,PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD:-16776961,PREFERENCES_HIGHLIGHTCOLORS_MARGINS:-16744193,PREFERENCES_MARGIN_CLIP_MODE:1,PREFERENCES_DOCUMENTHISTORYDIALOG_DOCKED:1,PREFERENCES_ANNOTATION_SHOWSELECTEDONLY:1,LAYOUT_NAVIGATOR_SIZE_X:128,LAYOUT_MAIN_PANEL_RIGHT_SPLITTER:203,PREFERENCES_WINDOW_BACKGROUNDCOLOR:5592405,
PREFERENCES_ANTIALIASING:-1,PREFERENCES_MARGIN_DISPLAY_MODE:0,PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB:-65536,PREFERENCES_HIGHLIGHTCOLORS:-1,PREFERENCES_ANNOTATION_DATESORT_MODE:0,PREFERENCES_DOCUMENTSELECTDIALOG_REOPEN:0,PREFERENCES_DIFFMODE:1,PREFERENCES_DIFFMODE_COMPARE:2,PREFERENCES_PAGELISTDIALOG_DOCKED:1,PREFERENCES_RULER_DISPLAY_MODE:1,LAYOUT_EXPAND_NAVIGATOR_STATE:1,LAYOUT_MAIN_PANEL_LEFT_SPLITTER:209,PREFERENCES_TOOLSPANEL_VISIBLE:0,PREFERENCES_VIEW_ZOOM_MODE:0,PREFERENCES_IMAGE_BACKGROUNDCOLOR:-1,
LAYOUT_EXPAND_DIFFADJUST:0,MRU_COUNT:0,PREFERENCES_ANNOTATION_SHOWCOUNT:0,PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY:1,LAYOUT_CLASSESTABLE_SIZE:83,LAYOUT_EXPAND_PAGETOOLS_STATE:1,PREFERENCES_UNIT_ANGLE:0,LAYOUT_EXPAND_APPROVAL_STATE:1,LAYOUT_EXPAND_INFO_STATE:1,CONFIG_SHOWDIFFADJUST:0,PREFERENCES_RULER_DISPLAY_COLOR:-13022894,PREFERENCES_HIGHLIGHTCOLORS_SEAMLESS_GUIDELINES:-16711936,PREFERENCES_VIEWXTOOLS_ENABLE1BIT:0,PREFERENCES_PAGELISTDIALOG_REOPEN:0,LAYOUT_LOOK_AND_FEEL:0,PREFERENCES_ANNOTATION_NOTE_COLOR:-256,
PREFERENCES_UNIT_SCREEN:2,PREFERENCES_VIEWX_PARAMETERS:"",PREFERENCES_DIFF_SPLITMODE:4,PREFERENCES_DOCUMENTHISTORYDIALOG_REOPEN:0,CONFIG_DIFF_COMPAREMODE:0,PREFERENCES_SHOWBRIDGES_MODE:2,LAYOUT_EXPAND_CAD_STATE:1,PREFERENCES_TOOLSPANELTOP_VISIBLE:1,PREFERENCES_READOUTDIALOG_BRAILLE_VISIBLE:1,LAYOUT_LAYERSTABLE_SIZE:83,PREFERENCES_COLORMATCHING:2,PREFERENCES_READOUTDIALOG_BARCODE_VISIBLE:1,PREFERENCES_ANNOTATION_TOOLMODE:0,PREFERENCES_VIEWXTOOLS_VISIBLE:0,LAYOUT_EXPAND_ANNOTATIONS_STATE:1,PREFERENCES_CHANNELS_SINGESEPBLACK:0,
PREFERENCES_HIGHLIGHTCOLORS_MARGINS_DIFF:-32768,PREFERENCES_DOCUMENTANNOTATIONDIALOG_DOCKED:1,PREFERENCES_BRAILLE_LANGUAGE:0,PREFERENCES_RULER_DISPLAY_MODE_DA:1,PREFERENCES_RULER_DISPLAY_MODE_XY:0,PREFERENCES_RULER_DISPLAY_MODE_WH:0,PREFERENCE_MONITOR_RES:72/25.4+"",PREFERENCES_ZOOM_REALSIZE:0,PREFERENCES_PRINT_TYPE:0,PREFERENCES_PRINT_AREA:0,PREFERENCES_PRINT_CHANNELS:0,PREFERENCES_PRINT_RESOLUTION:150/25.4+"",PREFERENCES_PAGELIST_ICON_SIZE:1,LAYOUT_STATE:"",LAYOUT_PREFERENCE:"automatic",PREFERENCES_UNIT_EYEDROPPER:5,
PREFERENCES_SCREEN_ORIENTATION:1,ANNOTATION_FILTER:"",PREFERENCES_DIFFMODE_THRESHOLD:0});
define("web-viewer/data/User",["underscore","web-viewer/core/Extendable","web-viewer/core/PrivateChannel","web-viewer/utils/ViewerUtils","web-viewer/data/PreferencesDefaults"],function(g,e,d,c,f){var b=function(a,b,c,f,l){this.f=null;this.persistDebounced=g.debounce(g.bind(this._persistUserOptions,this),1E3);e.installTo(this);this._options={};this._originalNonPersistedValues={};this.getID=function(){return a};this.getUsername=function(){return b};this.lastname=f;this.first=c;void 0===l&&(l="en");
this.locale=l;this.setFacade=g.once(function(b){this.f=b;d.installTo(this,this.f,["user",a])})};b.prototype.getFullName=function(){return this.getUsername()};b.prototype.getLastName=function(){return this.lastname};b.prototype.getFirstName=function(){return this.first};b.prototype.getLocale=function(){return this.locale};b.prototype.setOption=function(a,b,c,d){var f=this._options[a];f!==b?(this._options[a]=b,this._emit("options.changed."+a,f,b),c?void 0===this._originalNonPersistedValues[a]&&(this._originalNonPersistedValues[a]=
f):(delete this._originalNonPersistedValues[a],d?this._persistUserOptions(d):this.persistDebounced())):d&&d(!0)};b.prototype.setOptions=function(a){g.each(a,function(a,b){this.setOption(b,a)},this)};b.prototype.initializeOption=function(a,b){var c=this._options[a];c!==b&&(this._options[a]=b,this._emit("options.changed."+a,c,b))};b.prototype.initializeOptions=function(a){g.each(a,function(a,b){this.initializeOption(b,a)},this)};b.prototype.getOptions=function(){return this._options};b.prototype.getOption=
function(a){return this._options[a]};b.prototype.getColor=function(a){return"#"+c.hexFromInt(this.getOption(a))};b.prototype.setColor=function(a,b){-1<b.indexOf("#")&&(b=b.replace("#",""));this.setOption(a,c.intFromHex(b))};b.prototype.persistOptions=function(){};b.prototype.loadOptions=function(){};b.prototype.resetOption=function(a){this.setOption(a,f[a])};b.prototype.getOptionDefault=function(a){return f[a]};b.prototype._persistUserOptions=function(a){var b=g.clone(this._options);g.each(this._originalNonPersistedValues,
function(a,c){b[c]=a});this.persistOptions(b,a)};return b});define("web-viewer/data/DataModule","web-viewer/data/AbstractDataAdapter web-viewer/data/AbstractDocument web-viewer/data/AbstractDocumentPage web-viewer/data/AbstractDocumentVersion web-viewer/data/DataConstants web-viewer/data/DocumentController web-viewer/data/PreferencesConstants web-viewer/data/PreferencesDefaults web-viewer/data/User".split(" "),function(){});
define("web-viewer/graphics/GraphicsConstants",{ChannelViewMode:{COMPOSITE_VIEW:0,AUTOMATIC_TILING:1,HORIZONTAL_TILING:2,VERTICAL_TILING:3},ChannelDiffMode:{CURRENT:0,PREVIOUS:1,IN_CURRENT_AND_MATCHED_WITH_PREVIOUS:2,IN_PREVIOUS_AND_MATCHED_WITH_CURRENT:3},ChannelViewModeLayoutMode:{COMPOSITE_VIEW:"AUTOMATIC",AUTOMATIC_TILING:"AUTOMATIC",HORIZONTAL_TILING:"HORIZONTAL",VERTICAL_TILING:"VERTICAL"},SingleChannelMode:{IN_CHANNEL_COLOR:0,IN_BLACK:1,IN_BLACK_WITH_SHOW_ALL_EFFECT:2},ResetToDefaultMode:{RESET_ORDER:0,
RESET_COLORS:1,RESET_BOTH:2},ChannelMatching:{IDENTICAL_MATCHING:0,NAME_MATCHING:1,SMART_NAME_MATCHING:2}});define("tpl",["underscore"],function(g){var e={};return{load:function(d,c,f){g.templateSettings.variable="d";c.toUrl(d+".tpl.html");c(["lib/text!"+d+".tpl.html","underscore"],function(b,a){var c=a.template(b);f(c)})},write:function(d,c,f){if(c in e){var b=g.template("define('<%-d.pluginName%>!<%=d.moduleName%>', function(){return <%=d.func%>});");f(b({pluginName:d,moduleName:c,func:e[c]}))}}}});
define("web-viewer/layout/component/ButtonGroup",["jquery","underscore"],function(g){var e=function(d,c){this.name=d;this.btngroup=this.element=g("<div/>").attr("name",d).addClass("btn-group");this.titleElement=void 0;this.buttons=[];this.prependButton=function(b){this.btngroup.prepend(b.element);this.buttons.unshift(b)};this.addButton=function(b){this.detachButton(b);this.btngroup.append(b.element);this.buttons.push(b)};this.detachButton=function(b){var a=this.buttons.length;this.buttons=_.without(this.buttons,
b);a!=this.buttons.length&&b.element.detach()};this.clearButtons=function(){_.each(this.buttons,function(b){b.element.detach()});this.buttons=[]};this.addSeparator=function(){this.btngroup.append(g("<span/>").addClass("separator"))};if(c)for(var f in c)c.hasOwnProperty(f)&&this.addButton(c[f]);this.hide=function(){this.element.addClass("displayNone")};this.show=function(){this.element.removeClass("displayNone")}};e.prototype.setTitle=function(d,c,f){this.element=g("<div/>").addClass("btnGroupWithTitle").append(this.element);
void 0===this.titleElement&&(this.titleElement=g("<div/>").addClass("btnGroupTitle"),this.element.append(this.titleElement));d.i18n.loadBundle(c,_.bind(function(){this.titleElement.text(d.i18n.t(f))},this))};e.prototype.moved=function(){_.each(this.buttons,function(d){d.moved()})};return e});
define("web-viewer/layout/component/ColorPicker",["web-viewer/utils/ViewerUtils","web-viewer/layout/component/Tooltip","underscore","jquery","colorpicker"],function(g,e,d,c){var f=function(b,a){this._onColorPicked=b;this._colorBlock=this._color=void 0;this.element=this._colorBlock=void 0===a?c("<div />").addClass("colorblock"):a;this._lazyOnChange=d.debounce(d.bind(this._onChange,this),50);this.element.ColorPicker({onChange:this._lazyOnChange,onBeforeShow:d.bind(function(){c(this).ColorPickerSetColor(this._color)},
this),onSubmit:function(a,b,d,f){c(f).ColorPickerHide()}})};f.prototype._onChange=function(b,a){this._color=a.toUpperCase();this._updateColor();this._onColorPicked(this._color)};f.prototype._updateColor=function(){this._colorBlock.hasClass("colorblock")&&this._colorBlock.css("background-color","#"+this._color)};f.prototype.setColor=function(b){g.startsWith(b,"#")&&(b=b.substring(1));this._color!=b&&(this._color=b,this._updateColor())};f.prototype.getColor=function(){return this._color};f.prototype.show=
function(){this.element.ColorPickerShow()};f.prototype.hide=function(){this.element.ColorPickerHide()};f.prototype.destroy=function(){this.element.ColorPickerHide();c("#"+this.element.data("colorpickerId")).detach()};f.prototype.setTooltip=function(b,a,c,d){void 0===this.tooltip?this.tooltip=new e(b,this._colorBlock,a,c,d):this.tooltip.setTooltipContent(a,c,d)};return f});
define("web-viewer/layout/component/DropdownMenu",["web-viewer/layout/component/Popover","web-viewer/layout/component/Button","jquery","underscore"],function(g,e,d,c){var f=function(b,a,c,d,f){this.f=b;this.active=!1;this._attachedTo=void 0;this._restrictedPositions=f;this.items={};this.itemStack=[];this.dividerNum=0;this._listElements={};this.menu=void 0;this.autoHideTimeout=750;this._minHeight=d;this._popoverPosition=a||"bottom";this._popoverClass=c};f.prototype._initialize=function(){this.menu=
d("<ul/>").addClass("dropdown-menu");this.popover=new g(this.f.getContext(),this.f.getContext(),this.f.getContext(),this._popoverPosition,"#ffffff",this._popoverClass,0,this._minHeight,!0);this._restrictedPositions&&this.popover.setPlacementOptions(this._restrictedPositions);this.popover.setContent(this.menu);c.each(this.itemStack,function(b){this._addItemToDOM(b);b.isVisible||this.hideElement(b.name)},this);this._isInitialized=!0};f.prototype.attachTo=function(b){this.attachedEvent&&this._attachedTo.off("click",
this.attachedEvent);this._attachedTo=b;this.attachedEvent=c.bind(function(){this.isActive()?this.hide():this.show()},this);this._attachedTo.on("click",this.attachedEvent)};f.prototype.show=function(b){void 0===b&&(b=this._attachedTo);this._isInitialized||this._initialize();this.popover.setContext(b);this.popover.show();this.startAutoHide(b);this.active=!0};f.prototype.hide=function(){this.popover.hide();this.active=!1};f.prototype.toggle=function(b){void 0===b&&(b=!this.active);b?this.show():this.hide()};
f.prototype.isActive=function(){return this.active};f.prototype.addAction=function(b){b.type="action";void 0===b.enabled&&(b.enabled=!0);this._addItem(b,b.after)};f.prototype.removeAction=function(b){this._listElements[b]?(this._listElements[b].remove(),delete this._listElements[b]):(b=c.indexOf(this.itemStack,this.items[b]),0<=b&&this.itemStack.splice(b,1))};f.prototype.addGroup=function(b){b.type="group";void 0===b.enabled&&(b.enabled=!0);this._addItem(b)};f.prototype.setActionEnabled=function(b,
a){this.items[b]&&(this.items[b].enabled=a,this._isInitialized&&this.items[b].btn.setEnabled(a))};f.prototype.isActionEnabled=function(b){return this.items[b]&&this.items[b].enabled};f.prototype.addDivider=function(){var b={name:"divider"+this.dividerNum++,type:"divider"};this._addItem(b);return b.name};f.prototype.addOption=function(b){b.type="option";void 0===b.selected&&(b.selected=!1);void 0===b.enabled&&(b.enabled=!0);b.toggle=function(a){b.selected=void 0===a?!b.selected:1<a||a;b.iconElement&&
b.iconElement.toggleClass("icon-WCR_Checked",b.selected).toggleClass("unchecked",!b.selected)};b.action=function(){if(!b.userCannotUncheck||!b.selected)b.toggle(),b.onchange(b.selected)};this._addItem(b)};f.prototype.toggleOption=function(b,a){this.items[b]&&this.items[b].toggle(a)};f.prototype.getOptionValue=function(b){if(this.items[b])return this.items[b].selected};f.prototype._addItem=function(b,a){this.items[b.name]=b;if(a){var d=c.indexOf(this.itemStack,this.items[a]);0<=d?this.itemStack.splice(d+
1,0,b):this.itemStack.unshift(b)}else this.itemStack.push(b);void 0===b.isVisible&&(b.isVisible=!0);this._isInitialized&&b.isVisible&&this._addItemToDOM(b,a)};f.prototype._addItemToDOM=function(b,a){if("action"==b.type||"option"==b.type||"group"==b.type){"option"==b.type&&(b.icon=b.selected?"icon-WCR_Checked":"unchecked");b.btn=new e(this.f,"btn_"+b.name,b.content,!1,c.partial(function(a,c){b.action.call(this,c);b.doNotHideOnClick||a.hide()},this));b.cssClass&&b.btn.element.addClass(b.cssClass);b.btn.setEnabled(b.enabled);
var f=d("<li/>").addClass(b.name).append(b.btn.element);"group"==b.type&&(f=d("<div/>").addClass("group").addClass(b.name).append(f));this._listElements[b.name]=f;if(void 0!==b.group)this._listElements[b.group].append(f);else if(a){var g=this._listElements[a];g?g.after(f):this.menu.prepend(f)}else this.menu.append(f);this._prependIcon(b);b.isVisible||f.hide()}else"divider"==b.type?(f=d("<li/>").addClass("divider"),this._listElements[b.name]=f,this.menu.append(f),b.isVisible||f.hide()):this.f.emit("error.SEVERE",
"DropdownMenu shouldn't come into this state")};f.prototype.clear=function(){this.menu&&this.menu.empty();this.itemStack=[];this.items={};this._listElements={}};f.prototype.startAutoHide=function(b){if(this.f.isMobile())this._oneClickAutoHide||(this._oneClickAutoHide=c.bind(function(a){if(0===this.popover.element.has(a.target).length&&a.target!=this.popover.element[0]&&(!b||0===b.has(a.target).length&&b[0]!==a.target))this.hide(),d(document.body).off("click pointerup touchend",this._oneClickAutoHide)},
this)),d(document.body).on("click pointerup touchend",this._oneClickAutoHide);else{var a=void 0,f=void 0,e=function(){clearTimeout(a)},f=c.bind(function(){a&&clearTimeout(a);a=setTimeout(c.bind(function(){this.hide();b.add(this.popover.element).off({mouseenter:e,mouseleave:f})},this),this.autoHideTimeout)},this);b.add(this.popover.element).on({mouseenter:e,mouseleave:f})}};f.prototype.setActionText=function(b,a){var c=this.items[b];c.content=a;this._isInitialized&&(c.btn.setContent(a),this._prependIcon(c))};
f.prototype.hideElement=function(b){void 0!==this.items[b]&&(void 0!==this._listElements[b]&&(this._listElements[b].isVisible=!1,this._listElements[b].hide()),this.items[b].isVisible=!1)};f.prototype.showElement=function(b){void 0!==this.items[b]&&(this.items[b].isVisible=!0,void 0!==this._listElements[b]?(this._listElements[b].show(),this._listElements[b].isVisible=!0):this._isInitialized&&this._addItemToDOM(this.items[b]))};f.prototype.isElementVisible=function(b){if(void 0!==this.items[b])return this.items[b].isVisible};
f.prototype._prependIcon=function(b){void 0!==b.icon&&(c.isString(b.icon)?(b.iconElement=d("<i/>").addClass("icon").addClass(b.icon),b.btn.element.prepend(b.iconElement)):b.btn.element.prepend(b.icon))};return f});
define("web-viewer/layout/component/DropdownMiniButton","web-viewer/layout/component/MiniButton web-viewer/layout/component/DropdownMenu web-viewer/layout/component/Button web-viewer/layout/component/Popover jquery underscore".split(" "),function(g,e,d,c,f,b){d=function(a,b,c,d){g.call(this,a,b,c,!1,this.toggle);this.element.addClass("dropdown-mini-button");this.dropdown=new e(a,"bottom","dropdown",void 0,d);this.dropdown.attachTo(this.element);this.toggleCallbacks=[]};d.prototype=Object.create(g.prototype);
d.prototype.constructor=d;d.prototype.toggle=function(){this.toggleCallbacks&&b.each(this.toggleCallbacks,function(a){a(this.isActive)},this)};d.prototype.isOpen=function(){return this.dropdown.isActive()};d.prototype.show=function(){this.dropdown.show()};d.prototype.setActionText=function(a,b){this.dropdown.setActionText(a,b)};d.prototype.toggleOption=function(a,b){this.dropdown.toggleOption(a,b)};d.prototype.getOptionValue=function(a){return this.dropdown.getOptionValue(a)};d.prototype.setActionEnabled=
function(a,b){this.dropdown.setActionEnabled(a,b)};d.prototype.isActionEnabled=function(a){return this.dropdown.isActionEnabled(a)};d.prototype.setWarning=function(){this.badge.addClass("warning");this.setBadge("!")};d.prototype.removeWarning=function(){this.badge.removeClass("warning");this.setBadge("")};d.prototype.onToggle=function(a){this.toggleCallbacks.push(a)};d.prototype.addAction=function(a){this.dropdown.addAction(a)};d.prototype.addOption=function(a){this.dropdown.addOption(a)};d.prototype.addDivider=
function(){this.dropdown.addDivider()};d.prototype.clear=function(){this.dropdown.clear()};return d});define("web-viewer/layout/component/SubtoolbarButton",["web-viewer/layout/component/ToolbarButton","jquery"],function(g){var e=function(d,c,f,b,a){g.call(this,d,c,f,b,a);this.element.removeClass("btn").addClass("subtoolbar-btn")};e.prototype=Object.create(g.prototype);return e.prototype.constructor=e});
define("web-viewer/layout/component/DropdownSubtoolbarButton",["web-viewer/layout/component/SubtoolbarButton","web-viewer/layout/component/DropdownMenu","jquery","underscore"],function(g,e){var d=function(c,d,b,a){g.call(this,c,d,b,a,this.toggle);this.dropdown=new e(c,"bottom","dropdown")};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.toggle=function(){this.isOpen()?this.hide():this.show()};d.prototype.isOpen=function(){return this.dropdown.isActive()};d.prototype.show=
function(){this.dropdown.show(this.element)};d.prototype.hide=function(){this.dropdown.hide()};d.prototype.setActionText=function(c,d){this.dropdown.setActionText(c,d)};d.prototype.toggleOption=function(c,d){this.dropdown.toggleOption(c,d)};d.prototype.getOptionValue=function(c){return this.dropdown.getOptionValue(c)};d.prototype.setActionEnabled=function(c,d){this.dropdown.setActionEnabled(c,d)};d.prototype.isActionEnabled=function(c){return this.dropdown.isActionEnabled(c)};d.prototype.addAction=
function(c){this.dropdown.addAction(c)};d.prototype.addOption=function(c){this.dropdown.addOption(c)};d.prototype.addDivider=function(){this.dropdown.addDivider()};return d});
define("web-viewer/layout/component/DropdownToolbarButton",["web-viewer/layout/component/ToolbarButton","web-viewer/layout/component/DropdownMenu","jquery","underscore"],function(g,e,d,c){d=function(d,b,a,h,o){g.call(this,d,b,a,h,this.toggle);this.leftClickAction=o;if(void 0===this.leftClickAction)this.setAction(function(){this.isEnabled()&&this._dropdownEnabled&&(this.dropdown.isActive()?this.dropdown.hide():this.showDropdown())});else this.element.on("contextmenu",c.bind(function(a){a.preventDefault();
a.stopPropagation();this.isEnabled()&&this._dropdownEnabled&&this.showDropdown()},this));this._dropdownEnabled=!0;this.dropdown=new e(d,"bottom","dropdown")};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.toggle=function(){this.isActive()?this.leftClickAction(!1):this.leftClickAction(!0)};d.prototype.isOpen=function(){return this.dropdown.isActive()};d.prototype.showDropdown=function(){this.dropdown.show(this.element)};d.prototype.setActionText=function(c,b){this.dropdown.setActionText(c,
b)};d.prototype.toggleOption=function(c,b){this.dropdown.toggleOption(c,b)};d.prototype.getOptionValue=function(c){return this.dropdown.getOptionValue(c)};d.prototype.setActionEnabled=function(c,b){this.dropdown.setActionEnabled(c,b)};d.prototype.isActionEnabled=function(c){return this.dropdown.isActionEnabled(c)};d.prototype.addAction=function(c){this.dropdown.addAction(c)};d.prototype.addOption=function(c){this.dropdown.addOption(c)};d.prototype.addDivider=function(){this.dropdown.addDivider()};
d.prototype.enableDropdown=function(){this._dropdownEnabled=!0};d.prototype.disableDropdown=function(){this._dropdownEnabled=!1};d.prototype.clear=function(){this.dropdown.clear()};return d});
define("web-viewer/layout/component/ToolbarComponent",["web-viewer/layout/component/ButtonGroup","web-viewer/core/PrivateChannel","jquery","underscore"],function(g,e,d){g=function(c,f){e.installTo(this,f,["toolbarComponent",c]);this.name=c;this.element=d("<div />").attr("name",c).addClass("btn-toolbar");this.buttonGroups=[];this._isVisible=!0;this.addElement=function(b){this.element.append(b)};this.addButtonGroup=function(b){this.buttonGroups.push(b);this.element.append(b.element)};this.prependButtonGroup=
function(b){this.buttonGroups.unshift(b);this.element.prepend(b.element)};this.detachButtonGroup=function(b){this.buttonGroups=_.without(this.buttonGroups,b);b.element.detach()};this.moved=function(){_.each(this.buttonGroups,function(b){b.moved()})};this.show=function(){this.element.toggleClass("displayNone",!1);this._isVisible=!0;this._emit(["changed","visibility"])};this.hide=function(){this.element.toggleClass("displayNone",!0);this._isVisible=!1;this._emit(["changed","visibility"])}};g.prototype.getName=
function(){return this.name};g.prototype.isVisible=function(){return this._isVisible};return g});
define("web-viewer/layout/LayoutModule","web-viewer/layout/AbstractWidget web-viewer/layout/LayoutManager Template tpl web-viewer/layout/component/Button web-viewer/layout/component/ButtonGroup web-viewer/layout/component/ColorPicker web-viewer/layout/component/DropdownMenu web-viewer/layout/component/DropdownMiniButton web-viewer/layout/component/DropdownSubtoolbarButton web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/ToolbarButton web-viewer/layout/component/LoadingIndicator web-viewer/layout/component/MiniButton web-viewer/layout/component/ModalPopup web-viewer/layout/component/Popover web-viewer/layout/component/Popup web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/ToolbarButton web-viewer/layout/component/ToolbarComponent web-viewer/layout/component/Tooltip".split(" "),function(){});
define("web-viewer/measure/MeasureConstants",{MeasureType:{Ruler:0,EyeDropper:1,Barcode:2,Braille:3,Caliper:4,ScreenRuling:5},BrailleLanguage:{Automatic:0,English:1,French:2,Polish:3,Portuguese:4,Russian:5,Spanish:6,Finnish:7,German:8,Italian:9,Latvian:10,Romanian:11,Slovene:12,Swedish:13,Hungarian:14,Dutch:15,Maltese:16},LanguageTranslationPrefix:"Lanuguage",LanguageAutomatic:"Automatic",LanguageDefault:"English",LanguageLocales:{en:"English",fr:"French",pl:"Polish",br:"Portuguese",ru:"Russian",
es:"Spanish",de:"German",it:"Italian",hu:"Hungarian",nl:"Dutch"},CaliperStyle:{Freeform:0,Fixed:1,Preset:2},RulerPoint:{DEFAULT:"/wcr-static/web-viewer/layout/img/crosshair_fine.png",OFFSET:{width:7,height:7},CLOSETODISTANCE:15},MeasureDrawType:{RECTANGLE:0,LINE:1,WIDTH:2,HEIGHT:3},ScreenRulingMode:{LINES:0,ANGLE:1,BOTH:2},ScreenRulingOrientation:{XMP:0,CW:1,CCW:2},ClickSize:{NORMAL:1,DIGITAL_FILM:64},ServerInfoFlags:{barCode:512,barCodeGV:8192,braille:1024}});
define("web-viewer/navigation/PanTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/ShapeUtils","web-viewer/utils/GEOUtils","web-viewer/core/CoreConstants"],function(g,e,d,c,f){c=function(b){e.call(this,b,f.TOOLS.PAN);var a=new d.Point(0,0),c=new d.Size,o=!1,k=g.bind(function(d,f){var e=a.sizeTo(d);if(0<Math.abs(e.width)||0<Math.abs(e.height)||f){e=this.sceneToWorld(a).sizeTo(this.sceneToWorld(d));e.add(c);var g=void 0;f&&(g={duration:200,type:"ease-out"},o&&(b.emit("toolManager.deactivateTool",
this),o=!1));this._widget.getWorld().setOffsetSize(e,g)}},this);this.registerState("default",{mousedown:g.bind(function(b){1===b.which&&(a=this.getScenePoint(b),c=this._widget.getWorld().getOffsetSize(),this.changeState("panning"),b.preventDefault())},this),mouseup:function(){},mousemove:function(){},mouseout:function(){},mouseleave:function(){},dblclick:g.bind(function(a){this.changeState("default");this._widget.getWorld().isSmallerThanFullView()?this._widget.getWorld().zoomToFit(!0):this.zoom(1,
this.getWorldPoint(a),!0)},this),contextmenu:g.bind(function(a){a.preventDefault();a.stopPropagation();this.zoom(-1,this.getWorldPoint(a),!0)},this)});var l=void 0,i=new d.Point(0,0);this.registerState("panning",g.defaults({enterState:function(){l&&(clearTimeout(l),l=null);b.emit("viewport.startInteractive");b.emit("viewport.startPanning");b.emit("layout.disableTextSelection")},leaveState:function(){a=new d.Point(0,0);b.emit("viewport.stopInteractive");b.emit("viewport.stopPanning");l=setTimeout(function(){b.emit("layout.enableTextSelection")},
500)},mouseup:g.bind(function(a){a.preventDefault();k(this.getScenePoint(a),!0);this.changeState("default")},this),mousemove:g.bind(function(a){i=this.getScenePoint(a);k(i,!1)},this),mouseout:g.bind(function(a){a.preventDefault();k(i,!0);this.changeState("default")},this),mouseleave:g.bind(function(a){a.preventDefault();k(i,!0);this.changeState("default")},this)},this.getState("default")));this.passiveKeyEvents=[];this.activeKeyEvents=[];this._override("initialize",function(c,f){this._super(c,f);
this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu dblclick".split(" "));var e=!1;this.passiveKeyEvents.push(["space",g.bind(function(){e||(e=!0,b.emit("toolManager.request.activation",this))},this),"keydown"]);this.passiveKeyEvents.push(["space",function(){e=!1},"keyup"]);this.activeKeyEvents.push(["space",g.bind(function(){e&&(e=!1,b.emit("toolManager.request.deactivation",this))},this),"keyup"]);this.passiveKeyEvents.push(["h",g.bind(function(a){a.preventDefault();
b.emit("toolManager.activateTool",this)},this),"keypress"]);this.passiveKeyEvents.push(["mod+up",g.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new d.Point(a.x,a.y+b.height/4);k(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["mod+down",g.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new d.Point(a.x,a.y-b.height/4);k(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["mod+right",
g.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new d.Point(a.x-b.width/4,a.y);k(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["mod+left",g.bind(function(b){b.preventDefault();b.stopPropagation();this._setPanStart();b=this._widget.getWorld().getSceneSize();b=new d.Point(a.x+b.width/4,a.y);k(b,!0)},this),"keypress"]);this.passiveKeyEvents.push(["f7",g.bind(function(a){a.preventDefault();a.stopPropagation();o=!0;b.emit("toolManager.activateTool",
this,!0)},this)])});this._setPanStart=function(){var b=this._widget.getWorld().getSceneSize();new d.Point;a=new d.Point(b.width/2,b.height/2);c=this._widget.getWorld().getOffsetSize()};this.getDefaultCursor=function(){return"cursor-move"};this.canBeInterrupted=function(){return"panning"!=this.getCurrentStateName()};this._override("doActivation",function(){this._super();this.changeState("default")});this._override("deactivate",function(a){this._super(a);this.changeState("default")});this.zoom=function(a,
b,c){this._widget.getWorld().transform({zoom:a,middle:b,animated:c})}};c.prototype=Object.create(e.prototype);return c.prototype.constructor=c});
define("web-viewer/utils/TouchUtil",["underscore","lib/hammer","web-viewer/utils/ShapeUtils"],function(g,e,d){var c=function(c){this.ctx=c;var c=new e.Manager(c),b=new e.Pinch,a=new e.Tap({event:"singletap"}),d=new e.Tap({event:"doubletap",taps:2}),o=new e.Pan;c.add([b,a,d,o]);b.recognizeWith(o);b.requireFailure(o);d.recognizeWith(a);this.listeners={};c.on("singletap doubletap pinchstart pinchmove pinchend panstart panmove panend pancancel",g.bind(this.handleTouchEvent,this))};c.prototype.handleTouchEvent=
function(c){var b=c.type;this.listeners[b]&&0<this.listeners[b].length&&g.each(this.listeners[b],function(a){a(c)})};c.prototype.addSingleTapListener=function(c){this._addListener("singletap",c)};c.prototype.addDoubleTapListener=function(c){this._addListener("doubletap",c)};c.prototype.addPinchStartListener=function(c){this._addListener("pinchstart",c)};c.prototype.addPinchMoveListener=function(c){this._addListener("pinchmove",c)};c.prototype.addPinchEndListener=function(c){this._addListener("pinchend",
c);this._addListener("pinchcancel",c)};c.prototype.addPanStartListener=function(c){this._addListener("panstart",c)};c.prototype.addPanMoveListener=function(c){this._addListener("panmove",c)};c.prototype.addPanEndListener=function(c){this._addListener("panend",c);this._addListener("pancancel",c)};c.prototype.removeDoubleTapListener=function(c){this._removeListener("doubletap",c)};c.prototype.removePinchStartListener=function(c){this._removeListener("pinchstart",c)};c.prototype.removePinchMoveListener=
function(c){this._removeListener("pinchmove",c)};c.prototype.removePinchEndListener=function(c){this._removeListener("pinchcancel",c);this._removeListener("pinchend",c)};c.prototype.removePanStartListener=function(c){this._removeListener("panstart",c)};c.prototype.removePanMoveListener=function(c){this._removeListener("panmove",c)};c.prototype.removePanEndListener=function(c){this._removeListener("panend",c);this._removeListener("pancancel",c)};c.prototype.removeAllListeners=function(){this.listeners=
{}};c.prototype._addListener=function(c,b){this.listeners[c]||(this.listeners[c]=[]);0>g.indexOf(this.listeners[c],b)&&this.listeners[c].push(b)};c.prototype._removeListener=function(c,b){this.listeners[c]&&(this.listeners[c]=g.without(this.listeners[c],b))};c.prototype.preventDefault=function(c){c.preventDefault()};c.prototype.getScale=function(c){return c.scale};c.prototype.getRotation=function(c){return c.rotation};c.prototype.getCenter=function(c,b){var a=new d.Point;a.x=c.center.x;a.y=c.center.y;
b&&(a.x-=b.left,a.y-=b.top);return a};c.prototype.getScenePointFromTouch=function(c,b,a){c=this.getCenter(c);a||(a=b.requestView(c));a&&(b=a.getViewContext().offset(),c.offsetXY(-b.left,-b.top));return{view:a,point:c}};return c});
define("web-viewer/navigation/TouchTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/ViewerUtils","web-viewer/utils/TouchUtil","web-viewer/core/CoreConstants"],function(g,e,d,c,f){var b=function(a){e.call(this,a,f.TOOLS.TOUCH);this._touchUtil=null;this._allowRotation=!0;this._unlockRotation=!1;this._unlockRotationAngle=25;this._initTouchCenter=this._initRotate=this._initZoom=void 0};b.prototype=Object.create(e.prototype);b.prototype.constructor=b;b.prototype.startAction=
function(a){this._touchUtil.preventDefault(a);this.f.emit("viewport.startInteractive");this._unlockRotation=!1;var b=this._widget.getWorld();this._initZoom=b.getZoom();this._initRotate=b.getRotation();a=this._touchUtil.getScenePointFromTouch(a,this._widget);this._initTouchCenter=this.sceneToWorld(a.point);this._currentView=a.view};b.prototype.stopAction=function(a){this._touchUtil.preventDefault(a);delete this._currentView;this.f.emit("viewport.stopInteractive");this.releaseCanvasLayer();this._unlockRotation=
!1;this._widget.getWorld().transform({rubber:!1,animated:{duration:100,type:"ease-out"},constrainRotation:!0})};b.prototype.doubleTap=function(a){this._touchUtil.preventDefault(a);var a=this.getScenePointFromTouch(a),a=this._widget.getWorld().getWorldPointFromScene(a),b=this._widget.getWorld();b.isFullView()?b.transform({zoom:3,middle:a,animated:!0}):b.zoomToFit(!0)};b.prototype.pinchMove=function(a){this._touchUtil.preventDefault(a);var b=this._touchUtil.getScale(a),c=this._touchUtil.getRotation(a),
a=this.getScenePointFromTouch(a);this.updateWorld(a,b,c)};b.prototype.panAction=function(a){this._touchUtil.preventDefault(a);a=this.getScenePointFromTouch(a);this.updateWorld(a)};b.prototype.updateWorld=function(a,b,c){var f=this._widget.getWorld(),e={};b&&(e.fixedzoom=this._initZoom*b);c&&this._allowRotation&&(c=parseInt(c,10)%360,this._unlockRotation||(b=c-d.closestAngle(c,4),Math.abs(b)>this._unlockRotationAngle&&(this._unlockRotation=!0)),this._unlockRotation&&(e.fixedrotation=c+this._initRotate));
e.middle=this._initTouchCenter;f.transform(e,!0);e=f.getSceneBounds().center().sizeTo(a);a=f.getWorldSizeFromScene(e);e={};e.offsetX=a.width;e.offsetY=a.height;f.transform(e)};b.prototype.initialize=function(a,b){e.prototype.initialize.apply(this,arguments);this._touchUtil=new c(a.getElement()[0])};b.prototype.doDeactivation=function(){e.prototype.doDeactivation.call(this);this._touchUtil.removeAllListeners()};b.prototype.doActivation=function(){e.prototype.doActivation.call(this);this._touchUtil.addPinchStartListener(g.bind(function(a){this.f.emit("viewport.startZooming");
this.startAction(a)},this));this._touchUtil.addPinchMoveListener(g.bind(this.pinchMove,this));this._touchUtil.addPinchEndListener(g.bind(function(a){this.f.emit("viewport.stopZooming");this.stopAction(a)},this));this._touchUtil.addDoubleTapListener(g.bind(this.doubleTap,this));this._touchUtil.addPanStartListener(g.bind(function(a){this.f.emit("viewport.startPanning");this.startAction(a)},this));this._touchUtil.addPanMoveListener(g.bind(this.panAction,this));this._touchUtil.addPanEndListener(g.bind(function(a){this.f.emit("viewport.stopPanning");
this.stopAction(a)},this))};b.prototype.getScenePointFromTouch=function(a){return this._touchUtil.getScenePointFromTouch(a,this._widget,this._currentView).point};return b});
define("web-viewer/navigation/TouchPreventerTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/TouchUtil","web-viewer/core/CoreConstants"],function(g,e,d,c){var f=function(b){e.call(this,b,c.TOOLS.NOTOUCH);this._touchUtil=null};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.doPassivation=function(){e.prototype.doPassivation.call(this);this._touchUtil.removeAllListeners()};f.prototype.initialize=function(b,a){e.prototype.initialize.apply(this,
arguments);this._touchUtil=new d(b.getElement()[0])};f.prototype.doActivation=function(){e.prototype.doActivation.call(this);var b=g.bind(function(a){this._touchUtil.preventDefault(a)},this);this._touchUtil.addPinchStartListener(g.bind(b,this));this._touchUtil.addPinchMoveListener(g.bind(b,this));this._touchUtil.addPinchEndListener(g.bind(b,this));this._touchUtil.addDoubleTapListener(g.bind(b,this));this._touchUtil.addPanStartListener(g.bind(b,this));this._touchUtil.addPanMoveListener(g.bind(b,this));
this._touchUtil.addPanEndListener(g.bind(b,this))};return f});
define("web-viewer/utils/Mousewheel",["underscore"],function(g){return new function(){var e=[];this.enabled=!0;var d=g.bind(function(c){if(this.enabled){var d=Math.max(-1,Math.min(1,c.wheelDelta||-c.detail));d&&g.each(e,function(b){b(c,d)})}},this);window.addEventListener&&/Firefox/i.test(navigator.userAgent)?window.addEventListener("DOMMouseScroll",d,!1):document.onmousewheel=d;this.addListener=function(c){0>g.indexOf(e,c)&&e.push(c)};this.removeListener=function(c){e=g.without(e,c)}}});
define("web-viewer/navigation/ZoomTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/Mousewheel web-viewer/utils/DrawUtils web-viewer/core/CoreConstants".split(" "),function(g,e,d,c,f,b,a){c=function(c){e.call(this,c,a.TOOLS.ZOOM);var f=1,k,l=0,i=new d.Point,j=!1,n=g.bind(function(){j&&(c.emit("toolManager.deactivateTool",this),j=!1)},this);this.registerState("default",g.bind(function(){var a=g.bind(function(a){f=a.altKey?
-1:1;this.setCursor(-1==f?"cursor-zoomOut":"cursor-zoomIn")},this);return{mousedown:g.bind(function(b){k=new d.Rect(this.getScenePoint(b));a(b);1===b.which&&this.changeState("couldStartDragging");b.preventDefault()},this),mouseup:g.bind(function(b){a(b);0<l?l--:(this.zoom((1===b.which?1:-1)*f,this.getWorldPoint(b),!0),this.changeState("default"),n(),b.preventDefault())},this),mousemove:function(b){a(b)},contextmenu:function(a){a.preventDefault();a.stopPropagation()},mouseleave:g.bind(function(){this.changeState("default")},
this),esc:g.bind(function(){this.changeState("default")},this),spacedown:function(){},spaceup:function(){},canBeInterrupted:!0}},this)());this.registerState("couldStartDragging",g.defaults({mousemove:g.bind(function(a){var b=this.getScenePoint(a);k.update(b);if(16<Math.abs(k.size.width)||16<Math.abs(k.size.height))this.requestCanvasLayer(a),this.changeState("dragging")},this),mouseleave:g.bind(function(){this.changeState("default")},this),esc:g.bind(function(){l++;this.changeState("default")},this),
canBeInterrupted:!1},this.getState("default")));var m=g.bind(function(){this.releaseCanvasLayer()},this),p=g.throttle(g.bind(function(){var a=this.getCanvasCtx();if(a){var c=this.getCanvasSize();a.clearRect(0,0,c.width,c.height);a.beginPath();a.strokeStyle="rgba(0, 0, 0, 1.0)";a.lineWidth=1;a.fillStyle="rgba(0, 0, 0, 0.40)";a.rect(0,0,c.width,c.height);a.fill();a.stroke();a.clearRect(k.origin.x,k.origin.y,k.size.width,k.size.height);a.beginPath();a.strokeStyle="rgba(210,210,210,0.9)";a.lineWidth=
1;b.drawDashedRect(a,k,[4,3]);a.stroke()}},this),40);this.registerState("dragging",g.defaults({enterState:function(){c.emit("layout.disableTextSelection");c.emit("viewport.startInteractive")},leaveState:function(a){if("panningSelection"!=a||"dragging"!=a)setTimeout(function(){c.emit("layout.enableTextSelection")},500),c.emit("viewport.stopInteractive")},mousedown:function(){l++},mousemove:g.bind(function(a){i=a=this.getScenePoint(a);k.update(a);p()},this),mouseleave:g.bind(function(){this.changeState("default");
m()},this),mouseup:g.bind(function(a){0<l?l--:(i=a=this.getScenePoint(a),k.update(a),this.zoomToSelection(k),this.changeState("default"),n(),m())},this),esc:g.bind(function(){l++;this.changeState("default");m()},this),spacedown:g.bind(function(){this.changeState("panningSelection")},this),canBeInterrupted:!1},this.getState("default")));this.registerState("panningSelection",g.defaults({mousemove:g.bind(function(a){var a=this.getScenePoint(a),b=i.sizeTo(a);i=a;k.origin.x+=b.width;k.origin.y+=b.height;
p()},this),spacedown:function(){},spaceup:g.bind(function(){this.changeState("dragging")},this)},this.getState("dragging")));this.passiveKeyEvents=[];this.activeKeyEvents=[];this.persistentKeyEvents=[];this._override("initialize",function(a,b){this._super(a,b);this.registerActiveEvents(["mousedown","mousemove","mouseup","mouseleave","contextmenu"]);this.persistentKeyEvents.push([["ctrl+plus","f5","ctrl+="],g.bind(function(a){a.preventDefault();a.returnValue=!1;this.zoom(1,void 0,!0)},this)]);this.persistentKeyEvents.push([["ctrl+-",
"f6"],g.bind(function(a){a.preventDefault();a.returnValue=!1;this.zoom(-1,void 0,!0)},this)]);this.persistentKeyEvents.push([["ctrl+0","f9"],function(a){a.shiftKey||(a.preventDefault(),c.emit("viewport.zoomToFit",{animated:!0}))}]);this.passiveKeyEvents.push(["z",g.bind(function(a){a.preventDefault();c.emit("toolManager.activateTool",this)},this),"keypress"]);this.passiveKeyEvents.push(["f8",g.bind(function(a){a.preventDefault();j=!0;c.emit("toolManager.activateTool",this,!0)},this)]);this.activeKeyEvents.push(["esc",
g.bind(function(a){a.preventDefault();this.getCurrentState().esc(a)},this),"keyup"]);this.activeKeyEvents.push(["space",g.bind(function(a){this.getCurrentState().spacedown(a)},this),"keydown"]);this.activeKeyEvents.push(["space",g.bind(function(a){this.getCurrentState().spaceup(a)},this),"keyup"])});this.zoom=function(a,b,c){this._widget.getWorld().transform({zoom:a,middle:b,animated:c})};this.zoomToSelection=function(a){this._widget.getWorld().zoomToSceneRect(a,!0)};this.canBeInterrupted=function(){return this.getCurrentState().canBeInterrupted};
this.getDefaultCursor=function(){return-1==f?"cursor-zoomOut":"cursor-zoomIn"};this._override("doActivation",function(){this._super();this.changeState("default")});this._override("deactivate",function(a){this._super(a);this.changeState("default");m()})};c.prototype=Object.create(e.prototype);c.prototype.constructor=c;c.prototype.getIconOffset=function(){return new d.Size(6,6)};c.prototype.doPassivation=function(){e.prototype.doPassivation.call(this);f.addListener(g.throttle(g.bind(this.handleScrollWheel,
this),150))};c.prototype.handleScrollWheel=function(a,b){0<this._widget.context.has(a.target).length&&(this.zoom(0>b?-1:1,this.getWorldPoint(a),!0),a.preventDefault())};return c});
define("web-viewer/layout/component/LogSlider",["web-viewer/layout/component/Tooltip","web-viewer/utils/ViewerUtils","jquery","jqueryUI","underscore"],function(g,e,d){e=function(c,f){this.f=c;this._minp=void 0===f.minp?0:f.minp;this._maxp=void 0===f.maxp?100:f.maxp;this.setOptions(f);this._onSliderChanged=f.onSliderChanged;this.element=d("<div />").addClass("sliderWrapper");this._slider=d("<div />").addClass("slider");this.element.append(this._slider);this._slider.slider({slide:_.bind(function(b,
a){this._fireSliderChanged(a.value)},this),min:this._minp,max:this._maxp});void 0!==f.tooltip&&(this._tooltip=new g(c,this.element,f.tooltip))};e.prototype._toValue=function(c){return Math.exp((c-this._minp)*this._scale+this._minv)};e.prototype._toPosition=function(c){return this._minp+(Math.log(c)-this._minv)/this._scale};e.prototype._fireSliderChanged=function(c){c=this._toValue(c);this._onSliderChanged(c)};e.prototype.setValue=function(c){c=this._toPosition(c);this._slider.slider("value",c)};e.prototype.setOptions=
function(c){this._minv=Math.log(void 0===c.minv?1:c.minv);this._maxv=Math.log(void 0===c.maxv?1E5:c.maxv);this._scale=(this._maxv-this._minv)/(this._maxp-this._minp)};return e});
define("web-viewer/navigation/ZoomBar",["web-viewer/layout/component/LogSlider","web-viewer/utils/ListenerUtil","web-viewer/layout/component/MiniButton","jquery","underscore"],function(g,e,d,c,f){var b=function(a){this.f=a;e.mixin(this,this.f);this.element=c("<div />").addClass("zoomBar clearfix");this._minButton=new d(this.f,"minZoom","icon-WCR_Minus",!0,f.bind(this._minZoom,this));this.element.append(this._minButton.element.addClass("minZoom"));this._zoomPercentage=c("<span />").addClass("zoomPercentage");
this.element.append(this._zoomPercentage);this._plusButton=new d(this.f,"plusZoom","icon-WCR_Plus",!0,f.bind(this._plusZoom,this));this.element.append(this._plusButton.element.addClass("plusZoom"));if(a=this.f.getModule("viewport"))this._slider=new g(this.f,{onSliderChanged:f.bind(this._sliderChanged,this),minp:1,maxp:a.getNumberOfZoomLevels()}),this._updateMinMax(),this.element.append(this._slider.element);this._registerListener("transform.viewportWidget.minMaxZoomChanged",this._updateMinMax,this);
this._registerListener("transform.viewportWidget.transformChanged",this._updateZoom,this)};b.prototype._sliderChanged=function(a){var b=this.f.getModule("viewport");b&&b.transform({fixedzoom:a,animated:!0})};b.prototype._updateZoom=function(){var a=this.f.getModule("viewport");if(a){var b=a.getZoomPercentage();this._zoomPercentage.text(b.toFixed(2)+"%");a=a.getZoom();this._slider.setValue(a)}};b.prototype._updateMinMax=function(){var a=this.f.getModule("viewport");if(a){var b=a.getMinZoom(),a=a.getMaxZoom();
this._slider.setOptions({minv:b,maxv:a})}};b.prototype._minZoom=function(){var a=this.f.getModule("viewport");a&&a.transform({zoom:-1,animated:!0})};b.prototype._plusZoom=function(){var a=this.f.getModule("viewport");a&&a.transform({zoom:1,animated:!0})};return b});
define("web-viewer/navigation/NavigatorPanTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/ShapeUtils","web-viewer/core/CoreConstants"],function(g,e,d,c){var f=function(b,a){e.call(this,b,c.TOOLS.NAVIGATIONPAN);this._startPoint=new d.Point;this._startOffset=new d.Size;this._currentCenter=new d.Size;this._viewport=a;this._lastMousePosition=null;this.registerState("default",{mousedown:g.bind(function(a){var b=this._viewport.getVisibleRect();if(!this._viewport.getWorldBounds().rectEquals(b)){var c=
this._widget.getNavigatorImageOffset(),a=new d.Point(a.pageX-c.left,a.pageY-c.top),c=this.convertScenePointToWorldPoint(a);this._startOffset=this._viewport.getWorld().getOffsetSize();this._startPoint=a;b.containsPoint(c)?this.changeState("panning"):this._viewport.getWorldBounds().containsPoint(c)&&(this._currentCenter=b.center(),this._updateViewport(a,!0),this._startPoint=this._widget.getNavigatorTransformation().transformedPoint(this._currentCenter),this.changeState("panning"))}},this),mouseup:function(){},
mousemove:function(){},mouseout:function(){},mouseleave:function(){},contextmenu:g.bind(function(a){a.preventDefault();a.stopPropagation()},this)});this.registerState("panning",g.defaults({enterState:g.bind(function(){this.setCursor("cursor-moveObject");this.f.emit("viewport.startInteractive");this.f.emit("viewport.startPanning");this.f.emit("layout.disableTextSelection")},this),leaveState:g.bind(function(){this.setCursor("cursor-default");this.f.emit("viewport.stopInteractive");this.f.emit("viewport.stopPanning");
this.f.emit("layout.enableTextSelection");this._lastMousePosition&&this._updateViewport(this._lastMousePosition,!1,!0)},this),mouseup:g.bind(function(a){a.preventDefault();this._lastMousePosition=null;this.changeState("default")},this),mousemove:g.bind(function(a){var b=this._widget.getNavigatorImageOffset();this._lastMousePosition=a=new d.Point(a.pageX-b.left,a.pageY-b.top);this._updateViewport(a,!1)},this),mouseout:g.bind(function(a){a.preventDefault();this.changeState("default")},this),mouseleave:g.bind(function(a){a.preventDefault();
this.changeState("default")},this)},this.getState("default")))};f.prototype=Object.create(e.prototype);f.prototype.constructor=f;f.prototype.initialize=function(b,a){e.prototype.initialize.call(this,b,a);this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "))};f.prototype.getDefaultCursor=function(){return"panning"!=this.getCurrentStateName()?"cursor-default":"cursor-moveObject"};f.prototype.canBeInterrupted=function(){return"panning"!=this.getCurrentStateName()};
f.prototype.doActivation=function(){e.prototype.doActivation.call(this);this.changeState("default")};f.prototype.deactivate=function(b){e.prototype.deactivate.call(this,b);this.changeState("default")};f.prototype._updateViewport=function(b,a,c){var f=this._startPoint.sizeTo(b);if(0<Math.abs(f.width)||0<Math.abs(f.height)||a||c)c=new d.Size,c=a?this._currentCenter.sizeTo(this.convertScenePointToWorldPoint(b)):this.convertScenePointToWorldPoint(this._startPoint).sizeTo(this.convertScenePointToWorldPoint(b)),
c=new d.Size(-c.width,-c.height),c.add(this._startOffset),this._viewport.getWorld().setOffsetSize(c)};f.prototype.convertScenePointToWorldPoint=function(b){return this._widget.getNavigatorTransformation().createInverse().transformedPoint(b)};return f});
define("web-viewer/navigation/NavigatorWidget","web-viewer/layout/AbstractWidget web-viewer/layout/LayoutConstants web-viewer/layout/component/MiniButton web-viewer/navigation/ZoomBar jquery underscore utils/HTTPUtils web-viewer/utils/Fragment web-viewer/utils/Transformation web-viewer/utils/DrawUtils web-viewer/utils/ShapeUtils web-viewer/utils/ListenerUtil web-viewer/navigation/NavigatorPanTool web-viewer/compare/CompareConstants".split(" "),function(g,e,d,c,f,b,a,h,o,k,l,i,j,n){d=function(a){g.call(this,
a,e.Widget.NAVIGATOR);i.mixin(this,a);this.navigatorImage=f("<div>").addClass("navigatorImage");this._graphicsLayer=f("<canvas>").css({position:"absolute",top:0,left:0});this._cadLayer=f("<canvas>").css({position:"absolute",top:0,left:0});this._interactiveLayer=f("<canvas>").css({position:"absolute",top:0,left:0});this._worldTranformation=this._viewport=this._fragment=null;this.f.loadBundle("viewer",function(){this.setTitle(this.f.t("NavigatorTitle"))},this);var c=b.debounce(this._renderNavigatorImage,
200),a=b.throttle(b.bind(function(){if(this._viewport){var a=this._viewport.getWorld().getRotation()%360,b=this._viewport.getWorldBounds();if(90==a||270==a)b.size=new l.Size(b.size.height,b.size.width);0!==b.size.width&&0!==b.size.height&&this._renderVisibleRect(this._interactiveLayer[0].getContext("2d"),b,a)}},this),10);this.resized=function(){c.call(this)};this._zoomBar=null;this._registerListener("transform.viewportWidget.worldBoundsChanged",c,this);this._registerListener("module.compare.changed.diffMode",
c,this);this._registerListener("module.viewport.finishedLoadingImageData",c,this);this._registerListener("cadModel.*.modelChanged",c,this);this._registerListener("transform.viewportWidget.rotated",c,this);this._registerListener("transform.viewportWidget.flipped",c,this);this._registerListener("transform.viewportWidget.flippedViewFromBack",c,this);this._registerListener("transform.viewportWidget.transformChanged",a,this);this._registerListener("modalResize",c,this,this);this._registerListener("collapsed",
c,this,this);this._registerListener("visible",c,this,this)};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.widgetName=e.Widget.NAVIGATOR;d.prototype.setContext=function(a){g.prototype.setContext.call(this,a);a.append(this.navigatorImage);this.navigatorImage.append(this._graphicsLayer);this.navigatorImage.append(this._cadLayer);this.navigatorImage.append(this._interactiveLayer);this.f.whenModuleAvailable("viewport",function(a){this._viewport=a;this._panTool=new j(this.f,this._viewport);
this._panTool.initialize(this);this._panTool.activate();this._zoomBar=new c(this.f);this.context.addClass("navigatorWidget").append(this._zoomBar.element);this._renderNavigatorImage()},this)};d.prototype._renderNavigatorImage=function(){if(!this.isCollapsed()&&this.isVisible()&&this._viewport&&this.context){var a=this.f.getActivePage(),b=this.f.getDocumentController().getCadOverlay(),c=new l.Size(this.context.innerWidth(),this.context.innerHeight()-this._zoomBar.element.outerHeight()),d=this._viewport.world.getRotation()%
360,f=this._viewport.getWorldBounds();if(0!==f.size.width&&0!==f.size.height){if(90==d||270==d)f.size=new l.Size(f.size.height,f.size.width);this._pageRes=c.width/f.size.width;var e=c.width,g=f.size.height*this._pageRes,h=200;this._isModal&&(h=c.height);g>h&&(g=h,this._pageRes=g/f.size.height,e=f.size.width*this._pageRes);this.navigatorImage.height(g);this.navigatorImage.width(e);this._fireResized();c=new l.Size(e,g);h=new l.Size(e,g);if(90==d||270==d)h=new l.Size(g,e);a.hasGraphics()||a.isBlankPage()?
(this._graphicsLayer.show(),this._graphicsLayer[0].width=e,this._graphicsLayer[0].height=g,this._renderGraphicsImage(this._graphicsLayer[0].getContext("2d"),this._pageRes,c,h,f)):this._graphicsLayer.hide();a.hasCad()||b?(this._cadLayer.show(),this._cadLayer[0].width=e,this._cadLayer[0].height=g,this.f.getModule("cad")&&(a.hasCad()?this._renderCAD(this._cadLayer[0].getContext("2d"),a,this._pageRes,f,null,h):this._renderCAD(this._cadLayer[0].getContext("2d"),b,this._pageRes,f,!0,h))):this._cadLayer.hide();
this._interactiveLayer[0].width=e;this._interactiveLayer[0].height=g;this._renderVisibleRect(this._interactiveLayer[0].getContext("2d"),f,d)}}};d.prototype._renderGraphicsImage=function(c,d,f,e,g){if(!(0>=d||this.f.isParameterUpdateOngoing())){var i={resolution:d,rectangle:this._viewport.getWorldBounds(),servlet:"",params:{x1:0,x2:0,y1:0,y2:0}};this._fragment=new h(g,d);this.f.emit("intercept.fragmentURL",i);if(void 0===i.params.file&&void 0===i.params.diff)c.setTransform(1,0,0,1,0,0),c.clearRect(0,
0,this._graphicsLayer.width(),this._graphicsLayer.height()),this._transformCanvas(c,f,null,null),c.fillStyle="rgba(255, 255, 255, 1)",k.drawRect(c,0,0,e.width,e.height,0,!0,!1);else{if(void 0===i.params.file&&void 0!==i.params.diff)i.params.file=i.params.diff,delete i.params.diff,i.params.rs=1==i.params.rs?2:1;else if(i.params.dmode==n.diffMode.SHOWBOTHSIDEBYSIDE||i.params.dmode==n.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT||i.params.dmode==n.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY)i.params.dmode=n.diffMode.CURRENTVERSION;
delete i.params.colorBITWISE;delete i.params.isDefaultView;d=a.constructURL(i.servlet,i.params);d=d.replace(/%2C/g,",");this._fragment.fetchImage(this._viewport.getImageCache(),d,b.bind(function(){this._fragment.isFetched()&&(c.setTransform(1,0,0,1,0,0),c.clearRect(0,0,this._graphicsLayer.width(),this._graphicsLayer.height()),this._transformCanvas(c,f,null,null),c.drawImage(this._fragment.image,0,0,e.width,e.height))},this),function(){})}}};d.prototype._renderCAD=function(a,c,d,f,e,g){c.requestCad(b.bind(function(){var b=
this.f.getModule("cad"),c;c=e?b.getCadOverlayModel():b.getCurrentPageCadModel();var h=b.getReferencePageCadModel(),i=this._viewport.getWorldBounds();if(null!==c&&c.getCad()){var j=c.getCad().getOrigin();i.origin.x+=j.x;i.origin.y-=j.y;var p=c.getVisibleCadLines(),o=new l.Size,o=e?new l.Size(-f.origin.x,-f.origin.y):new l.Size(-j.x-f.origin.x,j.y-f.origin.y);a.setTransform(1,0,0,1,0,0);a.clearRect(0,0,this._cadLayer.width(),this._cadLayer.height());var o=this._transformCanvas(a,f.size,o,d),F=null;
e?(F=b.getOverlayTransform())&&a.transform(F.a,F.b,F.c,F.d,F.e,F.f):(a.save(),a.fillStyle=c.getBackgroundString(),k.drawRect(a,i.origin.x,i.origin.y,i.size.width,i.size.height,0,!0,!0),a.restore());var D=o.copy();if(b.compareDiffMode!==n.diffMode.DIFFVERSION||e)F&&D.concatenate(F),F=this.f.getModule("viewport").getWorld().getWorldRectFromScene(new l.Rect(null,new l.Size(this._cadLayer.width(),this._cadLayer.height())),D),k.drawOverlay(this.f,a,p,F,function(){},g.width/i.size.width,o,c.getCadColor(),
c.getAlpha());null!==h&&(null!==h.getCad()&&b.getReferenceTransform())&&(c=h.getVisibleCadLines(),o=b.getReferenceTransform(),o.preTranslate(j.x,-j.y),a.transform(o.a,o.b,o.c,o.d,o.e,o.f),D.concatenate(o),b=this.f.getModule("viewport").getWorld().getWorldRectFromScene(new l.Rect(null,new l.Size(this._cadLayer.width(),this._cadLayer.height())),D),k.drawOverlay(this.f,a,c,b,function(){},g.width/i.size.width,o,h.getCadColor(),h.getAlpha()))}},this))};d.prototype._renderVisibleRect=function(a,b,c){var d=
this._viewport.getVisibleRect();a.setTransform(1,0,0,1,0,0);a.clearRect(0,0,this._interactiveLayer.width(),this._interactiveLayer.height());this._worldTranformation=this._transformCanvas(a,b.size,new l.Size(-b.origin.x,-b.origin.y),this._pageRes);a.beginPath();a.strokeStyle="rgba(0, 0, 0, 1.0)";a.lineWidth=1/this._pageRes;a.fillStyle="rgba(0, 0, 0, 0.50)";90==c||270==c?a.rect(b.origin.x,b.origin.y,b.size.height,b.size.width):a.rect(b.origin.x,b.origin.y,b.size.width,b.size.height);a.fill();a.stroke();
a.clearRect(d.origin.x,d.origin.y,d.size.width,d.size.height);a.beginPath();a.strokeStyle="rgba(255,255,255,1)";a.lineWidth=1/this._pageRes;a.strokeStyle="rgba(0,0,0,1)";this._pageRes&&k.drawDashedRect(a,d,[2,5],this._pageRes);a.stroke()};d.prototype._transformCanvas=function(a,b,c,d){var f=this._viewport.world.isFlip(),e=this._viewport.world.isFlipViewFromBack(),g=this._viewport.world.getRotation()%360,h=new o;null!==d&&h.scale(d,d);h.translate(b.width/2,b.height/2);h.rotate(g*(Math.PI/180));f&&
h.scale(-1,1);e&&(0===g%180?h.scale(-1,1):h.scale(1,-1));90==g||270==g?h.translate(-b.width/2+(b.width-b.height)/2,-b.height/2-(b.width-b.height)/2):h.translate(-b.width/2,-b.height/2);null!==c&&h.translate(c.width,c.height);a.transform(h.a,h.b,h.c,h.d,h.e,h.f);return h};d.prototype.getNavigatorTransformation=function(){return this._worldTranformation};d.prototype.getMinimumSize=function(){return new l.Size(100,this.navigatorImage.height()+this._zoomBar.element.height())};d.prototype.getNavigatorImageOffset=
function(){return this.navigatorImage.offset()};return d});define("web-viewer/navigation/NavigationConstants",{ZoomOneToOneClick:{AUTO:0,REALSIZE:1}});
define("tpl!web-viewer/navigation/AdjustMonitorResolutionPopup",function(){return function(g){var e;return g=""+('<span class="label">'+(null==(e=g.i18n("ZoomOneToOneAdjustResLabel"))?"":_.escape(e))+' </span><input value="'+(null==(e=g.monitorResolution)?"":_.escape(e))+'" type="text" size="7" name="monitorResolution" class="monitorResolution"></input><span class="unit"> '+(null==(e=g.i18n(g.resolutionUnitsLangKey))?"":_.escape(e))+"</span>\r\n\r\n<p>"+(null==(e=g.i18n("ZoomOneToOneAdjustResHint"))?
"":_.escape(e))+"<br />"+(null==(e=g.i18n("ZoomOneToOneAdjustResExample"))?"":_.escape(e))+"</p>\r\n<p>"+(null==(e=g.i18n("ZoomOneToOneAdjustResMoreInfo"))?"":_.escape(e))+' <a href="'+(null==(e=g.moreInfoLink)?"":_.escape(e))+'" target="_blank">'+(null==(e=g.i18n("ZoomOneToOneAdjustResMoreInfoLink"))?"":_.escape(e))+"</a></p>")}});
define("web-viewer/navigation/AdjustMonitorResolutionPopup","web-viewer/layout/component/ModalPopup Template web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants tpl!web-viewer/navigation/AdjustMonitorResolutionPopup jquery underscore".split(" "),function(g,e,d,c,f,b,a){c=function(c,o,k){g.call(this,c,o,c.getContext());this._navigationModule=k;this.f.i18n.loadBundle("viewer",a.bind(function(){this.setHeader(b("<span/>").addClass("popupTitle").html(this.f.i18n.t("ZoomOneToOneAdjustResTitle")));
this.setOkBtnText(this.f.i18n.t("OkButton"));this.setOkAction(a.bind(function(){this._navigationModule.okMonitorResolution()},this));this.setCancelAction(a.bind(function(){this._navigationModule.cancelMonitorResolution()},this))},this));this.element.addClass("adjustMonitorResolutionPopup");this.t=new e(this.f.i18n,f);this.t.setContext(this._popupContent.addClass("adjustMonitorResolutionPopupContent"));this.t.d.moreInfoLink="https://wiki.esko.com/display/KBA/KB134185394:+WebCenter+-+How+to+determine+the+Monitor+Resolution+for+Zoom+to+Actual+Size+in+the+HTML5+Viewer";
this.t.bind("focusout","[name=monitorResolution]",a.bind(function(a){var b=a.value,c=a.value.split("/");2==c.length&&(b=d.parseFloat(c[0])/d.parseFloat(c[1]));b=d.parseFloat(b);isNaN(b)&&(b=d.parseFloat(d.convertResolutionFromPpmmValue(this._navigationModule.getMonitorResolution(),this.f.getResolutionUnits())));b=d.parseFloat(d.convertResolutionToPpmmValue(b,this.f.getResolutionUnits()));a.value=d.convertResolutionFromPpmmValue(b,this.f.getResolutionUnits(),this.f.getResolutionUnitsFix());this._navigationModule.setMonitorResolution(b)},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_RESOLUTION",a.bind(function(){this.isVisible()&&this.render()},this))};c.prototype=Object.create(g.prototype);c.prototype.constructor=c;c.prototype.render=a.throttle(function(){this.t.d.monitorResolution=d.convertResolutionFromPpmmValue(this._navigationModule.getMonitorResolution(),this.f.getResolutionUnits(),this.f.getResolutionUnitsFix());this.t.d.resolutionUnitsLangKey=this.f.getResolutionUnitsLocName();this.t.render();this._isInitialized&&
this.recalculateSize(500)},40);c.prototype.show=function(){this.render();g.prototype.show.call(this);this.recalculateSize(500)};return c});
define("web-viewer/navigation/NavigationModule","underscore web-viewer/core/AbstractModule web-viewer/navigation/PanTool web-viewer/navigation/TouchTool web-viewer/navigation/TouchPreventerTool web-viewer/navigation/ZoomTool web-viewer/navigation/NavigatorWidget web-viewer/navigation/NavigationConstants web-viewer/navigation/AdjustMonitorResolutionPopup web-viewer/layout/component/ToolbarComponent web-viewer/layout/component/ButtonGroup web-viewer/layout/component/ToolbarButton web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/LayoutConstants web-viewer/utils/ViewerUtils Mousetrap".split(" "),function(g,
e,d,c,f,b,a,h,o,k,l,i,j,n,m,p){var s=function(b,c){e.call(this,b,c,"navigation");this.requiresViewportAccess=!0;this._extraRotation=0;this._initializeTools(b);this._publishWidget(a.widgetName,g.bind(function(){return this._navigatorWidget=new a(b)},this))};s.prototype=Object.create(e.prototype);s.prototype.constructor=s;s.prototype._initializeTools=function(a){if(this.f.getLayoutType()===n.LayoutType.MOBILE){var e=new c(a);this._publishTool(e);e.requestActivation()}else{var h=new d(a),m=new b(a),
e=new f(a);this._publishTool(m);this._publishTool(h);this._publishTool(e);this._publishToolbarComponent(n.ToolbarComponent.NAVIGATE,g.bind(function(){var b=new k(n.ToolbarComponent.NAVIGATE,a),c=new l("NavigateGroup");c.setTitle(a,"viewer","NavBtnGroupTitle");b.addButtonGroup(c);var d=new i(a,"ZoomButton","zoom",!1);d.setTooltip("viewer","ZoomBtnTT");d.listenToTool(m);d.element.on("dblclick",function(b){a.emit("viewport.zoomToFit",{animated:!0});b.stopPropagation()});c.addButton(d);d=new i(a,"ZoomInButton",
"zoomin",!1,function(){a.emit("viewport.transform",{zoom:1,animated:!0})});d.setTooltip("viewer","ZoomInCursor");c.addButton(d);d=new i(a,"ZoomOutButton","zoomout",!1,function(){a.emit("viewport.transform",{zoom:-1,animated:!0})});d.setTooltip("viewer","ZoomOutCursor");c.addButton(d);var f=new j(a,"ZoomToFitButton","zoomfitpage",!1,function(){a.emit("viewport.zoomToFit",{animated:!0})});f.setTooltip("viewer","ZoomFitToPage");c.addButton(f);this._zoomOneToOneButton=new j(a,"ZoomOneToOne","zoomfitonetoone",
!1,g.bind(this._zoomOneToOne,this));c.addButton(this._zoomOneToOneButton);d=new i(a,"PanButton","pan",!1);d.setTooltip("viewer","PanBtnTT");d.listenToTool(h);c.addButton(d);c=new l("RotFlipGroup");c.setTitle(a,"viewer","RotateBtnGroupTitle");b.addButtonGroup(c);this._rotateButton=new i(a,"RotateButton","rotateA",!0,g.bind(function(a){var b=90;a.shiftKey&&(b=-90);this.f.emit("viewport.transform",{rotate:b,animated:{interrupt:!0}})},this));c.addButton(this._rotateButton);this._flipButton=new i(a,"FlipButton",
"flipA",!0,g.bind(function(){this._doToggleFlip()},this));c.addButton(this._flipButton);this.f.loadBundle("viewer",function(){f.addAction({name:"zoomFitWidth",content:a.i18n.t("ZoomFitWidth"),icon:"zoomfitwidth",action:function(){a.emit("viewport.zoomToFitWidth",{animated:!0})}});f.addAction({name:"zoomFitHeight",content:a.i18n.t("ZoomFitHeight"),icon:"zoomfitheight",action:function(){a.emit("viewport.zoomToFitHeight",{animated:!0})}});this._zoomOneToOneButton.addAction({name:"zoomOneToOnePixel",
content:a.i18n.t("ZoomOneToOnePixel"),icon:"zoomonetoonepixel",action:g.bind(this._zoomOneToOnePixel,this)});this._zoomOneToOneButton.addAction({name:"zoomOneToOneRealSize",content:a.i18n.t("ZoomOneToOneRealSize"),icon:"zoomonetoone",action:g.bind(this._zoomOneToOneRealSize,this)});this._zoomOneToOneButton.addDivider();this._zoomOneToOneButton.addAction({name:"adjustMonitorResolution",content:a.i18n.t("ZoomOneToOneAdjustRes"),action:g.bind(this._adjustMonitorResolution,this)});this._updateZoomOneToOneButton();
this.f.getCurrentUser().on("options.changed.PREFERENCES_ZOOM_REALSIZE",g.bind(this._updateZoomOneToOneButton,this));this.f.getDocumentController().whenActivePageChanged(g.bind(this._updateZoomOneToOneButton,this));this._updateRotateButton();this.f.on("transform.viewportWidget.rotated",g.bind(this._updateRotateButton,this));this._updateFlipButton();this.f.on("transform.viewportWidget.flipped",g.bind(this._updateFlipButton,this))},this);return b},this));p.bind("ctrl+m",g.bind(function(a){this._doToggleFlip();
a.preventDefault();a.stopPropagation()},this),"keydown");p.bind(["ctrl+alt+plus","ctrl+alt+="],g.bind(function(a){this.f.emit("viewport.transform",{rotate:90,animated:{interrupt:!0}});a.preventDefault();a.stopPropagation()},this));p.bind("ctrl+alt+-",g.bind(function(a){this.f.emit("viewport.transform",{rotate:-90,animated:{interrupt:!0}});a.preventDefault();a.stopPropagation()},this))}};s.prototype._doToggleFlip=function(){var a=this.f.getModule("viewport");a&&(0===a.getRotation()%180?this.f.emit("viewport.transform",
{flip:!0,animated:!1}):this.f.emit("viewport.transform",{rotate:180,flip:!0,animated:!1}))};s.prototype._updateRotateButton=function(){var a=["rotateA","rotateB","rotateC","rotateD"],b=["Rotate90TT","Rotate180TT","Rotate270TT","Rotate0TT"],c=this.f.getModule("viewport");c&&this._rotateButton&&(c=(c.getRotation()+this._extraRotation)/90%4,this._rotateButton.setIcon(a[c]),this._rotateButton.setTooltip("viewer",b[c]))};s.prototype.setExtraRotation=function(a){this._extraRotation=a;this._updateRotateButton()};
s.prototype.resetExtraRotation=function(){this._extraRotation=0;this._updateRotateButton()};s.prototype._updateFlipButton=function(){var a=this.f.getModule("viewport");a&&this._flipButton&&(a.isFlip()?(this._flipButton.setIcon("flipB"),this._flipButton.setTooltip("viewer","MirrorTT2")):(this._flipButton.setIcon("flipA"),this._flipButton.setTooltip("viewer","MirrorTT")))};s.prototype._isZoomOneToOnePixel=function(){return this.f.getActivePage().hasGraphics()&&this.f.getOption("PREFERENCES_ZOOM_REALSIZE")===
h.ZoomOneToOneClick.AUTO};s.prototype._updateZoomOneToOneButton=function(){this._zoomOneToOneButton&&(this._isZoomOneToOnePixel()?(this._zoomOneToOneButton.setTooltip("viewer","ZoomOneToOnePixel"),this._zoomOneToOneButton.setIcon("zoomonetoonepixeloptions")):(this._zoomOneToOneButton.setTooltip("viewer","ZoomOneToOneRealSize"),this._zoomOneToOneButton.setIcon("zoomonetooneoptions")),this.f.getActivePage().hasGraphics()?this._zoomOneToOneButton.setActionEnabled("zoomOneToOnePixel",!0):this._zoomOneToOneButton.setActionEnabled("zoomOneToOnePixel",
!1))};s.prototype._adjustMonitorResolution=function(){void 0===this._adjustMonitorResolutionPopup&&(this._adjustMonitorResolutionPopup=new o(this.f,"adjustMonitorResulutionPopup",this));this._adjustMonitorResolutionPopup.show()};s.prototype._zoomOneToOne=function(){this._isZoomOneToOnePixel()?this._zoomOneToOnePixel():this._zoomOneToOneRealSize()};s.prototype._zoomOneToOnePixel=function(){this.f.getActivePage().hasGraphics()&&this.f.setOption("PREFERENCES_ZOOM_REALSIZE",h.ZoomOneToOneClick.AUTO);
this.f.emit("viewport.zoomOneToOne",{animated:!0})};s.prototype._zoomOneToOneRealSize=function(){this.f.getActivePage().hasGraphics()&&this.f.setOption("PREFERENCES_ZOOM_REALSIZE",h.ZoomOneToOneClick.REALSIZE);this.f.emit("viewport.zoomOneToOne",{animated:!0,worldResolution:this.getMonitorResolution()})};s.prototype.getMonitorResolution=function(){return void 0!==this._monitorResolution?this._monitorResolution:m.parseFloat(this.f.getOption("PREFERENCE_MONITOR_RES"))};s.prototype.setMonitorResolution=
function(a){this._monitorResolution=a};s.prototype.okMonitorResolution=function(){this.f.setOption("PREFERENCE_MONITOR_RES",this.getMonitorResolution()+"");this._monitorResolution=void 0;this._zoomOneToOneRealSize();this._adjustMonitorResolutionPopup.hide()};s.prototype.cancelMonitorResolution=function(){this._monitorResolution=void 0};return s});define("web-viewer/pagelist/PagelistConstants",{viewerThumbSize:{SMALL:0,MEDIUM:1,LARGE:2},thumbWidth:{SMALL:75,MEDIUM:100,LARGE:150},binding:{RIGHT:0,LEFT:1}});
define("web-viewer/print/PrintConstants",{PrintType:{PRINTCURRENTVIEW:0,PRINTIMAGEAREA:1,PRINTANNOTATIONOVERVIEW:2},PrintArea:{PRINTENTIREIMAGE:0,PRINTCURRENTVIEWAREA:1,PRINTCURRENTSELECTION:2},PrintChannels:{PRINTALLCHANNELS:0,PRINTSELECTEDCHANNELS:1},PrintAnnotationsSource:{PRINTANNOTATIONSCURRENT:0,PRINTANNOTATIONSREFERENCE:1}});
define("web-viewer/utils/LineworkPoint",["underscore"],function(){var g=function(){this.type=-1;this.v5=this.v4=this.v3=this.v2=this.v1=this.y=this.x=0};g.prototype.makeMoveTo=function(e,d){this.type=0;this.x=e;this.y=d};g.prototype.makeLineTo=function(e,d){this.type=1;this.x=e;this.y=d};g.prototype.makeBezier=function(e,d,c,f,b,a){this.type=2;this.x=e;this.y=d;this.v1=c;this.v2=f;this.v3=b;this.v4=a};g.prototype.makeArc=function(e,d,c,f,b,a,g){this.type=3;this.x=e;this.y=d;this.v1=c;this.v2=f;this.v3=
b;this.v4=a;this.v5=g};g.prototype.makeNick=function(e,d,c,f,b){this.type=4;this.x=e;this.y=d;this.v1=c;this.v2=f;this.v3=b};return g});
define("web-viewer/utils/LineWorkWrapper",["underscore","web-viewer/utils/ShapeUtils","web-viewer/core/Extendable","web-viewer/utils/DrawUtils","web-viewer/utils/LineworkPoint"],function(g,e,d,c){var f=function(){d.installTo(this);this.fillcolor=this.c=this.color=null;this.pointArray=[];this.rect=new e.Rect;this.type=0;this.linewidth=1;this.imageRef=this.imagetouchspot=this.imagehotspot=null;this.treatAsOutline=!1;this.textoptions={};this.showIndicator=this.selected=!1;this.indicatorColor=this.indicatorTextColor=
this.indicatorText=null;this.snapable=!1};f.prototype.move=function(b){this.rect.origin.x+=b.width;this.rect.origin.y+=b.height;if(this.pointArray&&0<this.pointArray.length)for(var a=0;a<this.pointArray.length;a++){var c=this.pointArray[a];c.x+=b.width;c.y+=b.height}};f.prototype.setRect=function(b,a){if(a&&this.pointArray&&2==this.pointArray.length){var c=b.topleft(),d=b.bottomright();this.pointArray[0].x==c.x&&this.pointArray[0].y==c.y||this.pointArray[0].x==this.pointArray[1].x&&this.pointArray[0].y==
this.pointArray[1].y?(this.pointArray[0].x=c.x,this.pointArray[0].y=c.y,this.pointArray[1].x=d.x,this.pointArray[1].y=d.y):(this.pointArray[1].x=c.x,this.pointArray[1].y=c.y,this.pointArray[0].x=d.x,this.pointArray[0].y=d.y)}this.rect=b};f.prototype.setStartEnd=function(b,a){this.pointArray&&2==this.pointArray.length&&(b?(this.pointArray[0].x=b.x,this.pointArray[0].y=b.y):b=new e.Point(this.pointArray[0].x,this.pointArray[0].y),a?(this.pointArray[1].x=a.x,this.pointArray[1].y=a.y):a=new e.Point(this.pointArray[1].x,
this.pointArray[1].y),this.setRect(new e.Rect(b,b.sizeTo(a))))};f.prototype.rgbaColor=function(b){var a=this.rgbColor();return"rgba("+a.r+","+a.g+","+a.b+","+b+")"};f.prototype.rgbColor=function(){var b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.color);return b?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null};f.prototype.calculateRectFromPointArray=function(){for(var b=null,a=null,c=null,d=null,f=0;f<this.pointArray.length;f++){var g=this.pointArray[f];if(!b||g.x<b)b=
g.x;if(!a||g.x>a)a=g.x;if(!c||g.y<c)c=g.y;if(!d||g.y>d)d=g.y}b=new e.Rect(new e.Point(b,c),new e.Size(a-b,d-c));b.normalize();this.rect=b};f.prototype.selectionAnchorPoint=function(b,a,d,g){var k=new f;k.type=c.LWTYPE_ELLIPSE;k.color=d;k.fillcolor=a;k.staticsize=!0;k.linewidth=1;k.rect=new e.Rect(new e.Point(b.x-5,b.y-5),new e.Size(10,10));k.anchor=g;k.linework=this;return k};f.prototype.getSelectionBox=function(){if(this.pointArray&&2<=this.pointArray.length)return[this.selectionAnchorPoint(new e.Point(this.pointArray[0].x,
this.pointArray[0].y),"rgb(153,152,187)","white",c.LWANCHOR_START),this.selectionAnchorPoint(new e.Point(this.pointArray[this.pointArray.length-1].x,this.pointArray[this.pointArray.length-1].y),"rgb(153,152,187)","white",c.LWANCHOR_END)];var b=[this.selectionAnchorPoint(this.rect.topleft(),"rgb(153,152,187)","white",c.LWANCHOR_TOPLEFT),this.selectionAnchorPoint(this.rect.topright(),"rgb(153,152,187)","white",c.LWANCHOR_TOPRIGHT),this.selectionAnchorPoint(this.rect.bottomleft(),"rgb(153,152,187)",
"white",c.LWANCHOR_BOTTOMLEFT),this.selectionAnchorPoint(this.rect.bottomright(),"rgb(153,152,187)","white",c.LWANCHOR_BOTTOMRIGHT),this.selectionAnchorPoint(this.rect.topcenter(),"rgb(153,152,187)","white",c.LWANCHOR_TOPCENTER),this.selectionAnchorPoint(this.rect.bottomcenter(),"rgb(153,152,187)","white",c.LWANCHOR_BOTTOMCENTER),this.selectionAnchorPoint(this.rect.centerleft(),"rgb(153,152,187)","white",c.LWANCHOR_CENTERLEFT),this.selectionAnchorPoint(this.rect.centerright(),"rgb(153,152,187)","white",
c.LWANCHOR_CENTERRIGHT)];return g.union(b)};f.prototype.scale=function(b){b&&(g.each(this.pointArray,function(a){a.x*=b.x;a.y*=b.y}),this.rect.origin.x*=b.x,this.rect.origin.y*=b.y,this.rect.size.width*=b.x,this.rect.size.height*=b.y)};return f});
define("web-viewer/core/AbstractConfig",["web-viewer/data/AbstractDataAdapter","web-viewer/core/Extendable"],function(g,e){var d=function(){e.installTo(this);this.properties={}};d.prototype.set=function(c,d){this.properties[c]=d};d.prototype.get=function(c){return this.properties[c]};d.prototype.initializeAdapter=function(c){return this.adapter=new g(c)};d.prototype.getUser=function(){};d.prototype.getModules=function(){return[]};return d});
define("web-viewer/viewControls/ViewControlsConstants",{compensateDist:{DISTONLY:1,SCALEONLY:2,DISTANDSCALE:3},trimboxMode:{ONCURRENTPAGE:0,ONBOTHINREADERSPREAD:1},marginClipMode:{CLIP_OFF:0,CLIP_IN_READERSPREAD:1,CLIP:2}});
define("web-viewer/webcenter/WebCenterDocumentPage","web-viewer/data/AbstractDocumentPage utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/utils/ShapeUtils web-viewer/data/DataConstants web-viewer/viewControls/ViewControlsConstants underscore".split(" "),function(g,e,d,c,f,b,a){e=function(b,c,d,e,i,j){g.call(this,b,c,d);this._adapter=j;this.documentType=this.getDocument().getDocumentType();this._pageVersionId=null;void 0!==i&&void 0!==i.pageindex&&(this._pageVersionId=i.docversion);void 0!==
i&&void 0!==i.blank&&(this._isBlankPage=!0);void 0!==i&&(this.set("canEditAttributes",i.can_edit_attributes),this.set("attributeCategoryID",i.attribute_category_id));if(this.documentType===f.documentPageType.GRAPHICS&&void 0!==e&&void 0!==i)this.set("hasDefaultData",i.hasDefaultData),this.set("margbot",i.margbot),this.set("margtop",i.margtop),this.set("margleft",i.margleft),this.set("margright",i.margright),this.set("vsize",i.vsize),this.set("hsize",i.hsize),this.set("hasCorrectMargin",!c.isPageList()),
this.set("docversionid",e.docversionid),this.set("pageDocversionid",i.docversionid),void 0===e.file?this.set("file",i.file):this.set("file",e.file),this.set("offsetx",i.offsetx),this.set("offsety",i.offsety),this.set("pageindex",i.pageindex),this.set("pagename",i.pagename),this.set("hscale",i.hscale),this.set("vscale",i.vscale),this.set("hdist",i.hdist),this.set("vdist",i.vdist),this.set("has3DPerspective","1"==e.has3DPerspective?!0:!1),this.set("canGenerate3D","1"==e.canGenerate3D?!0:!1),this.set("document_approval_code",
i.document_approval_code),this.set("user_approval_code",i.user_approval_code),void 0!==i.cadregedit&&(this.set("cadregedit",i.cadregedit),this.set("isCadAlignmentSaved",1==i.saved?!0:!1));else if(this.documentType===f.documentPageType.CAD&&void 0!==e&&void 0!==i){this.set("cad",e.file);this.set("pageDocversionid",i.docversionid);a.isArray(i.style)?this.set("style",i.style[0]):this.set("style",i.style);if(i.metadata&&(i.metadata.design||i.metadata.layout))b=i.metadata.design||i.metadata.layout,this.set("grainDirection",
b.grain_direction),this.set("defaultSide",b.default_side),this.set("dieSide",b.die_side);this.setPageAlignmentData(i);this.set("docversionid",e.docversionid);this.set("has3DPerspective","1"==e.has3DPerspective?!0:!1);this.set("canGenerate3D","1"==e.canGenerate3D?!0:!1)}else void 0!==e&&void 0!==e.file&&(this.set("file",e.file),this._pageVersionId=e.docversion,this.set("hasCorrectMargin",!1));void 0!==i&&this.set("diffversion",i.diffversion?!0:!1)};e.prototype=Object.create(g.prototype);e.prototype.constructor=
e;e.prototype.setPageAlignmentData=function(a){this.set("offsetx",a.offsetx);this.set("offsety",a.offsety);d.isCloseTo(this._data.offsetx,0,7)&&this.set("offsetx",0);d.isCloseTo(this._data.offsety,0,7)&&this.set("offsety",0);void 0!==a.orientation&&(this.set("overlayIsFlipped",0<(+a.orientation&4)),this.set("overlayRotation",90*(4-a.orientation%4)%360))};e.prototype.getMargins=function(){var a={};a.bottom=d.parseFloat(this._data.margbot?this._data.margbot:0);a.top=d.parseFloat(this._data.margtop?
this._data.margtop:0);a.left=d.parseFloat(this._data.margleft?this._data.margleft:0);a.right=d.parseFloat(this._data.margright?this._data.margright:0);return a};e.prototype.getDocumentPageOrigin=function(){var a=this.getRotation()%360,b=this.isFlipped(),d=this.getMargins(),f=this.getParam("fileminx"),e=this.getParam("fileminy");90===a?(f-=d.bottom,e=b?e-d.right:e-d.left):180===a?(e-=d.bottom,f=b?f-d.left:f-d.right):270===a?(f-=d.top,e=b?e-d.left:e-d.right):(e-=d.top,f=b?f-d.right:f-d.left);return new c.Point(f,
e)};e.prototype.getTrimboxRect=function(){var a,b;this.isBlankPage()?(a=this.getMargins(),a=new c.Point(a.left,a.top),b=new c.Size(d.parseFloat(this.get("hsize")),d.parseFloat(this.get("vsize")))):(a=new c.Point(d.parseFloat(this.getParam("fileminx")),d.parseFloat(this.getParam("fileminy"))),b=new c.Size(d.parseFloat(this.getParam("filemaxx"))-a.x,d.parseFloat(this.getParam("filemaxy"))-a.y));return new c.Rect(a,b)};e.prototype.getPageSize=function(){var a=this.getMargins();if(this.hasGraphics()){if(1E-9<
Math.abs(d.parseFloat(this.get("hsize")))){var a=new c.Size(d.parseFloat(this.get("hsize"))+a.left+a.right,d.parseFloat(this.get("vsize"))+a.bottom+a.top),b=this.getCurrentScaling();b&&(a.width*=b.x,a.height*=b.y);return a}return new c.Size(d.parseFloat(this.getParam("sizex")),d.parseFloat(this.getParam("sizey")))}if(this.isBlankPage())return this.isReaderSpread()?(a=this.getMargins(),b=this.getTrimboxSize(),new c.Size(b.width+a.left+a.right,b.height+a.top+a.bottom)):new c.Size(this.getParam("filemaxx")+
a.left+a.right,this.getParam("filemaxy")+a.top+a.bottom);if(this.hasCad())return this.isCadAvailable&&this.isCadAvailable()?this.getCad().getSize():new c.Size};e.prototype.getCurrentScaling=function(){var a=1,f=1;if(this.getStateParam("compensateDist")===b.compensateDist.DISTONLY||this.getStateParam("compensateDist")===b.compensateDist.DISTANDSCALE)a=1*a/d.parseFloat(this.get("vdist")),f=1*f/d.parseFloat(this.get("hdist"));if(this.getStateParam("compensateDist")===b.compensateDist.SCALEONLY||this.getStateParam("compensateDist")===
b.compensateDist.DISTANDSCALE)a=1*a/d.parseFloat(this.get("vscale")),f=1*f/d.parseFloat(this.get("hscale"));return 1===a&&1===f?null:new c.Point(f,a)};e.prototype.getInfoURL=function(a){return this._adapter.ViewServer("info.jsp",a)};e.prototype.isRectOnPage=function(a){var b=this.getMargins(),d=this.getPageSize(),d=new c.Rect(new c.Point(0,0),d);d.origin.offset(new c.Size(-b.left,-b.bottom));return d.rectIntersect(a)};e.prototype.getPageVersionId=function(){return this._pageVersionId};e.prototype.isDigitalFilmPage=
function(){return this.hasGraphics()&&this.getParam("imagetype")===f.imageType.OTHER};e.prototype.getTrimboxSize=function(){var a=d.parseFloat(this.get("hsize")),b=d.parseFloat(this.get("vsize"));return!a||!b?new c.Size:new c.Size(a,b)};e.prototype.getThumbnailUrl=function(){var a;if(this.hasGraphics())return a={file:this._data.file,px:50,py:50},this.f.getDataAdapter().ViewServer("thumbdata.jsp",a);if(this.hasCad())return a={docverid:this._docVersion.get("docversionid")},this.f.getDataAdapter().WebCenter("docgetthumbdata.jsp",
a)};e.prototype.getInformationForDocumentSelector=function(){var a=this.getDocument(),b=this.getDocumentVersion(),c={};c.documentName=a.get("docname");c.project=a.get("projectname");if(a.hasMultipleVersions()){c.versionNumber=this.getPageVersionId();if(void 0===c.versionNumber||null===c.versionNumber)c.versionNumber=b.getVersionId();c.versionNumber&&b.get("docRevision")&&(c.versionNumber+="("+b.get("docRevision")+")");c.versionId=b.getVersionId()}b=b.getPageCount();1<b&&(c.pageCount=b,c.pageNumber=
this.getPagenum());c.thumbnailUrl=this.getThumbnailUrl();c.pageId=this.getUniqueID();c.docType=a.getDocumentType();return c};e.prototype.canSaveCadOverlay=function(){return 1==this.get("cadregedit")};e.prototype.canEditAttributes=function(){return 1==this.get("canEditAttributes")};e.prototype.getAttributeCategoryID=function(){return this.get("attributeCategoryID")};g.prototype.needsDataUpdate=function(){return this.get("hasDefaultData")};return e});
define("web-viewer/webcenter/WebCenterDocumentVersion","web-viewer/data/AbstractDocumentVersion web-viewer/data/AbstractDocumentPage web-viewer/webcenter/WebCenterDocumentPage utils/XMLUtils web-viewer/utils/ViewerUtils underscore".split(" "),function(g,e,d,c,f,b){e=function(a,c,f,e,l,i){g.call(this,a,c,f);this._adapter=i;this._versionData.docversionid=e.docversionid;this._versionData.docversion=f;this._versionData.isMultiPage=void 0!==e.isMultiPage?e.isMultiPage:!1;b.isString(this._versionData.isMultiPage)&&
(this._versionData.isMultiPage="true"===this._versionData.isMultiPage?!0:!1);this._versionData.isPageList=void 0!==e.isPageList?e.isPageList:!1;b.isString(this._versionData.isPageList)&&(this._versionData.isPageList="true"===this._versionData.isPageList?!0:!1);this._versionData.docRevision=e.docrevision;void 0!==l&&void 0!==l.pagecount&&(this._versionData.pagecount=l.pagecount);!b.isArray(e)&&void 0!==e&&(c=1,l&&(c=l.pageno||1),a=new d(a,this,c,e,l,i),this.addPage(c,a))};e.prototype=Object.create(g.prototype);
e.prototype.constructor=e;e.prototype.addDocumentPageFromData=function(a){var b=new d(this._f,this,a.pageno,this._versionData,a,this._adapter);this.addPage(b.getPagenum(),b);void 0!==a.pagecount&&(this._versionData.pagecount=parseInt(a.pagecount))};e.prototype.isMultiPage=function(){return 1<this.getPageCount()||this._versionData.isMultiPage};e.prototype.getDocumentVersionID=function(){return this.get("docversionid")};e.prototype.getPageCount=function(){return this.get("pagecount")?this.get("pagecount"):
this._versionData.isMultiPage?this._pages.length-1:1};return e});
define("web-viewer/webcenter/WebCenterDocument","web-viewer/data/AbstractDocument web-viewer/data/DataConstants underscore web-viewer/webcenter/WebCenterDocumentVersion web-viewer/webcenter/WebCenterDocumentPage utils/XMLUtils".split(" "),function(g,e,d,c,f){var b=function(a,b,c,d,f){g.call(this,a,c,d);this.f=a;this._adapter=f;void 0!==b&&this._initializeWithDocInfo(b)};b.prototype=Object.create(g.prototype);b.prototype.constructor=b;b.prototype.addDocumentPageFromData=function(a){var b=this.getDocumentVersion(a.docversion);
if(void 0!==b&&a.docversionid===b._versionData.docversionid)b.addDocumentPageFromData(a);else if(a.isMultiPage&&void 0!==a.pageindex)if(b=this.getDocumentVersion(),b.addDocumentPageFromData(a),a.docversion>b.getVersionId()){var d=b.getVersionId();b._versionData.docversionid=a.docversionid;b._versionData.docversion=a.docversion;b._versionId=a.docversion;this._documentVersions[a.docversion]=b;delete this._documentVersions[d]}else a.docversion===b.getVersionId()&&a.docversionid>b._versionData.docversionid&&
(b._versionData.docversionid=a.docversionid,this._documentVersions[a.docversion]=b);void 0!==a.diff&&(b=this.getDocumentVersion(a.diffversion),void 0===b&&(b=new c(this.f,this,a.diffversion,{},void 0,this._adapter),this.addDocumentVersion(b)),d=new f(this.f,b,a.pageno,{file:a.diff},void 0,this._adapter),b.addPage(a.pageno,d))};b.prototype._initializeWithDocInfo=function(a){this.set("docid",a.docid);this.set("projectid",a.projectid);this.set("projectname",a.projectname+"");this.set("binding",a.binding);
if(this._documentType===e.documentPageType.GRAPHICS){var b={};b.docversionid=a.docversionid;this.set("docname",a.docname+"");this.set("projectname",a.projectname+"");b.file=a.file;b.isPageList=void 0!==a.pageindex;b.docrevision=a.docrevision;b=new c(this.f,this,a.docversion,b,a,this._adapter);this.addDocumentVersion(b);a.cadversionid&&this.set("linkedCADVersionID",a.cadversionid);if(a.isMultiPage&&void 0===a.versionlist&&void 0===a.pageindex){for(b=1;b<parseInt(a.docversion,10);b++){var g=new c(this.f,
this,b,{isMultiPage:a.isMultiPage},void 0,this._adapter);this.addDocumentVersion(g)}void 0!==a.diff&&(b=this.getDocumentVersion(a.diffversion),g=new f(this.f,b,a.pageno,{file:a.diff},void 0,this._adapter),b.addPage(a.pageno,g));a.pageNumber=1;this._adapter.loadVersionsOfDocumentPage(a,this,d.bind(function(){this.f.getDocumentController().loadedDocumentChanged()},this))}void 0!==a.versionlist&&(d.isArray(a.versionlist)||(a.versionlist=[a.versionlist]),d.each(a.versionlist,d.bind(function(a){a=new c(this.f,
this,a.docversion,a,void 0,this._adapter);this.addDocumentVersion(a)},this)))}else this._documentType===e.documentPageType.CAD&&(a.caddocname?this.set("docname",a.caddocname+""):this.set("docname",a.docname+""),void 0!==a.cadversionlist?(d.isArray(a.cadversionlist)||(a.cadversionlist=[a.cadversionlist]),d.each(a.cadversionlist,d.bind(function(b){b=new c(this.f,this,b.docversion,b,a,this._adapter);this.addDocumentVersion(b)},this))):void 0!==a.versionlist&&(d.isArray(a.versionlist)||(a.versionlist=
[a.versionlist]),d.each(a.versionlist,d.bind(function(b){b=new c(this.f,this,b.docversion,b,a,this._adapter);this.addDocumentVersion(b)},this))))};b.prototype.loadVersionsForDocumentPage=function(a,b){var c={docid:a.getDocument().getDocumentID(),docversionid:a.getDocumentVersion().getDocumentVersionID(),diffversion:null,pageNumber:a.getPagenum(),isPageList:a.getDocumentVersion().isPageList()};this._adapter.loadVersionsOfDocumentPage(c,this,b,a)};b.prototype.getDocumentID=function(){return this.get("docid")};
b.prototype.getProjectID=function(){return this.get("projectid")};return b});
define("web-viewer/utils/LineworkWrapper",["underscore","web-viewer/utils/ShapeUtils","web-viewer/core/Extendable","web-viewer/utils/DrawUtils","web-viewer/utils/LineworkPoint"],function(g,e,d,c){var f=function(){d.installTo(this);this.fillcolor=this.c=this.color=null;this.pointArray=[];this.rect=new e.Rect;this.type=0;this.linewidth=1;this.imageRef=this.imagetouchspot=this.imagehotspot=null;this.treatAsOutline=!1;this.textoptions={};this.showIndicator=this.selected=!1;this.indicatorColor=this.indicatorTextColor=
this.indicatorText=null;this.snapable=!1};f.prototype.move=function(b){this.rect.origin.x+=b.width;this.rect.origin.y+=b.height;if(this.pointArray&&0<this.pointArray.length)for(var a=0;a<this.pointArray.length;a++){var c=this.pointArray[a];c.x+=b.width;c.y+=b.height}};f.prototype.setRect=function(b,a){if(a&&this.pointArray&&2==this.pointArray.length){var c=b.topleft(),d=b.bottomright();this.pointArray[0].x==c.x&&this.pointArray[0].y==c.y||this.pointArray[0].x==this.pointArray[1].x&&this.pointArray[0].y==
this.pointArray[1].y?(this.pointArray[0].x=c.x,this.pointArray[0].y=c.y,this.pointArray[1].x=d.x,this.pointArray[1].y=d.y):(this.pointArray[1].x=c.x,this.pointArray[1].y=c.y,this.pointArray[0].x=d.x,this.pointArray[0].y=d.y)}this.rect=b};f.prototype.setStartEnd=function(b,a){this.pointArray&&2==this.pointArray.length&&(b?(this.pointArray[0].x=b.x,this.pointArray[0].y=b.y):b=new e.Point(this.pointArray[0].x,this.pointArray[0].y),a?(this.pointArray[1].x=a.x,this.pointArray[1].y=a.y):a=new e.Point(this.pointArray[1].x,
this.pointArray[1].y),this.setRect(new e.Rect(b,b.sizeTo(a))))};f.prototype.rgbaColor=function(b){var a=this.rgbColor();return"rgba("+a.r+","+a.g+","+a.b+","+b+")"};f.prototype.rgbColor=function(){var b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.color);return b?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null};f.prototype.calculateRectFromPointArray=function(){for(var b=null,a=null,c=null,d=null,f=0;f<this.pointArray.length;f++){var g=this.pointArray[f];if(!b||g.x<b)b=
g.x;if(!a||g.x>a)a=g.x;if(!c||g.y<c)c=g.y;if(!d||g.y>d)d=g.y}b=new e.Rect(new e.Point(b,c),new e.Size(a-b,d-c));b.normalize();this.rect=b};f.prototype.selectionAnchorPoint=function(b,a,d,g){var k=new f;k.type=c.LWTYPE_ELLIPSE;k.color=d;k.fillcolor=a;k.staticsize=!0;k.linewidth=1;k.rect=new e.Rect(new e.Point(b.x-5,b.y-5),new e.Size(10,10));k.anchor=g;k.linework=this;return k};f.prototype.getSelectionBox=function(){if(this.pointArray&&2<=this.pointArray.length)return[this.selectionAnchorPoint(new e.Point(this.pointArray[0].x,
this.pointArray[0].y),"rgb(153,152,187)","white",c.LWANCHOR_START),this.selectionAnchorPoint(new e.Point(this.pointArray[this.pointArray.length-1].x,this.pointArray[this.pointArray.length-1].y),"rgb(153,152,187)","white",c.LWANCHOR_END)];var b=[this.selectionAnchorPoint(this.rect.topleft(),"rgb(153,152,187)","white",c.LWANCHOR_TOPLEFT),this.selectionAnchorPoint(this.rect.topright(),"rgb(153,152,187)","white",c.LWANCHOR_TOPRIGHT),this.selectionAnchorPoint(this.rect.bottomleft(),"rgb(153,152,187)",
"white",c.LWANCHOR_BOTTOMLEFT),this.selectionAnchorPoint(this.rect.bottomright(),"rgb(153,152,187)","white",c.LWANCHOR_BOTTOMRIGHT),this.selectionAnchorPoint(this.rect.topcenter(),"rgb(153,152,187)","white",c.LWANCHOR_TOPCENTER),this.selectionAnchorPoint(this.rect.bottomcenter(),"rgb(153,152,187)","white",c.LWANCHOR_BOTTOMCENTER),this.selectionAnchorPoint(this.rect.centerleft(),"rgb(153,152,187)","white",c.LWANCHOR_CENTERLEFT),this.selectionAnchorPoint(this.rect.centerright(),"rgb(153,152,187)","white",
c.LWANCHOR_CENTERRIGHT)];return g.union(b)};f.prototype.scale=function(b){b&&(g.each(this.pointArray,function(a){a.x*=b.x;a.y*=b.y}),this.rect.origin.x*=b.x,this.rect.origin.y*=b.y,this.rect.size.width*=b.x,this.rect.size.height*=b.y)};return f});
define("web-viewer/cad/CadLine","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint web-viewer/utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/utils/DrawUtils web-viewer/cad/CadConstants".split(" "),function(g,e,d,c,f,b,a){b=function(b,o,k){g.call(this);"Nicks"==b.nodeName?(this.type=a.CadTypes.Nick,this.linewidth=1,this.color="black"):this.type=c.attributeValue(b,"linetype");var l=c.attributeValue(b,"bridgeopt");l&&(this.bridgeopt=parseInt(l,10));if(null===this.type)o=
c.attributeValue(b,"stroke"),null!==o&&(this.color=o);else if(o=o[this.type])this.c=o.color,this.color="#"+f.rgbToHex(this.c.r,this.c.g,this.c.b),this.linewidth=o.width/4,"0"!==o.style&&(this.dash=a.LineTypes[o.style]);this.fillcolor=c.attributeValue(b,"fill");"none"===this.fillcolor&&(this.fillcolor=null);this.fillcolor&&"none"===c.attributeValue(b,"stroke")&&(this.linewidth=1);var i=c.attributeValue(b,"d");this.pointArray=[];for(var j=l=o=b=null,i=i.match(/[a-z][^a-z]*/ig),n=0;n<i.length;n++){var m=
new e,p=f.trim(i[n]),s=null,v=null,q=null,w=null,r=p.charAt(0);if("A"==r){var p=RegExp(/A\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)/).exec(p),s=f.parseFloat(p[1]),v=f.parseFloat(p[2]),q=f.parseFloat(p[3]),w=f.parseFloat(p[4]),u=f.parseFloat(p[5]),r=f.parseFloat(p[6]),p=f.parseFloat(p[7]);m.makeArc(r,k-p,s,v,q,w,u);v=s=m.x;w=q=m.y}else if("C"==r){var s=RegExp(/C\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)\s(.+)/).exec(p),r=f.parseFloat(s[1]),p=f.parseFloat(s[2]),u=f.parseFloat(s[3]),y=f.parseFloat(s[4]),t=f.parseFloat(s[5]),
x=f.parseFloat(s[6]),s=Math.min(r,u,t),v=Math.max(r,u,t),q=Math.min(k-p,k-y,k-x),w=Math.max(k-p,k-y,k-x);m.makeBezier(r,k-p,u,k-y,t,k-x)}else if("N"==r)q=RegExp(/N(.+)\s(.+)\s(.+)\s(.+)\s(.+)/).exec(p),r=f.parseFloat(q[1]),p=f.parseFloat(q[2]),s=f.parseFloat(q[3]),v=f.parseFloat(q[4]),q=f.parseFloat(q[5]),m.makeNick(r,k-p,s,v,q),v=s=m.x,w=q=m.y;else if("L"==r||"M"==r)s=RegExp(/.(.+)\s(.+)/).exec(p),p=f.parseFloat(s[1]),s=k-f.parseFloat(s[2]),"L"==r?m.makeLineTo(p,s):m.makeMoveTo(p,s),v=s=m.x,w=q=
m.y;if(-1!=m.type){this.pointArray.push(m);if(null===b||s<b)b=s;if(null===o||v>o)o=v;if(null===l||q<l)l=q;if(null===j||w>j)j=w}}k=new d.Rect(new d.Point(b,l),new d.Size(o-b,j-l));k.normalize();this.rect=k};b.prototype=Object.create(g.prototype);return b.prototype.constructor=b});
define("web-viewer/cad/CadText",["web-viewer/utils/LineworkWrapper","web-viewer/utils/ShapeUtils","utils/XMLUtils","web-viewer/utils/ViewerUtils"],function(g,e,d,c){var f=function(b,a,f,o){g.call(this);this.type=-21;for(var k=this.textoptions.rotation=0;k<b.attributes.length;k++){var l=b.attributes[k];this.textoptions[l.nodeName]=l.nodeValue}this.textoptions.rotate=null==this.textoptions.rotate?0:c.parseFloat(this.textoptions.rotate);f=b.getElementsByTagName("Tspan")[f];this.textoptions.text=f.firstChild.nodeValue;
b=d.attributeValue(f,"x");k=d.attributeValue(f,"y");0!==this.textoptions.rotate&&(l=-this.textoptions.rotate/180*Math.PI,f=b*Math.cos(l)-k*Math.sin(l),k=b*Math.sin(l)+k*Math.cos(l),b=f);this.rect=new e.Rect(new e.Point(0,0),new e.Size(0,0));this.rect.origin.x=b;this.rect.origin.y=o-k;if(a=a[this.textoptions.filltype])this.c=a.color,this.color="#"+c.rgbToHex(this.c.r,this.c.g,this.c.b);void 0!==this.textoptions.fill&&(this.color=this.textoptions.fill)};f.prototype=Object.create(g.prototype);return f.prototype.constructor=
f});
define("web-viewer/cad/CadFile","underscore web-viewer/utils/ShapeUtils utils/XMLUtils web-viewer/cad/CadLine web-viewer/cad/CadText web-viewer/cad/CadConstants web-viewer/utils/ViewerUtils".split(" "),function(g,e,d,c,f,b,a){var h=function(a,b,c){this.layerclass=a;this.layertype=b;this.layername=c;this.lines=[];this.oneUps=[]},o=function(b,l,i,j){this.cstyles=b;this.name=null;this.cadlayers=[];this._selectedClasses=this._selectedLayers=this.oneupClasses=null;this.alpha=1;this._xmlData=l;if(j)this.rect=i;
else{this.rect=new e.Rect;var i=a.parseFloat(d.attributeValue(l,"minx")),n=a.parseFloat(d.attributeValue(l,"miny")),m=a.parseFloat(d.attributeValue(l,"maxx")),p=a.parseFloat(d.attributeValue(l,"maxy"));this.rect.origin.x=i;this.rect.origin.y=n;this.rect.size.width=m-i;this.rect.size.height=p-n}this.originalOrigin=this.rect.origin.copy();this.doctype=d.attributeValue(l,"doctype");j?(this.name=d.attributeValue(l,"name"),l=l.getElementsByTagName("OneupLayer")):l=l.getElementsByTagName("Layer");for(var p=
m=n=i=null,s=0;s<l.length;s++){for(var v=l[s],q=d.attributeValue(v,"class"),w=d.attributeValue(v,"type"),r=d.attributeValue(v,"name"),q=new h(q,w,r,j),v=v.childNodes,w=0;w<v.length;w++){var u=v[w];if(1===u.nodeType)if("Path"==u.nodeName||"Nicks"==u.nodeName)r=new c(u,this.cstyles.plottingStyles,this.rect.size.height),"Path"==u.nodeName&&("3"!=q.layerclass&&"4"!=q.layerclass)&&(r.snapable=!0),q.lines.push(r),i=i?Math.min(i,r.rect.left()):r.rect.left(),n=n?Math.min(n,r.rect.top()):r.rect.top(),m=m?
Math.max(m,r.rect.right()):r.rect.right(),p=p?Math.max(p,r.rect.bottom()):r.rect.bottom();else if("TextGroup"==u.nodeName)for(var u=u.getElementsByTagName("Text"),y=0;y<u.length;y++)for(var t=u[y].getElementsByTagName("Tspan"),x=0;x<t.length;x++)r=new f(u[y],this.cstyles.plottingStyles,x,this.rect.size.height),q.lines.push(r);else"Oneup"==u.nodeName&&(r=new o(b,u,this.rect,!0),q.oneUps.push(r))}this.cadlayers.push(q);this.contentRect=new e.Rect(new e.Point(i,n),new e.Size(m-i,p-n));this.contentRect.normalize()}this._selectedLayers=
g.clone(this.cadlayers);this._selectedClasses=g.clone(this.getOneupClasses())};o.prototype.getSize=function(){return this.rect.size.copy()};o.prototype.getOrigin=function(){return this.rect.origin.copy()};o.prototype.getOriginalOrigin=function(){return this.originalOrigin};o.prototype.resetOrigin=function(){this.rect.origin=this.originalOrigin.copy()};o.prototype.setOrigin=function(a,b){this.rect.origin.x=a;this.rect.origin.y=b};o.prototype.getSelectedLayers=function(){return this._selectedLayers};
o.prototype.getSelectedClasses=function(){return this._selectedClasses};o.prototype.setLocation=function(a){this._location=a};o.prototype.getLocation=function(){return this._location};o.prototype.toggleLayer=function(a,b){if(0>a)this._selectedLayers=this._selectedLayers.length===this.cadlayers.length&&b?[]:g.clone(this.cadlayers);else{var c=this.cadlayers[a];c&&(a=g.indexOf(this._selectedLayers,c),0<=a?this._selectedLayers.splice(a,1):this._selectedLayers.push(c))}};o.prototype.toggleClass=function(a,
b){if(0>a)this._selectedClasses=this._selectedClasses.length===this.getOneupClasses().length&&b?[]:g.clone(this.getOneupClasses());else{var c=this.getOneupClasses()[a];if(c){var d=g.indexOf(this._selectedClasses,c);0>d?this._selectedClasses.push(c):this._selectedClasses.splice(d,1)}}};o.prototype.hideClasses=function(){this._selectedClasses=[]};o.prototype.hideLayers=function(){this._selectedLayers=[]};o.prototype.getOneupClasses=function(){if(!this.oneupClasses){var a=[];g.each(this.cadlayers,function(b){g.each(b.oneUps,
function(b){g.each(b.cadlayers,function(b){b=b.layerclass;0>g.indexOf(a,b)&&a.push(b)})})});this.oneupClasses=a}return this.oneupClasses};return o});
define("web-viewer/webcenter/WebCenterDataAdapter","web-viewer/data/AbstractDataAdapter web-viewer/webcenter/WebCenterDocument web-viewer/webcenter/WebCenterDocumentVersion web-viewer/webcenter/WebCenterDocumentPage web-viewer/data/DataConstants utils/HTTPUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/graphics/GraphicsConstants web-viewer/viewControls/ViewControlsConstants web-viewer/cad/CadFile jquery underscore".split(" "),function(g,e,d,c,f,b,a,h,o,k,l,i,j){k=function(a,b,c){g.call(this,
a,b);this.instance=b;this.viewserver=c;this._parameterUpdateToken=0;this._cadStyles={};b=j.bind(function(){a.ajax(this.WebCenter("sessionalive.jsp"),{error:function(b,c,d){a.i18n.loadBundle("viewer",function(){a.emit("error.WARNING",a.i18n.t("WCSessionLostError"),b,c,d)})},success:function(){a.debug.log("Keep WebCenter session alive")}})},this);setInterval(b,6E5);this.f.on("intercept.fragmentURL",j.bind(this.interceptFragmentURL,this))};k.prototype=Object.create(g.prototype);k.prototype.constructor=
k;k.prototype.getNumberOfDocuments=function(a){if(void 0===a)return 0;if(j.isString(a))return 1;if(j.isObject(a))return a=a.pagelist.page,j.isArray(a)?a.length:1};k.prototype.openDocuments=function(a,b){j.isString(a)?this.loadDocument(a,b,!0):j.isObject(a)?this.loadDocuments(a,b):void 0!==a&&this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.t("UnknownDocumentError"),a)},this)};k.prototype.loadDocument=function(b,c,d){b=this.WebCenter("getdocumentinfo.jsp",{docversionid:b});
this.f.ajax(b,{success:j.bind(function(b){b=a.xml2obj(b);"0"==b.status.value?j.isArray(b.status.page)?j.each(b.status.page,j.bind(function(a){this._initDocument(a,c,d)},this)):this._initDocument(b.status.page,c,d):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),b)},this),c(null))},this),error:j.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,d)},
this);c(null)},this)})};k.prototype.loadDocuments=function(a,b){var c=a.pagelist.page;j.isArray(c)?j.each(c,j.bind(function(c,d){var f=0===d;void 0!==a.pagelist.startpageindex&&(f=d===a.pagelist.startpageindex);this._initDocument(c,b,f)},this)):this._initDocument(c,b,!0)};k.prototype._initDocument=function(a,b,c){var d=this.f.getDocumentController(),g=null,h=null,i=a.docversion,k;if(void 0!==a.file||void 0!==a.blank)k=this.getDocumentByDocId(a.docid),g=f.documentPageType.GRAPHICS,a.hasDefaultData=
!0,a.isMultiPage=void 0!==a.pagecount&&1<a.pagecount?!0:!1,void 0===k?g=new e(this.f,a,d.getNextIID(),g,this):(k.addDocumentPageFromData(a),g=k);if(void 0!==a.cad){null!==g&&void 0!==a.cadid&&(a.docid=a.cadid,a.docversionid=a.cadversionid);if(null===g||!g.hasLinkedDocument())h=new e(this.f,a,d.getNextIID(),f.documentPageType.CAD,this);b&&null===g&&b(h,!1)}void 0===a.cad&&(void 0===a.file&&(void 0===a.pageno||1===parseInt(a.pageno,10))&&1!=a.blank)&&this.loadDocument(a.docversionid,b,c);if(null!==
g&&null!==h){for(var l,o=h.getAllDocumentVersions(),t=function(b){return b&&b.get("docversionid")===a.cadversionid},x=1;!l&&x<=o.length;x++){var A=o[x];A&&(l=j.find(A.getAllPages(),t))}g.setLinkedDocumentPage(l)}b&&null!==g?b(g,!1):k&&b(k,!1);c&&(null==g&&null!==h&&void 0!==h.getDocumentVersion(i)&&void 0!==h.getDocumentVersion(i).getFirstPage()?d.changeActivePage(h.getDocumentVersion(i).getFirstPage()):k&&void 0!==k.getDocumentVersion()&&void 0!==k.getDocumentVersion().getLastPage()?d.changeActivePage(k.getDocumentVersion().getLastPage()):
null!==g&&(void 0!==g.getDocumentVersion(i)&&void 0!==g.getDocumentVersion(i).getFirstPage())&&d.changeActivePage(g.getDocumentVersion(i).getFirstPage()))};k.prototype.WebCenter=function(a,c){return b.constructURL(a,c,this.instance)};k.prototype.ViewServer=function(a,c){return b.constructURL(a,c,this.viewserver)};k.prototype.getPathToWCRImages=function(){return this.instance+"images/"};k.prototype.getPathToJSFiles=function(){return this.instance+"javascript/"};k.prototype.interceptFragmentURL=function(a){a.params.x1+=
a.rectangle.left();a.params.y1+=a.rectangle.top();a.params.x2+=a.rectangle.right();a.params.y2+=a.rectangle.bottom();a.params.res=a.resolution;a.params.wc=6;a.servlet=this.viewserver+"thumbdata.jsp"};k.prototype.isUpdateTokenValid=function(a){return this._parameterUpdateToken===a};k.prototype.generateUpdateToken=function(){return++this._parameterUpdateToken};k.prototype.cancelDocumentParametersUpdate=function(){this.generateUpdateToken()};k.prototype.shouldRequestCadDataForPage=function(a){a=a.get("cadData");
return!a||!a.loaded};k.prototype.shouldRequestCadStyleForPage=function(a){return!this._cadStyles[a.get("style")]};k.prototype.updateDocumentParameters=function(a,b,c,d){var f=this.generateUpdateToken();a.getDocumentVersion().isPageList()||!a.get("hasCorrectMargin")?this._fetchPageInfo(a,j.bind(function(){b&&b.getDocumentVersion().isPageList()?this._fetchPageInfo(b,j.bind(function(){this._fetchParameters(f,a,b,c,d)},this)):this._fetchParameters(f,a,b,c,d)},this)):b&&(b.getDocumentVersion().isPageList()||
!b.get("hasCorrectMargin"))?this._fetchPageInfo(b,j.bind(function(){this._fetchParameters(f,a,b,c,d)},this)):this._fetchParameters(f,a,b,c,d)};k.prototype._fetchParameters=function(a,b,c,d,f){var e,g;if(b.hasGraphics()||b.isBlankPage()&&c&&c.hasGraphics()){b.isBlankPage()&&(c&&c.hasGraphics())&&(g=c,c=b,b=g);e=b.getMargins();var h=b.getTrimboxSize();e={wc:6,file:b.get("file"),ftbtlx:e.left,ftbtly:e.top,ftbbrx:h.width+e.left,ftbbry:h.height+e.top};b.getDocumentVersion().isPageList()&&(e.pageno=b.getPagenum());
if(c){var h=c.getMargins(),i=c.getTrimboxSize();c.getDocumentVersion().isPageList()&&(e.diffpageno=c.getPagenum());e.dtbtlx=h.left;e.dtbtly=h.top;e.dtbbrx=i.width+h.left;e.dtbbry=i.height+h.top}this.f.emit("intercept.parameters",{params:e});g&&e.rs&&(e.rs=1==e.rs?2:1);void 0!==c&&!c.isBlankPage()&&(e.diff=c.get("file"),c.resetParameters());d&&this.shouldRequestCadDataForPage(d)&&(e.cad=d.get("cad"),this.shouldRequestCadStyleForPage(d)&&(e.style=d.get("style")))}else b.hasCad()&&(this.shouldRequestCadDataForPage(b)?
(e={wc:6,cad:b.get("cad")},this.shouldRequestCadStyleForPage(b)&&(e.style=b.get("style")),c&&(c.hasCad()&&this.shouldRequestCadDataForPage(c))&&(e.dcad=c.get("cad"))):c&&c.hasCad()&&this.shouldRequestCadDataForPage(c)?(g=b,b=c,c=g,e={wc:6,cad:b.get("cad")},this.shouldRequestCadStyleForPage(b)&&(e.style=b.get("style"))):f());e?(g=this.ViewServer("parameters.jsp",e),this.f.ajax(g,{success:j.bind(this._handleParametersResult,this,a,e,b,c,d,f)})):f&&this._whenCadDataAvailableForAllActiveFiles(a,b,c,d,
f)};k.prototype._whenCadDataAvailableForAllActiveFiles=function(a,b,c,d,f){this.f.requestModule("cad",j.bind(function(){if(this.isUpdateTokenValid(a)){var e=j.filter([b,c,d],function(a){return a&&a.hasCad()?(a=a.get("cadData"),a.requested&&!1===a.loaded):!1},this),g=j.bind(function(a,b){this.isUpdateTokenValid(a)&&b()},this,a,f);0<e.length?(g=j.after(e.length,g),j.each(e,function(a){a.on("cadData.available",g)})):g()}},this),!0)};k.prototype._handleParametersResult=function(b,c,d,f,e,g,h){var i=a.xml2obj(h);
!i.status||-1==i.status.value?this.isUpdateTokenValid(b)&&this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerImageParmsError",this.f.i18n.t("file")),i.status.message,i)},this):(i.status.parameters.cad&&(i.status.parameters.cad.data&&this._loadCadDataFor(e?e:d,i.status.parameters.cad.data),i.status.parameters.cad.ddata&&this._loadCadDataFor(f,i.status.parameters.cad.ddata),i.status.parameters.cad.style&&this._loadCadStyle(c.style,i.status.parameters.cad.style)),
this._whenCadDataAvailableForAllActiveFiles(b,d,f,e,j.bind(function(){this._handleGraphicsParametersResult(b,d,f,e,g,i)},this)))};k.prototype._whenCadStyleAvailable=function(a,b,c){c&&(b=j.bind(b,c));if(this._cadStyles[a]&&"LOADING"!==this._cadStyles[a])b(this._cadStyles[a]);else this.once(["cadStyle",a,"available"],b)};k.prototype._loadCadStyle=function(a,b){this._cadStyles[a]="LOADING";this._fetchPreviewData(b,j.bind(function(b){this._cadStyles[a]=b.documentElement;this._emit(["cadStyle",a,"available"],
b.documentElement)},this))};k.prototype._loadCadDataFor=function(a,b,c){var d={requested:!0,loaded:!1};a.set("cadData",d);this._fetchPreviewData(b,j.bind(function(b){this._whenCadStyleAvailable(a.get("style"),function(f){d.loaded=!0;d.rawCad=b.documentElement;d.rawStyle=f;a.set("cadData",d);a.setCadDataAvailable();c&&c()},this)},this))};k.prototype._fetchPreviewData=function(a,b,c){this.f.ajax(this.ViewServer("getcaddata.jsp",{url:a}),{success:j.bind(function(c){try{b(c)}finally{this.f.ajax(this.ViewServer("previewdelete.jsp",
{url:a}),{error:j.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("PreviewDeleteError"),a,b,c)},this)},this)})}},this),error:j.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerCadReadError",this.f.i18n.t("file")),a,b,d)});c&&c(a,b,d)},this)})};k.prototype._handleGraphicsParametersResult=function(a,b,c,d,f,e){if(this.isUpdateTokenValid(a)){var g={resolutionx:h.parseFloat(e.status.parameters.resolutionx),
resolutiony:h.parseFloat(e.status.parameters.resolutiony),sizex:h.parseFloat(e.status.parameters.sizex),sizey:h.parseFloat(e.status.parameters.sizey),fileminx:h.parseFloat(e.status.parameters.fileminx),fileminy:h.parseFloat(e.status.parameters.fileminy),filemaxx:h.parseFloat(e.status.parameters.filemaxx),filemaxy:h.parseFloat(e.status.parameters.filemaxy),imagetype:h.parseFloat(e.status.parameters.imagetype)};d&&d.setParameters({resolutionx:h.parseFloat(e.status.parameters.resolutionx),resolutiony:h.parseFloat(e.status.parameters.resolutiony),
sizex:h.parseFloat(e.status.parameters.sizex),sizey:h.parseFloat(e.status.parameters.sizey),imagetype:-1});var i={resolutionx:h.parseFloat(e.status.parameters.diffresx),resolutiony:h.parseFloat(e.status.parameters.diffresy),sizex:h.parseFloat(e.status.parameters.sizex),sizey:h.parseFloat(e.status.parameters.sizey),fileminx:h.parseFloat(e.status.parameters.diffminx),fileminy:h.parseFloat(e.status.parameters.diffminy),filemaxx:h.parseFloat(e.status.parameters.diffmaxx),filemaxy:h.parseFloat(e.status.parameters.diffmaxy)};
g.channel=[];i.channel=[];var k=[],l=[];void 0!==e.status.parameters.channel&&!j.isArray(e.status.parameters.channel)&&(e.status.parameters.channel=[e.status.parameters.channel]);j.each(e.status.parameters.channel,j.bind(function(a,b){a.serverID=b;void 0!==a.dmode||null!==a.dmode?(a.dmode=parseInt(a.dmode,10),isNaN(a.dmode)&&(a.dmode=null)):a.dmode=null;a.opaque=a.opaque?!0:!1;if(null===a.dmode||a.dmode===o.ChannelDiffMode.CURRENT||a.dmode===o.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS)g.channel.push(a),
a.dmode===o.ChannelDiffMode.IN_CURRENT_AND_MATCHED_WITH_PREVIOUS&&k.push(a);else if(a.dmode===o.ChannelDiffMode.PREVIOUS||a.dmode===o.ChannelDiffMode.IN_PREVIOUS_AND_MATCHED_WITH_CURRENT)i.channel.push(a),a.dmode===o.ChannelDiffMode.IN_PREVIOUS_AND_MATCHED_WITH_CURRENT&&l.push(a)},this));for(a=0;a<k.length;a++)k[a].matchedWith=l[a].serverID,l[a].matchedWith=k[a].serverID;void 0!==c&&(c.setParameters(i),c.setHasAnnotations(1==e.status.parameters.annotations.diffexists));void 0!==b&&(b.setHasAnnotations(1==
e.status.parameters.annotations.exists),b.setParameters(g));f&&f()}else this.f.debug.log("_fetchParameters returned dirty result")};k.prototype._fetchPageInfo=function(b,c){var d=this.WebCenter("getdocumentinfo.jsp",{docid:b.getDocument().getDocumentID(),docversionid:b.getDocumentVersion().getDocumentVersionID(),pageno:b.getPagenum()});this.f.ajax(d,{success:j.bind(function(d){var d=a.xml2obj(d),e=d.status.page;if(void 0!==e){b.set("margbot",d.status.page.margbot);b.set("margtop",d.status.page.margtop);
b.set("margleft",d.status.page.margleft);b.set("margright",d.status.page.margright);b.set("hsize",d.status.page.hsize);b.set("vsize",d.status.page.vsize);b.set("hasCorrectMargin",!0);b.set("pageno",d.status.page.pageno);b.set("offsetx",d.status.page.offsetx);b.set("offsety",d.status.page.offsety);void 0!==d.status.page.cadregedit&&(b.set("cadregedit",d.status.page.cadregedit),b.set("isCadAlignmentSaved",1==d.status.page.saved?!0:!1));if(e.metadata&&(e.metadata.design||e.metadata.layout)){var f=e.metadata.design||
e.metadata.layout;b.set("grainDirection",f.grain_direction);b.set("defaultSide",f.default_side);b.set("dieSide",f.die_side)}b.set("has3DPerspective","1"==d.status.page.has3DPerspective?!0:!1);b.set("canGenerate3D","1"==d.status.page.canGenerate3D?!0:!1)}b.isBlankPage()&&(e={sizex:h.parseFloat(e.hsize),sizey:h.parseFloat(e.vsize),filemaxx:h.parseFloat(e.hsize),filemaxy:h.parseFloat(e.vsize)},b.setHasAnnotations(!1),b.setParameters(e));c&&c(d)},this),error:j.bind(function(a,b,d){this.f.i18n.loadBundle("viewer",
function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,d)},this);c&&c()},this)})};k.prototype.getDeepCopy=function(a,b,f,g){var h=a._docVersion,k=h._doc;void 0===g&&(g=k.documentID);void 0===b&&(b=new e(this.f,void 0,g,a.documentType,this),b._data=i.extend(!0,{},k._data));g=f;void 0===g&&(g=new d(this.f,b,h._versionData.docversion,{docversionid:h._versionData.docversionid,docRevision:h._versionData.docRevision},void 0,this));h=new c(this.f,g,a._pagenum,void 0,void 0,this);
h._data=i.extend(!0,{},a._data);h._parameters=i.extend(!0,{},a._parameters);h._state=i.extend(!0,{},a._state);a._data.cadData&&(h._data.cadData=j.clone(a._data.cadData),a._data.cadData.cad&&(h._data.cadData.cad=new l(a._data.cadData.cad.cstyles,a._data.cadData.cad._xmlData)));h._state.compareOffset&&(h._state.compareOffset=a._state.compareOffset.copy());h.setReaderSpread(a.isReaderSpread());void 0===f&&b.addDocumentVersion(g);g.addPage(a.getPagenum(),h);return h};k.prototype.getPagesOfDocumentVersion=
function(b,c){var d=b.getDocument(),e=this.WebCenter("getdocumentinfo.jsp",{docid:d.getDocumentID(),docversionid:b.getDocumentVersionID()});this.f.ajax(e,{success:j.bind(function(b){b=a.xml2obj(b);j.each(b.status.page,j.bind(j.bind(function(a){d.addDocumentPageFromData(a)},this)));void 0!==c&&c()},this),error:j.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,c)},this)},this)})};k.prototype.getDocumentByDocId=
function(a){var b=j.find(this.f.getDocumentController().getAllDocuments(),function(b){return b.getDocumentID()===a});return b?b:j.find(this.f.getDocumentController().getLinkedDocuments(),function(b){return b.getDocumentID()===a})};k.prototype.loadVersionsOfDocumentPage=function(b,e,f,g){var h=this.WebCenter("getdocumentinfo.jsp",{docid:b.docid,docversionid:b.docversionid,diffversion:b.diffversion,pageno:b.pageNumber}),i=b.pageNumber,k=b.isPageList,l=b.isMultiPage;this.f.ajax(h,{success:j.bind(function(b){var b=
a.xml2obj(b),h=b.status.page.versionlist;void 0!==b.status.page&&void 0!==g&&(g.set("margbot",b.status.page.margbot),g.set("margtop",b.status.page.margtop),g.set("margleft",b.status.page.margleft),g.set("margright",b.status.page.margright),g.set("hasCorrectMargin",!0));if(void 0!==h){j.isArray(h)||(h=[h]);var n=[];j.each(h,j.bind(function(a){var b=e._documentVersions[parseInt(a.docversion,10)];void 0===b?(a.isPageList=k,a.isMultiPage=l,b=new d(this.f,e,parseInt(a.docversion,10),a,void 0,this),e._documentVersions[parseInt(a.docversion,
10)]=b):(b.set("docversionid",a.docversionid),b.set("isMultiPage","true"===a.isMultiPage));var f=new c(this.f,b,i,{file:a.file,versionNumber:a.docversion},void 0,this);b.addPage(i,f);n[a.docversion]=f},this));f(n)}},this),error:j.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("LoadingDocumentInfoError"),a,b,c)},this)},this)})};k.prototype.saveCadOverlay=function(b,c,d,e,f,g){if(b.canSaveCadOverlay()){var h=(4-d/90)%4;e&&(h+=4);var i;c&&(i=
c.get("docversionid"));c=b.getMargins();h=this.WebCenter("setcadalignment.jsp",{docversionid:b.get("docversionid"),cadversionid:i,cadorgx:f.x,cadorgy:f.y,cadorientation:h,hs:b.get("hsize"),vs:b.get("vsize"),ml:c.left,mt:c.top,mr:c.right,mb:c.bottom});this.f.ajax(h,{dataType:"xml",success:j.bind(function(c){var c=a.xml2obj(c),h="";if(c){if(c.status&&"0"===c.status.value){this.f.loadBundle("viewer",function(){this.f.emit("userMessage","success",this.f.t("SaveCadOverlaySuccess"),!0)},this);b.getLinkedPage()!==
this.f.getDocumentController().getCadOverlay()&&this.f.getDocumentController().createNewLinkedCadFromOverlay();(c=this.f.getDocumentController().getCadOverlay())?(c.set("offsetx",f.x),c.set("offsety",f.y),c.set("overlayRotation",d),c.set("overlayIsFlipped",e)):this.updateDocumentData(b,void 0,!0);g&&g(!0);return}"-1"===c.status&&(h=c.status.message)}this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed")+" "+h);g&&g(!1)},this),error:j.bind(function(){this.f.loadBundle("viewer",function(){this.f.emit("userMessage",
"warn",this.f.t("SaveCadOverlayFailed"))},this);g&&g(!1)},this)})}else this.f.emit("userMessage","warn",this.f.t("SaveCadOverlayFailed")),g&&g(!1)};k.prototype.show3DView=function(a){a=this.WebCenter("doctypecolladaview.jsp",{docVerID:a.get("docversionid"),sourcePage:"javascript:window.close()"});window.open(a,"_blank")};k.prototype.updateDocumentData=function(a,b,c){this._fetchPageInfo(a,j.bind(function(d){if(d.status.page.file&&d.status.page.cad&&a===this.f.getActivePage()){var d=d.status.page,
g=d.cadid,h=a.getLinkedPage();d.docid=d.cadid;d.docversionid=d.cadversionid;this.getDocumentByDocId(g)?(g=this.getDocumentByDocId(g).getDocumentVersion().getPage(),g!==h&&this.f.getDocumentController().createNewLinkedCadFromOverlay(c,g),(h=a.getLinkedPage())&&h.setPageAlignmentData(d)):(d=new e(this.f,d,this.f.getDocumentController().getNextIID(),f.documentPageType.CAD,this),this.f.getDocumentController().addNewLinkedDocument(d,c))}else a.getDocument().hasLinkedDocument()&&(a.getDocument().setLinkedDocumentPage(),
this.f.getDocumentController().changeCadOverlay());b&&b()},this))};return k});
define("web-viewer/webcenter/WebCenterConfig",["web-viewer/core/AbstractConfig","web-viewer/webcenter/WebCenterDataAdapter"],function(g,e){var d=function(c,d,b){g.call(this);this.modules=[];this.instance=c;this.user=b;this.viewserver=d};d.prototype=Object.create(g.prototype);d.prototype.constructor=d;d.prototype.addModule=function(c){this.modules.push(c)};d.prototype.intializeAdapter=function(c){return this.adapter=new e(c,this.instance,this.viewserver)};d.prototype.getUser=function(){return this.user};
d.prototype.getModules=function(){return this.modules};return d});
define("web-viewer/webcenter/WebCenterUser",["web-viewer/data/User","web-viewer/data/PreferencesConstants","web-viewer/data/PreferencesDefaults","web-viewer/data/DataConstants","web-viewer/core/CoreConstants"],function(g,e,d,c,f){var b=function(a,b,c,d,e,f){g.call(this,a,b,c,d,e);this.userIsAdmin=f;this.viewServerID=void 0};b.prototype=Object.create(g.prototype);b.prototype.constructor=b;b.prototype.getFullName=function(){var a=this.getLastName();this.first&&(a+=", "+this.first);return a+=" ("+this.getUsername().toUpperCase()+
")"};b.prototype.isAdmin=function(){return this.userIsAdmin};b.prototype.loadOptions=function(a){this.f.requestModule("featureDetector",_.bind(function(b){var c="";b.isMobile()&&(c="m");var b={name:this.getFullName(),address:window.screen.width+"x"+window.screen.height+c},d=this.f.getDataAdapter();d.ViewServer?(b=d.ViewServer("userid.jsp",b),this.f.ajax(b,{success:_.bind(function(b){var c=b.documentElement;"0"==(c.getElementsByTagName("value")[0].textContent||c.getElementsByTagName("value")[0].text)?
(this.viewServerID=c.getElementsByTagName("userid")[0].textContent||c.getElementsByTagName("userid")[0].text,b=d.ViewServer("getsettings.jsp",{userid:this.viewServerID}),this.f.ajax(b,{success:_.bind(function(b){var c=b.documentElement;"0"==(c.getElementsByTagName("value")[0].textContent||c.getElementsByTagName("value")[0].text)?(b=c.getElementsByTagName("settings")[0],this._handleSettings(b)):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),
c.getElementsByTagName("error")[0].textContent||c.getElementsByTagName("error")[0].text)},this),this.loadDefaultOptions());a()},this),error:_.bind(function(b,c,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),b,c,d)},this);this.loadDefaultOptions();a()},this)})):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),c.getElementsByTagName("error")[0]?c.getElementsByTagName("error")[0].textContent:
void 0)},this),this.loadDefaultOptions(),a())},this),error:_.bind(function(b,c,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),b,c,d)},this);this.loadDefaultOptions();a()},this)})):(this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsReadError"),"Adapter cannot connect to Viewserver")},this),this.loadDefaultOptions(),a())},this))};b.prototype.loadDefaultOptions=function(){this.setOptions(_.clone(d))};
b.prototype._handleSettings=function(a){for(var b=_.invert(e),g=_.clone(d),a=a.firstChild;a;){if(1==a.nodeType){var k=a.nodeName,l=a.getElementsByTagName("id")[0].textContent||a.getElementsByTagName("id")[0].text,i=a.getElementsByTagName("value")[0].textContent||a.getElementsByTagName("value")[0].text;"settingint"==k&&(i=parseInt(i,10));if("settingchar"==k||!_.contains(c.charsequencePreferences,b[l]))g[b[l]]=i}a=a.nextSibling}this.f.getUnits()===f.SizeUnits.INCH?(g.PREFERENCES_UNIT_SIZE=f.SizeUnits.INCH,
g.PREFERENCES_UNIT_RESOLUTION=f.ResolutionUnits.PPI,g.PREFERENCES_UNIT_SCREENRULING=f.ResolutionUnits.PPI):(g.PREFERENCES_UNIT_SIZE=f.SizeUnits.MM,g.PREFERENCES_UNIT_RESOLUTION=f.ResolutionUnits.PPCM,g.PREFERENCES_UNIT_SCREENRULING=f.ResolutionUnits.PPCM);this.initializeOptions(g)};b.prototype.persistOptions=function(a,b){var c=this.f.getDataAdapter();if(c.ViewServer){var d=document.implementation.createDocument("","settings",null);_.each(a,function(a,b){var c=d.createElementNS(null,_.isNumber(a)?
"settingint":"settingchar"),f=d.createElementNS(null,"id");f.textContent=e[b];var g=d.createElementNS(null,"value");g.textContent=a;c.appendChild(f);c.appendChild(g);d.documentElement.appendChild(c)});c=c.ViewServer("setsettings.jsp",{userid:this.viewServerID});this.f.ajax(c,{error:_.bind(function(a,c,d){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsWriteError"),a,c,d)},this);b&&b(!1)},this),success:function(){b&&b(!0)},processData:!1,contentType:"text/xml",
data:d,type:"POST"})}else this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("ServerSettingsWriteError"),"Adapter cannot connect to Viewserver")},this),b&&b(!1)};return b});
define("web-viewer/webcenter/WebCenterModule","web-viewer/webcenter/WebCenterConfig web-viewer/webcenter/WebCenterDataAdapter web-viewer/webcenter/WebCenterDocument web-viewer/webcenter/WebCenterDocumentPage web-viewer/webcenter/WebCenterDocumentVersion web-viewer/webcenter/WebCenterModule web-viewer/webcenter/WebCenterUser".split(" "),function(){});