define("web-viewer/annotation/AnnotationFilter",["underscore","web-viewer/core/PrivateChannel","web-viewer/annotation/AnnotationConstants"],function(c,h,g){var a=function(a,c){h.installTo(this,a,["annotationFilter"]);this._annotationFilterModel=c};a.prototype.filterAnnotations=function(a){var n=[];if(this._annotationFilterModel.isCustomFilterActive()&&a)return n=c.filter(a,c.bind(function(a){return this.compliesToCustomFilter(a)},this)),this._annotationFilterModel.setNumberOfFilteredAnnotations(n.length),
n;if(a){if(this._annotationFilterModel.getSelectedUser()||this._annotationFilterModel.getSelectedState())return n=c.filter(a,c.bind(function(a){return this.compliesToFilter(a)},this)),this._annotationFilterModel.setNumberOfFilteredAnnotations(n.length),n;this._annotationFilterModel.setNumberOfFilteredAnnotations(a.length);return a}this._annotationFilterModel.setNumberOfFilteredAnnotations(0);return[]};a.prototype.filterIncomingAnnotations=function(a){var n=this._annotationFilterModel.getViewerUserFilter();
if(0<n.length){var l=[];c.each(a,function(a){a.runThroughAnnotation(!0,!0,!0,c.bind(function(a){if(!c.some(n,function(m){return this._compliesToAuthor(a,m)},this)){if(a.inreplyto&&!a.state){var k=c.indexOf(a.parent.replies,a);a.parent.replies.splice(k,1);return!0}if(a.state&&a.parent)return k=c.indexOf(a.parent.states,a),a.parent.states.splice(k,1),!0;if(!a.parent||a.linkedto)return l.push(a),!0}return!1},this))},this);c.each(l,function(i){i=c.indexOf(a,i);a.splice(i,1)})}return a};a.prototype.compliesToFilter=
function(a){return this._compliesToUser(a)&&this._compliesToState(a)};a.prototype.compliesToCustomFilter=function(a){var n=this._annotationFilterModel.getFilterRows();if(this._annotationFilterModel.getFilterOperator()==g.FilterOperators.ALL)return c.every(n,function(c){return this._checkCustomFilterRule(a,c)},this);if(this._annotationFilterModel.getFilterOperator()==g.FilterOperators.ANY)return c.some(n,function(c){return this._checkCustomFilterRule(a,c)},this)};a.prototype._checkCustomFilterRule=
function(a,c){if(c.filterType==g.FilterTypes.AUTHOR)return c.filterCondition==g.FilterCondition.IS?this._compliesToUser(a,c.filterOption):!this._compliesToUser(a,c.filterOption);if(c.filterType==g.FilterTypes.REVIEWSTATE)return c.filterCondition==g.FilterCondition.IS?this._compliesToCustomFilterState(a,c.filterOption):!this._compliesToCustomFilterState(a,c.filterOption);if(c.filterType==g.FilterTypes.REVIEWAUTHORANDSTATE)return c.filterCondition==g.FilterCondition.IS?this._compliesToReviewAuthorAndState(a,
c.filterOption):!this._compliesToReviewAuthorAndState(a,c.filterOption)};a.prototype._compliesToUser=function(a,g){var l=!0;void 0===g&&(g=this._annotationFilterModel.getSelectedUser());g&&(l=!1,a.runThroughAnnotation(!0,!0,!0,c.bind(function(a){if(a.username==g)return l=!0},this)));return l};a.prototype._compliesToAuthor=function(a,c){return c&&a.username==c?!0:!1};a.prototype._compliesToReviewAuthorAndState=function(a,n){var l=!1;if(n){var i=c.invert(g.AnnotationReviewState);a.runThroughAnnotation(!0,
!0,!1,c.bind(function(a){if(l=c.some(a.states,c.bind(function(a){a=a.getUserName()+" "+i[a.state];return n===a},this)))return!0},this))}return l};a.prototype._compliesToState=function(a){var g=!0,l=this._annotationFilterModel.getSelectedState();l&&(g=!1,"Any"==l?a.runThroughAnnotation(!0,!this._annotationFilterModel.isInverseState(),!1,c.bind(function(a){g=0<a.states.length},this)):a.runThroughAnnotation(!0,!this._annotationFilterModel.isInverseState(),!1,c.bind(function(a){c.some(a.states,c.bind(function(a){return a.state==
l},this))&&(g=!0)},this)),this._annotationFilterModel.isInverseState()&&(g=!g));return g};a.prototype._compliesToCustomFilterState=function(a,h){var l=!1;a.runThroughAnnotation(!0,!0,!1,c.bind(function(a){c.some(a.states,c.bind(function(a){return a.state==g.AnnotationReviewState[h]},this))&&(l=!0)},this));return l};return a});
define("web-viewer/annotation/Annotation","web-viewer/utils/LineworkWrapper web-viewer/utils/LineworkPoint web-viewer/utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/StringSet web-viewer/annotation/AnnotationConstants underscore".split(" "),function(c,h,g,a,o,n,l,i,j,k){function m(b,e){var d=null;if(b.nodeType===Node.TEXT_NODE)d=e.createTextNode(b.textContent);else if(b.nodeType===Node.ELEMENT_NODE){d=e.createElement(b.nodeName.toLowerCase());
if(b.hasAttributes&&b.hasAttributes())for(var f=0;f<b.attributes.length;f++)d.setAttribute(b.attributes[f].name,b.attributes[f].value);if(b.hasChildNodes&&b.hasChildNodes())for(f=0;f<b.childNodes.length;f++){var a=m(b.childNodes[f],e);null!=a&&d.appendChild(a)}}return d}var f=function(b){c.call(this);this.f=b;this.creationdate=new Date;this.date=new Date;this.name=null;this.page=0;this.lastname=this.firstname=this.username=this.content=this.title=this.subject="";this.messagenumber=-1;this.parent=
this.annottype=null;this.replies=[];this.inreplyto=null;this.links=[];this.linkedto=null;this.saved=!1;this.isNew=!0;this.states=[];this.statemodel=this.state=null;this.flags="print";this.popuprect=new g.Rect;this.popuppage=0;this.popupIsOpen=!1;this.originalAnnotationColor=this.modifiedContent=this.unsavedReplyText=null;this._modifications=new i;this._scaling=null;this._override("setRect",function(b,d){this._super(b,d);this.setModified("LINEWORK")});this._override("move",function(b){this._super(b);
(0!==b.width||0!==b.height)&&this.setModified("LINEWORK")});this._override("setStartEnd",function(b,d){this._super(b,d);this.setModified("LINEWORK")})};f.prototype=Object.create(c.prototype);f.prototype.constructor=f;f.prototype.getPermission=function(){return this.f.getCurrentUser().getUsername()==this.username?j.AccessRight.READ_WRITE:j.AccessRight.READ_ONLY};f.prototype.getSortByAttr=function(){return this.content};f.prototype.getOutliningRect=function(){var b=k.union(this.links,[this]),e=k.min(b,
function(d){return d.rect.left()}).rect.left(),d=k.max(b,function(d){return d.rect.top()}).rect.top(),f=k.max(b,function(d){return d.rect.right()}).rect.right(),b=k.min(b,function(d){return d.rect.bottom()}).rect.bottom();return new g.Rect(new g.Point(e,d),new g.Size(f-e,b-d))};f.prototype.getIconClass=function(){return j.AnnotationIcons[this.annottype]};f.prototype.isAnnotationModified=function(){return 0===this.date-this.creationdate};f.prototype.initAnnotation=function(b,e,d,f,a){if(!this.name||
0===this.name.length)void 0===f?this.f.emit("error.SEVERE","Problem initializing annotation","No model specified for generating unique name!"):this.name=f.generateUniqueName();a||(a=new g.Rect);this.rect=a;f&&(this._scaling=f.getCurrentScaling());e||(e=this.annotationcolor);this.annotationcolor=this.originalAnnotationColor=e;null===this.annotationcolor&&(this.annotationColor=this._getDefaultAnnotationColor(b));this.color=e;this.annottype=b;this.setSelected(d);if(!this.subject||0===this.subject.length)this.subject=
(null!=this.inreplyto?"Re: ":"")+j.AnnotationReplyName[this.annottype];switch(b){case j.AnnotationType.ANNOT_RECT:this.color=e;this.type=l.LWTYPE_RECT;break;case j.AnnotationType.ANNOT_ELLIPSE:this.color=e;this.type=l.LWTYPE_ELLIPSE;break;case j.AnnotationType.ANNOT_HIGHLIGHT:this.type=l.LWTYPE_RECT;this.treatAsOutline=!0;this.color=null;break;case j.AnnotationType.ANNOT_LINE:this.type=l.LWTYPE_LINE;this.color=e;this.pointArray[0]=new h;this.pointArray[0].makeMoveTo(this.rect.origin.x,this.rect.origin.y);
this.pointArray[1]=new h;this.pointArray[1].makeLineTo(this.rect.origin.x+this.rect.size.width,this.rect.origin.y+this.rect.size.height);break;case j.AnnotationType.ANNOT_ARROW:this.type=l.LWTYPE_ARROW;this.color=e;this.pointArray[0]=new h;this.pointArray[0].makeMoveTo(this.rect.origin.x,this.rect.origin.y);this.pointArray[1]=new h;this.pointArray[1].makeLineTo(this.rect.origin.x+this.rect.size.width,this.rect.origin.y+this.rect.size.height);break;case j.AnnotationType.ANNOT_PIN:this.type=l.LWTYPE_IMAGE;
this.imagehotspot=new g.Point(j.AnnotationPin.imagehotspotx,j.AnnotationPin.imagehotspoty);this.imagetouchspot=new g.Rect(new g.Point(j.AnnotationPin.imagetouchspotx,j.AnnotationPin.imagetouchspoty),new g.Size(j.AnnotationPin.imagetouchspotw,j.AnnotationPin.imagetouchspoth));break;case j.AnnotationType.ANNOT_FREEFORM:this.type=l.LWTYPE_LINEARRAY,this.color=e}};f.prototype.initWithXML=function(b){this.saved=!0;this.isNew=!1;this.pointArray=[];this.name=a.attributeValue(b,"name");this.subject=a.attributeValue(b,
"subject");this.title=a.attributeValue(b,"title");this.flags=a.attributeValue(b,"flags");var e=/((\d+)\s)?(.+)/.exec(this.title);if(e){this.messagenumber=e[2];void 0===this.messagenumber&&(this.messagenumber=-1);var d=/([^,]+)(,\s(.+))?\s\((.+)\)/.exec(e[3]);d?(this.username=d[4],this.lastname=d[1],this.firstname=d[3]||""):(this.username=e[3],this.firstname=this.lastname="")}this.messagenumber=parseInt(this.messagenumber,10);this.page=a.attributeValue(b,"page");this.date=o.dateFromString(a.attributeValue(b,
"date"));this.creationdate=o.dateFromString(a.attributeValue(b,"creationdate"));this.state=a.attributeValue(b,"state");this.statemodel=a.attributeValue(b,"statemodel");e=b.getElementsByTagName("contents-richtext");this.content="<p></p>";0<e.length&&((d=e[0].getElementsByTagName("body")[0])||(d=e[0]),"undefined"!=typeof window.XMLSerializer?this.content=(new XMLSerializer).serializeToString(d):"undefined"!=typeof d.xml&&(this.content=d.xml));if(e=a.attributeValue(b,"inreplyto"))this.inreplyto=e;if(e=
a.attributeValue(b,"linkedto"))this.linkedto=e;var e=RegExp(/(.+),(.+),(.+),(.+)/),f=e.exec(a.attributeValue(b,"rect")),d=n.convertPSPointsToMM(f[1]),m=n.convertPSPointsToMM(f[2]),k=n.convertPSPointsToMM(f[3]),f=n.convertPSPointsToMM(f[4]);switch(b.nodeName){case "square":this.initAnnotation(j.AnnotationType.ANNOT_RECT);break;case "circle":this.initAnnotation(j.AnnotationType.ANNOT_ELLIPSE);break;case "highlight":this.initAnnotation(j.AnnotationType.ANNOT_HIGHLIGHT);break;case "text":this.rect.size.width=
0;this.rect.size.height=0;this.initAnnotation(j.AnnotationType.ANNOT_PIN);break;case "ink":this.initAnnotation(j.AnnotationType.ANNOT_FREEFORM);if(!this.inreplyto){var c=b.getElementsByTagName("inklist")[0];if(c){for(var c=c.getElementsByTagName("gesture")[0],i="",l=0;l<c.childNodes.length;l++)i+=c.childNodes[l].nodeValue;i=i.split(";");c=new h;l=i[0].split(",");c.makeMoveTo(n.convertPSPointsToMM(l[0]),n.convertPSPointsToMM(l[1]));this.pointArray.push(c);for(c=1;c<i.length;c++){var u=new h,l=i[c].split(",");
if(void 0!==l[0]&&void 0!==l[1]){var w=n.convertPSPointsToMM(l[0]),l=n.convertPSPointsToMM(l[1]);u.makeLineTo(w,l);this.pointArray.push(u)}else this.f.emit("error.DEBUG","chunkpoint[0] || chunkpoint[1] is undefined...")}this.calculateRectFromPointArray()}}break;case "line":(c=a.attributeValue(b,"subject"))&&"Arrow"==c?this.initAnnotation(j.AnnotationType.ANNOT_ARROW):this.initAnnotation(j.AnnotationType.ANNOT_LINE),this.inreplyto||(i=RegExp(/(.+),(.+)/),c=a.attributeValue(b,"start"),l=a.attributeValue(b,
"end"),c=i.exec(c),w=i.exec(l),i=n.convertPSPointsToMM(c[1]),u=n.convertPSPointsToMM(c[2]),l=n.convertPSPointsToMM(w[1]),w=n.convertPSPointsToMM(w[2]),c=new h,c.makeMoveTo(i,u),i=new h,i.makeLineTo(l,w),this.pointArray[0]=c,this.pointArray[1]=i,c=new g.Point(c.x,c.y),i=new g.Point(i.x,i.y),this.rect=new g.Rect(c,c.sizeTo(i)),this.rect.normalize())}this.rect.origin.x=d;this.rect.origin.y=f;this.rect.size.width=k-d;this.rect.size.height=m-f;d=a.attributeValue(b,"color");/^#?[a-f\d]{6}$/i.test(d)||(d=
this._getDefaultAnnotationColor(this.annottype));this.annotationcolor=this.originalAnnotationColor=this.color=d;b=b.getElementsByTagName("popup")[0];this.popuppage=a.attributeValue(b,"page");this.popupIsOpen="yes"==a.attributeValue(b,"open");m=e.exec(a.attributeValue(b,"rect"));b=n.convertPSPointsToMM(m[1]);e=n.convertPSPointsToMM(m[2]);d=n.convertPSPointsToMM(m[3]);m=n.convertPSPointsToMM(m[4]);this.popuprect.origin.x=b;this.popuprect.origin.y=e;this.popuprect.size.width=d-b;this.popuprect.size.height=
m-e};f.prototype.duplicate=function(b,e,d,a,m){var c=new f(this.f);d?(c.initAnnotation(this.annottype,this.annotationcolor,!0,m),c.content=k.clone(this.content)):(k.each(this,function(d,b){c[b]=d}),c.modifiedContent=null,c.rect&&(c.rect=c.rect.copy()),c.popuprect&&(c.popuprect=c.popuprect.copy()));c.isNew=!0;c.name=m.generateUniqueName();b||(c.replies=[]);e||(c.states=[]);d?(b=this.inreplyto?this.parent:this,c.pointArray=[],k.each(b.pointArray,function(d){c.pointArray.push(k.clone(d))}),c.color=k.clone(b.color),
c.rect=b.rect.copy(),c.popuprect=b.popuprect.copy()):c.pointArray=[];a?(c.links=[],k.each(this.links,function(d){d=d.duplicate(!1,!1,!0,!1,m);d.linkedto=c.name;d.parent=c;c.links.push(d)})):c.links=[];return c};f.prototype.needsSelectionBox=function(){return this.annottype!=j.AnnotationType.ANNOT_PIN};f.prototype.setSelected=function(b){this.linewidth=(this.selected=b)?3:2;this.annottype===j.AnnotationType.ANNOT_HIGHLIGHT&&(this.fillcolor="rgba(255, 255, 0, "+(b?".8":".3")+")");this.annottype===j.AnnotationType.ANNOT_PIN&&
(this.imageRef=b?j.AnnotationPin.highlighted:j.AnnotationPin.normal)};f.prototype.updateIndicator=function(){this.indicatorText=""+this.messagenumber;this.linkedto?this.parent&&(this.indicatorText+="-"+(k.indexOf(this.parent.links,this)+2)):0<this.getGodfather().links.length&&(this.indicatorText+="-1");this.indicatorTextColor=this.getHeaderTextColor();this.indicatorColor=this.annotationcolor};f.prototype.getUserName=function(){return this.firstname?this.lastname+", "+this.firstname+" ("+this.username+
")":this.lastname+" ("+this.username+")"};f.prototype.rgbColor=function(){var b=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(this.annotationcolor);return b?{r:parseInt(b[1],16),g:parseInt(b[2],16),b:parseInt(b[3],16)}:null};f.prototype.getHeaderTextColor=function(){var b=this.rgbColor();return 0.5<0.3*(b.r/255)+0.59*b.g/255+0.11*b.b/255?"black":"white"};f.prototype.setModified=function(b){this._modifications.add(b);this.saved=0===this._modifications.size();this.date=new Date};f.prototype.setIsNew=
function(b){this.isNew=b};f.prototype.cancelModified=function(b){"CONTENT"===b&&(this.modifiedContent=null);void 0!==b?this._modifications.remove(b):this._modifications.clear();this.saved=0===this._modifications.size()};f.prototype.setBeingModified=function(b){void 0===b&&(b=null);this.modifiedContent!==b&&(this._modifications.add("CONTENT"),this.modifiedContent=b,this.saved=!1)};f.prototype.isBeingModified=function(){return!this.saved};f.prototype._runThroughAnnotation=function(b,e,d,f){if(e){var a=
k.clone(b.replies);k.each(a,k.bind(function(b){f(b)||this._runThroughAnnotation(b,e,d,f)},this))}d&&(b=k.clone(b.states),k.each(b,k.bind(function(b){f(b)||this._runThroughAnnotation(b,e,d,f)},this)))};f.prototype.runThroughAnnotation=function(b,e,d,f){(!b||!f(this))&&this._runThroughAnnotation(this,e,d,f)};f.prototype.toXML=function(b){var e=b.createElementNS(null,j.AnnotationElementName[this.annottype]);this.isNew&&!this.linkedto?e.setAttribute("title",this.getUserName()):e.setAttribute("title",
this.messagenumber+" "+this.getUserName());(!this.name||0===this.name.length)&&this.f.emit("error.SEVERE","Trying to convert an annotation without a name to XML");e.setAttribute("name",this.name);e.setAttribute("color",this.annotationcolor);e.setAttribute("creationdate",o.stringFromDate(this.creationdate));e.setAttribute("date",o.stringFromDate(this.date));e.setAttribute("flags",this.flags);e.setAttribute("page",this.page);var d=this.rect;this._scaling&&(d=new g.Rect(new g.Point(1*this.rect.origin.x/
this._scaling.x,1*this.rect.origin.y/this._scaling.y),new g.Size(1*this.rect.size.width/this._scaling.x,1*this.rect.size.height/this._scaling.y)));e.setAttribute("rect",o.rectToString(d));e.setAttribute("subject",this.subject);this.state&&e.setAttribute("state",this.state);this.statemodel&&e.setAttribute("statemodel",this.statemodel);this.inreplyto&&e.setAttribute("inreplyto",this.inreplyto);this.linkedto&&e.setAttribute("linkedto",this.linkedto);if(!this.inreplyto)if(j.AnnotationType.ANNOT_FREEFORM==
this.annottype){for(var f=b.createElementNS(null,"inklist"),d=b.createElementNS(null,"gesture"),a="",c=0;c<this.pointArray.length;c++){var k=this.pointArray[c];0!==c&&(a+=";");a=this._scaling?a+(n.convertMMToPSPoints(1*k.x/this._scaling.x)+","+n.convertMMToPSPoints(1*k.y/this._scaling.y)):a+(n.convertMMToPSPoints(k.x)+","+n.convertMMToPSPoints(k.y))}d.textContent=a;f.appendChild(d);e.appendChild(f)}else if(j.AnnotationType.ANNOT_LINE==this.annottype||j.AnnotationType.ANNOT_ARROW==this.annottype)c=
this.pointArray[0],f=this.pointArray[1],d=this._scaling?new g.Rect(new g.Point(1*d.origin.x/this._scaling.x,1*d.origin.y/this._scaling.y),new g.Size(1*d.size.width/this._scaling.x,1*d.size.height/this._scaling.y)):new g.Rect(new g.Point(c.x,f.y),new g.Size(f.x-c.x,c.y-f.y)),e.setAttribute("rect",o.rectToString(d)),d=n.convertMMToPSPoints(c.x)+","+n.convertMMToPSPoints(c.y),a=n.convertMMToPSPoints(f.x)+","+n.convertMMToPSPoints(f.y),this._scaling&&(d=n.convertMMToPSPoints(1*c.x/this._scaling.x)+","+
n.convertMMToPSPoints(1*c.y/this._scaling.y),a=n.convertMMToPSPoints(1*f.x/this._scaling.x)+","+n.convertMMToPSPoints(1*f.y/this._scaling.y)),e.setAttribute("start",d),e.setAttribute("end",a),this.annottype==j.AnnotationType.ANNOT_ARROW&&(e.setAttribute("head","None"),e.setAttribute("tail","OpenArrow"));if(!this.linkedto||this.statemodel){f=b.createElement("contents-richtext");null!==this.modifiedContent&&(this.content=this.modifiedContent);if(this.content)if(d=this._parseMarkupToXMLDocument(this.content),
c=d.getElementsByTagName("body")[0])f.appendChild(m(c,b));else{a=b.createElement("body");if(d.hasChildNodes&&d.hasChildNodes())for(c=0;c<d.childNodes.length;c++)k=m(d.childNodes[c],b),null!=k&&a.appendChild(k);f.appendChild(a)}e.appendChild(f)}0===this.popuprect.origin.x&&0===this.popuprect.origin.y&&(this.popuprect.origin.x=this.rect.right(),this.popuprect.origin.y=this.rect.top());b=b.createElementNS(null,"popup");b.setAttribute("rect",o.rectToString(this.popuprect));b.setAttribute("page",this.popuppage);
b.setAttribute("open",this.popupIsOpen?"yes":"no");e.appendChild(b);return e};f.prototype._parseMarkupToXMLDocument=function(b){b=b.replace(/\&nbsp;/g," ");try{if((new DOMParser).parseFromString("","text/html")){var e=(new DOMParser).parseFromString(b,"text/html");if(e&&e.documentElement)return e.documentElement}}catch(d){}var e=document.implementation.createHTMLDocument(""),f=/<body>(.*)<\/body>/.exec(b);f&&1<=f.length&&(b=f[1]);(f=/<html>(.*)<\/html>/.exec(b))&&1<=f.length&&(b=f[1]);e.body.innerHTML=
b;return e.documentElement};f.prototype.getUserStateAnnotation=function(b){return k.find(this.states,function(e){return e.username===b})};f.prototype.getStringContent=function(b){var e=this.content.replace(/<([^<]*)>/g,"").trim();b&&e.length>b&&(e=e.substring(0,b)+"...");return e};f.prototype.setColor=function(b){null===b&&(b=this._getDefaultAnnotationColor(this.annottype));this.runThroughAnnotation(!0,!0,!0,function(d){d.annotationcolor!=b&&(d.annotationcolor=b,d.color=b,d.setModified("COLOR"))});
var e=this.getGodfather();k.each(e.links,function(d){d.annotationcolor!=b&&(d.annotationcolor=b,d.color=b,d.setModified("COLOR"))})};f.prototype.cancelModifiedColor=function(){this.cancelModified("COLOR");this.runThroughAnnotation(!0,!0,!0,function(b){b.cancelModified("COLOR")});var b=this.getGodfather();k.each(b.links,function(b){b.cancelModified("COLOR")})};f.prototype.resetAnnotationColor=function(){this.originalAnnotationColor&&this.setColor(this.originalAnnotationColor)};f.prototype.getGodfather=
function(){for(var b=this;b.parent;)b=b.parent;return b};f.prototype.getType=function(){return this.annottype};f.prototype.setUnsavedReply=function(b){this.setModified("REPLY");this.unsavedReplyText=b;""===b&&this.cancelModified("REPLY")};f.prototype.resetUnsavedReply=function(){this.unsavedReplyText=null;this.cancelModified("REPLY")};f.prototype.getUnsavedReply=function(){return this.unsavedReplyText};f.prototype.hasUnsavedReply=function(){return null!==this.unsavedReplyText&&""!==this.unsavedReplyText};
f.prototype.isStateObject=function(){return null!==this.state};f.prototype.setScale=function(b){this.scale(b);this._scaling=b};f.prototype.isScaled=function(){return null!==this._scaling&&void 0!==this._scaling};f.prototype.getScale=function(){return this._scaling};f.prototype._getDefaultAnnotationColor=function(b){return b==j.AnnotationType.ANNOT_PIN?this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR"):this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};return f});
define("web-viewer/annotation/AnnotationFilterModel2",["web-viewer/core/PrivateChannel","web-viewer/annotation/AnnotationConstants","web-viewer/core/AbstractModel"],function(c,h,g){c=function(a){g.call(this,a,"annotationFilterModel");this.f=a;this._filterRows=[];this._filterOperator=h.FilterOperators.ALL;this._isCustomFilterEnabled=!1;this._selectedState=this._selectedUser=null;this._inverseState=!1;this._numberOfFilteredAnnotations=0;this._viewerUserFilter=(a=this.f.getProperty("showuser"))?a.split("|"):
[];(this._annotationFilterPinnedState=void 0!==this.f.getOption("ANNOTATION_FILTER")&&""!==this.f.getOption("ANNOTATION_FILTER"))&&this.setFilterState(this.f.getOption("ANNOTATION_FILTER"))};c.prototype.resetFilter=function(){this._selectedState=this._selectedUser=null;this._inverseState=!1;this._filterRows=[];this._filterRows.push(this.getDefaultFilterRow());this._filterOperator=h.FilterOperators.ALL;this._isCustomFilterEnabled=!1;this._numberOfFilteredAnnotations=0;this._emit("filterReset",this);
this._emit("filterChanged",this)};c.prototype.setSelectedUser=function(a){this._selectedUser=a;this._isCustomFilterEnabled=!1;this._emit("filterChanged",this);this.fireFilterStateChanged()};c.prototype.getSelectedUser=function(){return this._selectedUser};c.prototype.setSelectedState=function(a,c){this._selectedState=a;this._inverseState=c;this._isCustomFilterEnabled=!1;this._emit("filterChanged",this);this.fireFilterStateChanged()};c.prototype.getSelectedState=function(){return this._selectedState};
c.prototype.isInverseState=function(){return this._inverseState};c.prototype.addFilterRow=function(a,c,g,l){this._filterRows[a]={filterId:a,filterType:c,filterCondition:g,filterOption:l}};c.prototype.addEmptyRow=function(){this._filterRows.push(this.getDefaultFilterRow());this._emit("filterChanged",this);return this._filterRows.length-1};c.prototype.updateFilterType=function(a,c,g){this._filterRows[a]&&(this._filterRows[a].filterType=c,this._filterRows[a].filterOption=g,this._emit("filterChanged",
this))};c.prototype.updateFilterOption=function(a,c){this._filterRows[a]&&(this._filterRows[a].filterOption=c,this._emit("filterChanged",this))};c.prototype.updateFilterCondition=function(a,c){this._filterRows[a]&&(this._filterRows[a].filterCondition=c,this._emit("filterChanged",this))};c.prototype.removeFilterRow=function(a){delete this._filterRows[a];this._emit("filterChanged",this)};c.prototype.removeAllFilterRows=function(){this._filterRows=[];this._emit("filterChanged",this)};c.prototype.getFilterRow=
function(a){return this._filterRows[a]};c.prototype.getFilterRows=function(){0===this._filterRows.length&&this._filterRows.push(this.getDefaultFilterRow());return _.without(this._filterRows,null,void 0)};c.prototype.setFilterRows=function(a){this._filterRows=a;this._emit("filterChanged",this)};c.prototype.getDefaultFilterRow=function(){return{filterId:this._filterRows.length,filterType:h.FilterTypes.REVIEWSTATE,filterCondition:h.FilterCondition.IS,filterOption:"STATUS_ACCEPTED"}};c.prototype.setCustomFilterActive=
function(a){(this._isCustomFilterEnabled=a)&&0===this._filterRows.length&&this._filterRows.push(this.getDefaultFilterRow());this._emit("filterChanged",this)};c.prototype.isCustomFilterActive=function(){return this._isCustomFilterEnabled};c.prototype.setFilterOperator=function(a){this._filterOperator=a;this._emit("filterChanged",this)};c.prototype.getFilterOperator=function(){return this._filterOperator};c.prototype.setNumberOfFilteredAnnotations=function(a){this._numberOfFilteredAnnotations=a};c.prototype.getNumberOfFilteredAnnotations=
function(){return this._numberOfFilteredAnnotations};c.prototype.isAnnotationFilterPinned=function(){return this._annotationFilterPinnedState};c.prototype.toggleAnnotationPinnedState=function(a){(this._annotationFilterPinnedState=void 0!==a?a:!this._annotationFilterPinnedState)?this.fireFilterStateChanged():this._emit("filterStateChanged",!1)};c.prototype.getFilterState=function(){var a={customFilterOperator:this._filterOperator,customFilterRows:_.compact(this._filterRows),isCustomFilterActive:this.isCustomFilterActive(),
selectedUser:this._selectedUser,selectedState:this._selectedState,inverseState:this._inverseState};return JSON.stringify(a)};c.prototype.setFilterState=function(a){if(a=$.parseJSON(a))this._isCustomFilterEnabled=a.isCustomFilterActive,this._filterOperator=a.customFilterOperator,this._filterRows=a.customFilterRows,_.each(this._filterRows,function(a,c){a.filterId=c},this),this._selectedUser=a.selectedUser,this._selectedState=a.selectedState,this._inverseState=a.inverseState;this._emit("filterChanged",
this)};c.prototype.fireFilterStateChanged=function(){this._emit("filterStateChanged",!0)};c.prototype.getViewerUserFilter=function(){return this._viewerUserFilter};return c});
define("web-viewer/annotation/AnnotationModel","web-viewer/core/PrivateChannel web-viewer/annotation/AnnotationFilter web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/annotation/AnnotationFilterModel2 web-viewer/utils/ShapeUtils web-viewer/utils/ListenerUtil web-viewer/utils/ViewerUtils web-viewer/layout/component/ModalPopup web-viewer/layout/component/ToolbarButton web-viewer/layout/LayoutConstants web-viewer/utils/OrderedObject underscore".split(" "),function(c,
h,g,a,o,n,l,i,j,k,m,f,b){var e=function(d,e){c.installTo(this,d,["annotationModel",e]);l.mixin(this,d);this.f=d;this._disabledReasons=new f;this._page=null;this._annotations=[];this._removedannotations=[];this._selectedAnnotations=[];this._filteredAnnotations=[];this._layoutType=null;this._annotationFilterModel=new o(this.f);this._orderedAnnotations=[];this._currentAnnotationIndex=-1;this._currentScaling=null;this.lockSelection=!1;this._disabledReasonChangedListener=this._addAnnotationsEnabledListener=
null;this._isSavingAnnotations=this._annotationListVisible=!1;var m=d.getCurrentUser();m.on("options.changed.PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",b.bind(function(){this.modelChanged()},this));m.on("options.changed.PREFERENCES_ANNOTATION_NEXT_MODE",b.bind(function(){this._orderedAnnotations.length=0;this.modelChanged()},this));m.on("options.changed.PREFERENCES_ANNOTATION_DATESORT_MODE",b.bind(function(d,b){this.setSortingMode(b)},this));m.on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",
b.bind(function(){this.modelChanged()},this));this.setSortingMode(d.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE"));this._canChangeAnnotations=!0;this._annotationmode=a.annotateMode.NO_RESTRICTIONS;d.getProperty("annotationmode")&&(this._annotationmode=parseInt(d.getProperty("annotationmode"),10));this._allowedAnnotators=a.allowedAnnotators.ALL;d.getProperty("annotatorsmode")&&(this._allowedAnnotators=parseInt(d.getProperty("annotatorsmode"),10));this.editabilityDependsOnApproval()&&(this._canChangeAnnotations=
!1,d.loadBundle("viewer",function(){this.setDisableReason("LOADING_APPROVAL",this.f.t("Loading"))},this));this._confirmedOnce=this._warnWhenChangingAnnotations=!1;this._filter=new h(d,this._annotationFilterModel);this._annotationFilterModel.on("filterChanged",b.bind(function(){this._filterAllAnnotations()},this));this._temporarilyDisabled={isTemporarilyDisabled:!1,reason:"",enableAnnotationToggling:!1,showingCurrentAnnotations:!1,showingDifferenceAnnotations:!1}};e.prototype.setAnnotationListVisible=
function(d){this._annotationListVisible!==d&&(this._annotationListVisible=d,this._emit("annotationListVisible",d))};e.prototype.isAnnotationListVisible=function(){return this._annotationListVisible};e.prototype.currentOrdening=function(){return this.orderByCreationDate};e.prototype.toggleVisibility=function(d){if(void 0===d)d=1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"),d=!d;else if(d&&1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"))return;d?this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",
1):(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",0),this.unselectAllAnnotations());this.modelChanged()};e.prototype.temporarilyDisable=function(d,b,e,f){this._temporarilyDisabled.isTemporarilyDisabled=d;this._temporarilyDisabled.reason=e;this._temporarilyDisabled.enableAnnotationToggling=b;this.unselectAllAnnotations();void 0!==f?("difference"==f?this.showTemporarilyDifferencePageAnnotations():"current"==f&&this.showTemporarilyActivePageAnnotations(),this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",
1,!0)):(this._temporarilyDisabled.showingCurrentAnnotations=!1,this._temporarilyDisabled.showingDifferenceAnnotations=!1);this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");d||(this.setPage(this.f.getActivePage()),this._temporarilyDisabled.showingCurrentAnnotations=!0);this.modelChanged()};e.prototype.updateTemporarilyDisabledReason=function(){this.f.loadBundle("viewer",function(){this.isTemporarilyDisabled()&&!this.isTemporarilyCurrentPageAnnotationsShown()?(this.setDisableReason("TEMPORARY_DISABLE",
this._temporarilyDisabled.reason),this.isTemporarilyDifferencePageAnnotationsShown()&&this.setDisableReason("TEMPORARY_DISABLE",this.f.t("AnnDisabledDiffMode"))):this.removeDisableReason("TEMPORARY_DISABLE")},this)};e.prototype.isTemporarilyDisabledAndNoAnnotationsVisible=function(){return this._temporarilyDisabled.isTemporarilyDisabled&&!this._temporarilyDisabled.showingCurrentAnnotations&&!this._temporarilyDisabled.showingDifferenceAnnotations||!this.isAllowedToShowAnnotations()};e.prototype.isTemporarilyDisabled=
function(){return this._temporarilyDisabled.isTemporarilyDisabled};e.prototype.isTemporarilyDisabledAndCannotEdit=function(){return this._temporarilyDisabled.isTemporarilyDisabled&&!this._temporarilyDisabled.showingCurrentAnnotations||!this.isAllowedToShowAnnotations()};e.prototype.getTemporarilyDisabledMessage=function(){return this._temporarilyDisabled.reason};e.prototype.isTemporarilyCurrentPageAnnotationsShown=function(){return this._temporarilyDisabled.showingCurrentAnnotations&&this.isAllowedToShowAnnotations()};
e.prototype.isTemporarilyDifferencePageAnnotationsShown=function(){return this._temporarilyDisabled.showingDifferenceAnnotations&&this.isAllowedToShowAnnotations()};e.prototype.isTemporarilyAnnotationDocumentTogglingEnabled=function(){return this._temporarilyDisabled.enableAnnotationToggling&&this.isAllowedToShowAnnotations()};e.prototype.isAllowedToShowAnnotations=function(){return!b.some(this._disabledReasons.getItemsAsObject(),function(d){return d.hideAnnotations})};e.prototype.showTemporarilyDifferencePageAnnotations=
function(){if(this.isAllowedToShowAnnotations()){var d=this.f.getDocumentController().getDifferencePage();this.unselectAllAnnotations();this._temporarilyDisabled.showingDifferenceAnnotations=!0;this._temporarilyDisabled.showingCurrentAnnotations=!1;this.updateTemporarilyDisabledReason();this.setPage(d,b.bind(function(){this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()},this))}};e.prototype.showTemporarilyActivePageAnnotations=function(){if(this.isAllowedToShowAnnotations()){var d=
this.f.getActivePage();this.unselectAllAnnotations();this.setPage(d,b.bind(function(){this._temporarilyDisabled.showingDifferenceAnnotations=!1;this._temporarilyDisabled.showingCurrentAnnotations=!0;this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()},this))}};e.prototype.hideTemporarilyAnnotations=function(){this._temporarilyDisabled.showingDifferenceAnnotations=!1;this._temporarilyDisabled.showingCurrentAnnotations=!1;this.setPage(this.f.getDocumentController().getActivePage());
this.updateTemporarilyDisabledReason();this._emit("temporarilyDisableChanged");this.modelChanged()};e.prototype.getAnnotationsPage=function(){return this._page};e.prototype.editabilityDependsOnApproval=function(){return this._annotationmode===a.annotateMode.IF_APPROVED_SHOW_WARNING||this._annotationmode===a.annotateMode.IF_APPROVED_DISABLE||this._annotationmode===a.annotateMode.IF_APPROVED_OR_REJECTED_SHOW_WARNING||this._annotationmode===a.annotateMode.IF_APPROVED_OR_REJECTED_DISABLE||this._allowedAnnotators!==
a.allowedAnnotators.ALL||this._annotationmode===a.annotateMode.ALWAYS_DISABLE};e.prototype.canChangeAnnotations=function(d){return this.isTemporarilyDisabledAndCannotEdit()||this._page&&!this._page.getDocumentVersion().isLatestVersion()||!this._canChangeAnnotations?!1:!this._confirmedOnce&&this._warnWhenChangingAnnotations&&!d?(d=this._page.isApproved()?"AnnAlreadyApproved":"AnnAlreadyRejected",this._confirmedOnce=confirm(this.f.i18n.t(d))):!0};e.prototype.canChangeAnnotation=function(d){if(this.isTemporarilyDisabledAndCannotEdit()||
this._page&&!this._page.getDocumentVersion().isLatestVersion())return!1;var b=a.AccessRight.READ_ONLY;this._canChangeAnnotations&&(b=d.getPermission());return b==a.AccessRight.READ_WRITE};e.prototype.canDeleteAnnotation=function(d){return this.f.getProperty("annotationblockdeletesaved")&&!d.isNew?!1:this.canChangeAnnotation(d)};e.prototype.updateApprovalInfo=function(){this._page&&this.f.loadBundle("viewer",function(){var d=this._canChangeAnnotations;this._canChangeAnnotations=!0;this._warnWhenChangingAnnotations=
!1;var e="";if(this._annotationmode===a.annotateMode.ALWAYS_DISABLE)this._canChangeAnnotations=!1,e=this.f.t("AnnDisabled");else if(this._page.isApproved()&&(this._annotationmode===a.annotateMode.IF_APPROVED_SHOW_WARNING?this._warnWhenChangingAnnotations=this._canChangeAnnotations=!0:this._annotationmode===a.annotateMode.IF_APPROVED_DISABLE&&(this._warnWhenChangingAnnotations=this._canChangeAnnotations=!1,e=this.f.t("AnnAlreadyApprovedBlocked"))),this._page.isApproved()||this._page.isRejected())this._annotationmode===
a.annotateMode.IF_APPROVED_OR_REJECTED_SHOW_WARNING?this._warnWhenChangingAnnotations=this._canChangeAnnotations=!0:this._annotationmode===a.annotateMode.IF_APPROVED_OR_REJECTED_DISABLE&&(this._warnWhenChangingAnnotations=this._canChangeAnnotations=!1,e=this._page.isApproved()?this.f.t("AnnAlreadyApprovedBlocked"):this.f.t("AnnAlreadyRejectedBlocked"));this._canChangeAnnotations&&this._page.isUnderApproval()&&this._allowedAnnotators!==a.allowedAnnotators.ALL&&(this._allowedAnnotators===a.allowedAnnotators.ALL_APPROVERS?
this._page.isUserApprover()||(this._canChangeAnnotations=!1,e=this.f.t("AnnNotApproverBlocked")):this._allowedAnnotators===a.allowedAnnotators.ALL_APPROVERS_AND_MASTER?!this._page.isUserApprover()&&!this._page.isUserApprovalMaster(b.bind(this.updateApprovalInfo,this))&&(this._canChangeAnnotations=!1,e=this.f.t("AnnNotApproverOrMasterBlocked")):this._allowedAnnotators===a.allowedAnnotators.PENDING_APPROVERS?this._page.isUserPendingApprover()||(this._canChangeAnnotations=!1,e=this.f.t("AnnNotPendingApproverBlocked")):
this._allowedAnnotators===a.allowedAnnotators.PENDING_APPROVERS_AND_MASTER&&(!this._page.isUserPendingApprover()&&!this._page.isUserApprovalMaster(b.bind(this.updateApprovalInfo,this)))&&(this._canChangeAnnotations=!1,e=this.f.t("AnnNotPendingApproverOrMasterBlocked")));""!==e?(this.setDisableReason("ANNOTATORS_MODE",e),0<this.getUnsavedAnnotationCount()&&this.reload()):this.removeDisableReason("ANNOTATORS_MODE");d!=this._canChangeAnnotations&&this._emit("readWriteChanged")},this)};e.prototype.onApprovalUpdated=
function(){this.removeDisableReason("LOADING_APPROVAL");this.updateApprovalInfo()};e.prototype.setAnnotations=function(d){d=this._filter.filterIncomingAnnotations(d);this.scaleAllAnnotations(null);this._annotations=d;this._page&&this._page!==this.f.getDocumentController().getDifferencePage()&&this.scaleAllAnnotations(this._page.getCurrentScaling());this._confirmedOnce=!1;this.setSortingMode(this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE"),!0);this._filterAllAnnotations(!0);this.modelContentChanged()};
e.prototype.getAnnotations=function(){return this._annotations};e.prototype.getAnnotationCount=function(){return b.filter(this._annotations,function(d){return d.getGodfather()===d},this).length};e.prototype._filterAllAnnotations=function(d){var e=b.filter(this._annotations,function(d){return d.getGodfather()===d},this);this._filteredAnnotations=this._filter.filterAnnotations(e);this.currentOrdening();d||(this.modelChanged(),this.filterChanged())};e.prototype.getUsers=function(){var d={};b.each(this._annotations,
function r(e){d[e.username]||(d[e.username]=e.getUserName());0<e.replies.length&&b.each(e.replies,r)});void 0===d[this.f.getCurrentUser().getUsername()]&&(d[this.f.getCurrentUser().getUsername()]=this.f.getCurrentUser().getFullName());return d};e.prototype._deleteOneAnnotation=function(d){this._annotations.splice(b.indexOf(this._annotations,d),1);0<=b.indexOf(this._filteredAnnotations,d)&&this._filteredAnnotations.splice(b.indexOf(this._filteredAnnotations,d),1);d.isNew||this._removedannotations.push(d)};
e.prototype._renumberNewAnnotations=function(d){var e=this.getUnsavedAnnotations();b.each(e,b.bind(function(b){b.messagenumber>d&&(b.messagenumber-=1,b.updateIndicator())},this));this._emit("modelContentChanged")};e.prototype.deleteAnnotation=function(d){this.canDeleteAnnotation(d)?this.f.i18n.loadBundle("viewer",b.bind(function(){d.inreplyto?this._deleteAnnotationWithoutConfirmation(d):(void 0===this._deleteAnnotationPopup&&(this._deleteAnnotationPopup=new j(this.f,"deleteAnnotationPopup",this.f.getContext()),
this._deleteAnnotationPopup.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("DeleteAnnotBtnTT"))),this._deleteAnnotationPopup.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnDelete"))),this._deleteAnnotationPopup.setOkBtnText(this.f.i18n.t("YesResponse")),this._deleteAnnotationPopup.setCancelBtnText(this.f.i18n.t("NoResponse"))),this._deleteAnnotationPopup.setOkAction(b.bind(function(){this._deleteAnnotationPopup.hide();this._deleteAnnotationWithoutConfirmation(d)},
this)),this._deleteAnnotationPopup.show(),this._deleteAnnotationPopup.recalculateSize(400))},this)):this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.WARNING",this.f.i18n.t("AnnReadOnlyError"))},this)};e.prototype._deleteAnnotationWithoutConfirmation=function(d){if(d.parent){var e=b.indexOf(d.parent.replies,d);-1<e?d.parent.replies.splice(e,1):(e=b.indexOf(d.parent.states,d),-1<e?d.parent.states.splice(e,1):-1<b.indexOf(d.parent.links,d)&&this._deleteAnnotationWithoutConfirmation(d.parent));
d.isNew||this._removedannotations.push(d)}else this.unselectAllAnnotations(!0),b.each(d.links,function(d){this._deleteOneAnnotation(d)},this),this._deleteOneAnnotation(d),this._filterAllAnnotations(!0);this._emit("annotationDeleted",d);d.isNew&&this._renumberNewAnnotations(d.messagenumber);this.modelChanged()};e.prototype.reload=function(d){var e=b.bind(function(){this._emit("reload.started");this.unselectAllAnnotations();this.resetAllAnnotations();this._page?(this.modelChanged(),this._page.reloadAnnotations(b.bind(function(d){d&&
this.setAnnotations(this._page.getAnnotations());this.modelChanged();this._emit("reload.finished")},this))):this._emit("reload.finished")},this);d?e():this.promptToSaveUnsavedAnnotations(e,function(){},e)||e()};e.prototype.save=function(d,e){if(this._isSavingAnnotations)this.f.emit("error.WARNING",this.f.i18n.t("AnnAreAlreadyBeingSaved"),!0);else if(this._emit("save.started"),this._isSavingAnnotations=!0,this.canChangeAnnotations()&&this._page){this.unselectAllAnnotations();b.each(this._annotations,
function(d){if(d.hasUnsavedReply()){var b=d.getUnsavedReply();d.resetUnsavedReply();this.replyToAnnotation(d,b,!1)}},this);var f,a=this._removedannotations.slice(0);this._removedannotations=[];if(d){a=[];f=[];f.push(d);var c=d.getGodfather();b.each(c.links,function(d){!d.saved&&-1==b.indexOf(f,d)&&f.push(d)})}else f=this.getUnsavedAnnotations();this._page.saveAnnotations(f,a,b.bind(function(d,b){this._isSavingAnnotations=!1;this._page==d&&this.setAnnotations(b);e&&e();this._emit("save.finished");
this.modelChanged()},this,this._page))}else this._isSavingAnnotations=!1,this._emit("save.finished")};e.prototype.getUnsavedAnnotationCount=function(){var d=this.getUnsavedAnnotations().length,b=this.getDeletedAnnotations().length;return d+b};e.prototype.getUnsavedAnnotations=function(){var d=[];this.canChangeAnnotations(!0)&&b.each(this._annotations,b.bind(function(e){e.runThroughAnnotation(!0,!0,!0,b.bind(function(e){(!e.saved||e.hasUnsavedReply())&&(-1==b.indexOf(d,e)&&this.canChangeAnnotation(e))&&
d.push(e)},this));e=e.getGodfather();b.each(e.links,b.bind(function(e){(!e.saved||e.hasUnsavedReply())&&(-1==b.indexOf(d,e)&&this.canChangeAnnotation(e)&&!e.isStateObject())&&d.push(e)},this))},this));return d};e.prototype.getSavedAnnotations=function(){var d=[];b.each(this._annotations,function(b){b.saved&&d.push(b)});return d};e.prototype.getDeletedAnnotations=function(){return this._removedannotations};e.prototype.getVisibleAnnotations=function(){return 0===this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")||
this.isTemporarilyDisabledAndNoAnnotationsVisible()?[]:this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")&&0<this._selectedAnnotations.length?this._selectedAnnotations:this._filteredAnnotations};e.prototype.getFilteredAnnotations=function(){return this._filteredAnnotations};e.prototype.selectAnnotation=function(d,b){var e;if(!(1===this._selectedAnnotations.length&&d==this._selectedAnnotations[0])){this.unselectAllAnnotations(!0,b);this._selectedAnnotations.push(d);var f=d.getGodfather();
if(f.links)for(e=0;e<f.links.length;e++)this._selectedAnnotations.push(f.links[e]);if(d.linkedto&&(d=this.getAnnotation(d.linkedto))){for(e=0;e<d.links.length;e++)d.links[e]!=d&&this._selectedAnnotations.push(d.links[e]);this._selectedAnnotations.push(d)}this.ensureVisibility();this._layoutType==m.LayoutType.MOBILE&&this.f.emit("module.annotation.zoomToAnnotation",d);this._emit("selectedAnnotation",d);this.modelChanged()}};e.prototype.ensureVisibility=function(){this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")||
this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1)};e.prototype.getAnnotation=function(d){for(var b=0;b<this._annotations.length;b++)if(this._annotations[b].name==d)return this._annotations[b];return null};e.prototype.getAnnotationLinks=function(d){var b,e=[];if(d.links)for(b=0;b<d.links.length;b++)e.push(d.links[b]);if(d.linkedto)for(b=0;b<this._annotations.length;b++)this._annotations[b].name==d.linkedto&&e.push(this._annotations[b]);return e};e.prototype.getReplies=function(d){var b=[];
d.runThroughAnnotation(!1,!0,!1,function(d){b.push(d)});return b};e.prototype.unselectAllAnnotations=function(d,e){if(!(0>=this._selectedAnnotations.length||this.lockSelection&&!e)){var f=this._selectedAnnotations;this._selectedAnnotations=[];b.each(f,b.bind(function(d){this._emit("unselectedAnnotation",d)},this));d||this.modelChanged()}};e.prototype.resetAllAnnotations=function(){this.scaleAllAnnotations(null);this.unselectAllAnnotations();this._annotations=[];this._removedannotations=[];this._page.resetAnnotations()};
e.prototype.isAnnotationOrReplySelected=function(d){return null!==d?-1<b.indexOf(this._selectedAnnotations,d)?!0:0===d.replies.length?!1:b.some(d.replies,b.bind(function(d){return-1<b.indexOf(this._selectedAnnotations,d)},this)):!1};e.prototype.getSelectedAnnotations=function(){return this._selectedAnnotations};e.prototype.moveAnnotation=function(d,b){if(!this.canChangeAnnotation(d))return!1;d.move(b);this.modelChanged();return!0};e.prototype.transformAnnotation=function(d,b){if(!this.canChangeAnnotation(d))return!1;
d.setRect(b);this.modelChanged();return!0};e.prototype.updateStartEndOfAnnotation=function(d,b,e){if(!this.canChangeAnnotation(d))return!1;d.setStartEnd(b,e);this.modelChanged();return!0};e.prototype.addAnnotationWithRect=function(d,b,e){var f;f=this.f.getProperty("annotationcolor")?this.f.getProperty("annotationcolor"):this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");var a=new g(this.f);a.initAnnotation(e,f,!1,this,d);b&&(a.content=b);this.addAnnotation(a)};e.prototype._nextNumber=
function(){for(var d=0,b=0;b<this._annotations.length;b++)this._annotations[b].messagenumber>d&&(d=this._annotations[b].messagenumber);d++;return d};e.prototype.addAnnotation=function(d,e){if(this.checkCanChangeAnnotationsAndDisplayError())if(d.linkedto||(d.messagenumber=this._nextNumber()),d.username=this.f.getCurrentUser().getUsername(),d.firstname=this.f.getCurrentUser().getFirstName(),d.lastname=this.f.getCurrentUser().getLastName(),d.creationdate=new Date,d.date=new Date,d.setModified("NEW"),
this.ensureVisibility(),e)this.modelChanged(e,d);else{this._annotations.push(d);this._filterAllAnnotations(!0);var f=this._filter.compliesToFilter(d),a=!0;this._annotationFilterModel.isCustomFilterActive()&&(a=this._filter.compliesToCustomFilter(d));f&&a?(d.linkedto||this._emit("annotationAdded",d,!1),this._filteredAnnotations.push(d),this.selectAnnotation(d)):(this._emit("annotationAdded",d,!0),this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("AnnNotViewable"),
b.bind(function(){this._annotationFilterModel.resetFilter()},this))},this))}};e.prototype.addLinkedAnnotation=function(d){var b=this.getSelectedAnnotations()[0];b?this.canChangeAnnotation(b)?this.checkCanChangeAnnotationsAndDisplayError()&&(b=b.getGodfather(),b.linkedto&&(b=this.getAnnotation(b.linkedto)),d.linkedto=b.name,d.parent=b,b.links.push(d),d.messagenumber=b.messagenumber,this.addAnnotation(d),d.annotationcolor=b.color,d.color=b.color,this.selectAnnotation(b,!0)):this.f.i18n.loadBundle("viewer",
function(){this.f.emit("userMessage","warn",this.f.i18n.t("AnnCannotAddLinkedToNonOwnedAnnotation"),!0)},this):this.f.i18n.loadBundle("viewer",function(){this.f.emit("userMessage","warn",this.f.i18n.t("NoAnnotationSelected"),!0)},this)};e.prototype.replyToAnnotation=function(d,e,f){if(this.checkCanChangeAnnotationsAndDisplayError()){d.resetUnsavedReply();var a=d.duplicate(!1,!1,!1,!1,this);a.inreplyto=d.name;a.content=e;a.parent=d;d.replies.push(a);this.addAnnotation(a,d);f&&this.save(null,b.bind(function(){this.selectAnnotation(d,
!0);a.cancelModified();a.setIsNew(!1)},this))}else d.resetUnsavedReply(),this.modelChanged()};e.prototype.setState=function(d,e){this.checkCanChangeAnnotationsAndDisplayError()&&this.f.i18n.loadBundle("viewer",b.bind(function(){var b="<p>"+this.f.i18n.t("AnnStatusSetByText",e,this.f.getCurrentUser().getFullName())+"</p>",f=d.getUserStateAnnotation(this.f.getCurrentUser().getUsername());f?f.state!=e&&(f.state=e,f.content=b,f.setModified("STATE"),this.modelChanged(d)):(f=d.duplicate(!1,!1,!1,!1,this),
f.inreplyto=d.name,f.content=b,f.parent=d,f.state=e,f.statemodel="Review",f.parent=d,f.linkedto=d.name,d.states.push(f),this.addAnnotation(f,d))},this))};e.prototype.checkCanChangeAnnotationsAndDisplayError=function(){if(this.canChangeAnnotations())return!0;0<this.getDisabledReason().length&&this.f.emit("userMessage","warn",this.getDisabledReason());return!1};e.prototype.modelChanged=function(b,e){(e||b)&&this._emit("annotationUpdated",b,e);this._emit("modelChanged")};e.prototype.modelContentChanged=
function(){this._orderedAnnotations.length=0;this._emit("modelContentChanged")};e.prototype.filterChanged=function(){this._emit("filterChanged")};e.prototype.orderByModificationDate=function(){this._filteredAnnotations=b.sortBy(this._filteredAnnotations,function(b){var e=new Date(0);b.runThroughAnnotation(!0,!0,!0,function(b){b.date>e&&(e=b.date)});return e});this.currentOrdening=this.orderByModificationDate};e.prototype.orderByCreationDate=function(){this._filteredAnnotations=b.sortBy(this._filteredAnnotations,
function(b){return b.creationdate});this.currentOrdening=this.orderByCreationDate};e.prototype.orderAnnotationsForStep=function(){var d=this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===a.AnnotationSortType.SORT_BY_CREATION_DATE;if(0===this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")){var e=[];b.each(this._filteredAnnotations,function(b){b.runThroughAnnotation(!0,!0,!1,function(b){e.push(b)})});this._orderedAnnotations=b.sortBy(e,function(b){return d?-b.creationdate:-b.date})}else this._orderedAnnotations=
b.sortBy(this._filteredAnnotations,function(b){return d?-b.creationdate:-b.date});3!==this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")&&(this._orderedAnnotations=b.filter(this._orderedAnnotations,function(b){return!b.linkedto}));this._currentAnnotationIndex=b.indexOf(this._orderedAnnotations,this._selectedAnnotations[0])};e.prototype.getNextAnnotation=function(){0===this._orderedAnnotations.length&&this.orderAnnotationsForStep();0<this._selectedAnnotations.length&&(this._currentAnnotationIndex=
b.indexOf(this._orderedAnnotations,this._selectedAnnotations[0]));return this._orderedAnnotations[++this._currentAnnotationIndex%this._orderedAnnotations.length]};e.prototype.getPreviousAnnotation=function(){0===this._orderedAnnotations.length&&this.orderAnnotationsForStep();0<this._selectedAnnotations.length&&(this._currentAnnotationIndex=b.indexOf(this._orderedAnnotations,this._selectedAnnotations[0]));0>--this._currentAnnotationIndex&&(this._currentAnnotationIndex=this._orderedAnnotations.length-
1);return this._orderedAnnotations[this._currentAnnotationIndex%this._orderedAnnotations.length]};e.prototype.goToAnnotation=function(b){b=b?this.getNextAnnotation():this.getPreviousAnnotation();this.selectAnnotation(b,!0);var e=this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE");(2===e||3===e)&&this.f.emit("module.annotation.zoomToAnnotation",b)};e.prototype.updateAllAnnotationColors=function(){var d=this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR"),e=this.f.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");
b.each(this._annotations,b.bind(function(b){this.canChangeAnnotation(b)&&(b.annottype==a.AnnotationType.ANNOT_PIN?b.setColor(d):b.setColor(e),this._emit("annotationUpdated",b))},this));this.modelChanged()};e.prototype.setSortingMode=function(b,e){b===a.AnnotationSortType.SORT_BY_CREATION_DATE?this.orderByCreationDate():b===a.AnnotationSortType.SORT_BY_MODIFICATION_DATE&&this.orderByModificationDate();e||this.filterChanged()};e.prototype.generateUniqueName=function(){for(var d=100,e;void 0===e&&0<
d;){var f=i.randomString(22);void 0===b.find(this._annotations,function(b){return b.name===f})&&(e=f);d--}void 0===e&&this.f.emit("error.SEVERE","Error while generating ID for new annotation");return e};e.prototype.setPage=function(d,e){if(d!=this._page){var f=this._page;this._approvalUpdatedListener&&f&&(f.getDocumentVersion().isPageList()?f.off("approval.loaded",this._approvalUpdatedListener):f.getDocumentVersion().off("approval.update",this._approvalUpdatedListener));this.setAnnotations([]);this._emit("changed.page");
this.unselectAllAnnotations(!1,!0);this._page=d;this._addAnnotationsEnabledListener&&this._unregisterListener(this._addAnnotationsEnabledListener);this._disabledReasonChangedListener&&this._unregisterListener(this._disabledReasonChangedListener);this._clearDisableReasons();d&&d.requestAnnotations(b.bind(function(b){this._page=d;this.f.loadBundle("viewer",function(){d.getDocumentVersion().isLatestVersion()?this.removeDisableReason("NOT_LATEST"):this.setDisableReason("NOT_LATEST",this.f.t("AnnReadOnlyNotLatestVersion"))},
this);b?(this.setAnnotations(d.getAnnotations()),0===this.getAnnotationCount()&&"1"===this.f.getConfig().get("annotationaddglobal")&&(0<this.getDisabledReason().length||!this.canChangeAnnotations()?(this._addAnnotationsEnabledListener=this._registerListener("readWriteChanged",function(){0===this.getDisabledReason().length&&(this.canChangeAnnotations()&&0===this.getAnnotationCount())&&(this._emit("addGlobalAnnotation"),this._unregisterListener(this._addAnnotationsEnabledListener),this._unregisterListener(this._disabledReasonChangedListener))},
this,this),this._disabledReasonChangedListener=this._registerListener("disabledReasonChanged",function(){0===this.getDisabledReason().length&&(this.canChangeAnnotations()&&0===this.getAnnotationCount())&&(this._emit("addGlobalAnnotation"),this._unregisterListener(this._addAnnotationsEnabledListener),this._unregisterListener(this._disabledReasonChangedListener))},this,this)):this._emit("addGlobalAnnotation"))):this.f.debug.error("Annotations were NOT fetched succesfully");this.updateTemporarilyDisabledReason();
e&&e()},this));this._appovalUpdatedListener||(this._approvalUpdatedListener=b.bind(function(b){this.onApprovalUpdated(b)},this));this.editabilityDependsOnApproval()&&(this.f.loadBundle("viewer",function(){this.setDisableReason("LOADING_APPROVAL",this.f.t("Loading"))},this),this.f.requestModule("approval",b.bind(function(){var b=d.getDocumentVersion();b.isPageList()?(d.on("approval.loaded",this._approvalUpdatedListener),d.requestPageApprovalSetup(this._approvalUpdatedListener)):(b.on("approval.update",
this._approvalUpdatedListener),b.requestApprovalSetup(this._approvalUpdatedListener))},this)))}else void 0!==e&&e();this._annotationFilterModel.isAnnotationFilterPinned()||this._annotationFilterModel.resetFilter();this.modelChanged()};e.prototype.getPage=function(){return this._page};e.prototype.getAnnotationsOffset=function(){return this._page.getAnnotationsOffset()};e.prototype.getDisabledReason=function(){if(0<this._disabledReasons.getLength()){var d=this._disabledReasons.getLast().reason;""===
d&&b.some(this._disabledReasons.getItemsAsObject(),function(b){d=b.reason;return""!==d});return d}return""};e.prototype.setDisableReason=function(b,e,f,a){this._disabledReasons.addOrReplaceItem(b,{reason:e,hideAnnotations:f,dontRemove:a});this._disabledReasons.moveItemByKeyToEnd(b);this._emit("disabledReasonChanged")};e.prototype.removeDisableReason=function(b){this._disabledReasons.removeByKey(b);this._emit("disabledReasonChanged")};e.prototype._clearDisableReasons=function(){var d=[];b.each(this._disabledReasons.getKeys(),
function(b){this._disabledReasons.getItemByKey(b).dontRemove&&d.push(b)},this);this._disabledReasons.omitOthers(d);this._emit("disabledReasonChanged")};e.prototype.promptToSaveUnsavedAnnotations=function(d,e,f){void 0===e&&(e=d);return this._page&&0<this.getUnsavedAnnotationCount()&&this.canChangeAnnotations(!0)?(this.f.loadBundle("viewer",function(){var a=new j(this.f,"unsavedAnnotationsPopup",this.f.getContext());a.setRemoveFromDomAfterUsage(!0);a.setOkAction(b.bind(function(){a.enableOkBtn(!1);
this.save(null,b.bind(function(){a.hide();d&&d();this.toggleVisibility(!0)},this))},this));a.setCancelAction(b.bind(function(){e&&e();this.toggleVisibility(!0)},this));if(f){var c=new k(this.f,"dontSaveAnnotations",$("<span>").append(this.f.t("RevertAnnChanges")),!1,b.bind(function(){a.hide();this.toggleVisibility(!0);f&&f()},this));a.addButton(c)}a.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("AnnTitle")));a.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnSavePrompt")));
a.setOkBtnText(this.f.i18n.t("Save"));this.toggleVisibility(!1);a.show();a.recalculateSize(600)},this),!0):!1};e.prototype.setLockSelection=function(b){this.lockSelection=b};e.prototype.setLayoutType=function(b){this._layoutType=b};e.prototype.scaleAllAnnotations=function(d){this._currentScaling&&b.each(this._annotations,function(b){b.isScaled()&&b.scale(new n.Point(1/b.getScale().x,1/b.getScale().y))},this);this._currentScaling=d;b.each(this._annotations,function(b){b.setScale(d)})};e.prototype.getCurrentScaling=
function(){return this._currentScaling};e.prototype.getAnnotationFilterModel=function(){return this._annotationFilterModel};return e});
define("web-viewer/annotation/AnnotationLayerModel",["web-viewer/viewport/model/ViewportLayerModel","web-viewer/utils/ShapeUtils","web-viewer/utils/ListenerUtil","web-viewer/viewControls/ViewControlsConstants","underscore"],function(c,h,g,a,o){a=function(a,l,i){c.call(this,a,l);g.mixin(this,a);this.f=a;this.annotationModel=i;this._registerListener("modelChanged",this._calculateTransformation,this,this.annotationModel);this._registerListener("modelContentChanged",this.modelChanged,this,this.annotationModel);
this._registerListener("parameters.changed",this._calculateTransformation,this,this.f.getDocumentController());this._registerListener("transform.viewportWidget.transformChanged",this._calculateTransformation,this)};a.prototype=Object.create(c.prototype);a.prototype.constructor=a;a.prototype._calculateTransformation=function(){var a=this.annotationModel.getAnnotationsPage();if(null!==a&&void 0!==a){this.resetTransformation();this.getTransform().scale(1,-1);var c=a.getRotation(),i=this.f.getModule("viewport").getWorldBounds(),
j=new h.Size;j.add(this.annotationModel.getAnnotationsOffset());this.calculateTransformation(i,a.getPageSize(),j,c,a.isFlipped())}this.modelChanged()};a.prototype.getLinework=function(a,c){var i=this.annotationModel.getVisibleAnnotations(),j=[];o.each(i,function(b){o.each(b.links,function(b){j.push(b)})});for(var i=o.union(i,j),k=[],m=this.f.getOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE")&&!c,f=0;f<i.length;f++){var b=i[f];this.annotationModel.isAnnotationOrReplySelected(b)?(b.setSelected(!0),
b.needsSelectionBox()&&this.annotationModel.canChangeAnnotation(b)&&(k[f]=b.getSelectionBox())):b.setSelected(!1);m?(b.updateIndicator(),b.showIndicator=!0):b.showIndicator=!1}return o.union(i,j,o.without(o.flatten(k),void 0,null))};return a});
define("web-viewer/viewport/model/ViewportPopupModel",["underscore","web-viewer/core/PrivateChannel"],function(){var c=function(c,g){this.f=c;this.id=g;this.shown=!0};c.prototype.getId=function(){return this.id};c.prototype.show=function(){this.shown=!0};c.prototype.hide=function(){this.shown=!1};c.prototype.isShown=function(){return this.shown};c.prototype.getPopup=function(){};c.prototype.onDestroy=function(){};c.prototype.getWorldOrigin=function(){};c.prototype.getWorldSize=function(){};c.prototype.getSceneOffset=
function(){};c.prototype.onResized=function(){};c.prototype.onDragged=function(){};return c});
define("web-viewer/annotation/AnnotationPopup",["web-viewer/annotation/AnnotationConstants","web-viewer/layout/component/Popup","web-viewer/layout/component/MiniButton","jquery","underscore"],function(c,h,g,a,o){var n=function(c,i,j,k){this.f=c;h.call(this,c,i,k);this.annotation=j;this.element.addClass("annotationPopup");this.annotationNumber=a("<span />").addClass("annotationNumber");this.icon=a("<i />");this.title=a("<span />").addClass("annotationTitle")};n.prototype=Object.create(h.prototype);
n.prototype.constructor=n;n.prototype._initialize=function(){this._isInitialized||(h.prototype._initialize.call(this),this.headerWrapper.addClass("annotationPopupHeader"),this.header.append(this.annotationNumber),this.header.append(this.icon),this.header.append(this.title),this.pinIcon=new g(this.f,"pin","pinned icon-WCR_Pin12",!0,o.bind(function(a){this._emit("pinned",!this.annotation.popupIsOpen);a.stopPropagation()},this)),this.headerIcons.prepend(this.pinIcon.element),n.prototype.repaint.call(this))};
n.prototype.repaint=function(){this._isInitialized&&(this.annotation.popupIsOpen?(this.pinIcon.setIcon("pinned icon-WCR_Pin12"),this.pinIcon.setTooltip("viewer","UnpinPopupTT")):(this.pinIcon.setIcon("unpinned icon-WCR_Pin12"),this.pinIcon.setTooltip("viewer","PinPopupTT")),this.setAnnotationNumber(this.annotation.messagenumber),this.annotationNumber.css({color:this.annotation.getHeaderTextColor(),"background-color":this.annotation.annotationcolor}),this.setTitle(this.annotation.getUserName()),this.setIcon(c.AnnotationIcons[this.annotation.annottype]))};
n.prototype.setTitle=function(a){this.title.text(a)};n.prototype.remove=function(){this.removeAllListeners("pinned");h.prototype.remove.call(this)};n.prototype.setIcon=function(a){this.icon.removeClass().addClass("icon").addClass(a)};n.prototype.setAnnotationNumber=function(a){this.annotationNumber.text(a)};return n});
define("web-viewer/layout/component/RichTextEditor",["web-viewer/utils/ViewerUtils","jquery","underscore"],function(c,h,g){var a=function(a){this.f=a;this.onTextChangeCallbacks=[];this.id=c.generateUniqueDOMId("richText_");this.element=h("<div />").addClass("richText").attr("id",this.id);this.element.data("richTextObj",this);this.titleBar=h("<h3 />").addClass("title");this.titleBar.hide();this.actionBar=h("<div />").addClass("actionBar").addClass("clearfix");this.textAreaDiv=h("<div />").addClass("wrapper");
this.textArea=h("<textarea />").addClass("text");this.textAreaId="textArea_"+this.id;this.textArea.attr("id",this.textAreaId);this.initialized=!1;this.element.append(this.titleBar).append(this.textAreaDiv.append(this.textArea)).append(this.actionBar);this._fireTextChanges=!0};a.prototype.setContent=function(){};a.prototype.getContent=function(){return""};a.prototype.setButtons=function(a){this.actionBar.empty();g.each(a,function(a){a&&this.actionBar.append(a.element)},this)};a.prototype.setTitle=
function(a){this.titleBar.text(a);this.titleBar.show()};a.prototype.init=function(){};a.prototype._fireTextChanged=function(){this._shouldFireTextChanged()&&g.each(this.onTextChangeCallbacks,function(a){a()})};a.prototype._shouldFireTextChanged=function(){return this._fireTextChanges};a.prototype.isInitialized=function(){return this.initialized};a.prototype.destroy=function(){};a.prototype.onTextChanged=function(a){this.onTextChangeCallbacks.push(a)};a.prototype.beforeDetach=function(){};a.prototype.repair=
function(){};a.prototype.setHeight=function(a){this.isInitialized()&&(a-=this.actionBar.outerHeight(!0),a=Math.max(a,80),this.textAreaDiv.css("height",a))};return a});
define("web-viewer/layout/component/RichTextEditorTextarea",["web-viewer/layout/component/RichTextEditor","web-viewer/utils/ViewerUtils","utils/ConvertUtils","jquery","underscore"],function(c,h,g,a,o){h=function(a){c.call(this,a)};h.prototype=Object.create(c.prototype);h.prototype.constructor=h;h.prototype.setContent=function(a){this.textArea.val(g.convertHTMLStringToRaw(a))};h.prototype.getContent=function(){return this.isInitialized()?"<html><body>"+g.convertRawStringToHTML(this.textArea.val())+
"</body></html>":""};h.prototype.init=function(a){this.initialized?(a&&a(),this.textArea.focus()):(this.initialized=!0,this.textArea.on("keyup change",o.bind(this._fireTextChanged,this)),this.textArea.focus(),a&&a())};h.prototype.destroy=function(){this.textArea.off("keyup change");this.initialized=!1};return h});
define("web-viewer/layout/component/RichTextEditorTinyMCE",["web-viewer/layout/component/RichTextEditor","web-viewer/utils/ViewerUtils","tinyMCE","jquery","underscore"],function(c,h,g,a){var o="br cn cz de en es fr hu it jp nl pl ru th tr tw".split(" "),n=[],h=function(a){c.call(this,a);this.editor=void 0};h.prototype=Object.create(c.prototype);h.prototype.constructor=Object.create(h);h.prototype.setContent=function(a){this.textArea.val(a);this.initialized&&this.editor.setContent(a)};h.prototype.getContent=
function(){return this.initialized?this.editor.getContent():""};h.prototype.init=function(a){if(this.initialized)a&&a(),this.editor.focus();else{var c=this.f.getCurrentUser().getLocale();_.contains(o,c)?this._initMCE(a,c):_.contains(n,c)?this._initMCE(a,"en"):this.f.ajax(requirejs.toUrl("lib/tinymce/langs/"+c+".js"),{dataType:"text",timeout:2E3,success:_.bind(function(){o.push(c);this._initMCE(a,c)},this),error:_.bind(function(){n.push(c);this._initMCE(a,"en")},this)})}};h.prototype._initMCE=function(a,
c){g.init({selector:"#"+this.textAreaId,menubar:!1,statusbar:!1,plugins:"paste fullpage",toolbar:"bold italic underline strikethrough | subscript superscript | undo redo",toolbar_items_size:"small",element_format:"xhtml",doctype:"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>",fullpage_default_doctype:"<!DOCTYPE html PUBLIC '-//W3C//DTD XHTML 1.0 Strict//EN' 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd'>",inline_styles:!0,language:c,
valid_elements:"p[style],p[style]/li,div,span[style],span[style],br,nobr,sub,sup,strike/s,strong/b,i,u,s,a,h?,big,small,font,tt,code,var,kbd,em,samp,center,a[href|title|style]",auto_focus:this.textAreaId,setup:_.bind(function(c){this.editor=c;c.on("keyup",_.bind(function(){this._fireTextChanged()},this));c.on("redo",_.bind(function(){this._fireTextChanged()},this));c.on("undo",_.bind(function(){this._fireTextChanged()},this));c.on("change",_.bind(function(){this._fireTextChanged()},this));c.on("init",
_.bind(function(){this.initialized=!0;a&&a()},this))},this),paste_preprocess:function(a,c){c.content=c.content.replace(/<(\/)?table[^>]*>/gi,"<$1div>");c.content=c.content.replace(/<(\/)?tr[^>]*>/gi,"<$1p>");c.content=c.content.replace(/<th[^>]*>/gi,"<span><strong>");c.content=c.content.replace(/<\/th[^>]*>/gi,"</strong></span>&nbsp;");c.content=c.content.replace(/<td[^>]*>/gi,"<span>");c.content=c.content.replace(/<\/td[^>]*>/gi,"</span>&nbsp;")},height:"100%"})};h.prototype._shouldFireTextChanged=
function(){return this.editor&&this.editor.isDirty()&&this._fireTextChanges};h.prototype.destroy=function(){this.initialized&&this.editor.destroy();this.initialized=!1};h.prototype.beforeDetach=function(){this.isInitialized()&&(this._fireTextChanges=!1,this.destroy(),this._fireTextChanges=!0)};h.prototype.repair=function(){this.isInitialized()&&(this.initialized=!1,this.init())};h.prototype.setHeight=function(c){if(this.isInitialized()){var i=this.textAreaDiv.find(".mce-toolbar-grp").outerHeight(!0);
2!==i%26&&(i=28);c=c-this.actionBar.outerHeight(!0)-i;c=Math.max(c,80);a("#"+this.textAreaId+"_ifr").css("height",c)}};return h});define("web-viewer/layout/component/RichTextEditorFactory",["web-viewer/layout/component/RichTextEditorTextarea","web-viewer/layout/component/RichTextEditorTinyMCE"],function(c,h){return{createEditor:function(g){return g.getFeatureDetector().isIOS()?new c(g):new h(g)}}});
define("web-viewer/annotation/AnnotationCharLineCount",["web-viewer/utils/ViewerUtils","web-viewer/layout/component/Tooltip","utils/ConvertUtils","jquery","underscore"],function(c,h,g,a){c=function(c){this.element=a("<div />").addClass("charLineCount");this.showing=!1;this.f=c;this.tooltip=null};c.prototype.update=function(a){this.showing&&(a=g.getCharacterLineCount(a),this.element.text(a.charCount+"/"+a.lineCount),this.tooltip?this.tooltip.setTooltipContent("viewer","charLineCount",[a.charCount,
a.lineCount]):this.tooltip=new h(this.f,this.element,"viewer","charLineCount",[a.charCount,a.lineCount]))};c.prototype.show=function(){this.element.show();this.showing=!0};c.prototype.hide=function(){this.element.hide();this.showing=!1};return c});
define("web-viewer/layout/AutoTimeLabel",["web-viewer/layout/component/Tooltip","web-viewer/utils/ViewerUtils","utils/ConvertUtils","jquery"],function(c,h,g,a){return function(h,n){function l(a){var c=Math.floor(((new Date).getTime()-a.getTime())/1E3),k=Math.floor(c/86400),c=c-86400*k,m=Math.floor(c/3600),c=Math.floor((c-3600*m)/60),f,b=null;0<k?1==k?b=h.i18n.t("dateYesterday"):5>k?f=k+h.i18n.t("daysAbbreviation"):b=g.getLangFormattedDate(h.i18n,a):0<m?f=m+h.i18n.t("hoursAbbreviation"):0<c?f=c+h.i18n.t("minutesAbbreviation"):
(h.i18n.t("secondsAbbreviation"),f="< 1"+h.i18n.t("minutesAbbreviation"));return b?b:h.i18n.t("timeAgo",f)}this.editOnTop=!0;this.element=a("<span>");this.date=n;this.tooltip=new c(h,this.element,g.getLangFormattedDateAndTime(h.i18n,this.date));this.updateText=function(a){h.i18n.loadBundle("viewer",_.bind(function(){this.element.text(l(this.date));var c="",c=a?h.i18n.t("createdOn"):h.i18n.t("modifiedOn");this.tooltip.setTooltipContent(c+g.getLangFormattedDateAndTime(h.i18n,this.date))},this))};this.updateText()}});
define("web-viewer/annotation/AnnotationSingleRow","web-viewer/layout/AutoTimeLabel web-viewer/annotation/AnnotationConstants web-viewer/annotation/AnnotationCharLineCount web-viewer/layout/component/MiniButton web-viewer/layout/component/DropdownMiniButton web-viewer/layout/component/ToolbarButton web-viewer/layout/component/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/layout/component/ColorPicker jquery HTMLTruncator".split(" "),function(c,h,g,a,o,n,l,i,j,k){var m=function(f,
b,e,d,m,j,i){this.element=k("<div/>").addClass(e?"main":"reply");this.selected=!1;this.f=f;this._MAX_CHARS=300;this._hideHeader=m;this._annotation=b;this._main=e;this._annotationModel=d;this._isForMobile=i;this._visible=!0;if(!this._hideHeader){f=k("<div/>").addClass("annotHeader");this.element.append(f);this._main&&f.append(k("<i>").addClass("icon").addClass(this._annotation.getIconClass()));b=k("<span />").addClass("userName").text(this._annotation.getUserName());f.append(b);var p=new c(this.f,
this._annotation.date);p.element.addClass("date").addClass("pull-right");f.append(p.element);this.updateTimer=_.bind(function(){p.date=this._annotation.date;p.updateText(this._annotation.isAnnotationModified())},this)}this._content=k("<div/>").addClass("annotContent");this.element.append(this._content);this._actionsDiv=k("<div/>").addClass("annotActions").addClass("clearfix");this._moreActions=new o(this.f,"moreActions","icon-WCR_More-horizontal");this._moreActions.addButtonClass("annotAction");this._moreActions.setTooltip("viewer",
"moreActions");this._moreActions.onToggle(_.bind(function(){this.showOrHideOptions()},this));this._annotationColorPicker=this._richTextEditor=void 0;this._actionsDiv.append(this._moreActions.element);var v=new n(this.f,"saveEdit","icon-WCR_Save12 marginRight5",!0,_.bind(function(b){this._annotation.content=this._richTextEditor.getContent();this._annotation.setModified("CONTENT");this._annotationModel.save();this.closeRichText();b.stopPropagation()},this)),t=new n(this.f,"cancelReply","icon-WCR_Revert12 marginRight5",
!0,_.bind(function(b){this._annotation.resetAnnotationColor();this._annotationModel.modelChanged(this._annotation);this._annotation.cancelModifiedColor();this._richTextEditor.setContent("");this._annotation.cancelModified("CONTENT");this._annotationModel.modelChanged();this.closeRichText();b.stopPropagation()},this));this._editActionsGroup=new l("editActionsGroup",[t,v]);this._editActionsGroup.element.addClass("pull-right");this._duplicateAction=new a(this.f,"annotationDuplicate","icon-WCR_Duplicate",
!0,_.bind(function(b){this.f.emit("module.annotation.duplicateAnnotation",this._annotation);b.stopPropagation()},this));this._duplicateAction.addButtonClass("annotAction");this._duplicateAction.setTooltip("viewer","DuplicateAnnotBtnTT");this._actionsDiv.append(this._duplicateAction.element);this._main&&(f=new a(this.f,"annotationZoom","icon-WCR_ZoomFit",!0,_.bind(function(b){this.f.emit("module.annotation.zoomToAnnotation",this._annotation);b.stopPropagation()},this)),f.addButtonClass("annotAction"),
f.setTooltip("viewer","ZoomAnnotBtnTT"),this._actionsDiv.append(f.element));this._statusAction=new o(this.f,"setReviewStatus","icon-WCR_Approve-submenu");this._statusAction.addButtonClass("annotAction");this._statusAction.setTooltip("viewer","SetReviewStateBtnTT");this._actionsDiv.append(this._statusAction.element);this._statusAction.onToggle(_.bind(function(){this.showOrHideOptions()},this));this._isForMobile&&void 0!==j&&this._actionsDiv.append(j);this._charLineCount=new g(this.f);this._actionsDiv.append(this._charLineCount.element);
this.element.append(this._actionsDiv);this._reviews=k("<ul/>").addClass("Review").hide();this.element.append(this._reviews);this.element.mouseenter(_.bind(function(){this.mouseEntered=!0;this.showOrHideOptions()},this)).mouseleave(_.bind(function(){this.mouseEntered=!1;this.showOrHideOptions()},this));this.f.i18n.loadBundle("viewer",_.bind(function(){this._moreActions.addAction({name:"annotationEdit",content:this.f.i18n.t("EditAnnotBtnTT"),icon:"icon-WCR_Annotate",action:_.bind(function(){this._annotation.isNew?
this._annotationModel.selectAnnotation(this._annotation,!0):(this._initializeRichTextEditor(),this._richTextEditor.isInitialized()||(this._content.after(this._richTextEditor.element),this._richTextEditor.element.trigger("makeMeVisible")),this._richTextEditor.element.show(),this._content.hide(),this._actionsDiv.hide(),this._charLineCount.element.insertAfter(this._editActionsGroup.element),this._richTextEditor.setContent("<html>"+this._annotation.content+"</html>"),this.updateColorPicker(),this._richTextEditor.init())},
this)});this._moreActions.addAction({name:"duplicateAnnotation",content:this.f.i18n.t("DuplicateAnnotBtnTT"),icon:"icon-WCR_Duplicate",action:_.bind(function(b){b.which&&(this.f.emit("module.annotation.duplicateAnnotation",this._annotation),b.stopPropagation())},this)});this._moreActions.addAction({name:"annotationSave",content:this.f.i18n.t("SaveAnnotBtnTT"),icon:"icon-WCR_Save",action:_.bind(function(){this._annotationModel.save()},this)});this._moreActions.addAction({name:"annotationDelete",content:this.f.i18n.t("DeleteAnnotBtnTT"),
icon:"icon-WCR_Trash",action:_.bind(function(){this._annotationModel.deleteAnnotation(this._annotation)},this)});v.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));t.element.addClass("btn-mini").append(this.f.i18n.t("CancelButton"));_.each(h.AnnotationReviewStateLocs,_.bind(function(b,d){"STATUS_ANY"!=d&&this._statusAction.addAction({name:d,content:this.f.i18n.t(b),action:_.bind(function(){this._annotationModel.setState(this._annotation,h.AnnotationReviewState[d])},
this),icon:h.AnnotationReviewStateIcons[d]})},this))},this))};m.prototype.closeRichText=function(){this._actionsDiv.show();this._actionsDiv.append(this._charLineCount.element);this._content.show();this._richTextEditor.element.hide()};m.prototype.showHideCharLineCount=function(a){var b=this._annotation.getGodfather();a&&this._annotationModel.isAnnotationOrReplySelected(b)?(this._charLineCount.show(),this._charLineCount.update(this._annotation.content)):this._charLineCount.hide()};m.prototype.repaintRow=
function(){this._hideHeader||this.updateTimer();!this._annotation.isBeingModified()&&void 0!==this._richTextEditor?this.closeRichText():this.updateColorPicker();this._content.empty();this._content.removeClass("noContent");if(this._annotation.content&&0<this._annotation.content.length){var a=k("<div>").html(this._annotation.content);this._content.empty().append(a);this.f.i18n.loadBundle("viewer",_.bind(function(){a.truncate({max_length:this._MAX_CHARS,more:this.f.i18n.t("ReadMore"),less:this.f.i18n.t("ReadLess"),
css_more_class:"truncator-link truncator-more",css_less_class:"truncator-link truncator-less",link_prefix:"",link_suffix:""})},this))}else this.f.i18n.loadBundle("viewer",function(){this._content.addClass("noContent");this._annotation.isNew?this._content.text(this.f.t("AnnNewClickToEdit")):this._content.text(this.f.t("AnnNoContent"))},this);this.showOrHideOptions();this._updateReviews(this._annotation.states);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._annotationModel.canChangeAnnotations(!0)?
(this._annotationModel.canChangeAnnotation(this._annotation)?(this._moreActions.element.show(),this._duplicateAction.element.hide()):(this._moreActions.element.hide(),this._duplicateAction.element.show()),this._statusAction.element.show(),this._moreActions.setActionEnabled("annotationDelete",this._annotationModel.canDeleteAnnotation(this._annotation))):(this._duplicateAction.element.hide(),this._moreActions.element.hide(),this._statusAction.element.hide())};m.prototype.shouldShowOptions=function(){return this._isForMobile?
this.selected:this.selected||this.mouseEntered||this._moreActions.isOpen()||this._statusAction.isOpen()};m.prototype.showOrHideOptions=function(){this.showOptions(this.shouldShowOptions())};m.prototype.showOptions=function(a){a?this._isForMobile?this._actionsDiv.show():this._actionsDiv.removeClass("hideOptions"):this._isForMobile?this._actionsDiv.hide():this._actionsDiv.addClass("hideOptions")};m.prototype._updateReviews=function(a){this.f.i18n.loadBundle("viewer",function(){this._reviews.empty();
for(var b=0;b<a.length;b++){var e=k("<li/>"),d=k("<a/>"),c=k("<i/>").addClass("icon").addClass(h.AnnotationReviewStateIcons[_.invert(h.AnnotationReviewState)[a[b].state]]),m=_.invert(h.AnnotationReviewState)[a[b].state],m=k("<span/>").text('"'+this.f.i18n.t(h.AnnotationReviewStateLocs[m])+'": '+a[b].getUserName());d.append(c);d.append(m);e.append(d);this._reviews.append(e)}},this);this._reviews.toggle(0<a.length)};m.prototype._initializeRichTextEditor=function(){this._richTextEditor||(this._richTextEditor=
i.createEditor(this.f),!this.f.getProperty("annotationcolor")&&this._main&&(this._annotationColorPicker=new j(_.bind(function(a){this._annotation.setColor("#"+a);this._annotationModel.modelChanged(this._annotation)},this)),this._annotationColorPicker.setColor(this._annotation.annotationcolor),this._annotationColorPicker.element.addClass("annotationColorPicker"),this._annotationColorPicker.setTooltip(this.f,"general","ChangeColor")),this._richTextEditor.setButtons([this._editActionsGroup,this._annotationColorPicker]),
this._richTextEditor.onTextChanged(_.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._annotation.setBeingModified(this._richTextEditor.getContent());this._annotationModel.modelChanged()},this)))};m.prototype.setSelected=function(a){this.selected=a;this.element.toggleClass("selected",this.selected);this.repaintRow()};m.prototype.onDetachFromDOM=function(){this._richTextEditor&&this._richTextEditor.beforeDetach()};m.prototype.onReattachToDOM=function(){this._richTextEditor&&
this._richTextEditor.repair()};m.prototype.updateColorPicker=function(){this._annotationColorPicker&&this._annotationColorPicker.setColor(this._annotation.annotationcolor)};m.prototype.setVisible=function(a){this._visible=a;this.element.toggle(a)};m.prototype.isVisible=function(){return this._visible};m.prototype.setAnnotation=function(a){this._annotation=a;this.repaintRow()};return m});
define("web-viewer/annotation/AnnotationRow","web-viewer/annotation/AnnotationSingleRow web-viewer/layout/component/ToolbarButton web-viewer/layout/component/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/annotation/AnnotationCharLineCount web-viewer/layout/component/MiniButton jquery underscore".split(" "),function(c,h,g,a,o,n,l,i){var j=function(k,m,f,b,e,d){this.f=k;this._replyLimit=e;this._replyLimit||(this._replyLimit=2);this._annotation=m;this._annotationModel=f;this._limitReplyCount=
!0;this._totalReplyCount=this._shownReplyCount=0;this.name=this._annotation.name;this.element=l("<div>").addClass("annotation");this.annotationRows={};this.selected=!1;this._isForMobile=d;this._repliesDiv=l("<div/>").addClass("replies");this._moreReplies=l("<p/>").addClass("MoreReplies clearfix");this._moreRepliesLabel=l("<a/>");this._moreRepliesLabel.on("click",i.bind(function(b){this.toggleReplyLimit();b.stopPropagation()},this));this._moreReplies.append(this._moreRepliesLabel);this._moreReplies.hide();
b||(this.title=l("<span/>").addClass("annotationNumber"),this.element.append(this.title));d?(m=new n(this.f,"annotationAddReply","icon-WCR_Comment",!0,i.bind(function(b){this._showRichTextEditor(b)},this)),m.addButtonClass("annotAction"),this._replyText=m.element):(this._replyText=l("<input/>"),this.f.i18n.loadBundle("viewer",i.bind(function(){this._replyText.attr("placeholder",this.f.i18n.t("AnnReplyTT"))},this)),this._replyText.on("click",function(b){b.preventDefault();b.stopPropagation()}),this._replyText.on("focus",
i.bind(function(b){this._showRichTextEditor(b)},this)));this._reply=l("<div/>").append(this._replyText).addClass("addReply");this._richTextEditor=a.createEditor(this.f);this._saveReply=new h(this.f,"saveReply","icon-WCR_Save12 marginRight5",!0,i.bind(function(b){this._annotationModel.replyToAnnotation(this._annotation,this._richTextEditor.getContent(),!0);this._closeRichText();b.stopPropagation()},this));this._cancelReply=new h(this.f,"cancelReply","icon-WCR_Revert12 marginRight5",!0,i.bind(function(b){this._closeRichText();
this._richTextEditor.setContent("");this._annotation.resetUnsavedReply();this._annotationModel.modelChanged();b.stopPropagation()},this));this._replyActionsGroup=new g("replyActionsGroup",[this._cancelReply,this._saveReply]);this._replyActionsGroup.element.addClass("pull-right");k.i18n.loadBundle("viewer",i.bind(function(){this._saveReply.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));this._cancelReply.element.addClass("btn-mini").append(this.f.i18n.t("CancelButton"))},
this));this._charLineCount=new o(k);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._richTextEditor.onTextChanged(i.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._annotation.setUnsavedReply(this._richTextEditor.getContent());this._annotationModel.modelChanged()},this));this._richTextEditor.setButtons([this._replyActionsGroup,this._charLineCount]);this._mainRow=new c(this.f,this._annotation,!0,this._annotationModel,b,this._replyText,
this._isForMobile);this.element.append(this._mainRow.element);this.annotationRows[this._annotation.name]=this._mainRow;this.element.append(this._repliesDiv);this._repliesDiv.prepend(this._moreReplies);d||this.element.append(this._reply);this.annotationUpdated();this.updateReplyLimitLabel()};j.prototype._closeRichText=function(){this._replyText.show();this._richTextEditor.setContent("");this._richTextEditor.element.hide()};j.prototype._showRichTextEditor=function(a){this._replyText.hide();this._richTextEditor.isInitialized()||
this._replyText.after(this._richTextEditor.element);this._richTextEditor.element.show();this._annotation.setUnsavedReply("");this._richTextEditor.setContent("<html><body></body></html>");this._richTextEditor.init(i.bind(function(){this._charLineCount.update(this._richTextEditor.getContent());this._richTextEditor.element.trigger("makeMeVisible");this._richTextEditor.element.trigger("contentResized")},this));a.preventDefault();a.stopPropagation()};j.prototype.showHideCharLineCount=function(a,c){a&&
this._annotationModel.isAnnotationOrReplySelected(this._annotation)?(this._charLineCount.show(),this._charLineCount.update(this._richTextEditor.getContent())):this._charLineCount.hide();c&&i.each(this.annotationRows,function(f){f.showHideCharLineCount(a)})};j.prototype.annotationUpdated=function(a){this.element.css({"border-color":this._annotation.annotationcolor});this.title&&(this.title.text(this._annotation.messagenumber),this.title.css({color:this._annotation.getHeaderTextColor(),"background-color":this._annotation.annotationcolor}));
this._mainRow.setAnnotation(this._annotation);var m=this._annotationModel.getReplies(this._annotation);this._totalReplyCount=m.length;var f=[];i.each(this.annotationRows,function(b,d){f.push(d)});this._annotation.runThroughAnnotation(!0,!0,!1,function(b){b=i.indexOf(f,b.name);-1<b&&f.splice(b,1)});i.each(f,function(b){this.annotationRows[b].element.remove();delete this.annotationRows[b]},this);var b=this._totalReplyCount;this._limitReplyCount&&(b=this._replyLimit);a&&(a=m.length-i.indexOf(m,a.parent),
a<=m.length&&(b=Math.max(b,a)));this._shownReplyCount=Math.min(b,this._totalReplyCount);for(a=0;a<this._totalReplyCount;a++){var e=m[a],d=this.annotationRows[e.name];d||(d=new c(this.f,e,!1,this._annotationModel,void 0,this._isForMobile),this._repliesDiv.append(d.element),this.annotationRows[e.name]=d,d.setSelected(this.selected),d.setVisible(!1));this._totalReplyCount-1-a<b?(d.setAnnotation(e),d.setVisible(!0)):d&&d.setVisible(!1)}this._repliesDiv.prepend(this._moreReplies);this.shouldShowMoreRepliesLink()?
this._moreReplies.show():this._moreReplies.hide();this.updateReplyLimitLabel();this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"));this._annotationModel.canChangeAnnotations(!0)&&!this._annotation.isNew?(this._reply.show(),this._replyText.show(),null===this._annotation.getUnsavedReply()?this._closeRichText():this._richTextEditor.setContent(this._annotation.getUnsavedReply())):(this._reply.hide(),this._replyText.hide())};j.prototype.shouldShowMoreRepliesLink=function(){return this._totalReplyCount>
this._replyLimit};j.prototype.toggleReplyLimit=function(a){this._limitReplyCount=void 0===a?!this._limitReplyCount:a;this.annotationUpdated();this.updateReplyLimitLabel();this._moreReplies.trigger("contentResized")};j.prototype.updateReplyLimitLabel=function(){if(this._limitReplyCount){var a=this._totalReplyCount-this._shownReplyCount;1>=a?this._moreRepliesLabel.text(this.f.i18n.t("AnnShowOneMoreReply")):this._moreRepliesLabel.text(this.f.i18n.t("AnnShowMoreReplies",a))}else this._moreRepliesLabel.text(this.f.i18n.t("AnnShowLessReplies"))};
j.prototype.updateTimers=function(){i.each(this.annotationRows,function(a){a.updateTimer()})};j.prototype.setSelected=function(a){this.selected=a;i.each(this.annotationRows,function(c){c.setSelected(a)});this.element.toggleClass("selected",a);this.showHideCharLineCount(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT"))};j.prototype.onDetachFromDOM=function(){this.detachedFromDOM||(this.detachedFromDOM=!0,this._richTextEditor.beforeDetach(),i.each(this.annotationRows,function(a){a.onDetachFromDOM()}))};
j.prototype.onReattachToDOM=function(){this.detachedFromDOM&&(this.detachedFromDOM=!1,this._richTextEditor.repair(),i.each(this.annotationRows,function(a){a.onReattachToDOM()}))};j.prototype.setAvailableHeight=function(a){if(null!==this._annotation.getUnsavedReply()){var c=a-10;this.shouldShowMoreRepliesLink()&&(c-=this._moreReplies.outerHeight(!0));i.each(this.annotationRows,function(a){a.isVisible()&&(c-=a.element.outerHeight(!0))});this._richTextEditor.setHeight(c)}};j.prototype.setAnnotation=
function(a){this._annotation=a;this.annotationUpdated()};j.prototype.getAnnotation=function(){return this._annotation};return j});
define("web-viewer/annotation/AnnotationPopupNew","web-viewer/annotation/AnnotationPopup web-viewer/layout/component/ColorPicker web-viewer/layout/component/ToolbarButton web-viewer/layout/component/ButtonGroup web-viewer/layout/component/RichTextEditorFactory web-viewer/annotation/AnnotationCharLineCount web-viewer/annotation/AnnotationRow underscore".split(" "),function(c,h,g,a,o,n){var l=function(a,j,k,m,f){c.call(this,a,j,k,f);this.element.removeClass("annotationPopup").addClass("annotationPopupNew");
this.annotation.popuprect.size.width||(this.annotation.popuprect.size.width=65);this.annotation.popuprect.size.height||(this.annotation.popuprect.size.height=45);this.annotation.popuprect.origin.x||(this.annotation.popuprect.origin.x=this.annotation.rect.right());this.annotation.popuprect.origin.y||(this.annotation.popuprect.origin.y=this.annotation.rect.bottom()-this.annotation.popuprect.size.height);this.annotationModel=m};l.prototype=Object.create(c.prototype);l.prototype.constructor=l;l.prototype._initialize=
function(){c.prototype._initialize.call(this);this.richTextEditor=o.createEditor(this.f);this.richTextEditor.setContent(this.annotation.content);var i;this.f.getProperty("annotationcolor")||(i=new h(_.bind(function(a){this.annotation.setColor("#"+a);this.annotationModel.modelChanged(this.annotation)},this)),i.setColor(this.annotation.annotationcolor),i.element.addClass("annotationColorPicker"),i.setTooltip(this.f,"general","ChangeColor"));var j=new g(this.f,"saveAnnot","icon-WCR_Save12 marginRight5",
!1,_.bind(function(a){this.annotation.content=this.richTextEditor.getContent();this.annotationModel.save();a.stopPropagation()},this)),k=new g(this.f,"deleteAnnot","icon-WCR_Trash12 marginRight5",!1,_.bind(function(a){this.annotationModel.deleteAnnotation(this.annotation);a.stopPropagation()},this)),m=new a("AnnotationActionsGroup",[k,j]);m.element.addClass("pull-right");this.f.i18n.loadBundle("viewer",_.bind(function(){j.element.addClass("btn-mini").addClass("btn-success").append(this.f.i18n.t("Save"));
k.element.addClass("btn-mini").append(this.f.i18n.t("Delete"))},this));this.charLineCount=new n(this.f);this.richTextEditor.setButtons([i,m,this.charLineCount]);this.richTextEditor.onTextChanged(_.bind(function(){this.charLineCount.update(this.richTextEditor.getContent());this.annotation.setBeingModified(this.richTextEditor.getContent())},this));this.setContent(this.richTextEditor.element);this.richTextEditor.init(_.bind(function(){this._repaintCharLineCount();this.on("contentResized",_.bind(function(a){this.richTextEditor.setHeight(a.height)},
this));this.richTextEditor.setHeight(this._outerContent.height())},this))};l.prototype.repaint=function(){this._isInitialized&&(c.prototype.repaint.call(this),this._repaintCharLineCount())};l.prototype._repaintCharLineCount=function(){this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")?(this.charLineCount.show(),this.charLineCount.update(this.richTextEditor.getContent())):this.charLineCount.hide()};l.prototype.remove=function(){this.annotationColorPicker&&this.annotationColorPicker.destroy();this.richTextEditor&&
this.richTextEditor.destroy();c.prototype.remove.call(this)};return l});
define("web-viewer/annotation/AnnotationPopupExisting",["web-viewer/annotation/AnnotationPopup","web-viewer/annotation/AnnotationRow","underscore"],function(c,h,g){var a=function(a,g,h,i,j){c.call(this,a,g,h,j);this.annotationModel=i};a.prototype=Object.create(c.prototype);a.prototype.constructor=a;a.prototype._initialize=function(){c.prototype._initialize.call(this);this.row=new h(this.f,this.annotation,this.annotationModel,!0);this.row.setSelected(!0);this.annotationExistingContent=$("<div>").addClass("AnnotationTable enableTextSelection").append(this.row.element);
this.setContent(this.annotationExistingContent);this.on("contentResized",g.bind(function(a){this.row.setAvailableHeight(a.height)},this));this.row.setAvailableHeight(this.content.height())};a.prototype.repaint=function(a){this._isInitialized&&(c.prototype.repaint.call(this),this.row.annotationUpdated(a))};return a});
define("web-viewer/annotation/AnnotationPopupModel","web-viewer/viewport/model/ViewportPopupModel web-viewer/annotation/AnnotationPopupNew web-viewer/annotation/AnnotationPopupExisting web-viewer/annotation/AnnotationConstants web-viewer/utils/ShapeUtils underscore".split(" "),function(c,h,g,a,o){var n=function(a,i,j,k){c.call(this,a,i);this.annotation=j;this.annotationModel=k;this.popup=null};n.prototype=Object.create(c.prototype);n.prototype.constructor=n;n.prototype.repaint=function(a){null!=this.popup&&
this.popup.repaint(a)};n.prototype.getPopup=function(a){a=a.getCanvas();null===this.popup?this._createPopup(a):this.popup.setContainment(a);return this.popup};n.prototype._createPopup=function(a){this.popup=this.annotation.isNew?new h(this.f,this.id,this.annotation,this.annotationModel,a):new g(this.f,this.id,this.annotation,this.annotationModel,a);this.popup.on("closed",_.bind(this.onClosed,this));this.popup.on("pinned",_.bind(this.onPinned,this));this.popup.on("clicked",_.bind(this.onClicked,this))};
n.prototype.onDestroy=function(){null!=this.popup&&this.popup.remove()};n.prototype.onResized=function(a,c){var j=a.copy();j.origin.y-=j.size.height;this.annotation.popuprect.rectEquals(j)||(this.annotation.popuprect=j,c||this._fireAnnotationChanged("POPUP_SIZE"))};n.prototype.onDragged=function(a){a=a.copy();a.y-=this.annotation.popuprect.size.height;this.annotation.popuprect.origin.equals(a)||(this.annotation.popuprect.origin=a,this._fireAnnotationChanged("POPUP_POSITION"))};n.prototype.onClosed=
function(){this.annotationModel.unselectAllAnnotations(!0,!0);this.annotation.popupIsOpen&&(this.annotation.popupIsOpen=!1,this.annotation.setModified("POPUP_PINNED"));this.annotationModel.modelChanged(this.annotation)};n.prototype.onPinned=function(a){this.annotation.popupIsOpen!==a&&(this.annotation.popupIsOpen=a,this._fireAnnotationChanged("POPUP_PINNED")||this.popup.repaint())};n.prototype.onClicked=function(){this.annotationModel.selectAnnotation(this.annotation)};n.prototype._fireAnnotationChanged=
function(a){return this.annotationModel.canChangeAnnotation(this.annotation)?(this.annotation.setModified(a),this.annotationModel.modelChanged(this.annotation),!0):!1};n.prototype.getWorldOrigin=function(){return new o.Point(this.annotation.popuprect.left(),this.annotation.popuprect.bottom())};n.prototype.getWorldSize=function(){return this.annotation.popuprect.size};n.prototype.getSceneOffset=function(){if(this.annotation.getType()==a.AnnotationType.ANNOT_PIN)return new o.Size(a.AnnotationPin.imagewidth,
0)};return n});
define("web-viewer/annotation/AnnotationPopupsLayerModel",["web-viewer/viewport/model/ViewportLayerModel","web-viewer/annotation/AnnotationPopupModel","underscore"],function(c,h,g){var a=function(a,h,l){c.call(this,a,h);this.f=a;this.annotationModel=l;this._createModels();this.annotationModel.on("modelContentChanged",g.bind(function(){this.removeAllPopupModels();this._createModels()},this));this.annotationModel.on("modelChanged",g.bind(function(){var a=this.annotationModel.getAnnotationsPage();if(null!==
a&&void 0!==a){this.resetTransformation();this.getTransform().scale(1,-1);var c=a.getRotation(),k=this.f.getModule("viewport").getWorldBounds();this.calculateTransformation(k,a.getPageSize(),this.annotationModel.getAnnotationsOffset(),c,a.isFlipped())}this.modelChanged()},this));this.annotationModel.on("selectedAnnotation",g.bind(function(a){if(this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")){var c=a.getGodfather(),k=this.getPopupModel(c.name);void 0!==k&&(c==a?k.repaint():k.repaint(a))}this._updateModels();
this.modelChanged()},this));this.annotationModel.on("unselectedAnnotation",g.bind(function(a){this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")&&(a=this.getPopupModel(a.getGodfather().name),void 0!==a&&a.repaint());this._updateModels()},this));this.annotationModel.on("annotationDeleted",g.bind(function(a){var c=a.getGodfather();a==c?this.removePopupModel(a.name):(a=this.getPopupModel(c.name),void 0!==a&&a.repaint())},this));this.annotationModel.on("annotationAdded",g.bind(function(a){this._createModel(a)},
this));this.annotationModel.on("annotationUpdated",g.bind(function(a,c){var k=this.getPopupModel(a.getGodfather().name);void 0!==k&&k.repaint(c);this._updateModels()},this));this.annotationModel.on("annotationListVisible",g.bind(function(){this._updateModels();this.modelChanged()},this));this.annotationModel.on("readWriteChanged",g.bind(function(){g.each(this.getPopupModels(),function(a){a.repaint()},this);this.modelChanged()},this));this.annotationModel.on("temporarilyDisableChanged",g.bind(function(){this._updateModels()},
this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",g.bind(function(){this._updateModels();this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",g.bind(function(){this._updateModels();this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWCOUNT",g.bind(function(){g.each(this.getPopupModels(),function(a){var c=this.annotationModel.getAnnotation(a.getId());
this.annotationModel.isAnnotationOrReplySelected(c)&&a.repaint()},this);this.modelChanged()},this));this.f.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",g.bind(function(){this._updateModels()},this))};a.prototype=Object.create(c.prototype);a.prototype.constructor=a;a.prototype._updateModels=function(){this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?this.annotationModel.isAnnotationListVisible()?this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")?0<this.annotationModel.getSelectedAnnotations().length?
g.each(this.getPopupModels(),function(a){this._showSelected(a)},this):g.each(this.getPopupModels(),function(a){this._showPinnedOrSelected(a)},this):this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY")?g.each(this.getPopupModels(),function(a){this._showSelected(a)},this):g.each(this.getPopupModels(),function(a){this._showPinnedOrSelected(a)},this):g.each(this.getPopupModels(),function(a){this._showPinnedOrSelected(a)},this):g.each(this.getPopupModels(),function(a){a.hide()},this)};a.prototype._showSelected=
function(a){var c=this.annotationModel.getAnnotation(a.getId());this.annotationModel.isAnnotationOrReplySelected(c)?a.show():a.hide()};a.prototype._showPinnedOrSelected=function(a){var c=this.annotationModel.getAnnotation(a.getId());!this.annotationModel.isTemporarilyDisabledAndNoAnnotationsVisible()&&c&&(c.popupIsOpen||this.annotationModel.isAnnotationOrReplySelected(c))?a.show():a.hide()};a.prototype._createModels=function(){g.each(this.annotationModel.getAnnotations(),function(a){this._createModel(a)},
this);this._updateModels();this.modelChanged()};a.prototype._createModel=function(a){a.linkedto||(a=new h(this.f,a.name,a,this.annotationModel),this.addPopupModel(a))};return a});
define("web-viewer/annotation/AnnotationTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/utils/ShapeUtils web-viewer/utils/DrawUtils web-viewer/utils/ViewerUtils web-viewer/annotation/AnnotationConstants web-viewer/annotation/Annotation web-viewer/core/CoreConstants".split(" "),function(c,h,g,a,o,n,l,i){o=function(j,k){h.call(this,j,i.TOOLS.ANNOTATION);this.f=j;this._annotationModel=k;this._defaultState="defaultState";this._hoverState="hoverState";this._draggingState="draggingState";
this._anchorState="anchorState";this._anchor=void 0;this._touchDown=this._targetAnnotation=null;this.registerState(this._defaultState,function(a){return{mousemove:function(c){var b=a._getAnnotationLayer(c);b&&b.isVisible()&&(a._verifyObjects(c,b),(a._targetAnnotation||a._anchor)&&a.requestActivation())},mouseup:function(){},mousedown:function(c){a._getAnnotationLayer(c)&&(k.unselectAllAnnotations(),c.originalEvent.preventDefault())},mouseout:function(){a.isActive()&&j.emit("toolManager.request.deactivation",
a)},mouseleave:function(){a.isActive()&&j.emit("toolManager.request.deactivation",a)},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1}}}(this));this.registerState(this._hoverState,c.defaults(function(a){return{mousedown:function(c){1===c.which&&(a._verifyObjects(c),a._touchDown=a._getAnnotationLayer(c).getWorldPointFromScene(a.getScenePoint(c)),a._anchor&&a._targetAnnotation.annottype!=n.AnnotationType.ANNOT_FREEFORM?(j.emit("viewport.startInteractive"),a.changeState(a._anchorState)):
a._targetAnnotation&&(j.emit("viewport.startInteractive"),k.selectAnnotation(a._targetAnnotation),a.changeState(a._draggingState)));c.originalEvent.preventDefault()},mousemove:function(c){a._verifyObjects(c);a.cursorShouldChange()}}}(this),this.getState(this._defaultState)));this.registerState(this._draggingState,c.defaults(function(a){return{mousemove:function(c){a.cursorShouldChange();var b=a._getAnnotationLayer(c).getWorldPointFromScene(a.getScenePoint(c)),e=a._widget.getWorld().getWorldBounds(),
c=a._getAnnotationLayer(c).convertWorldRectToLayer(new g.Rect(new g.Point,e.size));c.origin.y=-(c.size.height+c.origin.y)-e.origin.y;c.origin.x+=e.origin.x;e=a.keepMoveSizeWithinRect(c,a._targetAnnotation.rect,a._touchDown.sizeTo(b));k.moveAnnotation(a._targetAnnotation,e);a._touchDown=b},mouseup:function(){j.emit("viewport.stopInteractive");a.changeState(a._hoverState)},mouseout:function(){j.emit("viewport.stopInteractive");a.changeState(a._hoverState)},enterState:function(){j.emit("viewport.startInteractive")},
leaveState:function(){j.emit("viewport.stopInteractive")}}}(this),this.getState(this._defaultState)));this.registerState(this._anchorState,c.defaults(function(c){return{mousemove:function(f){var f=c._getWorldPoint(f),b,e=null;switch(c._anchor.anchor){case a.LWANCHOR_TOPLEFT:e="NW";break;case a.LWANCHOR_TOPCENTER:e="N";break;case a.LWANCHOR_TOPRIGHT:e="NE";break;case a.LWANCHOR_BOTTOMLEFT:e="SW";break;case a.LWANCHOR_BOTTOMCENTER:e="S";break;case a.LWANCHOR_BOTTOMRIGHT:e="SE";break;case a.LWANCHOR_CENTERLEFT:e=
"W";break;case a.LWANCHOR_CENTERRIGHT:e="E"}b=e;if(null!=b){e=c._anchor.linework.rect.copy();if(-1<b.indexOf("E")||-1<b.indexOf("W"))if(-1<b.indexOf("W")){var d=c._anchor.linework.rect.left()-f.x;e.origin.x-=d;e.size.width+=d}else d=c._anchor.linework.rect.right()-f.x,e.size.width-=d;if(-1<b.indexOf("N")||-1<b.indexOf("S"))-1<b.indexOf("N")?(b=c._anchor.linework.rect.top()-f.y,e.origin.y-=b,e.size.height+=b):(b=c._anchor.linework.rect.bottom()-f.y,e.size.height-=b);k.transformAnnotation(c._anchor.linework,
e)}else c._anchor.anchor==a.LWANCHOR_START?k.updateStartEndOfAnnotation(c._anchor.linework,f,null):c._anchor.anchor==a.LWANCHOR_END&&k.updateStartEndOfAnnotation(c._anchor.linework,null,f);c._touchDown=f},mouseup:function(){j.emit("viewport.stopInteractive");c.cursorShouldChange();c.changeState(c._hoverState)},mouseleave:function(){j.emit("viewport.stopInteractive");c.cursorShouldChange();c.changeState(c._hoverState)},mouseout:function(){}}}(this),this.getState(this._defaultState)));this._override("initialize",
c.bind(function(a,f){this._super(a,f);this.persistentKeyEvents.push(["del",c.bind(function(){0<this._annotationModel.getSelectedAnnotations().length&&c.each(this._annotationModel.getSelectedAnnotations(),c.bind(function(b){this._annotationModel.deleteAnnotation(b)},this))},this),"keyup"]);this.changeState(this._defaultState);this.registerPassiveEvents(["mousemove","mousedown"]);this.registerActiveEvents("mousemove mousedown mouseup mouseout mouseleave contextmenu".split(" "))},this));this._override("activate",
c.bind(function(a){this._super(a);this.changeState(this._hoverState)},this));this._override("deactivate",c.bind(function(a){this._super(a);this.changeState(this._defaultState)},this))};o.prototype=Object.create(h.prototype);o.prototype.constructor=o;o.prototype.getDefaultCursor=function(){return this._anchor?this._cursorForAnchor():this.getCurrentStateName()==this._draggingState?this._annotationModel.canChangeAnnotation(this._targetAnnotation)?"cursor-moveObject":"cursor-notAllowed":"cursor-select"};
o.prototype._deActivate=function(){this.isActive()&&(this.changeState(this._defaultState),this.f.emit("toolManager.request.deactivation",this))};o.prototype._cursorForAnchor=function(){var a="cursor-moveObject";if(this._anchor.linework.annottype==n.AnnotationType.ANNOT_ARROW||this._anchor.linework.annottype==n.AnnotationType.ANNOT_LINE)return a;var c=this._getAnnotationLayer("Main");if(!c)return a;var m=c.getScenePointFromWorld(this._anchor.rect.center()),f=new g.Size(this._anchor.rect.size.width,
this._anchor.rect.size.height),m=new g.Rect(new g.Point(m.x-f.width/2,m.y-f.height/2),f),c=c.getSceneRectFromWorld(this._anchor.linework.rect);m.containsPoint(c.topleft())?a="NW":m.containsPoint(c.topcenter())?a="N":m.containsPoint(c.topright())?a="NE":m.containsPoint(c.centerleft())?a="W":m.containsPoint(c.centerright())?a="E":m.containsPoint(c.bottomleft())?a="SW":m.containsPoint(c.bottomcenter())?a="S":m.containsPoint(c.bottomright())&&(a="SE");return"cursor-resize"+a};o.prototype._getAnnotationLayer=
function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null};o.prototype._getClosestLineworkFromPoint=function(a,c){var m=c;m||(m=this._getAnnotationLayer(a));return m?m.getClosestLineworkFromPoint(this.getScenePoint(a)):null};o.prototype._getWorldPoint=function(a){var c=this._annotationModel.getAnnotationsPage(),a=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!1);a.y=c.getPageSize().height-a.y;var m=c.getDocumentPageOrigin();a.offset(new g.Size(-m.x,m.y));
var f=c.getTrimboxRect().size,m=0;0!==f.width&&0!==f.height&&(m=c.getPageSize().height-(f.height+c.getMargins().top+c.getMargins().bottom));f=c.getMargins();c.isReaderSpread()&&c.get("isRightPage")&&(f.left=-f.left);a.offset(new g.Size(-f.left,-f.bottom-m));return a};o.prototype._verifyObjects=function(a,c){if(!c&&(c=this._getAnnotationLayer(a),!c))return;var m=this._getClosestLineworkFromPoint(a,c);this._anchor=this._targetAnnotation=null;m&&(m instanceof l?this._targetAnnotation=m:m.anchor&&(this._anchor=
m,this._targetAnnotation=m.linework));!m&&!this._targetAnnotation&&this._deActivate(a)};return o});
define("web-viewer/annotation/AnnotationDrawTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/annotation/Annotation web-viewer/utils/LineworkPoint web-viewer/utils/ListenerUtil web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(c,h,g,a,o,n,l,i,j,k,m){a=function(a,b,e){h.call(this,a,m.TOOLS.ANNOTATION_DRAW);i.mixin(this,a);var d;this.drawLinkedAnnotation=
!1;this._annotationModule=e;this._annotationModel=b;this.setAnnotationType=function(b){a.setOption("PREFERENCES_ANNOTATION_TOOLMODE",b)};this.getAnnotationType=function(){return a.getOption("PREFERENCES_ANNOTATION_TOOLMODE")};this.setAnnotationColor=function(b){a.getCurrentUser().setColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR",b)};this.getAnnotationColor=function(){return a.getProperty("annotationcolor")?a.getProperty("annotationcolor"):a.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};
this.getDefaultCursor=function(){return"cursor-drawAnnotation"};this.addGlobalAnnotation=function(){this.drawLinkedAnnotation||b.unselectAllAnnotations(!0,!0);var e=a.getModule("viewport").getWorldBounds();k("Main")&&(d=new n(a),d.initAnnotation(this.getAnnotationType(),this.getAnnotationColor(),!1,b),d.rect=a.getModule("viewport").getWorld().getSceneRectFromWorld(e),r("Main"))};this._registerListener("addGlobalAnnotation",function(){if(this.f.isParameterUpdateOngoing())var a=this._registerListener("parameters.changed",
function(){this._unregisterListener(a);this.addGlobalAnnotation()},this,this.f.getDocumentController());else this.addGlobalAnnotation()},this,this._annotationModel);var k=c.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{mousedown:function(){},mouseup:function(){},mousemove:function(){},mouseout:function(){},contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},mouseleave:function(){},click:function(){},
canBeInterrupted:!0});this.registerState("draw",c.defaults({mousedown:c.bind(function(e){if(1===e.which){this.drawLinkedAnnotation||b.unselectAllAnnotations(!0,!0);this.requestCanvasLayer(e);var c=this.keepPointWithinWorldBounds(this.getWorldPoint(e),!0);d=new n(a);d.initAnnotation(this.getAnnotationType(),this.getAnnotationColor(),!1,b);d.rect=new g.Rect(c,new g.Size);this.changeState("drawing")}e.originalEvent.preventDefault()},this)},this.getState("default")));var r=c.bind(function(a){p();a||(d=
null);d&&2===d.pointArray.length&&d.pointArray[0].x==d.pointArray[1].x&&d.pointArray[0].y==d.pointArray[1].y&&(d=null);if(null!==d&&(0===Math.abs(d.rect.size.width)||0>=Math.abs(d.rect.size.height)))0===Math.abs(d.rect.size.width)&&0>=Math.abs(d.rect.size.height)?d=null:d.annottype!=j.AnnotationType.ANNOT_ARROW&&d.annottype!=j.AnnotationType.ANNOT_LINE&&(d=null);if(d){var b=k(a);b?(d.rect=b.getWorldRectFromScene(d.rect),this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(d.rect,
c.bind(function(a){var e=this.drawLinkedAnnotation;a&&!e&&(this.drawLinkedAnnotation=!0);this.createAnnotation(d,b);a&&!e&&(this.drawLinkedAnnotation=!1)},this),function(){d=null},this.drawLinkedAnnotation):this.createAnnotation(d,b)):d=null}this.changeState("draw")},this);this.createAnnotation=function(a,d){for(var e=0;e<a.pointArray.length;e++){var c=a.pointArray[e],f=new g.Point(c.x,c.y),f=d.getWorldPointFromScene(f);c.x=f.x;c.y=f.y}this.drawLinkedAnnotation?b.addLinkedAnnotation(a):(b.addAnnotation(a),
this.isActive()&&this.requestDeactivation())};var q=c.throttle(c.bind(function(){var a=this.getCanvasCtx();if(a){var b=this.getCanvasSize();a.clearRect(0,0,b.width,b.height);d&&o.drawOverlay(this.f,a,[d])}},this),40);this.registerState("drawing",c.defaults({enterState:function(){a.emit("viewport.startInteractive");a.emit("layout.disableTextSelection")},leaveState:function(){a.emit("viewport.stopInteractive");setTimeout(function(){a.emit("layout.enableTextSelection")},500)},mousemove:c.bind(function(a){var b=
d.rect.copy(),e=this.keepPointWithinWorldBounds(this.getWorldPoint(a),!0);if(this.getAnnotationType()==j.AnnotationType.ANNOT_FREEFORM){a=new l;if(0===d.pointArray.length)a.makeMoveTo(d.rect.origin.x,d.rect.origin.y);else{var c=d.pointArray[d.pointArray.length-1];if(0>Math.abs(c.x-e.x)||0>Math.abs(c.y-e.y))return;a.makeLineTo(e.x,e.y)}d.pointArray.push(a);e=Math.abs(a.x-b.origin.x);a.x<b.origin.x?(e=Math.abs(b.origin.x-a.x),b.origin.x=a.x,b.size.width+=e):e>b.size.width&&(b.size.width=e);e=Math.abs(a.y-
b.origin.y);a.y<b.origin.y?(e=Math.abs(b.origin.y-a.y),b.origin.y=a.y,b.size.height+=e):e>b.size.height&&(b.size.height=e)}else b.size=d.rect.origin.sizeTo(e);d.setRect(b,!0);q()},this),mouseclick:function(){},mouseup:function(a){r(a)},mouseleave:function(){r()},mousedown:function(a){a.originalEvent.preventDefault()},canBeInterrupted:!1},this.getState("default")));this.canBeInterrupted=function(){return!1};this.activeKeyEvents=[];this.persistentKeyEvents=[];this._override("initialize",function(a,
b){this._super(a,b);this.changeState("default");this.registerActiveEvents("mousedown mousemove mouseup mouseout mouseleave contextmenu".split(" "));this.activeKeyEvents.push(["shift",c.bind(function(){this.drawLinkedAnnotation=!0},this),"keydown"]);this.activeKeyEvents.push(["shift",c.bind(function(){this.drawLinkedAnnotation=!1},this),"keyup"])});var p=c.bind(function(){this.releaseCanvasLayer()},this);this.canBeActivated=function(){return b.canChangeAnnotations()};this._override("activate",function(a){this._super(a);
this.getAnnotationType();this.getAnnotationColor();b.setLockSelection(!0);this.changeState("draw")});this._override("deactivate",function(a){this._super(a);this.changeState("default");p();this.drawLinkedAnnotation=!1;b.setLockSelection(!1)});a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",c.bind(function(a,b){!b&&this.isActive()&&this.requestDeactivation()},this))};a.prototype=Object.create(h.prototype);return a.prototype.constructor=a});
define("web-viewer/annotation/AnnotationIndicatorTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/viewport/model/ViewportLayerModel web-viewer/utils/ShapeUtils web-viewer/annotation/AnnotationConstants web-viewer/core/CoreConstants".split(" "),function(c,h,g,a,o,n){c=function(c,i){h.call(this,c,n.TOOLS.ANNOTATION_INDICATOR);this.f=c;this.layerModel=new g(c,"annotationIndication");this.layerModel.annotation=null;this.layerModel.tool=this;this.layerModel.annotationModel=i;this.layerModel.alpha=
0.7;this.layerModel.render=function(c,k){c.fillStyle="rgba(0, 0, 0, "+this.alpha+")";c.clearRect(k.origin.x,k.origin.y,k.size.width,k.size.height);c.beginPath();c.rect(k.origin.x,k.origin.y,k.size.width,k.size.height);c.fill();c.save();if(this.annotation){var m=Math.abs(this.tool.sceneToWorldSize(new a.Size(10,10)).width),f=this.annotationModel.getAnnotationsPage();if(null!==f&&void 0!==f){this.resetTransformation();this.getTransform().scale(1,-1);var b=f.getRotation(),e=this.f.getModule("viewport").getWorldBounds();
this.calculateTransformation(e,f.getPageSize(),this.annotationModel.getAnnotationsOffset(),b,f.isFlipped())}f=this.annotation.rect.copy();f.normalize();c.clearRect(f.origin.x-m,f.origin.y+f.size.height+m,f.size.width+2*m,-f.size.height-2*m);b=this.annotationModel.getAnnotationLinks(this.annotation);for(e=0;e<b.length;e++)f=b[e].rect.copy(),f.normalize(),c.clearRect(f.origin.x-m,f.origin.y+f.size.height+m,f.size.width+2*m,-f.size.height-2*m)}c.restore()};this._override("activate",function(){this._super();
this.f.getModule("viewport").addLayer("annotationIndication",this.layerModel)});this._override("deactivate",function(a){this._super(a);this.f.getModule("viewport").removeLayer("annotationIndication")})};c.prototype=Object.create(h.prototype);c.prototype.constructor=c;c.prototype.canBeInterrupted=function(){return!1};c.prototype.setAnnotation=function(a){this.layerModel.annotation=a};return c});
define("tpl!web-viewer/annotation/AnnotationCustomFilterPopup",function(){return function(c){var h,g="",g=g+('\r\n    <div class="filterOperator">\r\n        <span class="operatorText">'+(null==(h=c.i18n("FilterMatch"))?"":_.escape(h))+'</span>\r\n        <select class="filterOperatorSelector">\r\n            <option ');0==c.filterOperator&&(g+='selected="selected"');g+=' value="0">'+(null==(h=c.i18n("AnnotFilterAllOperator"))?"":_.escape(h))+"</option>    \r\n            <option ";1==c.filterOperator&&
(g+='selected="selected"');g+=' value="1">'+(null==(h=c.i18n("AnnotFilterAnyOperator"))?"":_.escape(h))+'</option>\r\n        </select>\r\n        <span class="operatorText">'+(null==(h=c.i18n("FilterOperator"))?"":_.escape(h))+'</span>\r\n    </div>\r\n    <div class="filterRows">\r\n        ';_.each(c.getFilterRows(),function(a,o){g+='\r\n            <div class="" data-bind="'+(null==(h=o)?"":_.escape(h))+'">\r\n                '+(null==(h=c.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",
a,"filter"))?"":h)+"\r\n            </div>\t\r\n        "});return g+='\r\n    </div>\r\n    <a class="addFilterRow">\r\n        <i class="icon-WCR_Filter-Add12"></i><span class="addFilterRowText">'+(null==(h=c.i18n("AnnotFilterAddRow"))?"":_.escape(h))+"</span>\r\n    </a>"}});
define("tpl!web-viewer/annotation/AnnotationCustomFilterRow",function(){return function(c){var h,g="",g=g+('<div class="filterRow" data-bind="'+(null==(h=c.filter.filterId)?"":_.escape(h))+'">\r\n    <select class="filterType">\r\n        ');_.each(c.getFilterTypes(),function(a,o){g+="\r\n            <option ";c.filter.filterType==o&&(g+='selected="selected"');g+=' value="'+(null==(h=o)?"":_.escape(h))+'">'+(null==(h=c.i18n(a))?"":_.escape(h))+"</option>\r\n        "});g+='\r\n    </select>\r\n    <select class="filterCondition">\r\n        <option ';
0==c.filter.filterCondition&&(g+='selected="selected"');g+=' value="0">'+(null==(h=c.i18n("AnnotFilterIs"))?"":_.escape(h))+"</option>\r\n        <option ";1==c.filter.filterCondition&&(g+='selected="selected"');g+=' value="1">'+(null==(h=c.i18n("AnnotFilterIsNot"))?"":_.escape(h))+'</option>\r\n    </select>\r\n    <select class="filterOption">\r\n        ';_.each(c.getOptions(c.filter.filterType,c.filter.filterOption),function(a,o){g+="\r\n            <option ";c.filter.filterOption===o&&(g+='selected="selected"');
g+=" ";"hidden"===o&&(g+="selected hidden");g+=' value="'+(null==(h=o)?"":_.escape(h))+'">\r\n                '+(null==(h=a)?"":_.escape(h))+"\r\n            </option>\r\n        "});g+="  \r\n    </select>\r\n    ";0!==c.filter.filterId&&(g+='\r\n        <a class="removeFilterRow" data-bind="'+(null==(h=c.filter.filterId)?"":_.escape(h))+'">\r\n            <i class="icon-WCR_Filter-Remove12"></i>\r\n        </a>\r\n    ');return g+="\r\n</div>"}});
define("web-viewer/annotation/AnnotationCustomFilterPopup","web-viewer/core/PrivateChannel web-viewer/layout/component/Popup web-viewer/layout/component/ToolbarButton Template web-viewer/annotation/AnnotationConstants tpl!web-viewer/annotation/AnnotationCustomFilterPopup tpl!web-viewer/annotation/AnnotationCustomFilterRow jquery underscore".split(" "),function(c,h,g,a,o,n,l,i,j){l=function(k,m,f){h.call(this,k,m,k.getContext());c.installTo(this,k,["annotationFilterPopup"]);this._annotationModel=f;
this._filterModel=this._annotationModel.getAnnotationFilterModel();this._savedFilterState=null;this._wasCustomFilterActive=!1;this._filterContent=i("<div>").addClass("annotationFilter");this._location=null;this.content.append(this._filterContent);this._okButton=new g(this.f,"okButton",i("<span/>"),!1,j.bind(function(){this._filterModel.setCustomFilterActive(!0);this._filterModel.fireFilterStateChanged();this.hide()},this));this._okButton.addClass("btn-success");this._cancelButton=new g(this.f,"cancelButton",
i("<span/>"),!1,j.bind(function(){this._filterModel.setFilterState(this._savedFilterState);this._savedFilterState=null;this._wasCustomFilterActive||this._filterModel.setCustomFilterActive(!1);this.hide()},this));this._cancelButton.addClass("btn");this.addButton(this._cancelButton.element);this.addButton(this._okButton.element);this.t=new a(this.f.i18n,n);this.t.setContext(this._filterContent);this.t.d.getFilterRows=j.bind(function(){return this._filterModel.getFilterRows()},this);this.t.d.getFilterTypes=
j.bind(function(){return j.values(o.FilterTypeNameLocs)},this);this.t.d.getOptions=j.bind(function(a,e){var d=this._annotationModel.getUsers();if(a==o.FilterTypes.AUTHOR)return e&&void 0===d[e]&&(d.hidden=this.f.i18n.t("AnnotFilterUserNotAvailable")),d;if(a==o.FilterTypes.REVIEWSTATE||a==o.FilterTypes.REVIEWAUTHORANDSTATE){var c={};j.each(o.AnnotationReviewStateLocs,function(a,b){c[b]=this.f.i18n.t(a)},this);if(a==o.FilterTypes.REVIEWSTATE)return c;var f={};j.each(d,function(a,b){j.each(c,function(b,
d){f[a+" "+d]=a+" "+b});b!==j.last(j.keys(d))&&(f[a+"Delimiter"]="\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500\u2500")},this);e&&void 0===f[e]&&(f.hidden=this.f.i18n.t("AnnotFilterUserNotAvailable"));return f}},this);this.on("closed",j.bind(function(){this.hide()},this));this.t.bind("click",".addFilterRow",function(){var a=this._filterModel.addEmptyRow();this._addFilterRow(a)},this);this.t.bind("click",".removeFilterRow",function(a){a=i(a).attr("data-bind");this._removeFilterRow(a)},this);
this.t.bind("change",".filterType",function(a){var e=i(a).parent().attr("data-bind"),a=i(a).val(),d=this.t.d.getOptions(a);this._filterModel.updateFilterType(e,a,j.first(j.keys(d)));this._rerenderFilterRow(e)},this);this.t.bind("change",".filterCondition",function(a){var e=i(a).parent().attr("data-bind"),a=i(a).val();this._filterModel.updateFilterCondition(e,a)},this);this.t.bind("change",".filterOption",function(a){var e=i(a).parent().attr("data-bind"),a=i(a).val();this._filterModel.updateFilterOption(e,
a)},this);this.t.bind("change",".filterOperatorSelector",function(a){a=i(a).val();this._filterModel.setFilterOperator(a)},this);this.f.i18n.loadBundle("viewer",function(){this.setHeader(i("<span/>").addClass("popupTitle").html(this.f.i18n.t("CustomAnnotationFilter")));this._okButton.element.html(this.f.i18n.t("ApplyCustomFilter"));this._cancelButton.element.html(this.f.i18n.t("AppDialogCancel"))},this)};l.prototype=Object.create(h.prototype);l.prototype.constructor=l;l.prototype.render=function(){this.f.i18n.loadBundle("viewer",
function(){this.t.d.filterOperator=this._filterModel.getFilterOperator();this.t.render()},this)};l.prototype._rerenderFilterRow=function(a){var c=this._filterModel.getFilterRow(a);this.content.find(".filterRow[data-bind='"+a+"']").html(this.t.d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",c,"filter"))};l.prototype._addFilterRow=function(a){a=this._filterModel.getFilterRow(a);this.content.find(".filterRows").append(this.t.d.callTemplate("web-viewer/annotation/AnnotationCustomFilterRow",
a,"filter"));this.recalculateSize(this._location,475)};l.prototype._removeFilterRow=function(a){this.content.find(".filterRow[data-bind='"+a+"']").remove();this._filterModel.removeFilterRow(a);this.recalculateSize(this._location,475)};l.prototype.show=function(a){this._savedFilterState=this._filterModel.getFilterState();this._wasCustomFilterActive=this._filterModel.isCustomFilterActive();this.render();this._location=a;this._filterModel.setCustomFilterActive(!0);h.prototype.show.call(this,a,475)};
return l});
define("web-viewer/annotation/AnnotationWidget","web-viewer/layout/AbstractWidget web-viewer/annotation/AnnotationRow web-viewer/annotation/AnnotationCustomFilterPopup jquery web-viewer/annotation/AnnotationConstants web-viewer/utils/ShapeUtils web-viewer/layout/component/MiniButton web-viewer/layout/component/Button web-viewer/layout/component/ButtonGroup web-viewer/layout/component/DropdownMiniButton web-viewer/layout/LayoutConstants web-viewer/layout/component/ToolbarButton underscore".split(" "),function(c,
h,g,a,o,n,l,i,j,k,m,f,b){f=function(e,d,f,h){c.call(this,e,m.Widget.ANNOTATION);this.f=e;this.annotationModel=f;this.annotationModule=d;this.annotationRows={};this._isForMobile=h===m.LayoutType.MOBILE;this.detailsDiv=a("<div>").addClass("annotationDetails enableTextSelection");this.nonScrollablePart=a("<div>").addClass("nonScrollablePart");this.detailsDiv.append(this.nonScrollablePart);this.warningMessage=a("<div/>").addClass("alert").text(this.annotationModel.getDisabledReason()).toggle(0<this.annotationModel.getDisabledReason().length);
this.nonScrollablePart.append(this.warningMessage);this.temporarilyDisabledDiv=a("<div/>").addClass("annotationsTemporarilyDisabled").hide();this.nonScrollablePart.append(this.temporarilyDisabledDiv);this.showCurrentFileAnnotationsButton=new i(this.f,"currentDocument",a("<span/>").text("current").prepend(a("<i>").addClass("icon showCurrentAnnotations")),!0,b.bind(function(){this.annotationModule.toggleCurrentPageAnnotations()},this));this.showCurrentFileAnnotationsButton.element.addClass("btn");this.showDifferenceFileAnnotationsButton=
new i(this.f,"differenceDocument",a("<span/>").text("reference").prepend(a("<i>").addClass("icon showDifferenceAnnotations")),!0,b.bind(function(){this.annotationModule.toggleDifferencePageAnnotations()},this));this.showDifferenceFileAnnotationsButton.element.addClass("btn");this.annotationToggleGroup=new j("annotationToggleBetweenCurrentAndDifference",[this.showCurrentFileAnnotationsButton,this.showDifferenceFileAnnotationsButton]);this.temporaryAnnotationToggler=a("<div/>").addClass("temporaryAnnotationToggle");
e.i18n.loadBundle("viewer",function(){this.temporaryAnnotationToggler.append(a("<span/>").text(this.f.t("AnnShowAnnotationsFor")+": ")).append(a("<br/>")).append(this.annotationToggleGroup.element);this.showCurrentFileAnnotationsButton.setContent(a("<span/>").text(this.f.t("CaptionCurrent")).prepend(a("<i>").addClass("icon showCurrentAnnotations")));this.showDifferenceFileAnnotationsButton.setContent(a("<span/>").text(this.f.t("CaptionPrevious")).prepend(a("<i>").addClass("icon showDifferenceAnnotations")))},
this);this.temporarilyDisabledDiv.append(this.temporaryAnnotationToggler);this.temporaryAnnotationToggler.hide();this.header=a("<div>").addClass("annotationFilter");this._annotationFilters=a("<div>").addClass("annotationFilterSelectors");this._customFilters=a("<div>").addClass("customFilterControls");this.header.append(this._annotationFilters);this._numberOfSelectedThreads=a("<span/>").addClass("threadsCount");this.header.append(this._customFilters);this._customFilters.append(this._numberOfSelectedThreads);
this._isForMobile||(this._customFilterPopup=new g(this.f,"customFilter",this.annotationModel),this.annotationModel.getAnnotationFilterModel().on("filterReset",b.bind(function(){this._customFilterPopup.isVisible()&&this._customFilterPopup.hide()},this)),this._pinFilterButton=new l(this.f,"pinFilter","icon-WCR_Pin12",!0,b.bind(function(){this.annotationModel.getAnnotationFilterModel().toggleAnnotationPinnedState();this._updateFilterPinnedIcon()},this)),this._updateFilterPinnedIcon(),this._pinFilterButton.element.addClass("pinAnnotationFilter"),
this._openFilterPopupButton=new l(this.f,"customFilter","icon-WCR_Filter12",!0,b.bind(function(){var a=250>this.context.offset().left?this.context.width():this.context.offset().left-250,a=new n.Point(a,this.context.offset().top);this._customFilterPopup.show(a)},this)),this._openFilterPopupButton.element.addClass("customFilterBtn"),this._openFilterPopupButton.setTooltip("viewer","OpenCustomFilterPopup"));this.annotationsListWrapper=a("<div>").addClass("annotationListWrapper");this.annotationsListWrapper.on("makeMeVisible",
b.partial(function(b,d){var e=a(d.target).offset().top,c=a(d.target).outerHeight(),f=a(this).offset().top,m=a(this).outerHeight();if(0>e-f||e+c>f+m)e=a(this).scrollTop()+e-f,a(this).scrollTop(e);b._visibleItem=a(d.target);d.preventDefault();d.stopPropagation()},this));this._isForMobile||(this._customFilters.append(this._openFilterPopupButton.element),this._customFilters.append(this._pinFilterButton.element));this.detailsDiv.append(this.annotationsListWrapper);this.annotationList=a("<div>").addClass("annotationList");
this._isForMobile?this.annotationsListWrapper.append(this.header):this.nonScrollablePart.append(this.header);this.annotationsListWrapper.append(this.annotationList);e.i18n.loadBundle("viewer",function(){this.setTitle(this.f.i18n.t("AnnWidgetTitle"))},this);this.inDOM={};this.toBeRemovedFromDOM={};this.saveButton=null;this.disableSaveButton=!1;this.annotationModel.on("disabledReasonChanged",b.bind(function(){this.warningMessage.text(this.annotationModel.getDisabledReason());this.warningMessage.toggle(0<
this.annotationModel.getDisabledReason().length);this.resized()},this));this.annotationModel.on("save.finished",b.bind(function(){this.disableSaveButton=!1;this.updateSaveButton();this.reloadButton.setEnabled(!0)},this));this.annotationModel.on("readWriteChanged",b.bind(function(){b.each(this.annotationRows,function(a){a.annotationUpdated()})},this));this.saveButton=new l(e,"saveAnnotations","icon-WCR_Save",!0,b.bind(function(){this.annotationModel.save()},this),"fontIconDisabled icon-WCR_Save");
this.updateSaveButton();this.stepThroughButton=new l(e,"stepThroughAnn","icon-WCR_Step",!0,b.bind(function(a){a.shiftKey?this.annotationModel.goToAnnotation(!1):this.annotationModel.goToAnnotation(!0)},this));this.stepThroughButton.setDisabledIcon("icon-WCR_Step fontIconDisabled");this.stepThroughButton.element.on("contextmenu",b.bind(function(a){a.preventDefault();this.stepThroughButton.isEnabled()&&this.annotationModel.goToAnnotation(!1)},this));this.stepThroughButton.setTooltip("viewer","StepThroughAnnTT");
this.reloadButton=new l(e,"reloadAnnotations","icon-WCR_Refresh",!0,b.bind(function(){this.annotationModel.reload()},this),"icon-WCR_Refresh fontIconDisabled");this.reloadButton.setTooltip("viewer","ReloadMiniBtnTT");this.annotationModel.on("save.started",b.bind(function(){this.reloadButton.setEnabled(!1);this.disableSaveButton=!0;this.updateSaveButton()},this));this.annotationModel.on("reload.started",b.bind(function(){this.reloadButton.setEnabled(!1)},this));this.annotationModel.on("reload.finished",
b.bind(function(){this.reloadButton.setEnabled(!0)},this));this.annotationModel.on("temporarilyDisableChanged",b.bind(this.updateListVisibility,this));this.annotationModel.on("disabledReasonChanged",b.bind(this.updateListVisibility,this));this.updateListVisibility();e.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_DATESORT_MODE",b.bind(function(a,b){this.setSortByMode(b)},this));e.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_NEXT_MODE",b.bind(function(a,b){this.setStepThroughMode(b)},
this));e.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",b.bind(function(a,b){this.setShowSelectedAnnotationOnly(0<b)},this));e.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",b.bind(function(a,b){this.setShowSelectedAnnotationPopupOnly(0<b)},this));e.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",b.bind(function(a,b){this.setShowSequenceLabel(0<b)},this));e.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_SHOWCOUNT",
b.bind(function(a,b){this.setShowCharLineCounter(0<b)},this));this.optionButton=new k(e,"annotationSettings","icon-WCR_Settings-submenu");e.i18n.loadBundle("viewer",function(){function a(b,d){d&&this.setStepThroughMode(b,!0)}function d(a,b){b&&this.setSortByMode(a,!0)}this.optionButton.addOption({name:"stepByThread",content:this.f.i18n.t("AnnSortThread"),onchange:b.bind(a,this,o.StepThroughMode.BY_THREAD),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==o.StepThroughMode.BY_THREAD,userCannotUncheck:!0});
this.optionButton.addOption({name:"stepWithReplies",content:this.f.i18n.t("AnnSortDate"),onchange:b.bind(a,this,o.StepThroughMode.WITH_REPLIES),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==o.StepThroughMode.WITH_REPLIES,userCannotUncheck:!0});this.optionButton.addOption({name:"stepWithZoom",content:this.f.i18n.t("AnnSortThreadFit"),onchange:b.bind(a,this,o.StepThroughMode.WITH_ZOOM),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==o.StepThroughMode.WITH_ZOOM,userCannotUncheck:!0});
this.optionButton.addOption({name:"stepWithLinked",content:this.f.i18n.t("AnnSortAreaFit"),onchange:b.bind(a,this,o.StepThroughMode.WITH_LINKED),selected:this.f.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")==o.StepThroughMode.WITH_LINKED,userCannotUncheck:!0});this.optionButton.addDivider();this.optionButton.addOption({name:"showselann",content:this.f.i18n.t("AnnListShowSel"),onchange:b.bind(function(a){this.setShowSelectedAnnotationOnly(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY")});
this.optionButton.addOption({name:"showselannpopup",content:this.f.i18n.t("AnnListShowSelPopup"),onchange:b.bind(function(a){this.setShowSelectedAnnotationPopupOnly(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY")});this.optionButton.addOption({name:"shownumber",content:this.f.i18n.t("AnnSeqLabelShow"),onchange:b.bind(function(a){this.setShowSequenceLabel(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE")});this.optionButton.addOption({name:"showCharLineCount",
content:this.f.i18n.t("AnnCountShow"),onchange:b.bind(function(a){this.setShowCharLineCounter(a,!0)},this),selected:0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWCOUNT")});this.optionButton.addDivider();this.optionButton.addOption({name:"sortbycreationdate",content:this.f.i18n.t("DateSortCreation"),onchange:b.bind(d,this,o.AnnotationSortType.SORT_BY_CREATION_DATE),selected:this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===o.AnnotationSortType.SORT_BY_CREATION_DATE,userCannotUncheck:!0});
this.optionButton.addOption({name:"sortbymodificationdate",content:this.f.i18n.t("DateSortModification"),onchange:b.bind(d,this,o.AnnotationSortType.SORT_BY_MODIFICATION_DATE),selected:this.f.getOption("PREFERENCES_ANNOTATION_DATESORT_MODE")===o.AnnotationSortType.SORT_BY_MODIFICATION_DATE,userCannotUncheck:!0});this.setShowSelectedAnnotationOnly(0<this.f.getOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY"),!1);this.updateWarningBadge()},this);this.on("movingStarted",b.bind(function(){this.context&&
this.context.find("[id^=richText_]").each(function(){var b=a(this).data("richTextObj");b&&b.isInitialized()&&(b.destroy(),b.isDestroyed=!0)})},this));this.on("movingStopped",b.bind(function(){this.context&&this.context.find("[id^=richText_]").each(function(){var d=a(this).data("richTextObj");d&&d.isDestroyed&&b.defer(function(){d.init()})})},this));this.on("visible",function(a){f.setAnnotationListVisible(a)});f.setAnnotationListVisible(this.isVisible());f.on("selectedAnnotation",b.bind(this.selectAnnotation,
this));f.on("unselectedAnnotation",b.bind(this.deselectAnnotation,this));f.on("annotationAdded",b.bind(function(a,b){b||this.addAnnotation(a,!0)},this));f.on("annotationUpdated",b.bind(this.updateAnnotation,this));f.on("annotationDeleted",b.bind(this.deleteAnnotation,this));var q=b.bind(function(){this._updateButtons();this.renderCompleteWidget()},this),p=b.bind(function(){this._updateButtons()},this);this._override("setContext",function(a,d){this._super(a,d);this.renderCompleteWidget();this.context.append(this.detailsDiv);
this.headerExtra.append(this.saveButton.element).append(this.stepThroughButton.element).append(this.reloadButton.element).append(this.optionButton.element);this._updateButtons();this.annotationModel.on("filterChanged",q);this.annotationModel.on("modelContentChanged",q);this.annotationModel.on("modelChanged",p);this.annotationModel.on("changed.page",b.bind(function(){var a=b.keys(this.inDOM);b.each(a,function(a){this._removeFromDOM(a)},this);this.annotationRows={}},this));this.startHeartBeat();this.resized()});
this._override("destroy",function(){this._super();f.off("filterChanged",q);f.off("modelContentChanged",q);f.off("modelChanged",p);this.stopHeartBeat()})};f.prototype=Object.create(c.prototype);f.prototype.constructor=f;f.widgetName=m.Widget.ANNOTATION;f.prototype.getMinimumSize=function(){return new n.Size(250,150)};f.prototype.willFill=function(){return!0};f.prototype._updateButtons=function(){this.updateSaveButton();this.updateStepThroughButton(!0)};f.prototype.updateSaveButton=function(){if(this.saveButton)if(this.disableSaveButton)this.saveButton.setEnabled(!1);
else{var a=this.annotationModel.getUnsavedAnnotationCount();0<a?(this.saveButton.setEnabled(!0),this.saveButton.setBadge(a),0<this.annotationModel.getUnsavedAnnotations().length?0<this.annotationModel.getDeletedAnnotations().length?this.saveButton.setTooltip("viewer","SaveMiniBtnTT",[this.annotationModel.getUnsavedAnnotations().length,this.annotationModel.getDeletedAnnotations().length]):this.saveButton.setTooltip("viewer","SaveMiniBtnAnnTT",[this.annotationModel.getUnsavedAnnotations().length]):
this.saveButton.setTooltip("viewer","SaveMiniBtnDelTT",[this.annotationModel.getDeletedAnnotations().length])):this.saveButton.setEnabled(!1)}};f.prototype.updateWarningBadge=function(){var a=this.optionButton.getOptionValue("showselann"),b=this.optionButton.getOptionValue("showselannpopup");a||b?(this.optionButton.setWarning(),this.f.i18n.loadBundle("viewer",function(){var c=this.f.i18n.t("AnnWidgetOptionsTT")+".",c=c+("<br />"+this.f.i18n.t("Warn"));a&&(c+="  "+this.f.i18n.t("OnlySelectedAnnotationWarningTT"));
b&&this.optionButton.isActionEnabled("showselannpopup")&&(a&&(c+="<br />"),c+="  "+this.f.i18n.t("OnlySelectedAnnotationPopupWarningTT"));this.optionButton.setTooltip(c)},this)):(this.optionButton.removeWarning(),this.optionButton.setTooltip("viewer","AnnWidgetOptionsTT"))};f.prototype.updateStepThroughButton=function(a){0===this.annotationModel.getAnnotationCount()||!a?this.stepThroughButton.setEnabled(!1):this.stepThroughButton.setEnabled(!0)};f.prototype.setSortByMode=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_DATESORT_MODE",
a);this.optionButton.toggleOption("sortbycreationdate",a==o.AnnotationSortType.SORT_BY_CREATION_DATE);this.optionButton.toggleOption("sortbymodificationdate",a==o.AnnotationSortType.SORT_BY_MODIFICATION_DATE)};f.prototype.setShowSelectedAnnotationOnly=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",a?1:0);a&&(this.optionButton.toggleOption("showselannpopup",!1),this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",!1));this.updateWarningBadge()};f.prototype.setShowSelectedAnnotationPopupOnly=
function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDPOPUPONLY",a?1:0);a&&(this.optionButton.toggleOption("showselann",!1),this.f.setOption("PREFERENCES_ANNOTATION_SHOWSELECTEDONLY",!1));this.updateWarningBadge()};f.prototype.setStepThroughMode=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_NEXT_MODE",a);this.optionButton.toggleOption("stepWithReplies",a==o.StepThroughMode.WITH_REPLIES);this.optionButton.toggleOption("stepByThread",a==o.StepThroughMode.BY_THREAD);this.optionButton.toggleOption("stepWithZoom",
a==o.StepThroughMode.WITH_ZOOM);this.optionButton.toggleOption("stepWithLinked",a==o.StepThroughMode.WITH_LINKED)};f.prototype.setShowSequenceLabel=function(a,b){b&&this.f.setOption("PREFERENCES_ANNOTATION_SEQLABEL_VISIBLE",a?1:0);this.optionButton.toggleOption("shownumber",a)};f.prototype.setShowCharLineCounter=function(a,d){d&&this.f.setOption("PREFERENCES_ANNOTATION_SHOWCOUNT",a?1:0);this.optionButton.toggleOption("showCharLineCount",a);b.each(this.annotationRows,function(b){b.showHideCharLineCount(a,
!0)})};f.prototype.renderCompleteWidget=function(){this.f.i18n.loadBundle("viewer",function(){b.defer(b.bind(function(){this.renderHeader();this.renderAnnotationList()},this))},this)};f.prototype.renderHeader=function(){this._annotationFilters.empty();this._usercombo=a("<select>");var c=a("<option/>").text(this.f.i18n.t("AnnAllUsers")).val("All"),d=a("<option selected disabled hidden value=''/>").text(this.f.i18n.t("AnnotFilterCustomEnabled"));this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&
this._usercombo.append(d);this._usercombo.append(c);c=this.annotationModel.getUsers();b.each(c,function(b,d){var c=a("<option/>").text(b).val(d);this._usercombo.append(c)},this);if((c=this.annotationModel.getAnnotationFilterModel().getSelectedUser())&&!this.annotationModel.getAnnotationFilterModel().isCustomFilterActive())0<this._usercombo.find("option[value='"+c+"']").length?this._usercombo.val(c):(c=a("<option hidden selected/>").text(this.f.i18n.t("AnnotFilterUserNotAvailable")),this._usercombo.append(c));
this._annotationFilters.append(this._usercombo);this._usercombo.on("change",b.bind(function(a){"All"!=a.target.value?this.annotationModel.getAnnotationFilterModel().setSelectedUser(a.target.value):this.annotationModel.getAnnotationFilterModel().setSelectedUser(null)},this));this._statecombo=a("<select>");c=a("<option/>").text(this.f.i18n.t("AnnAllReviewState")).val("All");d=a("<option selected disabled hidden value=''/>").text(this.f.i18n.t("AnnotFilterCustomEnabled"));this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&
this._statecombo.append(d);this._statecombo.append(c);this._statecombo.append(a("<option>").text("------------------------------").attr("disabled","disabled"));c=a("<option/>").text(this.f.i18n.t("AnnStatusAny")).val("Any");this._statecombo.append(c);c=a("<option/>").text(this.f.i18n.t("AnnNoReviewState")).val("NOT_Any");this._statecombo.append(c);this._statecombo.append(a("<option>").text("------------------------------").attr("disabled","disabled"));b.each(o.AnnotationReviewState,function(b,d){var c=
a("<option/>").text(this.f.i18n.t(o.AnnotationReviewStateLocs[d])).val(o.AnnotationReviewState[d]);this._statecombo.append(c)},this);this._statecombo.append(a("<option>").text("------------------------------").attr("disabled","disabled"));b.each(o.AnnotationReviewState,function(b,d){var c=a("<option/>").text(this.f.i18n.t("AllExcept",this.f.i18n.t(o.AnnotationReviewStateLocs[d]))).val("NOT_"+o.AnnotationReviewState[d]);this._statecombo.append(c)},this);this._annotationFilters.append(this._statecombo);
this._statecombo.on("change",b.bind(function(a){if("All"!=a.target.value){var b=-1<a.target.value.indexOf("NOT_"),a=a.target.value;b&&(a=a.substring(4));this.annotationModel.getAnnotationFilterModel().setSelectedState(a,b)}else this.annotationModel.getAnnotationFilterModel().setSelectedState(null,!1);return!0},this));(c=this.annotationModel.getAnnotationFilterModel().getSelectedState())&&!this.annotationModel.getAnnotationFilterModel().isCustomFilterActive()&&this._statecombo.val((this.annotationModel.getAnnotationFilterModel().isInverseState()?
"NOT_":"")+c);this._customFilterPopup&&this._customFilterPopup.isVisible()&&this._customFilterPopup.render();this._updateNumberOfSelectedAnnotations()};f.prototype._updateNumberOfSelectedAnnotations=function(){this.f.i18n.loadBundle("viewer",function(){var a=this.f.i18n.t("SelectedThreadsCount",this.annotationModel.getAnnotationFilterModel().getNumberOfFilteredAnnotations(),this.annotationModel.getAnnotationCount());this._numberOfSelectedThreads.text(a)},this)};f.prototype.renderAnnotationList=function(){var a=
this.annotationModel.getFilteredAnnotations();this.toBeRemovedFromDOM=b.clone(this.inDOM);b.each(a,function(a){if(!(a.linkedto&&0<a.linkedto.length))if(this.annotationRows[a.name]){var b=this.annotationRows[a.name];b.element.next("hr").remove();b.setAnnotation(a);this._addToDom(b);b.element.show()}else this.addAnnotation(a)},this);b.each(this.toBeRemovedFromDOM,function(a,b){this._removeFromDOM(b)},this);this.toBeRemovedFromDOM={};this._fireResized()};f.prototype._addToDom=function(b){this.inDOM[b.name]=
1;delete this.toBeRemovedFromDOM[b.name];b.onDetachFromDOM();this.annotationList.append(b.element).append(a("<hr/>"));b.onReattachToDOM()};f.prototype._removeFromDOM=function(a){if(this.inDOM[a]){var b=this.annotationRows[a];b&&(b.element.next("hr").remove(),b.onDetachFromDOM(),b.element.detach());delete this.toBeRemovedFromDOM[a];delete this.inDOM[a]}};f.prototype.addAnnotation=function(a,d){if(!(a.linkedto&&0<a.linkedto.length)){var c=new h(this.f,a,this.annotationModel,void 0,void 0,this._isForMobile);
this.annotationRows[a.name]=c;var f=c.element;this._addToDom(c);f.on("click",b.bind(function(a){this.annotationModel.selectAnnotation(c.getAnnotation(),!0);a.stopPropagation()},this));var m=!1,k=!1;f.on("mousedown",b.bind(function(){m=!0;setTimeout(b.bind(function(){m&&(k=!0,this.f.emit("module.annotation.highlightAnnotation",c.getAnnotation()))},this),500)},this));f.on("mouseup",b.bind(function(){m&&k&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");k=m=!1},this));f.on("mouseout",
b.bind(function(){m&&k&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");k=m=!1},this));f.on("mouseleave",b.bind(function(){m&&k&&this.f.emit("toolManager.deactivateTool","annotationindicatortool");k=m=!1},this));this.annotationModel.isAnnotationOrReplySelected(a)&&this.selectAnnotation(a);this._updateNumberOfSelectedAnnotations();d&&this._fireResized()}};f.prototype.selectAnnotation=function(a){this.annotationRows[a.inreplyto]&&this.annotationRows[a.inreplyto].toggleReplyLimit(!1);
if(this.annotationRows[a.name]||this.annotationRows[a.inreplyto])a=this.annotationRows[a.name]||this.annotationRows[a.inreplyto].annotationRows[a.name],a.setSelected(!0),a.element.trigger("makeMeVisible")};f.prototype.deselectAnnotation=function(a){var b;this.annotationRows[a.name]&&(b=this.annotationRows[a.name]);this.annotationRows[a.inreplyto]&&(this.annotationRows[a.inreplyto].toggleReplyLimit(),void 0===b&&(b=this.annotationRows[a.inreplyto].annotationRows[a.name]));b&&b.setSelected(!1)};f.prototype.updateAnnotation=
function(a,b){if(this.annotationRows[a.name])this.annotationRows[a.name].annotationUpdated(b);else if(a.linkedto&&!a.parent&&this.annotationRows[a.linkedto])this.annotationRows[a.linkedto].annotationUpdated();else{var c=a.getGodfather();c!==a&&this.updateAnnotation(c,a)}};f.prototype.deleteAnnotation=function(a){this.annotationRows[a.name]?(this._removeFromDOM(a.name),delete this.annotationRows[a.name]):a.linkedto&&!a.parent&&this.annotationRows[a.linkedto]?(this._removeFromDOM(a.linkedto),delete this.annotationRows[a.linkedto]):
(a=a.getGodfather(),this.updateAnnotation(a));this._updateNumberOfSelectedAnnotations();this._fireResized()};f.prototype.resized=function(){this.isContextAvailable()&&b.defer(b.bind(function(){this.context.css("overflow","hidden");this.annotationsListWrapper.css("height","auto");var a=this.context.outerHeight(!0);this._isForMobile||(a-=this.header.outerHeight(!0));this.warningMessage.is(":visible")&&(a-=this.warningMessage.outerHeight(!0));this.temporarilyDisabledDiv.is(":visible")&&(a-=this.temporarilyDisabledDiv.outerHeight(!0));
0<a&&this.annotationsListWrapper.css("height",a);this._visibleItem&&this._visibleItem.trigger("makeMeVisible");this.context.css("overflow","auto")},this))};f.prototype.getPreferredSize=function(){return new n.Size(this.annotationsListWrapper.outerWidth(!0),this.annotationsListWrapper.outerHeight(!0)+this.nonScrollablePart.outerHeight(!0))};f.prototype.startHeartBeat=function(){this.canRunTimer=!0;this.updateTimers()};f.prototype.stopHeartBeat=function(){this.canRunTimer=!1};f.prototype._updateFilterPinnedIcon=
function(){this.annotationModel.getAnnotationFilterModel().isAnnotationFilterPinned()?(this._pinFilterButton.setIcon("pinned icon-WCR_Pin12"),this._pinFilterButton.setTooltip("viewer","AnnotFilterPinOn")):(this._pinFilterButton.setIcon("unpinned icon-WCR_Pin12"),this._pinFilterButton.setTooltip("viewer","AnnotFilterPinOff"))};f.prototype.updateTimers=function(){this.canRunTimer&&(b.each(this.annotationRows,function(a){a.updateTimers()}),setTimeout(b.bind(function(){this.updateTimers()},this),3E4))};
f.prototype.updateListVisibility=function(){this.annotationModel.isTemporarilyDisabled()?(this.temporarilyDisabledDiv.toggle(this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()),this.temporaryAnnotationToggler.toggle(this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()),this.showCurrentFileAnnotationsButton.setActive(this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()),this.showDifferenceFileAnnotationsButton.setActive(this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()),
this.annotationModel.isTemporarilyDisabledAndNoAnnotationsVisible()?(this.header.hide(),this.annotationsListWrapper.hide(),this.updateStepThroughButton(!1),this.reloadButton.setEnabled(!1)):(this.header.show(),this.annotationsListWrapper.show(),this.updateStepThroughButton(!0),this.reloadButton.setEnabled(!0))):(this.header.show(),this.annotationsListWrapper.show(),this.temporarilyDisabledDiv.hide(),this.updateStepThroughButton(!0),this.reloadButton.setEnabled(!0));this.resized()};return f});
define("web-viewer/annotation/AnnotationDataExtensions","web-viewer/annotation/Annotation web-viewer/data/AbstractDocumentPage web-viewer/utils/ShapeUtils utils/XMLUtils web-viewer/utils/ViewerUtils web-viewer/annotation/AnnotationConstants underscore".split(" "),function(c,h,g,a,o,n,l){return function(i){function j(a){var c="";if(a.inreplyto)return(a=a.getGodfather())&&0<=a.messagenumber&&(c=" ("+a.messagenumber+")"),i.i18n.t("AnnCommReply")+c;0<=a.messagenumber&&!a.isNew&&(c=" ("+a.messagenumber+
")");return i.i18n.t(n.AnnotationComments[a.annottype])+c}var k=i.getDataAdapter();k.WebCenter?(h.prototype._initAnnotationModule=function(){this._annotData||(this._annotData={dataStatus:"notAvailable",onAnnotationsAvailableCallbacks:[],annotations:[]})},h.prototype.requestAnnotations=function(a){this._initAnnotationModule();"available"===this._annotData.dataStatus?a(!0):"loading"===this._annotData.dataStatus?this._annotData.onAnnotationsAvailableCallbacks.push(a):this.hasAnnotations()?(this._annotData.onAnnotationsAvailableCallbacks.push(a),
this._fetchAnnotationsFromServer()):a(!0)},h.prototype.reloadAnnotations=function(a){this._initAnnotationModule();"loading"===this._annotData.dataStatus?this._annotData.onAnnotationsAvailableCallbacks.push(a):(this._annotData.onAnnotationsAvailableCallbacks.push(a),this._fetchAnnotationsFromServer())},h.prototype.resetAnnotations=function(){this._annotData.dataStatus="notAvailable";this._annotData.annotations=[]},h.prototype._fireOnAnnotationsAvailableCallbacks=function(a){l.each(this._annotData.onAnnotationsAvailableCallbacks,
function(c){c&&c(a)});this._annotData.onAnnotationsAvailableCallbacks=[];this._annotData.dataStatus=a?"available":"notAvailable"},h.prototype._fetchAnnotationsFromServer=function(){var c={};this.hasGraphics()?c.file=this.get("file"):this.hasCad()&&(c.cad=this.get("cad"),c.style=this.get("style"));this._annotData.dataStatus="loading";c=k.ViewServer("getannotations.jsp",c);i.ajax(c,{success:l.bind(function(c){if(c){var b=c.getElementsByTagName("status");if(b[0]&&(b=b[0].getElementsByTagName("value"),
b[0]&&"-1"===a.textContent(b[0]))){i.i18n.loadBundle("viewer",function(){i.emit("error.SEVERE",i.i18n.t("AnnOpenError",""),c)});return}}this._parseAnnotationData(c)},this),error:l.bind(function(a,b,c){try{var d=(new DOMParser).parseFromString(a.responseText,"text/xml");this._parseAnnotationData(d);return}catch(m){c=m}i.i18n.loadBundle("viewer",function(){i.emit("error.SEVERE",i.i18n.t("AnnOpenError",""),a,b,c)});this._fireOnAnnotationsAvailableCallbacks(!1)},this)})},h.prototype._parseAnnotationData=
function(a){this._initAnnotationModule();if(a)try{var f=a.getElementsByTagName("annots"),b,e;f&&1<=f.length&&(b=a.getElementsByTagName("annots")[0]);b&&(e=b.firstChild);var d={};if(null!=this._annotData.annotations)for(a=0;a<this._annotData.annotations.length;a++)this._annotData.annotations[a].runThroughAnnotation(!0,!0,!0,function(a){d[a.name]=a});for(a={};e;){if(1===e.nodeType){var k=e.getAttribute("name"),f=null;d[k]?(f=d[k],f.replies=[],f.links=[],f.states=[],f.resetUnsavedReply(),f.cancelModified(),
f._scaling=null,delete d[k]):f=new c(i);f.initWithXML(e,this._data.vsize);a[f.name]=f}e=e.nextSibling}d=null;this._annotData.annotations=[];for(var g in a)if(a.hasOwnProperty(g)){var h=a[g];if(h.inreplyto){var j=a[h.inreplyto];j&&(h.parent=j,h.state?j.states.push(h):j.replies.push(h))}else h.linkedto?a[h.linkedto]&&(a[h.linkedto].links.push(h),this._annotData.annotations.push(a[g]),h.parent=a[h.linkedto],h.messagenumber=h.parent.messagenumber,h.updateIndicator()):this._annotData.annotations.push(a[g])}}catch(l){i.i18n.loadBundle("viewer",
function(){i.emit("error.SEVERE",i.i18n.t("AnnDisplayError"),l)})}else this._annotData.annotations=[];this._fireOnAnnotationsAvailableCallbacks(!0)},h.prototype.getAnnotations=function(){this._initAnnotationModule();return this._annotData.annotations},h.prototype.getAnnotationsOffset=function(){var a=this.f.getModule("viewport"),c=this.getRotation()%360,b=this.isFlipped(),a=a.getWorldBounds(),e=this.getPageSize();if(this.hasGraphics())return e=this.getTrimboxRect(),c=!b&&0===c||b&&90===c?e.bottomleft():
!b&&90===c||b&&180===c?e.topleft():!b&&180===c||b&&270===c?e.topright():e.bottomright(),new g.Size(c.x,-(a.size.height-c.y));if(this.hasCad()){var d=new g.Point;this.getCad()&&this.getCad().getLocation()&&(d=this.getCad().getLocation().origin.copy());if(!b&&0===c)d.y+=e.height;else if(b||90!==c)!b&&180===c?d.x+=e.width:b||(d.x+=e.height,d.y+=e.width);b&&90===c?d.y+=e.width:b&&180===c||(b&&270===c?d.x+=e.height:b&&(d.x+=e.width,d.y+=e.height));return new g.Size(d.x,-(a.size.height-d.y))}return new g.Size},
h.prototype.saveAnnotations=function(a,c,b){function e(a){if("status"==a.documentElement.nodeName&&1<=a.documentElement.getElementsByTagName("value").length&&"-1"==a.documentElement.getElementsByTagName("value")[0].textContent){var b="server returned status -1";0<a.documentElement.getElementsByTagName("message").length&&(b=a.documentElement.getElementsByTagName("message")[0].textContent);i.i18n.loadBundle("viewer",function(){i.emit("error.SEVERE",i.i18n.t("AnnSaveError"),b)});return!0}return!1}var d=
document.implementation.createDocument("http://ns.adobe.com/xfdf/","xfdf",null);try{d.characterSet="UTF-8"}catch(g){}try{d.charset="UTF-8"}catch(h){}var j=document.createElementNS(null,"annots");d.documentElement.appendChild(j);for(var n=[],o=[],t=0;t<a.length;t++)a[t].isNew?n.push(a[t]):o.push(a[t]),j.appendChild(a[t].toXML(d));var u=[];c&&0<c.length&&l.each(c,function(a){a.runThroughAnnotation(!0,!0,!0,function(a){u.push(a.name)})});a={};this.get("file")?a.file=this.get("file"):this.get("cad")&&
(a.cad=this.get("cad"),a.style=this.get("style"));u&&0<u.length&&(a.remove=u);a=k.ViewServer("changeannotations.jsp",a);i.ajax(a,{success:l.bind(function(a){e(a)||(this._parseAnnotationData(a),this._processAfterParsingSavedAnnotations(n,o,c,b))},this),error:l.bind(function(a,d,k){try{var g=(new DOMParser).parseFromString(a.responseText,"text/xml");if(e(g))return;this._parseAnnotationData(g);this._processAfterParsingSavedAnnotations(n,o,c,b);return}catch(m){k=m}i.i18n.loadBundle("viewer",function(){i.emit("error.SEVERE",
i.i18n.t("AnnSaveError"),a,d,k)})},this),processData:!1,contentType:"text/xml; charset=UTF-8",data:d,type:"POST"})},h.prototype._processAfterParsingSavedAnnotations=function(a,c,b,e){var d=this.getAnnotations();this.setHasAnnotations(0<l.size(d));this.reportAnnotations(a,c,b,function(a){e&&e(d);a&&((a=i.getProperty("annotationcallbackurl"))&&i.ajax(a,{dataType:void 0,noAjaxParam:!0}),i.i18n.loadBundle("viewer",function(){i.emit("userMessage","success",i.i18n.t("AnnotationsSaved"),!0)}))})},h.prototype.reportAnnotations=
function(a,c,b,e){var d=0;a&&(d+=a.length);c&&(d+=c.length);b&&(d+=b.length);0===d&&e(!0);var k=0,g=!0,h=function(a){a||(g=!1);k++;k===d&&e&&e(g)};i.i18n.loadBundle("viewer",l.bind(function(){a&&l.each(a,function(a){a.cancelModified();this.alertOnAnnotationAdded(a,h)},this);c&&l.each(c,function(a){a.cancelModified();this.alertOnAnnotationModified(a,h)},this);b&&l.each(b,function(a){this.alertOnAnnotationDelete(a,h)},this)},this))},h.prototype.alertOnAnnotationAdded=function(a,c){var b=a.date.getTime()==
a.creationdate.getTime(),e=j(a),b=i.i18n.t(b?"AnnCommAdded":"AnnCommAdded2",e,a.getStringContent(130),a.getUserName(),i.i18n.d("AnnCommDate",a.creationdate),i.i18n.d("AnnCommDate",a.date));this.getDocumentVersion().isMultiPage()&&(b=i.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+b);this.updateApprovalState(b,c)},h.prototype.alertOnAnnotationDelete=function(a,c,b){if(!b&&a.replies&&0<a.replies.length){var e=l.after(a.replies.length,l.bind(function(){this.alertOnAnnotationDelete(a,
c,!0)},this));l.each(a.replies,function(a){this.alertOnAnnotationDelete(a,e)},this)}else{var b=a.date.getTime()==a.creationdate.getTime(),d=j(a),b=i.i18n.t(b?"AnnCommDeleted":"AnnCommDeleted2",d,a.getStringContent(130),i.getCurrentUser().getFullName(),a.getUserName(),i.i18n.d("AnnCommDate",new Date),i.i18n.d("AnnCommDate",a.creationdate),i.i18n.d("AnnCommDate",a.date));this.getDocumentVersion().isMultiPage()&&(b=i.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+
b);this.updateApprovalState(b,c)}},h.prototype.alertOnAnnotationModified=function(a,c){var b=j(a),b=i.i18n.t("AnnCommModded",b,a.getStringContent(130),i.getCurrentUser().getFullName(),a.getUserName(),i.i18n.d("AnnCommDate",a.creationdate),i.i18n.d("AnnCommDate",new Date));this.getDocumentVersion().isMultiPage()&&(b=i.i18n.t("PagesString",this.getPagenum(),this.getPagenum(),this.getDocumentVersion().getPageCount())+b);this.updateApprovalState(b,c)},h.prototype.updateApprovalState=function(a,c){var b=
{approvalcomments:a,projectid:this.getDocument().get("projectid"),docid:this.getDocument().get("docid"),docversionid:this.get("pageDocversionid"),pageno:this.getPagenum()};void 0!==this.get("pageindex")&&(b.pageindex=this.get("pageindex"));void 0!==this.get("pagename")&&(b.pagename=this.get("pagename"));var e=k.WebCenter("updateapprovalstate.jsp");i.ajax(e,{success:function(){c&&c(!0)},error:function(a,b,e){i.i18n.loadBundle("viewer",function(){i.emit("error.SEVERE",i.i18n.t("DocumentHistoryUpdateError"),
a,b,e)});c&&c(!1)},data:b,type:"POST"})}):i.emit("error.SEVERE","Can't initialize Annotations on a non-webcenter data-adapter")}});
define("web-viewer/annotation/AnnotationNoteDrawTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/utils/ShapeUtils web-viewer/annotation/Annotation web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(c,h,g,a,o,n,l){var i=function(j,k,i){h.call(this,j,l.TOOLS.ANNOTATION_NOTE_DRAW);this.drawLinkedAnnotation=!1;this._annotationModel=k;this._annotationModule=i;this.setAnnotationColor=function(a){j.getCurrentUser().setColor("PREFERENCES_ANNOTATION_NOTE_COLOR",
a)};this.getAnnotationColor=function(){return j.getProperty("annotationcolor")?j.getProperty("annotationcolor"):j.getCurrentUser().getColor("PREFERENCES_ANNOTATION_NOTE_COLOR")};this.getDefaultCursor=function(){return"cursor-drawComment"};var f=c.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{contextmenu:function(a){a.preventDefault();a.stopPropagation();return!1},click:c.bind(function(b){var e=f(b);if(e){var b=
this.keepPointWithinWorldBounds(this.getWorldPoint(b),!0),b=new g.Rect(b,new g.Size),d=new a(j);d.initAnnotation(o.AnnotationType.ANNOT_PIN,this.getAnnotationColor(),!1,k);b=e.getWorldRectFromScene(b);b.origin.x=n.parseFloat(b.origin.x.toFixed(2));b.origin.y=n.parseFloat(b.origin.y.toFixed(2));d.rect=b;this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(d.rect,c.bind(function(){this.addAnnotation(d)},this),function(){d=null}):this.addAnnotation(d)}},
this)});this.canBeInterrupted=function(){return!0};this.activeKeyEvents=[];this.persistentKeyEvents=[];this._override("initialize",function(a,e){this._super(a,e);this.changeState("default");this.registerActiveEvents(["contextmenu","click"]);this.activeKeyEvents.push(["shift",c.bind(function(){this.drawLinkedAnnotation=!0},this),"keydown"]);this.activeKeyEvents.push(["shift",c.bind(function(){this.drawLinkedAnnotation=!1},this),"keyup"])});this._override("activate",function(a){this._super(a);k.setLockSelection(!0)});
this.canBeActivated=function(){return k.canChangeAnnotations()};this._override("deactivate",function(a){this._super(a);this.drawLinkedAnnotation=!1;k.setLockSelection(!1)});j.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",c.bind(function(a,c){!c&&this.isActive()&&this.requestDeactivation()},this))};i.prototype=new h;i.prototype.constructor=i;i.prototype.addAnnotation=function(a){this.drawLinkedAnnotation?this._annotationModel.addLinkedAnnotation(a):(this._annotationModel.addAnnotation(a),
this.requestDeactivation())};return i});
define("web-viewer/annotation/AnnotationTouchDrawTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/utils/ShapeUtils web-viewer/utils/GEOUtils web-viewer/utils/DrawUtils web-viewer/utils/TouchUtil web-viewer/annotation/Annotation web-viewer/utils/LineworkPoint web-viewer/annotation/AnnotationConstants web-viewer/utils/ViewerUtils web-viewer/core/CoreConstants".split(" "),function(c,h,g,a,o,n,l,i,j,k,m){a=function(a,b,e){h.call(this,a,m.TOOLS.ANNOTATION_TOUCH_DRAW);var d=void 0;this.drawLinkedAnnotation=
!1;this._annotationModel=b;this._annotationModule=e;this.setAnnotationType=function(){};this.getAnnotationType=function(){return j.AnnotationType.ANNOT_FREEFORM};this.setAnnotationColor=function(b){a.getCurrentUser().setColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR",b)};this.getAnnotationColor=function(){return a.getProperty("annotationcolor")?a.getProperty("annotationcolor"):a.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")};this.getDefaultCursor=function(){return"cursor-drawAnnotation"};
var k=c.bind(function(a){if(a=this._widget.requestView(a))if(a=a.getLayer("Annotations"))return a;return null},this);this.registerState("default",{panstart:function(){},panmove:function(){},panend:function(){},canBeInterrupted:!0});this.registerState("draw",c.defaults({panstart:c.bind(function(c){this.requestCanvasLayer(c.pointers[0]);c=this.keepPointWithinWorldBounds(this.getWorldPoint(c.pointers[0]),!0);d=new l(a);d.initAnnotation(j.AnnotationType.ANNOT_FREEFORM,this.getAnnotationColor(),!1,b);
d.rect=new g.Rect(c,new g.Size);this.changeState("drawing")},this)},this.getState("default")));var n=c.bind(function(a){p();a||(d=null);d&&2===d.pointArray.length&&d.pointArray[0].x==d.pointArray[1].x&&d.pointArray[0].y==d.pointArray[1].y&&(d=null);if(null!==d&&(0===Math.abs(d.rect.size.width)||0>=Math.abs(d.rect.size.height)))d=null;if(d){var b=k(a);b?(d.rect=b.getWorldRectFromScene(d.rect),this._annotationModel.getPage().isReaderSpread()?this._annotationModule.promptIfAnnotationOutsidePage(d.rect,
c.bind(function(){this.createAnnotation(d,b)},this),function(){d=null}):this.createAnnotation(d,b)):d=null}this.changeState("draw")},this);this.createAnnotation=function(a,c){for(var d=0;d<a.pointArray.length;d++){var e=a.pointArray[d],f=new g.Point(e.x,e.y),f=c.getWorldPointFromScene(f);e.x=f.x;e.y=f.y}b.addAnnotation(a);this.requestDeactivation()};var q=c.throttle(c.bind(function(){var a=this.getCanvasCtx();if(a){var b=this.getCanvasSize();a.clearRect(0,0,b.width,b.height);d&&o.drawOverlay(this.f,
a,[d])}},this),40);this.registerState("drawing",c.defaults({enterState:function(){a.emit("viewport.startInteractive");a.emit("layout.disableTextSelection")},leaveState:function(){a.emit("viewport.stopInteractive");setTimeout(function(){a.emit("layout.enableTextSelection")},500)},panmove:c.bind(function(a){var b=d.rect.copy(),c=this.keepPointWithinWorldBounds(this.getWorldPoint(a.pointers[0]),!0),a=new i;if(0===d.pointArray.length)a.makeMoveTo(d.rect.origin.x,d.rect.origin.y);else{var e=d.pointArray[d.pointArray.length-
1];if(0>Math.abs(e.x-c.x)||0>Math.abs(e.y-c.y))return;a.makeLineTo(c.x,c.y)}d.pointArray.push(a);c=Math.abs(a.x-b.origin.x);a.x<b.origin.x?(c=Math.abs(b.origin.x-a.x),b.origin.x=a.x,b.size.width+=c):c>b.size.width&&(b.size.width=c);c=Math.abs(a.y-b.origin.y);a.y<b.origin.y?(c=Math.abs(b.origin.y-a.y),b.origin.y=a.y,b.size.height+=c):c>b.size.height&&(b.size.height=c);d.setRect(b,!0);q()},this),panend:function(a){n(a.pointers[0])},canBeInterrupted:!1},this.getState("default")));this.canBeInterrupted=
function(){return!1};this.activeKeyEvents=[];this.persistentKeyEvents=[];var p=c.bind(function(){this.releaseCanvasLayer()},this);this.canBeActivated=function(){return b.canChangeAnnotations()};a.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",c.bind(function(a,b){!b&&this.isActive()&&this.requestDeactivation()},this))};a.prototype=Object.create(h.prototype);a.prototype.constructor=a;a.prototype.initialize=function(a,b){h.prototype.initialize.apply(this,arguments);this._touchUtil=
new n(a.getElement()[0]);this.changeState("default")};a.prototype.doActivation=function(){h.prototype.doActivation.call(this);this._annotationModel.setLockSelection(!0);this._touchUtil.addPanStartListener(c.bind(function(a){this.getCurrentState().panstart(a)},this));this._touchUtil.addPanMoveListener(c.bind(function(a){this.getCurrentState().panmove(a)},this));this._touchUtil.addPanEndListener(c.bind(function(a){this.getCurrentState().panend(a)},this));this.changeState("draw");this.drawLinkedAnnotation=
!1};a.prototype.doDeactivation=function(){h.prototype.doDeactivation.call(this);this.changeState("default");this.releaseCanvasLayer();this._touchUtil.removeAllListeners();this._annotationModel.setLockSelection(!1)};return a});
define("web-viewer/annotation/AnnotationTouchTool","underscore web-viewer/viewport/tools/AbstractTool web-viewer/utils/ShapeUtils web-viewer/utils/TouchUtil web-viewer/annotation/Annotation web-viewer/core/CoreConstants".split(" "),function(c,h,g,a,o,n){var l=function(a,j){h.call(this,a,n.TOOLS.ANNOTATION_TOUCH);this.f=a;this._annotationModel=j;this._defaultState="defaultState";this._annotationSelectedState="annotationSelectedState";this._annotationSelectedPanningState="annotationSelectedPanningState";
this.registerState(this._defaultState,function(a){return{enterState:function(){a._annotationModel.unselectAllAnnotations();a._activeAnnotation=null},panstart:function(){},panmove:function(){},panend:function(){},singletap:function(c){c=a.getScenePointFromTouch(c);c.view&&((c=a.getClosestAnnotation(c.view,c.point))?a._annotationModel.selectAnnotation(c):a._annotationModel.unselectAllAnnotations())}}}(this));this.registerState(this._annotationSelectedState,function(a){return c.defaults({enterState:function(){},
panstart:function(c){var f=a.getScenePointFromTouch(c);if(f.view){var b=a.getClosestAnnotation(f.view,f.point);a._activeAnnotation===b&&a._annotationModel.canChangeAnnotation(b)&&(a.changeState(a._annotationSelectedPanningState),a._previousPoint=a._getAnnotationLayer(f.view).getWorldPointFromScene(a.getScenePoint(c.pointers[0])),a.requestActivation())}},panmove:function(){},panend:function(){}},a.getState(a._defaultState))}(this));this.registerState(this._annotationSelectedPanningState,function(a){return{enterState:function(){a.f.emit("viewport.startInteractive");
a.f.emit("layout.disableTextSelection")},leaveState:function(){a.isActive()&&a.requestDeactivation();a.f.emit("viewport.stopInteractive");setTimeout(function(){a.f.emit("layout.enableTextSelection")},500)},panstart:function(){},panmove:function(c){if(a.isActive()){var f=a._widget.requestView(c.pointers[0]);if(f){var c=a._getAnnotationLayer(f).getWorldPointFromScene(a.getScenePoint(c.pointers[0])),b=a._widget.getWorld().getWorldBounds(),f=a._getAnnotationLayer(f).convertWorldRectToLayer(new g.Rect(new g.Point,
b.size));f.origin.y=-(f.size.height+f.origin.y)-b.origin.y;f.origin.x+=b.origin.x;f=a.keepMoveSizeWithinRect(f,a._activeAnnotation.rect,a._previousPoint.sizeTo(c));j.moveAnnotation(a._activeAnnotation,f);a._previousPoint=c}}else a.changeState(a._annotationSelectedState)},panend:function(){a.changeState(a._annotationSelectedState)}}}(this));this._annotationModel.on("unselectedAnnotation",c.bind(function(){this.changeState(this._defaultState)},this));this._annotationModel.on("selectedAnnotation",c.bind(function(a){a!=
this._activeAnnotation&&(this._activeAnnotation=a,this.changeState(this._annotationSelectedState))},this))};l.prototype=Object.create(h.prototype);l.prototype.constructor=l;l.prototype.getScenePointFromTouch=function(a){return this._touchUtil.getScenePointFromTouch(a,this._widget)};l.prototype.getClosestAnnotation=function(a,c){var g=a.getClosestLineworkFromPoint(c,["Annotations"],30);if(g){if(g instanceof o)return g;if(g.anchor&&g.linework instanceof o)return g.linework}return null};l.prototype.initialize=
function(g,j){h.prototype.initialize.apply(this,arguments);this._touchUtil=new a(g.getElement()[0]);this.changeState(this._defaultState);this._touchUtil.addSingleTapListener(c.bind(function(a){this.getCurrentState().singletap(a)},this));this._touchUtil.addPanStartListener(c.bind(function(a){this.getCurrentState().panstart(a)},this));this._touchUtil.addPanMoveListener(c.bind(function(a){this.getCurrentState().panmove(a)},this));this._touchUtil.addPanEndListener(c.bind(function(a){this.getCurrentState().panend(a)},
this))};l.prototype._getAnnotationLayer=function(a){return a&&(a=a.getLayer("Annotations"))?a:null};return l});
define("web-viewer/annotation/AnnotationToolbarComponent","web-viewer/layout/component/ToolbarComponent web-viewer/layout/component/ButtonGroup web-viewer/layout/component/ToolbarButton web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/ColorPicker web-viewer/layout/LayoutConstants web-viewer/annotation/AnnotationConstants".split(" "),function(c,h,g,a,o,n,l){var i=function(j,k,i,f){c.call(this,n.ToolbarComponent.ANNOTATION,j);this.f=j;this.annotationModel=k;var b=new h("AnnotateGroup");
b.setTitle(j,"viewer","AnnBtnGroupTitle");this.addButtonGroup(b);var e=new g(j,"HideAnnotationsButton",j.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?"hideAnnotations":"showAnnotations",!0,function(){k.toggleVisibility()});e.setTooltip("viewer",j.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE")?"HideAnnotationsBtnTT":"ShowAnnotationsBtnTT");j.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATIONTOOLS_VISIBLE",function(a,b){b?(e.setTooltip("viewer","HideAnnotationsBtnTT"),e.setIcon("hideAnnotations")):
(e.setTooltip("viewer","ShowAnnotationsBtnTT"),e.setIcon("showAnnotations"));u()});b.addButton(e);var d=new g(j,"AnnotateButton","addAnnotation",!0,function(){k.toggleVisibility(!0)});d.setTooltip("viewer","AddAnnotationBtnTT");d.listenToTool(i,!0);b.addButton(d);j.getOption("PREFERENCES_ANNOTATION_TOOLMODE")!=l.ANNOT_PIN&&d.setIcon(l.AnnotationToolIcons[j.getOption("PREFERENCES_ANNOTATION_TOOLMODE")]);j.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_TOOLMODE",function(a,b){b!=l.ANNOT_PIN&&
d.setIcon(l.AnnotationToolIcons[b])});var s=new c("AnnotationSelectorSubtoolbar");d.addSubtoolbarComponent(s);var r=new h("AnnotateSubGroup");s.addButtonGroup(r);var q=void 0,p=new a(j,"RectangleButton","addRectangle",!0,function(){i.setAnnotationType(l.AnnotationType.ANNOT_RECT);q&&q.setColor(i.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",l.AnnotationType.ANNOT_RECT);p.setTooltip("viewer","AnnRectTT");r.addButton(p);p=new a(j,"OvalButton","addOval",
!0,function(){i.setAnnotationType(l.AnnotationType.ANNOT_ELLIPSE);q&&q.setColor(i.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",l.AnnotationType.ANNOT_ELLIPSE);p.setTooltip("viewer","AnnOvalTT");r.addButton(p);p=new a(j,"LineButton","addLine",!0,function(){i.setAnnotationType(l.AnnotationType.ANNOT_LINE);q&&q.setColor(i.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",l.AnnotationType.ANNOT_LINE);
p.setTooltip("viewer","AnnLineTT");r.addButton(p);p=new a(j,"ArrowButton","addArrow",!0,function(){i.setAnnotationType(l.AnnotationType.ANNOT_ARROW);q&&q.setColor(i.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",l.AnnotationType.ANNOT_ARROW);p.setTooltip("viewer","AnnArrowTT");r.addButton(p);p=new a(j,"FreeformButton","addFreehand",!0,function(){i.setAnnotationType(l.AnnotationType.ANNOT_FREEFORM);q&&q.setColor(i.getAnnotationColor())});p.listenToToolOption("annotationdrawtool",
"PREFERENCES_ANNOTATION_TOOLMODE",l.AnnotationType.ANNOT_FREEFORM);p.setTooltip("viewer","AnnFreehandTT");r.addButton(p);p=new a(j,"HighlightButton","addHighlight",!0,function(){i.setAnnotationType(l.AnnotationType.ANNOT_HIGHLIGHT);q&&q.setColor(i.getAnnotationColor())});p.listenToToolOption("annotationdrawtool","PREFERENCES_ANNOTATION_TOOLMODE",l.AnnotationType.ANNOT_HIGHLIGHT);p.setTooltip("viewer","AnnHighlightTT");r.addButton(p);r=new h("AnnotateSubGroupGlobAction");s.addButtonGroup(r);p=new a(j,
"GlobalAnnotation","addGlobalAnnotation",!0,function(a){i.setAnnotationType(l.AnnotationType.ANNOT_RECT);i.addGlobalAnnotation(a)});p.setTooltip("viewer","AnnNewRectGlobal");r.addButton(p);j.getProperty("annotationcolor")||(r=new h("AnnotateSubGroupColor"),s.addButtonGroup(r),q=new o(function(a){i.setAnnotationColor("#"+a)}),j.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_RECTANGLE_COLOR",function(){q.setColor(j.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR"))}),
q.setColor(j.getCurrentUser().getColor("PREFERENCES_ANNOTATION_RECTANGLE_COLOR")),s=new a(j,"ColorSelector",q.element,!0),s.setTooltip("viewer","AnnColorDefaultRect"),p=new a(j,"ColorReset","resetColor",!0,_.bind(function(){j.resetOption("PREFERENCES_ANNOTATION_RECTANGLE_COLOR");this.askToChangeAnnotationColors()},this)),p.setTooltip("viewer","AnnResetDefaultColor"),r.addButton(s),r.addButton(p));var v=new g(j,"CommentButton","addComment",!0,function(){k.toggleVisibility(!0)});v.listenToTool(f,!0);
v.setTooltip("viewer","AnnCommNote");b.addButton(v);if(!j.getProperty("annotationcolor")){s=new c("AnnotationNoteSelectorSubtoolbar");v.addSubtoolbarComponent(s);b=new h("AnnotateNoteSubGroup");s.addButtonGroup(b);var t=new o(function(a){f.setAnnotationColor("#"+a)});j.getCurrentUser().on("options.changed.PREFERENCES_ANNOTATION_NOTE_COLOR",function(){t.setColor(f.getAnnotationColor())});t.setColor(f.getAnnotationColor());s=new a(j,"ColorSelector",t.element,!0);s.setTooltip("viewer","AnnColorDefaultNote");
r=new a(j,"ColorReset","resetColor",!0,_.bind(function(){j.resetOption("PREFERENCES_ANNOTATION_NOTE_COLOR");this.askToChangeAnnotationColors()},this));r.setTooltip("viewer","AnnResetNoteColor");b.addButton(s);b.addButton(r)}var u=function(){if(k.canChangeAnnotations(!0))d.setEnabled(!0),v.setEnabled(!0);else{var a="";0<k.getDisabledReason().length&&(a=k.getDisabledReason());d.setDisabledTooltip(a);v.setDisabledTooltip(a);i.isActive()&&i.requestDeactivation();f.isActive()&&f.requestDeactivation();
d.setEnabled(!1);v.setEnabled(!1)}e.setEnabled(!k.isTemporarilyDisabledAndNoAnnotationsVisible())};u();k.on("readWriteChanged",u);k.on("temporarilyDisableChanged",u);k.on("disabledReasonChanged",u)};i.prototype=Object.create(c.prototype);i.prototype.constructor=i;i.toolbarName=n.ToolbarComponent.ANNOTATION;i.prototype.askToChangeAnnotationColors=function(){this.f.i18n.loadBundle("viewer",_.bind(function(){confirm(this.f.i18n.t("AnnUpdateColors"))&&this.annotationModel.updateAllAnnotationColors()},
this))};return i});
define("web-viewer/annotation/AnnotationTouchToolbarComponent",["web-viewer/layout/component/ToolbarComponent","web-viewer/layout/component/ButtonGroup","web-viewer/layout/component/ToolbarButton","web-viewer/layout/LayoutConstants"],function(c,h,g,a){var o=function(n,l,i){c.call(this,a.ToolbarComponent.ANNOTATION,n);this.f=n;this.annotationModel=l;var j=new h("AnnotateGroup");j.setTitle(n,"viewer","AnnBtnGroupTitle");this.addButtonGroup(j);var k=new g(n,"AnnotateButton","icon-WCR_Add",!0,function(){l.toggleVisibility(!0)});
k.listenToTool(i,!0);j.addButton(k);n=function(){if(l.canChangeAnnotations(!0))k.setEnabled(!0);else{var a="";0<l.getDisabledReason().length&&(a=l.getDisabledReason());k.setDisabledTooltip(a);i.isActive()&&i.requestDeactivation();k.setEnabled(!1)}};n();l.on("readWriteChanged",n);l.on("temporarilyDisableChanged",n);l.on("disabledReasonChanged",n)};o.prototype=Object.create(c.prototype);o.prototype.constructor=o;o.toolbarName=a.ToolbarComponent.ANNOTATION;return o});
define("web-viewer/annotation/AnnotationModule","underscore web-viewer/core/AbstractModule web-viewer/annotation/AnnotationModel web-viewer/annotation/AnnotationLayerModel web-viewer/annotation/AnnotationPopupsLayerModel web-viewer/annotation/AnnotationTool web-viewer/annotation/AnnotationDrawTool web-viewer/annotation/AnnotationIndicatorTool web-viewer/annotation/AnnotationWidget web-viewer/utils/Transformation web-viewer/utils/ShapeUtils web-viewer/annotation/AnnotationDataExtensions web-viewer/annotation/AnnotationNoteDrawTool web-viewer/annotation/AnnotationTouchDrawTool web-viewer/annotation/AnnotationTouchTool web-viewer/annotation/AnnotationToolbarComponent web-viewer/annotation/AnnotationTouchToolbarComponent web-viewer/annotation/AnnotationConstants web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/utils/ListenerUtil".split(" "),
function(c,h,g,a,o,n,l,i,j,k,m,f,b,e,d,s,r,q,p,v,t){k=function(a,k){function o(a){var b=p().createInverse();return new m.Rect(b.transformedPoint(a.origin),b.transformedSize(a.size))}h.call(this,a,k,"annotation");t.mixin(this,a);this.annotationModel=new g(this.f,"annotation");this.layerModels={};f(a);this._drawTool=new l(a,this.annotationModel,this);this._noteDrawTool=new b(a,this.annotationModel,this);this._indicatorTool=new i(a,this.annotationModel);this._publishTool(this._indicatorTool);this.f.isMobile()?
(this._touchDrawTool=new e(a,this.annotationModel,this),this._publishTool(this._touchDrawTool),this._selectTool=new d(a,this.annotationModel)):(this._publishTool(this._drawTool),this._publishTool(this._noteDrawTool),this._selectTool=new n(a,this.annotationModel));this._publishTool(this._selectTool);this._annotateComponent=null;this._publishToolbarComponent(s.toolbarName,c.bind(function(b){return this._annotateComponent=b===v.LayoutType.MOBILE?new r(a,this.annotationModel,this._touchDrawTool):new s(a,
this.annotationModel,this._drawTool,this._noteDrawTool)},this));this._annotationWidget=null;this._publishWidget(j.widgetName,c.bind(function(b){this.annotationModel.setLayoutType(b);return this._annotationWidget=new j(a,this,this.annotationModel,b)},this));this.on("highlightAnnotation",c.bind(function(b){this.annotationModel.selectAnnotation(b,!0);this._indicatorTool.setAnnotation(b);a.emit("toolManager.request.activation","annotationindicatortool")},this));this.on("duplicateAnnotation",c.bind(function(a){var b=
a.getGodfather().duplicate(!1,!1,!0,!0,this.annotationModel);a.inreplyto&&(b.content=c.clone(a.content));a=null;a=b.getType()==q.AnnotationType.ANNOT_PIN?this._noteDrawTool.getAnnotationColor():this._drawTool.getAnnotationColor();b.setColor(a);this.annotationModel.unselectAllAnnotations(!0,!0);this.annotationModel.addAnnotation(b);0<b.links.length&&c.each(b.links,function(a){a.messagenumber=b.messagenumber;this.annotationModel.addAnnotation(a)},this);b.setColor(a);this.annotationModel.modelChanged(b)},
this));this.on("zoomToAnnotation",c.bind(function(b){var c={},d=b.rect.copy();3!==a.getOption("PREFERENCES_ANNOTATION_NEXT_MODE")&&(d=b.getOutliningRect());b=null;20>Math.abs(d.size.width)&&(b=(20-d.size.width)/2,d.origin.x-=b,d.size.width=20);20>Math.abs(d.size.height)&&(b=(20-d.size.height)/2,d.origin.y-=b,d.size.height=20);c.rect=p().transformedRect(d);c.constrain=!0;c.animated=!0;this.annotationModel.ensureVisibility();a.emit("viewport.fitInRect",c)},this));this.on("temporarilyDisable",c.bind(function(a,
b,c,d){this.annotationModel.temporarilyDisable(a,b,c,d)},this));var p=c.bind(function(){return this.layerModels.AnnotationLayer.getTransform().copy()},this);this.on("createAnnotation",c.bind(function(a,b,c){void 0===c&&(c=q.AnnotationType.ANNOT_RECT);this.annotationModel.addAnnotationWithRect(o(a),b,c)},this));this._registerListener("intercept.activePageChange",function(a){var b=a.newActivePage,d=a.oldActivePage;b!==d&&this.promptToSaveUnsavedAnnotations(c.bind(function(){this.f.getDocumentController().changeActivePage(b)},
this),c.bind(function(){},this),c.bind(function(){this.annotationModel.resetAllAnnotations();this.f.getDocumentController().changeActivePage(b)},this))&&(a.newActivePage=d)},this);this._registerListener("viewControls.compensationChanged",function(){if(this.annotationModel){var a=this.annotationModel.getAnnotationsPage();a!==this.f.getDocumentController().getDifferencePage()&&(a=a.getCurrentScaling(),this.annotationModel.scaleAllAnnotations(a))}},this,this.f);this._registerListener("filterStateChanged",
function(a){a?this.f.setOption("ANNOTATION_FILTER",this.annotationModel.getAnnotationFilterModel().getFilterState()):this.f.resetOption("ANNOTATION_FILTER")},this,this.annotationModel.getAnnotationFilterModel());this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailable(this._whenActiveOrDifferencePageChangedAndParametersAvailable,this);this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(this._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange,
this)};k.prototype=Object.create(h.prototype);k.prototype.constructor=k;k.prototype.hasUnsavedElements=function(){return 0<this.annotationModel.getUnsavedAnnotationCount()};k.prototype.saveAllUnsavedElements=function(a){this.annotationModel.save(null,a)};k.prototype._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=function(b,c){if(void 0===this.layerModels.AnnotationLayer){this.layerModels.AnnotationLayer=new a(this.f,"Annotations",this.annotationModel);this.layerModels.AnnotationPopupsLayer=
new o(this.f,"AnnotationPopups",this.annotationModel);var d=this.f.getModule("viewport");d.addLayer("Annotations",this.layerModels.AnnotationLayer);d.addLayer("AnnotationPopups",this.layerModels.AnnotationPopupsLayer,"Main")}this.annotationModel.isTemporarilyDisabled()?this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()?(this.annotationModel.setPage(b),this.annotationModel.modelChanged()):this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()&&(this.annotationModel.setPage(c),
this.annotationModel.modelChanged()):this.annotationModel.setPage(b)};k.prototype._whenActiveOrDifferencePageChangedAndParametersAvailable=function(a){this._annotateComponent&&(a.isBlankPage()?this._annotateComponent.hide():this._annotateComponent.show())};k.prototype.toggleDifferencePageAnnotations=function(a){void 0===a&&(a=!this.annotationModel.isTemporarilyDifferencePageAnnotationsShown());a?(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1,!0),this.annotationModel.showTemporarilyDifferencePageAnnotations()):
this.annotationModel.hideTemporarilyAnnotations()};k.prototype.toggleCurrentPageAnnotations=function(a){void 0===a&&(a=!this.annotationModel.isTemporarilyCurrentPageAnnotationsShown());a?(this.f.setOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE",1,!0),this.annotationModel.showTemporarilyActivePageAnnotations()):this.annotationModel.hideTemporarilyAnnotations()};k.prototype.getUnsavedElementsName=function(){return this.f.i18n.t("Annotations")};k.prototype.isTemporarilyCurrentPageAnnotationsShown=function(){return this.annotationModel.isTemporarilyCurrentPageAnnotationsShown()};
k.prototype.isTemporarilyDifferencePageAnnotationsShown=function(){return this.annotationModel.isTemporarilyDifferencePageAnnotationsShown()};k.prototype.getState=function(){return{annotationModel:{temporarilyDisabled:{temporarilyDisabled:this.annotationModel.isTemporarilyDisabled(),temporarilyCurrentPageAnnotationsShown:this.annotationModel.isTemporarilyCurrentPageAnnotationsShown(),temporarilyDifferencePageAnnotationsShown:this.annotationModel.isTemporarilyDifferencePageAnnotationsShown(),temporarilyDisabledMessage:this.annotationModel.getTemporarilyDisabledMessage(),
temporaryAnnotationDocumentTogglingEnabled:this.annotationModel.isTemporarilyAnnotationDocumentTogglingEnabled()},annotationVisibility:1==this.f.getOption("PREFERENCES_ANNOTATIONTOOLS_VISIBLE"),filter:this.annotationModel.getAnnotationFilterModel().getFilterState()}}};k.prototype.setState=function(a){this.f.whenModuleAvailable("annotation",function(){if(void 0!==a){var b=a.annotationModel;a.disableSelectTool&&(this._selectTool=null,this._unpublishTool("annotationtool"),this._indicatorTool=null,this._unpublishTool("annotationindicatortool"));
if(void 0!==b){var c=b.temporarilyDisabled;void 0!==c&&(this.annotationModel.temporarilyDisable(c.temporarilyDisabled,c.temporaryAnnotationDocumentTogglingEnabled,c.temporarilyDisabledMessage),c.temporarilyCurrentPageAnnotationsShown?this.annotationModel.showTemporarilyActivePageAnnotations():c.temporarilyDifferencePageAnnotationsShown&&this.annotationModel.showTemporarilyDifferencePageAnnotations());this.annotationModel.toggleVisibility(b.annotationVisibility);b.filter&&this.annotationModel.getAnnotationFilterModel().setFilterState(b.filter)}}},
this)};k.prototype.promptToSaveUnsavedAnnotations=function(a,b,c){return this.annotationModel.promptToSaveUnsavedAnnotations(a,b,c)};k.prototype.promptIfAnnotationOutsidePage=function(a,b,d,e){var f=this.f.getDocumentController().getActivePage(),g=!0;f.hasCad()||(g=f.isRectOnPage(a));if(g)b();else{var h=new p(this.f,"annotationOnOtherPage",this.f.getContext());h.setRemoveFromDomAfterUsage(!0);h.setOkAction(c.bind(function(){b(e);h.hide()},this));h.setCancelAction(c.bind(function(){d()},this));h.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("AnnSaveTitle")));
h.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("AnnSaveOutsidePrompt")));h.setOkBtnText(this.f.i18n.t("YesResponse"));h.setCancelBtnText(this.f.i18n.t("NoResponse"));h.show()}};k.prototype.reload=function(){this.annotationModel.reload(!0)};k.prototype.disableAnnotations=function(a,b,c){a?this.annotationModel.setDisableReason(b,c,!0,!0):this.annotationModel.removeDisableReason(b)};return k});