define("web-viewer/compare/CompareModel",["web-viewer/core/AbstractModel","web-viewer/compare/CompareConstants","web-viewer/utils/ShapeUtils","underscore"],function(c,f,e,g){var d=function(b,a,h){c.call(this,b,a);this._currentMode=null;this._diffMode=h?h:f.diffMode.UNDEFINED;this._availableModes={};this._offset=new e.Point(0,0);this._cadOverlayOffset=new e.Point(0,0);this._cornerAlign=f.cornerAutoAlign.TOPLEFT;this._referenceNegated=this._cadOverlayFlipped=this._referenceFlipped=!1;this._cadOverlayRotation=
this._referenceRotation=f.referenceRotation.NOTROTATED;this._trimBoxAlign=!1;this._newModeName=null;this._fireParametersChanged=this._silenceParametersChanged=!1};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.activateModeByName=function(b,a){if(this._availableModes[b]){var h=this._currentMode,d=this._availableModes[b];d!==h&&(this.toggleCurrentMode(!1),this._newModeName=b,d.toggle(!0,a),this._currentMode=d,this._fireChange(!1,["mode"],h,d))}};d.prototype.deactivateCurrentMode=
function(){this.toggleCurrentMode(!1);if(this._currentMode){var b=this._currentMode;this._newModeName="";this._currentMode=null;this._fireChange(!1,["mode"],b,null)}};d.prototype.toggleCurrentMode=function(b){this._currentMode&&this._currentMode.isEnabled()!==b&&this._currentMode.toggle(b)};d.prototype.getModeNameByDiffMode=function(b){b=g.invert(f.diffMode)[b];return f.mode[f.diffModeToMode[b]]};d.prototype.getModeByName=function(b){return this._availableModes[b]};d.prototype.setOffset=function(b){var a=
this._offset;this._offset=b.copy();this._fireChange(!1,["offset"],a,b)};d.prototype.getOffset=function(){return this._offset.copy()};d.prototype.resetOffset=function(){this.setOffset(new e.Point(0,0))};d.prototype.setCadOverlayOffset=function(b){var a=this._cadOverlayOffset;this._cadOverlayOffset=b.copy();this._fireChange(!1,["cadOverlayOffset"],a,b)};d.prototype.getCadOverlayOffset=function(){return this._cadOverlayOffset.copy()};d.prototype.resetCadOverlayOffset=function(){this.setCadOverlayOffset(new e.Point(0,
0))};d.prototype.setCornerAlign=function(b){this._cornerAlign=b};d.prototype.getCornerAlign=function(){return this._cornerAlign};d.prototype.resetCornerAlign=function(){this._cornerAlign=f.cornerAutoAlign.TOPLEFT};d.prototype.getReferenceRotation=function(){return this._referenceRotation};d.prototype.setReferenceRotation=function(b){this._referenceRotation=b};d.prototype.flipReference=function(){this._referenceFlipped=!this._referenceFlipped};d.prototype.flipCadOverlay=function(b){void 0===b&&(b=
!this._cadOverlayFlipped);this._cadOverlayFlipped=b};d.prototype.isReferenceFlipped=function(){return this._referenceFlipped};d.prototype.isCadOverlayFlipped=function(){return this._cadOverlayFlipped};d.prototype.negateReference=function(){this._referenceNegated=!this._referenceNegated;this.parametersChanged()};d.prototype.isReferenceNegated=function(){return this._referenceNegated};d.prototype.resetReferenceOrientation=function(){this._referenceNegated=this._referenceFlipped=!1;this._referenceRotation=
f.referenceRotation.NOTROTATED};d.prototype.resetCadOverlayOrientation=function(){this._cadOverlayRotation=f.referenceRotation.NOTROTATED;this._cadOverlayFlipped=!1};d.prototype.toggleTrimBoxAlign=function(){this._trimBoxAlign=!this._trimBoxAlign};d.prototype.isTrimBoxAlign=function(){return this._trimBoxAlign};d.prototype.resetTrimBoxAlign=function(){this._trimBoxAlign=!1};d.prototype.setDiffMode=function(b){var a=this._diffMode;this._diffMode=b;null===this._currentMode&&(a=f.diffMode.UNDEFINED);
a!=b&&this.parametersChanged();this._fireChange(!1,["diffMode"],a,this._diffMode)};d.prototype.getDiffMode=function(){return this._diffMode};d.prototype.getActiveMode=function(){return this._currentMode};d.prototype.registerMode=function(b){if(this._availableModes[b.getName()])throw Error("Trying to register mode which already exists!",b.getName(),b);var a=g.keys(this._availableModes);this._availableModes[b.getName()]=b;this._fireChange(!1,["availableModes"],a,g.keys(this._availableModes))};d.prototype.parametersChanged=
function(){this._silenceParametersChanged?this._fireParametersChanged=!0:this.f.emit("viewport.viewserverParametersChanged")};d.prototype.isRealCompareMode=function(b){return b>=f.diffMode.SHOWBOTHCHANGES&&b<=f.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY&&b!==f.diffMode.READERSPREAD};d.prototype.isReaderSpreadActive=function(){return this._newModeName===f.mode.READERSPREAD};d.prototype.toggleSilenceParametersChanged=function(b){b?this._silenceParametersChanged=!0:(this._silenceParametersChanged=!1,this._fireParametersChanged&&
(this.parametersChanged(),this._fireParametersChanged=!1))};d.prototype.setCadOverlayRotation=function(b){this._cadOverlayRotation=b};d.prototype.getCadOverlayRotation=function(){return this._cadOverlayRotation};return d});
define("web-viewer/compare/CompareMode",["web-viewer/core/AbstractModel","underscore"],function(c){var f=function(e,f,d,b,a,h){var j=d.getPrivateChannelNameAsArray();j.push("mode");j.push(f);c.call(this,e,j);this.f=e;this.name=f;this._enabled=!1;this._compareModel=d;this._enableTogglingAnnotations=b;this._annotationTooltipKey=a;this._whichToEnable=h;this._annotationModuleAvailable=!1;this.f.whenModuleAvailable("annotation",function(){this._annotationModuleAvailable=!0;this._enabled&&this._fireTemporarilyDisableAnnotations()},
this)};f.prototype=Object.create(c.prototype);f.prototype.constructor=f;f.prototype.getName=function(){return this.name};f.prototype.toggle=function(e){e!==this._enabled&&(this._enabled=e,this._annotationModuleAvailable&&this._fireTemporarilyDisableAnnotations())};f.prototype.isEnabled=function(){return this._enabled};f.prototype.interceptFragmentURL=function(){};f.prototype._fireTemporarilyDisableAnnotations=function(){this.f.loadBundle("viewer",function(){this.f.emit("module.annotation.temporarilyDisable",
this._enabled,this._enableTogglingAnnotations,this.f.t(this._annotationTooltipKey),this._whichToEnable)},this)};return f});
define("web-viewer/compare/CompareShowCurrentMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,f,e){c=function(c,d){f.call(this,c,e.mode.SHOW_CURRENT,d,!1,"","current")};c.prototype=Object.create(f.prototype);c.prototype.constructor=c;c.prototype.toggle=function(c){f.prototype.toggle.call(this,c);this._compareModel.setDiffMode(c?e.diffMode.CURRENTVERSION:e.diffMode.UNDEFINED)};return c});
define("web-viewer/compare/CompareShowDifferenceMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,f,e){c=function(c,d){f.call(this,c,e.mode.SHOW_DIFFERENCE,d,!1,"AnnDisabledDiffMode","difference")};c.prototype=Object.create(f.prototype);c.prototype.constructor=c;c.prototype.toggle=function(c){f.prototype.toggle.call(this,c);this._compareModel.setDiffMode(c?e.diffMode.DIFFVERSION:e.diffMode.UNDEFINED)};return c});
define("web-viewer/compare/CompareBlinkingMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,f,e){var g=function(d,b){f.call(this,d,e.mode.BLINKING,b,!1,"DiffBlinkingAnnotationsHidden");this._blinkInterval=e.blinkingSpeed;this._differenceVisible=!1;this._toggleDifference=c.bind(function(){this._differenceVisible=!this._differenceVisible;this._updateCompareModel();this.isEnabled()&&(this._timer=setTimeout(this._toggleDifference,this._blinkInterval))},
this)};g.prototype=Object.create(f.prototype);g.prototype.constructor=g;g.prototype.toggle=function(d){f.prototype.toggle.call(this,d);d?this._toggleDifference():(this._timer&&clearTimeout(this._timer),this._differenceVisible=!1,this._updateCompareModel())};g.prototype._updateCompareModel=function(){var d=this.isDifferenceVisible()?e.diffMode.DIFFVERSION:e.diffMode.CURRENTVERSION;this._compareModel.setDiffMode(d)};g.prototype.isDifferenceVisible=function(){return this._differenceVisible};g.prototype.isCurrentVisible=
function(){return!this._differenceVisible};return g});
define("web-viewer/compare/CompareDifferenceMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants","web-viewer/utils/ViewerUtils"],function(c,f,e,g){var d=function(b,a){f.call(this,b,e.mode.DIFFERENCE,a,!0,"DiffDifferenceAnnotationsHidden");this.threshold=0;this.setThreshold(parseInt(this.f.getCurrentUser().getOption("PREFERENCES_DIFFMODE_THRESHOLD"),10));this.f.getCurrentUser().on("options.changed.PREFERENCES_DIFFMODE_THRESHOLD",c.bind(function(a,b){this.setThreshold(b)},
this));this.colorSpace=this.f.getOption("CONFIG_DIFF_COMPAREMODE");this.differenceMode=a.getDiffMode();if(this.differenceMode<e.diffMode.SHOWBOTHCHANGES||this.differenceMode>e.diffMode.SHOWBOTHCHANGESONLY){var h=e.sideBySideToDiffMode[this.differenceMode];this.differenceMode=void 0===h?e.diffMode.SHOWBOTHCHANGES:h}this.addedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD");this.f.getCurrentUser().on("options.changed.PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD",c.bind(function(){this.setAddedHighlightColor(this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD"))},
this));this.subtractedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB");this.f.getCurrentUser().on("options.changed.PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB",c.bind(function(){this.setSubtractedHighlightColor(this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB"))},this));this.on("changed.**",function(){a.parametersChanged()})};d.prototype=Object.create(f.prototype);d.prototype.constructor=d;d.prototype.toggle=function(b,a){f.prototype.toggle.call(this,
b);b?void 0!=a&&(a===e.diffMode.SHOWBOTHCHANGES||a===e.diffMode.SHOWBOTHCHANGESHIGHLIGHT||a===e.diffMode.SHOWBOTHCHANGESONLY||a===e.diffMode.SHOWBOTHONTOP)?this.setDifferenceMode(a):this._compareModel.setDiffMode(this.differenceMode):this._compareModel.setDiffMode(e.diffMode.UNDEFINED)};d.prototype._getDType=function(){return 8*this.colorSpace};d.prototype.interceptFragmentURL=function(b){b.params=c.extend(b.params,this.getOverwriteOptions())};d.prototype.getOverwriteOptions=function(){return{dtype:this._getDType(),
dlevel:this.threshold,hc0:g.rgbIntToBgrInt(g.intFromHex(this.addedHighlightColor)),hc1:g.rgbIntToBgrInt(g.intFromHex(this.subtractedHighlightColor))}};d.prototype.setThreshold=function(b){var a=this.threshold;this.threshold=b;isNaN(this.threshold)&&(this.threshold=0);this.threshold=Math.min(Math.max(this.threshold,0),100);this.f.setOption("PREFERENCES_DIFFMODE_THRESHOLD",this.threshold);this._fireChange(!1,["threshold"],a,b)};d.prototype.getThreshold=function(){return this.threshold};d.prototype.setColorSpace=
function(b){var a=this.colorSpace;this.colorSpace=b;this._fireChange(!1,["colorspace"],a,b);this.f.setOption("CONFIG_DIFF_COMPAREMODE",b)};d.prototype.getColorSpace=function(){return this.colorSpace};d.prototype.setDifferenceMode=function(b){var a=this.differenceMode;this.differenceMode=b;this.isEnabled()&&this._compareModel.setDiffMode(this.differenceMode);this._fireChange(!1,["differenceMode"],a,b)};d.prototype.getDifferenceMode=function(){return this.differenceMode};d.prototype.setAddedHighlightColor=
function(b){var a=this.addedHighlightColor;this.f.getCurrentUser().setColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD",b);this.addedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD");this._fireChange(!1,["addedHighlightColor"],a,this.addedHighlightColor)};d.prototype.getAddedHighlightColor=function(){return this.addedHighlightColor};d.prototype.setSubtractedHighlightColor=function(b){var a=this.subtractedHighlightColor;this.f.getCurrentUser().setColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB",
b);this.subtractedHighlightColor=this.f.getCurrentUser().getColor("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB");this._fireChange(!1,["subtractedHighlightColor"],a,this.subtractedHighlightColor)};d.prototype.getSubtractedHighlightColor=function(){return this.subtractedHighlightColor};d.prototype.resetHighlightColors=function(){this.f.getCurrentUser().resetOption("PREFERENCES_HIGHLIGHTCOLORS_DIFF_ADD");this.f.getCurrentUser().resetOption("PREFERENCES_HIGHLIGHTCOLORS_DIFF_SUB")};return d});
define("web-viewer/compare/CompareSideBySideMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants","web-viewer/viewport/ViewportConstants","web-viewer/utils/ListenerUtil"],function(c,f,e,g,d){var b=function(a,b,j){f.call(this,a,e.mode.SIDEBYSIDE,b,!0,"DiffSideBySideAnnotationsHidden");d.mixin(this,a);this.differenceCompareMode=j;this._showDifference=!0;this._isListeningToGraphics=!1;this._panelsLayoutMode=g.PanelsLayoutMode.AUTOMATIC;this.updateSettingsFromUserPreference(this.f.getOption("PREFERENCES_DIFF_SPLITMODE"));
this.differenceModePanel=this.differenceFilePanel=this.currentFilePanel=null;this.viewport=this.f.getModule("viewport");a.getCurrentUser().on("options.changed.PREFERENCES_DIFF_SPLITMODE",c.bind(function(a,b){this.updateSettingsFromUserPreference(b)},this))};b.prototype=Object.create(f.prototype);b.prototype.constructor=b;b.prototype.toggle=function(a,b){!this.isEnabled()&&a?(f.prototype.toggle.call(this,a),void 0===b&&(b=this.differenceCompareMode.getDifferenceMode(),b=parseInt(c.invert(e.sideBySideToDiffMode)[b])),
this._compareModel.setDiffMode(b),this.f.getDocumentController().whenParametersAvailable(function(){this.isEnabled()&&(this.graphicsModule||(this.graphicsModule=this.f.getModule("graphics")),this.viewport.setPanelsLayoutMode(this._panelsLayoutMode),this.currentFilePanel=this.viewport.getPanelModel("default"),this.currentFilePanel.toggleLayer("referenceCad",!1),this.currentFilePanel.toggleLayer("currentDiffCad",!1),this.currentFilePanel.toggleLayer("referenceDiffCad",!1),this.differenceFilePanel=this.viewport.addPanel("compare_difference",
this._getDifferenceFileOverwriteOptions(),["Cad","currentDiffCad","referenceDiffCad"]),this.toggleDifferencePanel(this._showDifference),this.updateOverwriteOptions(),this.f.whenModuleAvailable("graphics",function(a){this.graphicsModule=a;this.isEnabled()&&!this._isListeningToGraphics&&(this._registerListener("model.changed.channels",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._registerListener("model.changed.channel.**",c.debounce(c.bind(this.updateOverwriteOptions,
this),40),void 0,this.graphicsModule),this._isListeningToGraphics=!0,this.updateOverwriteOptions())},this),this._registerListener("changed.**",this.updateOverwriteOptions,this,this.differenceCompareMode),this._registerListener("annotationModel.annotation.temporarilyDisableChanged",this.updateOverwriteOptions,this),this._registerListener("doc.page.active",this.updatePanelHeaders,this),this._registerListener("doc.page.difference",this.updatePanelHeaders,this),this.updatePanelHeaders())},this)):this.isEnabled()&&
!a&&(f.prototype.toggle.call(this,a),this.viewport.removePanel("compare_difference"),this.viewport.removePanel("compare_differenceMode"),this._compareModel.setDiffMode(e.diffMode.UNDEFINED),this.currentFilePanel.deleteOverwriteOption("dmode"),this.currentFilePanel.deleteOverwriteOption("colorBITWISE"),this.currentFilePanel.toggleLayer("Annotations",!0),this.currentFilePanel.toggleLayer("AnnotationPopups",!0),this.currentFilePanel.toggleLayer("referenceCad",!0),this.currentFilePanel.toggleLayer("currentDiffCad",
!0),this.currentFilePanel.toggleLayer("referenceDiffCad",!0),this.currentFilePanel.setHeaderText(null),this.differenceModePanel=this.differenceFilePanel=this.currentFilePanel=null,this.viewport.setPanelsLayoutMode(g.PanelsLayoutMode.AUTOMATIC),this._unregisterAllListeners(),this._isListeningToGraphics=!1)};b.prototype.isShowingDifference=function(){return this._showDifference};b.prototype.setShowingDifference=function(a){var b=this._showDifference;this._showDifference=a;this.isEnabled()&&b!==a&&this.toggleDifferencePanel(a);
this.storeUserPreference();this._fireChange(!1,["showDifference"],b,a)};b.prototype.toggleDifferencePanel=function(a){a?(this.differenceModePanel=this.viewport.addPanel("compare_differenceMode",this._getDifferenceModeOverwriteOptions(),["Annotations","AnnotationPopups","Cad","referenceCad"]),this.f.loadBundle("viewer",function(){this.differenceModePanel.setHeaderText(this.f.t("CaptionCompared"))},this)):(this.viewport.removePanel("compare_differenceMode"),this.differenceModePanel=null);this.updateOverwriteOptions()};
b.prototype.updateOverwriteOptions=function(){this.isEnabled()&&(void 0===this.graphicsModule&&(this.graphicsModule=this.f.getModule("graphics")),void 0===this.annotationModule&&(this.annotationModule=this.f.getModule("annotation")),this.currentFilePanel.setOverwriteOptions(this._getCurrentFileOverwriteOptions()),this.differenceFilePanel.setOverwriteOptions(this._getDifferenceFileOverwriteOptions()),null!==this.differenceModePanel&&this.differenceModePanel.setOverwriteOptions(this._getDifferenceModeOverwriteOptions()),
void 0!==this.annotationModule&&(this.currentFilePanel.toggleLayer("Annotations",this.annotationModule.isTemporarilyCurrentPageAnnotationsShown()),this.currentFilePanel.toggleLayer("AnnotationPopups",this.annotationModule.isTemporarilyCurrentPageAnnotationsShown()),this.differenceFilePanel.toggleLayer("Annotations",this.annotationModule.isTemporarilyDifferencePageAnnotationsShown()),this.differenceFilePanel.toggleLayer("AnnotationPopups",this.annotationModule.isTemporarilyDifferencePageAnnotationsShown())))};
b.prototype._getCurrentFileOverwriteOptions=function(){var a=0;void 0!==this.graphicsModule&&(a=this.graphicsModule.getChannelSelectionMaskForDiffMode(e.diffMode.CURRENTVERSION));return{dmode:e.diffMode.CURRENTVERSION,colorBITWISE:a}};b.prototype._getDifferenceFileOverwriteOptions=function(){var a=0;void 0!==this.graphicsModule&&(a=this.graphicsModule.getChannelSelectionMaskForDiffMode(e.diffMode.DIFFVERSION));return{dmode:e.diffMode.DIFFVERSION,colorBITWISE:a,isDefaultView:!1}};b.prototype._getDifferenceModeOverwriteOptions=
function(){var a=0;void 0!==this.graphicsModule&&(a=this.graphicsModule.getChannelSelectionMaskForDiffMode(this.differenceCompareMode.getDifferenceMode()));return c.extend(this.differenceCompareMode.getOverwriteOptions(),{dmode:this.differenceCompareMode.getDifferenceMode(),colorBITWISE:a,isDefaultView:!1})};b.prototype.updateSettingsFromUserPreference=function(a){this.setPanelsLayoutMode(+a&3);this.setShowingDifference(4===(a&4))};b.prototype.storeUserPreference=function(){var a=this.getPanelsLayoutMode();
this.isShowingDifference()&&(a+=4);this.f.setOption("PREFERENCES_DIFF_SPLITMODE",a)};b.prototype.setPanelsLayoutMode=function(a){var b=this._panelsLayoutMode;this._panelsLayoutMode=a;this.isEnabled()&&this.viewport.setPanelsLayoutMode(a);this.storeUserPreference();this._fireChange(!1,["panelLayout"],b,this._panelsLayoutMode)};b.prototype.getPanelsLayoutMode=function(){return this._panelsLayoutMode};b.prototype.updatePanelHeaders=function(){this.f.loadBundle("viewer",function(){if(this.isEnabled()){var a=
"",b="",d=this.f.getDocumentController(),e=d.getActivePage().getDocumentVersion(),d=d.getDifferencePage().getDocumentVersion();e.getDocument()!==d.getDocument()&&(a+=e.getDocument().get("docname")+", ",b+=d.getDocument().get("docname")+", ");a+=this.f.t("WCHistVersion")+" "+e.getVersionId();b+=this.f.t("WCHistVersion")+" "+d.getVersionId();a+=" - ("+this.f.t("CaptionCurrent")+")";b+=" - ("+this.f.t("CaptionPrevious")+")";this.currentFilePanel.setHeaderText(a);this.differenceFilePanel.setHeaderText(b)}},
this)};b.prototype.interceptFragmentURL=function(a){a.params.dmode=e.diffMode.CURRENTVERSION};return b});
define("web-viewer/compare/CompareShowBothOnTopMode",["underscore","web-viewer/compare/CompareMode","web-viewer/compare/CompareConstants"],function(c,f,e){c=function(c,d){f.call(this,c,e.mode.SHOWBOTHONTOP,d,!0,"DiffShowBothOnTopAnnotationsHidden")};c.prototype=Object.create(f.prototype);c.prototype.constructor=c;c.prototype.toggle=function(c){f.prototype.toggle.call(this,c);this._compareModel.setDiffMode(c?e.diffMode.SHOWBOTHONTOP:e.diffMode.UNDEFINED)};return c});
define("web-viewer/core/ViewerMode",["underscore"],function(){var c=function(c,e){this.f=c;this._name=e;this._active=!1};c.prototype.toggle=function(c){!this._active&&c?(this._active=!0,this._doStart()):this._active&&!c&&(this._active=!1,this._doStop())};c.prototype._doStart=function(){};c.prototype._doStop=function(){};c.prototype.isActive=function(){return this._active};c.prototype.requestStop=function(){this._active&&this.f.stopMode(this)};c.prototype._allowAllTools=function(){this.f.emit("toolManager.request.allowAllTools")};
c.prototype._allowAllToolsExcept=function(c){this.f.emit("toolManager.request.allowAllToolsExcept",c)};c.prototype._disallowAllToolsExcept=function(c){this.f.emit("toolManager.request.disallowAllToolsExcept",c)};return c});
define("web-viewer/compare/alignment/CompareAlignmentMode","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/viewport/ViewportConstants web-viewer/utils/ListenerUtil web-viewer/utils/ShapeUtils".split(" "),function(c,f,e,g,d){var b=function(a,b,c,k){f.call(this,a,e.mode.ALIGNMENT,b,!1,"DiffSideBySideAnnotationsHidden");d.mixin(this,a);this._isListeningToGraphics=!1;this._resultPanel=this._differenceFilePanel=this._currentFilePanel=null;this._currentAnchorLayerModel=
c;this._referenceAnchorLayerModel=k;this._forCadOverlay=!1;this.viewport=this.f.getModule("viewport")};b.prototype=Object.create(f.prototype);b.prototype.constructor=b;b.prototype.toggle=function(a){!this.isEnabled()&&a?(f.prototype.toggle.call(this,a),this.viewport.addLayer("compare_alignment_currentAnchor",this._currentAnchorLayerModel),this.viewport.addLayer("compare_alignment_referenceAnchor",this._referenceAnchorLayerModel),this.graphicsModule||(this.graphicsModule=this.f.getModule("graphics")),
this._compareModel.setDiffMode(e.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT),this.viewport.setPanelsLayoutMode(g.PanelsLayoutMode.VERTICAL),this._currentFilePanel=this.viewport.getPanelModel("default"),this._currentFilePanel.toggleLayer("referenceCad",!1),this._currentFilePanel.toggleLayer("currentDiffCad",!1),this._currentFilePanel.toggleLayer("referenceDiffCad",!1),this._currentFilePanel.toggleLayer("Annotations",!1),this._currentFilePanel.toggleLayer("AnnotationPopups",!1),this._currentFilePanel.toggleLayer("compare_alignment_referenceAnchor",
!1),this._currentFilePanel.toggleLayer("CadOverlay",!this._forCadOverlay),a="Cad currentDiffCad referenceDiffCad Annotations AnnotationPopups compare_alignment_currentAnchor".split(" "),this._forCadOverlay||a.push("CadOverlay"),this._differenceFilePanel=this.viewport.addPanel("compare_difference",this._getDifferenceFileOverwriteOptions(),a),this._resultPanel=this.viewport.addPanel("compare_align_result",this._getResultOverwriteOptions(),["Annotations","AnnotationPopups","Cad","referenceCad","compare_alignment_referenceAnchor"]),
this.updatePanelHeaders(),this.updateOverwriteOptions(),this.f.whenModuleAvailable("graphics",function(a){this.graphicsModule=a;this.isEnabled()&&!this._isListeningToGraphics&&(this._registerListener("model.changed.channels",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._registerListener("model.changed.channel.**",c.debounce(c.bind(this.updateOverwriteOptions,this),40),void 0,this.graphicsModule),this._isListeningToGraphics=!0,this.updateOverwriteOptions())},
this),this._registerListener("doc.page.active",this.updatePanelHeaders,this),this._registerListener("doc.page.difference",this.updatePanelHeaders,this),this.updatePanelHeaders()):this.isEnabled()&&!a&&(f.prototype.toggle.call(this,a),this.viewport.removePanel("compare_difference"),this.viewport.removePanel("compare_align_result"),this._compareModel.setDiffMode(e.diffMode.UNDEFINED),this._currentFilePanel.deleteOverwriteOption("dmode"),this._currentFilePanel.deleteOverwriteOption("colorBITWISE"),this._currentFilePanel.toggleLayer("Annotations",
!0),this._currentFilePanel.toggleLayer("AnnotationPopups",!0),this._currentFilePanel.toggleLayer("referenceCad",!0),this._currentFilePanel.toggleLayer("currentDiffCad",!0),this._currentFilePanel.toggleLayer("referenceDiffCad",!0),this._currentFilePanel.toggleLayer("CadOverlay",!0),this._currentFilePanel.setHeaderText(null),this._resultPanel=this._differenceFilePanel=this._currentFilePanel=null,this.viewport.setPanelsLayoutMode(g.PanelsLayoutMode.AUTOMATIC),this._unregisterAllListeners(),this._isListeningToGraphics=
!1,this.viewport.removeLayer("compare_alignment_currentAnchor"),this.viewport.removeLayer("compare_alignment_referenceAnchor"))};b.prototype.updateOverwriteOptions=function(){this.isEnabled()&&(void 0===this.graphicsModule&&(this.graphicsModule=this.f.getModule("graphics")),void 0===this.annotationModule&&(this.annotationModule=this.f.getModule("annotation")),this._currentFilePanel.setOverwriteOptions(this._getCurrentFileOverwriteOptions()),this._differenceFilePanel.setOverwriteOptions(this._getDifferenceFileOverwriteOptions()),
this._resultPanel.setOverwriteOptions(this._getResultOverwriteOptions()))};b.prototype._getCurrentFileOverwriteOptions=function(){var a=0;void 0!==this.graphicsModule&&(a=this.graphicsModule.getChannelSelectionMaskForDiffMode(e.diffMode.CURRENTVERSION));return{dmode:e.diffMode.CURRENTVERSION,colorBITWISE:a}};b.prototype._getDifferenceFileOverwriteOptions=function(){var a={dmode:e.diffMode.DIFFVERSION,colorBITWISE:0,isDefaultView:!1};void 0!==this.graphicsModule&&(a.colorBITWISE=this.graphicsModule.getChannelSelectionMaskForDiffMode(e.diffMode.DIFFVERSION));
this._forCadOverlay&&(a.colorBITWISE=0);return a};b.prototype._getResultOverwriteOptions=function(){var a={dmode:e.diffMode.SHOWBOTHONTOP};void 0!==this.graphicsModule&&(a.colorBITWISE=this.graphicsModule.getChannelSelectionMaskForDiffMode(e.diffMode.SHOWBOTHCHANGES));return a};b.prototype.updatePanelHeaders=function(){this.f.loadBundle("viewer",function(){if(this.isEnabled()&&!this._forCadOverlay){var a="",b="",d=this.f.getDocumentController(),c=d.getActivePage().getDocumentVersion(),d=d.getDifferencePage().getDocumentVersion();
c.getDocument()!==d.getDocument()&&(a+=c.getDocument().get("docname")+", ",b+=d.getDocument().get("docname")+", ");a+=this.f.t("WCHistVersion")+" "+c.getVersionId();a+=" - ("+this.f.t("CaptionCurrent")+")";b+=this.f.t("WCHistVersion")+" "+d.getVersionId();b+=" - ("+this.f.t("CaptionPrevious")+")";this._currentFilePanel.setHeaderText(a);this._differenceFilePanel.setHeaderText(b);this._resultPanel&&this._resultPanel.setHeaderText(this.f.t("AnchorAlignWizardResultPanelHeader"))}},this)};b.prototype.setForCadOverlay=
function(a){this._forCadOverlay=a};return b});
define("web-viewer/compare/alignment/CompareAlignmentAnchorModel",["web-viewer/core/AbstractModel","web-viewer/utils/ShapeUtils","underscore"],function(c,f){var e=function(e,d){c.call(this,e,d);this._referenceAnchor=this._currentAnchor=null;this._isCurrentActive=!1};e.prototype=Object.create(c.prototype);e.prototype.constructor=e;e.prototype.setCurrentAnchor=function(c){var d=this._currentAnchor;this._currentAnchor=null!==c?c.copy():null;this._fireChange(!1,["current"],d,null!==this._currentAnchor?
this._currentAnchor.copy():null)};e.prototype.moveCurrentAnchor=function(c,d){var b=this._currentAnchor;null===this._currentAnchor&&(this._currentAnchor=new f.Point);this._currentAnchor=new f.Point(this._currentAnchor.x+c,this._currentAnchor.y+d);this._fireChange(!1,["current"],b,this._currentAnchor.copy())};e.prototype.setReferenceAnchor=function(c){var d=this._referenceAnchor;this._referenceAnchor=null!==c?c.copy():null;this._fireChange(!1,["reference"],d,null!==this._referenceAnchor?this._referenceAnchor.copy():
null)};e.prototype.moveReferencAnchor=function(c,d){var b=this._referenceAnchor;null===this._referenceAnchor&&(this._referenceAnchor=new f.Point);this._referenceAnchor=new f.Point(this._referenceAnchor.x+c,this._referenceAnchor.y+d);this._fireChange(!1,["reference"],b,this._referenceAnchor.copy())};e.prototype.getOffset=function(){if(null!==this._currentAnchor&&null!==this._referenceAnchor)return new f.Size(this._currentAnchor.x-this._referenceAnchor.x,this._currentAnchor.y-this._referenceAnchor.y)};
e.prototype.getCurrentAnchor=function(){return null!==this._currentAnchor?this._currentAnchor.copy():null};e.prototype.getReferenceAnchor=function(){return null!==this._referenceAnchor?this._referenceAnchor.copy():null};e.prototype.getActiveAnchor=function(){return this._isCurrentActive?this.getCurrentAnchor():this.getReferenceAnchor()};e.prototype.setCurrentActive=function(c){var d=this._isCurrentActive;this._isCurrentActive=c;this._fireChange(!1,["isCurrentActive"],d,c)};e.prototype.isCurrentActive=
function(){return this._isCurrentActive};e.prototype.setActiveAnchorPosition=function(c){this.isCurrentActive()?this.setCurrentAnchor(c):this.setReferenceAnchor(c)};e.prototype.moveActiveAnchor=function(c,d){this.isCurrentActive()?this.moveCurrentAnchor(c,d):this.moveReferencAnchor(c,d)};e.prototype.reset=function(){this.setCurrentAnchor(null);this.setReferenceAnchor(null)};return e});
define("web-viewer/utils/SnapIndicator",["web-viewer/utils/LineworkWrapper","web-viewer/utils/DrawUtils","web-viewer/utils/ShapeUtils"],function(c,f,e){var g=new e.Size(7,7),d=function(b){c.call(this);this.type=f.LWTYPE_IMAGE;this.linewidth=0;this.imageRef="/wcr-static/web-viewer/layout/img/crosshair.png";this.staticsize=!0;this.imageOffset=g;b&&this.setCenter(b)};d.prototype=Object.create(c.prototype);d.prototype.constructor=d;d.prototype.setCenter=function(b){this.setRect(new e.Rect(new e.Point(b.x,
b.y)))};return d});
define("web-viewer/compare/alignment/CompareAlignmentAnchorLayerModel","underscore web-viewer/viewport/model/ViewportLayerModel web-viewer/compare/CompareConstants web-viewer/utils/LineworkWrapper web-viewer/utils/DrawUtils web-viewer/utils/ShapeUtils web-viewer/utils/SnapIndicator".split(" "),function(c,f,e,g,d,b,a){var h=function(a,b){f.call(this,a,b);this._anchor=null;this._isActive=!1;this._snapIndicator=null;this.f.getDocumentController().whenActivePageParametersChange(c.bind(this._updateTransformation,this))};
h.prototype=Object.create(f.prototype);h.prototype.constructor=h;h.prototype.setAnchor=function(a){this._anchor=a;this.modelChanged()};h.prototype.moveAnchor=function(a,b){this._anchor.x+=a;this._anchor.y+=b;this.modelChanged()};h.prototype.setActive=function(a){this._isActive=a};h.prototype._updateTransformation=function(){this.resetTransformation();var a=this.f.getActivePage().getDocumentPageOrigin();this.transform.translate(a.x,a.y)};h.prototype.indicateSnapPoint=function(a){this._snapPoint!==
a&&(this._snapPoint=a,this.modelChanged())};h.prototype.getLinework=function(){var h=[];if(this._anchor){var c=new g;c.type=d.LWTYPE_IMAGE;c.linewidth=1;c.imageRef=e.anchorAlignment[this._isActive?"ACTIVE":"DEFAULT"];c.staticsize=!0;c.setRect(new b.Rect(new b.Point(this._anchor.x,this._anchor.y)));c.imageOffset=new b.Size(e.anchorAlignment.OFFSET.width,e.anchorAlignment.OFFSET.height);h.push(c)}this._snapPoint&&(this._snapIndicator?this._snapIndicator.setCenter(this._snapPoint):this._snapIndicator=
new a(this._snapPoint),h.push(this._snapIndicator));return h};return h});
define("web-viewer/compare/alignment/CompareAnchorTool",["underscore","web-viewer/viewport/tools/AbstractTool","web-viewer/utils/ShapeUtils","web-viewer/core/CoreConstants"],function(c,f,e,g){var d=function(b,a,d,e){f.call(this,b,g.TOOLS.COMPARE_ANCHOR_ALIGNMENT);this._alignmentAnchorModel=a;this._currentLayerModel=d;this._referenceLayerModel=e;this._forCadOverlay=!1;null!==window.mozInnerScreenX&&0<=navigator.platform.indexOf("Mac")?(this._macFF=!0,this.f.getContext().addClass("MacFF")):this._macFF=
!1;this.registerState("default",{mousedown:c.bind(function(a){var b=this.getPanelAt(a).getModel().getName();"default"===b?(this._alignmentAnchorModel.setCurrentActive(!0),this.changeState("validPanel")):"compare_difference"===b&&(this._alignmentAnchorModel.setCurrentActive(!1),this.changeState("validPanel"));a.preventDefault()},this),mouseup:function(){},mousemove:c.bind(function(a){this._getAndIndicateSnapPoint(a)},this),contextmenu:c.bind(function(a){a.preventDefault();a.stopPropagation()},this)});
this.registerState("validPanel",c.defaults({mouseup:c.bind(function(a){var b=this._getAndIndicateSnapPoint(a);b||(a=this.getScenePoint(a),b=this.convertScenePointToWorldWithCorrectTransform(a));this._alignmentAnchorModel.setActiveAnchorPosition(b);this.changeState("default")},this),mousemove:c.bind(function(a){var b=this._getAndIndicateSnapPoint(a);b||(a=this.getScenePoint(a),b=this.convertScenePointToWorldWithCorrectTransform(a));this._liveSetAnchor(b)},this)},this.getState("default")));this.registerActiveEvents(["mousedown",
"mousemove","mouseup","contextmenu"]);c.each(["up","down","left","right"],function(a){this.activeKeyEvents.push([a,c.bind(this._handleArrowKey,this,a),"keyup"])},this);this._keyMove=null;this._handleEndOfKeyInput=c.debounce(c.bind(function(){this._keyMove&&(this._alignmentAnchorModel.moveActiveAnchor(this._keyMove.width,this._keyMove.height),this._keyMove=null);this.f.emit("viewport.stopInteractive")},this),500)};d.prototype=Object.create(f.prototype);d.prototype.constructor=d;d.prototype.doActivation=
function(b){f.prototype.doActivation.call(this,b);this.changeState("default")};d.prototype._getActiveAnchorLayerModel=function(){return this._alignmentAnchorModel.isCurrentActive()?this._currentLayerModel:this._referenceLayerModel};d.prototype._liveSetAnchor=function(b){this._getActiveAnchorLayerModel().setAnchor(b)};d.prototype.getDefaultCursor=function(){return"cursor-anchor"};d.prototype.convertScenePointToWorldWithCorrectTransform=function(b){var a=this._widget.getWorld().getTransformation(),
d=this.f.getActivePage().getDocumentPageOrigin();a.translate(d.x,d.y);return a.createInverse().transformedPoint(b)};d.prototype._getAndIndicateSnapPoint=function(b){var a=this.getPanelAt(b);if(a&&(a=a.getModel().getName(),"default"===a||"compare_difference"===a)){var d=this._widget.requestView(b),b=this.getScenePoint(b);if(d){var c;"default"===a?(c=["Cad"],this._forCadOverlay||c.push("CadOverlay")):"compare_difference"===a&&(c=this._forCadOverlay?["CadOverlay"]:["referenceCad"]);(c=d.getClosestLineworkPointFromPoint(b,
16,c))?(c=this.convertScenePointToWorldWithCorrectTransform(c),this._currentLayerModel.indicateSnapPoint("default"===a?c:null),this._referenceLayerModel.indicateSnapPoint("compare_difference"===a?c:null),this.setCursor("cursor-none")):(c=this.convertScenePointToWorldWithCorrectTransform(b),this._currentLayerModel.indicateSnapPoint(null),this._referenceLayerModel.indicateSnapPoint(null),this.setCursor("cursor-anchor"));return c}}return null};d.prototype._handleArrowKey=function(b){this._keyMove||(this.f.emit("viewport.startInteractive"),
this._keyMove=new e.Size(0,0));var a=1/this._widget.getWorld().getZoom(),b=c.indexOf(["up","right","down","left"],b),d=this._widget.getWorld().getRotation()%360,f=this._widget.getWorld().isFlip();if(this._widget.getWorld().isFlipViewFromBack()){if(90===d||270===d)d=(d+180)%360;f=!f}b=(b+4-d/90%4)%4;f&&(1==b?b=3:3==b&&(b=1));f=d=0;switch(b){case 0:f-=a;break;case 1:d+=a;break;case 2:f+=a;break;case 3:d-=a}this._getActiveAnchorLayerModel().moveAnchor(d,f);this._keyMove.width+=d;this._keyMove.height+=
f;this._handleEndOfKeyInput()};d.prototype.setForCadOverlay=function(b){this._forCadOverlay=b};d.prototype.getIconOffset=function(){return this._macFF?new e.Size(0,0):new e.Size(5,5)};return d});
define("tpl!web-viewer/compare/alignment/CompareAlignmentWizardWidget",function(){return function(c){var f;return c=""+("<h3>"+(null==(f=c.i18n("AnchorAlignWizardTitle"))?"":_.escape(f))+"</h3>\r\n<p>"+(null==(f=c.getExplanationText())?"":_.escape(f))+"<br />\r\n"+(null==(f=c.i18n("AnchorAlignWizardArrowKeys"))?"":_.escape(f))+"</p>")}});
define("web-viewer/compare/alignment/CompareAlignmentWizardWidget","web-viewer/layout/AbstractWidget Template tpl!web-viewer/compare/alignment/CompareAlignmentWizardWidget web-viewer/layout/component/ToolbarButton web-viewer/layout/component/ButtonGroup web-viewer/layout/component/Popover jquery underscore web-viewer/compare/CompareConstants web-viewer/layout/LayoutConstants web-viewer/core/CoreConstants web-viewer/utils/ListenerUtil".split(" "),function(c,f,e,g,d,b,a,h,j,k,i,m){j=function(j,q,i){c.call(this,
j,k.Widget.ALIGNWIZARD);m.mixin(this,j);this._wizard=q;this._anchorTool=i;this.templateContext=a("<td/>");this.t=new f(j.i18n,e);this.t.d.getExplanationText=function(){return q.isForCadOverlay()?this.i18n("AnchorAlignWizardExplanationCadGraphics"):this.i18n("AnchorAlignWizardExplanation")};this.render=h.throttle(h.bind(this._render,this),40);this._buttonBar=a("<td/>").addClass("buttons");this._anchorToolButton=new g(this.f,"anchorTool","icon-WCR_Align-Point",!0);var u=new b(this._anchorToolButton.element,
this.f.getContext(),this.f.getContext(),"bottom","#333","tooltip",5);this._tooltip=u;var r=this._anchorToolButton.setActive;this._anchorToolButton.setActive=h.bind(function(a,b){r.call(this,b);!b&&a.isVisible()&&a.isEnabled()?u.show():u.hide()},this._anchorToolButton,this);this._anchorToolButton.listenToTool(this._anchorTool,!0);this._anchorToolButton.setTooltip("viewer","AnchorAlignWizardAnchorTool");this._autoAlignButton=new g(this.f,"autoAlign","icon-WCR_Align-Auto",!0,h.bind(function(){this._wizard.doAutoAlign()},
this));this._autoAlignButton.setTooltip("viewer","AlignAuto");this._autoAlignButton.element.addClass("autoAlign");this._alignGroup=new d("alignButtons",[this._anchorToolButton,this._autoAlignButton]);this._buttonBar.append(this._alignGroup.element);this._cancelButton=new g(this.f,"cancelAlignment","icon-WCR_Revert",!0,h.bind(function(){this._tooltip.hide();this._wizard.cancel()},this));this._alignButton=new g(this.f,"saveAlignment","icon-WCR_Save",!0,h.bind(function(){this._tooltip.hide();this._wizard.alignAndExit()},
this));this._alignButton.element.addClass("btn-success");this._cancelSaveGroup=new d("editActionsGroup",[this._cancelButton,this._alignButton]);this._buttonBar.append(this._cancelSaveGroup.element);this.f.loadBundle("viewer",function(){this._tooltip.setContent(a("<div/>").text(this.f.t("AnchorAlignWizardReactivateTool")));this._alignButton.setContent(a("<span/>").text(this.f.t("AnchorAlignWizardAlign")));this._cancelButton.setContent(a("<span/>").text(this.f.t("CancelButton")));this.render()},this)};
j.prototype=Object.create(c.prototype);j.prototype.constructor=j;j.widgetName=k.Widget.ALIGNWIZARD;j.prototype.setContext=function(b){c.prototype.setContext.call(this,b);this.context.addClass("enableTextSelection");this.context.append(a("<table>").append(a("<tr>").append(this.templateContext).append(this._buttonBar)));this.t.setContext(this.templateContext);this.context.addClass("CompareAlignmentWizardWidget");this.render()};j.prototype._render=function(){this._wizard.isAutoAlignEnabled()?this._alignGroup.addButton(this._autoAlignButton):
this._alignGroup.detachButton(this._autoAlignButton);this.t.render()};j.prototype.getWidgetType=function(){return"wizard"};j.prototype.setEnabled=function(a){c.prototype.setEnabled.apply(this,arguments);a||this._tooltip.hide()};j.prototype.setVisible=function(a){c.prototype.setVisible.call(this,a);a||this._tooltip.hide();this.render()};j.prototype.setCollapsed=function(a){c.prototype.setCollapsed.call(this,a);a&&this._tooltip.hide()};return j});
define("web-viewer/compare/alignment/CompareAlignmentWizard","web-viewer/core/ViewerMode web-viewer/core/CoreConstants web-viewer/compare/alignment/CompareAlignmentMode web-viewer/compare/alignment/CompareAlignmentAnchorModel web-viewer/compare/alignment/CompareAlignmentAnchorLayerModel web-viewer/compare/alignment/CompareAnchorTool web-viewer/compare/alignment/CompareAlignmentWizardWidget web-viewer/utils/ListenerUtil web-viewer/utils/ShapeUtils web-viewer/layout/LayoutConstants web-viewer/graphics/GraphicsConstants web-viewer/cad/CadConstants Mousetrap underscore".split(" "),
function(c,f,e,g,d,b,a,h,j,k,i,m,l,q){var p=function(a,b,f){c.call(this,a,"compareAlignmentWizardMode");h.mixin(this,a);this._compareModule=b;this._compareModel=f;this._alignmentAnchorModel=new g(this.f,["module","compare","alignment","anchor"]);this._currentAnchorLayerModel=new d(this.f,"compare_alignment_currentAnchor");this._referenceAnchorLayerModel=new d(this.f,"compare_alignment_referenceAnchor");this._compareAlignmentMode=new e(this.f,this._compareModel,this._currentAnchorLayerModel,this._referenceAnchorLayerModel);
this._compareModel.registerMode(this._compareAlignmentMode);this._anchorTool=this._middleToActiveAnchor=this._compareAlignmentWizardWidget=null;this._forCadOverlay=!1;this._offsetBeforeStart=null;this._before={};this._activeAnchorToWorldOffset=new j.Size;this._compareDiffMode=null;this._onPressA=q.bind(function(){this.f.emit("toolManager.activateTool",this._anchorTool)},this)};p.prototype=Object.create(c.prototype);p.prototype.constructor=p;p.prototype._doStart=function(){this._before={};this._offsetBeforeStart=
this._forCadOverlay?this._compareModel.getCadOverlayOffset():this._compareModel.getOffset();var b=this.f.getModule("graphics");b&&(this._before.channelViewMode=b.getChannelViewMode(),b.setChannelViewMode(i.ChannelViewMode.COMPOSITE_VIEW));if(b=this.f.getModule("cad"))this._before.cadGraphicsMode=b.getCadGraphicsMode(),b.setCadGraphicsMode(m.CadGraphicsMode.BOTH);this._registerListener("changed.*",this._anchorsUpdated,this,this._alignmentAnchorModel);this._registerListener("referenceOffset.beforeChange",
this._storeMiddleToAnchorOffset,this,this._compareModule);this._registerListener("cadOverlayOffset.beforeChange",this._storeMiddleToAnchorOffset,this,this._compareModule);this._registerListener("referenceOffset.changed",this._offsetChanged,this,this._compareModel);this._registerListener("cadOverlayOffset.changed",this._offsetChanged,this,this._compareModel);this._alignmentAnchorModel.reset();this._currentAnchorLayerModel._updateTransformation();this._referenceAnchorLayerModel._updateTransformation();
this._disallowAllToolsExcept([f.TOOLS.PAN,f.TOOLS.ZOOM,f.TOOLS.COMPARE_ANCHOR_ALIGNMENT]);this._compareDiffMode=this._compareModule.getCurrentDiffMode();this._compareAlignmentMode.setForCadOverlay(this._forCadOverlay);this._compareModule.activateModeByName("alignment");this._anchorTool||this._initializeAnchorTool();this._anchorTool.setForCadOverlay(this._forCadOverlay);this.f.emit("toolManager.activateTool",this._anchorTool);this._compareAlignmentWizardWidget||(this._compareAlignmentWizardWidget=
new a(this.f,this,this._anchorTool),this.f.emit("layout.addWidget",a.widgetName,q.bind(function(){return this._compareAlignmentWizardWidget},this)));this._compareAlignmentWizardWidget.setEnabled(!0);l.bind("a",this._onPressA,"keypress");this.f.emit("layout.switchLayoutMode",k.LayoutMode.WIZARD);this._compareAlignmentWizardWidget&&this._compareAlignmentWizardWidget.render()};p.prototype._doStop=function(){this._unregisterAllListeners();this._allowAllTools();this._anchorTool.isActive()&&this._anchorTool.requestDeactivation();
this._compareModule.activateModeByDiffMode(this._compareDiffMode);this._compareDiffMode=null;l.unbind("a",this._onPressA,"keypress");this._compareAlignmentWizardWidget.setEnabled(!1);this.f.emit("layout.switchLayoutMode");var a=this.f.getModule("graphics");a&&a.setChannelViewMode(this._before.channelViewMode);(a=this.f.getModule("cad"))&&void 0!==this._before.cadGraphicsMode&&a.setCadGraphicsMode(this._before.cadGraphicsMode)};p.prototype._offsetChanged=function(){this._currentAnchorLayerModel.indicateSnapPoint(null);
this._referenceAnchorLayerModel.indicateSnapPoint(null);this._currentAnchorLayerModel._updateTransformation();this._referenceAnchorLayerModel._updateTransformation();this._alignmentAnchorModel.setReferenceAnchor(this._alignmentAnchorModel.getCurrentAnchor());this._restoreMiddleToAnchorOffset()};p.prototype._setReferenceOffset=function(){var a=this._alignmentAnchorModel.getOffset(),b;if(a&&!(0===a.width&&0===a.height))if(this._forCadOverlay){var d=this._compareModel.getCadOverlayOffset();b=this.f.getModule("cad");
a=b.getOverlayTransform().createInverse().transformedSize(a);this._compareModule.changeCadOverlayOffset(new j.Point(d.x-a.width,d.y+a.height))}else d=this._compareModel.getOffset(),this.f.getActivePage().hasCad()&&(b=this.f.getModule("cad"),a=b.getReferenceTransform().createInverse().transformedSize(a),a.width=-a.width),this._compareModule.changeReferenceOffset(new j.Point(d.x+a.width,d.y+a.height))};p.prototype._anchorsUpdated=function(){this._referenceAnchorLayerModel.setAnchor(this._alignmentAnchorModel.getReferenceAnchor());
this._currentAnchorLayerModel.setAnchor(this._alignmentAnchorModel.getCurrentAnchor());this._currentAnchorLayerModel.setActive(this._alignmentAnchorModel.isCurrentActive());this._referenceAnchorLayerModel.setActive(!this._alignmentAnchorModel.isCurrentActive());this._setReferenceOffset()};p.prototype._initializeAnchorTool=function(){this._anchorTool=new b(this.f,this._alignmentAnchorModel,this._currentAnchorLayerModel,this._referenceAnchorLayerModel);this.f.emit("toolManager.addTool",this._anchorTool)};
p.prototype.cancel=function(){this._forCadOverlay?this._compareModule.changeCadOverlayOffset(this._offsetBeforeStart):this._compareModule.changeReferenceOffset(this._offsetBeforeStart);this.requestStop()};p.prototype.alignAndExit=function(){this.requestStop()};p.prototype.doAutoAlign=function(){this._compareModule.doAutoAlign()};p.prototype._storeMiddleToAnchorOffset=function(){var a=this._alignmentAnchorModel.getActiveAnchor();if(a&&!this._middleToActiveAnchor){var b=this.f.getActivePage().getDocumentPageOrigin();
a.offset(new j.Size(b.x,b.y));var d=this.f.getModule("viewport"),b=d.getMiddle(),d=d.getZoom();this._middleToActiveAnchor=new j.Size((a.x-b.x)*d,(a.y-b.y)*d);this.f.emit("module.graphics.model.needsFragmentCleanup")}};p.prototype._restoreMiddleToAnchorOffset=function(){if(this._middleToActiveAnchor){var a=this._alignmentAnchorModel.getActiveAnchor(),b=this.f.getActivePage().getDocumentPageOrigin();a.offset(new j.Size(b.x,b.y));var b=this.f.getModule("viewport"),d=b.getZoom();b.transform({middle:new j.Point(a.x-
this._middleToActiveAnchor.width/d,a.y-this._middleToActiveAnchor.height/d),animated:!1,tmpDisableConstraints:!0});this._middleToActiveAnchor=null}};p.prototype.isAutoAlignEnabled=function(){return!this.f.getActivePage().hasCad()&&!this._forCadOverlay};p.prototype.isForCadOverlay=function(){return this._forCadOverlay};p.prototype.setForCadOverlay=function(a){this._forCadOverlay=a};return p});
define("web-viewer/layout/component/Spinner",["web-viewer/layout/component/Tooltip","web-viewer/utils/ViewerUtils","underscore","jquery","jqueryUI"],function(c,f,e,g){var d=function(b,a){this.f=b;this._min=void 0===a.min?0:a.min;this._max=void 0===a.max?100:a.max;this._step=void 0===a.step?1:a.step;this._page=void 0===a.page?10:a.page;this._onSpinnerChanged=a.onSpinnerChanged;this._inputUnit=void 0===a.inputUnit?"%":a.inputUnit;this.element=g("<div />").addClass("spinnerWrapper");this._input=g("<input />").attr("size",
(""+this._max).length).addClass("input");this._input.on("keydown",e.bind(this._valueChanged,this));this._input.on("blur",e.bind(this._valueChanged,this));this._labelUnit=g("<span>"+this._inputUnit+"</span>");this._label=g("<label />").addClass("unit").append(this._input).append(this._labelUnit);this.element.append(this._label);this._input.spinner({min:this._min,max:this._max,step:this._step,page:this._page,spin:e.bind(function(a,b){this._fireSpinnerChanged(b.value)},this)});this.setValue(this._min);
void 0!==a.tooltip&&(this._tooltip=new c(b,this.element,a.tooltip))};d.prototype._valueChanged=function(b){if((13==b.which||13==b.keyCode)&&"keydown"===b.type)this._input.blur();else if("keydown"!==b.type){var a=f.parseFloat(g(b.target).val());isNaN(a)&&(a=this._min);a=Math.max(Math.min(a,this._max),this._min);g(b.target).val(a);this._fireSpinnerChanged(a)}};d.prototype._fireSpinnerChanged=function(b){this._onSpinnerChanged(b)};d.prototype.setValue=function(b){this.getValue()!==b&&this._input.spinner("value",
b)};d.prototype.getValue=function(){return this._input.spinner("value")};d.prototype.isDisabled=function(){return this._input.spinner("option","disabled")};d.prototype.setDisabled=function(b){this._input.spinner("option","disabled",b)};d.prototype.setTooltip=function(b){void 0===this._tooltip?this._tooltip=new c(this.f,this.element,b):this._tooltip.setTooltipContent(b)};d.prototype.setOption=function(b,a){var d=this["_"+b];void 0!==d&&d!==a&&(this["_"+b]=a,this._input.spinner("option",b,a))};d.prototype.setInputUnit=
function(b){this._inputUnit=b;this._labelUnit.empty();this._labelUnit.append(this._inputUnit)};return d});
define("web-viewer/layout/component/Slider","web-viewer/layout/component/Tooltip web-viewer/layout/component/Spinner web-viewer/utils/ViewerUtils underscore jquery jqueryUI jqueryUITouchPunch".split(" "),function(c,f,e,g,d){e=function(b,a){this.f=b;this._min=void 0===a.min?0:a.min;this._max=void 0===a.max?100:a.max;this._step=void 0===a.step?1:a.step;this._onSliderChanged=a.onSliderChanged;this._showInput=void 0===a.showInput?!0:a.showInput;this._inputUnit=void 0===a.inputUnit?"%":a.inputUnit;this.element=
d("<div />").addClass("sliderWrapper");this._slider=d("<div />").addClass("slider");this.element.append(this._slider);this._slider.slider({slide:g.bind(function(a,b){this._setInputValue(b.value);this._fireSliderChanged(b.value)},this),min:this._min,max:this._max,step:this._step});this._showInput&&(this._spinner=new f(b,{min:this._min,max:this._max,step:this._step,page:10*this._step,onSpinnerChanged:g.bind(function(a){this._setSliderValue(a)},this),inputUnit:this._inputUnit}),this.element.append(this._spinner.element));
void 0!==a.tooltip&&(this._tooltip=new c(b,this.element,a.tooltip))};e.prototype._fireSliderChanged=function(b){this._onSliderChanged(b)};e.prototype._setSliderValue=function(b){this.getValue()!==b&&(this._slider.slider("value",b),this._fireSliderChanged(b))};e.prototype._setInputValue=function(b){this._showInput&&this._spinner.setValue(b)};e.prototype.setValue=function(b){this.getValue()!==b&&(this._setSliderValue(b),this._setInputValue(b))};e.prototype.getValue=function(){return this._slider.slider("value")};
e.prototype.isDisabled=function(){return this._slider.slider("option","disabled")};e.prototype.setDisabled=function(b){this._slider.slider("option","disabled",b);this._showInput&&this._input.spinner("option","disabled",b)};e.prototype.setTooltip=function(b){void 0===this._tooltip?this._tooltip=new c(this.f,this.element,b):this._tooltip.setTooltipContent(b)};e.prototype.setOption=function(b,a){var d=this["_"+b];void 0!==d&&d!==a&&(this["_"+b]=a,this._slider.slider("option",b,a),this._showInput&&this._spinner.setOption(b,
a))};e.prototype.getOption=function(b){return this["_"+b]};return e});
define("web-viewer/layout/component/DoubleColorBlock",["jquery"],function(c){var f=function(e,f){this.element=c("<div />").addClass("doubleColorBlock");this._leftBlock=c("<div />").addClass("part");this._rightBlock=c("<div />").addClass("part");void 0!==e&&this.setLeftColor(e);void 0!==f&&this.setRightColor(f);this.element.append(this._leftBlock);this.element.append(this._rightBlock)};f.prototype.setLeftColor=function(c){this._leftBlock.css("background-color",c)};f.prototype.setRightColor=function(c){this._rightBlock.css("background-color",
c)};return f});
define("web-viewer/compare/CompareDifferenceSubToolbarComponent","web-viewer/layout/component/ToolbarComponent web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/DropdownSubtoolbarButton web-viewer/layout/component/ButtonGroup web-viewer/layout/component/Slider web-viewer/layout/component/ColorPicker web-viewer/layout/component/DoubleColorBlock web-viewer/compare/CompareConstants web-viewer/utils/ListenerUtil underscore".split(" "),function(c,f,e,g,d,b,a,h,j,k){var i=function(a,
b,d){j.mixin(this,a);c.call(this,"DifferenceCompareOptions",a);this.f=a;this.compareDiffMode=b;this.parent=d;this._initColorSpace();this._initThresholdSlider();this._initHighlightColor();this._initDiffmode();this.f.getDocumentController().whenActivePageChanged(k.bind(function(a,b){this._whenActivePageChanged(a,b)},this))};i.prototype=Object.create(c.prototype);i.prototype.constructor=i;i.prototype._whenActivePageChanged=function(a,b){b.hasCad()?(this.colorspaceGroup.hide(),this.differenceShowModeGroup.hide(),
this.slider.element.addClass("displayNone")):(this.colorspaceGroup.show(),this.differenceShowModeGroup.show(),this.slider.element.removeClass("displayNone"))};i.prototype._initColorSpace=function(){this.colorSpaceButtons=[];var a=this.f.isMobile();this.colorSpaceButtons[0]=new f(this.f,"colorspaceChannels",a?"icon-WCR_Compare-Channels":"compareChannels",!0,k.bind(this.compareDiffMode.setColorSpace,this.compareDiffMode,h.colorSpace.CHANNELS));this.colorSpaceButtons[1]=new f(this.f,"colorspaceHSV",
a?"icon-WCR_Compare-HSV":"compareHSV",!0,k.bind(this.compareDiffMode.setColorSpace,this.compareDiffMode,h.colorSpace.HSV));this.colorSpaceButtons[2]=new f(this.f,"colorspaceAutomatic",a?"icon-WCR_Compare-Automatic":"compareAutomatic",!0,k.bind(this.compareDiffMode.setColorSpace,this.compareDiffMode,h.colorSpace.AUTOMATIC));this.f.i18n.loadBundle("viewer",function(){var a=this.f.i18n.t("DiffColorSpace")+" ";this.colorSpaceButtons[0].setTooltip(a+this.f.i18n.t("DiffColorSpaceChannels"));this.colorSpaceButtons[1].setTooltip(a+
this.f.i18n.t("DiffColorSpaceHsv"));this.colorSpaceButtons[2].setTooltip(a+this.f.i18n.t("DiffColorSpaceAutomatic"))},this);this.colorspaceGroup=new g("colorspace",this.colorSpaceButtons);this.colorspaceGroup.element.addClass("toggleBtnGroup");this.addButtonGroup(this.colorspaceGroup);this.compareDiffMode.on("changed.colorspace",k.bind(this.updateColorSpaceButtons,this));this.updateColorSpaceButtons(0,this.compareDiffMode.getColorSpace())};i.prototype.updateColorSpaceButtons=function(a,b){k.each(this.colorSpaceButtons,
function(a,d){b===h.colorSpace.DEFAULT&&(b=h.colorSpace.CHANNELS);a.setActive(d+1===b)},this)};i.prototype._initThresholdSlider=function(){this.slider=new d(this.f,{onSliderChanged:k.bind(k.debounce(function(){this.compareDiffMode.setThreshold(this.slider.getValue())},250),this)});this.slider.setValue(this.compareDiffMode.getThreshold());this._registerListener("changed.threshold",function(a,b){this.slider.setValue(b)},this,this.compareDiffMode);this.f.i18n.loadBundle("viewer",function(){this.slider.setTooltip(this.f.i18n.t("ChangeDifferenceThresholdTT"))},
this);this.element.append(this.slider.element)};i.prototype._initHighlightColor=function(){if(!this.f.isMobile()){this.diffColorChangeGroup=new g("diffColorChangeGroup");this.addButtonGroup(this.diffColorChangeGroup);var d=new a(this.compareDiffMode.getAddedHighlightColor(),this.compareDiffMode.getSubtractedHighlightColor()),c=new e(this.f,"ChangeDiffColor",d.element,!0);c.setTooltip("viewer","ChangeDifferenceHighlightColorsTT");this.diffColorChangeGroup.addButton(c);var h=new b(k.bind(this.compareDiffMode.setAddedHighlightColor,
this.compareDiffMode));h.setColor(this.compareDiffMode.getAddedHighlightColor());var j=new b(k.bind(this.compareDiffMode.setSubtractedHighlightColor,this.compareDiffMode));j.setColor(this.compareDiffMode.getSubtractedHighlightColor());var i=new a(this.compareDiffMode.getAddedHighlightColor(),this.compareDiffMode.getSubtractedHighlightColor()),r=new b(k.bind(function(a){this.compareDiffMode.setAddedHighlightColor(a);this.compareDiffMode.setSubtractedHighlightColor(a)},this),i.element);r.setColor(this.compareDiffMode.getAddedHighlightColor());
this.compareDiffMode.on("changed.addedHighlightColor",function(a,b){h.setColor(b);d.setLeftColor(b);i.setLeftColor(b)});this.compareDiffMode.on("changed.subtractedHighlightColor",function(a,b){j.setColor(b);d.setRightColor(b);i.setRightColor(b)});this.f.i18n.loadBundle("viewer",function(){c.addAction({name:"changeAddedHighlightColor",icon:h.element,content:this.f.i18n.t("DiffAddColor"),enabled:!0,action:function(){h.show()}});c.addAction({name:"changeSubtractedHighlightColor",icon:j.element,content:this.f.i18n.t("DiffSubColor"),
enabled:!0,action:function(){j.show()}});c.addAction({name:"changeBothHighlightColor",icon:r.element,content:this.f.i18n.t("DiffBothColors"),enabled:!0,action:function(){r.show()}})},this);var w=new f(this.f,"ResetDiffColor","resetColor",!0,k.bind(this.compareDiffMode.resetHighlightColors,this.compareDiffMode));w.setTooltip("viewer","DiffResetColor");this.diffColorChangeGroup.addButton(w)}};i.prototype._initDiffmode=function(){this.showModeButtons=[];var a=this.f.isMobile();this.showModeButtons[0]=
new f(this.f,"differenceShow",a?"icon-WCR_Compare-BothDiff":"compareViewBoth",!0,k.bind(this.setDifferenceMode,this,h.showDifferenceMode.SHOW));this.showModeButtons[1]=new f(this.f,"differenceHighlight",a?"icon-WCR_Compare-HighlightDiff":"compareViewBothHighlightDifference",!0,k.bind(this.setDifferenceMode,this,h.showDifferenceMode.HIGHLIGHT));this.showModeButtons[2]=new f(this.f,"differenceOnly",a?"icon-WCR_Compare-ShowDiff":"compareViewBothOnlyDifference",!0,k.bind(this.setDifferenceMode,this,h.showDifferenceMode.ONLY));
this.f.i18n.loadBundle("viewer",function(){this.showModeButtons[0].setTooltip(this.f.i18n.t("DiffBothTT"));this.showModeButtons[1].setTooltip(this.f.i18n.t("DiffBothHighlightTT"));this.showModeButtons[2].setTooltip(this.f.i18n.t("DiffBothShowTT"))},this);this.differenceShowModeGroup=new g("differenceShowMode",this.showModeButtons);this.differenceShowModeGroup.element.addClass("toggleBtnGroup");this.addButtonGroup(this.differenceShowModeGroup);this.compareDiffMode.on("changed.differenceMode",k.bind(this.updateDifferenceModeButtons,
this));this.updateDifferenceModeButtons(0,this.compareDiffMode.getDifferenceMode())};i.prototype.updateDifferenceModeButtons=function(a,b){k.each(this.showModeButtons,function(a,d){a.setActive(d+2===b);a.element.removeClass("displayNone")});this.updateParentIcon(["compareViewBoth","compareViewBothHighlightDifference","compareViewBothOnlyDifference"][b-2])};i.prototype.updateParentIcon=function(a){this.parent&&this.parent.setIcon(a)};i.prototype.setDifferenceMode=function(a){this.compareDiffMode.setDifferenceMode(a)};
return i});
define("web-viewer/compare/CompareSideBySideSubToolbarComponent","web-viewer/compare/CompareDifferenceSubToolbarComponent web-viewer/layout/component/ButtonGroup web-viewer/layout/component/SubtoolbarButton web-viewer/layout/component/DropdownSubtoolbarButton web-viewer/viewport/ViewportConstants jquery underscore".split(" "),function(c,f,e,g,d,b,a){b=function(b,j,k,i){this._sideBySideMode=k;c.call(this,b,j,i);this._tileIcons=["automaticTiling","verticalTiling","horizontalTiling"];this._tileButton=new g(this.f,
"sideBySideMode",this.getTileIcon(),!0);this._tileButton.setTooltip("viewer","diffChangeSideBySideTilingMode");this.f.i18n.loadBundle("viewer",function(){this._tileButton.addAction({name:"automaticTiling",icon:"automaticTiling",content:this.f.i18n.t("DiffSplitTileAuto"),enabled:!0,action:a.bind(function(){this._sideBySideMode.setPanelsLayoutMode(d.PanelsLayoutMode.AUTOMATIC)},this)});this._tileButton.addAction({name:"verticalTiling",icon:"verticalTiling",content:this.f.i18n.t("DiffSplitTileVer"),
enabled:!0,action:a.bind(function(){this._sideBySideMode.setPanelsLayoutMode(d.PanelsLayoutMode.VERTICAL)},this)});this._tileButton.addAction({name:"horizontalTiling",icon:"horizontalTiling",content:this.f.i18n.t("DiffSplitTileHor"),enabled:!0,action:a.bind(function(){this._sideBySideMode.setPanelsLayoutMode(d.PanelsLayoutMode.HORIZONTAL)},this)})},this);this.f.isMobile()||(this._tilingModeButtonGroup=new f("tilingmode",[this._tileButton]),this.prependButtonGroup(this._tilingModeButtonGroup));this.toggleDifferenceSidePanelButton=
new e(this.f,"toggleDifferencePanel",this.f.isMobile()?"icon-WCR_Compare-HideDiff":"compareToggleDifferencePanel",!1,a.bind(this.toggleDifferencePanel,this));this.toggleDifferenceSidePanelButton.setTooltip("viewer","compareDisableDifferenceView");this.f.i18n.loadBundle("viewer",function(){var a=this.f.i18n.t("DiffBothSplitShowDiff")+": <br />\r\n";this.showModeButtons[0].setTooltip(a+this.f.i18n.t("DiffBothTT"));this.showModeButtons[1].setTooltip(a+this.f.i18n.t("DiffBothHighlightTT"));this.showModeButtons[2].setTooltip(a+
this.f.i18n.t("DiffBothShowTT"))},this);this.differenceShowModeGroup.prependButton(this.toggleDifferenceSidePanelButton);this._sideBySideMode.on("changed.*",a.bind(function(){this.updateControls()},this));this.updateControls()};b.prototype=Object.create(c.prototype);b.prototype.constructor=b;b.prototype.updateParentIcon=function(){};b.prototype.updateControls=function(){this.differenceShowModeGroup.show();if(this._sideBySideMode.isShowingDifference()){this.diffColorChangeGroup&&this.diffColorChangeGroup.show();
var a=this.f.getDocumentController().getActivePage();a&&!a.hasCad()&&(this.colorspaceGroup.show(),this.slider.element.removeClass("displayNone"))}else this.colorspaceGroup.hide(),this.slider.element.addClass("displayNone"),this.diffColorChangeGroup&&this.diffColorChangeGroup.hide();this._tileButton&&this._tileButton.setIcon(this.getTileIcon());this.updateDifferenceModeButtons();this.element.trigger("contentResized")};b.prototype.setDifferenceMode=function(a){this._sideBySideMode.setShowingDifference(!0);
c.prototype.setDifferenceMode.call(this,a)};b.prototype._whenActivePageChanged=function(a,b){c.prototype._whenActivePageChanged.call(this,a,b);this.updateControls()};b.prototype.updateDifferenceModeButtons=function(){this._sideBySideMode.isShowingDifference()?c.prototype.updateDifferenceModeButtons.call(this,void 0,this.compareDiffMode.getDifferenceMode()):a.each(this.showModeButtons,function(a){a.setActive(!1)});this.toggleDifferenceSidePanelButton&&this.toggleDifferenceSidePanelButton.setActive(!this._sideBySideMode.isShowingDifference());
var b=this.f.getDocumentController().getActivePage();b&&!b.hasCad()?a.each(this.showModeButtons,function(a){a.element.removeClass("displayNone");a.element.removeClass("endRoundedCorner")}):a.each(this.showModeButtons,function(a,b){0<b?a.element.addClass("displayNone"):a.element.addClass("endRoundedCorner")})};b.prototype.getTileIcon=function(){return this._tileIcons[this._sideBySideMode.getPanelsLayoutMode()]};b.prototype.toggleDifferencePanel=function(){this._sideBySideMode.isShowingDifference()&&
this._sideBySideMode.setShowingDifference(!1)};return b});
define("web-viewer/compare/CompareToolbarComponent","web-viewer/layout/component/ToolbarComponent web-viewer/layout/component/ButtonGroup web-viewer/layout/component/ToolbarButton web-viewer/layout/LayoutConstants web-viewer/compare/CompareConstants web-viewer/compare/CompareDifferenceSubToolbarComponent web-viewer/compare/CompareSideBySideSubToolbarComponent underscore".split(" "),function(c,f,e,g,d,b,a,h){var j=function(a,b){c.call(this,g.ToolbarComponent.COMPARE,a);this.f=a;this.compareModule=
b;this.compareModel=b.getCompareModel();this.buttons={};this.modesGroup=new f("Compare",[]);this.modesGroup.setTitle(this.f,"viewer","CompareToolsTitle");this.addButtonGroup(this.modesGroup);this.compareModel.on("changed.mode",h.bind(function(a,b){a&&void 0!==this.buttons[a.getName()]&&this.buttons[a.getName()].setActive(!1);b&&void 0!==this.buttons[b.getName()]&&this.buttons[b.getName()].setActive(!0)},this));this.addButtonForMode(d.mode.SHOW_CURRENT,"compareShowCurrent","DiffCurrentTT");this.addButtonForMode(d.mode.SHOW_DIFFERENCE,
"compareShowDifference","DiffPrevTT");this.addButtonForMode(d.mode.BLINKING,"compareBlinking","DiffBothBlinkingTT");this.addButtonForMode(d.mode.SHOWBOTHONTOP,"compareShowBothOnTop","DiffShowBothOnTopTT");var e=this.compareModel.getModeByName(d.mode.DIFFERENCE);if(void 0!==e){this.addDifferenceModeButton(e);var j=h.debounce(h.bind(this._updateBadges,this),0);e.on("changed.threshold",j);this.compareModel.on("changed.mode",j);this.f.getDocumentController().whenActivePageChanged(j);var q=this.compareModel.getModeByName(d.mode.SIDEBYSIDE);
void 0!==q&&(this.addSideBySideModeButton(e,q),q.on("changed.showDifference",j));this._updateBadges()}};j.prototype=Object.create(c.prototype);j.prototype.constructor=j;j.toolbarName=g.ToolbarComponent.COMPARE;j.prototype.addButtonForMode=function(a,b,d){this.buttons[a]=new e(this.f,"compare_"+a,b,!0,h.partial(function(b){this.isActive()?b.compareModule.activateModeByName():b.compareModule.activateModeByName(a)},this));this.buttons[a].setTooltip("viewer",d);this.modesGroup.addButton(this.buttons[a])};
j.prototype.addDifferenceModeButton=function(a){this.addButtonForMode(d.mode.DIFFERENCE,"compareViewBoth","compareDifferenceMode");var c=this.buttons[d.mode.DIFFERENCE];c.addSubtoolbarComponent(new b(this.f,a,c));this._differenceCompareMode=a};j.prototype.addSideBySideModeButton=function(b,c){this.addButtonForMode(d.mode.SIDEBYSIDE,"compareSideBySide","DiffBothSplitTT");var e=this.buttons[d.mode.SIDEBYSIDE];e.addSubtoolbarComponent(new a(this.f,b,c,e));this._sideBySideCompareMode=c};j.prototype._updateBadges=
function(){var a;this.buttons[d.mode.DIFFERENCE]&&this._differenceCompareMode&&(a=this.buttons[d.mode.DIFFERENCE],this._differenceCompareMode.isEnabled()&&0<this._differenceCompareMode.getThreshold()&&!this.f.getActivePage().hasCad()?(a.setBadge("!","warning"),a.setTooltip("viewer","compareDifferenceThresholdWarning")):(a.setBadge(),a.setTooltip("viewer","compareDifferenceMode")));this.buttons[d.mode.SIDEBYSIDE]&&(a=this.buttons[d.mode.SIDEBYSIDE],this._sideBySideCompareMode.isEnabled()&&this._sideBySideCompareMode.isShowingDifference()&&
0<this._differenceCompareMode.getThreshold()&&!this.f.getActivePage().hasCad()?(a.setBadge("!","warning"),a.setTooltip("viewer","compareDifferenceThresholdWarning")):(a.setBadge(),a.setTooltip("viewer","DiffBothSplitTT")))};return j});
define("web-viewer/compare/CompareTouchToolbarComponent","web-viewer/layout/component/ToolbarComponent web-viewer/layout/component/ButtonGroup web-viewer/layout/component/ToolbarButton web-viewer/layout/LayoutConstants web-viewer/compare/CompareConstants underscore".split(" "),function(c,f,e,g,d,b){var a=function(a,e){c.call(this,g.ToolbarComponent.COMPARE,a);this.f=a;this._compareModule=e;this._compareModel=e.getCompareModel();this._buttons={};this._modesGroup=new f("Compare",[]);this._modesGroup.element.removeClass("btn-group");
this._modesGroup.element.addClass("compareModes");this._modesGroup.setTitle(this.f,"viewer","CompareToolsTitle");this.addButtonGroup(this._modesGroup);var k=this._compareModel.getModeByName(d.mode.DIFFERENCE);this.addDifferenceModeButton(k);this.addButtonForMode(d.mode.BLINKING,"icon-WCR_Compare-Blinking","DiffBothBlinkingTT");var i=this._compareModel.getModeByName(d.mode.SIDEBYSIDE);this.addSideBySideModeButton(k,i);this.addButtonForMode(d.mode.SHOWBOTHONTOP,"icon-WCR_Compare-Both","DiffShowBothOnTopTT");
this.addButtonForMode(d.mode.SHOW_CURRENT,"icon-WCR_Compare-Current","DiffCurrentTT");this.addButtonForMode(d.mode.SHOW_DIFFERENCE,"icon-WCR_Compare-Reference","DiffPrevTT");this._compareModel.on("changed.mode",b.bind(this._updateActiveStatus,this));this._updateActiveStatus(void 0,this._compareModule.getActiveMode())};a.prototype=Object.create(c.prototype);a.prototype.constructor=a;a.toolbarName=g.ToolbarComponent.COMPARE;a.prototype._updateActiveStatus=function(a,b){a&&void 0!==this._buttons[a.getName()]&&
this._buttons[a.getName()].setActive(!1);b&&void 0!==this._buttons[b.getName()]&&this._buttons[b.getName()].setActive(!0)};a.prototype.addButtonForMode=function(a,d,c){this._buttons[a]=new e(this.f,"compare_"+a,d,!0,b.partial(function(b){this.isActive()?b._compareModule.activateModeByName():b._compareModule.activateModeByName(a)},this));this._buttons[a].setTooltip("viewer",c);this._modesGroup.addButton(this._buttons[a])};a.prototype.addDifferenceModeButton=function(){this.addButtonForMode(d.mode.DIFFERENCE,
"icon-WCR_Compare-BothDiff","compareDifferenceMode")};a.prototype.addSideBySideModeButton=function(){this.addButtonForMode(d.mode.SIDEBYSIDE,"icon-WCR_Compare-SideBySide","DiffBothSplitTT")};return a});
define("web-viewer/layout/component/UserUnitInputField",["web-viewer/utils/ViewerUtils","web-viewer/core/CoreConstants","underscore","jquery"],function(c,f,e,g){var d=function(b,a,d,f){this.f=b;this.element=g("<span>").addClass("userUnitInputField");this._input=g("<input>").attr("type","number").attr("step","any").appendTo(this.element);this._unitLabel=g("<span>").addClass("unitLabel").appendTo(this.element);this._direction=d;this._mmValue=a=c.parseFloat(a);this.f.getCurrentUser().on("options.changed.PREFERENCES_UNIT_SIZE",
e.bind(this._renderField,this));this._input.on("blur keydown",e.bind(this._inputChanged,this));this._renderField();this._onChange=f};d.prototype.setValue=function(b){var a=this._mmValue;this._mmValue=c.parseFloat(b);this._renderField();a!==this._mmValue&&this._onChange(a,this._mmValue)};d.prototype._renderField=function(){var b=c.convertFromMmValue(this._mmValue,this.f.getUnits(),this.f.getUnitsFix(),this._getResolution());this._input.val(b);this.f.loadBundle("viewer",function(){this._unitLabel.text(this.f.t(this.f.getUnitsLocName()))},
this)};d.prototype._getResolution=function(){var b=this.f.getActivePage();if(b){if("y"===this._direction)return c.parseFloat(b.getParam("resolutiony"));if("x"===this._direction)return c.parseFloat(b.getParam("resolutionx"))}return 1};d.prototype._inputChanged=function(b){if(13==b.which||13==b.keyCode||"keydown"!==b.type){(b=c.parseFloat(this._input.val()))||(b=0);this._input.val(b);var a=this._mmValue;this._mmValue=c.parseFloat(c.convertToMmValue(b,this.f.getUnits(),this.f.getUnitsFix(f.SizeUnits.MM),
this._getResolution()));this._mmValue!=a&&this._onChange(a,this._mmValue);this._input.blur()}};d.prototype.toggleLabel=function(b){this._unitLabel.toggleClass("displayNone",!b)};d.prototype.getValue=function(){return this._mmValue};return d});
define("web-viewer/compare/CompareWidget","web-viewer/layout/AbstractWidget web-viewer/layout/component/ToolbarButton web-viewer/layout/component/DropdownToolbarButton web-viewer/layout/component/MiniButton web-viewer/layout/component/ModalPopup web-viewer/layout/component/UserUnitInputField web-viewer/compare/CompareDifferenceSubToolbarComponent web-viewer/compare/CompareSideBySideSubToolbarComponent web-viewer/layout/LayoutConstants web-viewer/compare/CompareConstants jquery underscore".split(" "),function(c,
f,e,g,d,b,a,h,j,k,i,m){var l=function(a,b,e,h){c.call(this,a,j.Widget.COMPARE);this._compareModel=e;this._compareModule=b;this.f=a;this._documentSelection=h;this._cadOverlayOptionsInitialized=this._compareOptionsInitialized=!1;this._extraControls=i("<div/>").addClass("extraControls displayNone");this._documentSelectionDiv=i("<div/>").addClass("documentSelection");this._compareOptions=i("<div/>").addClass("compareOptions displayNone");this._cadOverlay=i("<div>").addClass("cadOverlay displayNone");
this._resetLinkedComparePagesButton=new g(this.f,"resetLinkedComparePages","icon-WCR_Revert",!0,m.bind(function(){this.f.i18n.loadBundle("viewer",function(){var b=new d(this.f,"resetLinkedComparePagesPopup",this.f.getContext());b.setRemoveFromDomAfterUsage(!0);b.setOkAction(m.bind(function(){this.f.getActivePage().resetLinkedComparePage();this._updateResetLinkedComparePagesBtn();b.hide()},this));b.addButton(new f(this.f,"allPages",i("<span/>").append(a.i18n.t("AllPages")),!0,m.bind(function(){m.each(this.f.getActivePage().getDocumentVersion().getAllPages(),
function(a){a.resetLinkedComparePage()});this._updateResetLinkedComparePagesBtn();b.hide()},this)));b.setHeader(i("<span/>").addClass("popupTitle").text(this.f.i18n.t("ResetLinkedComparePagesTT")));b.setContent(i("<div/>").addClass("unsavedItemsContent").text(this.f.t("ResetLinkedComparePages")));b.setOkBtnText(this.f.i18n.t("PageOnly"));b.show()},this)},this),"icon-WCR_Revert fontIconDisabled");this._resetLinkedComparePagesButton.setTooltip("viewer","ResetLinkedComparePagesTT");this._diffDocPageElement=
i("<div/>");this.f.i18n.loadBundle("viewer",m.bind(function(){this._documentSelectionDiv.append(i("<h4/>").append(this.f.t("DocumentListCurrentLabel")+" <br/>"));this._documentSelectionDiv.append(this._documentSelection.getActiveDocumentSelector().element);this._diffDocPageElement.append(i("<h4/>").append(this.f.t("DocumentListDiffLabel")+" <br/>")).append(this._documentSelection.getDifferenceDocumentSelector().element);this._documentSelectionDiv.append(this._diffDocPageElement);this.setTitle(this.f.t("DocumentListTitle"))},
this));this.f.isMobile()&&this.f.loadBundle("viewer",function(){this._compareModule.on("changed.mode",m.bind(this._compareModeChanged,this));this._compareModeChanged()},this)};l.prototype=Object.create(c.prototype);l.prototype.constructor=l;l.widgetName=j.Widget.COMPARE;l.prototype._compareModeChanged=function(){var b=this._compareModule.getActiveMode(),d;if(b){var c=b.getName();d=this.f.t(k.modeNameToLanguageKey[c]);this.f.isMobile()&&(c===k.mode.DIFFERENCE||c===k.mode.SIDEBYSIDE?(b=this._compareModel.getModeByName(k.mode.DIFFERENCE),
c===k.mode.DIFFERENCE&&(this._differenceCompareControls||(this._differenceCompareControls=new a(this.f,b),this._extraControls.prepend(this._differenceCompareControls.element)),this._differenceCompareControls.element.removeClass("displayNone"),this._sideBySideCompareControls&&this._sideBySideCompareControls.element.addClass("displayNone")),c===k.mode.SIDEBYSIDE&&(this._sideBySideCompareControls||(c=this._compareModel.getModeByName(k.mode.SIDEBYSIDE),this._sideBySideCompareControls=new h(this.f,b,c),
this._extraControls.prepend(this._sideBySideCompareControls.element)),this._sideBySideCompareControls.element.removeClass("displayNone"),this._differenceCompareControls&&this._differenceCompareControls.element.addClass("displayNone")),this._extraControls.removeClass("displayNone")):this._extraControls.addClass("displayNone"),this._fireResized())}else this._extraControls.addClass("displayNone");this.f.isMobile()&&(d||(d=this.f.t("DocumentListTitle")),this.setTitle(d))};l.prototype._initCompareOptions=
function(){this._compareOptionsInitialized||(this._compareOptionsInitialized=!0,this.f.isMobile()||(this._channelMatchingBtn=new f(this.f,"channelMatching","icon-WCR_Channel-Matching",!1,m.bind(function(){var a=this.f.getModule("graphics");void 0!==a&&a.showChannelMatchingPopup()},this))),this._autoAlign=new f(this.f,"autoAlign","icon-WCR_Align-Auto",!0,m.bind(function(){this._emit("doAutoAlign")},this)),this._autoAlign.element.addClass("autoAlign"),this._anchorAlign=new f(this.f,"anchorAlign","icon-WCR_Align-Point",
!0,m.bind(function(){this._compareModule.startAlignmentWizard()},this)),this._anchorAlign.setTooltip("viewer","AnchorAlignWizardTitle"),this._cornerAlign=new e(this.f,"cornerAlign","cornerAlign",!0),this._rotateReference=new f(this.f,"rotateReference","icon-WCR_Orientation-Rotate1",!0,m.bind(function(){this._emit("rotateReference");this._updateRotateBtn()},this)),this._flipReference=new f(this.f,"flipReference","icon-WCR_Orientation-Mirror",!0,m.bind(function(){this._emit("flipReference");this._updateFlipBtn()},
this)),this._negateReference=new f(this.f,"negateReference","icon-WCR_Invert",!0,m.bind(function(){this._emit("negateReference");this._updateNegateBtn()},this)),this._trimBoxAlign=new f(this.f,"trimBoxAlign","icon-WCR_Align-Trimbox",!0,m.bind(function(){this._emit("trimBoxAlign");this._trimBoxAlign.setActive(this._compareModel.isTrimBoxAlign())},this)),this._trimBoxAlign.element.addClass("toggleBtn"),this._offsetX=new b(this.f,0,"x",m.bind(function(a,b){this._emit("offsetXChanged",b)},this)),this._offsetY=
new b(this.f,0,"y",m.bind(function(a,b){this._emit("offsetYChanged",b)},this)),this.f.i18n.loadBundle("viewer",m.bind(function(){this._cornerAlign.addAction({name:"topLeftAlign",content:this.f.t("AlignTopLeft"),icon:"icon-WCR_Align-TopLeft",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.TOPLEFT);this._cornerAlign.setIcon("icon-WCR_Align-TopLeft")},this),enabled:!0});this._cornerAlign.addAction({name:"topCenterAlign",content:this.f.t("AlignTopCenter"),icon:"icon-WCR_Align-TopCenter",
action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.TOPCENTER);this._cornerAlign.setIcon("icon-WCR_Align-TopCenter")},this),enabled:!0});this._cornerAlign.addAction({name:"topRightAlign",content:this.f.t("AlignTopRight"),icon:"icon-WCR_Align-TopRight",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.TOPRIGHT);this._cornerAlign.setIcon("icon-WCR_Align-TopRight")},this),enabled:!0});this._cornerAlign.addAction({name:"centerLeftAlign",content:this.f.t("AlignCenterLeft"),
icon:"icon-WCR_Align-MiddleLeft",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.CENTERLEFT);this._cornerAlign.setIcon("icon-WCR_Align-MiddleLeft")},this),enabled:!0});this._cornerAlign.addAction({name:"centeredAlign",content:this.f.t("AlignCentered"),icon:"icon-WCR_Align-MiddleCenter",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.CENTERED);this._cornerAlign.setIcon("icon-WCR_Align-MiddleCenter")},this),enabled:!0});this._cornerAlign.addAction({name:"centerRightAlign",
content:this.f.t("AlignCenterRight"),icon:"icon-WCR_Align-MiddleRight",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.CENTERRIGHT);this._cornerAlign.setIcon("icon-WCR_Align-MiddleRight")},this),enabled:!0});this._cornerAlign.addAction({name:"bottomLeftAlign",content:this.f.t("AlignBottomLeft"),icon:"icon-WCR_Align-BottomLeft",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.BOTTOMLEFT);this._cornerAlign.setIcon("icon-WCR_Align-BottomLeft")},this),enabled:!0});
this._cornerAlign.addAction({name:"bottomCenterAlign",content:this.f.t("AlignBottomCenter"),icon:"icon-WCR_Align-BottomCenter",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.BOTTOMCENTER);this._cornerAlign.setIcon("icon-WCR_Align-BottomCenter")},this),enabled:!0});this._cornerAlign.addAction({name:"bottomRightAlign",content:this.f.t("AlignBottomRight"),icon:"icon-WCR_Align-BottomRight",action:m.bind(function(){this._emit("doCornerAlign",k.cornerAutoAlign.BOTTOMRIGHT);this._cornerAlign.setIcon("icon-WCR_Align-BottomRight")},
this),enabled:!0});this._channelMatchingBtn&&this._channelMatchingBtn.setTooltip(this.f.i18n.t("MapChanTitle"));this._autoAlign.setTooltip(this.f.t("AlignAuto"));this._rotateReference.setTooltip(this.f.t("RotateReferenceTT"));this._flipReference.setTooltip(this.f.t("MirrorReferenceTT"));this._negateReference.setTooltip(this.f.t("ToolInvertReferenceTT"));this._cornerAlign.setTooltip(this.f.t("AlignCornerReferenceTT"));this._trimBoxAlign.setTooltip(this.f.t("AlignFromTrimBoxTT"));this._addCompareOptionsToDOM()},
this)))};l.prototype._initCadOverlayOptions=function(){this._cadOverlayOptionsInitialized||(this._cadOverlayOptionsInitialized=!0,this._cadOverlaySaveToEmpty=new g(this.f,"saveCadOverlayToEmpty","icon-WCR_Save",!0,m.bind(function(){this._emit("saveCadOverlay")},this),"icon-WCR_Save fontIconDisabled"),this._cadOverlaySaveToEmpty.element.addClass("pull-right"),this._cadOverlaySaveToEmpty.setTooltip("viewer","saveCadRefTT"),this._cadOverlaySaveToEmpty.hide(),this._cadOverlaySave=new f(this.f,"saveCadOVerlay",
"icon-WCR_Save",!0,m.bind(function(){this._emit("saveCadOverlay")},this)),this._cadOverlaySave.setTooltip("viewer","SaveCadOverlayTT"),this._open3DView=new f(this.f,"open3DView","icon-WCR_3D-Create",!1,m.bind(function(){this._compareModule.checkAligmentAndShow3D()},this)),this._open3DView.setTooltip("viewer","Open3DViewTT"),this._cadOverlayOrientation=i("<div>").addClass("alignment"),this._cadOverlayRotate=new f(this.f,"rotateOverlay","icon-WCR_Orientation-Rotate1",!0,m.bind(function(){this._emit("rotateCadOverlay")},
this)),this._cadOverlayRotate.setTooltip("viewer","RotateOverlayTT"),this._cadOverlayFlip=new f(this.f,"flipOverlay","icon-WCR_Orientation-Mirror",!0,m.bind(function(){this._emit("flipCadOverlay")},this)),this._cadOverlayFlip.setTooltip("viewer","FlipOverlayTT"),this._cadOverlayOffsetX=new b(this.f,0,"x",m.bind(function(a,b){this._emit("cadOverlayOffsetXChanged",b)},this)),this._cadOverlayOffsetY=new b(this.f,0,"y",m.bind(function(a,b){this._emit("cadOverlayOffsetYChanged",b)},this)),this.f.loadBundle("viewer",
function(){this.f.isMobile()?this._cadOverlay.append(i("<h3>").text(this.f.t("DocumentListCadOverlayTitle")).append(this._cadOverlaySaveToEmpty.element)):(this._cadOverlay.append(this._cadOverlaySaveToEmpty.element),this._cadOverlay.append(i("<h4>").text(this.f.t("DocumentListCadLabel"))));this._cadOverlay.append(i("<div>").addClass("documentSelection").append(this._documentSelection.getCadOverlayDocumentSelector().element));this._cadOverlay.append(this._cadOverlayOrientation);this.f.isMobile()||
this._cadOverlayOrientation.append(i("<span>").addClass("alignLabel").text(this.f.t("DiffOrientation")));this._cadOverlayOrientation.append(this._cadOverlayRotate.element).append(this._cadOverlayFlip.element);this._cadOverlayOrientation.append("<br />");this.f.isMobile()||(this._cadOverlayOrientation.append(i("<span>").addClass("alignLabel").text(this.f.t("AlignLabel"))),this._cadOverlayAnchorAlign=new f(this.f,"anchorAlign","icon-WCR_Align-Point",!0,m.bind(function(){this._compareModule.startAlignmentWizard(!0)},
this)),this._cadOverlayAnchorAlign.setTooltip("viewer","AnchorAlignWizardTitle"),this._cadOverlayOrientation.append(this._cadOverlayAnchorAlign.element));var a;this.f.isMobile()?(a=i("<div>").addClass("offsetFields"),a.append(i("<p>").addClass("alignLabel").text(this.f.t("AlignOffset"))),a.append(i("<p>").text("X: ").append(this._cadOverlayOffsetX.element)),a.append(i("<p>").text("Y: ").append(this._cadOverlayOffsetY.element))):(this._cadOverlayOffsetX.toggleLabel(!1),a=i("<div>").append(i("<span>").addClass("alignLabel").text(this.f.t("AlignOffset"))),
a.append(i("<div>").addClass("offsetFields").append(this._cadOverlayOffsetX.element).append(this._cadOverlayOffsetY.element)));this._cadOverlayOrientation.append(this._cadOverlaySave.element);this._cadOverlayOrientation.append(this._open3DView.element);this._cadOverlayOrientation.append(a)},this))};l.prototype._addCompareOptionsToDOM=function(){this._compareOptionsInitialized&&(this.context&&!this._compareOptionsAddedToDOM)&&(this._compareOptionsAddedToDOM=!0,this.f.loadBundle("viewer",function(){this.f.isMobile()?
(this._documentSelectionTitle=i("<h3/>").text(this.f.t("DocumentListTitle")),this._extraControls.append(this._documentSelectionTitle)):(this._channelMatching=i("<div/>").addClass("channelMatching"),this._channelMatching.append(i("<h4/>").append(this.f.t("DocumentListChannelMatch")+": ")),this._channelMatching.append(this._channelMatchingBtn.element),this._compareOptions.append(this._channelMatching));this._alignBtns=i("<div/>").addClass("alignment");var a=i(this.f.isMobile()?"<h3/>":"<h4/>");this._alignBtns.append(a.text(this.f.t("DocumentListAlignment")));
this.f.isMobile()||this._alignBtns.append(i("<span>").addClass("alignLabel").text(this.f.t("DiffOrientation")));this._alignBtns.append(this._rotateReference.element);this._alignBtns.append(this._flipReference.element);this._alignBtns.append(this._negateReference.element);this._alignBtns.append("<br>");this.f.isMobile()||this._alignBtns.append(i("<span>").addClass("alignLabel").text(this.f.t("AlignLabel")));this._alignBtns.append(this._autoAlign.element);this.f.isMobile()||this._alignBtns.append(this._anchorAlign.element);
this._alignBtns.append(this._cornerAlign.element);this._alignBtns.append(this._trimBoxAlign.element);this._alignBtns.append("<br>");this.f.isMobile()?(this._offsetFields=i("<div>").addClass("offsetFields"),this._offsetFields.append(i("<p>").addClass("alignLabel").text(this.f.t("AlignOffset"))),this._offsetFields.append(i("<p>").text("X: ").append(this._offsetX.element)),this._offsetFields.append(i("<p>").text("Y: ").append(this._offsetY.element)),this._alignBtns.append(this._offsetFields)):(this._alignBtns.append(i("<span>").addClass("alignLabel").text(this.f.t("AlignOffset"))),
this._offsetFields=i("<div>").addClass("offsetFields"),this._offsetX.toggleLabel(!1),this._offsetFields.append(this._offsetX.element),this._offsetFields.append(this._offsetY.element),this._alignBtns.append(this._offsetFields).append(this._unitLabel));this._compareOptions.append(this._alignBtns);this.headerExtra.append(this._resetLinkedComparePagesButton.element);this._compareModeChanged()},this))};l.prototype.setContext=function(a,b){c.prototype.setContext.call(this,a,b);this.context.addClass("compareWidget");
this.context.append(this._extraControls).append(this._documentSelectionDiv).append(this._compareOptions).append(this._cadOverlay);this._addCompareOptionsToDOM();this.headerExtra.addClass("flexEnd");this._updateResetLinkedComparePagesBtn()};l.prototype.updateCompareWidget=function(){var a=this.f.getDocumentController().getDifferencePage();if(void 0===a||this._compareModel.isReaderSpreadActive())null!==this._compareOptions&&this._compareOptions.addClass("displayNone");else{this._initCompareOptions();
this._compareOptions.removeClass("displayNone");var b=this._compareModel.getOffset();this._offsetX.setValue(b.x);this._offsetY.setValue(b.y);this._trimBoxAlign.setActive(this._compareModel.isTrimBoxAlign());(b=k.cornerAlignIcons[this._compareModel.getCornerAlign()])?this._cornerAlign.setIcon(b):this._cornerAlign.setIcon("icon-WCR_Align-TopLeft");this._updateRotateBtn();this._updateFlipBtn();this._updateNegateBtn();a.hasCad()?(this._negateReference.hide(),this._trimBoxAlign.hide(),this._cornerAlign.hide(),
this._autoAlign.hide(),this._channelMatching&&this._channelMatching.hide()):(this._negateReference.show(),this._trimBoxAlign.show(),this._cornerAlign.show(),this._autoAlign.show(),this._channelMatching&&this._channelMatching.show())}this._cadOverlay&&this._cadOverlay.toggleClass("displayNone",!this._compareModule.isCadOverlayAllowed());this.f.getDocumentController().getCadOverlay()?(this._initCadOverlayOptions(),this._cadOverlayOrientation.removeClass("displayNone"),a=this._compareModel.getCadOverlayOffset(),
this._cadOverlayOffsetX.setValue(a.x),this._cadOverlayOffsetY.setValue(a.y),this._compareModule.canSaveCadOverlay()?(this._cadOverlaySave.show(),!this.f.getActivePage().getDocumentVersion().isMultiPage()&&this.f.getActivePage().get("canGenerate3D")&&this.f.getActivePage().canEditAttributes()?this._open3DView.show():this._open3DView.hide(),this._compareModule.isCadOverlayModified()?this._cadOverlaySave.setEnabled(!0):this._cadOverlaySave.setEnabled(!1)):(this._cadOverlaySave.hide(),this._open3DView.hide()),
this.f.getActivePage().hasLinkedPage()&&(this.f.getActivePage().get("canGenerate3D")&&this.f.getActivePage().canEditAttributes())&&this._open3DView.show(),this._cadOverlaySaveToEmpty.hide(),this._updateCadOverlayButtons()):(this._cadOverlayOrientation&&this._cadOverlayOrientation.addClass("displayNone"),this._compareModule.isCadOverlayAllowed()&&this._initCadOverlayOptions(),this._compareModule.canSaveCadOverlay()?(this._initCadOverlayOptions(),this._cadOverlaySaveToEmpty&&(this._cadOverlaySaveToEmpty.show(),
this._compareModule.isCadOverlayModified()?this._cadOverlaySaveToEmpty.setEnabled(!0):this._cadOverlaySaveToEmpty.setEnabled(!1))):this._cadOverlaySaveToEmpty&&this._cadOverlaySaveToEmpty.hide());this._updateResetLinkedComparePagesBtn();this._fireResized()};l.prototype._updateRotateBtn=function(){var a=this._compareModel.getReferenceRotation();a===k.referenceRotation.NOTROTATED?this._rotateReference.setIcon("icon-WCR_Orientation-Rotate1"):a===k.referenceRotation.ROTATED90?this._rotateReference.setIcon("icon-WCR_Orientation-Rotate2"):
a===k.referenceRotation.ROTATED180?this._rotateReference.setIcon("icon-WCR_Orientation-Rotate3"):a===k.referenceRotation.ROTATED270&&this._rotateReference.setIcon("icon-WCR_Orientation-Rotate4")};l.prototype._updateFlipBtn=function(){this._compareModel.isReferenceFlipped()?(this._flipReference.setIcon("icon-WCR_Orientation-MirrorReverse"),this._flipReference.setTooltip(this.f.t("MirrorReferenceTT2"))):(this._flipReference.setIcon("icon-WCR_Orientation-Mirror"),this._flipReference.setTooltip(this.f.t("MirrorReferenceTT")))};
l.prototype._updateNegateBtn=function(){this._compareModel.isReferenceNegated()?(this._negateReference.setIcon("icon-WCR_InvertReverse"),this._negateReference.setTooltip(this.f.t("ToolInvertReferenceTT2"))):(this._negateReference.setIcon("icon-WCR_Invert"),this._negateReference.setTooltip(this.f.t("ToolInvertReferenceTT")))};l.prototype._updateResetLinkedComparePagesBtn=function(){var a=this.f.getActivePage().getDocumentVersion().isMultiPage();this._resetLinkedComparePagesButton.element.toggle(a);
a&&this._resetLinkedComparePagesButton.setEnabled(m.some(this.f.getActivePage().getDocumentVersion().getAllPages(),function(a){return a.hasLinkedComparePage()}))};l.prototype.toggleDifferenceDocPageSelector=function(a){a?this._diffDocPageElement.hide():this._diffDocPageElement.show()};l.prototype._updateCadOverlayButtons=function(){var a=this._compareModel.getCadOverlayRotation();a===k.referenceRotation.NOTROTATED?this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate1"):a===k.referenceRotation.ROTATED90?
this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate2"):a===k.referenceRotation.ROTATED180?this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate3"):a===k.referenceRotation.ROTATED270&&this._cadOverlayRotate.setIcon("icon-WCR_Orientation-Rotate4");this._compareModel.isCadOverlayFlipped()?(this._cadOverlayFlip.setIcon("icon-WCR_Orientation-MirrorReverse"),this._cadOverlayFlip.setTooltip(this.f.t("MirrorCadOverlayTT2"))):(this._cadOverlayFlip.setIcon("icon-WCR_Orientation-Mirror"),this._cadOverlayFlip.setTooltip(this.f.t("MirrorCadOverlayTT")))};
return l});
define("web-viewer/compare/CompareShowReaderSpreadMode","underscore web-viewer/compare/CompareMode web-viewer/compare/CompareConstants web-viewer/viewport/ViewportConstants web-viewer/pagelist/PagelistConstants web-viewer/utils/ListenerUtil web-viewer/utils/ShapeUtils".split(" "),function(c,f,e,g,d,b){c=function(a,d){f.call(this,a,e.mode.READERSPREAD,d,!1,"","current");b.mixin(this,a);this.diffPage=null;this.rs=e.pagelistSide.RIGHTPAGE};c.prototype=Object.create(f.prototype);c.prototype.constructor=c;
c.prototype.toggle=function(a){f.prototype.toggle.call(this,a);this.f.getDocumentController().willNeedParameterUpdate("READER_SPREAD");if(a){a=void 0!==this.f.getDocumentController().getDifferencePage();this.f.getDocumentController().resetDifferencePage();this._compareModel.setDiffMode(e.diffMode.READERSPREAD);var b=this.f.getDocumentController().getActivePage();b.setReaderSpread(!0);var d=this._calculateReferencePageNumber(b);this.diffPage=b.getDocumentVersion().getPage(d);void 0!==this.diffPage&&
(this.diffPage.resetParameters(),b.resetParameters(),this.f.getDocumentController().changeDifferencePage(this.diffPage));this.rs===e.pagelistSide.RIGHTPAGE?(b.set("isRightPage",!0),void 0===this.diffPage&&a&&b.resetParameters()):b.set("isRightPage",!1);this._registerListener("intercept.activePageChange",this._whenActivePageChanges,this,this.f)}else b=this.f.getDocumentController().getActivePage(),b.reset("isRightPage"),b.setReaderSpread(!1),this.diffPage=null,this.f.getDocumentController().resetDifferencePage(),
this._compareModel.setDiffMode(e.diffMode.UNDEFINED),this._unregisterAllListeners();this.f.getDocumentController().readyForParameterUpdate("READER_SPREAD")};c.prototype.interceptFragmentURL=function(a){a.params.rs=this.rs;a.params.daligntrim=1;a.params.dmode=e.diffMode.SHOWBOTHONTOP};c.prototype._whenActivePageChanges=function(a){if(this.isEnabled()){void 0!==a.oldActivePage&&(a.oldActivePage.setReaderSpread(!1),a.oldActivePage.reset("isRightPage"));a.newActivePage.setReaderSpread(!0);var b=this._calculateReferencePageNumber(a.newActivePage);
this.diffPage=a.newActivePage.getDocumentVersion().getPage(b);void 0===this.diffPage?a.diffPage=void 0:(this.diffPage.resetParameters(),a.diffPage=this.diffPage);this.rs===e.pagelistSide.RIGHTPAGE?(void 0!==this.diffPage&&a.newActivePage.resetParameters(),a.newActivePage.set("isRightPage",!0)):a.newActivePage.set("isRightPage",!1)}};c.prototype._calculateReferencePageNumber=function(a){var b=a.getPagenum(),a=a.getDocument().get("binding");0===b%2?(b+=1,void 0===a||a===d.binding.LEFT?this.rs=e.pagelistSide.LEFTPAGE:
a===d.binding.RIGHT&&(this.rs=e.pagelistSide.RIGHTPAGE)):(b-=1,void 0===a||a===d.binding.LEFT?this.rs=e.pagelistSide.RIGHTPAGE:a===d.binding.RIGHT&&(this.rs=e.pagelistSide.LEFTPAGE));return b};return c});
define("tpl!web-viewer/compare/ComparePagelistPopup",function(){return function(c){var f,e;e="";c.showPage&&(e+='\r\n\t<div class="page">\r\n\t\t'+(null==(f=c.i18n("PagelistComparePage"))?"":_.escape(f))+" "+(null==(f=c.page)?"":_.escape(f))+"\r\n\t</div>\r\n");e+='\r\n<div class="range">\r\n\t<div>'+(null==(f=c.i18n("PagelistCompareRange"))?"":_.escape(f))+'</div>\r\n\t<ul>\r\n\t\t<li><input type="radio" name="range" value="0" ';0===c.range&&(e+=" checked ");e+=" /> "+(null==(f=c.i18n("PagelistCompareCurrent"))?
"":_.escape(f))+'</li>\r\n\t\t<li><input type="radio" name="range" value="1" ';1===c.range&&(e+=" checked ");e+=" /> "+(null==(f=c.i18n("PagelistCompareFollowing"))?"":_.escape(f))+'</li>\r\n\t\t<li><input type="radio" name="range" value="2" ';2===c.range&&(e+=" checked ");return e+=" /> "+(null==(f=c.i18n("PagelistCompareAll"))?"":_.escape(f))+"</li>\r\n\t</ul>\r\n</div>"}});
define("web-viewer/compare/ComparePagelistPopup","web-viewer/core/PrivateChannel web-viewer/layout/component/ModalPopup Template tpl!web-viewer/compare/ComparePagelistPopup web-viewer/compare/CompareConstants jquery underscore".split(" "),function(c,f,e,g,d,b){var a=function(a,j){f.call(this,a,j,a.getContext());c.installTo(this,a,["comparePagelist"]);this._defaultPagelistCompareRange=d.pagelistCompareRange.CURRENT;this._pagelistComparePage=this._currentPagelistCompareRange=null;this.t=new e(this.f.i18n,
g);this.t.setContext(this._popupContent);this.t.bind("change","[name=range]",function(a){this._currentPagelistCompareRange=parseInt(a.value,10)},this);this.f.i18n.loadBundle("viewer",function(){this.setHeader(b("<span/>").addClass("popupTitle").html(a.i18n.t("MultipageCompare")));this.setOkBtnText(a.i18n.t("OkButton"))},this);this.element.addClass("comparePagelistPopup")};a.prototype=Object.create(f.prototype);a.prototype.constructor=a;a.prototype.render=function(){this.t.d.showPage=this._pagelistComparePage&&
this._pagelistComparePage.getDocumentVersion().isMultiPage();this.t.d.page=this._pagelistComparePage.getPagenum()||"";this.t.d.range=this._currentPagelistCompareRange;this.t.render()};a.prototype._reset=function(){this._currentPagelistCompareRange=d.pagelistCompareRange.CURRENT};a.prototype.show=function(){this._reset();this.render();f.prototype.show.call(this);this.recalculateSize(300)};a.prototype.setComparePage=function(a){this._pagelistComparePage=a};return a});
define("tpl!web-viewer/layout/component/DocumentSelector",function(){return function(c){var f,e;e=""+('<div class="documentItem"> \r\n\t<img class="thumbnail pull-left" src="'+(null==(f=c.thumbnailUrl)?"":f)+'" />\r\n\t<ul class="info">\t\t\r\n\t\t<li class="documentName">\r\n\t\t\t'+(null==(f=c.docInfo.documentName)?"":_.escape(f))+"\r\n\t\t</li>\r\n\t\t\r\n\t\t");void 0!==c.docInfo.project&&(e+='\r\n\t\t\t<li class="projectName">\r\n\t\t\t\t<span class="docSelectorKey">'+(null==(f=c.i18n("WCProject"))?
"":_.escape(f))+"</span> "+(null==(f=c.docInfo.project)?"":_.escape(f))+"\r\n\t\t\t</li>\r\n\t\t");e+="\t\r\n\t\t\r\n\t\t";c.docInfo.isGroup?(e+="\r\n\t\t\t",void 0!==c.docInfo.versionNumber&&(e+='\r\n\t\t\t\t<li class="versionNumber">\r\n\t\t\t\t\t<span class="docSelectorKey">'+(null==(f=c.i18n("WCVersion"))?"":_.escape(f))+" </span>"+(null==(f=c.docInfo.versionId)?"":_.escape(f))+" \r\n\t\t\t\t</li>\r\n\t\t\t"),e+='\r\n\t\t\t<li class="showAllPages"  ',c.docInfo.isOpen&&(e+='style="display: none;"'),
e+=">"+(null==(f=c.i18n("ShowAllPages"))?"":_.escape(f))+' </li>\r\n\t\t\t<li class="hideAllPages"  ',c.docInfo.isOpen||(e+='style="display: none;"'),e+=">"+(null==(f=c.i18n("HideAllPages"))?"":_.escape(f))+" </li>\r\n\t\t"):(e+="\t\t\t\t\r\n\t\t\t",void 0!==c.docInfo.pageNumber&&!c.docInfo.referencedFrom&&(e+='\r\n\t\t\t\t<li class="docSelectorPageInfo">\t\r\n\t\t\t\t\t<span class="pageNumber">'+(null==(f=c.i18n("PageUC"))?"":_.escape(f))+"&nbsp;"+(null==(f=c.docInfo.pageNumber)?"":_.escape(f))+
"</span>\r\n\t\t\t\t\t\t",null!==c.docInfo.pageCount&&(e+="\r\n\t\t\t\t\t\t\t"+(null==(f=c.i18n("OfKeyWord"))?"":_.escape(f))+" "+(null==(f=c.docInfo.pageCount)?"":_.escape(f))+"\r\n\t\t\t\t\t\t"),e+="\r\n\t\t\t\t</li>\r\n\t\t\t"),e+="\r\n\t\t\r\n\t\t\t",void 0!==c.docInfo.versionNumber&&(e+='\r\n\t\t\t\t<li class="versionNumber">\r\n\t\t\t\t\t<span class="docSelectorKey">'+(null==(f=c.i18n("WCVersion"))?"":_.escape(f))+"</span> "+(null==(f=c.docInfo.versionNumber)?"":_.escape(f))+"\r\n\t\t\t\t</li>\r\n\t\t\t"),
e+="\r\n\t\t");e+="\r\n\t\t\r\n\t\t\t ";c.docInfo.referencedFrom&&(e+=' \r\n\t\t\t\t<li class="cadReferencedFrom">\r\n                \t<i class="icon icon-WCR_Link"></i> '+(null==(f=c.docInfo.referencedFrom)?"":_.escape(f))+"\r\n\t\t\t\t</li>\r\n            ");return e+"\r\n\t</ul>\r\n</div>"}});
define("web-viewer/layout/component/DocumentDropdownMenu",["web-viewer/layout/component/DropdownMenu","Template","tpl!web-viewer/layout/component/DocumentSelector","jquery","underscore"],function(c,f,e,g,d){var b=function(a,b,j,k,i,m,l,q){c.call(this,a,"bottom","documentSelector",300);this._onDocChange=b;this.element=g("<div/>").addClass("selectedDocument");this.attachTo(this.element);this._isMobile=l;this._selectedDocumentElement=g("<div>");this._isMobile&&this.element.append('<i class="icon-WCR_Down"></i>');
this.element.append(this._selectedDocumentElement);this._isMobile||this.element.append(g("<div>").addClass("docSelectorCaret").append(g("<span/>").addClass("caret")));this._selectedDocumentPage=null;this._enabledDocuments=0;this._elementGrouping={};this.dividerId=this._enabledDocType=this._activeGroup=null;this.t=new f(this.f.i18n,e);this.unveil=d.debounce(d.partial(this._unveil,!0),100);this.t.d.compact=q;this._deselectText=i||"";this._nothingSelectedText=k||"";this._deselectCallback=m;""!==this._deselectText&&
""!==this._nothingSelectedText&&(a=g("<div />").addClass("deselectElement").html(this._nothingSelectedText),this.deselectElement={name:"deselectAction",content:a,icon:void 0,action:d.bind(function(){var a=this.getSelectedDocumentPageId();this.deselectCurrentPage(!0);this._deselectCallback(a)},this),enabled:!0},this.addAction(this.deselectElement),this.disableDocumentPage(this.deselectElement.name),this._selectedDocumentPage=this.deselectElement,this._selectedDocumentElement.html(this._selectedDocumentPage.content.clone()),
this._enabledDocuments++);""!==j&&(a=g("<div />").addClass("deselectElement").html(j),this.emptyListElement={name:"emptyList",content:a,icon:void 0,action:function(){},enabled:!0},this.addAction(this.emptyListElement))};b.prototype=Object.create(c.prototype);b.prototype.constructor=b;b.prototype._initialize=function(){c.prototype._initialize.call(this);this._isMobile?this.popover.setPlacementOptions(["bottomLeft"]):this.popover.setPlacementOptions(["bottom","top"])};b.prototype.addDocumentPage=function(a,
b){if(void 0!==b&&void 0!==this._elementGrouping[b]){if(0===this._elementGrouping[b].length){this.t.d.docInfo=d.clone(a);this.t.d.docInfo.isGroup=!0;this.t.d.docInfo.isOpen=this.items[b].isOpen;this.t.d.thumbnailUrl=a.thumbnailUrl;var c=this.t.getRenderedHtml();this.setActionText(b,g(c));null!==this._enabledDocType&&a.docType!==this._enabledDocType&&this.disableDocumentPage(b)}this._elementGrouping[b].push(a.pageId)}void 0===this.items[a.pageId]&&(this.t.d.docInfo=a,this.t.d.thumbnailUrl="",c=this.t.getRenderedHtml(),
c={name:a.pageId,content:c,icon:void 0,action:d.bind(function(a){this._itemClicked(a)},this,a.pageId),enabled:!0,docType:a.docType,isVisible:void 0===b||this._activeGroup===b&&(null===this._enabledDocType||a.docType===this._enabledDocType),group:b,thumb:a.thumbnailUrl,isUnveiled:!1,after:a.prepend&&this.deselectElement?this.deselectElement.name:void 0},this.addAction(c),c.isVisible&&this._enabledDocuments++,void 0!==this.emptyListElement&&0<this._enabledDocuments&&(this.hideElement(this.emptyListElement.name),
this.showElement(this.dividerId)))};b.prototype.removeDocumentPage=function(a){this.removeAction(a);delete this.items[a]};b.prototype.addDivider=function(){null===this.dividerId&&(this.dividerId=c.prototype.addDivider.call(this),void 0!==this.emptyListElement&&this.emptyListElement.isVisible&&this.hideElement(this.dividerId))};b.prototype.addDocumentGroup=function(a,b,c){this._elementGrouping[a]=[];var e=g("<div />");this.groupElement={name:a,content:e,icon:void 0,isOpen:!1,action:d.bind(function(){void 0!==
b&&b();this.isGroupOpen(a)?this.hideElementGroup(a):this.showElementGroup(a);this.show();void 0!==c&&c()},this),enabled:!0,doNotHideOnClick:!0,isUnveiled:!0,isGroup:!0};this._enabledDocuments++;this.addGroup(this.groupElement)};b.prototype.setSelectedDocumentPage=function(a){this._selectedDocumentPage!==this.deselectElement&&null!==this._selectedDocumentPage?this.enableDocumentPage(this._selectedDocumentPage.name):null!==this._selectedDocumentPage&&(this.deselectElement.content.html(this._deselectText),
this.enableDocumentPage(this.deselectElement.name));this._selectedDocumentPage=this.items[a];void 0!==this._selectedDocumentPage?(this._selectedDocumentElement.html(this._selectedDocumentPage.content),this._selectedDocumentElement.find(".thumbnail").attr("src",this._selectedDocumentPage.thumb)):this._selectedDocumentPage=null;this.disableDocumentPage(a)};b.prototype.setTempSelectedDocumentPage=function(a){this.t.d.docInfo=a;this.t.d.thumbnailUrl=a.thumbnailUrl;a=this.t.getRenderedHtml();this._selectedDocumentPage!==
this.deselectElement&&null!==this._selectedDocumentPage?this.enableDocumentPage(this._selectedDocumentPage.name):null!==this._selectedDocumentPage&&(this.deselectElement.content.html(this._deselectText),this.enableDocumentPage(this.deselectElement.name));this._selectedDocumentElement.html(a);this._selectedDocumentPage=null};b.prototype._itemClicked=function(a){this.hide();this.setSelectedDocumentPage(a);this._onDocChange(a)};b.prototype.disableDocumentPage=function(a){this.isElementVisible(a)&&(this.hideElement(a),
this._enabledDocuments--,void 0!==this.emptyListElement&&0>=this._enabledDocuments&&(this.showElement(this.emptyListElement.name),this.hideElement(this.dividerId)))};b.prototype.enableDocumentPage=function(a){if(void 0!==this.isElementVisible(a)&&!this.isElementVisible(a)&&(void 0===this.items[a].group||this.isGroupOpen(this.items[a].group)))this.showElement(a),this._enabledDocuments++,void 0!==this.emptyListElement&&0<this._enabledDocuments&&(this.hideElement(this.emptyListElement.name),this.showElement(this.dividerId))};
b.prototype.enableOnlyPagesWithDocType=function(a){d.each(this.items,d.bind(function(b){void 0!==b.docType&&b.docType===a&&void 0===b.group?this.enableDocumentPage(b.name):void 0!==b.docType&&void 0===b.group&&this.disableDocumentPage(b.name)},this));this._enabledDocType=a;d.each(this._elementGrouping,d.bind(function(b,d){var c=this.items[b[0]];void 0!==c&&c.docType!==a?(this.hideElementGroup(d),this.disableDocumentPage(d)):void 0!==c&&(!this.items[d].isVisible&&!c.isVisible)&&this.hideElementGroup(d)},
this));null!==this._selectedDocumentPage&&a!==this._selectedDocumentPage.docType?this.deselectCurrentPage(!1):null!==this._selectedDocumentPage&&this.disableDocumentPage(this._selectedDocumentPage.name);null!==this._selectedDocumentPage&&(void 0!==this.deselectElement&&this.deselectElement!==this._selectedDocumentPage)&&this.enableDocumentPage(this.deselectElement.name)};b.prototype.getSelectedDocumentPageId=function(){if(null!==this._selectedDocumentPage&&this._selectedDocumentPage!==this.deselectElement)return this._selectedDocumentPage.name};
b.prototype.deselectCurrentPage=function(a){a&&null!==this._selectedDocumentPage&&this.enableDocumentPage(this._selectedDocumentPage.name);""!==this._deselectText&&""!==this._nothingSelectedText?(this._selectedDocumentPage=this.deselectElement,this.disableDocumentPage(this.deselectElement.name),this.deselectElement.content.html(this._nothingSelectedText),this._selectedDocumentElement.html(this._selectedDocumentPage.content.clone())):(this._selectedDocumentElement.html(""),this._selectedDocumentPage=
null)};b.prototype.hideElementGroup=function(a){if(void 0!==a){void 0!==this._listElements[a]?(this._listElements[a].first().find(".showAllPages").show(),this._listElements[a].first().find(".hideAllPages").hide()):(this.items[a].content.find(".showAllPages").show(),this.items[a].content.find(".hideAllPages").hide());this.items[a].isOpen=!1;d.each(this._elementGrouping[a],d.bind(function(a){this.disableDocumentPage(a)},this));var b=this._elementGrouping[a][0];null!==this._enabledDocType&&void 0!==
b&&this._enabledDocType!==this.items[b].docType?this.disableDocumentPage(a):this.enableDocumentPage(a)}};b.prototype.showElementGroup=function(a){void 0!==a&&(void 0!==this._listElements[a]?(this._listElements[a].first().find(".showAllPages").hide(),this._listElements[a].first().find(".hideAllPages").show()):(this.items[a].content.find(".showAllPages").hide(),this.items[a].content.find(".hideAllPages").show()),this.items[a].isOpen=!0,this._activeGroup=a,d.each(this._elementGrouping[a],d.bind(function(a){this.enableDocumentPage(a)},
this)));this._unveil()};b.prototype.hideAllGroups=function(){d.each(this._elementGrouping,d.bind(function(a,b){this.hideElementGroup(b)},this))};b.prototype.hasDocumentPage=function(a){return void 0!==this.items[a]};b.prototype.hasDocumentGroup=function(a){return void 0!==this.items[a]};b.prototype.hasGroups=function(){return!d.isEmpty(this._elementGrouping)};b.prototype.isGroupOpen=function(a){return this.items[a].isOpen};b.prototype.show=function(){c.prototype.show.call(this);this._unveil();this.scrollListenerRegistered||
(this.popover.getContentDiv().scroll(d.bind(this.unveil,this)),this.scrollListenerRegistered=!0)};b.prototype._unveil=function(a){if(void 0===this.indexList||0===this.indexList.length||!a){var b=[];d.each(this._listElements,d.bind(function(a,d){var c=this.items[d];if(c.isVisible)if("group"===c.type)b[a.index()]=[],b[a.index()][0]=c;else if(void 0!==c.group){var e=a.parent().index();b[e][a.index()]=c}else b[a.index()]=c},this));this.indexList=d.without(d.flatten(b),void 0,null)}if(0<this.indexList.length){var c=
0;void 0!==this.popover&&(c=this.popover.getContentDiv().scrollTop());var a=Math.ceil(this.menu.outerHeight(!0)/this.indexList.length),c=Math.floor(c/a),e=this.popover.getContentDiv().innerHeight(),a=c+Math.ceil(e/a);for(a>this.indexList.length-1&&(a=this.indexList.length-1);c<=a;c++)if(e=this.indexList[c]){var f=this._listElements[e.name];!e.isUnveiled&&void 0!==f&&(f.find(".thumbnail").attr("src",e.thumb),e.isUnveiled=!0)}}};b.prototype.unveilThumbnails=function(){this._unveil()};b.prototype._getOrderedItemList=
function(){return this.menu?d.map(this.menu.find("li"),function(a){return this.items[a.className]},this):this.itemStack};b.prototype.getFirstSelectablePageId=function(){for(var a=this._getOrderedItemList(),b=1,d=a[b];b<a.length&&d&&d.isGroup;)d=a[++b];return b<a.length&&d?d.name:null};b.prototype.getLastSelectablePageId=function(){for(var a=this._getOrderedItemList(),b=d.last(a),c=d.indexOf(a,b);0<c&&b&&b.isGroup;)b=a[--c];return b&&0<c?b.name:null};b.prototype.getNextItemId=function(){for(var a=
this._getOrderedItemList(),b=this.getSelectedDocumentPageId(),b=d.indexOf(a,this.items[b]),c=a[++b];b<a.length&&c&&c.isGroup;)c=a[++b];return c&&b<a.length?c.name:null};b.prototype.getPreviousItemId=function(){for(var a=this._getOrderedItemList(),b=this.getSelectedDocumentPageId(),b=d.indexOf(a,this.items[b]),c=a[--b];0<b&&c&&c.isGroup;)c=a[--b];return c&&0<b?c.name:null};return b});
define("web-viewer/layout/component/DocumentSelection",["web-viewer/core/PrivateChannel","web-viewer/layout/component/DocumentDropdownMenu","web-viewer/utils/ListenerUtil","web-viewer/data/DataConstants","underscore"],function(c,f,e,g,d){var b=function(a,b,j,k,g){c.installTo(this,a,"documentSelection");this.f=a;e.mixin(this,a);this._callBacksAreRegistered=!1;this._onDocChangeCallback=j;this.compareModule=b;this.cadOverLaySelector=this.differenceDocPageSelector=this.activeDocPageSelector=null;this.f.i18n.loadBundle("viewer",
d.bind(function(){this.activeDocPageSelector=new f(a,d.bind(this.changeActivePage,this),this.f.t("EmptyDocumentList"),void 0,void 0,void 0,k,g);this.compareModule&&(this.differenceDocPageSelector=new f(a,d.bind(this.changeDifferencePage,this),this.f.t("EmptyDocumentList"),this.f.t("EmptyDifferenceDocSelector"),this.f.t("DocumentListCompareTurnOff"),d.bind(function(a){this.activeDocPageSelector.enableDocumentPage(a);this.compareModule.activateModeByName()},this),k,g),this.cadOverLaySelector=new f(a,
d.bind(this.changeCadOverlay,this),this.f.t("EmptyDocumentList"),this.f.t("EmptyCadOverlayDocSelector"),this.f.t("DocumentListCadOverlayTurnOff"),d.bind(function(){this.f.getDocumentController().changeCadOverlay()},this),k,g));this.f.getDocumentController().whenDocumentsLoadedOrChange(this._whenDocumentsLoaded,this)},this))};b.prototype.getActiveDocumentSelector=function(){return this.activeDocPageSelector};b.prototype.getDifferenceDocumentSelector=function(){return this.differenceDocPageSelector};
b.prototype.getCadOverlayDocumentSelector=function(){return this.cadOverLaySelector};b.prototype.changeActivePage=function(a){var b=this.f.getDocumentController().getDocumentPage(a),c=this.f.getDocumentController().getActivePage();this._emit("changeActivePage",b,d.bind(function(d){if(d&&this.differenceDocPageSelector){if(void 0!==c){var e=c.getUniqueID();this.differenceDocPageSelector.enableDocumentPage(e)}c.getDocument().getDocumentType()!==b.getDocument().getDocumentType()&&(this.activeDocPageSelector.enableDocumentPage(this.differenceDocPageSelector.getSelectedDocumentPageId()),
this.compareModule.activateModeByName());e=b.getDocument().getDocumentType();this.differenceDocPageSelector.enableOnlyPagesWithDocType(e);this.differenceDocPageSelector.disableDocumentPage(a)}d||this.activeDocPageSelector.setSelectedDocumentPage(this.f.getActivePage().getUniqueID())},this))};b.prototype.changeDifferencePage=function(a){var b=this.f.getDocumentController().getDifferencePage();void 0!==b&&(b=b.getUniqueID(),this.activeDocPageSelector.enableDocumentPage(b));this.activeDocPageSelector.disableDocumentPage(a);
a=this.f.getDocumentController().getDocumentPage(a);this._emit("changeReferencePage",a)};b.prototype.changeCadOverlay=function(a){a=this.f.getDocumentController().getDocumentPage(a);this._emit("changeCadOverlay",a)};b.prototype._whenDocumentsLoaded=function(a){d.each(a,d.bind(function(a){d.each(a.getAllDocumentVersions(),d.bind(function(a){if(a&&a.getDocumentVersionID()){if(a.isMultiPage()){var b=a.getDocument().getIID()+"_"+a.getVersionId()+"_Group";this.activeDocPageSelector.hasDocumentGroup(b)||
this.activeDocPageSelector.addDocumentGroup(b,d.bind(this._loadPagesIfNeeded,this,a),d.bind(function(){this.activeDocPageSelector.disableDocumentPage(this.activeDocPageSelector.getSelectedDocumentPageId());this.differenceDocPageSelector&&this.activeDocPageSelector.disableDocumentPage(this.differenceDocPageSelector.getSelectedDocumentPageId())},this));this.differenceDocPageSelector&&!this.differenceDocPageSelector.hasDocumentGroup(b)&&this.differenceDocPageSelector.addDocumentGroup(b,d.bind(this._loadPagesIfNeeded,
this,a),d.bind(function(){this.differenceDocPageSelector.disableDocumentPage(this.differenceDocPageSelector.getSelectedDocumentPageId());this.differenceDocPageSelector.disableDocumentPage(this.activeDocPageSelector.getSelectedDocumentPageId())},this))}for(var c=a.getPageCount(),e=1;e<=c;e++){var f=a.getPage(e);if(void 0!==f){var h=f.getInformationForDocumentSelector();a.isMultiPage()&&(b=a.getDocument().getIID()+"_"+a.getVersionId()+"_Group");this.activeDocPageSelector.hasDocumentPage(h.pageId)||
this.activeDocPageSelector.addDocumentPage(h,b);this.differenceDocPageSelector&&(!this.differenceDocPageSelector.hasDocumentPage(h.pageId)&&!f.isBlankPage())&&this.differenceDocPageSelector.addDocumentPage(h,b);this.cadOverLaySelector&&(f.hasCad()?this.cadOverLaySelector.addDocumentPage(h):f.hasLinkedPage()&&(h=f.getLinkedPage().getInformationForDocumentSelector(),h.referencedFrom=f.getDocument().get("docname"),this.cadOverLaySelector.addDocumentPage(h)))}}}},this))},this));this.activeDocPageSelector.unveilThumbnails();
this.differenceDocPageSelector&&this.differenceDocPageSelector.unveilThumbnails();this._registerCallbacksIfNeeded()};b.prototype._registerCallbacksIfNeeded=function(){this._callBacksAreRegistered||(this.f.getDocumentController().whenActivePageChangedAndParametersAvailable(function(a,b){if(void 0===this.activeDocPageSelector.getSelectedDocumentPageId()||b.getUniqueID()!==this.activeDocPageSelector.getSelectedDocumentPageId()){if(b.getDocumentVersion().isMultiPage()){this.activeDocPageSelector.hideAllGroups();
var c=b.getDocument().getIID()+"_"+b.getDocumentVersion().getVersionId()+"_Group";this.activeDocPageSelector.showElementGroup(c)}this.activeDocPageSelector.setSelectedDocumentPage(b.getUniqueID());this.differenceDocPageSelector&&(c=b.getDocument().getDocumentType(),this.differenceDocPageSelector.enableOnlyPagesWithDocType(c),this.differenceDocPageSelector.disableDocumentPage(b.getUniqueID()),this.differenceDocPageSelector.hideAllGroups(),b.getDocumentVersion().isPageList()&&d.each(b.getDocument().getAllDocumentVersions(),
function(a){a&&(a=a.getPage(b.getPagenum()))&&this.differenceDocPageSelector.enableDocumentPage(a.getUniqueID())},this),void 0===a&&b.getDocumentVersion().isPageList()&&this.updateDocumentSelectorsForPageList(void 0,b))}this._onDocChangeCallback&&this._onDocChangeCallback()},this),this.differenceDocPageSelector&&this.f.getDocumentController().whenDifferencePageChangedAndParametersAvailable(function(a,b){var c=this.compareModule.isReaderSpreadActive(),d=this.compareModule.getActiveMode();if(c&&void 0!==
this.differenceDocPageSelector.getSelectedDocumentPageId()&&d.isEnabled())this.differenceDocPageSelector.deselectCurrentPage(!0);else if(null===d||!d.isEnabled()||!c)if(void 0===b)this.differenceDocPageSelector.deselectCurrentPage(!0),a&&this.activeDocPageSelector.enableDocumentPage(a.getUniqueID());else if(b.isBlankPage())void 0!==a&&this.activeDocPageSelector.enableDocumentPage(a.getUniqueID()),this.differenceDocPageSelector.setTempSelectedDocumentPage(b.getInformationForDocumentSelector()),this.f.emit("error.WARNING",
this.f.i18n.t("ComparingWithBlankPage"));else if(void 0===this.activeDocPageSelector.getSelectedDocumentPageId()||b.getUniqueID()!==this.differenceDocPageSelector.getSelectedDocumentPageId())this.differenceDocPageSelector.setSelectedDocumentPage(b.getUniqueID()),this.activeDocPageSelector.disableDocumentPage(b.getUniqueID()),a&&this.activeDocPageSelector.enableDocumentPage(a.getUniqueID());this._onDocChangeCallback&&this._onDocChangeCallback()},this),this.cadOverLaySelector&&this.f.getDocumentController().whenCadOverlayChangedAndParametersAvailable(function(a,
b){this.cadOverLaySelector.deselectCurrentPage(!0);b&&this.cadOverLaySelector.setSelectedDocumentPage(b.getUniqueID());this._onDocChangeCallback&&this._onDocChangeCallback()},this),this._callBacksAreRegistered=!0)};b.prototype.setDifferenceSelectorPage=function(a){this.differenceDocPageSelector&&(void 0===a?this.differenceDocPageSelector.deselectCurrentPage(!0):this.compareModule.isReaderSpreadActive()?(this.differenceDocPageSelector.deselectCurrentPage(!0),this.activeDocPageSelector.enableDocumentPage(a.getUniqueID())):
(this.differenceDocPageSelector.setSelectedDocumentPage(a.getUniqueID()),this.activeDocPageSelector.disableDocumentPage(a.getUniqueID())))};b.prototype.updateDocumentSelectorsForPageList=function(a,b){if(void 0!==a)for(var c=a.getPagenum(),e=a.getDocument(),f=1;f<a.getDocumentVersion().getVersionId();f++){var m=e.getDocumentVersion(f);void 0!==m&&m.hasPage(c)&&(m=m.getPage(c).getUniqueID(),this.differenceDocPageSelector.disableDocumentPage(m))}var l=!1;this.compareModule&&(l=null!==this.compareModule.getActiveMode()&&
!this.compareModule.isReaderSpreadActive()&&!b.getLinkedComparePage());b.getDocument().loadVersionsForDocumentPage(b,d.bind(function(a){d.each(a,d.bind(function(a){a&&(this.differenceDocPageSelector.hasDocumentPage(a.getUniqueID())?this.differenceDocPageSelector.enableDocumentPage(a.getUniqueID()):(a=a.getInformationForDocumentSelector(),a.prepend=!0,a.docType=g.documentPageType.PAGELIST,a.pageCount=null,this.differenceDocPageSelector.addDocumentPage(a)))},this));l&&(this.differenceDocPageSelector.setSelectedDocumentPage(d.last(a).getUniqueID()),
this.changeDifferencePage(d.last(a).getUniqueID()))},this))};b.prototype._loadPagesIfNeeded=function(a){a.isMultiPage()&&1>=a.getPageCount()&&this.f.getDocumentController().loadDocumentPages(a.getDocument().getIID(),a.getVersionId())};b.prototype.setNewlyCreatedCadOverlay=function(a,b){this.cadOverLaySelector.removeDocumentPage(b);var c=a.getLinkedPage();c&&(c=c.getInformationForDocumentSelector(),c.referencedFrom=a.getDocument().get("docname"),this.cadOverLaySelector.addDocumentPage(c),this.f.getDocumentController().getCadOverlay()&&
this.cadOverLaySelector.setSelectedDocumentPage(c.pageId))};b.prototype.getFirstSelectablePageId=function(){return this.activeDocPageSelector.getFirstSelectablePageId()};b.prototype.getLastSelectablePageId=function(){return this.activeDocPageSelector.getLastSelectablePageId()};b.prototype.getNextSelectablePageId=function(){return this.activeDocPageSelector.getNextItemId()};b.prototype.getPreviousSelectablePageId=function(){return this.activeDocPageSelector.getPreviousItemId()};return b});
define("web-viewer/compare/CompareModule","web-viewer/core/AbstractModule web-viewer/compare/CompareModel web-viewer/compare/CompareShowCurrentMode web-viewer/compare/CompareShowDifferenceMode web-viewer/compare/CompareBlinkingMode web-viewer/compare/CompareDifferenceMode web-viewer/compare/CompareSideBySideMode web-viewer/compare/CompareShowBothOnTopMode web-viewer/compare/alignment/CompareAlignmentWizard web-viewer/compare/CompareToolbarComponent web-viewer/compare/CompareTouchToolbarComponent web-viewer/compare/CompareWidget web-viewer/compare/CompareConstants web-viewer/compare/CompareShowReaderSpreadMode web-viewer/compare/ComparePagelistPopup web-viewer/layout/component/DocumentSelection web-viewer/layout/component/ModalPopup web-viewer/layout/LayoutConstants web-viewer/utils/ListenerUtil utils/XMLUtils web-viewer/utils/ShapeUtils web-viewer/utils/ViewerUtils Mousetrap underscore".split(" "),
function(c,f,e,g,d,b,a,h,j,k,i,m,l,q,p,u,r,w,z,A,v,s,t,o){var n=function(x,B){c.call(this,x,B,"compare");z.mixin(this,x);var y=this.f.getOption("PREFERENCES_DIFFMODE_COMPARE");this._compareModel=new f(this.f,this.getPrivateChannelNameAsArray(),y);this._documentSelection=new u(this.f,this,o.bind(function(){this._compareWidget&&this._compareWidget.updateCompareWidget()},this),this.f.isMobile());this._compareModel.registerMode(new e(this.f,this._compareModel));this._compareModel.registerMode(new g(this.f,
this._compareModel));this._compareModel.registerMode(new d(this.f,this._compareModel));this._compareModel.registerMode(new q(this.f,this._compareModel));this._differenceMode=new b(this.f,this._compareModel);this._compareModel.registerMode(this._differenceMode);this._sideBySideMode=new a(this.f,this._compareModel,this._differenceMode);this._compareModel.registerMode(this._sideBySideMode);this._compareModel.registerMode(new h(this.f,this._compareModel));this._compareAlignmentWizard=this._comparePagelistPopup=
this._compareWidget=this._toolbarComponent=null;this._publishToolbarComponentAndWidgetIfNeeded();this._docListener=this._registerListener("doc.loaded",this._publishToolbarComponentAndWidgetIfNeeded,this);this._registerListener("intercept.fragmentURL",this._interceptFragmentURL,this);this._registerListener("intercept.parameters",this._interceptFragmentURL,this);this._settingDefault=!1;"1"===this.f.getProperty("compare")&&this._compareModel.isRealCompareMode(y)?(this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE")),
this._settingDefault=!0):this._compareModel.setDiffMode(l.diffMode.UNDEFINED);this._registerListener("changed.mode",function(a,b){var c=this.getCurrentDiffMode();null===b&&void 0!==this.f.getDocumentController().getDifferencePage()&&this.changeReferenceOffset(new v.Point(0,0));this._compareModel.isRealCompareMode(c)&&this.f.setOption("PREFERENCES_DIFFMODE_COMPARE",c)},this,this._compareModel);this._registerListener("changed.differenceMode",function(a,b){var c=b;this._compareModel.getActiveMode().getName()===
l.mode.SIDEBYSIDE&&(c=c===l.diffMode.SHOWBOTHCHANGESHIGHLIGHT?l.diffMode.SHOWBOTHSIDEBYSIDEHIGHLIGHT:c===l.diffMode.SHOWBOTHCHANGESONLY?l.diffMode.SHOWBOTHSIDEBYSIDECHANGESONLY:l.diffMode.SHOWBOTHSIDEBYSIDE);this.f.setOption("PREFERENCES_DIFFMODE_COMPARE",c)},this,this._differenceMode);this.f.getDocumentController().whenDifferencePageChanged(function(a,b){!this._settingDefault&&(void 0===a&&b&&!this._compareModel.isReaderSpreadActive())&&this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE"))},
this);this.f.getDocumentController().whenActiveOrDifferencePageChanged(this._whenActiveOrDifferencePageChanged,this);this.f.getDocumentController().whenActiveOrDifferencePageChangedAndParametersAvailableOrChange(this._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange,this);this._registerListener("changeReferencePage",o.bind(function(a){this.f.getActivePage().getDocumentVersion().isMultiPage()?(this._comparePagelistPopup.setComparePage(a),this._comparePagelistPopup.show()):this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE"),
a)},this),this,this._documentSelection);this._registerListener("changeActivePage",o.bind(function(a,b){this._compareModel.isReaderSpreadActive()&&!a.getDocumentVersion().isMultiPage()&&this.activateModeByName();var c=this.f.getDocumentController().changeActivePage(a);b&&b(c)},this),this,this._documentSelection);this._registerListener("changeCadOverlay",o.bind(function(a){this.f.getDocumentController().changeCadOverlay(a)},this),this,this._documentSelection);this._registerListener("intercept.activePageChange",
this._interceptActivePageChange,this);this.f.getDocumentController().whenDifferencePageChanged(function(a,b){var c=this.f.getModule("navigation");c&&c.resetExtraRotation();this._compareModel.isRealCompareMode(this._compareModel.getDiffMode())&&(this._previousDifferencePage=b)},this);this.f.getDocumentController().whenCadOverlayChanged(function(a,b){b&&(this.changeCadOverlayOffset(this._compareModel.getCadOverlayOffset()),this.flipCadOverlay(this._compareModel.isCadOverlayFlipped()),this.setCadOverlayRotation(this._compareModel.getCadOverlayRotation()))},
this);this.f.getDocumentController().whenActivePageChanged(function(a,b){var c=this.f.getModule("navigation");c&&c.resetExtraRotation();this._compareModel.resetCadOverlayOffset();this._compareModel.resetCadOverlayOrientation();if(b&&b.hasLinkedPage()&&(c=b.getLinkedPage())){var d=new v.Point,e=!1,f=0;this.f.getDocumentController().getActivePage().hasLinkedPage()&&this.f.getDocumentController().getActivePage().getLinkedPage()===c&&(d=new v.Point(s.parseFloat(c.get("offsetx")),s.parseFloat(c.get("offsety"))),
e=c.get("overlayIsFlipped"),f=c.get("overlayRotation"));this.changeCadOverlayOffset(d);this.flipCadOverlay(e);this.setCadOverlayRotation(f)}this._3DWidget&&this._3DWidget.setEnabled(!1)},this);this._registerListener("newLinkedCad",function(a,b){if(a!==b){var c=null;a&&(c=a.getUniqueID());this._documentSelection.setNewlyCreatedCadOverlay(this.f.getActivePage(),c)}},this,this.f.getDocumentController());t.bind("ctrl+l",o.bind(function(a){var b=this.f.getDocumentController().getDifferencePage();void 0===
b||(this._compareModel.isReaderSpreadActive()||b.hasCad())||(this.doAutoAlign(),a.preventDefault(),a.stopPropagation())},this),"keydown");t.bind("home",o.bind(function(a){var b=this._documentSelection.getFirstSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));t.bind("end",o.bind(function(a){var b=this._documentSelection.getLastSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&
this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));t.bind("pagedown",o.bind(function(a){var b=this._documentSelection.getNextSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&this.f.getDocumentController().changeActivePage(b);a.preventDefault();a.stopPropagation()},this));t.bind("pageup",o.bind(function(a){var b=this._documentSelection.getPreviousSelectablePageId();b&&(b=this.f.getDocumentController().getDocumentPage(b))&&this.f.getDocumentController().changeActivePage(b);
a.preventDefault();a.stopPropagation()},this));t.bind("ctrl+s",o.bind(function(a){var b=this.getCurrentDiffMode();b===l.diffMode.UNDEFINED||this.isReaderSpreadActive()||(b===l.diffMode.CURRENTVERSION?this.activateModeByName(l.mode.SHOW_DIFFERENCE):this.activateModeByName(l.mode.SHOW_CURRENT),a.preventDefault(),a.stopPropagation())},this),"keydown")};n.prototype=Object.create(c.prototype);n.prototype.constructor=n;n.prototype.getCurrentDiffMode=function(){var a=this._compareModel.getActiveMode(),b=
null;return b=null!==a&&a.getName()===l.mode.BLINKING?l.diffMode.BLINKING_CURRENT:this._compareModel.getDiffMode()};n.prototype.activateLastUsedCompareMode=function(){var a=this.f.getOption("PREFERENCES_DIFFMODE_COMPARE");this._compareModel.isRealCompareMode(a)&&(this._previousDifferencePage===this.f.getActivePage()&&delete this._previousDifferencePage,this.activateModeByDiffMode(this.f.getOption("PREFERENCES_DIFFMODE_COMPARE"),this._previousDifferencePage),this._previousState&&(this.setState(this._previousState),
delete this._previousState))};n.prototype.activateModeByName=function(a,b,c){if(void 0===a)this._compareModel.isRealCompareMode(this._compareModel.getDiffMode())?this._previousState=this.getState():delete this._previousState,this._compareModel.deactivateCurrentMode(),this.f.getDocumentController().resetDifferencePage();else{var d=this._compareModel.getActiveMode();!d||d.getName()!==a?(this._compareModel.toggleSilenceParametersChanged(!0),this._compareModel.toggleCurrentMode(!1),a===l.mode.READERSPREAD||
a===l.mode.ALIGNMENT?(this._compareModel.activateModeByName(a,b),(c=this.f.getDocumentController().getDifferencePage())&&!c.isBlankPage()?c.whenParametersAvailable(o.bind(function(){this._compareModel.toggleSilenceParametersChanged(!1);this._compareWidget&&this._compareWidget.updateCompareWidget()},this)):this._compareModel.toggleSilenceParametersChanged(!1)):this.f.getDocumentController().whenDocumentsLoaded(function(){c||(c=this.f.getDocumentController().getDifferencePage());c||(c=this.getDefaultDiffPage());
this._settingDefault=!0;this.f.getDocumentController().changeDifferencePage(c);this._settingDefault=!1;(c=this.f.getDocumentController().getDifferencePage())?(this._compareModel.activateModeByName(a,b),c.whenParametersAvailable(o.bind(function(){this._compareModel.toggleSilenceParametersChanged(!1);this._compareWidget&&this._compareWidget.updateCompareWidget()},this))):this._compareModel.toggleSilenceParametersChanged(!1)},this)):c&&(this._settingDefault=!0,this.f.getDocumentController().changeDifferencePage(c),
this._settingDefault=!1)}};n.prototype.activateModeByDiffMode=function(a,b){if(a===l.diffMode.UNDEFINED)this.activateModeByName();else{var c=this._compareModel.getModeNameByDiffMode(a);this.activateModeByName(c,a,b)}};n.prototype.getDefaultDiffPage=function(a){a||(a=this.f.getActivePage());var b=a.getLinkedComparePage();if(b)return b;if(b=this._getNextDiffDocumentVersion(a)){if(a.getDocumentVersion().isMultiPage()&&b.isMultiPage()||a.getDocumentVersion().isPageList()&&b.isPageList()){var c=b.getPage(a.getPagenum());
if(c&&!c.isBlankPage()){if(c===a){if(b=this._getNextDiffDocumentVersion(a,b))return(c=b.getPage(a.getPagenum()))?c:b.getLastPage();return}return c}if(b.isPageList()&&(void 0===c||c.isBlankPage())){c=a.getPagenum();for(c++;c<b.getPageCount()&&(!b.hasPage(c)||b.getPage(c).isBlankPage());)c++;return c<b.getPageCount()&&b.getPage(c)!==a?b.getPage(c):b.getFirstNotBlankPage()}return b.getLastPage()}return b.getFirstPage()}if(a.getDocumentVersion().isMultiPage()){b=a.getDocumentVersion().getFirstPage();
if(a===b){for(a=b.getNextPage();a.isBlankPage()&&a.getPagenum()<a.getDocumentVersion().getPageCount();)a=a.getNextPage();return a}return b}};n.prototype._getNextDiffDocumentVersion=function(a,b){var c=a.getDocument(),d=o.find(this.f.getDocumentController().getAllDocuments(),function(a){return(!b||b&&a!==b.getDocument())&&a!==c&&a.getDocumentType()===c.getDocumentType()}),e;void 0!==d?e=d.getDocumentVersion():(d=a.getDocumentVersion(),c.hasMultipleVersions()&&1<d.getVersionId()&&(e=c.getDocumentVersion(d.getVersionId()-
1)));d=e;if(a.getDocumentVersion().isPageList()&&void 0!==e&&!e.hasPage(a.getPagenum())){for(;void 0!==e&&0<e.getVersionId()&&!e.hasPage(a.getPagenum());)e=c.getDocumentVersion(e.getVersionId()-1);void 0!==e&&!e.hasPage(a.getPagenum())&&(e=a.getDocumentVersion())}return b&&e===b?d&&d===b?void 0:d:e};n.prototype._interceptFragmentURL=function(a){if(this._compareModel.getActiveMode()){var b=this._compareModel.getOffset();null!==b&&(a.params.dox=b.x,a.params.doy=b.y);b=this._compareModel.getCornerAlign();
null!==b&&(a.params.dalign=b);this._compareModel.isReferenceNegated()&&(a.params.dn=1);b=this._compareModel.getReferenceRotation()/90;this._compareModel.isReferenceFlipped()&&(b+=4);0!==b&&(a.params.dor=b);this._compareModel.isTrimBoxAlign()&&(a.params.daligntrim=1);a.params.dmode=this._compareModel.getDiffMode();this._compareModel.getActiveMode().interceptFragmentURL(a)}};n.prototype.getCompareModel=function(){return this._compareModel};n.prototype.getDiffMode=function(){return this._compareModel.getDiffMode()};
n.prototype.getActiveMode=function(){return this._compareModel.getActiveMode()};n.prototype.getReferenceOffset=function(){return this._compareModel.getOffset()};n.prototype.isCompareAvailable=function(){if(!this._compareWidget&&!this._toolbarComponent){var a=this._shouldShowWidgetOrTools();return a.widget||a.tools}return!0};n.prototype.isCadOverlayAllowed=function(){var a=this.f.getActivePage();if(!a.hasCad()){if(a.canSaveCadOverlay()||a.hasLinkedPage())return!0;var b=this.f.getDocumentController().getActiveDocument();
return o.some(this.f.getDocumentController().getDocuments(),function(a){if(a!=b&&(a=a.getDocumentVersion()))if(a=a.getPage())return a.hasCad()||a.hasLinkedPage();return!1})}return!1};n.prototype.canSaveCadOverlay=function(){return this.f.getActivePage().canSaveCadOverlay()};n.prototype.isCadOverlayModified=function(){var a=this.f.getActivePage().getLinkedPage(),b=this.f.getDocumentController().getCadOverlay();return a!=b||a&&(void 0!==a.getStateParam("compareOffset")&&s.parseFloat(a.get("offsetx"))!==
a.getStateParam("compareOffset").x||void 0!==a.getStateParam("compareOffset")&&s.parseFloat(a.get("offsety"))!==a.getStateParam("compareOffset").y||void 0!==a.getStateParam("rotation")&&s.parseFloat(a.get("overlayRotation"))!==a.getStateParam("rotation")||void 0!==a.getStateParam("flipped")&&a.get("overlayIsFlipped")!==a.getStateParam("flipped"))};n.prototype.saveCadOverlay=function(a){var b=this.f.getActivePage(),c={saveCadOverlay:!0,callback:o.partial(o.bind(this.saveCadOverlay,this),a)};this.f.emit("intercept.savingCadOverlay",
c);c.saveCadOverlay&&this.f.getDataAdapter().saveCadOverlay(b,this.f.getDocumentController().getCadOverlay(),this._compareModel.getCadOverlayRotation(),this._compareModel.isCadOverlayFlipped(),this._compareModel.getCadOverlayOffset(),o.bind(function(c){c&&b.set("isCadAlignmentSaved",!0);this._compareWidget&&this._compareWidget.updateCompareWidget();a&&a(c)},this))};n.prototype._shouldShowWidgetOrTools=function(){var a=!1,b=!1;if(2<this.f.getDocumentController().getDocumentCount())b=a=!0;else{var c=
this.f.getDocumentController().getAllDocuments();if(o.some(c,function(a){return a.hasMultipleVersions()}))b=a=!0;else if(2==c.length){var a=!0,d=c[0].getDocumentVersion().getPage().hasCad(),e=c[1].getDocumentVersion().getPage().hasCad();d===e&&(b=!0)}else 1<c[0].getDocumentVersion().getPageCount()&&(b=a=!0),this.f.getActivePage().hasLinkedPage()&&(a=!0,b=!1);a||o.some(c,function(a){return o.some(a.getDocumentVersion().getAllPages(),function(a){return a.canSaveCadOverlay()})})&&(a=!0)}return{widget:a,
tools:b}};n.prototype._publishToolbarComponentAndWidgetIfNeeded=function(){if(null===this._toolbarComponent||null===this._compareWidget){var a=this._shouldShowWidgetOrTools();a.tools&&this._publishToolbarComponent(k.toolbarName,o.bind(function(a){return this._toolbarComponent=a===w.LayoutType.MOBILE?new i(this.f,this):new k(this.f,this)},this));a.widget&&this._publishWidget(m.widgetName,o.bind(function(){this._compareWidget=new m(this.f,this,this._compareModel,this._documentSelection);this._comparePagelistPopup=
new p(this.f,"comparePagelistPopup");this._comparePagelistPopup.setOkAction(o.partial(function(a){switch(this._currentPagelistCompareRange){case l.pagelistCompareRange.CURRENT:a._doCurrentCompareRange(this._pagelistComparePage);break;case l.pagelistCompareRange.CURRENTANDFOLLOWING:a._doCurrentAndFollowingCompareRange(this._pagelistComparePage);break;case l.pagelistCompareRange.ALL:a._doAllCompareRange(this._pagelistComparePage)}a.activateModeByDiffMode(a.f.getOption("PREFERENCES_DIFFMODE_COMPARE"),
this._pagelistComparePage);this.hide()},this));this._comparePagelistPopup.setCancelAction(o.bind(function(){this._documentSelection.setDifferenceSelectorPage(this.f.getDocumentController().getDifferencePage())},this));this._registerListener("doAutoAlign",this.doAutoAlign,this,this._compareWidget);this._registerListener("doCornerAlign",this._doCornerAlign,this,this._compareWidget);this._registerListener("rotateReference",this.rotateReference,this,this._compareWidget);this._registerListener("flipReference",
this.flipReference,this,this._compareWidget);this._registerListener("negateReference",o.bind(function(){this._compareModel.negateReference()},this),this,this._compareWidget);this._registerListener("trimBoxAlign",this._doTrimBoxAlign,this,this._compareWidget);this._registerListener("offsetXChanged",o.bind(function(a){var b=this._compareModel.getOffset();b.x=a;this.changeReferenceOffset(b)},this),this,this._compareWidget);this._registerListener("offsetYChanged",o.bind(function(a){var b=this._compareModel.getOffset();
b.y=a;this.changeReferenceOffset(b)},this),this,this._compareWidget);this._registerListener("cadOverlayOffsetXChanged",o.bind(function(a){var b=this._compareModel.getCadOverlayOffset();b.x=a;this.changeCadOverlayOffset(b)},this),this,this._compareWidget);this._registerListener("cadOverlayOffsetYChanged",o.bind(function(a){var b=this._compareModel.getCadOverlayOffset();b.y=a;this.changeCadOverlayOffset(b)},this),this,this._compareWidget);this._registerListener("rotateCadOverlay",this.rotateCadOverlay,
this,this._compareWidget);this._registerListener("flipCadOverlay",this.flipCadOverlay,this,this._compareWidget);this._registerListener("saveCadOverlay",this.saveCadOverlay,this,this._compareWidget);this._docListener&&(this._unregisterListener(this._docListener),this._docListener=null);this._compareWidget.updateCompareWidget();return this._compareWidget},this));(a.widget||a.tools)&&this._emit("compareAvailable")}};n.prototype._whenActiveOrDifferencePageChanged=function(){this._compareModel.resetOffset();
this._compareModel.resetCornerAlign();this._compareModel.resetReferenceOrientation();this._compareModel.resetTrimBoxAlign();null!==this._toolbarComponent&&(this.f.getActivePage().isBlankPage()?(this._toolbarComponent.hide(),this._compareWidget&&this._compareWidget.toggleDifferenceDocPageSelector(!0)):(this._toolbarComponent.show(),this._compareWidget&&this._compareWidget.toggleDifferenceDocPageSelector(!1)));this._compareWidget&&this._compareWidget.updateCompareWidget()};n.prototype._whenActiveOrDifferencePageChangedAndParametersAvailableOrChange=
function(){this._compareWidget&&this._compareWidget.updateCompareWidget()};n.prototype._doCornerAlign=function(a){var b=this.f.getDocumentController();b.willNeedParameterUpdate("CORNER_ALIGN");this._compareModel.resetOffset();this._compareWidget&&this._compareWidget.updateCompareWidget();this._compareModel.setCornerAlign(a);this.changeReferenceOffset(this._compareModel.getOffset());b.readyForParameterUpdate("CORNER_ALIGN")};n.prototype._doTrimBoxAlign=function(){var a=this.f.getDocumentController();
a.willNeedParameterUpdate("TRIMBOX_ALIGN");this._compareModel.toggleTrimBoxAlign();a.readyForParameterUpdate("TRIMBOX_ALIGN")};n.prototype.doAutoAlign=function(){var a=this.f.getActivePage(),b={rectangle:this.f.getModule("viewport").getVisibleRect(),servlet:"",params:{x1:0,x2:0,y1:0,y2:0,daligntrim:this._compareModel.isTrimBoxAlign()?1:0,opmask:3}};this.f.emit("intercept.fragmentURL",b);a=a.getInfoURL(b.params);this.f.ajax(a,{success:o.bind(function(a){var b=A.xml2obj(a);void 0!==b.status.info&&void 0!==
b.status.info.autoalign&&(a=this._compareModel.getOffset(),b=new v.Size(s.parseFloat(b.status.info.autoalign.dx),s.parseFloat(b.status.info.autoalign.dy)),a.offset(b),this.changeReferenceOffset(a))},this),error:o.bind(function(a,b,c){this.f.i18n.loadBundle("viewer",function(){this.f.emit("error.SEVERE",this.f.i18n.t("AlignChangeError")+" "+b,a,b,c)},this)},this)})};n.prototype._getCornerAlignOffset=function(){var a=this._compareModel.getCornerAlign(),b=new v.Size,c=this.f.getActivePage(),d=this.f.getDocumentController().getDifferencePage().getPageSize(),
c=c.getPageSize();if(!(a===l.cornerAutoAlign.TOPLEFT||a===l.cornerAutoAlign.CENTERLEFT||a===l.cornerAutoAlign.BOTTOMLEFT))if(a===l.cornerAutoAlign.TOPCENTER||a===l.cornerAutoAlign.CENTERED||a===l.cornerAutoAlign.BOTTOMCENTER)b.width=c.width/2-d.width/2;else if(a===l.cornerAutoAlign.TOPRIGHT||a===l.cornerAutoAlign.CENTERRIGHT||a===l.cornerAutoAlign.BOTTOMRIGHT)b.width=c.width-d.width;if(!(a===l.cornerAutoAlign.TOPLEFT||a===l.cornerAutoAlign.TOPCENTER||a===l.cornerAutoAlign.TOPRIGHT))if(a===l.cornerAutoAlign.CENTERLEFT||
a===l.cornerAutoAlign.CENTERED||a===l.cornerAutoAlign.CENTERRIGHT)b.height=c.height/2-d.height/2;else if(a===l.cornerAutoAlign.BOTTOMLEFT||a===l.cornerAutoAlign.BOTTOMCENTER||a===l.cornerAutoAlign.BOTTOMRIGHT)b.height=c.height-d.height;return b};n.prototype.changeReferenceOffset=function(a){this.f.getDocumentController().willNeedParameterUpdate("COMPARE_OFFSET");this._emit("referenceOffset.beforeChange");this._compareModel.setOffset(a);null!==this._compareWidget&&this._compareWidget.updateCompareWidget();
this.f.getDocumentController().getDifferencePage().setStateParam("compareOffset",a);this.f.getDocumentController().readyForParameterUpdate("COMPARE_OFFSET");this.f.getDocumentController().whenParametersAvailable(function(){this._emit("referenceOffset.changed")},this)};n.prototype.changeCadOverlayOffset=function(a){this._compareModel.setCadOverlayOffset(a);null!==this._compareWidget&&this._compareWidget.updateCompareWidget();var b=this.f.getDocumentController().getCadOverlay();b&&(this.f.getDocumentController().willNeedParameterUpdate("CAD_OVERLAY_OFFSET"),
this._emit("cadOverlayOffset.beforeChange"),b.setStateParam("compareOffset",a),this.f.getDocumentController().readyForParameterUpdate("CAD_OVERLAY_OFFSET"),this.f.getDocumentController().whenParametersAvailable(function(){this._emit("cadOverlayOffset.changed")},this))};n.prototype.getState=function(){return{compareModel:{diffMode:this.getCurrentDiffMode(),cornerAlign:this._compareModel.getCornerAlign(),trimBoxAlign:this._compareModel.isTrimBoxAlign(),offset:this._compareModel.getOffset(),cadOverlayOffset:this._compareModel.getCadOverlayOffset(),
cadOVerlayRotation:this._compareModel.getCadOverlayRotation(),referenceFlipped:this._compareModel.isReferenceFlipped(),referenceNegated:this._compareModel.isReferenceNegated(),referenceRotation:this._compareModel.getReferenceRotation()},differenceMode:{threshold:this._differenceMode.getThreshold(),colorSpace:this._differenceMode.getColorSpace(),addedColor:this._differenceMode.getAddedHighlightColor(),subtractedColor:this._differenceMode.getSubtractedHighlightColor()},sideBySideMode:{panelsLayoutMode:this._sideBySideMode.getPanelsLayoutMode(),
showingDifference:this._sideBySideMode.isShowingDifference()}}};n.prototype.setState=function(a){this.f.whenModuleAvailable("compare",function(){if(void 0!==a){var b=a.compareModel;void 0!==b&&(this.activateModeByDiffMode(b.diffMode),void 0!==this.f.getDocumentController().getDifferencePage()&&(this._compareModel.setCornerAlign(b.cornerAlign),b.trimBoxAlign&&this._doTrimBoxAlign(),b.referenceFlipped&&this.flipReference(),b.referenceNegated&&this._compareModel.negateReference(),b.referenceRotation&&
this.setReferenceRotation(b.referenceRotation),this._compareModel.isReaderSpreadActive()||this.changeReferenceOffset(b.offset),b.cadOverlayOffset&&this._compareModel.setCadOverlayOffset(b.cadOverlayOffset),b.cadOverlayRotation&&this._compareModel.setCadOverlayRotation(b.cadOverlayRotation)));b=a.differenceMode;void 0!==b&&(this._differenceMode.setThreshold(b.threshold),this._differenceMode.setColorSpace(b.colorSpace),this._differenceMode.setAddedHighlightColor(b.addedColor),this._differenceMode.setSubtractedHighlightColor(b.subtractedColor));
b=a.sideBySideMode;void 0!==b&&(this._sideBySideMode.setPanelsLayoutMode(b.panelsLayoutMode),this._sideBySideMode.setShowingDifference(b.showingDifference))}this.f.debug.log("STATE","compare state is injected.")},this)};n.prototype.isReaderSpreadActive=function(){return this._compareModel.isReaderSpreadActive()};n.prototype._doCurrentCompareRange=function(a){this.f.getActivePage().setLinkedComparePage(a)};n.prototype._doCurrentAndFollowingCompareRange=function(a){for(var b=this.f.getActivePage(),
c=b.getDocumentVersion(),d=a.getDocumentVersion(),e=b.getPagenum(),f=a.getPagenum();e<=c.getPageCount();)b=c.getPage(e),f<=d.getPageCount()&&(a=d.getPage(f)),void 0!==b&&!b.isBlankPage()&&b.setLinkedComparePage(a),e++,f++};n.prototype._doAllCompareRange=function(a){this._doCurrentAndFollowingCompareRange(a);for(var b=this.f.getActivePage(),c=b.getDocumentVersion(),d=a.getDocumentVersion(),e=b.getPagenum()-1,f=a.getPagenum()-1;1<=e;)b=c.getPage(e),1<=f&&(a=d.getPage(f)),void 0!==b&&!b.isBlankPage()&&
b.setLinkedComparePage(a),e--,f--};n.prototype.startAlignmentWizard=function(a){this._compareAlignmentWizard||(this._compareAlignmentWizard=new j(this.f,this,this._compareModel));this._compareAlignmentWizard.setForCadOverlay(a);this.f.startMode(this._compareAlignmentWizard)};n.prototype._interceptActivePageChange=function(a){var b=this.f.getModule("navigation");b&&b.resetExtraRotation();if(this.f.getDocumentController().getDifferencePage()&&(!this.isReaderSpreadActive()&&a.newActivePage.getDocumentVersion().isMultiPage())&&
(b=this.getDefaultDiffPage(a.newActivePage)))a.diffPage=b;a.newActivePage.getDocumentVersion().isPageList()&&(this._documentSelection.updateDocumentSelectorsForPageList(a.oldActivePage,a.newActivePage),!this.isReaderSpreadActive()&&a.newActivePage.isBlankPage()&&(a.diffPage=void 0,this.activateModeByName()))};n.prototype.flipReference=function(){var a=this.f.getDocumentController();a.willNeedParameterUpdate("FLIP");this._compareModel.flipReference();a.getDifferencePage().flipPage();a.readyForParameterUpdate("FLIP")};
n.prototype.flipCadOverlay=function(a){this._compareModel.flipCadOverlay(a);var b=this.f.getDocumentController(),c=b.getCadOverlay();c&&(b.willNeedParameterUpdate("FLIP_OVERLAY"),c.flipPage(a),b.readyForParameterUpdate("FLIP_OVERLAY"))};n.prototype.rotateReference=function(){this.setReferenceRotation((this._compareModel.getReferenceRotation()+90)%360)};n.prototype.setReferenceRotation=function(a){var b=this.f.getDocumentController();b.willNeedParameterUpdate("ROTATION");a%=360;this._compareModel.setReferenceRotation(a);
var c=this.f.getDocumentController().getDifferencePage();c.setRotation(a);var d=this.f.getModule("navigation");d&&c.hasCad()&&d.setExtraRotation(a);b.readyForParameterUpdate("ROTATION")};n.prototype.rotateCadOverlay=function(){this.setCadOverlayRotation((this._compareModel.getCadOverlayRotation()+90)%360)};n.prototype.setCadOverlayRotation=function(a){a%=360;this._compareModel.setCadOverlayRotation(a);var b=this.f.getDocumentController(),c=b.getCadOverlay();c&&(b.willNeedParameterUpdate("ROTATION_OVERLAY"),
c.setRotation(a),(c=this.f.getModule("navigation"))&&c.setExtraRotation(a),b.readyForParameterUpdate("ROTATION_OVERLAY"))};n.prototype.checkAligmentAndShow3D=function(){this.isCadOverlayModified()?this.f.loadBundle("viewer",function(){var a=new r(this.f,"saveCADAlignment",this.f.getContext());a.setRemoveFromDomAfterUsage(!0);this.canSaveCadOverlay()?(a.setOkAction(o.bind(function(){this.saveCadOverlay(o.bind(this._load3DView,this));a.hide()},this)),a.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("CadOverlayPromptTitle"))),
a.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("CadOverlayPromptContent"))),a.setOkBtnText(this.f.i18n.t("Save"))):(a.setOkAction(o.bind(function(){this._load3DView();a.hide()},this)),a.setHeader($("<span/>").addClass("popupTitle").text(this.f.i18n.t("CadOverlayPromptOpen3D"))),a.setContent($("<div/>").addClass("unsavedItemsContent").text(this.f.i18n.t("CadOverlayPromptOpen3DContent"))),a.setOkBtnText(this.f.i18n.t("CadOverlayPromptOpen3D")));a.setCancelBtnText(this.f.i18n.t("AppDialogCancel"));
a.show()},this):!this.f.getActivePage().get("isCadAlignmentSaved")&&this.canSaveCadOverlay()?this.saveCadOverlay(o.bind(this._load3DView,this)):this._load3DView()};n.prototype._load3DView=function(){this.f.requestModule("view3D",o.bind(function(a){a.show3D()},this),!1)};return n});